// Code generated by go-swagger; DO NOT EDIT.

package cloud

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewGetTargetsParams creates a new GetTargetsParams object
// with the default values initialized.
func NewGetTargetsParams() *GetTargetsParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &GetTargetsParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewGetTargetsParamsWithTimeout creates a new GetTargetsParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetTargetsParamsWithTimeout(timeout time.Duration) *GetTargetsParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &GetTargetsParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		timeout: timeout,
	}
}

// NewGetTargetsParamsWithContext creates a new GetTargetsParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetTargetsParamsWithContext(ctx context.Context) *GetTargetsParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &GetTargetsParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		Context: ctx,
	}
}

// NewGetTargetsParamsWithHTTPClient creates a new GetTargetsParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetTargetsParamsWithHTTPClient(client *http.Client) *GetTargetsParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &GetTargetsParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,
		HTTPClient:    client,
	}
}

/*GetTargetsParams contains all the parameters to send to the API endpoint
for the get targets operation typically these are written to a http.Request
*/
type GetTargetsParams struct {

	/*AccessKey
	  Filter by access_key

	*/
	AccessKey *string
	/*AuthenticationType
	  Filter by authentication_type

	*/
	AuthenticationType *string
	/*AzureAccount
	  Filter by azure_account

	*/
	AzureAccount *string
	/*CapURL
	  Filter by cap_url

	*/
	CapURL *string
	/*CertificateValidationEnabled
	  Filter by certificate_validation_enabled

	*/
	CertificateValidationEnabled *bool
	/*ClusterName
	  Filter by cluster.name

	*/
	ClusterName *string
	/*ClusterUUID
	  Filter by cluster.uuid

	*/
	ClusterUUID *string
	/*Container
	  Filter by container

	*/
	Container *string
	/*Fields
	  Specify the fields to return.

	*/
	Fields []string
	/*IpspaceName
	  Filter by ipspace.name

	*/
	IpspaceName *string
	/*IpspaceUUID
	  Filter by ipspace.uuid

	*/
	IpspaceUUID *string
	/*MaxRecords
	  Limit the number of records returned.

	*/
	MaxRecords *int64
	/*Name
	  Filter by name

	*/
	Name *string
	/*OrderBy
	  Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.

	*/
	OrderBy []string
	/*Owner
	  Filter by owner

	*/
	Owner *string
	/*Port
	  Filter by port

	*/
	Port *int64
	/*ProviderType
	  Filter by provider_type

	*/
	ProviderType *string
	/*ReturnRecords
	  The default is true for GET calls.  When set to false, only the number of records is returned.

	*/
	ReturnRecords *bool
	/*ReturnTimeout
	  The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	*/
	ReturnTimeout *int64
	/*Server
	  Filter by server

	*/
	Server *string
	/*ServerSideEncryption
	  Filter by server_side_encryption

	*/
	ServerSideEncryption *string
	/*SnapmirrorUse
	  Filter by snapmirror_use

	*/
	SnapmirrorUse *string
	/*SslEnabled
	  Filter by ssl_enabled

	*/
	SslEnabled *bool
	/*SvmName
	  Filter by svm.name

	*/
	SvmName *string
	/*SvmUUID
	  Filter by svm.uuid

	*/
	SvmUUID *string
	/*URLStyle
	  Filter by url_style

	*/
	URLStyle *string
	/*UseHTTPProxy
	  Filter by use_http_proxy

	*/
	UseHTTPProxy *bool
	/*Used
	  Filter by used

	*/
	Used *int64
	/*UUID
	  Filter by uuid

	*/
	UUID *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get targets params
func (o *GetTargetsParams) WithTimeout(timeout time.Duration) *GetTargetsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get targets params
func (o *GetTargetsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get targets params
func (o *GetTargetsParams) WithContext(ctx context.Context) *GetTargetsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get targets params
func (o *GetTargetsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get targets params
func (o *GetTargetsParams) WithHTTPClient(client *http.Client) *GetTargetsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get targets params
func (o *GetTargetsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAccessKey adds the accessKey to the get targets params
func (o *GetTargetsParams) WithAccessKey(accessKey *string) *GetTargetsParams {
	o.SetAccessKey(accessKey)
	return o
}

// SetAccessKey adds the accessKey to the get targets params
func (o *GetTargetsParams) SetAccessKey(accessKey *string) {
	o.AccessKey = accessKey
}

// WithAuthenticationType adds the authenticationType to the get targets params
func (o *GetTargetsParams) WithAuthenticationType(authenticationType *string) *GetTargetsParams {
	o.SetAuthenticationType(authenticationType)
	return o
}

// SetAuthenticationType adds the authenticationType to the get targets params
func (o *GetTargetsParams) SetAuthenticationType(authenticationType *string) {
	o.AuthenticationType = authenticationType
}

// WithAzureAccount adds the azureAccount to the get targets params
func (o *GetTargetsParams) WithAzureAccount(azureAccount *string) *GetTargetsParams {
	o.SetAzureAccount(azureAccount)
	return o
}

// SetAzureAccount adds the azureAccount to the get targets params
func (o *GetTargetsParams) SetAzureAccount(azureAccount *string) {
	o.AzureAccount = azureAccount
}

// WithCapURL adds the capURL to the get targets params
func (o *GetTargetsParams) WithCapURL(capURL *string) *GetTargetsParams {
	o.SetCapURL(capURL)
	return o
}

// SetCapURL adds the capUrl to the get targets params
func (o *GetTargetsParams) SetCapURL(capURL *string) {
	o.CapURL = capURL
}

// WithCertificateValidationEnabled adds the certificateValidationEnabled to the get targets params
func (o *GetTargetsParams) WithCertificateValidationEnabled(certificateValidationEnabled *bool) *GetTargetsParams {
	o.SetCertificateValidationEnabled(certificateValidationEnabled)
	return o
}

// SetCertificateValidationEnabled adds the certificateValidationEnabled to the get targets params
func (o *GetTargetsParams) SetCertificateValidationEnabled(certificateValidationEnabled *bool) {
	o.CertificateValidationEnabled = certificateValidationEnabled
}

// WithClusterName adds the clusterName to the get targets params
func (o *GetTargetsParams) WithClusterName(clusterName *string) *GetTargetsParams {
	o.SetClusterName(clusterName)
	return o
}

// SetClusterName adds the clusterName to the get targets params
func (o *GetTargetsParams) SetClusterName(clusterName *string) {
	o.ClusterName = clusterName
}

// WithClusterUUID adds the clusterUUID to the get targets params
func (o *GetTargetsParams) WithClusterUUID(clusterUUID *string) *GetTargetsParams {
	o.SetClusterUUID(clusterUUID)
	return o
}

// SetClusterUUID adds the clusterUuid to the get targets params
func (o *GetTargetsParams) SetClusterUUID(clusterUUID *string) {
	o.ClusterUUID = clusterUUID
}

// WithContainer adds the container to the get targets params
func (o *GetTargetsParams) WithContainer(container *string) *GetTargetsParams {
	o.SetContainer(container)
	return o
}

// SetContainer adds the container to the get targets params
func (o *GetTargetsParams) SetContainer(container *string) {
	o.Container = container
}

// WithFields adds the fields to the get targets params
func (o *GetTargetsParams) WithFields(fields []string) *GetTargetsParams {
	o.SetFields(fields)
	return o
}

// SetFields adds the fields to the get targets params
func (o *GetTargetsParams) SetFields(fields []string) {
	o.Fields = fields
}

// WithIpspaceName adds the ipspaceName to the get targets params
func (o *GetTargetsParams) WithIpspaceName(ipspaceName *string) *GetTargetsParams {
	o.SetIpspaceName(ipspaceName)
	return o
}

// SetIpspaceName adds the ipspaceName to the get targets params
func (o *GetTargetsParams) SetIpspaceName(ipspaceName *string) {
	o.IpspaceName = ipspaceName
}

// WithIpspaceUUID adds the ipspaceUUID to the get targets params
func (o *GetTargetsParams) WithIpspaceUUID(ipspaceUUID *string) *GetTargetsParams {
	o.SetIpspaceUUID(ipspaceUUID)
	return o
}

// SetIpspaceUUID adds the ipspaceUuid to the get targets params
func (o *GetTargetsParams) SetIpspaceUUID(ipspaceUUID *string) {
	o.IpspaceUUID = ipspaceUUID
}

// WithMaxRecords adds the maxRecords to the get targets params
func (o *GetTargetsParams) WithMaxRecords(maxRecords *int64) *GetTargetsParams {
	o.SetMaxRecords(maxRecords)
	return o
}

// SetMaxRecords adds the maxRecords to the get targets params
func (o *GetTargetsParams) SetMaxRecords(maxRecords *int64) {
	o.MaxRecords = maxRecords
}

// WithName adds the name to the get targets params
func (o *GetTargetsParams) WithName(name *string) *GetTargetsParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the get targets params
func (o *GetTargetsParams) SetName(name *string) {
	o.Name = name
}

// WithOrderBy adds the orderBy to the get targets params
func (o *GetTargetsParams) WithOrderBy(orderBy []string) *GetTargetsParams {
	o.SetOrderBy(orderBy)
	return o
}

// SetOrderBy adds the orderBy to the get targets params
func (o *GetTargetsParams) SetOrderBy(orderBy []string) {
	o.OrderBy = orderBy
}

// WithOwner adds the owner to the get targets params
func (o *GetTargetsParams) WithOwner(owner *string) *GetTargetsParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the get targets params
func (o *GetTargetsParams) SetOwner(owner *string) {
	o.Owner = owner
}

// WithPort adds the port to the get targets params
func (o *GetTargetsParams) WithPort(port *int64) *GetTargetsParams {
	o.SetPort(port)
	return o
}

// SetPort adds the port to the get targets params
func (o *GetTargetsParams) SetPort(port *int64) {
	o.Port = port
}

// WithProviderType adds the providerType to the get targets params
func (o *GetTargetsParams) WithProviderType(providerType *string) *GetTargetsParams {
	o.SetProviderType(providerType)
	return o
}

// SetProviderType adds the providerType to the get targets params
func (o *GetTargetsParams) SetProviderType(providerType *string) {
	o.ProviderType = providerType
}

// WithReturnRecords adds the returnRecords to the get targets params
func (o *GetTargetsParams) WithReturnRecords(returnRecords *bool) *GetTargetsParams {
	o.SetReturnRecords(returnRecords)
	return o
}

// SetReturnRecords adds the returnRecords to the get targets params
func (o *GetTargetsParams) SetReturnRecords(returnRecords *bool) {
	o.ReturnRecords = returnRecords
}

// WithReturnTimeout adds the returnTimeout to the get targets params
func (o *GetTargetsParams) WithReturnTimeout(returnTimeout *int64) *GetTargetsParams {
	o.SetReturnTimeout(returnTimeout)
	return o
}

// SetReturnTimeout adds the returnTimeout to the get targets params
func (o *GetTargetsParams) SetReturnTimeout(returnTimeout *int64) {
	o.ReturnTimeout = returnTimeout
}

// WithServer adds the server to the get targets params
func (o *GetTargetsParams) WithServer(server *string) *GetTargetsParams {
	o.SetServer(server)
	return o
}

// SetServer adds the server to the get targets params
func (o *GetTargetsParams) SetServer(server *string) {
	o.Server = server
}

// WithServerSideEncryption adds the serverSideEncryption to the get targets params
func (o *GetTargetsParams) WithServerSideEncryption(serverSideEncryption *string) *GetTargetsParams {
	o.SetServerSideEncryption(serverSideEncryption)
	return o
}

// SetServerSideEncryption adds the serverSideEncryption to the get targets params
func (o *GetTargetsParams) SetServerSideEncryption(serverSideEncryption *string) {
	o.ServerSideEncryption = serverSideEncryption
}

// WithSnapmirrorUse adds the snapmirrorUse to the get targets params
func (o *GetTargetsParams) WithSnapmirrorUse(snapmirrorUse *string) *GetTargetsParams {
	o.SetSnapmirrorUse(snapmirrorUse)
	return o
}

// SetSnapmirrorUse adds the snapmirrorUse to the get targets params
func (o *GetTargetsParams) SetSnapmirrorUse(snapmirrorUse *string) {
	o.SnapmirrorUse = snapmirrorUse
}

// WithSslEnabled adds the sslEnabled to the get targets params
func (o *GetTargetsParams) WithSslEnabled(sslEnabled *bool) *GetTargetsParams {
	o.SetSslEnabled(sslEnabled)
	return o
}

// SetSslEnabled adds the sslEnabled to the get targets params
func (o *GetTargetsParams) SetSslEnabled(sslEnabled *bool) {
	o.SslEnabled = sslEnabled
}

// WithSvmName adds the svmName to the get targets params
func (o *GetTargetsParams) WithSvmName(svmName *string) *GetTargetsParams {
	o.SetSvmName(svmName)
	return o
}

// SetSvmName adds the svmName to the get targets params
func (o *GetTargetsParams) SetSvmName(svmName *string) {
	o.SvmName = svmName
}

// WithSvmUUID adds the svmUUID to the get targets params
func (o *GetTargetsParams) WithSvmUUID(svmUUID *string) *GetTargetsParams {
	o.SetSvmUUID(svmUUID)
	return o
}

// SetSvmUUID adds the svmUuid to the get targets params
func (o *GetTargetsParams) SetSvmUUID(svmUUID *string) {
	o.SvmUUID = svmUUID
}

// WithURLStyle adds the uRLStyle to the get targets params
func (o *GetTargetsParams) WithURLStyle(uRLStyle *string) *GetTargetsParams {
	o.SetURLStyle(uRLStyle)
	return o
}

// SetURLStyle adds the urlStyle to the get targets params
func (o *GetTargetsParams) SetURLStyle(uRLStyle *string) {
	o.URLStyle = uRLStyle
}

// WithUseHTTPProxy adds the useHTTPProxy to the get targets params
func (o *GetTargetsParams) WithUseHTTPProxy(useHTTPProxy *bool) *GetTargetsParams {
	o.SetUseHTTPProxy(useHTTPProxy)
	return o
}

// SetUseHTTPProxy adds the useHttpProxy to the get targets params
func (o *GetTargetsParams) SetUseHTTPProxy(useHTTPProxy *bool) {
	o.UseHTTPProxy = useHTTPProxy
}

// WithUsed adds the used to the get targets params
func (o *GetTargetsParams) WithUsed(used *int64) *GetTargetsParams {
	o.SetUsed(used)
	return o
}

// SetUsed adds the used to the get targets params
func (o *GetTargetsParams) SetUsed(used *int64) {
	o.Used = used
}

// WithUUID adds the uuid to the get targets params
func (o *GetTargetsParams) WithUUID(uuid *string) *GetTargetsParams {
	o.SetUUID(uuid)
	return o
}

// SetUUID adds the uuid to the get targets params
func (o *GetTargetsParams) SetUUID(uuid *string) {
	o.UUID = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *GetTargetsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.AccessKey != nil {

		// query param access_key
		var qrAccessKey string
		if o.AccessKey != nil {
			qrAccessKey = *o.AccessKey
		}
		qAccessKey := qrAccessKey
		if qAccessKey != "" {
			if err := r.SetQueryParam("access_key", qAccessKey); err != nil {
				return err
			}
		}

	}

	if o.AuthenticationType != nil {

		// query param authentication_type
		var qrAuthenticationType string
		if o.AuthenticationType != nil {
			qrAuthenticationType = *o.AuthenticationType
		}
		qAuthenticationType := qrAuthenticationType
		if qAuthenticationType != "" {
			if err := r.SetQueryParam("authentication_type", qAuthenticationType); err != nil {
				return err
			}
		}

	}

	if o.AzureAccount != nil {

		// query param azure_account
		var qrAzureAccount string
		if o.AzureAccount != nil {
			qrAzureAccount = *o.AzureAccount
		}
		qAzureAccount := qrAzureAccount
		if qAzureAccount != "" {
			if err := r.SetQueryParam("azure_account", qAzureAccount); err != nil {
				return err
			}
		}

	}

	if o.CapURL != nil {

		// query param cap_url
		var qrCapURL string
		if o.CapURL != nil {
			qrCapURL = *o.CapURL
		}
		qCapURL := qrCapURL
		if qCapURL != "" {
			if err := r.SetQueryParam("cap_url", qCapURL); err != nil {
				return err
			}
		}

	}

	if o.CertificateValidationEnabled != nil {

		// query param certificate_validation_enabled
		var qrCertificateValidationEnabled bool
		if o.CertificateValidationEnabled != nil {
			qrCertificateValidationEnabled = *o.CertificateValidationEnabled
		}
		qCertificateValidationEnabled := swag.FormatBool(qrCertificateValidationEnabled)
		if qCertificateValidationEnabled != "" {
			if err := r.SetQueryParam("certificate_validation_enabled", qCertificateValidationEnabled); err != nil {
				return err
			}
		}

	}

	if o.ClusterName != nil {

		// query param cluster.name
		var qrClusterName string
		if o.ClusterName != nil {
			qrClusterName = *o.ClusterName
		}
		qClusterName := qrClusterName
		if qClusterName != "" {
			if err := r.SetQueryParam("cluster.name", qClusterName); err != nil {
				return err
			}
		}

	}

	if o.ClusterUUID != nil {

		// query param cluster.uuid
		var qrClusterUUID string
		if o.ClusterUUID != nil {
			qrClusterUUID = *o.ClusterUUID
		}
		qClusterUUID := qrClusterUUID
		if qClusterUUID != "" {
			if err := r.SetQueryParam("cluster.uuid", qClusterUUID); err != nil {
				return err
			}
		}

	}

	if o.Container != nil {

		// query param container
		var qrContainer string
		if o.Container != nil {
			qrContainer = *o.Container
		}
		qContainer := qrContainer
		if qContainer != "" {
			if err := r.SetQueryParam("container", qContainer); err != nil {
				return err
			}
		}

	}

	valuesFields := o.Fields

	joinedFields := swag.JoinByFormat(valuesFields, "csv")
	// query array param fields
	if err := r.SetQueryParam("fields", joinedFields...); err != nil {
		return err
	}

	if o.IpspaceName != nil {

		// query param ipspace.name
		var qrIpspaceName string
		if o.IpspaceName != nil {
			qrIpspaceName = *o.IpspaceName
		}
		qIpspaceName := qrIpspaceName
		if qIpspaceName != "" {
			if err := r.SetQueryParam("ipspace.name", qIpspaceName); err != nil {
				return err
			}
		}

	}

	if o.IpspaceUUID != nil {

		// query param ipspace.uuid
		var qrIpspaceUUID string
		if o.IpspaceUUID != nil {
			qrIpspaceUUID = *o.IpspaceUUID
		}
		qIpspaceUUID := qrIpspaceUUID
		if qIpspaceUUID != "" {
			if err := r.SetQueryParam("ipspace.uuid", qIpspaceUUID); err != nil {
				return err
			}
		}

	}

	if o.MaxRecords != nil {

		// query param max_records
		var qrMaxRecords int64
		if o.MaxRecords != nil {
			qrMaxRecords = *o.MaxRecords
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {
			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}

	}

	if o.Name != nil {

		// query param name
		var qrName string
		if o.Name != nil {
			qrName = *o.Name
		}
		qName := qrName
		if qName != "" {
			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}

	}

	valuesOrderBy := o.OrderBy

	joinedOrderBy := swag.JoinByFormat(valuesOrderBy, "csv")
	// query array param order_by
	if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
		return err
	}

	if o.Owner != nil {

		// query param owner
		var qrOwner string
		if o.Owner != nil {
			qrOwner = *o.Owner
		}
		qOwner := qrOwner
		if qOwner != "" {
			if err := r.SetQueryParam("owner", qOwner); err != nil {
				return err
			}
		}

	}

	if o.Port != nil {

		// query param port
		var qrPort int64
		if o.Port != nil {
			qrPort = *o.Port
		}
		qPort := swag.FormatInt64(qrPort)
		if qPort != "" {
			if err := r.SetQueryParam("port", qPort); err != nil {
				return err
			}
		}

	}

	if o.ProviderType != nil {

		// query param provider_type
		var qrProviderType string
		if o.ProviderType != nil {
			qrProviderType = *o.ProviderType
		}
		qProviderType := qrProviderType
		if qProviderType != "" {
			if err := r.SetQueryParam("provider_type", qProviderType); err != nil {
				return err
			}
		}

	}

	if o.ReturnRecords != nil {

		// query param return_records
		var qrReturnRecords bool
		if o.ReturnRecords != nil {
			qrReturnRecords = *o.ReturnRecords
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {
			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}

	}

	if o.ReturnTimeout != nil {

		// query param return_timeout
		var qrReturnTimeout int64
		if o.ReturnTimeout != nil {
			qrReturnTimeout = *o.ReturnTimeout
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {
			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}

	}

	if o.Server != nil {

		// query param server
		var qrServer string
		if o.Server != nil {
			qrServer = *o.Server
		}
		qServer := qrServer
		if qServer != "" {
			if err := r.SetQueryParam("server", qServer); err != nil {
				return err
			}
		}

	}

	if o.ServerSideEncryption != nil {

		// query param server_side_encryption
		var qrServerSideEncryption string
		if o.ServerSideEncryption != nil {
			qrServerSideEncryption = *o.ServerSideEncryption
		}
		qServerSideEncryption := qrServerSideEncryption
		if qServerSideEncryption != "" {
			if err := r.SetQueryParam("server_side_encryption", qServerSideEncryption); err != nil {
				return err
			}
		}

	}

	if o.SnapmirrorUse != nil {

		// query param snapmirror_use
		var qrSnapmirrorUse string
		if o.SnapmirrorUse != nil {
			qrSnapmirrorUse = *o.SnapmirrorUse
		}
		qSnapmirrorUse := qrSnapmirrorUse
		if qSnapmirrorUse != "" {
			if err := r.SetQueryParam("snapmirror_use", qSnapmirrorUse); err != nil {
				return err
			}
		}

	}

	if o.SslEnabled != nil {

		// query param ssl_enabled
		var qrSslEnabled bool
		if o.SslEnabled != nil {
			qrSslEnabled = *o.SslEnabled
		}
		qSslEnabled := swag.FormatBool(qrSslEnabled)
		if qSslEnabled != "" {
			if err := r.SetQueryParam("ssl_enabled", qSslEnabled); err != nil {
				return err
			}
		}

	}

	if o.SvmName != nil {

		// query param svm.name
		var qrSvmName string
		if o.SvmName != nil {
			qrSvmName = *o.SvmName
		}
		qSvmName := qrSvmName
		if qSvmName != "" {
			if err := r.SetQueryParam("svm.name", qSvmName); err != nil {
				return err
			}
		}

	}

	if o.SvmUUID != nil {

		// query param svm.uuid
		var qrSvmUUID string
		if o.SvmUUID != nil {
			qrSvmUUID = *o.SvmUUID
		}
		qSvmUUID := qrSvmUUID
		if qSvmUUID != "" {
			if err := r.SetQueryParam("svm.uuid", qSvmUUID); err != nil {
				return err
			}
		}

	}

	if o.URLStyle != nil {

		// query param url_style
		var qrURLStyle string
		if o.URLStyle != nil {
			qrURLStyle = *o.URLStyle
		}
		qURLStyle := qrURLStyle
		if qURLStyle != "" {
			if err := r.SetQueryParam("url_style", qURLStyle); err != nil {
				return err
			}
		}

	}

	if o.UseHTTPProxy != nil {

		// query param use_http_proxy
		var qrUseHTTPProxy bool
		if o.UseHTTPProxy != nil {
			qrUseHTTPProxy = *o.UseHTTPProxy
		}
		qUseHTTPProxy := swag.FormatBool(qrUseHTTPProxy)
		if qUseHTTPProxy != "" {
			if err := r.SetQueryParam("use_http_proxy", qUseHTTPProxy); err != nil {
				return err
			}
		}

	}

	if o.Used != nil {

		// query param used
		var qrUsed int64
		if o.Used != nil {
			qrUsed = *o.Used
		}
		qUsed := swag.FormatInt64(qrUsed)
		if qUsed != "" {
			if err := r.SetQueryParam("used", qUsed); err != nil {
				return err
			}
		}

	}

	if o.UUID != nil {

		// query param uuid
		var qrUUID string
		if o.UUID != nil {
			qrUUID = *o.UUID
		}
		qUUID := qrUUID
		if qUUID != "" {
			if err := r.SetQueryParam("uuid", qUUID); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
