// Code generated by go-swagger; DO NOT EDIT.

package cluster

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/greenqloud/ontap-rest-client/ntapmodel"
)

// NodeModifyReader is a Reader for the NodeModify structure.
type NodeModifyReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *NodeModifyReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 202:
		result := NewNodeModifyAccepted()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewNodeModifyDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewNodeModifyAccepted creates a NodeModifyAccepted with default headers values
func NewNodeModifyAccepted() *NodeModifyAccepted {
	return &NodeModifyAccepted{}
}

/*NodeModifyAccepted handles this case with default header values.

Accepted
*/
type NodeModifyAccepted struct {
	Payload *ntapmodel.JobLinkResponse
}

func (o *NodeModifyAccepted) Error() string {
	return fmt.Sprintf("[PATCH /cluster/nodes/{uuid}][%d] nodeModifyAccepted  %+v", 202, o.Payload)
}

func (o *NodeModifyAccepted) GetPayload() *ntapmodel.JobLinkResponse {
	return o.Payload
}

func (o *NodeModifyAccepted) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(ntapmodel.JobLinkResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewNodeModifyDefault creates a NodeModifyDefault with default headers values
func NewNodeModifyDefault(code int) *NodeModifyDefault {
	return &NodeModifyDefault{
		_statusCode: code,
	}
}

/*NodeModifyDefault handles this case with default header values.

ONTAP Error Response Codes
| Error Code | Description |
| ---------- | ----------- |
| 852046     | HA partner node |
| 852115     | The reboot/shutdown is prevented because LIFs cannot be moved away from the node |
| 3604514    | A reboot or shutdown request is already in progress. |
| 3604515    | Reboot or shutdown of all nodes results in data service failure and client disruption for the entire cluster. Use "allow-data-outage=true" to bypass this check. |
| 9240606    | The reboot/shutdown is prevented due to quorum warnings. |

*/
type NodeModifyDefault struct {
	_statusCode int

	Payload *ntapmodel.ErrorResponse
}

// Code gets the status code for the node modify default response
func (o *NodeModifyDefault) Code() int {
	return o._statusCode
}

func (o *NodeModifyDefault) Error() string {
	return fmt.Sprintf("[PATCH /cluster/nodes/{uuid}][%d] node_modify default  %+v", o._statusCode, o.Payload)
}

func (o *NodeModifyDefault) GetPayload() *ntapmodel.ErrorResponse {
	return o.Payload
}

func (o *NodeModifyDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(ntapmodel.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
