// Code generated by go-swagger; DO NOT EDIT.

package cluster

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewNodesGetParams creates a new NodesGetParams object
// with the default values initialized.
func NewNodesGetParams() *NodesGetParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &NodesGetParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewNodesGetParamsWithTimeout creates a new NodesGetParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewNodesGetParamsWithTimeout(timeout time.Duration) *NodesGetParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &NodesGetParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		timeout: timeout,
	}
}

// NewNodesGetParamsWithContext creates a new NodesGetParams object
// with the default values initialized, and the ability to set a context for a request
func NewNodesGetParamsWithContext(ctx context.Context) *NodesGetParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &NodesGetParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		Context: ctx,
	}
}

// NewNodesGetParamsWithHTTPClient creates a new NodesGetParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewNodesGetParamsWithHTTPClient(client *http.Client) *NodesGetParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &NodesGetParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,
		HTTPClient:    client,
	}
}

/*NodesGetParams contains all the parameters to send to the API endpoint
for the nodes get operation typically these are written to a http.Request
*/
type NodesGetParams struct {

	/*ClusterInterfacesIPAddress
	  Filter by cluster_interfaces.ip.address

	*/
	ClusterInterfacesIPAddress *string
	/*ClusterInterfacesName
	  Filter by cluster_interfaces.name

	*/
	ClusterInterfacesName *string
	/*ClusterInterfacesUUID
	  Filter by cluster_interfaces.uuid

	*/
	ClusterInterfacesUUID *string
	/*ControllerFlashCacheCapacity
	  Filter by controller.flash_cache.capacity

	*/
	ControllerFlashCacheCapacity *int64
	/*ControllerFlashCacheFirmwareVersion
	  Filter by controller.flash_cache.firmware_version

	*/
	ControllerFlashCacheFirmwareVersion *string
	/*ControllerFlashCacheHardwareRevision
	  Filter by controller.flash_cache.hardware_revision

	*/
	ControllerFlashCacheHardwareRevision *string
	/*ControllerFlashCacheModel
	  Filter by controller.flash_cache.model

	*/
	ControllerFlashCacheModel *string
	/*ControllerFlashCachePartNumber
	  Filter by controller.flash_cache.part_number

	*/
	ControllerFlashCachePartNumber *string
	/*ControllerFlashCacheSerialNumber
	  Filter by controller.flash_cache.serial_number

	*/
	ControllerFlashCacheSerialNumber *string
	/*ControllerFlashCacheSlot
	  Filter by controller.flash_cache.slot

	*/
	ControllerFlashCacheSlot *string
	/*ControllerFlashCacheState
	  Filter by controller.flash_cache.state

	*/
	ControllerFlashCacheState *string
	/*ControllerFrusID
	  Filter by controller.frus.id

	*/
	ControllerFrusID *int64
	/*ControllerFrusState
	  Filter by controller.frus.state

	*/
	ControllerFrusState *string
	/*ControllerFrusType
	  Filter by controller.frus.type

	*/
	ControllerFrusType *string
	/*ControllerOverTemperature
	  Filter by controller.over_temperature

	*/
	ControllerOverTemperature *string
	/*Date
	  Filter by date

	*/
	Date *string
	/*Fields
	  Specify the fields to return.

	*/
	Fields []string
	/*HaAutoGiveback
	  Filter by ha.auto_giveback

	*/
	HaAutoGiveback *bool
	/*HaEnabled
	  Filter by ha.enabled

	*/
	HaEnabled *bool
	/*HaGivebackFailureCode
	  Filter by ha.giveback.failure.code

	*/
	HaGivebackFailureCode *int64
	/*HaGivebackFailureMessage
	  Filter by ha.giveback.failure.message

	*/
	HaGivebackFailureMessage *string
	/*HaGivebackState
	  Filter by ha.giveback.state

	*/
	HaGivebackState *string
	/*HaPartnersName
	  Filter by ha.partners.name

	*/
	HaPartnersName *string
	/*HaPartnersUUID
	  Filter by ha.partners.uuid

	*/
	HaPartnersUUID *string
	/*HaPortsNumber
	  Filter by ha.ports.number

	*/
	HaPortsNumber *int64
	/*HaPortsState
	  Filter by ha.ports.state

	*/
	HaPortsState *string
	/*HaTakeoverFailureCode
	  Filter by ha.takeover.failure.code

	*/
	HaTakeoverFailureCode *int64
	/*HaTakeoverFailureMessage
	  Filter by ha.takeover.failure.message

	*/
	HaTakeoverFailureMessage *string
	/*HaTakeoverState
	  Filter by ha.takeover.state

	*/
	HaTakeoverState *string
	/*Location
	  Filter by location

	*/
	Location *string
	/*ManagementInterfacesIPAddress
	  Filter by management_interfaces.ip.address

	*/
	ManagementInterfacesIPAddress *string
	/*ManagementInterfacesName
	  Filter by management_interfaces.name

	*/
	ManagementInterfacesName *string
	/*ManagementInterfacesUUID
	  Filter by management_interfaces.uuid

	*/
	ManagementInterfacesUUID *string
	/*MaxRecords
	  Limit the number of records returned.

	*/
	MaxRecords *int64
	/*Membership
	  Filter by membership

	*/
	Membership *string
	/*Model
	  Filter by model

	*/
	Model *string
	/*Name
	  Filter by name

	*/
	Name *string
	/*OrderBy
	  Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.

	*/
	OrderBy []string
	/*ReturnRecords
	  The default is true for GET calls.  When set to false, only the number of records is returned.

	*/
	ReturnRecords *bool
	/*ReturnTimeout
	  The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	*/
	ReturnTimeout *int64
	/*SerialNumber
	  Filter by serial_number

	*/
	SerialNumber *string
	/*ServiceProcessorDhcpEnabled
	  Filter by service_processor.dhcp_enabled

	*/
	ServiceProcessorDhcpEnabled *bool
	/*ServiceProcessorFirmwareVersion
	  Filter by service_processor.firmware_version

	*/
	ServiceProcessorFirmwareVersion *string
	/*ServiceProcessorIPV4InterfaceAddress
	  Filter by service_processor.ipv4_interface.address

	*/
	ServiceProcessorIPV4InterfaceAddress *string
	/*ServiceProcessorIPV4InterfaceGateway
	  Filter by service_processor.ipv4_interface.gateway

	*/
	ServiceProcessorIPV4InterfaceGateway *string
	/*ServiceProcessorIPV4InterfaceNetmask
	  Filter by service_processor.ipv4_interface.netmask

	*/
	ServiceProcessorIPV4InterfaceNetmask *string
	/*ServiceProcessorIPV6InterfaceAddress
	  Filter by service_processor.ipv6_interface.address

	*/
	ServiceProcessorIPV6InterfaceAddress *string
	/*ServiceProcessorIPV6InterfaceGateway
	  Filter by service_processor.ipv6_interface.gateway

	*/
	ServiceProcessorIPV6InterfaceGateway *string
	/*ServiceProcessorIPV6InterfaceNetmask
	  Filter by service_processor.ipv6_interface.netmask

	*/
	ServiceProcessorIPV6InterfaceNetmask *string
	/*ServiceProcessorLinkStatus
	  Filter by service_processor.link_status

	*/
	ServiceProcessorLinkStatus *string
	/*ServiceProcessorMacAddress
	  Filter by service_processor.mac_address

	*/
	ServiceProcessorMacAddress *string
	/*ServiceProcessorState
	  Filter by service_processor.state

	*/
	ServiceProcessorState *string
	/*State
	  Filter by state

	*/
	State *string
	/*SystemID
	  Filter by system_id

	*/
	SystemID *string
	/*SystemMachineType
	  Filter by system_machine_type

	*/
	SystemMachineType *string
	/*Uptime
	  Filter by uptime

	*/
	Uptime *int64
	/*UUID
	  Filter by uuid

	*/
	UUID *string
	/*VendorSerialNumber
	  Filter by vendor_serial_number

	*/
	VendorSerialNumber *string
	/*VersionFull
	  Filter by version.full

	*/
	VersionFull *string
	/*VersionGeneration
	  Filter by version.generation

	*/
	VersionGeneration *int64
	/*VersionMajor
	  Filter by version.major

	*/
	VersionMajor *int64
	/*VersionMinor
	  Filter by version.minor

	*/
	VersionMinor *int64
	/*VMProviderType
	  Filter by vm.provider_type

	*/
	VMProviderType *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the nodes get params
func (o *NodesGetParams) WithTimeout(timeout time.Duration) *NodesGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the nodes get params
func (o *NodesGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the nodes get params
func (o *NodesGetParams) WithContext(ctx context.Context) *NodesGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the nodes get params
func (o *NodesGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the nodes get params
func (o *NodesGetParams) WithHTTPClient(client *http.Client) *NodesGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the nodes get params
func (o *NodesGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithClusterInterfacesIPAddress adds the clusterInterfacesIPAddress to the nodes get params
func (o *NodesGetParams) WithClusterInterfacesIPAddress(clusterInterfacesIPAddress *string) *NodesGetParams {
	o.SetClusterInterfacesIPAddress(clusterInterfacesIPAddress)
	return o
}

// SetClusterInterfacesIPAddress adds the clusterInterfacesIpAddress to the nodes get params
func (o *NodesGetParams) SetClusterInterfacesIPAddress(clusterInterfacesIPAddress *string) {
	o.ClusterInterfacesIPAddress = clusterInterfacesIPAddress
}

// WithClusterInterfacesName adds the clusterInterfacesName to the nodes get params
func (o *NodesGetParams) WithClusterInterfacesName(clusterInterfacesName *string) *NodesGetParams {
	o.SetClusterInterfacesName(clusterInterfacesName)
	return o
}

// SetClusterInterfacesName adds the clusterInterfacesName to the nodes get params
func (o *NodesGetParams) SetClusterInterfacesName(clusterInterfacesName *string) {
	o.ClusterInterfacesName = clusterInterfacesName
}

// WithClusterInterfacesUUID adds the clusterInterfacesUUID to the nodes get params
func (o *NodesGetParams) WithClusterInterfacesUUID(clusterInterfacesUUID *string) *NodesGetParams {
	o.SetClusterInterfacesUUID(clusterInterfacesUUID)
	return o
}

// SetClusterInterfacesUUID adds the clusterInterfacesUuid to the nodes get params
func (o *NodesGetParams) SetClusterInterfacesUUID(clusterInterfacesUUID *string) {
	o.ClusterInterfacesUUID = clusterInterfacesUUID
}

// WithControllerFlashCacheCapacity adds the controllerFlashCacheCapacity to the nodes get params
func (o *NodesGetParams) WithControllerFlashCacheCapacity(controllerFlashCacheCapacity *int64) *NodesGetParams {
	o.SetControllerFlashCacheCapacity(controllerFlashCacheCapacity)
	return o
}

// SetControllerFlashCacheCapacity adds the controllerFlashCacheCapacity to the nodes get params
func (o *NodesGetParams) SetControllerFlashCacheCapacity(controllerFlashCacheCapacity *int64) {
	o.ControllerFlashCacheCapacity = controllerFlashCacheCapacity
}

// WithControllerFlashCacheFirmwareVersion adds the controllerFlashCacheFirmwareVersion to the nodes get params
func (o *NodesGetParams) WithControllerFlashCacheFirmwareVersion(controllerFlashCacheFirmwareVersion *string) *NodesGetParams {
	o.SetControllerFlashCacheFirmwareVersion(controllerFlashCacheFirmwareVersion)
	return o
}

// SetControllerFlashCacheFirmwareVersion adds the controllerFlashCacheFirmwareVersion to the nodes get params
func (o *NodesGetParams) SetControllerFlashCacheFirmwareVersion(controllerFlashCacheFirmwareVersion *string) {
	o.ControllerFlashCacheFirmwareVersion = controllerFlashCacheFirmwareVersion
}

// WithControllerFlashCacheHardwareRevision adds the controllerFlashCacheHardwareRevision to the nodes get params
func (o *NodesGetParams) WithControllerFlashCacheHardwareRevision(controllerFlashCacheHardwareRevision *string) *NodesGetParams {
	o.SetControllerFlashCacheHardwareRevision(controllerFlashCacheHardwareRevision)
	return o
}

// SetControllerFlashCacheHardwareRevision adds the controllerFlashCacheHardwareRevision to the nodes get params
func (o *NodesGetParams) SetControllerFlashCacheHardwareRevision(controllerFlashCacheHardwareRevision *string) {
	o.ControllerFlashCacheHardwareRevision = controllerFlashCacheHardwareRevision
}

// WithControllerFlashCacheModel adds the controllerFlashCacheModel to the nodes get params
func (o *NodesGetParams) WithControllerFlashCacheModel(controllerFlashCacheModel *string) *NodesGetParams {
	o.SetControllerFlashCacheModel(controllerFlashCacheModel)
	return o
}

// SetControllerFlashCacheModel adds the controllerFlashCacheModel to the nodes get params
func (o *NodesGetParams) SetControllerFlashCacheModel(controllerFlashCacheModel *string) {
	o.ControllerFlashCacheModel = controllerFlashCacheModel
}

// WithControllerFlashCachePartNumber adds the controllerFlashCachePartNumber to the nodes get params
func (o *NodesGetParams) WithControllerFlashCachePartNumber(controllerFlashCachePartNumber *string) *NodesGetParams {
	o.SetControllerFlashCachePartNumber(controllerFlashCachePartNumber)
	return o
}

// SetControllerFlashCachePartNumber adds the controllerFlashCachePartNumber to the nodes get params
func (o *NodesGetParams) SetControllerFlashCachePartNumber(controllerFlashCachePartNumber *string) {
	o.ControllerFlashCachePartNumber = controllerFlashCachePartNumber
}

// WithControllerFlashCacheSerialNumber adds the controllerFlashCacheSerialNumber to the nodes get params
func (o *NodesGetParams) WithControllerFlashCacheSerialNumber(controllerFlashCacheSerialNumber *string) *NodesGetParams {
	o.SetControllerFlashCacheSerialNumber(controllerFlashCacheSerialNumber)
	return o
}

// SetControllerFlashCacheSerialNumber adds the controllerFlashCacheSerialNumber to the nodes get params
func (o *NodesGetParams) SetControllerFlashCacheSerialNumber(controllerFlashCacheSerialNumber *string) {
	o.ControllerFlashCacheSerialNumber = controllerFlashCacheSerialNumber
}

// WithControllerFlashCacheSlot adds the controllerFlashCacheSlot to the nodes get params
func (o *NodesGetParams) WithControllerFlashCacheSlot(controllerFlashCacheSlot *string) *NodesGetParams {
	o.SetControllerFlashCacheSlot(controllerFlashCacheSlot)
	return o
}

// SetControllerFlashCacheSlot adds the controllerFlashCacheSlot to the nodes get params
func (o *NodesGetParams) SetControllerFlashCacheSlot(controllerFlashCacheSlot *string) {
	o.ControllerFlashCacheSlot = controllerFlashCacheSlot
}

// WithControllerFlashCacheState adds the controllerFlashCacheState to the nodes get params
func (o *NodesGetParams) WithControllerFlashCacheState(controllerFlashCacheState *string) *NodesGetParams {
	o.SetControllerFlashCacheState(controllerFlashCacheState)
	return o
}

// SetControllerFlashCacheState adds the controllerFlashCacheState to the nodes get params
func (o *NodesGetParams) SetControllerFlashCacheState(controllerFlashCacheState *string) {
	o.ControllerFlashCacheState = controllerFlashCacheState
}

// WithControllerFrusID adds the controllerFrusID to the nodes get params
func (o *NodesGetParams) WithControllerFrusID(controllerFrusID *int64) *NodesGetParams {
	o.SetControllerFrusID(controllerFrusID)
	return o
}

// SetControllerFrusID adds the controllerFrusId to the nodes get params
func (o *NodesGetParams) SetControllerFrusID(controllerFrusID *int64) {
	o.ControllerFrusID = controllerFrusID
}

// WithControllerFrusState adds the controllerFrusState to the nodes get params
func (o *NodesGetParams) WithControllerFrusState(controllerFrusState *string) *NodesGetParams {
	o.SetControllerFrusState(controllerFrusState)
	return o
}

// SetControllerFrusState adds the controllerFrusState to the nodes get params
func (o *NodesGetParams) SetControllerFrusState(controllerFrusState *string) {
	o.ControllerFrusState = controllerFrusState
}

// WithControllerFrusType adds the controllerFrusType to the nodes get params
func (o *NodesGetParams) WithControllerFrusType(controllerFrusType *string) *NodesGetParams {
	o.SetControllerFrusType(controllerFrusType)
	return o
}

// SetControllerFrusType adds the controllerFrusType to the nodes get params
func (o *NodesGetParams) SetControllerFrusType(controllerFrusType *string) {
	o.ControllerFrusType = controllerFrusType
}

// WithControllerOverTemperature adds the controllerOverTemperature to the nodes get params
func (o *NodesGetParams) WithControllerOverTemperature(controllerOverTemperature *string) *NodesGetParams {
	o.SetControllerOverTemperature(controllerOverTemperature)
	return o
}

// SetControllerOverTemperature adds the controllerOverTemperature to the nodes get params
func (o *NodesGetParams) SetControllerOverTemperature(controllerOverTemperature *string) {
	o.ControllerOverTemperature = controllerOverTemperature
}

// WithDate adds the date to the nodes get params
func (o *NodesGetParams) WithDate(date *string) *NodesGetParams {
	o.SetDate(date)
	return o
}

// SetDate adds the date to the nodes get params
func (o *NodesGetParams) SetDate(date *string) {
	o.Date = date
}

// WithFields adds the fields to the nodes get params
func (o *NodesGetParams) WithFields(fields []string) *NodesGetParams {
	o.SetFields(fields)
	return o
}

// SetFields adds the fields to the nodes get params
func (o *NodesGetParams) SetFields(fields []string) {
	o.Fields = fields
}

// WithHaAutoGiveback adds the haAutoGiveback to the nodes get params
func (o *NodesGetParams) WithHaAutoGiveback(haAutoGiveback *bool) *NodesGetParams {
	o.SetHaAutoGiveback(haAutoGiveback)
	return o
}

// SetHaAutoGiveback adds the haAutoGiveback to the nodes get params
func (o *NodesGetParams) SetHaAutoGiveback(haAutoGiveback *bool) {
	o.HaAutoGiveback = haAutoGiveback
}

// WithHaEnabled adds the haEnabled to the nodes get params
func (o *NodesGetParams) WithHaEnabled(haEnabled *bool) *NodesGetParams {
	o.SetHaEnabled(haEnabled)
	return o
}

// SetHaEnabled adds the haEnabled to the nodes get params
func (o *NodesGetParams) SetHaEnabled(haEnabled *bool) {
	o.HaEnabled = haEnabled
}

// WithHaGivebackFailureCode adds the haGivebackFailureCode to the nodes get params
func (o *NodesGetParams) WithHaGivebackFailureCode(haGivebackFailureCode *int64) *NodesGetParams {
	o.SetHaGivebackFailureCode(haGivebackFailureCode)
	return o
}

// SetHaGivebackFailureCode adds the haGivebackFailureCode to the nodes get params
func (o *NodesGetParams) SetHaGivebackFailureCode(haGivebackFailureCode *int64) {
	o.HaGivebackFailureCode = haGivebackFailureCode
}

// WithHaGivebackFailureMessage adds the haGivebackFailureMessage to the nodes get params
func (o *NodesGetParams) WithHaGivebackFailureMessage(haGivebackFailureMessage *string) *NodesGetParams {
	o.SetHaGivebackFailureMessage(haGivebackFailureMessage)
	return o
}

// SetHaGivebackFailureMessage adds the haGivebackFailureMessage to the nodes get params
func (o *NodesGetParams) SetHaGivebackFailureMessage(haGivebackFailureMessage *string) {
	o.HaGivebackFailureMessage = haGivebackFailureMessage
}

// WithHaGivebackState adds the haGivebackState to the nodes get params
func (o *NodesGetParams) WithHaGivebackState(haGivebackState *string) *NodesGetParams {
	o.SetHaGivebackState(haGivebackState)
	return o
}

// SetHaGivebackState adds the haGivebackState to the nodes get params
func (o *NodesGetParams) SetHaGivebackState(haGivebackState *string) {
	o.HaGivebackState = haGivebackState
}

// WithHaPartnersName adds the haPartnersName to the nodes get params
func (o *NodesGetParams) WithHaPartnersName(haPartnersName *string) *NodesGetParams {
	o.SetHaPartnersName(haPartnersName)
	return o
}

// SetHaPartnersName adds the haPartnersName to the nodes get params
func (o *NodesGetParams) SetHaPartnersName(haPartnersName *string) {
	o.HaPartnersName = haPartnersName
}

// WithHaPartnersUUID adds the haPartnersUUID to the nodes get params
func (o *NodesGetParams) WithHaPartnersUUID(haPartnersUUID *string) *NodesGetParams {
	o.SetHaPartnersUUID(haPartnersUUID)
	return o
}

// SetHaPartnersUUID adds the haPartnersUuid to the nodes get params
func (o *NodesGetParams) SetHaPartnersUUID(haPartnersUUID *string) {
	o.HaPartnersUUID = haPartnersUUID
}

// WithHaPortsNumber adds the haPortsNumber to the nodes get params
func (o *NodesGetParams) WithHaPortsNumber(haPortsNumber *int64) *NodesGetParams {
	o.SetHaPortsNumber(haPortsNumber)
	return o
}

// SetHaPortsNumber adds the haPortsNumber to the nodes get params
func (o *NodesGetParams) SetHaPortsNumber(haPortsNumber *int64) {
	o.HaPortsNumber = haPortsNumber
}

// WithHaPortsState adds the haPortsState to the nodes get params
func (o *NodesGetParams) WithHaPortsState(haPortsState *string) *NodesGetParams {
	o.SetHaPortsState(haPortsState)
	return o
}

// SetHaPortsState adds the haPortsState to the nodes get params
func (o *NodesGetParams) SetHaPortsState(haPortsState *string) {
	o.HaPortsState = haPortsState
}

// WithHaTakeoverFailureCode adds the haTakeoverFailureCode to the nodes get params
func (o *NodesGetParams) WithHaTakeoverFailureCode(haTakeoverFailureCode *int64) *NodesGetParams {
	o.SetHaTakeoverFailureCode(haTakeoverFailureCode)
	return o
}

// SetHaTakeoverFailureCode adds the haTakeoverFailureCode to the nodes get params
func (o *NodesGetParams) SetHaTakeoverFailureCode(haTakeoverFailureCode *int64) {
	o.HaTakeoverFailureCode = haTakeoverFailureCode
}

// WithHaTakeoverFailureMessage adds the haTakeoverFailureMessage to the nodes get params
func (o *NodesGetParams) WithHaTakeoverFailureMessage(haTakeoverFailureMessage *string) *NodesGetParams {
	o.SetHaTakeoverFailureMessage(haTakeoverFailureMessage)
	return o
}

// SetHaTakeoverFailureMessage adds the haTakeoverFailureMessage to the nodes get params
func (o *NodesGetParams) SetHaTakeoverFailureMessage(haTakeoverFailureMessage *string) {
	o.HaTakeoverFailureMessage = haTakeoverFailureMessage
}

// WithHaTakeoverState adds the haTakeoverState to the nodes get params
func (o *NodesGetParams) WithHaTakeoverState(haTakeoverState *string) *NodesGetParams {
	o.SetHaTakeoverState(haTakeoverState)
	return o
}

// SetHaTakeoverState adds the haTakeoverState to the nodes get params
func (o *NodesGetParams) SetHaTakeoverState(haTakeoverState *string) {
	o.HaTakeoverState = haTakeoverState
}

// WithLocation adds the location to the nodes get params
func (o *NodesGetParams) WithLocation(location *string) *NodesGetParams {
	o.SetLocation(location)
	return o
}

// SetLocation adds the location to the nodes get params
func (o *NodesGetParams) SetLocation(location *string) {
	o.Location = location
}

// WithManagementInterfacesIPAddress adds the managementInterfacesIPAddress to the nodes get params
func (o *NodesGetParams) WithManagementInterfacesIPAddress(managementInterfacesIPAddress *string) *NodesGetParams {
	o.SetManagementInterfacesIPAddress(managementInterfacesIPAddress)
	return o
}

// SetManagementInterfacesIPAddress adds the managementInterfacesIpAddress to the nodes get params
func (o *NodesGetParams) SetManagementInterfacesIPAddress(managementInterfacesIPAddress *string) {
	o.ManagementInterfacesIPAddress = managementInterfacesIPAddress
}

// WithManagementInterfacesName adds the managementInterfacesName to the nodes get params
func (o *NodesGetParams) WithManagementInterfacesName(managementInterfacesName *string) *NodesGetParams {
	o.SetManagementInterfacesName(managementInterfacesName)
	return o
}

// SetManagementInterfacesName adds the managementInterfacesName to the nodes get params
func (o *NodesGetParams) SetManagementInterfacesName(managementInterfacesName *string) {
	o.ManagementInterfacesName = managementInterfacesName
}

// WithManagementInterfacesUUID adds the managementInterfacesUUID to the nodes get params
func (o *NodesGetParams) WithManagementInterfacesUUID(managementInterfacesUUID *string) *NodesGetParams {
	o.SetManagementInterfacesUUID(managementInterfacesUUID)
	return o
}

// SetManagementInterfacesUUID adds the managementInterfacesUuid to the nodes get params
func (o *NodesGetParams) SetManagementInterfacesUUID(managementInterfacesUUID *string) {
	o.ManagementInterfacesUUID = managementInterfacesUUID
}

// WithMaxRecords adds the maxRecords to the nodes get params
func (o *NodesGetParams) WithMaxRecords(maxRecords *int64) *NodesGetParams {
	o.SetMaxRecords(maxRecords)
	return o
}

// SetMaxRecords adds the maxRecords to the nodes get params
func (o *NodesGetParams) SetMaxRecords(maxRecords *int64) {
	o.MaxRecords = maxRecords
}

// WithMembership adds the membership to the nodes get params
func (o *NodesGetParams) WithMembership(membership *string) *NodesGetParams {
	o.SetMembership(membership)
	return o
}

// SetMembership adds the membership to the nodes get params
func (o *NodesGetParams) SetMembership(membership *string) {
	o.Membership = membership
}

// WithModel adds the model to the nodes get params
func (o *NodesGetParams) WithModel(model *string) *NodesGetParams {
	o.SetModel(model)
	return o
}

// SetModel adds the model to the nodes get params
func (o *NodesGetParams) SetModel(model *string) {
	o.Model = model
}

// WithName adds the name to the nodes get params
func (o *NodesGetParams) WithName(name *string) *NodesGetParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the nodes get params
func (o *NodesGetParams) SetName(name *string) {
	o.Name = name
}

// WithOrderBy adds the orderBy to the nodes get params
func (o *NodesGetParams) WithOrderBy(orderBy []string) *NodesGetParams {
	o.SetOrderBy(orderBy)
	return o
}

// SetOrderBy adds the orderBy to the nodes get params
func (o *NodesGetParams) SetOrderBy(orderBy []string) {
	o.OrderBy = orderBy
}

// WithReturnRecords adds the returnRecords to the nodes get params
func (o *NodesGetParams) WithReturnRecords(returnRecords *bool) *NodesGetParams {
	o.SetReturnRecords(returnRecords)
	return o
}

// SetReturnRecords adds the returnRecords to the nodes get params
func (o *NodesGetParams) SetReturnRecords(returnRecords *bool) {
	o.ReturnRecords = returnRecords
}

// WithReturnTimeout adds the returnTimeout to the nodes get params
func (o *NodesGetParams) WithReturnTimeout(returnTimeout *int64) *NodesGetParams {
	o.SetReturnTimeout(returnTimeout)
	return o
}

// SetReturnTimeout adds the returnTimeout to the nodes get params
func (o *NodesGetParams) SetReturnTimeout(returnTimeout *int64) {
	o.ReturnTimeout = returnTimeout
}

// WithSerialNumber adds the serialNumber to the nodes get params
func (o *NodesGetParams) WithSerialNumber(serialNumber *string) *NodesGetParams {
	o.SetSerialNumber(serialNumber)
	return o
}

// SetSerialNumber adds the serialNumber to the nodes get params
func (o *NodesGetParams) SetSerialNumber(serialNumber *string) {
	o.SerialNumber = serialNumber
}

// WithServiceProcessorDhcpEnabled adds the serviceProcessorDhcpEnabled to the nodes get params
func (o *NodesGetParams) WithServiceProcessorDhcpEnabled(serviceProcessorDhcpEnabled *bool) *NodesGetParams {
	o.SetServiceProcessorDhcpEnabled(serviceProcessorDhcpEnabled)
	return o
}

// SetServiceProcessorDhcpEnabled adds the serviceProcessorDhcpEnabled to the nodes get params
func (o *NodesGetParams) SetServiceProcessorDhcpEnabled(serviceProcessorDhcpEnabled *bool) {
	o.ServiceProcessorDhcpEnabled = serviceProcessorDhcpEnabled
}

// WithServiceProcessorFirmwareVersion adds the serviceProcessorFirmwareVersion to the nodes get params
func (o *NodesGetParams) WithServiceProcessorFirmwareVersion(serviceProcessorFirmwareVersion *string) *NodesGetParams {
	o.SetServiceProcessorFirmwareVersion(serviceProcessorFirmwareVersion)
	return o
}

// SetServiceProcessorFirmwareVersion adds the serviceProcessorFirmwareVersion to the nodes get params
func (o *NodesGetParams) SetServiceProcessorFirmwareVersion(serviceProcessorFirmwareVersion *string) {
	o.ServiceProcessorFirmwareVersion = serviceProcessorFirmwareVersion
}

// WithServiceProcessorIPV4InterfaceAddress adds the serviceProcessorIPV4InterfaceAddress to the nodes get params
func (o *NodesGetParams) WithServiceProcessorIPV4InterfaceAddress(serviceProcessorIPV4InterfaceAddress *string) *NodesGetParams {
	o.SetServiceProcessorIPV4InterfaceAddress(serviceProcessorIPV4InterfaceAddress)
	return o
}

// SetServiceProcessorIPV4InterfaceAddress adds the serviceProcessorIpv4InterfaceAddress to the nodes get params
func (o *NodesGetParams) SetServiceProcessorIPV4InterfaceAddress(serviceProcessorIPV4InterfaceAddress *string) {
	o.ServiceProcessorIPV4InterfaceAddress = serviceProcessorIPV4InterfaceAddress
}

// WithServiceProcessorIPV4InterfaceGateway adds the serviceProcessorIPV4InterfaceGateway to the nodes get params
func (o *NodesGetParams) WithServiceProcessorIPV4InterfaceGateway(serviceProcessorIPV4InterfaceGateway *string) *NodesGetParams {
	o.SetServiceProcessorIPV4InterfaceGateway(serviceProcessorIPV4InterfaceGateway)
	return o
}

// SetServiceProcessorIPV4InterfaceGateway adds the serviceProcessorIpv4InterfaceGateway to the nodes get params
func (o *NodesGetParams) SetServiceProcessorIPV4InterfaceGateway(serviceProcessorIPV4InterfaceGateway *string) {
	o.ServiceProcessorIPV4InterfaceGateway = serviceProcessorIPV4InterfaceGateway
}

// WithServiceProcessorIPV4InterfaceNetmask adds the serviceProcessorIPV4InterfaceNetmask to the nodes get params
func (o *NodesGetParams) WithServiceProcessorIPV4InterfaceNetmask(serviceProcessorIPV4InterfaceNetmask *string) *NodesGetParams {
	o.SetServiceProcessorIPV4InterfaceNetmask(serviceProcessorIPV4InterfaceNetmask)
	return o
}

// SetServiceProcessorIPV4InterfaceNetmask adds the serviceProcessorIpv4InterfaceNetmask to the nodes get params
func (o *NodesGetParams) SetServiceProcessorIPV4InterfaceNetmask(serviceProcessorIPV4InterfaceNetmask *string) {
	o.ServiceProcessorIPV4InterfaceNetmask = serviceProcessorIPV4InterfaceNetmask
}

// WithServiceProcessorIPV6InterfaceAddress adds the serviceProcessorIPV6InterfaceAddress to the nodes get params
func (o *NodesGetParams) WithServiceProcessorIPV6InterfaceAddress(serviceProcessorIPV6InterfaceAddress *string) *NodesGetParams {
	o.SetServiceProcessorIPV6InterfaceAddress(serviceProcessorIPV6InterfaceAddress)
	return o
}

// SetServiceProcessorIPV6InterfaceAddress adds the serviceProcessorIpv6InterfaceAddress to the nodes get params
func (o *NodesGetParams) SetServiceProcessorIPV6InterfaceAddress(serviceProcessorIPV6InterfaceAddress *string) {
	o.ServiceProcessorIPV6InterfaceAddress = serviceProcessorIPV6InterfaceAddress
}

// WithServiceProcessorIPV6InterfaceGateway adds the serviceProcessorIPV6InterfaceGateway to the nodes get params
func (o *NodesGetParams) WithServiceProcessorIPV6InterfaceGateway(serviceProcessorIPV6InterfaceGateway *string) *NodesGetParams {
	o.SetServiceProcessorIPV6InterfaceGateway(serviceProcessorIPV6InterfaceGateway)
	return o
}

// SetServiceProcessorIPV6InterfaceGateway adds the serviceProcessorIpv6InterfaceGateway to the nodes get params
func (o *NodesGetParams) SetServiceProcessorIPV6InterfaceGateway(serviceProcessorIPV6InterfaceGateway *string) {
	o.ServiceProcessorIPV6InterfaceGateway = serviceProcessorIPV6InterfaceGateway
}

// WithServiceProcessorIPV6InterfaceNetmask adds the serviceProcessorIPV6InterfaceNetmask to the nodes get params
func (o *NodesGetParams) WithServiceProcessorIPV6InterfaceNetmask(serviceProcessorIPV6InterfaceNetmask *string) *NodesGetParams {
	o.SetServiceProcessorIPV6InterfaceNetmask(serviceProcessorIPV6InterfaceNetmask)
	return o
}

// SetServiceProcessorIPV6InterfaceNetmask adds the serviceProcessorIpv6InterfaceNetmask to the nodes get params
func (o *NodesGetParams) SetServiceProcessorIPV6InterfaceNetmask(serviceProcessorIPV6InterfaceNetmask *string) {
	o.ServiceProcessorIPV6InterfaceNetmask = serviceProcessorIPV6InterfaceNetmask
}

// WithServiceProcessorLinkStatus adds the serviceProcessorLinkStatus to the nodes get params
func (o *NodesGetParams) WithServiceProcessorLinkStatus(serviceProcessorLinkStatus *string) *NodesGetParams {
	o.SetServiceProcessorLinkStatus(serviceProcessorLinkStatus)
	return o
}

// SetServiceProcessorLinkStatus adds the serviceProcessorLinkStatus to the nodes get params
func (o *NodesGetParams) SetServiceProcessorLinkStatus(serviceProcessorLinkStatus *string) {
	o.ServiceProcessorLinkStatus = serviceProcessorLinkStatus
}

// WithServiceProcessorMacAddress adds the serviceProcessorMacAddress to the nodes get params
func (o *NodesGetParams) WithServiceProcessorMacAddress(serviceProcessorMacAddress *string) *NodesGetParams {
	o.SetServiceProcessorMacAddress(serviceProcessorMacAddress)
	return o
}

// SetServiceProcessorMacAddress adds the serviceProcessorMacAddress to the nodes get params
func (o *NodesGetParams) SetServiceProcessorMacAddress(serviceProcessorMacAddress *string) {
	o.ServiceProcessorMacAddress = serviceProcessorMacAddress
}

// WithServiceProcessorState adds the serviceProcessorState to the nodes get params
func (o *NodesGetParams) WithServiceProcessorState(serviceProcessorState *string) *NodesGetParams {
	o.SetServiceProcessorState(serviceProcessorState)
	return o
}

// SetServiceProcessorState adds the serviceProcessorState to the nodes get params
func (o *NodesGetParams) SetServiceProcessorState(serviceProcessorState *string) {
	o.ServiceProcessorState = serviceProcessorState
}

// WithState adds the state to the nodes get params
func (o *NodesGetParams) WithState(state *string) *NodesGetParams {
	o.SetState(state)
	return o
}

// SetState adds the state to the nodes get params
func (o *NodesGetParams) SetState(state *string) {
	o.State = state
}

// WithSystemID adds the systemID to the nodes get params
func (o *NodesGetParams) WithSystemID(systemID *string) *NodesGetParams {
	o.SetSystemID(systemID)
	return o
}

// SetSystemID adds the systemId to the nodes get params
func (o *NodesGetParams) SetSystemID(systemID *string) {
	o.SystemID = systemID
}

// WithSystemMachineType adds the systemMachineType to the nodes get params
func (o *NodesGetParams) WithSystemMachineType(systemMachineType *string) *NodesGetParams {
	o.SetSystemMachineType(systemMachineType)
	return o
}

// SetSystemMachineType adds the systemMachineType to the nodes get params
func (o *NodesGetParams) SetSystemMachineType(systemMachineType *string) {
	o.SystemMachineType = systemMachineType
}

// WithUptime adds the uptime to the nodes get params
func (o *NodesGetParams) WithUptime(uptime *int64) *NodesGetParams {
	o.SetUptime(uptime)
	return o
}

// SetUptime adds the uptime to the nodes get params
func (o *NodesGetParams) SetUptime(uptime *int64) {
	o.Uptime = uptime
}

// WithUUID adds the uuid to the nodes get params
func (o *NodesGetParams) WithUUID(uuid *string) *NodesGetParams {
	o.SetUUID(uuid)
	return o
}

// SetUUID adds the uuid to the nodes get params
func (o *NodesGetParams) SetUUID(uuid *string) {
	o.UUID = uuid
}

// WithVendorSerialNumber adds the vendorSerialNumber to the nodes get params
func (o *NodesGetParams) WithVendorSerialNumber(vendorSerialNumber *string) *NodesGetParams {
	o.SetVendorSerialNumber(vendorSerialNumber)
	return o
}

// SetVendorSerialNumber adds the vendorSerialNumber to the nodes get params
func (o *NodesGetParams) SetVendorSerialNumber(vendorSerialNumber *string) {
	o.VendorSerialNumber = vendorSerialNumber
}

// WithVersionFull adds the versionFull to the nodes get params
func (o *NodesGetParams) WithVersionFull(versionFull *string) *NodesGetParams {
	o.SetVersionFull(versionFull)
	return o
}

// SetVersionFull adds the versionFull to the nodes get params
func (o *NodesGetParams) SetVersionFull(versionFull *string) {
	o.VersionFull = versionFull
}

// WithVersionGeneration adds the versionGeneration to the nodes get params
func (o *NodesGetParams) WithVersionGeneration(versionGeneration *int64) *NodesGetParams {
	o.SetVersionGeneration(versionGeneration)
	return o
}

// SetVersionGeneration adds the versionGeneration to the nodes get params
func (o *NodesGetParams) SetVersionGeneration(versionGeneration *int64) {
	o.VersionGeneration = versionGeneration
}

// WithVersionMajor adds the versionMajor to the nodes get params
func (o *NodesGetParams) WithVersionMajor(versionMajor *int64) *NodesGetParams {
	o.SetVersionMajor(versionMajor)
	return o
}

// SetVersionMajor adds the versionMajor to the nodes get params
func (o *NodesGetParams) SetVersionMajor(versionMajor *int64) {
	o.VersionMajor = versionMajor
}

// WithVersionMinor adds the versionMinor to the nodes get params
func (o *NodesGetParams) WithVersionMinor(versionMinor *int64) *NodesGetParams {
	o.SetVersionMinor(versionMinor)
	return o
}

// SetVersionMinor adds the versionMinor to the nodes get params
func (o *NodesGetParams) SetVersionMinor(versionMinor *int64) {
	o.VersionMinor = versionMinor
}

// WithVMProviderType adds the vMProviderType to the nodes get params
func (o *NodesGetParams) WithVMProviderType(vMProviderType *string) *NodesGetParams {
	o.SetVMProviderType(vMProviderType)
	return o
}

// SetVMProviderType adds the vmProviderType to the nodes get params
func (o *NodesGetParams) SetVMProviderType(vMProviderType *string) {
	o.VMProviderType = vMProviderType
}

// WriteToRequest writes these params to a swagger request
func (o *NodesGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.ClusterInterfacesIPAddress != nil {

		// query param cluster_interfaces.ip.address
		var qrClusterInterfacesIPAddress string
		if o.ClusterInterfacesIPAddress != nil {
			qrClusterInterfacesIPAddress = *o.ClusterInterfacesIPAddress
		}
		qClusterInterfacesIPAddress := qrClusterInterfacesIPAddress
		if qClusterInterfacesIPAddress != "" {
			if err := r.SetQueryParam("cluster_interfaces.ip.address", qClusterInterfacesIPAddress); err != nil {
				return err
			}
		}

	}

	if o.ClusterInterfacesName != nil {

		// query param cluster_interfaces.name
		var qrClusterInterfacesName string
		if o.ClusterInterfacesName != nil {
			qrClusterInterfacesName = *o.ClusterInterfacesName
		}
		qClusterInterfacesName := qrClusterInterfacesName
		if qClusterInterfacesName != "" {
			if err := r.SetQueryParam("cluster_interfaces.name", qClusterInterfacesName); err != nil {
				return err
			}
		}

	}

	if o.ClusterInterfacesUUID != nil {

		// query param cluster_interfaces.uuid
		var qrClusterInterfacesUUID string
		if o.ClusterInterfacesUUID != nil {
			qrClusterInterfacesUUID = *o.ClusterInterfacesUUID
		}
		qClusterInterfacesUUID := qrClusterInterfacesUUID
		if qClusterInterfacesUUID != "" {
			if err := r.SetQueryParam("cluster_interfaces.uuid", qClusterInterfacesUUID); err != nil {
				return err
			}
		}

	}

	if o.ControllerFlashCacheCapacity != nil {

		// query param controller.flash_cache.capacity
		var qrControllerFlashCacheCapacity int64
		if o.ControllerFlashCacheCapacity != nil {
			qrControllerFlashCacheCapacity = *o.ControllerFlashCacheCapacity
		}
		qControllerFlashCacheCapacity := swag.FormatInt64(qrControllerFlashCacheCapacity)
		if qControllerFlashCacheCapacity != "" {
			if err := r.SetQueryParam("controller.flash_cache.capacity", qControllerFlashCacheCapacity); err != nil {
				return err
			}
		}

	}

	if o.ControllerFlashCacheFirmwareVersion != nil {

		// query param controller.flash_cache.firmware_version
		var qrControllerFlashCacheFirmwareVersion string
		if o.ControllerFlashCacheFirmwareVersion != nil {
			qrControllerFlashCacheFirmwareVersion = *o.ControllerFlashCacheFirmwareVersion
		}
		qControllerFlashCacheFirmwareVersion := qrControllerFlashCacheFirmwareVersion
		if qControllerFlashCacheFirmwareVersion != "" {
			if err := r.SetQueryParam("controller.flash_cache.firmware_version", qControllerFlashCacheFirmwareVersion); err != nil {
				return err
			}
		}

	}

	if o.ControllerFlashCacheHardwareRevision != nil {

		// query param controller.flash_cache.hardware_revision
		var qrControllerFlashCacheHardwareRevision string
		if o.ControllerFlashCacheHardwareRevision != nil {
			qrControllerFlashCacheHardwareRevision = *o.ControllerFlashCacheHardwareRevision
		}
		qControllerFlashCacheHardwareRevision := qrControllerFlashCacheHardwareRevision
		if qControllerFlashCacheHardwareRevision != "" {
			if err := r.SetQueryParam("controller.flash_cache.hardware_revision", qControllerFlashCacheHardwareRevision); err != nil {
				return err
			}
		}

	}

	if o.ControllerFlashCacheModel != nil {

		// query param controller.flash_cache.model
		var qrControllerFlashCacheModel string
		if o.ControllerFlashCacheModel != nil {
			qrControllerFlashCacheModel = *o.ControllerFlashCacheModel
		}
		qControllerFlashCacheModel := qrControllerFlashCacheModel
		if qControllerFlashCacheModel != "" {
			if err := r.SetQueryParam("controller.flash_cache.model", qControllerFlashCacheModel); err != nil {
				return err
			}
		}

	}

	if o.ControllerFlashCachePartNumber != nil {

		// query param controller.flash_cache.part_number
		var qrControllerFlashCachePartNumber string
		if o.ControllerFlashCachePartNumber != nil {
			qrControllerFlashCachePartNumber = *o.ControllerFlashCachePartNumber
		}
		qControllerFlashCachePartNumber := qrControllerFlashCachePartNumber
		if qControllerFlashCachePartNumber != "" {
			if err := r.SetQueryParam("controller.flash_cache.part_number", qControllerFlashCachePartNumber); err != nil {
				return err
			}
		}

	}

	if o.ControllerFlashCacheSerialNumber != nil {

		// query param controller.flash_cache.serial_number
		var qrControllerFlashCacheSerialNumber string
		if o.ControllerFlashCacheSerialNumber != nil {
			qrControllerFlashCacheSerialNumber = *o.ControllerFlashCacheSerialNumber
		}
		qControllerFlashCacheSerialNumber := qrControllerFlashCacheSerialNumber
		if qControllerFlashCacheSerialNumber != "" {
			if err := r.SetQueryParam("controller.flash_cache.serial_number", qControllerFlashCacheSerialNumber); err != nil {
				return err
			}
		}

	}

	if o.ControllerFlashCacheSlot != nil {

		// query param controller.flash_cache.slot
		var qrControllerFlashCacheSlot string
		if o.ControllerFlashCacheSlot != nil {
			qrControllerFlashCacheSlot = *o.ControllerFlashCacheSlot
		}
		qControllerFlashCacheSlot := qrControllerFlashCacheSlot
		if qControllerFlashCacheSlot != "" {
			if err := r.SetQueryParam("controller.flash_cache.slot", qControllerFlashCacheSlot); err != nil {
				return err
			}
		}

	}

	if o.ControllerFlashCacheState != nil {

		// query param controller.flash_cache.state
		var qrControllerFlashCacheState string
		if o.ControllerFlashCacheState != nil {
			qrControllerFlashCacheState = *o.ControllerFlashCacheState
		}
		qControllerFlashCacheState := qrControllerFlashCacheState
		if qControllerFlashCacheState != "" {
			if err := r.SetQueryParam("controller.flash_cache.state", qControllerFlashCacheState); err != nil {
				return err
			}
		}

	}

	if o.ControllerFrusID != nil {

		// query param controller.frus.id
		var qrControllerFrusID int64
		if o.ControllerFrusID != nil {
			qrControllerFrusID = *o.ControllerFrusID
		}
		qControllerFrusID := swag.FormatInt64(qrControllerFrusID)
		if qControllerFrusID != "" {
			if err := r.SetQueryParam("controller.frus.id", qControllerFrusID); err != nil {
				return err
			}
		}

	}

	if o.ControllerFrusState != nil {

		// query param controller.frus.state
		var qrControllerFrusState string
		if o.ControllerFrusState != nil {
			qrControllerFrusState = *o.ControllerFrusState
		}
		qControllerFrusState := qrControllerFrusState
		if qControllerFrusState != "" {
			if err := r.SetQueryParam("controller.frus.state", qControllerFrusState); err != nil {
				return err
			}
		}

	}

	if o.ControllerFrusType != nil {

		// query param controller.frus.type
		var qrControllerFrusType string
		if o.ControllerFrusType != nil {
			qrControllerFrusType = *o.ControllerFrusType
		}
		qControllerFrusType := qrControllerFrusType
		if qControllerFrusType != "" {
			if err := r.SetQueryParam("controller.frus.type", qControllerFrusType); err != nil {
				return err
			}
		}

	}

	if o.ControllerOverTemperature != nil {

		// query param controller.over_temperature
		var qrControllerOverTemperature string
		if o.ControllerOverTemperature != nil {
			qrControllerOverTemperature = *o.ControllerOverTemperature
		}
		qControllerOverTemperature := qrControllerOverTemperature
		if qControllerOverTemperature != "" {
			if err := r.SetQueryParam("controller.over_temperature", qControllerOverTemperature); err != nil {
				return err
			}
		}

	}

	if o.Date != nil {

		// query param date
		var qrDate string
		if o.Date != nil {
			qrDate = *o.Date
		}
		qDate := qrDate
		if qDate != "" {
			if err := r.SetQueryParam("date", qDate); err != nil {
				return err
			}
		}

	}

	valuesFields := o.Fields

	joinedFields := swag.JoinByFormat(valuesFields, "csv")
	// query array param fields
	if err := r.SetQueryParam("fields", joinedFields...); err != nil {
		return err
	}

	if o.HaAutoGiveback != nil {

		// query param ha.auto_giveback
		var qrHaAutoGiveback bool
		if o.HaAutoGiveback != nil {
			qrHaAutoGiveback = *o.HaAutoGiveback
		}
		qHaAutoGiveback := swag.FormatBool(qrHaAutoGiveback)
		if qHaAutoGiveback != "" {
			if err := r.SetQueryParam("ha.auto_giveback", qHaAutoGiveback); err != nil {
				return err
			}
		}

	}

	if o.HaEnabled != nil {

		// query param ha.enabled
		var qrHaEnabled bool
		if o.HaEnabled != nil {
			qrHaEnabled = *o.HaEnabled
		}
		qHaEnabled := swag.FormatBool(qrHaEnabled)
		if qHaEnabled != "" {
			if err := r.SetQueryParam("ha.enabled", qHaEnabled); err != nil {
				return err
			}
		}

	}

	if o.HaGivebackFailureCode != nil {

		// query param ha.giveback.failure.code
		var qrHaGivebackFailureCode int64
		if o.HaGivebackFailureCode != nil {
			qrHaGivebackFailureCode = *o.HaGivebackFailureCode
		}
		qHaGivebackFailureCode := swag.FormatInt64(qrHaGivebackFailureCode)
		if qHaGivebackFailureCode != "" {
			if err := r.SetQueryParam("ha.giveback.failure.code", qHaGivebackFailureCode); err != nil {
				return err
			}
		}

	}

	if o.HaGivebackFailureMessage != nil {

		// query param ha.giveback.failure.message
		var qrHaGivebackFailureMessage string
		if o.HaGivebackFailureMessage != nil {
			qrHaGivebackFailureMessage = *o.HaGivebackFailureMessage
		}
		qHaGivebackFailureMessage := qrHaGivebackFailureMessage
		if qHaGivebackFailureMessage != "" {
			if err := r.SetQueryParam("ha.giveback.failure.message", qHaGivebackFailureMessage); err != nil {
				return err
			}
		}

	}

	if o.HaGivebackState != nil {

		// query param ha.giveback.state
		var qrHaGivebackState string
		if o.HaGivebackState != nil {
			qrHaGivebackState = *o.HaGivebackState
		}
		qHaGivebackState := qrHaGivebackState
		if qHaGivebackState != "" {
			if err := r.SetQueryParam("ha.giveback.state", qHaGivebackState); err != nil {
				return err
			}
		}

	}

	if o.HaPartnersName != nil {

		// query param ha.partners.name
		var qrHaPartnersName string
		if o.HaPartnersName != nil {
			qrHaPartnersName = *o.HaPartnersName
		}
		qHaPartnersName := qrHaPartnersName
		if qHaPartnersName != "" {
			if err := r.SetQueryParam("ha.partners.name", qHaPartnersName); err != nil {
				return err
			}
		}

	}

	if o.HaPartnersUUID != nil {

		// query param ha.partners.uuid
		var qrHaPartnersUUID string
		if o.HaPartnersUUID != nil {
			qrHaPartnersUUID = *o.HaPartnersUUID
		}
		qHaPartnersUUID := qrHaPartnersUUID
		if qHaPartnersUUID != "" {
			if err := r.SetQueryParam("ha.partners.uuid", qHaPartnersUUID); err != nil {
				return err
			}
		}

	}

	if o.HaPortsNumber != nil {

		// query param ha.ports.number
		var qrHaPortsNumber int64
		if o.HaPortsNumber != nil {
			qrHaPortsNumber = *o.HaPortsNumber
		}
		qHaPortsNumber := swag.FormatInt64(qrHaPortsNumber)
		if qHaPortsNumber != "" {
			if err := r.SetQueryParam("ha.ports.number", qHaPortsNumber); err != nil {
				return err
			}
		}

	}

	if o.HaPortsState != nil {

		// query param ha.ports.state
		var qrHaPortsState string
		if o.HaPortsState != nil {
			qrHaPortsState = *o.HaPortsState
		}
		qHaPortsState := qrHaPortsState
		if qHaPortsState != "" {
			if err := r.SetQueryParam("ha.ports.state", qHaPortsState); err != nil {
				return err
			}
		}

	}

	if o.HaTakeoverFailureCode != nil {

		// query param ha.takeover.failure.code
		var qrHaTakeoverFailureCode int64
		if o.HaTakeoverFailureCode != nil {
			qrHaTakeoverFailureCode = *o.HaTakeoverFailureCode
		}
		qHaTakeoverFailureCode := swag.FormatInt64(qrHaTakeoverFailureCode)
		if qHaTakeoverFailureCode != "" {
			if err := r.SetQueryParam("ha.takeover.failure.code", qHaTakeoverFailureCode); err != nil {
				return err
			}
		}

	}

	if o.HaTakeoverFailureMessage != nil {

		// query param ha.takeover.failure.message
		var qrHaTakeoverFailureMessage string
		if o.HaTakeoverFailureMessage != nil {
			qrHaTakeoverFailureMessage = *o.HaTakeoverFailureMessage
		}
		qHaTakeoverFailureMessage := qrHaTakeoverFailureMessage
		if qHaTakeoverFailureMessage != "" {
			if err := r.SetQueryParam("ha.takeover.failure.message", qHaTakeoverFailureMessage); err != nil {
				return err
			}
		}

	}

	if o.HaTakeoverState != nil {

		// query param ha.takeover.state
		var qrHaTakeoverState string
		if o.HaTakeoverState != nil {
			qrHaTakeoverState = *o.HaTakeoverState
		}
		qHaTakeoverState := qrHaTakeoverState
		if qHaTakeoverState != "" {
			if err := r.SetQueryParam("ha.takeover.state", qHaTakeoverState); err != nil {
				return err
			}
		}

	}

	if o.Location != nil {

		// query param location
		var qrLocation string
		if o.Location != nil {
			qrLocation = *o.Location
		}
		qLocation := qrLocation
		if qLocation != "" {
			if err := r.SetQueryParam("location", qLocation); err != nil {
				return err
			}
		}

	}

	if o.ManagementInterfacesIPAddress != nil {

		// query param management_interfaces.ip.address
		var qrManagementInterfacesIPAddress string
		if o.ManagementInterfacesIPAddress != nil {
			qrManagementInterfacesIPAddress = *o.ManagementInterfacesIPAddress
		}
		qManagementInterfacesIPAddress := qrManagementInterfacesIPAddress
		if qManagementInterfacesIPAddress != "" {
			if err := r.SetQueryParam("management_interfaces.ip.address", qManagementInterfacesIPAddress); err != nil {
				return err
			}
		}

	}

	if o.ManagementInterfacesName != nil {

		// query param management_interfaces.name
		var qrManagementInterfacesName string
		if o.ManagementInterfacesName != nil {
			qrManagementInterfacesName = *o.ManagementInterfacesName
		}
		qManagementInterfacesName := qrManagementInterfacesName
		if qManagementInterfacesName != "" {
			if err := r.SetQueryParam("management_interfaces.name", qManagementInterfacesName); err != nil {
				return err
			}
		}

	}

	if o.ManagementInterfacesUUID != nil {

		// query param management_interfaces.uuid
		var qrManagementInterfacesUUID string
		if o.ManagementInterfacesUUID != nil {
			qrManagementInterfacesUUID = *o.ManagementInterfacesUUID
		}
		qManagementInterfacesUUID := qrManagementInterfacesUUID
		if qManagementInterfacesUUID != "" {
			if err := r.SetQueryParam("management_interfaces.uuid", qManagementInterfacesUUID); err != nil {
				return err
			}
		}

	}

	if o.MaxRecords != nil {

		// query param max_records
		var qrMaxRecords int64
		if o.MaxRecords != nil {
			qrMaxRecords = *o.MaxRecords
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {
			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}

	}

	if o.Membership != nil {

		// query param membership
		var qrMembership string
		if o.Membership != nil {
			qrMembership = *o.Membership
		}
		qMembership := qrMembership
		if qMembership != "" {
			if err := r.SetQueryParam("membership", qMembership); err != nil {
				return err
			}
		}

	}

	if o.Model != nil {

		// query param model
		var qrModel string
		if o.Model != nil {
			qrModel = *o.Model
		}
		qModel := qrModel
		if qModel != "" {
			if err := r.SetQueryParam("model", qModel); err != nil {
				return err
			}
		}

	}

	if o.Name != nil {

		// query param name
		var qrName string
		if o.Name != nil {
			qrName = *o.Name
		}
		qName := qrName
		if qName != "" {
			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}

	}

	valuesOrderBy := o.OrderBy

	joinedOrderBy := swag.JoinByFormat(valuesOrderBy, "csv")
	// query array param order_by
	if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
		return err
	}

	if o.ReturnRecords != nil {

		// query param return_records
		var qrReturnRecords bool
		if o.ReturnRecords != nil {
			qrReturnRecords = *o.ReturnRecords
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {
			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}

	}

	if o.ReturnTimeout != nil {

		// query param return_timeout
		var qrReturnTimeout int64
		if o.ReturnTimeout != nil {
			qrReturnTimeout = *o.ReturnTimeout
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {
			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}

	}

	if o.SerialNumber != nil {

		// query param serial_number
		var qrSerialNumber string
		if o.SerialNumber != nil {
			qrSerialNumber = *o.SerialNumber
		}
		qSerialNumber := qrSerialNumber
		if qSerialNumber != "" {
			if err := r.SetQueryParam("serial_number", qSerialNumber); err != nil {
				return err
			}
		}

	}

	if o.ServiceProcessorDhcpEnabled != nil {

		// query param service_processor.dhcp_enabled
		var qrServiceProcessorDhcpEnabled bool
		if o.ServiceProcessorDhcpEnabled != nil {
			qrServiceProcessorDhcpEnabled = *o.ServiceProcessorDhcpEnabled
		}
		qServiceProcessorDhcpEnabled := swag.FormatBool(qrServiceProcessorDhcpEnabled)
		if qServiceProcessorDhcpEnabled != "" {
			if err := r.SetQueryParam("service_processor.dhcp_enabled", qServiceProcessorDhcpEnabled); err != nil {
				return err
			}
		}

	}

	if o.ServiceProcessorFirmwareVersion != nil {

		// query param service_processor.firmware_version
		var qrServiceProcessorFirmwareVersion string
		if o.ServiceProcessorFirmwareVersion != nil {
			qrServiceProcessorFirmwareVersion = *o.ServiceProcessorFirmwareVersion
		}
		qServiceProcessorFirmwareVersion := qrServiceProcessorFirmwareVersion
		if qServiceProcessorFirmwareVersion != "" {
			if err := r.SetQueryParam("service_processor.firmware_version", qServiceProcessorFirmwareVersion); err != nil {
				return err
			}
		}

	}

	if o.ServiceProcessorIPV4InterfaceAddress != nil {

		// query param service_processor.ipv4_interface.address
		var qrServiceProcessorIPV4InterfaceAddress string
		if o.ServiceProcessorIPV4InterfaceAddress != nil {
			qrServiceProcessorIPV4InterfaceAddress = *o.ServiceProcessorIPV4InterfaceAddress
		}
		qServiceProcessorIPV4InterfaceAddress := qrServiceProcessorIPV4InterfaceAddress
		if qServiceProcessorIPV4InterfaceAddress != "" {
			if err := r.SetQueryParam("service_processor.ipv4_interface.address", qServiceProcessorIPV4InterfaceAddress); err != nil {
				return err
			}
		}

	}

	if o.ServiceProcessorIPV4InterfaceGateway != nil {

		// query param service_processor.ipv4_interface.gateway
		var qrServiceProcessorIPV4InterfaceGateway string
		if o.ServiceProcessorIPV4InterfaceGateway != nil {
			qrServiceProcessorIPV4InterfaceGateway = *o.ServiceProcessorIPV4InterfaceGateway
		}
		qServiceProcessorIPV4InterfaceGateway := qrServiceProcessorIPV4InterfaceGateway
		if qServiceProcessorIPV4InterfaceGateway != "" {
			if err := r.SetQueryParam("service_processor.ipv4_interface.gateway", qServiceProcessorIPV4InterfaceGateway); err != nil {
				return err
			}
		}

	}

	if o.ServiceProcessorIPV4InterfaceNetmask != nil {

		// query param service_processor.ipv4_interface.netmask
		var qrServiceProcessorIPV4InterfaceNetmask string
		if o.ServiceProcessorIPV4InterfaceNetmask != nil {
			qrServiceProcessorIPV4InterfaceNetmask = *o.ServiceProcessorIPV4InterfaceNetmask
		}
		qServiceProcessorIPV4InterfaceNetmask := qrServiceProcessorIPV4InterfaceNetmask
		if qServiceProcessorIPV4InterfaceNetmask != "" {
			if err := r.SetQueryParam("service_processor.ipv4_interface.netmask", qServiceProcessorIPV4InterfaceNetmask); err != nil {
				return err
			}
		}

	}

	if o.ServiceProcessorIPV6InterfaceAddress != nil {

		// query param service_processor.ipv6_interface.address
		var qrServiceProcessorIPV6InterfaceAddress string
		if o.ServiceProcessorIPV6InterfaceAddress != nil {
			qrServiceProcessorIPV6InterfaceAddress = *o.ServiceProcessorIPV6InterfaceAddress
		}
		qServiceProcessorIPV6InterfaceAddress := qrServiceProcessorIPV6InterfaceAddress
		if qServiceProcessorIPV6InterfaceAddress != "" {
			if err := r.SetQueryParam("service_processor.ipv6_interface.address", qServiceProcessorIPV6InterfaceAddress); err != nil {
				return err
			}
		}

	}

	if o.ServiceProcessorIPV6InterfaceGateway != nil {

		// query param service_processor.ipv6_interface.gateway
		var qrServiceProcessorIPV6InterfaceGateway string
		if o.ServiceProcessorIPV6InterfaceGateway != nil {
			qrServiceProcessorIPV6InterfaceGateway = *o.ServiceProcessorIPV6InterfaceGateway
		}
		qServiceProcessorIPV6InterfaceGateway := qrServiceProcessorIPV6InterfaceGateway
		if qServiceProcessorIPV6InterfaceGateway != "" {
			if err := r.SetQueryParam("service_processor.ipv6_interface.gateway", qServiceProcessorIPV6InterfaceGateway); err != nil {
				return err
			}
		}

	}

	if o.ServiceProcessorIPV6InterfaceNetmask != nil {

		// query param service_processor.ipv6_interface.netmask
		var qrServiceProcessorIPV6InterfaceNetmask string
		if o.ServiceProcessorIPV6InterfaceNetmask != nil {
			qrServiceProcessorIPV6InterfaceNetmask = *o.ServiceProcessorIPV6InterfaceNetmask
		}
		qServiceProcessorIPV6InterfaceNetmask := qrServiceProcessorIPV6InterfaceNetmask
		if qServiceProcessorIPV6InterfaceNetmask != "" {
			if err := r.SetQueryParam("service_processor.ipv6_interface.netmask", qServiceProcessorIPV6InterfaceNetmask); err != nil {
				return err
			}
		}

	}

	if o.ServiceProcessorLinkStatus != nil {

		// query param service_processor.link_status
		var qrServiceProcessorLinkStatus string
		if o.ServiceProcessorLinkStatus != nil {
			qrServiceProcessorLinkStatus = *o.ServiceProcessorLinkStatus
		}
		qServiceProcessorLinkStatus := qrServiceProcessorLinkStatus
		if qServiceProcessorLinkStatus != "" {
			if err := r.SetQueryParam("service_processor.link_status", qServiceProcessorLinkStatus); err != nil {
				return err
			}
		}

	}

	if o.ServiceProcessorMacAddress != nil {

		// query param service_processor.mac_address
		var qrServiceProcessorMacAddress string
		if o.ServiceProcessorMacAddress != nil {
			qrServiceProcessorMacAddress = *o.ServiceProcessorMacAddress
		}
		qServiceProcessorMacAddress := qrServiceProcessorMacAddress
		if qServiceProcessorMacAddress != "" {
			if err := r.SetQueryParam("service_processor.mac_address", qServiceProcessorMacAddress); err != nil {
				return err
			}
		}

	}

	if o.ServiceProcessorState != nil {

		// query param service_processor.state
		var qrServiceProcessorState string
		if o.ServiceProcessorState != nil {
			qrServiceProcessorState = *o.ServiceProcessorState
		}
		qServiceProcessorState := qrServiceProcessorState
		if qServiceProcessorState != "" {
			if err := r.SetQueryParam("service_processor.state", qServiceProcessorState); err != nil {
				return err
			}
		}

	}

	if o.State != nil {

		// query param state
		var qrState string
		if o.State != nil {
			qrState = *o.State
		}
		qState := qrState
		if qState != "" {
			if err := r.SetQueryParam("state", qState); err != nil {
				return err
			}
		}

	}

	if o.SystemID != nil {

		// query param system_id
		var qrSystemID string
		if o.SystemID != nil {
			qrSystemID = *o.SystemID
		}
		qSystemID := qrSystemID
		if qSystemID != "" {
			if err := r.SetQueryParam("system_id", qSystemID); err != nil {
				return err
			}
		}

	}

	if o.SystemMachineType != nil {

		// query param system_machine_type
		var qrSystemMachineType string
		if o.SystemMachineType != nil {
			qrSystemMachineType = *o.SystemMachineType
		}
		qSystemMachineType := qrSystemMachineType
		if qSystemMachineType != "" {
			if err := r.SetQueryParam("system_machine_type", qSystemMachineType); err != nil {
				return err
			}
		}

	}

	if o.Uptime != nil {

		// query param uptime
		var qrUptime int64
		if o.Uptime != nil {
			qrUptime = *o.Uptime
		}
		qUptime := swag.FormatInt64(qrUptime)
		if qUptime != "" {
			if err := r.SetQueryParam("uptime", qUptime); err != nil {
				return err
			}
		}

	}

	if o.UUID != nil {

		// query param uuid
		var qrUUID string
		if o.UUID != nil {
			qrUUID = *o.UUID
		}
		qUUID := qrUUID
		if qUUID != "" {
			if err := r.SetQueryParam("uuid", qUUID); err != nil {
				return err
			}
		}

	}

	if o.VendorSerialNumber != nil {

		// query param vendor_serial_number
		var qrVendorSerialNumber string
		if o.VendorSerialNumber != nil {
			qrVendorSerialNumber = *o.VendorSerialNumber
		}
		qVendorSerialNumber := qrVendorSerialNumber
		if qVendorSerialNumber != "" {
			if err := r.SetQueryParam("vendor_serial_number", qVendorSerialNumber); err != nil {
				return err
			}
		}

	}

	if o.VersionFull != nil {

		// query param version.full
		var qrVersionFull string
		if o.VersionFull != nil {
			qrVersionFull = *o.VersionFull
		}
		qVersionFull := qrVersionFull
		if qVersionFull != "" {
			if err := r.SetQueryParam("version.full", qVersionFull); err != nil {
				return err
			}
		}

	}

	if o.VersionGeneration != nil {

		// query param version.generation
		var qrVersionGeneration int64
		if o.VersionGeneration != nil {
			qrVersionGeneration = *o.VersionGeneration
		}
		qVersionGeneration := swag.FormatInt64(qrVersionGeneration)
		if qVersionGeneration != "" {
			if err := r.SetQueryParam("version.generation", qVersionGeneration); err != nil {
				return err
			}
		}

	}

	if o.VersionMajor != nil {

		// query param version.major
		var qrVersionMajor int64
		if o.VersionMajor != nil {
			qrVersionMajor = *o.VersionMajor
		}
		qVersionMajor := swag.FormatInt64(qrVersionMajor)
		if qVersionMajor != "" {
			if err := r.SetQueryParam("version.major", qVersionMajor); err != nil {
				return err
			}
		}

	}

	if o.VersionMinor != nil {

		// query param version.minor
		var qrVersionMinor int64
		if o.VersionMinor != nil {
			qrVersionMinor = *o.VersionMinor
		}
		qVersionMinor := swag.FormatInt64(qrVersionMinor)
		if qVersionMinor != "" {
			if err := r.SetQueryParam("version.minor", qVersionMinor); err != nil {
				return err
			}
		}

	}

	if o.VMProviderType != nil {

		// query param vm.provider_type
		var qrVMProviderType string
		if o.VMProviderType != nil {
			qrVMProviderType = *o.VMProviderType
		}
		qVMProviderType := qrVMProviderType
		if qVMProviderType != "" {
			if err := r.SetQueryParam("vm.provider_type", qVMProviderType); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
