// Code generated by go-swagger; DO NOT EDIT.

package networking

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/greenqloud/ontap-rest-client/ntapmodel"
)

// IpspacesCreateReader is a Reader for the IpspacesCreate structure.
type IpspacesCreateReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *IpspacesCreateReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 201:
		result := NewIpspacesCreateCreated()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewIpspacesCreateDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewIpspacesCreateCreated creates a IpspacesCreateCreated with default headers values
func NewIpspacesCreateCreated() *IpspacesCreateCreated {
	return &IpspacesCreateCreated{}
}

/*IpspacesCreateCreated handles this case with default header values.

Created
*/
type IpspacesCreateCreated struct {
}

func (o *IpspacesCreateCreated) Error() string {
	return fmt.Sprintf("[POST /network/ipspaces][%d] ipspacesCreateCreated ", 201)
}

func (o *IpspacesCreateCreated) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewIpspacesCreateDefault creates a IpspacesCreateDefault with default headers values
func NewIpspacesCreateDefault(code int) *IpspacesCreateDefault {
	return &IpspacesCreateDefault{
		_statusCode: code,
	}
}

/*IpspacesCreateDefault handles this case with default header values.

ONTAP Error Response Codes
| Error Code | Description |
| ---------- | ----------- |
| 1967102 | A POST operation might have left the configuration in an inconsistent state. Check the configuration. |
ONTAP Error Response Codes
| Error Code | Description |
| ---------- | ----------- |
| 9240591 | The name is not valid. The name is already in use by a cluster node, Vserver, or it is the name of the local cluster. |

*/
type IpspacesCreateDefault struct {
	_statusCode int

	Payload *ntapmodel.ErrorResponse
}

// Code gets the status code for the ipspaces create default response
func (o *IpspacesCreateDefault) Code() int {
	return o._statusCode
}

func (o *IpspacesCreateDefault) Error() string {
	return fmt.Sprintf("[POST /network/ipspaces][%d] ipspaces_create default  %+v", o._statusCode, o.Payload)
}

func (o *IpspacesCreateDefault) GetPayload() *ntapmodel.ErrorResponse {
	return o.Payload
}

func (o *IpspacesCreateDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(ntapmodel.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
