// Code generated by go-swagger; DO NOT EDIT.

package networking

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/greenqloud/ontap-rest-client/ntapmodel"
)

// NetworkEthernetPortDeleteReader is a Reader for the NetworkEthernetPortDelete structure.
type NetworkEthernetPortDeleteReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *NetworkEthernetPortDeleteReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewNetworkEthernetPortDeleteOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewNetworkEthernetPortDeleteDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewNetworkEthernetPortDeleteOK creates a NetworkEthernetPortDeleteOK with default headers values
func NewNetworkEthernetPortDeleteOK() *NetworkEthernetPortDeleteOK {
	return &NetworkEthernetPortDeleteOK{}
}

/*NetworkEthernetPortDeleteOK handles this case with default header values.

OK
*/
type NetworkEthernetPortDeleteOK struct {
}

func (o *NetworkEthernetPortDeleteOK) Error() string {
	return fmt.Sprintf("[DELETE /network/ethernet/ports/{uuid}][%d] networkEthernetPortDeleteOK ", 200)
}

func (o *NetworkEthernetPortDeleteOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewNetworkEthernetPortDeleteDefault creates a NetworkEthernetPortDeleteDefault with default headers values
func NewNetworkEthernetPortDeleteDefault(code int) *NetworkEthernetPortDeleteDefault {
	return &NetworkEthernetPortDeleteDefault{
		_statusCode: code,
	}
}

/*NetworkEthernetPortDeleteDefault handles this case with default header values.

ONTAP Error Response Codes
| Error Code | Description |
| ---------- | ----------- |
| 1376858 | Port already has an interface bound. |
| 1966189 | Port is the home port or current port of an interface. |

*/
type NetworkEthernetPortDeleteDefault struct {
	_statusCode int

	Payload *ntapmodel.ErrorResponse
}

// Code gets the status code for the network ethernet port delete default response
func (o *NetworkEthernetPortDeleteDefault) Code() int {
	return o._statusCode
}

func (o *NetworkEthernetPortDeleteDefault) Error() string {
	return fmt.Sprintf("[DELETE /network/ethernet/ports/{uuid}][%d] network_ethernet_port_delete default  %+v", o._statusCode, o.Payload)
}

func (o *NetworkEthernetPortDeleteDefault) GetPayload() *ntapmodel.ErrorResponse {
	return o.Payload
}

func (o *NetworkEthernetPortDeleteDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(ntapmodel.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
