// Code generated by go-swagger; DO NOT EDIT.

package networking

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewNetworkEthernetPortsGetParams creates a new NetworkEthernetPortsGetParams object
// with the default values initialized.
func NewNetworkEthernetPortsGetParams() *NetworkEthernetPortsGetParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &NetworkEthernetPortsGetParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewNetworkEthernetPortsGetParamsWithTimeout creates a new NetworkEthernetPortsGetParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewNetworkEthernetPortsGetParamsWithTimeout(timeout time.Duration) *NetworkEthernetPortsGetParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &NetworkEthernetPortsGetParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		timeout: timeout,
	}
}

// NewNetworkEthernetPortsGetParamsWithContext creates a new NetworkEthernetPortsGetParams object
// with the default values initialized, and the ability to set a context for a request
func NewNetworkEthernetPortsGetParamsWithContext(ctx context.Context) *NetworkEthernetPortsGetParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &NetworkEthernetPortsGetParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		Context: ctx,
	}
}

// NewNetworkEthernetPortsGetParamsWithHTTPClient creates a new NetworkEthernetPortsGetParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewNetworkEthernetPortsGetParamsWithHTTPClient(client *http.Client) *NetworkEthernetPortsGetParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &NetworkEthernetPortsGetParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,
		HTTPClient:    client,
	}
}

/*NetworkEthernetPortsGetParams contains all the parameters to send to the API endpoint
for the network ethernet ports get operation typically these are written to a http.Request
*/
type NetworkEthernetPortsGetParams struct {

	/*BroadcastDomainIpspaceName
	  Filter by broadcast_domain.ipspace.name

	*/
	BroadcastDomainIpspaceName *string
	/*BroadcastDomainName
	  Filter by broadcast_domain.name

	*/
	BroadcastDomainName *string
	/*BroadcastDomainUUID
	  Filter by broadcast_domain.uuid

	*/
	BroadcastDomainUUID *string
	/*Enabled
	  Filter by enabled

	*/
	Enabled *bool
	/*Fields
	  Specify the fields to return.

	*/
	Fields []string
	/*LagActivePortsName
	  Filter by lag.active_ports.name

	*/
	LagActivePortsName *string
	/*LagActivePortsNodeName
	  Filter by lag.active_ports.node.name

	*/
	LagActivePortsNodeName *string
	/*LagActivePortsUUID
	  Filter by lag.active_ports.uuid

	*/
	LagActivePortsUUID *string
	/*LagDistributionPolicy
	  Filter by lag.distribution_policy

	*/
	LagDistributionPolicy *string
	/*LagMemberPortsName
	  Filter by lag.member_ports.name

	*/
	LagMemberPortsName *string
	/*LagMemberPortsNodeName
	  Filter by lag.member_ports.node.name

	*/
	LagMemberPortsNodeName *string
	/*LagMemberPortsUUID
	  Filter by lag.member_ports.uuid

	*/
	LagMemberPortsUUID *string
	/*LagMode
	  Filter by lag.mode

	*/
	LagMode *string
	/*MacAddress
	  Filter by mac_address

	*/
	MacAddress *string
	/*MaxRecords
	  Limit the number of records returned.

	*/
	MaxRecords *int64
	/*Mtu
	  Filter by mtu

	*/
	Mtu *int64
	/*Name
	  Filter by name

	*/
	Name *string
	/*NodeName
	  Filter by node.name

	*/
	NodeName *string
	/*NodeUUID
	  Filter by node.uuid

	*/
	NodeUUID *string
	/*OrderBy
	  Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.

	*/
	OrderBy []string
	/*ReturnRecords
	  The default is true for GET calls.  When set to false, only the number of records is returned.

	*/
	ReturnRecords *bool
	/*ReturnTimeout
	  The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	*/
	ReturnTimeout *int64
	/*Speed
	  Filter by speed

	*/
	Speed *int64
	/*State
	  Filter by state

	*/
	State *string
	/*Type
	  Filter by type

	*/
	Type *string
	/*UUID
	  Filter by uuid

	*/
	UUID *string
	/*VlanBasePortName
	  Filter by vlan.base_port.name

	*/
	VlanBasePortName *string
	/*VlanBasePortNodeName
	  Filter by vlan.base_port.node.name

	*/
	VlanBasePortNodeName *string
	/*VlanBasePortUUID
	  Filter by vlan.base_port.uuid

	*/
	VlanBasePortUUID *string
	/*VlanTag
	  Filter by vlan.tag

	*/
	VlanTag *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) WithTimeout(timeout time.Duration) *NetworkEthernetPortsGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) WithContext(ctx context.Context) *NetworkEthernetPortsGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) WithHTTPClient(client *http.Client) *NetworkEthernetPortsGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBroadcastDomainIpspaceName adds the broadcastDomainIpspaceName to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) WithBroadcastDomainIpspaceName(broadcastDomainIpspaceName *string) *NetworkEthernetPortsGetParams {
	o.SetBroadcastDomainIpspaceName(broadcastDomainIpspaceName)
	return o
}

// SetBroadcastDomainIpspaceName adds the broadcastDomainIpspaceName to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) SetBroadcastDomainIpspaceName(broadcastDomainIpspaceName *string) {
	o.BroadcastDomainIpspaceName = broadcastDomainIpspaceName
}

// WithBroadcastDomainName adds the broadcastDomainName to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) WithBroadcastDomainName(broadcastDomainName *string) *NetworkEthernetPortsGetParams {
	o.SetBroadcastDomainName(broadcastDomainName)
	return o
}

// SetBroadcastDomainName adds the broadcastDomainName to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) SetBroadcastDomainName(broadcastDomainName *string) {
	o.BroadcastDomainName = broadcastDomainName
}

// WithBroadcastDomainUUID adds the broadcastDomainUUID to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) WithBroadcastDomainUUID(broadcastDomainUUID *string) *NetworkEthernetPortsGetParams {
	o.SetBroadcastDomainUUID(broadcastDomainUUID)
	return o
}

// SetBroadcastDomainUUID adds the broadcastDomainUuid to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) SetBroadcastDomainUUID(broadcastDomainUUID *string) {
	o.BroadcastDomainUUID = broadcastDomainUUID
}

// WithEnabled adds the enabled to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) WithEnabled(enabled *bool) *NetworkEthernetPortsGetParams {
	o.SetEnabled(enabled)
	return o
}

// SetEnabled adds the enabled to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) SetEnabled(enabled *bool) {
	o.Enabled = enabled
}

// WithFields adds the fields to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) WithFields(fields []string) *NetworkEthernetPortsGetParams {
	o.SetFields(fields)
	return o
}

// SetFields adds the fields to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) SetFields(fields []string) {
	o.Fields = fields
}

// WithLagActivePortsName adds the lagActivePortsName to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) WithLagActivePortsName(lagActivePortsName *string) *NetworkEthernetPortsGetParams {
	o.SetLagActivePortsName(lagActivePortsName)
	return o
}

// SetLagActivePortsName adds the lagActivePortsName to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) SetLagActivePortsName(lagActivePortsName *string) {
	o.LagActivePortsName = lagActivePortsName
}

// WithLagActivePortsNodeName adds the lagActivePortsNodeName to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) WithLagActivePortsNodeName(lagActivePortsNodeName *string) *NetworkEthernetPortsGetParams {
	o.SetLagActivePortsNodeName(lagActivePortsNodeName)
	return o
}

// SetLagActivePortsNodeName adds the lagActivePortsNodeName to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) SetLagActivePortsNodeName(lagActivePortsNodeName *string) {
	o.LagActivePortsNodeName = lagActivePortsNodeName
}

// WithLagActivePortsUUID adds the lagActivePortsUUID to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) WithLagActivePortsUUID(lagActivePortsUUID *string) *NetworkEthernetPortsGetParams {
	o.SetLagActivePortsUUID(lagActivePortsUUID)
	return o
}

// SetLagActivePortsUUID adds the lagActivePortsUuid to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) SetLagActivePortsUUID(lagActivePortsUUID *string) {
	o.LagActivePortsUUID = lagActivePortsUUID
}

// WithLagDistributionPolicy adds the lagDistributionPolicy to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) WithLagDistributionPolicy(lagDistributionPolicy *string) *NetworkEthernetPortsGetParams {
	o.SetLagDistributionPolicy(lagDistributionPolicy)
	return o
}

// SetLagDistributionPolicy adds the lagDistributionPolicy to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) SetLagDistributionPolicy(lagDistributionPolicy *string) {
	o.LagDistributionPolicy = lagDistributionPolicy
}

// WithLagMemberPortsName adds the lagMemberPortsName to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) WithLagMemberPortsName(lagMemberPortsName *string) *NetworkEthernetPortsGetParams {
	o.SetLagMemberPortsName(lagMemberPortsName)
	return o
}

// SetLagMemberPortsName adds the lagMemberPortsName to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) SetLagMemberPortsName(lagMemberPortsName *string) {
	o.LagMemberPortsName = lagMemberPortsName
}

// WithLagMemberPortsNodeName adds the lagMemberPortsNodeName to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) WithLagMemberPortsNodeName(lagMemberPortsNodeName *string) *NetworkEthernetPortsGetParams {
	o.SetLagMemberPortsNodeName(lagMemberPortsNodeName)
	return o
}

// SetLagMemberPortsNodeName adds the lagMemberPortsNodeName to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) SetLagMemberPortsNodeName(lagMemberPortsNodeName *string) {
	o.LagMemberPortsNodeName = lagMemberPortsNodeName
}

// WithLagMemberPortsUUID adds the lagMemberPortsUUID to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) WithLagMemberPortsUUID(lagMemberPortsUUID *string) *NetworkEthernetPortsGetParams {
	o.SetLagMemberPortsUUID(lagMemberPortsUUID)
	return o
}

// SetLagMemberPortsUUID adds the lagMemberPortsUuid to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) SetLagMemberPortsUUID(lagMemberPortsUUID *string) {
	o.LagMemberPortsUUID = lagMemberPortsUUID
}

// WithLagMode adds the lagMode to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) WithLagMode(lagMode *string) *NetworkEthernetPortsGetParams {
	o.SetLagMode(lagMode)
	return o
}

// SetLagMode adds the lagMode to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) SetLagMode(lagMode *string) {
	o.LagMode = lagMode
}

// WithMacAddress adds the macAddress to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) WithMacAddress(macAddress *string) *NetworkEthernetPortsGetParams {
	o.SetMacAddress(macAddress)
	return o
}

// SetMacAddress adds the macAddress to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) SetMacAddress(macAddress *string) {
	o.MacAddress = macAddress
}

// WithMaxRecords adds the maxRecords to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) WithMaxRecords(maxRecords *int64) *NetworkEthernetPortsGetParams {
	o.SetMaxRecords(maxRecords)
	return o
}

// SetMaxRecords adds the maxRecords to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) SetMaxRecords(maxRecords *int64) {
	o.MaxRecords = maxRecords
}

// WithMtu adds the mtu to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) WithMtu(mtu *int64) *NetworkEthernetPortsGetParams {
	o.SetMtu(mtu)
	return o
}

// SetMtu adds the mtu to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) SetMtu(mtu *int64) {
	o.Mtu = mtu
}

// WithName adds the name to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) WithName(name *string) *NetworkEthernetPortsGetParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) SetName(name *string) {
	o.Name = name
}

// WithNodeName adds the nodeName to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) WithNodeName(nodeName *string) *NetworkEthernetPortsGetParams {
	o.SetNodeName(nodeName)
	return o
}

// SetNodeName adds the nodeName to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) SetNodeName(nodeName *string) {
	o.NodeName = nodeName
}

// WithNodeUUID adds the nodeUUID to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) WithNodeUUID(nodeUUID *string) *NetworkEthernetPortsGetParams {
	o.SetNodeUUID(nodeUUID)
	return o
}

// SetNodeUUID adds the nodeUuid to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) SetNodeUUID(nodeUUID *string) {
	o.NodeUUID = nodeUUID
}

// WithOrderBy adds the orderBy to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) WithOrderBy(orderBy []string) *NetworkEthernetPortsGetParams {
	o.SetOrderBy(orderBy)
	return o
}

// SetOrderBy adds the orderBy to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) SetOrderBy(orderBy []string) {
	o.OrderBy = orderBy
}

// WithReturnRecords adds the returnRecords to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) WithReturnRecords(returnRecords *bool) *NetworkEthernetPortsGetParams {
	o.SetReturnRecords(returnRecords)
	return o
}

// SetReturnRecords adds the returnRecords to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) SetReturnRecords(returnRecords *bool) {
	o.ReturnRecords = returnRecords
}

// WithReturnTimeout adds the returnTimeout to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) WithReturnTimeout(returnTimeout *int64) *NetworkEthernetPortsGetParams {
	o.SetReturnTimeout(returnTimeout)
	return o
}

// SetReturnTimeout adds the returnTimeout to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) SetReturnTimeout(returnTimeout *int64) {
	o.ReturnTimeout = returnTimeout
}

// WithSpeed adds the speed to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) WithSpeed(speed *int64) *NetworkEthernetPortsGetParams {
	o.SetSpeed(speed)
	return o
}

// SetSpeed adds the speed to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) SetSpeed(speed *int64) {
	o.Speed = speed
}

// WithState adds the state to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) WithState(state *string) *NetworkEthernetPortsGetParams {
	o.SetState(state)
	return o
}

// SetState adds the state to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) SetState(state *string) {
	o.State = state
}

// WithType adds the typeVar to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) WithType(typeVar *string) *NetworkEthernetPortsGetParams {
	o.SetType(typeVar)
	return o
}

// SetType adds the type to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) SetType(typeVar *string) {
	o.Type = typeVar
}

// WithUUID adds the uuid to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) WithUUID(uuid *string) *NetworkEthernetPortsGetParams {
	o.SetUUID(uuid)
	return o
}

// SetUUID adds the uuid to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) SetUUID(uuid *string) {
	o.UUID = uuid
}

// WithVlanBasePortName adds the vlanBasePortName to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) WithVlanBasePortName(vlanBasePortName *string) *NetworkEthernetPortsGetParams {
	o.SetVlanBasePortName(vlanBasePortName)
	return o
}

// SetVlanBasePortName adds the vlanBasePortName to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) SetVlanBasePortName(vlanBasePortName *string) {
	o.VlanBasePortName = vlanBasePortName
}

// WithVlanBasePortNodeName adds the vlanBasePortNodeName to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) WithVlanBasePortNodeName(vlanBasePortNodeName *string) *NetworkEthernetPortsGetParams {
	o.SetVlanBasePortNodeName(vlanBasePortNodeName)
	return o
}

// SetVlanBasePortNodeName adds the vlanBasePortNodeName to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) SetVlanBasePortNodeName(vlanBasePortNodeName *string) {
	o.VlanBasePortNodeName = vlanBasePortNodeName
}

// WithVlanBasePortUUID adds the vlanBasePortUUID to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) WithVlanBasePortUUID(vlanBasePortUUID *string) *NetworkEthernetPortsGetParams {
	o.SetVlanBasePortUUID(vlanBasePortUUID)
	return o
}

// SetVlanBasePortUUID adds the vlanBasePortUuid to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) SetVlanBasePortUUID(vlanBasePortUUID *string) {
	o.VlanBasePortUUID = vlanBasePortUUID
}

// WithVlanTag adds the vlanTag to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) WithVlanTag(vlanTag *int64) *NetworkEthernetPortsGetParams {
	o.SetVlanTag(vlanTag)
	return o
}

// SetVlanTag adds the vlanTag to the network ethernet ports get params
func (o *NetworkEthernetPortsGetParams) SetVlanTag(vlanTag *int64) {
	o.VlanTag = vlanTag
}

// WriteToRequest writes these params to a swagger request
func (o *NetworkEthernetPortsGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.BroadcastDomainIpspaceName != nil {

		// query param broadcast_domain.ipspace.name
		var qrBroadcastDomainIpspaceName string
		if o.BroadcastDomainIpspaceName != nil {
			qrBroadcastDomainIpspaceName = *o.BroadcastDomainIpspaceName
		}
		qBroadcastDomainIpspaceName := qrBroadcastDomainIpspaceName
		if qBroadcastDomainIpspaceName != "" {
			if err := r.SetQueryParam("broadcast_domain.ipspace.name", qBroadcastDomainIpspaceName); err != nil {
				return err
			}
		}

	}

	if o.BroadcastDomainName != nil {

		// query param broadcast_domain.name
		var qrBroadcastDomainName string
		if o.BroadcastDomainName != nil {
			qrBroadcastDomainName = *o.BroadcastDomainName
		}
		qBroadcastDomainName := qrBroadcastDomainName
		if qBroadcastDomainName != "" {
			if err := r.SetQueryParam("broadcast_domain.name", qBroadcastDomainName); err != nil {
				return err
			}
		}

	}

	if o.BroadcastDomainUUID != nil {

		// query param broadcast_domain.uuid
		var qrBroadcastDomainUUID string
		if o.BroadcastDomainUUID != nil {
			qrBroadcastDomainUUID = *o.BroadcastDomainUUID
		}
		qBroadcastDomainUUID := qrBroadcastDomainUUID
		if qBroadcastDomainUUID != "" {
			if err := r.SetQueryParam("broadcast_domain.uuid", qBroadcastDomainUUID); err != nil {
				return err
			}
		}

	}

	if o.Enabled != nil {

		// query param enabled
		var qrEnabled bool
		if o.Enabled != nil {
			qrEnabled = *o.Enabled
		}
		qEnabled := swag.FormatBool(qrEnabled)
		if qEnabled != "" {
			if err := r.SetQueryParam("enabled", qEnabled); err != nil {
				return err
			}
		}

	}

	valuesFields := o.Fields

	joinedFields := swag.JoinByFormat(valuesFields, "csv")
	// query array param fields
	if err := r.SetQueryParam("fields", joinedFields...); err != nil {
		return err
	}

	if o.LagActivePortsName != nil {

		// query param lag.active_ports.name
		var qrLagActivePortsName string
		if o.LagActivePortsName != nil {
			qrLagActivePortsName = *o.LagActivePortsName
		}
		qLagActivePortsName := qrLagActivePortsName
		if qLagActivePortsName != "" {
			if err := r.SetQueryParam("lag.active_ports.name", qLagActivePortsName); err != nil {
				return err
			}
		}

	}

	if o.LagActivePortsNodeName != nil {

		// query param lag.active_ports.node.name
		var qrLagActivePortsNodeName string
		if o.LagActivePortsNodeName != nil {
			qrLagActivePortsNodeName = *o.LagActivePortsNodeName
		}
		qLagActivePortsNodeName := qrLagActivePortsNodeName
		if qLagActivePortsNodeName != "" {
			if err := r.SetQueryParam("lag.active_ports.node.name", qLagActivePortsNodeName); err != nil {
				return err
			}
		}

	}

	if o.LagActivePortsUUID != nil {

		// query param lag.active_ports.uuid
		var qrLagActivePortsUUID string
		if o.LagActivePortsUUID != nil {
			qrLagActivePortsUUID = *o.LagActivePortsUUID
		}
		qLagActivePortsUUID := qrLagActivePortsUUID
		if qLagActivePortsUUID != "" {
			if err := r.SetQueryParam("lag.active_ports.uuid", qLagActivePortsUUID); err != nil {
				return err
			}
		}

	}

	if o.LagDistributionPolicy != nil {

		// query param lag.distribution_policy
		var qrLagDistributionPolicy string
		if o.LagDistributionPolicy != nil {
			qrLagDistributionPolicy = *o.LagDistributionPolicy
		}
		qLagDistributionPolicy := qrLagDistributionPolicy
		if qLagDistributionPolicy != "" {
			if err := r.SetQueryParam("lag.distribution_policy", qLagDistributionPolicy); err != nil {
				return err
			}
		}

	}

	if o.LagMemberPortsName != nil {

		// query param lag.member_ports.name
		var qrLagMemberPortsName string
		if o.LagMemberPortsName != nil {
			qrLagMemberPortsName = *o.LagMemberPortsName
		}
		qLagMemberPortsName := qrLagMemberPortsName
		if qLagMemberPortsName != "" {
			if err := r.SetQueryParam("lag.member_ports.name", qLagMemberPortsName); err != nil {
				return err
			}
		}

	}

	if o.LagMemberPortsNodeName != nil {

		// query param lag.member_ports.node.name
		var qrLagMemberPortsNodeName string
		if o.LagMemberPortsNodeName != nil {
			qrLagMemberPortsNodeName = *o.LagMemberPortsNodeName
		}
		qLagMemberPortsNodeName := qrLagMemberPortsNodeName
		if qLagMemberPortsNodeName != "" {
			if err := r.SetQueryParam("lag.member_ports.node.name", qLagMemberPortsNodeName); err != nil {
				return err
			}
		}

	}

	if o.LagMemberPortsUUID != nil {

		// query param lag.member_ports.uuid
		var qrLagMemberPortsUUID string
		if o.LagMemberPortsUUID != nil {
			qrLagMemberPortsUUID = *o.LagMemberPortsUUID
		}
		qLagMemberPortsUUID := qrLagMemberPortsUUID
		if qLagMemberPortsUUID != "" {
			if err := r.SetQueryParam("lag.member_ports.uuid", qLagMemberPortsUUID); err != nil {
				return err
			}
		}

	}

	if o.LagMode != nil {

		// query param lag.mode
		var qrLagMode string
		if o.LagMode != nil {
			qrLagMode = *o.LagMode
		}
		qLagMode := qrLagMode
		if qLagMode != "" {
			if err := r.SetQueryParam("lag.mode", qLagMode); err != nil {
				return err
			}
		}

	}

	if o.MacAddress != nil {

		// query param mac_address
		var qrMacAddress string
		if o.MacAddress != nil {
			qrMacAddress = *o.MacAddress
		}
		qMacAddress := qrMacAddress
		if qMacAddress != "" {
			if err := r.SetQueryParam("mac_address", qMacAddress); err != nil {
				return err
			}
		}

	}

	if o.MaxRecords != nil {

		// query param max_records
		var qrMaxRecords int64
		if o.MaxRecords != nil {
			qrMaxRecords = *o.MaxRecords
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {
			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}

	}

	if o.Mtu != nil {

		// query param mtu
		var qrMtu int64
		if o.Mtu != nil {
			qrMtu = *o.Mtu
		}
		qMtu := swag.FormatInt64(qrMtu)
		if qMtu != "" {
			if err := r.SetQueryParam("mtu", qMtu); err != nil {
				return err
			}
		}

	}

	if o.Name != nil {

		// query param name
		var qrName string
		if o.Name != nil {
			qrName = *o.Name
		}
		qName := qrName
		if qName != "" {
			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}

	}

	if o.NodeName != nil {

		// query param node.name
		var qrNodeName string
		if o.NodeName != nil {
			qrNodeName = *o.NodeName
		}
		qNodeName := qrNodeName
		if qNodeName != "" {
			if err := r.SetQueryParam("node.name", qNodeName); err != nil {
				return err
			}
		}

	}

	if o.NodeUUID != nil {

		// query param node.uuid
		var qrNodeUUID string
		if o.NodeUUID != nil {
			qrNodeUUID = *o.NodeUUID
		}
		qNodeUUID := qrNodeUUID
		if qNodeUUID != "" {
			if err := r.SetQueryParam("node.uuid", qNodeUUID); err != nil {
				return err
			}
		}

	}

	valuesOrderBy := o.OrderBy

	joinedOrderBy := swag.JoinByFormat(valuesOrderBy, "csv")
	// query array param order_by
	if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
		return err
	}

	if o.ReturnRecords != nil {

		// query param return_records
		var qrReturnRecords bool
		if o.ReturnRecords != nil {
			qrReturnRecords = *o.ReturnRecords
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {
			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}

	}

	if o.ReturnTimeout != nil {

		// query param return_timeout
		var qrReturnTimeout int64
		if o.ReturnTimeout != nil {
			qrReturnTimeout = *o.ReturnTimeout
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {
			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}

	}

	if o.Speed != nil {

		// query param speed
		var qrSpeed int64
		if o.Speed != nil {
			qrSpeed = *o.Speed
		}
		qSpeed := swag.FormatInt64(qrSpeed)
		if qSpeed != "" {
			if err := r.SetQueryParam("speed", qSpeed); err != nil {
				return err
			}
		}

	}

	if o.State != nil {

		// query param state
		var qrState string
		if o.State != nil {
			qrState = *o.State
		}
		qState := qrState
		if qState != "" {
			if err := r.SetQueryParam("state", qState); err != nil {
				return err
			}
		}

	}

	if o.Type != nil {

		// query param type
		var qrType string
		if o.Type != nil {
			qrType = *o.Type
		}
		qType := qrType
		if qType != "" {
			if err := r.SetQueryParam("type", qType); err != nil {
				return err
			}
		}

	}

	if o.UUID != nil {

		// query param uuid
		var qrUUID string
		if o.UUID != nil {
			qrUUID = *o.UUID
		}
		qUUID := qrUUID
		if qUUID != "" {
			if err := r.SetQueryParam("uuid", qUUID); err != nil {
				return err
			}
		}

	}

	if o.VlanBasePortName != nil {

		// query param vlan.base_port.name
		var qrVlanBasePortName string
		if o.VlanBasePortName != nil {
			qrVlanBasePortName = *o.VlanBasePortName
		}
		qVlanBasePortName := qrVlanBasePortName
		if qVlanBasePortName != "" {
			if err := r.SetQueryParam("vlan.base_port.name", qVlanBasePortName); err != nil {
				return err
			}
		}

	}

	if o.VlanBasePortNodeName != nil {

		// query param vlan.base_port.node.name
		var qrVlanBasePortNodeName string
		if o.VlanBasePortNodeName != nil {
			qrVlanBasePortNodeName = *o.VlanBasePortNodeName
		}
		qVlanBasePortNodeName := qrVlanBasePortNodeName
		if qVlanBasePortNodeName != "" {
			if err := r.SetQueryParam("vlan.base_port.node.name", qVlanBasePortNodeName); err != nil {
				return err
			}
		}

	}

	if o.VlanBasePortUUID != nil {

		// query param vlan.base_port.uuid
		var qrVlanBasePortUUID string
		if o.VlanBasePortUUID != nil {
			qrVlanBasePortUUID = *o.VlanBasePortUUID
		}
		qVlanBasePortUUID := qrVlanBasePortUUID
		if qVlanBasePortUUID != "" {
			if err := r.SetQueryParam("vlan.base_port.uuid", qVlanBasePortUUID); err != nil {
				return err
			}
		}

	}

	if o.VlanTag != nil {

		// query param vlan.tag
		var qrVlanTag int64
		if o.VlanTag != nil {
			qrVlanTag = *o.VlanTag
		}
		qVlanTag := swag.FormatInt64(qrVlanTag)
		if qVlanTag != "" {
			if err := r.SetQueryParam("vlan.tag", qVlanTag); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
