// Code generated by go-swagger; DO NOT EDIT.

package networking

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewNetworkIPInterfacesGetParams creates a new NetworkIPInterfacesGetParams object
// with the default values initialized.
func NewNetworkIPInterfacesGetParams() *NetworkIPInterfacesGetParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &NetworkIPInterfacesGetParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewNetworkIPInterfacesGetParamsWithTimeout creates a new NetworkIPInterfacesGetParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewNetworkIPInterfacesGetParamsWithTimeout(timeout time.Duration) *NetworkIPInterfacesGetParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &NetworkIPInterfacesGetParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		timeout: timeout,
	}
}

// NewNetworkIPInterfacesGetParamsWithContext creates a new NetworkIPInterfacesGetParams object
// with the default values initialized, and the ability to set a context for a request
func NewNetworkIPInterfacesGetParamsWithContext(ctx context.Context) *NetworkIPInterfacesGetParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &NetworkIPInterfacesGetParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		Context: ctx,
	}
}

// NewNetworkIPInterfacesGetParamsWithHTTPClient creates a new NetworkIPInterfacesGetParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewNetworkIPInterfacesGetParamsWithHTTPClient(client *http.Client) *NetworkIPInterfacesGetParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &NetworkIPInterfacesGetParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,
		HTTPClient:    client,
	}
}

/*NetworkIPInterfacesGetParams contains all the parameters to send to the API endpoint
for the network ip interfaces get operation typically these are written to a http.Request
*/
type NetworkIPInterfacesGetParams struct {

	/*Enabled
	  Filter by enabled

	*/
	Enabled *bool
	/*Fields
	  Specify the fields to return.

	*/
	Fields []string
	/*IPAddress
	  Filter by ip.address

	*/
	IPAddress *string
	/*IPFamily
	  Filter by ip.family

	*/
	IPFamily *string
	/*IPNetmask
	  Filter by ip.netmask

	*/
	IPNetmask *string
	/*IpspaceName
	  Filter by ipspace.name

	*/
	IpspaceName *string
	/*IpspaceUUID
	  Filter by ipspace.uuid

	*/
	IpspaceUUID *string
	/*LocationAutoRevert
	  Filter by location.auto_revert

	*/
	LocationAutoRevert *bool
	/*LocationFailover
	  Filter by location.failover

	*/
	LocationFailover *string
	/*LocationHomeNodeName
	  Filter by location.home_node.name

	*/
	LocationHomeNodeName *string
	/*LocationHomeNodeUUID
	  Filter by location.home_node.uuid

	*/
	LocationHomeNodeUUID *string
	/*LocationHomePortName
	  Filter by location.home_port.name

	*/
	LocationHomePortName *string
	/*LocationHomePortNodeName
	  Filter by location.home_port.node.name

	*/
	LocationHomePortNodeName *string
	/*LocationHomePortUUID
	  Filter by location.home_port.uuid

	*/
	LocationHomePortUUID *string
	/*LocationIsHome
	  Filter by location.is_home

	*/
	LocationIsHome *bool
	/*LocationNodeName
	  Filter by location.node.name

	*/
	LocationNodeName *string
	/*LocationNodeUUID
	  Filter by location.node.uuid

	*/
	LocationNodeUUID *string
	/*LocationPortName
	  Filter by location.port.name

	*/
	LocationPortName *string
	/*LocationPortNodeName
	  Filter by location.port.node.name

	*/
	LocationPortNodeName *string
	/*LocationPortUUID
	  Filter by location.port.uuid

	*/
	LocationPortUUID *string
	/*MaxRecords
	  Limit the number of records returned.

	*/
	MaxRecords *int64
	/*Name
	  Filter by name

	*/
	Name *string
	/*OrderBy
	  Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.

	*/
	OrderBy []string
	/*ReturnRecords
	  The default is true for GET calls.  When set to false, only the number of records is returned.

	*/
	ReturnRecords *bool
	/*ReturnTimeout
	  The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	*/
	ReturnTimeout *int64
	/*Scope
	  Filter by scope

	*/
	Scope *string
	/*ServicePolicyName
	  Filter by service_policy.name

	*/
	ServicePolicyName *string
	/*ServicePolicyUUID
	  Filter by service_policy.uuid

	*/
	ServicePolicyUUID *string
	/*Services
	  Filter by services

	*/
	Services *string
	/*State
	  Filter by state

	*/
	State *string
	/*SvmName
	  Filter by svm.name

	*/
	SvmName *string
	/*SvmUUID
	  Filter by svm.uuid

	*/
	SvmUUID *string
	/*UUID
	  Filter by uuid

	*/
	UUID *string
	/*Vip
	  Filter by vip

	*/
	Vip *bool

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) WithTimeout(timeout time.Duration) *NetworkIPInterfacesGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) WithContext(ctx context.Context) *NetworkIPInterfacesGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) WithHTTPClient(client *http.Client) *NetworkIPInterfacesGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithEnabled adds the enabled to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) WithEnabled(enabled *bool) *NetworkIPInterfacesGetParams {
	o.SetEnabled(enabled)
	return o
}

// SetEnabled adds the enabled to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) SetEnabled(enabled *bool) {
	o.Enabled = enabled
}

// WithFields adds the fields to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) WithFields(fields []string) *NetworkIPInterfacesGetParams {
	o.SetFields(fields)
	return o
}

// SetFields adds the fields to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) SetFields(fields []string) {
	o.Fields = fields
}

// WithIPAddress adds the iPAddress to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) WithIPAddress(iPAddress *string) *NetworkIPInterfacesGetParams {
	o.SetIPAddress(iPAddress)
	return o
}

// SetIPAddress adds the ipAddress to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) SetIPAddress(iPAddress *string) {
	o.IPAddress = iPAddress
}

// WithIPFamily adds the iPFamily to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) WithIPFamily(iPFamily *string) *NetworkIPInterfacesGetParams {
	o.SetIPFamily(iPFamily)
	return o
}

// SetIPFamily adds the ipFamily to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) SetIPFamily(iPFamily *string) {
	o.IPFamily = iPFamily
}

// WithIPNetmask adds the iPNetmask to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) WithIPNetmask(iPNetmask *string) *NetworkIPInterfacesGetParams {
	o.SetIPNetmask(iPNetmask)
	return o
}

// SetIPNetmask adds the ipNetmask to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) SetIPNetmask(iPNetmask *string) {
	o.IPNetmask = iPNetmask
}

// WithIpspaceName adds the ipspaceName to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) WithIpspaceName(ipspaceName *string) *NetworkIPInterfacesGetParams {
	o.SetIpspaceName(ipspaceName)
	return o
}

// SetIpspaceName adds the ipspaceName to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) SetIpspaceName(ipspaceName *string) {
	o.IpspaceName = ipspaceName
}

// WithIpspaceUUID adds the ipspaceUUID to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) WithIpspaceUUID(ipspaceUUID *string) *NetworkIPInterfacesGetParams {
	o.SetIpspaceUUID(ipspaceUUID)
	return o
}

// SetIpspaceUUID adds the ipspaceUuid to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) SetIpspaceUUID(ipspaceUUID *string) {
	o.IpspaceUUID = ipspaceUUID
}

// WithLocationAutoRevert adds the locationAutoRevert to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) WithLocationAutoRevert(locationAutoRevert *bool) *NetworkIPInterfacesGetParams {
	o.SetLocationAutoRevert(locationAutoRevert)
	return o
}

// SetLocationAutoRevert adds the locationAutoRevert to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) SetLocationAutoRevert(locationAutoRevert *bool) {
	o.LocationAutoRevert = locationAutoRevert
}

// WithLocationFailover adds the locationFailover to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) WithLocationFailover(locationFailover *string) *NetworkIPInterfacesGetParams {
	o.SetLocationFailover(locationFailover)
	return o
}

// SetLocationFailover adds the locationFailover to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) SetLocationFailover(locationFailover *string) {
	o.LocationFailover = locationFailover
}

// WithLocationHomeNodeName adds the locationHomeNodeName to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) WithLocationHomeNodeName(locationHomeNodeName *string) *NetworkIPInterfacesGetParams {
	o.SetLocationHomeNodeName(locationHomeNodeName)
	return o
}

// SetLocationHomeNodeName adds the locationHomeNodeName to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) SetLocationHomeNodeName(locationHomeNodeName *string) {
	o.LocationHomeNodeName = locationHomeNodeName
}

// WithLocationHomeNodeUUID adds the locationHomeNodeUUID to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) WithLocationHomeNodeUUID(locationHomeNodeUUID *string) *NetworkIPInterfacesGetParams {
	o.SetLocationHomeNodeUUID(locationHomeNodeUUID)
	return o
}

// SetLocationHomeNodeUUID adds the locationHomeNodeUuid to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) SetLocationHomeNodeUUID(locationHomeNodeUUID *string) {
	o.LocationHomeNodeUUID = locationHomeNodeUUID
}

// WithLocationHomePortName adds the locationHomePortName to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) WithLocationHomePortName(locationHomePortName *string) *NetworkIPInterfacesGetParams {
	o.SetLocationHomePortName(locationHomePortName)
	return o
}

// SetLocationHomePortName adds the locationHomePortName to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) SetLocationHomePortName(locationHomePortName *string) {
	o.LocationHomePortName = locationHomePortName
}

// WithLocationHomePortNodeName adds the locationHomePortNodeName to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) WithLocationHomePortNodeName(locationHomePortNodeName *string) *NetworkIPInterfacesGetParams {
	o.SetLocationHomePortNodeName(locationHomePortNodeName)
	return o
}

// SetLocationHomePortNodeName adds the locationHomePortNodeName to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) SetLocationHomePortNodeName(locationHomePortNodeName *string) {
	o.LocationHomePortNodeName = locationHomePortNodeName
}

// WithLocationHomePortUUID adds the locationHomePortUUID to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) WithLocationHomePortUUID(locationHomePortUUID *string) *NetworkIPInterfacesGetParams {
	o.SetLocationHomePortUUID(locationHomePortUUID)
	return o
}

// SetLocationHomePortUUID adds the locationHomePortUuid to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) SetLocationHomePortUUID(locationHomePortUUID *string) {
	o.LocationHomePortUUID = locationHomePortUUID
}

// WithLocationIsHome adds the locationIsHome to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) WithLocationIsHome(locationIsHome *bool) *NetworkIPInterfacesGetParams {
	o.SetLocationIsHome(locationIsHome)
	return o
}

// SetLocationIsHome adds the locationIsHome to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) SetLocationIsHome(locationIsHome *bool) {
	o.LocationIsHome = locationIsHome
}

// WithLocationNodeName adds the locationNodeName to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) WithLocationNodeName(locationNodeName *string) *NetworkIPInterfacesGetParams {
	o.SetLocationNodeName(locationNodeName)
	return o
}

// SetLocationNodeName adds the locationNodeName to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) SetLocationNodeName(locationNodeName *string) {
	o.LocationNodeName = locationNodeName
}

// WithLocationNodeUUID adds the locationNodeUUID to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) WithLocationNodeUUID(locationNodeUUID *string) *NetworkIPInterfacesGetParams {
	o.SetLocationNodeUUID(locationNodeUUID)
	return o
}

// SetLocationNodeUUID adds the locationNodeUuid to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) SetLocationNodeUUID(locationNodeUUID *string) {
	o.LocationNodeUUID = locationNodeUUID
}

// WithLocationPortName adds the locationPortName to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) WithLocationPortName(locationPortName *string) *NetworkIPInterfacesGetParams {
	o.SetLocationPortName(locationPortName)
	return o
}

// SetLocationPortName adds the locationPortName to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) SetLocationPortName(locationPortName *string) {
	o.LocationPortName = locationPortName
}

// WithLocationPortNodeName adds the locationPortNodeName to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) WithLocationPortNodeName(locationPortNodeName *string) *NetworkIPInterfacesGetParams {
	o.SetLocationPortNodeName(locationPortNodeName)
	return o
}

// SetLocationPortNodeName adds the locationPortNodeName to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) SetLocationPortNodeName(locationPortNodeName *string) {
	o.LocationPortNodeName = locationPortNodeName
}

// WithLocationPortUUID adds the locationPortUUID to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) WithLocationPortUUID(locationPortUUID *string) *NetworkIPInterfacesGetParams {
	o.SetLocationPortUUID(locationPortUUID)
	return o
}

// SetLocationPortUUID adds the locationPortUuid to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) SetLocationPortUUID(locationPortUUID *string) {
	o.LocationPortUUID = locationPortUUID
}

// WithMaxRecords adds the maxRecords to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) WithMaxRecords(maxRecords *int64) *NetworkIPInterfacesGetParams {
	o.SetMaxRecords(maxRecords)
	return o
}

// SetMaxRecords adds the maxRecords to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) SetMaxRecords(maxRecords *int64) {
	o.MaxRecords = maxRecords
}

// WithName adds the name to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) WithName(name *string) *NetworkIPInterfacesGetParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) SetName(name *string) {
	o.Name = name
}

// WithOrderBy adds the orderBy to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) WithOrderBy(orderBy []string) *NetworkIPInterfacesGetParams {
	o.SetOrderBy(orderBy)
	return o
}

// SetOrderBy adds the orderBy to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) SetOrderBy(orderBy []string) {
	o.OrderBy = orderBy
}

// WithReturnRecords adds the returnRecords to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) WithReturnRecords(returnRecords *bool) *NetworkIPInterfacesGetParams {
	o.SetReturnRecords(returnRecords)
	return o
}

// SetReturnRecords adds the returnRecords to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) SetReturnRecords(returnRecords *bool) {
	o.ReturnRecords = returnRecords
}

// WithReturnTimeout adds the returnTimeout to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) WithReturnTimeout(returnTimeout *int64) *NetworkIPInterfacesGetParams {
	o.SetReturnTimeout(returnTimeout)
	return o
}

// SetReturnTimeout adds the returnTimeout to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) SetReturnTimeout(returnTimeout *int64) {
	o.ReturnTimeout = returnTimeout
}

// WithScope adds the scope to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) WithScope(scope *string) *NetworkIPInterfacesGetParams {
	o.SetScope(scope)
	return o
}

// SetScope adds the scope to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) SetScope(scope *string) {
	o.Scope = scope
}

// WithServicePolicyName adds the servicePolicyName to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) WithServicePolicyName(servicePolicyName *string) *NetworkIPInterfacesGetParams {
	o.SetServicePolicyName(servicePolicyName)
	return o
}

// SetServicePolicyName adds the servicePolicyName to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) SetServicePolicyName(servicePolicyName *string) {
	o.ServicePolicyName = servicePolicyName
}

// WithServicePolicyUUID adds the servicePolicyUUID to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) WithServicePolicyUUID(servicePolicyUUID *string) *NetworkIPInterfacesGetParams {
	o.SetServicePolicyUUID(servicePolicyUUID)
	return o
}

// SetServicePolicyUUID adds the servicePolicyUuid to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) SetServicePolicyUUID(servicePolicyUUID *string) {
	o.ServicePolicyUUID = servicePolicyUUID
}

// WithServices adds the services to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) WithServices(services *string) *NetworkIPInterfacesGetParams {
	o.SetServices(services)
	return o
}

// SetServices adds the services to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) SetServices(services *string) {
	o.Services = services
}

// WithState adds the state to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) WithState(state *string) *NetworkIPInterfacesGetParams {
	o.SetState(state)
	return o
}

// SetState adds the state to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) SetState(state *string) {
	o.State = state
}

// WithSvmName adds the svmName to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) WithSvmName(svmName *string) *NetworkIPInterfacesGetParams {
	o.SetSvmName(svmName)
	return o
}

// SetSvmName adds the svmName to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) SetSvmName(svmName *string) {
	o.SvmName = svmName
}

// WithSvmUUID adds the svmUUID to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) WithSvmUUID(svmUUID *string) *NetworkIPInterfacesGetParams {
	o.SetSvmUUID(svmUUID)
	return o
}

// SetSvmUUID adds the svmUuid to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) SetSvmUUID(svmUUID *string) {
	o.SvmUUID = svmUUID
}

// WithUUID adds the uuid to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) WithUUID(uuid *string) *NetworkIPInterfacesGetParams {
	o.SetUUID(uuid)
	return o
}

// SetUUID adds the uuid to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) SetUUID(uuid *string) {
	o.UUID = uuid
}

// WithVip adds the vip to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) WithVip(vip *bool) *NetworkIPInterfacesGetParams {
	o.SetVip(vip)
	return o
}

// SetVip adds the vip to the network ip interfaces get params
func (o *NetworkIPInterfacesGetParams) SetVip(vip *bool) {
	o.Vip = vip
}

// WriteToRequest writes these params to a swagger request
func (o *NetworkIPInterfacesGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Enabled != nil {

		// query param enabled
		var qrEnabled bool
		if o.Enabled != nil {
			qrEnabled = *o.Enabled
		}
		qEnabled := swag.FormatBool(qrEnabled)
		if qEnabled != "" {
			if err := r.SetQueryParam("enabled", qEnabled); err != nil {
				return err
			}
		}

	}

	valuesFields := o.Fields

	joinedFields := swag.JoinByFormat(valuesFields, "csv")
	// query array param fields
	if err := r.SetQueryParam("fields", joinedFields...); err != nil {
		return err
	}

	if o.IPAddress != nil {

		// query param ip.address
		var qrIPAddress string
		if o.IPAddress != nil {
			qrIPAddress = *o.IPAddress
		}
		qIPAddress := qrIPAddress
		if qIPAddress != "" {
			if err := r.SetQueryParam("ip.address", qIPAddress); err != nil {
				return err
			}
		}

	}

	if o.IPFamily != nil {

		// query param ip.family
		var qrIPFamily string
		if o.IPFamily != nil {
			qrIPFamily = *o.IPFamily
		}
		qIPFamily := qrIPFamily
		if qIPFamily != "" {
			if err := r.SetQueryParam("ip.family", qIPFamily); err != nil {
				return err
			}
		}

	}

	if o.IPNetmask != nil {

		// query param ip.netmask
		var qrIPNetmask string
		if o.IPNetmask != nil {
			qrIPNetmask = *o.IPNetmask
		}
		qIPNetmask := qrIPNetmask
		if qIPNetmask != "" {
			if err := r.SetQueryParam("ip.netmask", qIPNetmask); err != nil {
				return err
			}
		}

	}

	if o.IpspaceName != nil {

		// query param ipspace.name
		var qrIpspaceName string
		if o.IpspaceName != nil {
			qrIpspaceName = *o.IpspaceName
		}
		qIpspaceName := qrIpspaceName
		if qIpspaceName != "" {
			if err := r.SetQueryParam("ipspace.name", qIpspaceName); err != nil {
				return err
			}
		}

	}

	if o.IpspaceUUID != nil {

		// query param ipspace.uuid
		var qrIpspaceUUID string
		if o.IpspaceUUID != nil {
			qrIpspaceUUID = *o.IpspaceUUID
		}
		qIpspaceUUID := qrIpspaceUUID
		if qIpspaceUUID != "" {
			if err := r.SetQueryParam("ipspace.uuid", qIpspaceUUID); err != nil {
				return err
			}
		}

	}

	if o.LocationAutoRevert != nil {

		// query param location.auto_revert
		var qrLocationAutoRevert bool
		if o.LocationAutoRevert != nil {
			qrLocationAutoRevert = *o.LocationAutoRevert
		}
		qLocationAutoRevert := swag.FormatBool(qrLocationAutoRevert)
		if qLocationAutoRevert != "" {
			if err := r.SetQueryParam("location.auto_revert", qLocationAutoRevert); err != nil {
				return err
			}
		}

	}

	if o.LocationFailover != nil {

		// query param location.failover
		var qrLocationFailover string
		if o.LocationFailover != nil {
			qrLocationFailover = *o.LocationFailover
		}
		qLocationFailover := qrLocationFailover
		if qLocationFailover != "" {
			if err := r.SetQueryParam("location.failover", qLocationFailover); err != nil {
				return err
			}
		}

	}

	if o.LocationHomeNodeName != nil {

		// query param location.home_node.name
		var qrLocationHomeNodeName string
		if o.LocationHomeNodeName != nil {
			qrLocationHomeNodeName = *o.LocationHomeNodeName
		}
		qLocationHomeNodeName := qrLocationHomeNodeName
		if qLocationHomeNodeName != "" {
			if err := r.SetQueryParam("location.home_node.name", qLocationHomeNodeName); err != nil {
				return err
			}
		}

	}

	if o.LocationHomeNodeUUID != nil {

		// query param location.home_node.uuid
		var qrLocationHomeNodeUUID string
		if o.LocationHomeNodeUUID != nil {
			qrLocationHomeNodeUUID = *o.LocationHomeNodeUUID
		}
		qLocationHomeNodeUUID := qrLocationHomeNodeUUID
		if qLocationHomeNodeUUID != "" {
			if err := r.SetQueryParam("location.home_node.uuid", qLocationHomeNodeUUID); err != nil {
				return err
			}
		}

	}

	if o.LocationHomePortName != nil {

		// query param location.home_port.name
		var qrLocationHomePortName string
		if o.LocationHomePortName != nil {
			qrLocationHomePortName = *o.LocationHomePortName
		}
		qLocationHomePortName := qrLocationHomePortName
		if qLocationHomePortName != "" {
			if err := r.SetQueryParam("location.home_port.name", qLocationHomePortName); err != nil {
				return err
			}
		}

	}

	if o.LocationHomePortNodeName != nil {

		// query param location.home_port.node.name
		var qrLocationHomePortNodeName string
		if o.LocationHomePortNodeName != nil {
			qrLocationHomePortNodeName = *o.LocationHomePortNodeName
		}
		qLocationHomePortNodeName := qrLocationHomePortNodeName
		if qLocationHomePortNodeName != "" {
			if err := r.SetQueryParam("location.home_port.node.name", qLocationHomePortNodeName); err != nil {
				return err
			}
		}

	}

	if o.LocationHomePortUUID != nil {

		// query param location.home_port.uuid
		var qrLocationHomePortUUID string
		if o.LocationHomePortUUID != nil {
			qrLocationHomePortUUID = *o.LocationHomePortUUID
		}
		qLocationHomePortUUID := qrLocationHomePortUUID
		if qLocationHomePortUUID != "" {
			if err := r.SetQueryParam("location.home_port.uuid", qLocationHomePortUUID); err != nil {
				return err
			}
		}

	}

	if o.LocationIsHome != nil {

		// query param location.is_home
		var qrLocationIsHome bool
		if o.LocationIsHome != nil {
			qrLocationIsHome = *o.LocationIsHome
		}
		qLocationIsHome := swag.FormatBool(qrLocationIsHome)
		if qLocationIsHome != "" {
			if err := r.SetQueryParam("location.is_home", qLocationIsHome); err != nil {
				return err
			}
		}

	}

	if o.LocationNodeName != nil {

		// query param location.node.name
		var qrLocationNodeName string
		if o.LocationNodeName != nil {
			qrLocationNodeName = *o.LocationNodeName
		}
		qLocationNodeName := qrLocationNodeName
		if qLocationNodeName != "" {
			if err := r.SetQueryParam("location.node.name", qLocationNodeName); err != nil {
				return err
			}
		}

	}

	if o.LocationNodeUUID != nil {

		// query param location.node.uuid
		var qrLocationNodeUUID string
		if o.LocationNodeUUID != nil {
			qrLocationNodeUUID = *o.LocationNodeUUID
		}
		qLocationNodeUUID := qrLocationNodeUUID
		if qLocationNodeUUID != "" {
			if err := r.SetQueryParam("location.node.uuid", qLocationNodeUUID); err != nil {
				return err
			}
		}

	}

	if o.LocationPortName != nil {

		// query param location.port.name
		var qrLocationPortName string
		if o.LocationPortName != nil {
			qrLocationPortName = *o.LocationPortName
		}
		qLocationPortName := qrLocationPortName
		if qLocationPortName != "" {
			if err := r.SetQueryParam("location.port.name", qLocationPortName); err != nil {
				return err
			}
		}

	}

	if o.LocationPortNodeName != nil {

		// query param location.port.node.name
		var qrLocationPortNodeName string
		if o.LocationPortNodeName != nil {
			qrLocationPortNodeName = *o.LocationPortNodeName
		}
		qLocationPortNodeName := qrLocationPortNodeName
		if qLocationPortNodeName != "" {
			if err := r.SetQueryParam("location.port.node.name", qLocationPortNodeName); err != nil {
				return err
			}
		}

	}

	if o.LocationPortUUID != nil {

		// query param location.port.uuid
		var qrLocationPortUUID string
		if o.LocationPortUUID != nil {
			qrLocationPortUUID = *o.LocationPortUUID
		}
		qLocationPortUUID := qrLocationPortUUID
		if qLocationPortUUID != "" {
			if err := r.SetQueryParam("location.port.uuid", qLocationPortUUID); err != nil {
				return err
			}
		}

	}

	if o.MaxRecords != nil {

		// query param max_records
		var qrMaxRecords int64
		if o.MaxRecords != nil {
			qrMaxRecords = *o.MaxRecords
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {
			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}

	}

	if o.Name != nil {

		// query param name
		var qrName string
		if o.Name != nil {
			qrName = *o.Name
		}
		qName := qrName
		if qName != "" {
			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}

	}

	valuesOrderBy := o.OrderBy

	joinedOrderBy := swag.JoinByFormat(valuesOrderBy, "csv")
	// query array param order_by
	if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
		return err
	}

	if o.ReturnRecords != nil {

		// query param return_records
		var qrReturnRecords bool
		if o.ReturnRecords != nil {
			qrReturnRecords = *o.ReturnRecords
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {
			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}

	}

	if o.ReturnTimeout != nil {

		// query param return_timeout
		var qrReturnTimeout int64
		if o.ReturnTimeout != nil {
			qrReturnTimeout = *o.ReturnTimeout
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {
			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}

	}

	if o.Scope != nil {

		// query param scope
		var qrScope string
		if o.Scope != nil {
			qrScope = *o.Scope
		}
		qScope := qrScope
		if qScope != "" {
			if err := r.SetQueryParam("scope", qScope); err != nil {
				return err
			}
		}

	}

	if o.ServicePolicyName != nil {

		// query param service_policy.name
		var qrServicePolicyName string
		if o.ServicePolicyName != nil {
			qrServicePolicyName = *o.ServicePolicyName
		}
		qServicePolicyName := qrServicePolicyName
		if qServicePolicyName != "" {
			if err := r.SetQueryParam("service_policy.name", qServicePolicyName); err != nil {
				return err
			}
		}

	}

	if o.ServicePolicyUUID != nil {

		// query param service_policy.uuid
		var qrServicePolicyUUID string
		if o.ServicePolicyUUID != nil {
			qrServicePolicyUUID = *o.ServicePolicyUUID
		}
		qServicePolicyUUID := qrServicePolicyUUID
		if qServicePolicyUUID != "" {
			if err := r.SetQueryParam("service_policy.uuid", qServicePolicyUUID); err != nil {
				return err
			}
		}

	}

	if o.Services != nil {

		// query param services
		var qrServices string
		if o.Services != nil {
			qrServices = *o.Services
		}
		qServices := qrServices
		if qServices != "" {
			if err := r.SetQueryParam("services", qServices); err != nil {
				return err
			}
		}

	}

	if o.State != nil {

		// query param state
		var qrState string
		if o.State != nil {
			qrState = *o.State
		}
		qState := qrState
		if qState != "" {
			if err := r.SetQueryParam("state", qState); err != nil {
				return err
			}
		}

	}

	if o.SvmName != nil {

		// query param svm.name
		var qrSvmName string
		if o.SvmName != nil {
			qrSvmName = *o.SvmName
		}
		qSvmName := qrSvmName
		if qSvmName != "" {
			if err := r.SetQueryParam("svm.name", qSvmName); err != nil {
				return err
			}
		}

	}

	if o.SvmUUID != nil {

		// query param svm.uuid
		var qrSvmUUID string
		if o.SvmUUID != nil {
			qrSvmUUID = *o.SvmUUID
		}
		qSvmUUID := qrSvmUUID
		if qSvmUUID != "" {
			if err := r.SetQueryParam("svm.uuid", qSvmUUID); err != nil {
				return err
			}
		}

	}

	if o.UUID != nil {

		// query param uuid
		var qrUUID string
		if o.UUID != nil {
			qrUUID = *o.UUID
		}
		qUUID := qrUUID
		if qUUID != "" {
			if err := r.SetQueryParam("uuid", qUUID); err != nil {
				return err
			}
		}

	}

	if o.Vip != nil {

		// query param vip
		var qrVip bool
		if o.Vip != nil {
			qrVip = *o.Vip
		}
		qVip := swag.FormatBool(qrVip)
		if qVip != "" {
			if err := r.SetQueryParam("vip", qVip); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
