// Code generated by go-swagger; DO NOT EDIT.

package ntapcli

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"github.com/go-openapi/runtime"
	httptransport "github.com/go-openapi/runtime/client"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/greenqloud/ontap-rest-client/ntapcli/cloud"
	"github.com/greenqloud/ontap-rest-client/ntapcli/cluster"
	"github.com/greenqloud/ontap-rest-client/ntapcli/networking"
	"github.com/greenqloud/ontap-rest-client/ntapcli/private_cli"
	"github.com/greenqloud/ontap-rest-client/ntapcli/snapmirror"
	"github.com/greenqloud/ontap-rest-client/ntapcli/storage"
	"github.com/greenqloud/ontap-rest-client/ntapcli/svm"
	"github.com/greenqloud/ontap-rest-client/ntapcli/vserver"
)

// Default ontap HTTP client.
var Default = NewHTTPClient(nil)

const (
	// DefaultHost is the default Host
	// found in Meta (info) section of spec file
	DefaultHost string = "localhost"
	// DefaultBasePath is the default BasePath
	// found in Meta (info) section of spec file
	DefaultBasePath string = "/api"
)

// DefaultSchemes are the default schemes found in Meta (info) section of spec file
var DefaultSchemes = []string{"https"}

// NewHTTPClient creates a new ontap HTTP client.
func NewHTTPClient(formats strfmt.Registry) *Ontap {
	return NewHTTPClientWithConfig(formats, nil)
}

// NewHTTPClientWithConfig creates a new ontap HTTP client,
// using a customizable transport config.
func NewHTTPClientWithConfig(formats strfmt.Registry, cfg *TransportConfig) *Ontap {
	// ensure nullable parameters have default
	if cfg == nil {
		cfg = DefaultTransportConfig()
	}

	// create transport and client
	transport := httptransport.New(cfg.Host, cfg.BasePath, cfg.Schemes)
	return New(transport, formats)
}

// New creates a new ontap client
func New(transport runtime.ClientTransport, formats strfmt.Registry) *Ontap {
	// ensure nullable parameters have default
	if formats == nil {
		formats = strfmt.Default
	}

	cli := new(Ontap)
	cli.Transport = transport

	cli.Cloud = cloud.New(transport, formats)

	cli.Cluster = cluster.New(transport, formats)

	cli.Networking = networking.New(transport, formats)

	cli.PrivateCli = private_cli.New(transport, formats)

	cli.Snapmirror = snapmirror.New(transport, formats)

	cli.Storage = storage.New(transport, formats)

	cli.Svm = svm.New(transport, formats)

	cli.Vserver = vserver.New(transport, formats)

	return cli
}

// DefaultTransportConfig creates a TransportConfig with the
// default settings taken from the meta section of the spec file.
func DefaultTransportConfig() *TransportConfig {
	return &TransportConfig{
		Host:     DefaultHost,
		BasePath: DefaultBasePath,
		Schemes:  DefaultSchemes,
	}
}

// TransportConfig contains the transport related info,
// found in the meta section of the spec file.
type TransportConfig struct {
	Host     string
	BasePath string
	Schemes  []string
}

// WithHost overrides the default host,
// provided by the meta section of the spec file.
func (cfg *TransportConfig) WithHost(host string) *TransportConfig {
	cfg.Host = host
	return cfg
}

// WithBasePath overrides the default basePath,
// provided by the meta section of the spec file.
func (cfg *TransportConfig) WithBasePath(basePath string) *TransportConfig {
	cfg.BasePath = basePath
	return cfg
}

// WithSchemes overrides the default schemes,
// provided by the meta section of the spec file.
func (cfg *TransportConfig) WithSchemes(schemes []string) *TransportConfig {
	cfg.Schemes = schemes
	return cfg
}

// Ontap is a client for ontap
type Ontap struct {
	Cloud *cloud.Client

	Cluster *cluster.Client

	Networking *networking.Client

	PrivateCli *private_cli.Client

	Snapmirror *snapmirror.Client

	Storage *storage.Client

	Svm *svm.Client

	Vserver *vserver.Client

	Transport runtime.ClientTransport
}

// SetTransport changes the transport on the client and all its subresources
func (c *Ontap) SetTransport(transport runtime.ClientTransport) {
	c.Transport = transport

	c.Cloud.SetTransport(transport)

	c.Cluster.SetTransport(transport)

	c.Networking.SetTransport(transport)

	c.PrivateCli.SetTransport(transport)

	c.Snapmirror.SetTransport(transport)

	c.Storage.SetTransport(transport)

	c.Svm.SetTransport(transport)

	c.Vserver.SetTransport(transport)

}
