// Code generated by go-swagger; DO NOT EDIT.

package private_cli

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"
)

// New creates a new private cli API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) *Client {
	return &Client{transport: transport, formats: formats}
}

/*
Client for private cli API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

/*
PrivateCliVolumeGet Retrieves select volume information using private/cli interface.
### Related ONTAP commands
* `volume show`
*/
func (a *Client) PrivateCliVolumeGet(params *PrivateCliVolumeGetParams, authInfo runtime.ClientAuthInfoWriter) (*PrivateCliVolumeGetOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPrivateCliVolumeGetParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "private_cli_volume_get",
		Method:             "GET",
		PathPattern:        "/private/cli/volume",
		ProducesMediaTypes: []string{"application/hal+json", "application/json"},
		ConsumesMediaTypes: []string{"application/hal+json", "application/json"},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &PrivateCliVolumeGetReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PrivateCliVolumeGetOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	unexpectedSuccess := result.(*PrivateCliVolumeGetDefault)
	return nil, runtime.NewAPIError("unexpected success response: content available as default response in error", unexpectedSuccess, unexpectedSuccess.Code())
}

/*
PrivateCliVolumeSpaceGet Retrieves select volume space information using private/cli interface.
### Related ONTAP commands
* `volume show-space`
*/
func (a *Client) PrivateCliVolumeSpaceGet(params *PrivateCliVolumeSpaceGetParams, authInfo runtime.ClientAuthInfoWriter) (*PrivateCliVolumeSpaceGetOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPrivateCliVolumeSpaceGetParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "private_cli_volume_space_get",
		Method:             "GET",
		PathPattern:        "/private/cli/volume/space",
		ProducesMediaTypes: []string{"application/hal+json", "application/json"},
		ConsumesMediaTypes: []string{"application/hal+json", "application/json"},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &PrivateCliVolumeSpaceGetReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PrivateCliVolumeSpaceGetOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	unexpectedSuccess := result.(*PrivateCliVolumeSpaceGetDefault)
	return nil, runtime.NewAPIError("unexpected success response: content available as default response in error", unexpectedSuccess, unexpectedSuccess.Code())
}

/*
PrivateCliVserverLocksGet Retrieves vserver lock information using private/cli interface.
### Related ONTAP commands
* `vserver locks show`
*/
func (a *Client) PrivateCliVserverLocksGet(params *PrivateCliVserverLocksGetParams, authInfo runtime.ClientAuthInfoWriter) (*PrivateCliVserverLocksGetOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPrivateCliVserverLocksGetParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "private_cli_vserver_locks_get",
		Method:             "GET",
		PathPattern:        "/private/cli/vserver/locks",
		ProducesMediaTypes: []string{"application/hal+json", "application/json"},
		ConsumesMediaTypes: []string{"application/hal+json", "application/json"},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &PrivateCliVserverLocksGetReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PrivateCliVserverLocksGetOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	unexpectedSuccess := result.(*PrivateCliVserverLocksGetDefault)
	return nil, runtime.NewAPIError("unexpected success response: content available as default response in error", unexpectedSuccess, unexpectedSuccess.Code())
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
