// Code generated by go-swagger; DO NOT EDIT.

package private_cli

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewPrivateCliVolumeSpaceGetParams creates a new PrivateCliVolumeSpaceGetParams object
// with the default values initialized.
func NewPrivateCliVolumeSpaceGetParams() *PrivateCliVolumeSpaceGetParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &PrivateCliVolumeSpaceGetParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewPrivateCliVolumeSpaceGetParamsWithTimeout creates a new PrivateCliVolumeSpaceGetParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewPrivateCliVolumeSpaceGetParamsWithTimeout(timeout time.Duration) *PrivateCliVolumeSpaceGetParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &PrivateCliVolumeSpaceGetParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		timeout: timeout,
	}
}

// NewPrivateCliVolumeSpaceGetParamsWithContext creates a new PrivateCliVolumeSpaceGetParams object
// with the default values initialized, and the ability to set a context for a request
func NewPrivateCliVolumeSpaceGetParamsWithContext(ctx context.Context) *PrivateCliVolumeSpaceGetParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &PrivateCliVolumeSpaceGetParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		Context: ctx,
	}
}

// NewPrivateCliVolumeSpaceGetParamsWithHTTPClient creates a new PrivateCliVolumeSpaceGetParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewPrivateCliVolumeSpaceGetParamsWithHTTPClient(client *http.Client) *PrivateCliVolumeSpaceGetParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &PrivateCliVolumeSpaceGetParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,
		HTTPClient:    client,
	}
}

/*PrivateCliVolumeSpaceGetParams contains all the parameters to send to the API endpoint
for the private cli volume space get operation typically these are written to a http.Request
*/
type PrivateCliVolumeSpaceGetParams struct {

	/*Fields
	  Specify the fields to return.

	*/
	Fields []string
	/*MaxRecords
	  Limit the number of records returned.

	*/
	MaxRecords *int64
	/*OrderBy
	  Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.

	*/
	OrderBy []string
	/*ReturnRecords
	  The default is true for GET calls.  When set to false, only the number of records is returned.

	*/
	ReturnRecords *bool
	/*ReturnTimeout
	  The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	*/
	ReturnTimeout *int64
	/*Volume
	  Filter based on volume name

	*/
	Volume *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the private cli volume space get params
func (o *PrivateCliVolumeSpaceGetParams) WithTimeout(timeout time.Duration) *PrivateCliVolumeSpaceGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the private cli volume space get params
func (o *PrivateCliVolumeSpaceGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the private cli volume space get params
func (o *PrivateCliVolumeSpaceGetParams) WithContext(ctx context.Context) *PrivateCliVolumeSpaceGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the private cli volume space get params
func (o *PrivateCliVolumeSpaceGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the private cli volume space get params
func (o *PrivateCliVolumeSpaceGetParams) WithHTTPClient(client *http.Client) *PrivateCliVolumeSpaceGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the private cli volume space get params
func (o *PrivateCliVolumeSpaceGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFields adds the fields to the private cli volume space get params
func (o *PrivateCliVolumeSpaceGetParams) WithFields(fields []string) *PrivateCliVolumeSpaceGetParams {
	o.SetFields(fields)
	return o
}

// SetFields adds the fields to the private cli volume space get params
func (o *PrivateCliVolumeSpaceGetParams) SetFields(fields []string) {
	o.Fields = fields
}

// WithMaxRecords adds the maxRecords to the private cli volume space get params
func (o *PrivateCliVolumeSpaceGetParams) WithMaxRecords(maxRecords *int64) *PrivateCliVolumeSpaceGetParams {
	o.SetMaxRecords(maxRecords)
	return o
}

// SetMaxRecords adds the maxRecords to the private cli volume space get params
func (o *PrivateCliVolumeSpaceGetParams) SetMaxRecords(maxRecords *int64) {
	o.MaxRecords = maxRecords
}

// WithOrderBy adds the orderBy to the private cli volume space get params
func (o *PrivateCliVolumeSpaceGetParams) WithOrderBy(orderBy []string) *PrivateCliVolumeSpaceGetParams {
	o.SetOrderBy(orderBy)
	return o
}

// SetOrderBy adds the orderBy to the private cli volume space get params
func (o *PrivateCliVolumeSpaceGetParams) SetOrderBy(orderBy []string) {
	o.OrderBy = orderBy
}

// WithReturnRecords adds the returnRecords to the private cli volume space get params
func (o *PrivateCliVolumeSpaceGetParams) WithReturnRecords(returnRecords *bool) *PrivateCliVolumeSpaceGetParams {
	o.SetReturnRecords(returnRecords)
	return o
}

// SetReturnRecords adds the returnRecords to the private cli volume space get params
func (o *PrivateCliVolumeSpaceGetParams) SetReturnRecords(returnRecords *bool) {
	o.ReturnRecords = returnRecords
}

// WithReturnTimeout adds the returnTimeout to the private cli volume space get params
func (o *PrivateCliVolumeSpaceGetParams) WithReturnTimeout(returnTimeout *int64) *PrivateCliVolumeSpaceGetParams {
	o.SetReturnTimeout(returnTimeout)
	return o
}

// SetReturnTimeout adds the returnTimeout to the private cli volume space get params
func (o *PrivateCliVolumeSpaceGetParams) SetReturnTimeout(returnTimeout *int64) {
	o.ReturnTimeout = returnTimeout
}

// WithVolume adds the volume to the private cli volume space get params
func (o *PrivateCliVolumeSpaceGetParams) WithVolume(volume *string) *PrivateCliVolumeSpaceGetParams {
	o.SetVolume(volume)
	return o
}

// SetVolume adds the volume to the private cli volume space get params
func (o *PrivateCliVolumeSpaceGetParams) SetVolume(volume *string) {
	o.Volume = volume
}

// WriteToRequest writes these params to a swagger request
func (o *PrivateCliVolumeSpaceGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	valuesFields := o.Fields

	joinedFields := swag.JoinByFormat(valuesFields, "csv")
	// query array param fields
	if err := r.SetQueryParam("fields", joinedFields...); err != nil {
		return err
	}

	if o.MaxRecords != nil {

		// query param max_records
		var qrMaxRecords int64
		if o.MaxRecords != nil {
			qrMaxRecords = *o.MaxRecords
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {
			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}

	}

	valuesOrderBy := o.OrderBy

	joinedOrderBy := swag.JoinByFormat(valuesOrderBy, "csv")
	// query array param order_by
	if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
		return err
	}

	if o.ReturnRecords != nil {

		// query param return_records
		var qrReturnRecords bool
		if o.ReturnRecords != nil {
			qrReturnRecords = *o.ReturnRecords
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {
			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}

	}

	if o.ReturnTimeout != nil {

		// query param return_timeout
		var qrReturnTimeout int64
		if o.ReturnTimeout != nil {
			qrReturnTimeout = *o.ReturnTimeout
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {
			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}

	}

	if o.Volume != nil {

		// query param volume
		var qrVolume string
		if o.Volume != nil {
			qrVolume = *o.Volume
		}
		qVolume := qrVolume
		if qVolume != "" {
			if err := r.SetQueryParam("volume", qVolume); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
