// Code generated by go-swagger; DO NOT EDIT.

package private_cli

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewPrivateCliVserverLocksGetParams creates a new PrivateCliVserverLocksGetParams object
// with the default values initialized.
func NewPrivateCliVserverLocksGetParams() *PrivateCliVserverLocksGetParams {
	var (
		returnRecordsDefault = bool(false)
		returnTimeoutDefault = int64(15)
	)
	return &PrivateCliVserverLocksGetParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewPrivateCliVserverLocksGetParamsWithTimeout creates a new PrivateCliVserverLocksGetParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewPrivateCliVserverLocksGetParamsWithTimeout(timeout time.Duration) *PrivateCliVserverLocksGetParams {
	var (
		returnRecordsDefault = bool(false)
		returnTimeoutDefault = int64(15)
	)
	return &PrivateCliVserverLocksGetParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		timeout: timeout,
	}
}

// NewPrivateCliVserverLocksGetParamsWithContext creates a new PrivateCliVserverLocksGetParams object
// with the default values initialized, and the ability to set a context for a request
func NewPrivateCliVserverLocksGetParamsWithContext(ctx context.Context) *PrivateCliVserverLocksGetParams {
	var (
		returnRecordsDefault = bool(false)
		returnTimeoutDefault = int64(15)
	)
	return &PrivateCliVserverLocksGetParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		Context: ctx,
	}
}

// NewPrivateCliVserverLocksGetParamsWithHTTPClient creates a new PrivateCliVserverLocksGetParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewPrivateCliVserverLocksGetParamsWithHTTPClient(client *http.Client) *PrivateCliVserverLocksGetParams {
	var (
		returnRecordsDefault = bool(false)
		returnTimeoutDefault = int64(15)
	)
	return &PrivateCliVserverLocksGetParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,
		HTTPClient:    client,
	}
}

/*PrivateCliVserverLocksGetParams contains all the parameters to send to the API endpoint
for the private cli vserver locks get operation typically these are written to a http.Request
*/
type PrivateCliVserverLocksGetParams struct {

	/*Node
	  Filter for ontap node

	*/
	Node *string
	/*ReturnRecords
	  The default is false.  If set to true, the records are returned.

	*/
	ReturnRecords *bool
	/*ReturnTimeout
	  The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	*/
	ReturnTimeout *int64
	/*SmbOpenType
	  Filter for SMB open type

	*/
	SmbOpenType *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the private cli vserver locks get params
func (o *PrivateCliVserverLocksGetParams) WithTimeout(timeout time.Duration) *PrivateCliVserverLocksGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the private cli vserver locks get params
func (o *PrivateCliVserverLocksGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the private cli vserver locks get params
func (o *PrivateCliVserverLocksGetParams) WithContext(ctx context.Context) *PrivateCliVserverLocksGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the private cli vserver locks get params
func (o *PrivateCliVserverLocksGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the private cli vserver locks get params
func (o *PrivateCliVserverLocksGetParams) WithHTTPClient(client *http.Client) *PrivateCliVserverLocksGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the private cli vserver locks get params
func (o *PrivateCliVserverLocksGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithNode adds the node to the private cli vserver locks get params
func (o *PrivateCliVserverLocksGetParams) WithNode(node *string) *PrivateCliVserverLocksGetParams {
	o.SetNode(node)
	return o
}

// SetNode adds the node to the private cli vserver locks get params
func (o *PrivateCliVserverLocksGetParams) SetNode(node *string) {
	o.Node = node
}

// WithReturnRecords adds the returnRecords to the private cli vserver locks get params
func (o *PrivateCliVserverLocksGetParams) WithReturnRecords(returnRecords *bool) *PrivateCliVserverLocksGetParams {
	o.SetReturnRecords(returnRecords)
	return o
}

// SetReturnRecords adds the returnRecords to the private cli vserver locks get params
func (o *PrivateCliVserverLocksGetParams) SetReturnRecords(returnRecords *bool) {
	o.ReturnRecords = returnRecords
}

// WithReturnTimeout adds the returnTimeout to the private cli vserver locks get params
func (o *PrivateCliVserverLocksGetParams) WithReturnTimeout(returnTimeout *int64) *PrivateCliVserverLocksGetParams {
	o.SetReturnTimeout(returnTimeout)
	return o
}

// SetReturnTimeout adds the returnTimeout to the private cli vserver locks get params
func (o *PrivateCliVserverLocksGetParams) SetReturnTimeout(returnTimeout *int64) {
	o.ReturnTimeout = returnTimeout
}

// WithSmbOpenType adds the smbOpenType to the private cli vserver locks get params
func (o *PrivateCliVserverLocksGetParams) WithSmbOpenType(smbOpenType *string) *PrivateCliVserverLocksGetParams {
	o.SetSmbOpenType(smbOpenType)
	return o
}

// SetSmbOpenType adds the smbOpenType to the private cli vserver locks get params
func (o *PrivateCliVserverLocksGetParams) SetSmbOpenType(smbOpenType *string) {
	o.SmbOpenType = smbOpenType
}

// WriteToRequest writes these params to a swagger request
func (o *PrivateCliVserverLocksGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Node != nil {

		// query param node
		var qrNode string
		if o.Node != nil {
			qrNode = *o.Node
		}
		qNode := qrNode
		if qNode != "" {
			if err := r.SetQueryParam("node", qNode); err != nil {
				return err
			}
		}

	}

	if o.ReturnRecords != nil {

		// query param return_records
		var qrReturnRecords bool
		if o.ReturnRecords != nil {
			qrReturnRecords = *o.ReturnRecords
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {
			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}

	}

	if o.ReturnTimeout != nil {

		// query param return_timeout
		var qrReturnTimeout int64
		if o.ReturnTimeout != nil {
			qrReturnTimeout = *o.ReturnTimeout
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {
			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}

	}

	if o.SmbOpenType != nil {

		// query param smb-open-type
		var qrSmbOpenType string
		if o.SmbOpenType != nil {
			qrSmbOpenType = *o.SmbOpenType
		}
		qSmbOpenType := qrSmbOpenType
		if qSmbOpenType != "" {
			if err := r.SetQueryParam("smb-open-type", qSmbOpenType); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
