// Code generated by go-swagger; DO NOT EDIT.

package snapmirror

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"
)

// New creates a new snapmirror API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) *Client {
	return &Client{transport: transport, formats: formats}
}

/*
Client for snapmirror API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

/*
SnapmirrorObjectStoreEndpointDelete Deletes all the data of specified snapmirror endpoint within object store.

### Related ONTAP commands
* `snapmirror object-store endpoint delete`

### Examples
  DELETE "/api/snapmirror/object-stores/cd9563a0-2e59-11ea-a778-00505682bd8f/endpoints/af86c94c-bcb2-4b4e-b8cc-c294793a310a"

*/
func (a *Client) SnapmirrorObjectStoreEndpointDelete(params *SnapmirrorObjectStoreEndpointDeleteParams, authInfo runtime.ClientAuthInfoWriter) (*SnapmirrorObjectStoreEndpointDeleteAccepted, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewSnapmirrorObjectStoreEndpointDeleteParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "snapmirror-object-store-endpoint-delete",
		Method:             "DELETE",
		PathPattern:        "/snapmirror/object-stores/{objectStoreUUID}/endpoints/{endpointUUID}",
		ProducesMediaTypes: []string{"application/hal+json", "application/json"},
		ConsumesMediaTypes: []string{"application/hal+json", "application/json"},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &SnapmirrorObjectStoreEndpointDeleteReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*SnapmirrorObjectStoreEndpointDeleteAccepted)
	if ok {
		return success, nil
	}
	// unexpected success response
	unexpectedSuccess := result.(*SnapmirrorObjectStoreEndpointDeleteDefault)
	return nil, runtime.NewAPIError("unexpected success response: content available as default response in error", unexpectedSuccess, unexpectedSuccess.Code())
}

/*
SnapmirrorGet Retrieves a list of snapmirrors status
### Important notes
* The snapmirror object includes a large set of fields and can be expensive to retrieve. Use this API to list the collection of all job status for the whole ONTAP cluster.
### Expensive properties
There is an added cost to retrieving values for these properties. They are not included by default in GET results and must be explicitly requested using the `fields` query parameter.
### Related ONTAP commands
* `snapmirror show`
Action: GET "/api/private/cli/snapmirror"

*/
func (a *Client) SnapmirrorGet(params *SnapmirrorGetParams, authInfo runtime.ClientAuthInfoWriter) (*SnapmirrorGetOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewSnapmirrorGetParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "snapmirror_get",
		Method:             "GET",
		PathPattern:        "/private/cli/snapmirror",
		ProducesMediaTypes: []string{"application/hal+json", "application/json"},
		ConsumesMediaTypes: []string{"application/hal+json", "application/json"},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &SnapmirrorGetReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*SnapmirrorGetOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	unexpectedSuccess := result.(*SnapmirrorGetDefault)
	return nil, runtime.NewAPIError("unexpected success response: content available as default response in error", unexpectedSuccess, unexpectedSuccess.Code())
}

/*
SnapmirrorModifyPost Action: POST "/api/private/cli/snapmirror/modify"

*/
func (a *Client) SnapmirrorModifyPost(params *SnapmirrorModifyPostParams, authInfo runtime.ClientAuthInfoWriter) (*SnapmirrorModifyPostOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewSnapmirrorModifyPostParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "snapmirror_modify_post",
		Method:             "POST",
		PathPattern:        "/private/cli/snapmirror/modify",
		ProducesMediaTypes: []string{"application/hal+json", "application/json"},
		ConsumesMediaTypes: []string{"application/hal+json", "application/json"},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &SnapmirrorModifyPostReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*SnapmirrorModifyPostOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	unexpectedSuccess := result.(*SnapmirrorModifyPostDefault)
	return nil, runtime.NewAPIError("unexpected success response: content available as default response in error", unexpectedSuccess, unexpectedSuccess.Code())
}

/*
SnapmirrorObjectStoreSnapshotDelete Deletes a Snapshot copy from the object store endpoint. The object store UUID, object store endpoint UUID together with the Snapshot copy UUID will be used to specify the Snapshot copy to be deleted.
### Related ONTAP commands
* `snapmirror object-store endpoint snapshot delete`
### Examples
  DELETE "/api/snapmirror/object-stores/cd9563a0-2e59-11ea-a778-00505682bd8f/endpoints/af86c94c-bcb2-4b4e-b8cc-c294793a310a/snapshots/04fb1ddb-2947-4eb0-af09-3eb6dc538926"

*/
func (a *Client) SnapmirrorObjectStoreSnapshotDelete(params *SnapmirrorObjectStoreSnapshotDeleteParams, authInfo runtime.ClientAuthInfoWriter) (*SnapmirrorObjectStoreSnapshotDeleteAccepted, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewSnapmirrorObjectStoreSnapshotDeleteParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "snapmirror_object_store_snapshot_delete",
		Method:             "DELETE",
		PathPattern:        "/snapmirror/object-stores/{objectStoreUUID}/endpoints/{endpointUUID}/snapshots/{snapshotUUID}",
		ProducesMediaTypes: []string{"application/hal+json", "application/json"},
		ConsumesMediaTypes: []string{"application/hal+json", "application/json"},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &SnapmirrorObjectStoreSnapshotDeleteReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*SnapmirrorObjectStoreSnapshotDeleteAccepted)
	if ok {
		return success, nil
	}
	// unexpected success response
	unexpectedSuccess := result.(*SnapmirrorObjectStoreSnapshotDeleteDefault)
	return nil, runtime.NewAPIError("unexpected success response: content available as default response in error", unexpectedSuccess, unexpectedSuccess.Code())
}

/*
SnapmirrorPoliciesGet Retrieves a list of snapmirror policies, get its UUID and fields
### Examples
1. Retrieves a list of snapmirror policies in the cluster
    <br/>
    ```
    GET "/api/snapmirror/policies"
    ```
    <br/>
### Learn more

*/
func (a *Client) SnapmirrorPoliciesGet(params *SnapmirrorPoliciesGetParams, authInfo runtime.ClientAuthInfoWriter) (*SnapmirrorPoliciesGetOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewSnapmirrorPoliciesGetParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "snapmirror_policies_get",
		Method:             "GET",
		PathPattern:        "/snapmirror/policies",
		ProducesMediaTypes: []string{"application/hal+json", "application/json"},
		ConsumesMediaTypes: []string{"application/hal+json", "application/json"},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &SnapmirrorPoliciesGetReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*SnapmirrorPoliciesGetOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	unexpectedSuccess := result.(*SnapmirrorPoliciesGetDefault)
	return nil, runtime.NewAPIError("unexpected success response: content available as default response in error", unexpectedSuccess, unexpectedSuccess.Code())
}

/*
SnapmirrorPoliciesUUIDDelete Delete specified snapmirror policy by UUID
1. Retrieves a list of SVMs in the cluster sorted by name
    <br/>
    ```
    DELETE "/api/snapmirror/policies/uuid"
    ```
    <br/>

*/
func (a *Client) SnapmirrorPoliciesUUIDDelete(params *SnapmirrorPoliciesUUIDDeleteParams, authInfo runtime.ClientAuthInfoWriter) (*SnapmirrorPoliciesUUIDDeleteOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewSnapmirrorPoliciesUUIDDeleteParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "snapmirror_policies_uuid_delete",
		Method:             "DELETE",
		PathPattern:        "/snapmirror/policies/{uuid}",
		ProducesMediaTypes: []string{"application/hal+json", "application/json"},
		ConsumesMediaTypes: []string{"application/hal+json", "application/json"},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &SnapmirrorPoliciesUUIDDeleteReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*SnapmirrorPoliciesUUIDDeleteOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	unexpectedSuccess := result.(*SnapmirrorPoliciesUUIDDeleteDefault)
	return nil, runtime.NewAPIError("unexpected success response: content available as default response in error", unexpectedSuccess, unexpectedSuccess.Code())
}

/*
SnapmirrorPoliciesUUIDGet Retrieves a snapmirror detail info for a specified policies UUID
### Examples
1. Retrieves a list of SVMs in the cluster sorted by name
    <br/>
    ```
    GET "/api/snapmirror/policies/{uuid}"
    ```
    <br/>

*/
func (a *Client) SnapmirrorPoliciesUUIDGet(params *SnapmirrorPoliciesUUIDGetParams, authInfo runtime.ClientAuthInfoWriter) (*SnapmirrorPoliciesUUIDGetOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewSnapmirrorPoliciesUUIDGetParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "snapmirror_policies_uuid_get",
		Method:             "GET",
		PathPattern:        "/snapmirror/policies/{uuid}",
		ProducesMediaTypes: []string{"application/hal+json", "application/json"},
		ConsumesMediaTypes: []string{"application/hal+json", "application/json"},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &SnapmirrorPoliciesUUIDGetReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*SnapmirrorPoliciesUUIDGetOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	unexpectedSuccess := result.(*SnapmirrorPoliciesUUIDGetDefault)
	return nil, runtime.NewAPIError("unexpected success response: content available as default response in error", unexpectedSuccess, unexpectedSuccess.Code())
}

/*
SnapmirrorPoliciesUUIDPatch Retrieves a snapmirror policies detail info for a specified relationship UUID, majorly throttle
1. Retrieves a list of SVMs in the cluster sorted by name
    <br/>
    ```
    PATCH "/api/snapmirror/policies/uuid"
    ```
    <br/>

*/
func (a *Client) SnapmirrorPoliciesUUIDPatch(params *SnapmirrorPoliciesUUIDPatchParams, authInfo runtime.ClientAuthInfoWriter) (*SnapmirrorPoliciesUUIDPatchOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewSnapmirrorPoliciesUUIDPatchParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "snapmirror_policies_uuid_patch",
		Method:             "PATCH",
		PathPattern:        "/snapmirror/policies/{uuid}",
		ProducesMediaTypes: []string{"application/hal+json", "application/json"},
		ConsumesMediaTypes: []string{"application/hal+json", "application/json"},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &SnapmirrorPoliciesUUIDPatchReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*SnapmirrorPoliciesUUIDPatchOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	unexpectedSuccess := result.(*SnapmirrorPoliciesUUIDPatchDefault)
	return nil, runtime.NewAPIError("unexpected success response: content available as default response in error", unexpectedSuccess, unexpectedSuccess.Code())
}

/*
SnapmirrorPolicyPost Create a snapmirror policy
### Examples
    <br/>
    ```
    POST "/api/snapmirror/policies"
    ```
    <br/>
### Learn more

*/
func (a *Client) SnapmirrorPolicyPost(params *SnapmirrorPolicyPostParams, authInfo runtime.ClientAuthInfoWriter) (*SnapmirrorPolicyPostCreated, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewSnapmirrorPolicyPostParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "snapmirror_policy_post",
		Method:             "POST",
		PathPattern:        "/snapmirror/policies",
		ProducesMediaTypes: []string{"application/hal+json", "application/json"},
		ConsumesMediaTypes: []string{"application/hal+json", "application/json"},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &SnapmirrorPolicyPostReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*SnapmirrorPolicyPostCreated)
	if ok {
		return success, nil
	}
	// unexpected success response
	unexpectedSuccess := result.(*SnapmirrorPolicyPostDefault)
	return nil, runtime.NewAPIError("unexpected success response: content available as default response in error", unexpectedSuccess, unexpectedSuccess.Code())
}

/*
SnapmirrorRelationshipsGet Retrieves a list of snapmirror relationship, get its UUID and data fields
* `snapmirror realtionship show`
1. Retrieves a list of snapmirror relationships in the cluster
    <br/>
    ```
    GET "/api/snapmirror/relationships"
    ```
    <br/>

*/
func (a *Client) SnapmirrorRelationshipsGet(params *SnapmirrorRelationshipsGetParams, authInfo runtime.ClientAuthInfoWriter) (*SnapmirrorRelationshipsGetOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewSnapmirrorRelationshipsGetParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "snapmirror_relationships_get",
		Method:             "GET",
		PathPattern:        "/snapmirror/relationships",
		ProducesMediaTypes: []string{"application/hal+json", "application/json"},
		ConsumesMediaTypes: []string{"application/hal+json", "application/json"},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &SnapmirrorRelationshipsGetReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*SnapmirrorRelationshipsGetOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	unexpectedSuccess := result.(*SnapmirrorRelationshipsGetDefault)
	return nil, runtime.NewAPIError("unexpected success response: content available as default response in error", unexpectedSuccess, unexpectedSuccess.Code())
}

/*
SnapmirrorRelationshipsPost Create a snapmirror relationship
    <br/>
    ```
    POST "/api/snapmirror/relationships"
    ```
    <br/>

*/
func (a *Client) SnapmirrorRelationshipsPost(params *SnapmirrorRelationshipsPostParams, authInfo runtime.ClientAuthInfoWriter) (*SnapmirrorRelationshipsPostCreated, *SnapmirrorRelationshipsPostAccepted, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewSnapmirrorRelationshipsPostParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "snapmirror_relationships_post",
		Method:             "POST",
		PathPattern:        "/snapmirror/relationships",
		ProducesMediaTypes: []string{"application/hal+json", "application/json"},
		ConsumesMediaTypes: []string{"application/hal+json", "application/json"},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &SnapmirrorRelationshipsPostReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, nil, err
	}
	switch value := result.(type) {
	case *SnapmirrorRelationshipsPostCreated:
		return value, nil, nil
	case *SnapmirrorRelationshipsPostAccepted:
		return nil, value, nil
	}
	// unexpected success response
	unexpectedSuccess := result.(*SnapmirrorRelationshipsPostDefault)
	return nil, nil, runtime.NewAPIError("unexpected success response: content available as default response in error", unexpectedSuccess, unexpectedSuccess.Code())
}

/*
SnapmirrorRelationshipsTransfersPost do a transfer restore
1. Retrieves a list of SVMs in the cluster sorted by name
    <br/>
    ```
    POST "/api/snapmirror/relationships/uuid"
    ```
    <br/>

*/
func (a *Client) SnapmirrorRelationshipsTransfersPost(params *SnapmirrorRelationshipsTransfersPostParams, authInfo runtime.ClientAuthInfoWriter) (*SnapmirrorRelationshipsTransfersPostCreated, *SnapmirrorRelationshipsTransfersPostAccepted, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewSnapmirrorRelationshipsTransfersPostParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "snapmirror_relationships_transfers_post",
		Method:             "POST",
		PathPattern:        "/snapmirror/relationships/{uuid}/transfers",
		ProducesMediaTypes: []string{"application/hal+json", "application/json"},
		ConsumesMediaTypes: []string{"application/hal+json", "application/json"},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &SnapmirrorRelationshipsTransfersPostReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, nil, err
	}
	switch value := result.(type) {
	case *SnapmirrorRelationshipsTransfersPostCreated:
		return value, nil, nil
	case *SnapmirrorRelationshipsTransfersPostAccepted:
		return nil, value, nil
	}
	// unexpected success response
	unexpectedSuccess := result.(*SnapmirrorRelationshipsTransfersPostDefault)
	return nil, nil, runtime.NewAPIError("unexpected success response: content available as default response in error", unexpectedSuccess, unexpectedSuccess.Code())
}

/*
SnapmirrorRelationshipsTransfersUUIDPatch do a snapmirror transfer abort
    <br/>
    ```
    POST "/api/snapmirror/relationships/uuid/transfers/uuid"
    ```
    <br/>

*/
func (a *Client) SnapmirrorRelationshipsTransfersUUIDPatch(params *SnapmirrorRelationshipsTransfersUUIDPatchParams, authInfo runtime.ClientAuthInfoWriter) (*SnapmirrorRelationshipsTransfersUUIDPatchOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewSnapmirrorRelationshipsTransfersUUIDPatchParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "snapmirror_relationships_transfers_uuid_patch",
		Method:             "PATCH",
		PathPattern:        "/snapmirror/relationships/{uuid1}/transfers/{uuid2}",
		ProducesMediaTypes: []string{"application/hal+json", "application/json"},
		ConsumesMediaTypes: []string{"application/hal+json", "application/json"},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &SnapmirrorRelationshipsTransfersUUIDPatchReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*SnapmirrorRelationshipsTransfersUUIDPatchOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	unexpectedSuccess := result.(*SnapmirrorRelationshipsTransfersUUIDPatchDefault)
	return nil, runtime.NewAPIError("unexpected success response: content available as default response in error", unexpectedSuccess, unexpectedSuccess.Code())
}

/*
SnapmirrorRelationshipsUUIDDelete Delete a snapmirror relationship by its UUID
    <br/>
    ```
    DELETE "/api/snapmirror/relationships/uuid"
    ```
    <br/>

*/
func (a *Client) SnapmirrorRelationshipsUUIDDelete(params *SnapmirrorRelationshipsUUIDDeleteParams, authInfo runtime.ClientAuthInfoWriter) (*SnapmirrorRelationshipsUUIDDeleteOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewSnapmirrorRelationshipsUUIDDeleteParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "snapmirror_relationships_uuid_delete",
		Method:             "DELETE",
		PathPattern:        "/snapmirror/relationships/{uuid}",
		ProducesMediaTypes: []string{"application/hal+json", "application/json"},
		ConsumesMediaTypes: []string{"application/hal+json", "application/json"},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &SnapmirrorRelationshipsUUIDDeleteReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*SnapmirrorRelationshipsUUIDDeleteOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	unexpectedSuccess := result.(*SnapmirrorRelationshipsUUIDDeleteDefault)
	return nil, runtime.NewAPIError("unexpected success response: content available as default response in error", unexpectedSuccess, unexpectedSuccess.Code())
}

/*
SnapmirrorRelationshipsUUIDGet Retrieves a snapmirror detail info for a specified relationship UUID
* `snapmirror realtionship show`
1. Retrieves a list of SVMs in the cluster sorted by name
    <br/>
    ```
    GET "/api/snapmirror/relationships"
    ```
    <br/>

*/
func (a *Client) SnapmirrorRelationshipsUUIDGet(params *SnapmirrorRelationshipsUUIDGetParams, authInfo runtime.ClientAuthInfoWriter) (*SnapmirrorRelationshipsUUIDGetOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewSnapmirrorRelationshipsUUIDGetParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "snapmirror_relationships_uuid_get",
		Method:             "GET",
		PathPattern:        "/snapmirror/relationships/{uuid}",
		ProducesMediaTypes: []string{"application/hal+json", "application/json"},
		ConsumesMediaTypes: []string{"application/hal+json", "application/json"},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &SnapmirrorRelationshipsUUIDGetReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*SnapmirrorRelationshipsUUIDGetOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	unexpectedSuccess := result.(*SnapmirrorRelationshipsUUIDGetDefault)
	return nil, runtime.NewAPIError("unexpected success response: content available as default response in error", unexpectedSuccess, unexpectedSuccess.Code())
}

/*
SnapmirrorRelationshipsUUIDPatch 1. change the status of a snapmirror realationship, input is "resync","initialize",etc.
    <br/>
    ```
    PATCH "/api/snapmirror/relationships/uuid"
    ```
    <br/>

*/
func (a *Client) SnapmirrorRelationshipsUUIDPatch(params *SnapmirrorRelationshipsUUIDPatchParams, authInfo runtime.ClientAuthInfoWriter) (*SnapmirrorRelationshipsUUIDPatchOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewSnapmirrorRelationshipsUUIDPatchParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "snapmirror_relationships_uuid_patch",
		Method:             "PATCH",
		PathPattern:        "/snapmirror/relationships/{uuid}",
		ProducesMediaTypes: []string{"application/hal+json", "application/json"},
		ConsumesMediaTypes: []string{"application/hal+json", "application/json"},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &SnapmirrorRelationshipsUUIDPatchReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*SnapmirrorRelationshipsUUIDPatchOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	unexpectedSuccess := result.(*SnapmirrorRelationshipsUUIDPatchDefault)
	return nil, runtime.NewAPIError("unexpected success response: content available as default response in error", unexpectedSuccess, unexpectedSuccess.Code())
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
