// Code generated by go-swagger; DO NOT EDIT.

package snapmirror

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/greenqloud/ontap-rest-client/ntapmodel"
)

// NewSnapmirrorModifyPostParams creates a new SnapmirrorModifyPostParams object
// with the default values initialized.
func NewSnapmirrorModifyPostParams() *SnapmirrorModifyPostParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &SnapmirrorModifyPostParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewSnapmirrorModifyPostParamsWithTimeout creates a new SnapmirrorModifyPostParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewSnapmirrorModifyPostParamsWithTimeout(timeout time.Duration) *SnapmirrorModifyPostParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &SnapmirrorModifyPostParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		timeout: timeout,
	}
}

// NewSnapmirrorModifyPostParamsWithContext creates a new SnapmirrorModifyPostParams object
// with the default values initialized, and the ability to set a context for a request
func NewSnapmirrorModifyPostParamsWithContext(ctx context.Context) *SnapmirrorModifyPostParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &SnapmirrorModifyPostParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		Context: ctx,
	}
}

// NewSnapmirrorModifyPostParamsWithHTTPClient creates a new SnapmirrorModifyPostParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewSnapmirrorModifyPostParamsWithHTTPClient(client *http.Client) *SnapmirrorModifyPostParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &SnapmirrorModifyPostParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,
		HTTPClient:    client,
	}
}

/*SnapmirrorModifyPostParams contains all the parameters to send to the API endpoint
for the snapmirror modify post operation typically these are written to a http.Request
*/
type SnapmirrorModifyPostParams struct {

	/*Fields
	  Specify the fields to return.

	*/
	Fields []string
	/*Info
	  Filter by destination-path

	*/
	Info *ntapmodel.SnapmirrorModify
	/*ReturnRecords
	  The default is true for GET calls.  When set to false, only the number of records is returned.

	*/
	ReturnRecords *bool
	/*ReturnTimeout
	  The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	*/
	ReturnTimeout *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the snapmirror modify post params
func (o *SnapmirrorModifyPostParams) WithTimeout(timeout time.Duration) *SnapmirrorModifyPostParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the snapmirror modify post params
func (o *SnapmirrorModifyPostParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the snapmirror modify post params
func (o *SnapmirrorModifyPostParams) WithContext(ctx context.Context) *SnapmirrorModifyPostParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the snapmirror modify post params
func (o *SnapmirrorModifyPostParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the snapmirror modify post params
func (o *SnapmirrorModifyPostParams) WithHTTPClient(client *http.Client) *SnapmirrorModifyPostParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the snapmirror modify post params
func (o *SnapmirrorModifyPostParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFields adds the fields to the snapmirror modify post params
func (o *SnapmirrorModifyPostParams) WithFields(fields []string) *SnapmirrorModifyPostParams {
	o.SetFields(fields)
	return o
}

// SetFields adds the fields to the snapmirror modify post params
func (o *SnapmirrorModifyPostParams) SetFields(fields []string) {
	o.Fields = fields
}

// WithInfo adds the info to the snapmirror modify post params
func (o *SnapmirrorModifyPostParams) WithInfo(info *ntapmodel.SnapmirrorModify) *SnapmirrorModifyPostParams {
	o.SetInfo(info)
	return o
}

// SetInfo adds the info to the snapmirror modify post params
func (o *SnapmirrorModifyPostParams) SetInfo(info *ntapmodel.SnapmirrorModify) {
	o.Info = info
}

// WithReturnRecords adds the returnRecords to the snapmirror modify post params
func (o *SnapmirrorModifyPostParams) WithReturnRecords(returnRecords *bool) *SnapmirrorModifyPostParams {
	o.SetReturnRecords(returnRecords)
	return o
}

// SetReturnRecords adds the returnRecords to the snapmirror modify post params
func (o *SnapmirrorModifyPostParams) SetReturnRecords(returnRecords *bool) {
	o.ReturnRecords = returnRecords
}

// WithReturnTimeout adds the returnTimeout to the snapmirror modify post params
func (o *SnapmirrorModifyPostParams) WithReturnTimeout(returnTimeout *int64) *SnapmirrorModifyPostParams {
	o.SetReturnTimeout(returnTimeout)
	return o
}

// SetReturnTimeout adds the returnTimeout to the snapmirror modify post params
func (o *SnapmirrorModifyPostParams) SetReturnTimeout(returnTimeout *int64) {
	o.ReturnTimeout = returnTimeout
}

// WriteToRequest writes these params to a swagger request
func (o *SnapmirrorModifyPostParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	valuesFields := o.Fields

	joinedFields := swag.JoinByFormat(valuesFields, "csv")
	// query array param fields
	if err := r.SetQueryParam("fields", joinedFields...); err != nil {
		return err
	}

	if o.Info != nil {
		if err := r.SetBodyParam(o.Info); err != nil {
			return err
		}
	}

	if o.ReturnRecords != nil {

		// query param return_records
		var qrReturnRecords bool
		if o.ReturnRecords != nil {
			qrReturnRecords = *o.ReturnRecords
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {
			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}

	}

	if o.ReturnTimeout != nil {

		// query param return_timeout
		var qrReturnTimeout int64
		if o.ReturnTimeout != nil {
			qrReturnTimeout = *o.ReturnTimeout
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {
			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
