// Code generated by go-swagger; DO NOT EDIT.

package snapmirror

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewSnapmirrorObjectStoreEndpointDeleteParams creates a new SnapmirrorObjectStoreEndpointDeleteParams object
// with the default values initialized.
func NewSnapmirrorObjectStoreEndpointDeleteParams() *SnapmirrorObjectStoreEndpointDeleteParams {
	var (
		returnTimeoutDefault = int64(0)
	)
	return &SnapmirrorObjectStoreEndpointDeleteParams{
		ReturnTimeout: &returnTimeoutDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewSnapmirrorObjectStoreEndpointDeleteParamsWithTimeout creates a new SnapmirrorObjectStoreEndpointDeleteParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewSnapmirrorObjectStoreEndpointDeleteParamsWithTimeout(timeout time.Duration) *SnapmirrorObjectStoreEndpointDeleteParams {
	var (
		returnTimeoutDefault = int64(0)
	)
	return &SnapmirrorObjectStoreEndpointDeleteParams{
		ReturnTimeout: &returnTimeoutDefault,

		timeout: timeout,
	}
}

// NewSnapmirrorObjectStoreEndpointDeleteParamsWithContext creates a new SnapmirrorObjectStoreEndpointDeleteParams object
// with the default values initialized, and the ability to set a context for a request
func NewSnapmirrorObjectStoreEndpointDeleteParamsWithContext(ctx context.Context) *SnapmirrorObjectStoreEndpointDeleteParams {
	var (
		returnTimeoutDefault = int64(0)
	)
	return &SnapmirrorObjectStoreEndpointDeleteParams{
		ReturnTimeout: &returnTimeoutDefault,

		Context: ctx,
	}
}

// NewSnapmirrorObjectStoreEndpointDeleteParamsWithHTTPClient creates a new SnapmirrorObjectStoreEndpointDeleteParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewSnapmirrorObjectStoreEndpointDeleteParamsWithHTTPClient(client *http.Client) *SnapmirrorObjectStoreEndpointDeleteParams {
	var (
		returnTimeoutDefault = int64(0)
	)
	return &SnapmirrorObjectStoreEndpointDeleteParams{
		ReturnTimeout: &returnTimeoutDefault,
		HTTPClient:    client,
	}
}

/*SnapmirrorObjectStoreEndpointDeleteParams contains all the parameters to send to the API endpoint
for the snapmirror object store endpoint delete operation typically these are written to a http.Request
*/
type SnapmirrorObjectStoreEndpointDeleteParams struct {

	/*EndpointUUID
	  Endpoint UUID

	*/
	EndpointUUID string
	/*ObjectStoreUUID
	  Object store UUID

	*/
	ObjectStoreUUID string
	/*ReturnTimeout
	  The number of seconds to allow the call to execute before returning. When doing a POST, PATCH, or DELETE operation on a single record, the default is 0 seconds.  This means that if an asynchronous operation is started, the server immediately returns HTTP code 202 (Accepted) along with a link to the job.  If a non-zero value is specified for POST, PATCH, or DELETE operations, ONTAP waits that length of time to see if the job completes so it can return something other than 202.

	*/
	ReturnTimeout *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the snapmirror object store endpoint delete params
func (o *SnapmirrorObjectStoreEndpointDeleteParams) WithTimeout(timeout time.Duration) *SnapmirrorObjectStoreEndpointDeleteParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the snapmirror object store endpoint delete params
func (o *SnapmirrorObjectStoreEndpointDeleteParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the snapmirror object store endpoint delete params
func (o *SnapmirrorObjectStoreEndpointDeleteParams) WithContext(ctx context.Context) *SnapmirrorObjectStoreEndpointDeleteParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the snapmirror object store endpoint delete params
func (o *SnapmirrorObjectStoreEndpointDeleteParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the snapmirror object store endpoint delete params
func (o *SnapmirrorObjectStoreEndpointDeleteParams) WithHTTPClient(client *http.Client) *SnapmirrorObjectStoreEndpointDeleteParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the snapmirror object store endpoint delete params
func (o *SnapmirrorObjectStoreEndpointDeleteParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithEndpointUUID adds the endpointUUID to the snapmirror object store endpoint delete params
func (o *SnapmirrorObjectStoreEndpointDeleteParams) WithEndpointUUID(endpointUUID string) *SnapmirrorObjectStoreEndpointDeleteParams {
	o.SetEndpointUUID(endpointUUID)
	return o
}

// SetEndpointUUID adds the endpointUuid to the snapmirror object store endpoint delete params
func (o *SnapmirrorObjectStoreEndpointDeleteParams) SetEndpointUUID(endpointUUID string) {
	o.EndpointUUID = endpointUUID
}

// WithObjectStoreUUID adds the objectStoreUUID to the snapmirror object store endpoint delete params
func (o *SnapmirrorObjectStoreEndpointDeleteParams) WithObjectStoreUUID(objectStoreUUID string) *SnapmirrorObjectStoreEndpointDeleteParams {
	o.SetObjectStoreUUID(objectStoreUUID)
	return o
}

// SetObjectStoreUUID adds the objectStoreUuid to the snapmirror object store endpoint delete params
func (o *SnapmirrorObjectStoreEndpointDeleteParams) SetObjectStoreUUID(objectStoreUUID string) {
	o.ObjectStoreUUID = objectStoreUUID
}

// WithReturnTimeout adds the returnTimeout to the snapmirror object store endpoint delete params
func (o *SnapmirrorObjectStoreEndpointDeleteParams) WithReturnTimeout(returnTimeout *int64) *SnapmirrorObjectStoreEndpointDeleteParams {
	o.SetReturnTimeout(returnTimeout)
	return o
}

// SetReturnTimeout adds the returnTimeout to the snapmirror object store endpoint delete params
func (o *SnapmirrorObjectStoreEndpointDeleteParams) SetReturnTimeout(returnTimeout *int64) {
	o.ReturnTimeout = returnTimeout
}

// WriteToRequest writes these params to a swagger request
func (o *SnapmirrorObjectStoreEndpointDeleteParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param endpointUUID
	if err := r.SetPathParam("endpointUUID", o.EndpointUUID); err != nil {
		return err
	}

	// path param objectStoreUUID
	if err := r.SetPathParam("objectStoreUUID", o.ObjectStoreUUID); err != nil {
		return err
	}

	if o.ReturnTimeout != nil {

		// query param return_timeout
		var qrReturnTimeout int64
		if o.ReturnTimeout != nil {
			qrReturnTimeout = *o.ReturnTimeout
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {
			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
