// Code generated by go-swagger; DO NOT EDIT.

package snapmirror

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/greenqloud/ontap-rest-client/ntapmodel"
)

// NewSnapmirrorPoliciesUUIDPatchParams creates a new SnapmirrorPoliciesUUIDPatchParams object
// with the default values initialized.
func NewSnapmirrorPoliciesUUIDPatchParams() *SnapmirrorPoliciesUUIDPatchParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &SnapmirrorPoliciesUUIDPatchParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewSnapmirrorPoliciesUUIDPatchParamsWithTimeout creates a new SnapmirrorPoliciesUUIDPatchParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewSnapmirrorPoliciesUUIDPatchParamsWithTimeout(timeout time.Duration) *SnapmirrorPoliciesUUIDPatchParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &SnapmirrorPoliciesUUIDPatchParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		timeout: timeout,
	}
}

// NewSnapmirrorPoliciesUUIDPatchParamsWithContext creates a new SnapmirrorPoliciesUUIDPatchParams object
// with the default values initialized, and the ability to set a context for a request
func NewSnapmirrorPoliciesUUIDPatchParamsWithContext(ctx context.Context) *SnapmirrorPoliciesUUIDPatchParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &SnapmirrorPoliciesUUIDPatchParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		Context: ctx,
	}
}

// NewSnapmirrorPoliciesUUIDPatchParamsWithHTTPClient creates a new SnapmirrorPoliciesUUIDPatchParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewSnapmirrorPoliciesUUIDPatchParamsWithHTTPClient(client *http.Client) *SnapmirrorPoliciesUUIDPatchParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &SnapmirrorPoliciesUUIDPatchParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,
		HTTPClient:    client,
	}
}

/*SnapmirrorPoliciesUUIDPatchParams contains all the parameters to send to the API endpoint
for the snapmirror policies uuid patch operation typically these are written to a http.Request
*/
type SnapmirrorPoliciesUUIDPatchParams struct {

	/*Fields
	  Specify the fields to return.

	*/
	Fields []string
	/*Info
	  snapmirror information.

	*/
	Info *ntapmodel.PolicyUUID
	/*ReturnRecords
	  The default is true for GET calls.  When set to false, only the number of records is returned.

	*/
	ReturnRecords *bool
	/*ReturnTimeout
	  The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	*/
	ReturnTimeout *int64
	/*UUID*/
	UUID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the snapmirror policies uuid patch params
func (o *SnapmirrorPoliciesUUIDPatchParams) WithTimeout(timeout time.Duration) *SnapmirrorPoliciesUUIDPatchParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the snapmirror policies uuid patch params
func (o *SnapmirrorPoliciesUUIDPatchParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the snapmirror policies uuid patch params
func (o *SnapmirrorPoliciesUUIDPatchParams) WithContext(ctx context.Context) *SnapmirrorPoliciesUUIDPatchParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the snapmirror policies uuid patch params
func (o *SnapmirrorPoliciesUUIDPatchParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the snapmirror policies uuid patch params
func (o *SnapmirrorPoliciesUUIDPatchParams) WithHTTPClient(client *http.Client) *SnapmirrorPoliciesUUIDPatchParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the snapmirror policies uuid patch params
func (o *SnapmirrorPoliciesUUIDPatchParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFields adds the fields to the snapmirror policies uuid patch params
func (o *SnapmirrorPoliciesUUIDPatchParams) WithFields(fields []string) *SnapmirrorPoliciesUUIDPatchParams {
	o.SetFields(fields)
	return o
}

// SetFields adds the fields to the snapmirror policies uuid patch params
func (o *SnapmirrorPoliciesUUIDPatchParams) SetFields(fields []string) {
	o.Fields = fields
}

// WithInfo adds the info to the snapmirror policies uuid patch params
func (o *SnapmirrorPoliciesUUIDPatchParams) WithInfo(info *ntapmodel.PolicyUUID) *SnapmirrorPoliciesUUIDPatchParams {
	o.SetInfo(info)
	return o
}

// SetInfo adds the info to the snapmirror policies uuid patch params
func (o *SnapmirrorPoliciesUUIDPatchParams) SetInfo(info *ntapmodel.PolicyUUID) {
	o.Info = info
}

// WithReturnRecords adds the returnRecords to the snapmirror policies uuid patch params
func (o *SnapmirrorPoliciesUUIDPatchParams) WithReturnRecords(returnRecords *bool) *SnapmirrorPoliciesUUIDPatchParams {
	o.SetReturnRecords(returnRecords)
	return o
}

// SetReturnRecords adds the returnRecords to the snapmirror policies uuid patch params
func (o *SnapmirrorPoliciesUUIDPatchParams) SetReturnRecords(returnRecords *bool) {
	o.ReturnRecords = returnRecords
}

// WithReturnTimeout adds the returnTimeout to the snapmirror policies uuid patch params
func (o *SnapmirrorPoliciesUUIDPatchParams) WithReturnTimeout(returnTimeout *int64) *SnapmirrorPoliciesUUIDPatchParams {
	o.SetReturnTimeout(returnTimeout)
	return o
}

// SetReturnTimeout adds the returnTimeout to the snapmirror policies uuid patch params
func (o *SnapmirrorPoliciesUUIDPatchParams) SetReturnTimeout(returnTimeout *int64) {
	o.ReturnTimeout = returnTimeout
}

// WithUUID adds the uuid to the snapmirror policies uuid patch params
func (o *SnapmirrorPoliciesUUIDPatchParams) WithUUID(uuid string) *SnapmirrorPoliciesUUIDPatchParams {
	o.SetUUID(uuid)
	return o
}

// SetUUID adds the uuid to the snapmirror policies uuid patch params
func (o *SnapmirrorPoliciesUUIDPatchParams) SetUUID(uuid string) {
	o.UUID = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *SnapmirrorPoliciesUUIDPatchParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	valuesFields := o.Fields

	joinedFields := swag.JoinByFormat(valuesFields, "csv")
	// query array param fields
	if err := r.SetQueryParam("fields", joinedFields...); err != nil {
		return err
	}

	if o.Info != nil {
		if err := r.SetBodyParam(o.Info); err != nil {
			return err
		}
	}

	if o.ReturnRecords != nil {

		// query param return_records
		var qrReturnRecords bool
		if o.ReturnRecords != nil {
			qrReturnRecords = *o.ReturnRecords
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {
			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}

	}

	if o.ReturnTimeout != nil {

		// query param return_timeout
		var qrReturnTimeout int64
		if o.ReturnTimeout != nil {
			qrReturnTimeout = *o.ReturnTimeout
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {
			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}

	}

	// path param uuid
	if err := r.SetPathParam("uuid", o.UUID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
