// Code generated by go-swagger; DO NOT EDIT.

package snapmirror

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/greenqloud/ontap-rest-client/ntapmodel"
)

// NewSnapmirrorRelationshipsTransfersPostParams creates a new SnapmirrorRelationshipsTransfersPostParams object
// with the default values initialized.
func NewSnapmirrorRelationshipsTransfersPostParams() *SnapmirrorRelationshipsTransfersPostParams {
	var (
		returnRecordsDefault = bool(false)
		returnTimeoutDefault = int64(0)
	)
	return &SnapmirrorRelationshipsTransfersPostParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewSnapmirrorRelationshipsTransfersPostParamsWithTimeout creates a new SnapmirrorRelationshipsTransfersPostParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewSnapmirrorRelationshipsTransfersPostParamsWithTimeout(timeout time.Duration) *SnapmirrorRelationshipsTransfersPostParams {
	var (
		returnRecordsDefault = bool(false)
		returnTimeoutDefault = int64(0)
	)
	return &SnapmirrorRelationshipsTransfersPostParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		timeout: timeout,
	}
}

// NewSnapmirrorRelationshipsTransfersPostParamsWithContext creates a new SnapmirrorRelationshipsTransfersPostParams object
// with the default values initialized, and the ability to set a context for a request
func NewSnapmirrorRelationshipsTransfersPostParamsWithContext(ctx context.Context) *SnapmirrorRelationshipsTransfersPostParams {
	var (
		returnRecordsDefault = bool(false)
		returnTimeoutDefault = int64(0)
	)
	return &SnapmirrorRelationshipsTransfersPostParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		Context: ctx,
	}
}

// NewSnapmirrorRelationshipsTransfersPostParamsWithHTTPClient creates a new SnapmirrorRelationshipsTransfersPostParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewSnapmirrorRelationshipsTransfersPostParamsWithHTTPClient(client *http.Client) *SnapmirrorRelationshipsTransfersPostParams {
	var (
		returnRecordsDefault = bool(false)
		returnTimeoutDefault = int64(0)
	)
	return &SnapmirrorRelationshipsTransfersPostParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,
		HTTPClient:    client,
	}
}

/*SnapmirrorRelationshipsTransfersPostParams contains all the parameters to send to the API endpoint
for the snapmirror relationships transfers post operation typically these are written to a http.Request
*/
type SnapmirrorRelationshipsTransfersPostParams struct {

	/*Fields
	  Specify the fields to return.

	*/
	Fields []string
	/*Info
	  snapmirror information.

	*/
	Info *ntapmodel.PublicSnapmirrorTransfers
	/*ReturnRecords
	  The default is false.  If set to true, the records are returned.

	*/
	ReturnRecords *bool
	/*ReturnTimeout
	  The number of seconds to allow the call to execute before returning. When doing a POST, PATCH, or DELETE operation on a single record, the default is 0 seconds.  This means that if an asynchronous operation is started, the server immediately returns HTTP code 202 (Accepted) along with a link to the job.  If a non-zero value is specified for POST, PATCH, or DELETE operations, ONTAP waits that length of time to see if the job completes so it can return something other than 202.

	*/
	ReturnTimeout *int64
	/*UUID*/
	UUID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the snapmirror relationships transfers post params
func (o *SnapmirrorRelationshipsTransfersPostParams) WithTimeout(timeout time.Duration) *SnapmirrorRelationshipsTransfersPostParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the snapmirror relationships transfers post params
func (o *SnapmirrorRelationshipsTransfersPostParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the snapmirror relationships transfers post params
func (o *SnapmirrorRelationshipsTransfersPostParams) WithContext(ctx context.Context) *SnapmirrorRelationshipsTransfersPostParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the snapmirror relationships transfers post params
func (o *SnapmirrorRelationshipsTransfersPostParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the snapmirror relationships transfers post params
func (o *SnapmirrorRelationshipsTransfersPostParams) WithHTTPClient(client *http.Client) *SnapmirrorRelationshipsTransfersPostParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the snapmirror relationships transfers post params
func (o *SnapmirrorRelationshipsTransfersPostParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFields adds the fields to the snapmirror relationships transfers post params
func (o *SnapmirrorRelationshipsTransfersPostParams) WithFields(fields []string) *SnapmirrorRelationshipsTransfersPostParams {
	o.SetFields(fields)
	return o
}

// SetFields adds the fields to the snapmirror relationships transfers post params
func (o *SnapmirrorRelationshipsTransfersPostParams) SetFields(fields []string) {
	o.Fields = fields
}

// WithInfo adds the info to the snapmirror relationships transfers post params
func (o *SnapmirrorRelationshipsTransfersPostParams) WithInfo(info *ntapmodel.PublicSnapmirrorTransfers) *SnapmirrorRelationshipsTransfersPostParams {
	o.SetInfo(info)
	return o
}

// SetInfo adds the info to the snapmirror relationships transfers post params
func (o *SnapmirrorRelationshipsTransfersPostParams) SetInfo(info *ntapmodel.PublicSnapmirrorTransfers) {
	o.Info = info
}

// WithReturnRecords adds the returnRecords to the snapmirror relationships transfers post params
func (o *SnapmirrorRelationshipsTransfersPostParams) WithReturnRecords(returnRecords *bool) *SnapmirrorRelationshipsTransfersPostParams {
	o.SetReturnRecords(returnRecords)
	return o
}

// SetReturnRecords adds the returnRecords to the snapmirror relationships transfers post params
func (o *SnapmirrorRelationshipsTransfersPostParams) SetReturnRecords(returnRecords *bool) {
	o.ReturnRecords = returnRecords
}

// WithReturnTimeout adds the returnTimeout to the snapmirror relationships transfers post params
func (o *SnapmirrorRelationshipsTransfersPostParams) WithReturnTimeout(returnTimeout *int64) *SnapmirrorRelationshipsTransfersPostParams {
	o.SetReturnTimeout(returnTimeout)
	return o
}

// SetReturnTimeout adds the returnTimeout to the snapmirror relationships transfers post params
func (o *SnapmirrorRelationshipsTransfersPostParams) SetReturnTimeout(returnTimeout *int64) {
	o.ReturnTimeout = returnTimeout
}

// WithUUID adds the uuid to the snapmirror relationships transfers post params
func (o *SnapmirrorRelationshipsTransfersPostParams) WithUUID(uuid string) *SnapmirrorRelationshipsTransfersPostParams {
	o.SetUUID(uuid)
	return o
}

// SetUUID adds the uuid to the snapmirror relationships transfers post params
func (o *SnapmirrorRelationshipsTransfersPostParams) SetUUID(uuid string) {
	o.UUID = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *SnapmirrorRelationshipsTransfersPostParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	valuesFields := o.Fields

	joinedFields := swag.JoinByFormat(valuesFields, "csv")
	// query array param fields
	if err := r.SetQueryParam("fields", joinedFields...); err != nil {
		return err
	}

	if o.Info != nil {
		if err := r.SetBodyParam(o.Info); err != nil {
			return err
		}
	}

	if o.ReturnRecords != nil {

		// query param return_records
		var qrReturnRecords bool
		if o.ReturnRecords != nil {
			qrReturnRecords = *o.ReturnRecords
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {
			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}

	}

	if o.ReturnTimeout != nil {

		// query param return_timeout
		var qrReturnTimeout int64
		if o.ReturnTimeout != nil {
			qrReturnTimeout = *o.ReturnTimeout
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {
			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}

	}

	// path param uuid
	if err := r.SetPathParam("uuid", o.UUID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
