// Code generated by go-swagger; DO NOT EDIT.

package snapmirror

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/greenqloud/ontap-rest-client/ntapmodel"
)

// NewSnapmirrorRelationshipsTransfersUUIDPatchParams creates a new SnapmirrorRelationshipsTransfersUUIDPatchParams object
// with the default values initialized.
func NewSnapmirrorRelationshipsTransfersUUIDPatchParams() *SnapmirrorRelationshipsTransfersUUIDPatchParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &SnapmirrorRelationshipsTransfersUUIDPatchParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewSnapmirrorRelationshipsTransfersUUIDPatchParamsWithTimeout creates a new SnapmirrorRelationshipsTransfersUUIDPatchParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewSnapmirrorRelationshipsTransfersUUIDPatchParamsWithTimeout(timeout time.Duration) *SnapmirrorRelationshipsTransfersUUIDPatchParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &SnapmirrorRelationshipsTransfersUUIDPatchParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		timeout: timeout,
	}
}

// NewSnapmirrorRelationshipsTransfersUUIDPatchParamsWithContext creates a new SnapmirrorRelationshipsTransfersUUIDPatchParams object
// with the default values initialized, and the ability to set a context for a request
func NewSnapmirrorRelationshipsTransfersUUIDPatchParamsWithContext(ctx context.Context) *SnapmirrorRelationshipsTransfersUUIDPatchParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &SnapmirrorRelationshipsTransfersUUIDPatchParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		Context: ctx,
	}
}

// NewSnapmirrorRelationshipsTransfersUUIDPatchParamsWithHTTPClient creates a new SnapmirrorRelationshipsTransfersUUIDPatchParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewSnapmirrorRelationshipsTransfersUUIDPatchParamsWithHTTPClient(client *http.Client) *SnapmirrorRelationshipsTransfersUUIDPatchParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &SnapmirrorRelationshipsTransfersUUIDPatchParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,
		HTTPClient:    client,
	}
}

/*SnapmirrorRelationshipsTransfersUUIDPatchParams contains all the parameters to send to the API endpoint
for the snapmirror relationships transfers uuid patch operation typically these are written to a http.Request
*/
type SnapmirrorRelationshipsTransfersUUIDPatchParams struct {

	/*Fields
	  Specify the fields to return.

	*/
	Fields []string
	/*Info
	  snapmirror transfer information.

	*/
	Info *ntapmodel.PublicSnapmirrorTransfersUUID
	/*ReturnRecords
	  The default is true for GET calls.  When set to false, only the number of records is returned.

	*/
	ReturnRecords *bool
	/*ReturnTimeout
	  The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	*/
	ReturnTimeout *int64
	/*Uuid1*/
	Uuid1 string
	/*Uuid2*/
	Uuid2 string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the snapmirror relationships transfers uuid patch params
func (o *SnapmirrorRelationshipsTransfersUUIDPatchParams) WithTimeout(timeout time.Duration) *SnapmirrorRelationshipsTransfersUUIDPatchParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the snapmirror relationships transfers uuid patch params
func (o *SnapmirrorRelationshipsTransfersUUIDPatchParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the snapmirror relationships transfers uuid patch params
func (o *SnapmirrorRelationshipsTransfersUUIDPatchParams) WithContext(ctx context.Context) *SnapmirrorRelationshipsTransfersUUIDPatchParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the snapmirror relationships transfers uuid patch params
func (o *SnapmirrorRelationshipsTransfersUUIDPatchParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the snapmirror relationships transfers uuid patch params
func (o *SnapmirrorRelationshipsTransfersUUIDPatchParams) WithHTTPClient(client *http.Client) *SnapmirrorRelationshipsTransfersUUIDPatchParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the snapmirror relationships transfers uuid patch params
func (o *SnapmirrorRelationshipsTransfersUUIDPatchParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFields adds the fields to the snapmirror relationships transfers uuid patch params
func (o *SnapmirrorRelationshipsTransfersUUIDPatchParams) WithFields(fields []string) *SnapmirrorRelationshipsTransfersUUIDPatchParams {
	o.SetFields(fields)
	return o
}

// SetFields adds the fields to the snapmirror relationships transfers uuid patch params
func (o *SnapmirrorRelationshipsTransfersUUIDPatchParams) SetFields(fields []string) {
	o.Fields = fields
}

// WithInfo adds the info to the snapmirror relationships transfers uuid patch params
func (o *SnapmirrorRelationshipsTransfersUUIDPatchParams) WithInfo(info *ntapmodel.PublicSnapmirrorTransfersUUID) *SnapmirrorRelationshipsTransfersUUIDPatchParams {
	o.SetInfo(info)
	return o
}

// SetInfo adds the info to the snapmirror relationships transfers uuid patch params
func (o *SnapmirrorRelationshipsTransfersUUIDPatchParams) SetInfo(info *ntapmodel.PublicSnapmirrorTransfersUUID) {
	o.Info = info
}

// WithReturnRecords adds the returnRecords to the snapmirror relationships transfers uuid patch params
func (o *SnapmirrorRelationshipsTransfersUUIDPatchParams) WithReturnRecords(returnRecords *bool) *SnapmirrorRelationshipsTransfersUUIDPatchParams {
	o.SetReturnRecords(returnRecords)
	return o
}

// SetReturnRecords adds the returnRecords to the snapmirror relationships transfers uuid patch params
func (o *SnapmirrorRelationshipsTransfersUUIDPatchParams) SetReturnRecords(returnRecords *bool) {
	o.ReturnRecords = returnRecords
}

// WithReturnTimeout adds the returnTimeout to the snapmirror relationships transfers uuid patch params
func (o *SnapmirrorRelationshipsTransfersUUIDPatchParams) WithReturnTimeout(returnTimeout *int64) *SnapmirrorRelationshipsTransfersUUIDPatchParams {
	o.SetReturnTimeout(returnTimeout)
	return o
}

// SetReturnTimeout adds the returnTimeout to the snapmirror relationships transfers uuid patch params
func (o *SnapmirrorRelationshipsTransfersUUIDPatchParams) SetReturnTimeout(returnTimeout *int64) {
	o.ReturnTimeout = returnTimeout
}

// WithUuid1 adds the uuid1 to the snapmirror relationships transfers uuid patch params
func (o *SnapmirrorRelationshipsTransfersUUIDPatchParams) WithUuid1(uuid1 string) *SnapmirrorRelationshipsTransfersUUIDPatchParams {
	o.SetUuid1(uuid1)
	return o
}

// SetUuid1 adds the uuid1 to the snapmirror relationships transfers uuid patch params
func (o *SnapmirrorRelationshipsTransfersUUIDPatchParams) SetUuid1(uuid1 string) {
	o.Uuid1 = uuid1
}

// WithUuid2 adds the uuid2 to the snapmirror relationships transfers uuid patch params
func (o *SnapmirrorRelationshipsTransfersUUIDPatchParams) WithUuid2(uuid2 string) *SnapmirrorRelationshipsTransfersUUIDPatchParams {
	o.SetUuid2(uuid2)
	return o
}

// SetUuid2 adds the uuid2 to the snapmirror relationships transfers uuid patch params
func (o *SnapmirrorRelationshipsTransfersUUIDPatchParams) SetUuid2(uuid2 string) {
	o.Uuid2 = uuid2
}

// WriteToRequest writes these params to a swagger request
func (o *SnapmirrorRelationshipsTransfersUUIDPatchParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	valuesFields := o.Fields

	joinedFields := swag.JoinByFormat(valuesFields, "csv")
	// query array param fields
	if err := r.SetQueryParam("fields", joinedFields...); err != nil {
		return err
	}

	if o.Info != nil {
		if err := r.SetBodyParam(o.Info); err != nil {
			return err
		}
	}

	if o.ReturnRecords != nil {

		// query param return_records
		var qrReturnRecords bool
		if o.ReturnRecords != nil {
			qrReturnRecords = *o.ReturnRecords
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {
			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}

	}

	if o.ReturnTimeout != nil {

		// query param return_timeout
		var qrReturnTimeout int64
		if o.ReturnTimeout != nil {
			qrReturnTimeout = *o.ReturnTimeout
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {
			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}

	}

	// path param uuid1
	if err := r.SetPathParam("uuid1", o.Uuid1); err != nil {
		return err
	}

	// path param uuid2
	if err := r.SetPathParam("uuid2", o.Uuid2); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
