// Code generated by go-swagger; DO NOT EDIT.

package storage

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewAggregateCollectionGetParams creates a new AggregateCollectionGetParams object
// with the default values initialized.
func NewAggregateCollectionGetParams() *AggregateCollectionGetParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &AggregateCollectionGetParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewAggregateCollectionGetParamsWithTimeout creates a new AggregateCollectionGetParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewAggregateCollectionGetParamsWithTimeout(timeout time.Duration) *AggregateCollectionGetParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &AggregateCollectionGetParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		timeout: timeout,
	}
}

// NewAggregateCollectionGetParamsWithContext creates a new AggregateCollectionGetParams object
// with the default values initialized, and the ability to set a context for a request
func NewAggregateCollectionGetParamsWithContext(ctx context.Context) *AggregateCollectionGetParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &AggregateCollectionGetParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		Context: ctx,
	}
}

// NewAggregateCollectionGetParamsWithHTTPClient creates a new AggregateCollectionGetParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewAggregateCollectionGetParamsWithHTTPClient(client *http.Client) *AggregateCollectionGetParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &AggregateCollectionGetParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,
		HTTPClient:    client,
	}
}

/*AggregateCollectionGetParams contains all the parameters to send to the API endpoint
for the aggregate collection get operation typically these are written to a http.Request
*/
type AggregateCollectionGetParams struct {

	/*BlockStorageHybridCacheDiskCount
	  Filter by block_storage.hybrid_cache.disk_count

	*/
	BlockStorageHybridCacheDiskCount *int64
	/*BlockStorageHybridCacheEnabled
	  Filter by block_storage.hybrid_cache.enabled

	*/
	BlockStorageHybridCacheEnabled *bool
	/*BlockStorageHybridCacheRaidType
	  Filter by block_storage.hybrid_cache.raid_type

	*/
	BlockStorageHybridCacheRaidType *string
	/*BlockStorageHybridCacheSize
	  Filter by block_storage.hybrid_cache.size

	*/
	BlockStorageHybridCacheSize *int64
	/*BlockStorageHybridCacheUsed
	  Filter by block_storage.hybrid_cache.used

	*/
	BlockStorageHybridCacheUsed *int64
	/*BlockStorageMirrorEnabled
	  Filter by block_storage.mirror.enabled

	*/
	BlockStorageMirrorEnabled *bool
	/*BlockStorageMirrorState
	  Filter by block_storage.mirror.state

	*/
	BlockStorageMirrorState *string
	/*BlockStoragePlexesName
	  Filter by block_storage.plexes.name

	*/
	BlockStoragePlexesName *string
	/*BlockStoragePrimaryChecksumStyle
	  Filter by block_storage.primary.checksum_style

	*/
	BlockStoragePrimaryChecksumStyle *string
	/*BlockStoragePrimaryDiskClass
	  Filter by block_storage.primary.disk_class

	*/
	BlockStoragePrimaryDiskClass *string
	/*BlockStoragePrimaryDiskCount
	  Filter by block_storage.primary.disk_count

	*/
	BlockStoragePrimaryDiskCount *int64
	/*BlockStoragePrimaryDiskType
	  Filter by block_storage.primary.disk_type

	*/
	BlockStoragePrimaryDiskType *string
	/*BlockStoragePrimaryRaidSize
	  Filter by block_storage.primary.raid_size

	*/
	BlockStoragePrimaryRaidSize *int64
	/*BlockStoragePrimaryRaidType
	  Filter by block_storage.primary.raid_type

	*/
	BlockStoragePrimaryRaidType *string
	/*CreateTime
	  Filter by create_time

	*/
	CreateTime *string
	/*DataEncryptionDriveProtectionEnabled
	  Filter by data_encryption.drive_protection_enabled

	*/
	DataEncryptionDriveProtectionEnabled *bool
	/*DataEncryptionSoftwareEncryptionEnabled
	  Filter by data_encryption.software_encryption_enabled

	*/
	DataEncryptionSoftwareEncryptionEnabled *bool
	/*DrHomeNodeName
	  Filter by dr_home_node.name

	*/
	DrHomeNodeName *string
	/*DrHomeNodeUUID
	  Filter by dr_home_node.uuid

	*/
	DrHomeNodeUUID *string
	/*Fields
	  Specify the fields to return.

	*/
	Fields []string
	/*HomeNodeName
	  Filter by home_node.name

	*/
	HomeNodeName *string
	/*HomeNodeUUID
	  Filter by home_node.uuid

	*/
	HomeNodeUUID *string
	/*MaxRecords
	  Limit the number of records returned.

	*/
	MaxRecords *int64
	/*MetricDuration
	  Filter by metric.duration

	*/
	MetricDuration *string
	/*MetricIopsOther
	  Filter by metric.iops.other

	*/
	MetricIopsOther *int64
	/*MetricIopsRead
	  Filter by metric.iops.read

	*/
	MetricIopsRead *int64
	/*MetricIopsTotal
	  Filter by metric.iops.total

	*/
	MetricIopsTotal *int64
	/*MetricIopsWrite
	  Filter by metric.iops.write

	*/
	MetricIopsWrite *int64
	/*MetricLatencyOther
	  Filter by metric.latency.other

	*/
	MetricLatencyOther *int64
	/*MetricLatencyRead
	  Filter by metric.latency.read

	*/
	MetricLatencyRead *int64
	/*MetricLatencyTotal
	  Filter by metric.latency.total

	*/
	MetricLatencyTotal *int64
	/*MetricLatencyWrite
	  Filter by metric.latency.write

	*/
	MetricLatencyWrite *int64
	/*MetricStatus
	  Filter by metric.status

	*/
	MetricStatus *string
	/*MetricThroughputOther
	  Filter by metric.throughput.other

	*/
	MetricThroughputOther *int64
	/*MetricThroughputRead
	  Filter by metric.throughput.read

	*/
	MetricThroughputRead *int64
	/*MetricThroughputTotal
	  Filter by metric.throughput.total

	*/
	MetricThroughputTotal *int64
	/*MetricThroughputWrite
	  Filter by metric.throughput.write

	*/
	MetricThroughputWrite *int64
	/*MetricTimestamp
	  Filter by metric.timestamp

	*/
	MetricTimestamp *string
	/*Name
	  Filter by name

	*/
	Name *string
	/*NodeName
	  Filter by node.name

	*/
	NodeName *string
	/*NodeUUID
	  Filter by node.uuid

	*/
	NodeUUID *string
	/*OrderBy
	  Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.

	*/
	OrderBy []string
	/*Recommend
	  If set to 'true', it queries the system for the recommended optimal layout for creating new aggregates. The default setting is 'false'.

	*/
	Recommend *bool
	/*ReturnRecords
	  The default is true for GET calls.  When set to false, only the number of records is returned.

	*/
	ReturnRecords *bool
	/*ReturnTimeout
	  The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	*/
	ReturnTimeout *int64
	/*ShowSpares
	  If set to 'true', the spares object is returned instead of records to show the spare groups in the cluster. The default setting is 'false'.

	*/
	ShowSpares *bool
	/*SnaplockType
	  Filter by snaplock_type

	*/
	SnaplockType *string
	/*SpaceBlockStorageAvailable
	  Filter by space.block_storage.available

	*/
	SpaceBlockStorageAvailable *int64
	/*SpaceBlockStorageFullThresholdPercent
	  Filter by space.block_storage.full_threshold_percent

	*/
	SpaceBlockStorageFullThresholdPercent *int64
	/*SpaceBlockStorageInactiveUserData
	  Filter by space.block_storage.inactive_user_data

	*/
	SpaceBlockStorageInactiveUserData *int64
	/*SpaceBlockStorageSize
	  Filter by space.block_storage.size

	*/
	SpaceBlockStorageSize *int64
	/*SpaceBlockStorageUsed
	  Filter by space.block_storage.used

	*/
	SpaceBlockStorageUsed *int64
	/*SpaceCloudStorageUsed
	  Filter by space.cloud_storage.used

	*/
	SpaceCloudStorageUsed *int64
	/*SpaceEfficiencyLogicalUsed
	  Filter by space.efficiency.logical_used

	*/
	SpaceEfficiencyLogicalUsed *int64
	/*SpaceEfficiencyRatio
	  Filter by space.efficiency.ratio

	*/
	SpaceEfficiencyRatio *float64
	/*SpaceEfficiencySavings
	  Filter by space.efficiency.savings

	*/
	SpaceEfficiencySavings *int64
	/*SpaceEfficiencyWithoutSnapshotsLogicalUsed
	  Filter by space.efficiency_without_snapshots.logical_used

	*/
	SpaceEfficiencyWithoutSnapshotsLogicalUsed *int64
	/*SpaceEfficiencyWithoutSnapshotsRatio
	  Filter by space.efficiency_without_snapshots.ratio

	*/
	SpaceEfficiencyWithoutSnapshotsRatio *float64
	/*SpaceEfficiencyWithoutSnapshotsSavings
	  Filter by space.efficiency_without_snapshots.savings

	*/
	SpaceEfficiencyWithoutSnapshotsSavings *int64
	/*SpaceFootprint
	  Filter by space.footprint

	*/
	SpaceFootprint *int64
	/*State
	  Filter by state

	*/
	State *string
	/*StatisticsIopsRawOther
	  Filter by statistics.iops_raw.other

	*/
	StatisticsIopsRawOther *int64
	/*StatisticsIopsRawRead
	  Filter by statistics.iops_raw.read

	*/
	StatisticsIopsRawRead *int64
	/*StatisticsIopsRawTotal
	  Filter by statistics.iops_raw.total

	*/
	StatisticsIopsRawTotal *int64
	/*StatisticsIopsRawWrite
	  Filter by statistics.iops_raw.write

	*/
	StatisticsIopsRawWrite *int64
	/*StatisticsLatencyRawOther
	  Filter by statistics.latency_raw.other

	*/
	StatisticsLatencyRawOther *int64
	/*StatisticsLatencyRawRead
	  Filter by statistics.latency_raw.read

	*/
	StatisticsLatencyRawRead *int64
	/*StatisticsLatencyRawTotal
	  Filter by statistics.latency_raw.total

	*/
	StatisticsLatencyRawTotal *int64
	/*StatisticsLatencyRawWrite
	  Filter by statistics.latency_raw.write

	*/
	StatisticsLatencyRawWrite *int64
	/*StatisticsStatus
	  Filter by statistics.status

	*/
	StatisticsStatus *string
	/*StatisticsThroughputRawOther
	  Filter by statistics.throughput_raw.other

	*/
	StatisticsThroughputRawOther *int64
	/*StatisticsThroughputRawRead
	  Filter by statistics.throughput_raw.read

	*/
	StatisticsThroughputRawRead *int64
	/*StatisticsThroughputRawTotal
	  Filter by statistics.throughput_raw.total

	*/
	StatisticsThroughputRawTotal *int64
	/*StatisticsThroughputRawWrite
	  Filter by statistics.throughput_raw.write

	*/
	StatisticsThroughputRawWrite *int64
	/*StatisticsTimestamp
	  Filter by statistics.timestamp

	*/
	StatisticsTimestamp *string
	/*UUID
	  Filter by uuid

	*/
	UUID *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithTimeout(timeout time.Duration) *AggregateCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithContext(ctx context.Context) *AggregateCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithHTTPClient(client *http.Client) *AggregateCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBlockStorageHybridCacheDiskCount adds the blockStorageHybridCacheDiskCount to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithBlockStorageHybridCacheDiskCount(blockStorageHybridCacheDiskCount *int64) *AggregateCollectionGetParams {
	o.SetBlockStorageHybridCacheDiskCount(blockStorageHybridCacheDiskCount)
	return o
}

// SetBlockStorageHybridCacheDiskCount adds the blockStorageHybridCacheDiskCount to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetBlockStorageHybridCacheDiskCount(blockStorageHybridCacheDiskCount *int64) {
	o.BlockStorageHybridCacheDiskCount = blockStorageHybridCacheDiskCount
}

// WithBlockStorageHybridCacheEnabled adds the blockStorageHybridCacheEnabled to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithBlockStorageHybridCacheEnabled(blockStorageHybridCacheEnabled *bool) *AggregateCollectionGetParams {
	o.SetBlockStorageHybridCacheEnabled(blockStorageHybridCacheEnabled)
	return o
}

// SetBlockStorageHybridCacheEnabled adds the blockStorageHybridCacheEnabled to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetBlockStorageHybridCacheEnabled(blockStorageHybridCacheEnabled *bool) {
	o.BlockStorageHybridCacheEnabled = blockStorageHybridCacheEnabled
}

// WithBlockStorageHybridCacheRaidType adds the blockStorageHybridCacheRaidType to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithBlockStorageHybridCacheRaidType(blockStorageHybridCacheRaidType *string) *AggregateCollectionGetParams {
	o.SetBlockStorageHybridCacheRaidType(blockStorageHybridCacheRaidType)
	return o
}

// SetBlockStorageHybridCacheRaidType adds the blockStorageHybridCacheRaidType to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetBlockStorageHybridCacheRaidType(blockStorageHybridCacheRaidType *string) {
	o.BlockStorageHybridCacheRaidType = blockStorageHybridCacheRaidType
}

// WithBlockStorageHybridCacheSize adds the blockStorageHybridCacheSize to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithBlockStorageHybridCacheSize(blockStorageHybridCacheSize *int64) *AggregateCollectionGetParams {
	o.SetBlockStorageHybridCacheSize(blockStorageHybridCacheSize)
	return o
}

// SetBlockStorageHybridCacheSize adds the blockStorageHybridCacheSize to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetBlockStorageHybridCacheSize(blockStorageHybridCacheSize *int64) {
	o.BlockStorageHybridCacheSize = blockStorageHybridCacheSize
}

// WithBlockStorageHybridCacheUsed adds the blockStorageHybridCacheUsed to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithBlockStorageHybridCacheUsed(blockStorageHybridCacheUsed *int64) *AggregateCollectionGetParams {
	o.SetBlockStorageHybridCacheUsed(blockStorageHybridCacheUsed)
	return o
}

// SetBlockStorageHybridCacheUsed adds the blockStorageHybridCacheUsed to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetBlockStorageHybridCacheUsed(blockStorageHybridCacheUsed *int64) {
	o.BlockStorageHybridCacheUsed = blockStorageHybridCacheUsed
}

// WithBlockStorageMirrorEnabled adds the blockStorageMirrorEnabled to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithBlockStorageMirrorEnabled(blockStorageMirrorEnabled *bool) *AggregateCollectionGetParams {
	o.SetBlockStorageMirrorEnabled(blockStorageMirrorEnabled)
	return o
}

// SetBlockStorageMirrorEnabled adds the blockStorageMirrorEnabled to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetBlockStorageMirrorEnabled(blockStorageMirrorEnabled *bool) {
	o.BlockStorageMirrorEnabled = blockStorageMirrorEnabled
}

// WithBlockStorageMirrorState adds the blockStorageMirrorState to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithBlockStorageMirrorState(blockStorageMirrorState *string) *AggregateCollectionGetParams {
	o.SetBlockStorageMirrorState(blockStorageMirrorState)
	return o
}

// SetBlockStorageMirrorState adds the blockStorageMirrorState to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetBlockStorageMirrorState(blockStorageMirrorState *string) {
	o.BlockStorageMirrorState = blockStorageMirrorState
}

// WithBlockStoragePlexesName adds the blockStoragePlexesName to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithBlockStoragePlexesName(blockStoragePlexesName *string) *AggregateCollectionGetParams {
	o.SetBlockStoragePlexesName(blockStoragePlexesName)
	return o
}

// SetBlockStoragePlexesName adds the blockStoragePlexesName to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetBlockStoragePlexesName(blockStoragePlexesName *string) {
	o.BlockStoragePlexesName = blockStoragePlexesName
}

// WithBlockStoragePrimaryChecksumStyle adds the blockStoragePrimaryChecksumStyle to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithBlockStoragePrimaryChecksumStyle(blockStoragePrimaryChecksumStyle *string) *AggregateCollectionGetParams {
	o.SetBlockStoragePrimaryChecksumStyle(blockStoragePrimaryChecksumStyle)
	return o
}

// SetBlockStoragePrimaryChecksumStyle adds the blockStoragePrimaryChecksumStyle to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetBlockStoragePrimaryChecksumStyle(blockStoragePrimaryChecksumStyle *string) {
	o.BlockStoragePrimaryChecksumStyle = blockStoragePrimaryChecksumStyle
}

// WithBlockStoragePrimaryDiskClass adds the blockStoragePrimaryDiskClass to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithBlockStoragePrimaryDiskClass(blockStoragePrimaryDiskClass *string) *AggregateCollectionGetParams {
	o.SetBlockStoragePrimaryDiskClass(blockStoragePrimaryDiskClass)
	return o
}

// SetBlockStoragePrimaryDiskClass adds the blockStoragePrimaryDiskClass to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetBlockStoragePrimaryDiskClass(blockStoragePrimaryDiskClass *string) {
	o.BlockStoragePrimaryDiskClass = blockStoragePrimaryDiskClass
}

// WithBlockStoragePrimaryDiskCount adds the blockStoragePrimaryDiskCount to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithBlockStoragePrimaryDiskCount(blockStoragePrimaryDiskCount *int64) *AggregateCollectionGetParams {
	o.SetBlockStoragePrimaryDiskCount(blockStoragePrimaryDiskCount)
	return o
}

// SetBlockStoragePrimaryDiskCount adds the blockStoragePrimaryDiskCount to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetBlockStoragePrimaryDiskCount(blockStoragePrimaryDiskCount *int64) {
	o.BlockStoragePrimaryDiskCount = blockStoragePrimaryDiskCount
}

// WithBlockStoragePrimaryDiskType adds the blockStoragePrimaryDiskType to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithBlockStoragePrimaryDiskType(blockStoragePrimaryDiskType *string) *AggregateCollectionGetParams {
	o.SetBlockStoragePrimaryDiskType(blockStoragePrimaryDiskType)
	return o
}

// SetBlockStoragePrimaryDiskType adds the blockStoragePrimaryDiskType to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetBlockStoragePrimaryDiskType(blockStoragePrimaryDiskType *string) {
	o.BlockStoragePrimaryDiskType = blockStoragePrimaryDiskType
}

// WithBlockStoragePrimaryRaidSize adds the blockStoragePrimaryRaidSize to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithBlockStoragePrimaryRaidSize(blockStoragePrimaryRaidSize *int64) *AggregateCollectionGetParams {
	o.SetBlockStoragePrimaryRaidSize(blockStoragePrimaryRaidSize)
	return o
}

// SetBlockStoragePrimaryRaidSize adds the blockStoragePrimaryRaidSize to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetBlockStoragePrimaryRaidSize(blockStoragePrimaryRaidSize *int64) {
	o.BlockStoragePrimaryRaidSize = blockStoragePrimaryRaidSize
}

// WithBlockStoragePrimaryRaidType adds the blockStoragePrimaryRaidType to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithBlockStoragePrimaryRaidType(blockStoragePrimaryRaidType *string) *AggregateCollectionGetParams {
	o.SetBlockStoragePrimaryRaidType(blockStoragePrimaryRaidType)
	return o
}

// SetBlockStoragePrimaryRaidType adds the blockStoragePrimaryRaidType to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetBlockStoragePrimaryRaidType(blockStoragePrimaryRaidType *string) {
	o.BlockStoragePrimaryRaidType = blockStoragePrimaryRaidType
}

// WithCreateTime adds the createTime to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithCreateTime(createTime *string) *AggregateCollectionGetParams {
	o.SetCreateTime(createTime)
	return o
}

// SetCreateTime adds the createTime to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetCreateTime(createTime *string) {
	o.CreateTime = createTime
}

// WithDataEncryptionDriveProtectionEnabled adds the dataEncryptionDriveProtectionEnabled to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithDataEncryptionDriveProtectionEnabled(dataEncryptionDriveProtectionEnabled *bool) *AggregateCollectionGetParams {
	o.SetDataEncryptionDriveProtectionEnabled(dataEncryptionDriveProtectionEnabled)
	return o
}

// SetDataEncryptionDriveProtectionEnabled adds the dataEncryptionDriveProtectionEnabled to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetDataEncryptionDriveProtectionEnabled(dataEncryptionDriveProtectionEnabled *bool) {
	o.DataEncryptionDriveProtectionEnabled = dataEncryptionDriveProtectionEnabled
}

// WithDataEncryptionSoftwareEncryptionEnabled adds the dataEncryptionSoftwareEncryptionEnabled to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithDataEncryptionSoftwareEncryptionEnabled(dataEncryptionSoftwareEncryptionEnabled *bool) *AggregateCollectionGetParams {
	o.SetDataEncryptionSoftwareEncryptionEnabled(dataEncryptionSoftwareEncryptionEnabled)
	return o
}

// SetDataEncryptionSoftwareEncryptionEnabled adds the dataEncryptionSoftwareEncryptionEnabled to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetDataEncryptionSoftwareEncryptionEnabled(dataEncryptionSoftwareEncryptionEnabled *bool) {
	o.DataEncryptionSoftwareEncryptionEnabled = dataEncryptionSoftwareEncryptionEnabled
}

// WithDrHomeNodeName adds the drHomeNodeName to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithDrHomeNodeName(drHomeNodeName *string) *AggregateCollectionGetParams {
	o.SetDrHomeNodeName(drHomeNodeName)
	return o
}

// SetDrHomeNodeName adds the drHomeNodeName to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetDrHomeNodeName(drHomeNodeName *string) {
	o.DrHomeNodeName = drHomeNodeName
}

// WithDrHomeNodeUUID adds the drHomeNodeUUID to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithDrHomeNodeUUID(drHomeNodeUUID *string) *AggregateCollectionGetParams {
	o.SetDrHomeNodeUUID(drHomeNodeUUID)
	return o
}

// SetDrHomeNodeUUID adds the drHomeNodeUuid to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetDrHomeNodeUUID(drHomeNodeUUID *string) {
	o.DrHomeNodeUUID = drHomeNodeUUID
}

// WithFields adds the fields to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithFields(fields []string) *AggregateCollectionGetParams {
	o.SetFields(fields)
	return o
}

// SetFields adds the fields to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetFields(fields []string) {
	o.Fields = fields
}

// WithHomeNodeName adds the homeNodeName to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithHomeNodeName(homeNodeName *string) *AggregateCollectionGetParams {
	o.SetHomeNodeName(homeNodeName)
	return o
}

// SetHomeNodeName adds the homeNodeName to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetHomeNodeName(homeNodeName *string) {
	o.HomeNodeName = homeNodeName
}

// WithHomeNodeUUID adds the homeNodeUUID to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithHomeNodeUUID(homeNodeUUID *string) *AggregateCollectionGetParams {
	o.SetHomeNodeUUID(homeNodeUUID)
	return o
}

// SetHomeNodeUUID adds the homeNodeUuid to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetHomeNodeUUID(homeNodeUUID *string) {
	o.HomeNodeUUID = homeNodeUUID
}

// WithMaxRecords adds the maxRecords to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithMaxRecords(maxRecords *int64) *AggregateCollectionGetParams {
	o.SetMaxRecords(maxRecords)
	return o
}

// SetMaxRecords adds the maxRecords to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetMaxRecords(maxRecords *int64) {
	o.MaxRecords = maxRecords
}

// WithMetricDuration adds the metricDuration to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithMetricDuration(metricDuration *string) *AggregateCollectionGetParams {
	o.SetMetricDuration(metricDuration)
	return o
}

// SetMetricDuration adds the metricDuration to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetMetricDuration(metricDuration *string) {
	o.MetricDuration = metricDuration
}

// WithMetricIopsOther adds the metricIopsOther to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithMetricIopsOther(metricIopsOther *int64) *AggregateCollectionGetParams {
	o.SetMetricIopsOther(metricIopsOther)
	return o
}

// SetMetricIopsOther adds the metricIopsOther to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetMetricIopsOther(metricIopsOther *int64) {
	o.MetricIopsOther = metricIopsOther
}

// WithMetricIopsRead adds the metricIopsRead to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithMetricIopsRead(metricIopsRead *int64) *AggregateCollectionGetParams {
	o.SetMetricIopsRead(metricIopsRead)
	return o
}

// SetMetricIopsRead adds the metricIopsRead to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetMetricIopsRead(metricIopsRead *int64) {
	o.MetricIopsRead = metricIopsRead
}

// WithMetricIopsTotal adds the metricIopsTotal to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithMetricIopsTotal(metricIopsTotal *int64) *AggregateCollectionGetParams {
	o.SetMetricIopsTotal(metricIopsTotal)
	return o
}

// SetMetricIopsTotal adds the metricIopsTotal to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetMetricIopsTotal(metricIopsTotal *int64) {
	o.MetricIopsTotal = metricIopsTotal
}

// WithMetricIopsWrite adds the metricIopsWrite to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithMetricIopsWrite(metricIopsWrite *int64) *AggregateCollectionGetParams {
	o.SetMetricIopsWrite(metricIopsWrite)
	return o
}

// SetMetricIopsWrite adds the metricIopsWrite to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetMetricIopsWrite(metricIopsWrite *int64) {
	o.MetricIopsWrite = metricIopsWrite
}

// WithMetricLatencyOther adds the metricLatencyOther to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithMetricLatencyOther(metricLatencyOther *int64) *AggregateCollectionGetParams {
	o.SetMetricLatencyOther(metricLatencyOther)
	return o
}

// SetMetricLatencyOther adds the metricLatencyOther to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetMetricLatencyOther(metricLatencyOther *int64) {
	o.MetricLatencyOther = metricLatencyOther
}

// WithMetricLatencyRead adds the metricLatencyRead to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithMetricLatencyRead(metricLatencyRead *int64) *AggregateCollectionGetParams {
	o.SetMetricLatencyRead(metricLatencyRead)
	return o
}

// SetMetricLatencyRead adds the metricLatencyRead to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetMetricLatencyRead(metricLatencyRead *int64) {
	o.MetricLatencyRead = metricLatencyRead
}

// WithMetricLatencyTotal adds the metricLatencyTotal to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithMetricLatencyTotal(metricLatencyTotal *int64) *AggregateCollectionGetParams {
	o.SetMetricLatencyTotal(metricLatencyTotal)
	return o
}

// SetMetricLatencyTotal adds the metricLatencyTotal to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetMetricLatencyTotal(metricLatencyTotal *int64) {
	o.MetricLatencyTotal = metricLatencyTotal
}

// WithMetricLatencyWrite adds the metricLatencyWrite to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithMetricLatencyWrite(metricLatencyWrite *int64) *AggregateCollectionGetParams {
	o.SetMetricLatencyWrite(metricLatencyWrite)
	return o
}

// SetMetricLatencyWrite adds the metricLatencyWrite to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetMetricLatencyWrite(metricLatencyWrite *int64) {
	o.MetricLatencyWrite = metricLatencyWrite
}

// WithMetricStatus adds the metricStatus to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithMetricStatus(metricStatus *string) *AggregateCollectionGetParams {
	o.SetMetricStatus(metricStatus)
	return o
}

// SetMetricStatus adds the metricStatus to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetMetricStatus(metricStatus *string) {
	o.MetricStatus = metricStatus
}

// WithMetricThroughputOther adds the metricThroughputOther to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithMetricThroughputOther(metricThroughputOther *int64) *AggregateCollectionGetParams {
	o.SetMetricThroughputOther(metricThroughputOther)
	return o
}

// SetMetricThroughputOther adds the metricThroughputOther to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetMetricThroughputOther(metricThroughputOther *int64) {
	o.MetricThroughputOther = metricThroughputOther
}

// WithMetricThroughputRead adds the metricThroughputRead to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithMetricThroughputRead(metricThroughputRead *int64) *AggregateCollectionGetParams {
	o.SetMetricThroughputRead(metricThroughputRead)
	return o
}

// SetMetricThroughputRead adds the metricThroughputRead to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetMetricThroughputRead(metricThroughputRead *int64) {
	o.MetricThroughputRead = metricThroughputRead
}

// WithMetricThroughputTotal adds the metricThroughputTotal to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithMetricThroughputTotal(metricThroughputTotal *int64) *AggregateCollectionGetParams {
	o.SetMetricThroughputTotal(metricThroughputTotal)
	return o
}

// SetMetricThroughputTotal adds the metricThroughputTotal to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetMetricThroughputTotal(metricThroughputTotal *int64) {
	o.MetricThroughputTotal = metricThroughputTotal
}

// WithMetricThroughputWrite adds the metricThroughputWrite to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithMetricThroughputWrite(metricThroughputWrite *int64) *AggregateCollectionGetParams {
	o.SetMetricThroughputWrite(metricThroughputWrite)
	return o
}

// SetMetricThroughputWrite adds the metricThroughputWrite to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetMetricThroughputWrite(metricThroughputWrite *int64) {
	o.MetricThroughputWrite = metricThroughputWrite
}

// WithMetricTimestamp adds the metricTimestamp to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithMetricTimestamp(metricTimestamp *string) *AggregateCollectionGetParams {
	o.SetMetricTimestamp(metricTimestamp)
	return o
}

// SetMetricTimestamp adds the metricTimestamp to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetMetricTimestamp(metricTimestamp *string) {
	o.MetricTimestamp = metricTimestamp
}

// WithName adds the name to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithName(name *string) *AggregateCollectionGetParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetName(name *string) {
	o.Name = name
}

// WithNodeName adds the nodeName to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithNodeName(nodeName *string) *AggregateCollectionGetParams {
	o.SetNodeName(nodeName)
	return o
}

// SetNodeName adds the nodeName to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetNodeName(nodeName *string) {
	o.NodeName = nodeName
}

// WithNodeUUID adds the nodeUUID to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithNodeUUID(nodeUUID *string) *AggregateCollectionGetParams {
	o.SetNodeUUID(nodeUUID)
	return o
}

// SetNodeUUID adds the nodeUuid to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetNodeUUID(nodeUUID *string) {
	o.NodeUUID = nodeUUID
}

// WithOrderBy adds the orderBy to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithOrderBy(orderBy []string) *AggregateCollectionGetParams {
	o.SetOrderBy(orderBy)
	return o
}

// SetOrderBy adds the orderBy to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetOrderBy(orderBy []string) {
	o.OrderBy = orderBy
}

// WithRecommend adds the recommend to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithRecommend(recommend *bool) *AggregateCollectionGetParams {
	o.SetRecommend(recommend)
	return o
}

// SetRecommend adds the recommend to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetRecommend(recommend *bool) {
	o.Recommend = recommend
}

// WithReturnRecords adds the returnRecords to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithReturnRecords(returnRecords *bool) *AggregateCollectionGetParams {
	o.SetReturnRecords(returnRecords)
	return o
}

// SetReturnRecords adds the returnRecords to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetReturnRecords(returnRecords *bool) {
	o.ReturnRecords = returnRecords
}

// WithReturnTimeout adds the returnTimeout to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithReturnTimeout(returnTimeout *int64) *AggregateCollectionGetParams {
	o.SetReturnTimeout(returnTimeout)
	return o
}

// SetReturnTimeout adds the returnTimeout to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetReturnTimeout(returnTimeout *int64) {
	o.ReturnTimeout = returnTimeout
}

// WithShowSpares adds the showSpares to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithShowSpares(showSpares *bool) *AggregateCollectionGetParams {
	o.SetShowSpares(showSpares)
	return o
}

// SetShowSpares adds the showSpares to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetShowSpares(showSpares *bool) {
	o.ShowSpares = showSpares
}

// WithSnaplockType adds the snaplockType to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithSnaplockType(snaplockType *string) *AggregateCollectionGetParams {
	o.SetSnaplockType(snaplockType)
	return o
}

// SetSnaplockType adds the snaplockType to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetSnaplockType(snaplockType *string) {
	o.SnaplockType = snaplockType
}

// WithSpaceBlockStorageAvailable adds the spaceBlockStorageAvailable to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithSpaceBlockStorageAvailable(spaceBlockStorageAvailable *int64) *AggregateCollectionGetParams {
	o.SetSpaceBlockStorageAvailable(spaceBlockStorageAvailable)
	return o
}

// SetSpaceBlockStorageAvailable adds the spaceBlockStorageAvailable to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetSpaceBlockStorageAvailable(spaceBlockStorageAvailable *int64) {
	o.SpaceBlockStorageAvailable = spaceBlockStorageAvailable
}

// WithSpaceBlockStorageFullThresholdPercent adds the spaceBlockStorageFullThresholdPercent to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithSpaceBlockStorageFullThresholdPercent(spaceBlockStorageFullThresholdPercent *int64) *AggregateCollectionGetParams {
	o.SetSpaceBlockStorageFullThresholdPercent(spaceBlockStorageFullThresholdPercent)
	return o
}

// SetSpaceBlockStorageFullThresholdPercent adds the spaceBlockStorageFullThresholdPercent to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetSpaceBlockStorageFullThresholdPercent(spaceBlockStorageFullThresholdPercent *int64) {
	o.SpaceBlockStorageFullThresholdPercent = spaceBlockStorageFullThresholdPercent
}

// WithSpaceBlockStorageInactiveUserData adds the spaceBlockStorageInactiveUserData to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithSpaceBlockStorageInactiveUserData(spaceBlockStorageInactiveUserData *int64) *AggregateCollectionGetParams {
	o.SetSpaceBlockStorageInactiveUserData(spaceBlockStorageInactiveUserData)
	return o
}

// SetSpaceBlockStorageInactiveUserData adds the spaceBlockStorageInactiveUserData to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetSpaceBlockStorageInactiveUserData(spaceBlockStorageInactiveUserData *int64) {
	o.SpaceBlockStorageInactiveUserData = spaceBlockStorageInactiveUserData
}

// WithSpaceBlockStorageSize adds the spaceBlockStorageSize to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithSpaceBlockStorageSize(spaceBlockStorageSize *int64) *AggregateCollectionGetParams {
	o.SetSpaceBlockStorageSize(spaceBlockStorageSize)
	return o
}

// SetSpaceBlockStorageSize adds the spaceBlockStorageSize to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetSpaceBlockStorageSize(spaceBlockStorageSize *int64) {
	o.SpaceBlockStorageSize = spaceBlockStorageSize
}

// WithSpaceBlockStorageUsed adds the spaceBlockStorageUsed to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithSpaceBlockStorageUsed(spaceBlockStorageUsed *int64) *AggregateCollectionGetParams {
	o.SetSpaceBlockStorageUsed(spaceBlockStorageUsed)
	return o
}

// SetSpaceBlockStorageUsed adds the spaceBlockStorageUsed to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetSpaceBlockStorageUsed(spaceBlockStorageUsed *int64) {
	o.SpaceBlockStorageUsed = spaceBlockStorageUsed
}

// WithSpaceCloudStorageUsed adds the spaceCloudStorageUsed to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithSpaceCloudStorageUsed(spaceCloudStorageUsed *int64) *AggregateCollectionGetParams {
	o.SetSpaceCloudStorageUsed(spaceCloudStorageUsed)
	return o
}

// SetSpaceCloudStorageUsed adds the spaceCloudStorageUsed to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetSpaceCloudStorageUsed(spaceCloudStorageUsed *int64) {
	o.SpaceCloudStorageUsed = spaceCloudStorageUsed
}

// WithSpaceEfficiencyLogicalUsed adds the spaceEfficiencyLogicalUsed to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithSpaceEfficiencyLogicalUsed(spaceEfficiencyLogicalUsed *int64) *AggregateCollectionGetParams {
	o.SetSpaceEfficiencyLogicalUsed(spaceEfficiencyLogicalUsed)
	return o
}

// SetSpaceEfficiencyLogicalUsed adds the spaceEfficiencyLogicalUsed to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetSpaceEfficiencyLogicalUsed(spaceEfficiencyLogicalUsed *int64) {
	o.SpaceEfficiencyLogicalUsed = spaceEfficiencyLogicalUsed
}

// WithSpaceEfficiencyRatio adds the spaceEfficiencyRatio to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithSpaceEfficiencyRatio(spaceEfficiencyRatio *float64) *AggregateCollectionGetParams {
	o.SetSpaceEfficiencyRatio(spaceEfficiencyRatio)
	return o
}

// SetSpaceEfficiencyRatio adds the spaceEfficiencyRatio to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetSpaceEfficiencyRatio(spaceEfficiencyRatio *float64) {
	o.SpaceEfficiencyRatio = spaceEfficiencyRatio
}

// WithSpaceEfficiencySavings adds the spaceEfficiencySavings to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithSpaceEfficiencySavings(spaceEfficiencySavings *int64) *AggregateCollectionGetParams {
	o.SetSpaceEfficiencySavings(spaceEfficiencySavings)
	return o
}

// SetSpaceEfficiencySavings adds the spaceEfficiencySavings to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetSpaceEfficiencySavings(spaceEfficiencySavings *int64) {
	o.SpaceEfficiencySavings = spaceEfficiencySavings
}

// WithSpaceEfficiencyWithoutSnapshotsLogicalUsed adds the spaceEfficiencyWithoutSnapshotsLogicalUsed to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithSpaceEfficiencyWithoutSnapshotsLogicalUsed(spaceEfficiencyWithoutSnapshotsLogicalUsed *int64) *AggregateCollectionGetParams {
	o.SetSpaceEfficiencyWithoutSnapshotsLogicalUsed(spaceEfficiencyWithoutSnapshotsLogicalUsed)
	return o
}

// SetSpaceEfficiencyWithoutSnapshotsLogicalUsed adds the spaceEfficiencyWithoutSnapshotsLogicalUsed to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetSpaceEfficiencyWithoutSnapshotsLogicalUsed(spaceEfficiencyWithoutSnapshotsLogicalUsed *int64) {
	o.SpaceEfficiencyWithoutSnapshotsLogicalUsed = spaceEfficiencyWithoutSnapshotsLogicalUsed
}

// WithSpaceEfficiencyWithoutSnapshotsRatio adds the spaceEfficiencyWithoutSnapshotsRatio to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithSpaceEfficiencyWithoutSnapshotsRatio(spaceEfficiencyWithoutSnapshotsRatio *float64) *AggregateCollectionGetParams {
	o.SetSpaceEfficiencyWithoutSnapshotsRatio(spaceEfficiencyWithoutSnapshotsRatio)
	return o
}

// SetSpaceEfficiencyWithoutSnapshotsRatio adds the spaceEfficiencyWithoutSnapshotsRatio to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetSpaceEfficiencyWithoutSnapshotsRatio(spaceEfficiencyWithoutSnapshotsRatio *float64) {
	o.SpaceEfficiencyWithoutSnapshotsRatio = spaceEfficiencyWithoutSnapshotsRatio
}

// WithSpaceEfficiencyWithoutSnapshotsSavings adds the spaceEfficiencyWithoutSnapshotsSavings to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithSpaceEfficiencyWithoutSnapshotsSavings(spaceEfficiencyWithoutSnapshotsSavings *int64) *AggregateCollectionGetParams {
	o.SetSpaceEfficiencyWithoutSnapshotsSavings(spaceEfficiencyWithoutSnapshotsSavings)
	return o
}

// SetSpaceEfficiencyWithoutSnapshotsSavings adds the spaceEfficiencyWithoutSnapshotsSavings to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetSpaceEfficiencyWithoutSnapshotsSavings(spaceEfficiencyWithoutSnapshotsSavings *int64) {
	o.SpaceEfficiencyWithoutSnapshotsSavings = spaceEfficiencyWithoutSnapshotsSavings
}

// WithSpaceFootprint adds the spaceFootprint to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithSpaceFootprint(spaceFootprint *int64) *AggregateCollectionGetParams {
	o.SetSpaceFootprint(spaceFootprint)
	return o
}

// SetSpaceFootprint adds the spaceFootprint to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetSpaceFootprint(spaceFootprint *int64) {
	o.SpaceFootprint = spaceFootprint
}

// WithState adds the state to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithState(state *string) *AggregateCollectionGetParams {
	o.SetState(state)
	return o
}

// SetState adds the state to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetState(state *string) {
	o.State = state
}

// WithStatisticsIopsRawOther adds the statisticsIopsRawOther to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithStatisticsIopsRawOther(statisticsIopsRawOther *int64) *AggregateCollectionGetParams {
	o.SetStatisticsIopsRawOther(statisticsIopsRawOther)
	return o
}

// SetStatisticsIopsRawOther adds the statisticsIopsRawOther to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetStatisticsIopsRawOther(statisticsIopsRawOther *int64) {
	o.StatisticsIopsRawOther = statisticsIopsRawOther
}

// WithStatisticsIopsRawRead adds the statisticsIopsRawRead to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithStatisticsIopsRawRead(statisticsIopsRawRead *int64) *AggregateCollectionGetParams {
	o.SetStatisticsIopsRawRead(statisticsIopsRawRead)
	return o
}

// SetStatisticsIopsRawRead adds the statisticsIopsRawRead to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetStatisticsIopsRawRead(statisticsIopsRawRead *int64) {
	o.StatisticsIopsRawRead = statisticsIopsRawRead
}

// WithStatisticsIopsRawTotal adds the statisticsIopsRawTotal to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithStatisticsIopsRawTotal(statisticsIopsRawTotal *int64) *AggregateCollectionGetParams {
	o.SetStatisticsIopsRawTotal(statisticsIopsRawTotal)
	return o
}

// SetStatisticsIopsRawTotal adds the statisticsIopsRawTotal to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetStatisticsIopsRawTotal(statisticsIopsRawTotal *int64) {
	o.StatisticsIopsRawTotal = statisticsIopsRawTotal
}

// WithStatisticsIopsRawWrite adds the statisticsIopsRawWrite to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithStatisticsIopsRawWrite(statisticsIopsRawWrite *int64) *AggregateCollectionGetParams {
	o.SetStatisticsIopsRawWrite(statisticsIopsRawWrite)
	return o
}

// SetStatisticsIopsRawWrite adds the statisticsIopsRawWrite to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetStatisticsIopsRawWrite(statisticsIopsRawWrite *int64) {
	o.StatisticsIopsRawWrite = statisticsIopsRawWrite
}

// WithStatisticsLatencyRawOther adds the statisticsLatencyRawOther to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithStatisticsLatencyRawOther(statisticsLatencyRawOther *int64) *AggregateCollectionGetParams {
	o.SetStatisticsLatencyRawOther(statisticsLatencyRawOther)
	return o
}

// SetStatisticsLatencyRawOther adds the statisticsLatencyRawOther to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetStatisticsLatencyRawOther(statisticsLatencyRawOther *int64) {
	o.StatisticsLatencyRawOther = statisticsLatencyRawOther
}

// WithStatisticsLatencyRawRead adds the statisticsLatencyRawRead to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithStatisticsLatencyRawRead(statisticsLatencyRawRead *int64) *AggregateCollectionGetParams {
	o.SetStatisticsLatencyRawRead(statisticsLatencyRawRead)
	return o
}

// SetStatisticsLatencyRawRead adds the statisticsLatencyRawRead to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetStatisticsLatencyRawRead(statisticsLatencyRawRead *int64) {
	o.StatisticsLatencyRawRead = statisticsLatencyRawRead
}

// WithStatisticsLatencyRawTotal adds the statisticsLatencyRawTotal to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithStatisticsLatencyRawTotal(statisticsLatencyRawTotal *int64) *AggregateCollectionGetParams {
	o.SetStatisticsLatencyRawTotal(statisticsLatencyRawTotal)
	return o
}

// SetStatisticsLatencyRawTotal adds the statisticsLatencyRawTotal to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetStatisticsLatencyRawTotal(statisticsLatencyRawTotal *int64) {
	o.StatisticsLatencyRawTotal = statisticsLatencyRawTotal
}

// WithStatisticsLatencyRawWrite adds the statisticsLatencyRawWrite to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithStatisticsLatencyRawWrite(statisticsLatencyRawWrite *int64) *AggregateCollectionGetParams {
	o.SetStatisticsLatencyRawWrite(statisticsLatencyRawWrite)
	return o
}

// SetStatisticsLatencyRawWrite adds the statisticsLatencyRawWrite to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetStatisticsLatencyRawWrite(statisticsLatencyRawWrite *int64) {
	o.StatisticsLatencyRawWrite = statisticsLatencyRawWrite
}

// WithStatisticsStatus adds the statisticsStatus to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithStatisticsStatus(statisticsStatus *string) *AggregateCollectionGetParams {
	o.SetStatisticsStatus(statisticsStatus)
	return o
}

// SetStatisticsStatus adds the statisticsStatus to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetStatisticsStatus(statisticsStatus *string) {
	o.StatisticsStatus = statisticsStatus
}

// WithStatisticsThroughputRawOther adds the statisticsThroughputRawOther to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithStatisticsThroughputRawOther(statisticsThroughputRawOther *int64) *AggregateCollectionGetParams {
	o.SetStatisticsThroughputRawOther(statisticsThroughputRawOther)
	return o
}

// SetStatisticsThroughputRawOther adds the statisticsThroughputRawOther to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetStatisticsThroughputRawOther(statisticsThroughputRawOther *int64) {
	o.StatisticsThroughputRawOther = statisticsThroughputRawOther
}

// WithStatisticsThroughputRawRead adds the statisticsThroughputRawRead to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithStatisticsThroughputRawRead(statisticsThroughputRawRead *int64) *AggregateCollectionGetParams {
	o.SetStatisticsThroughputRawRead(statisticsThroughputRawRead)
	return o
}

// SetStatisticsThroughputRawRead adds the statisticsThroughputRawRead to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetStatisticsThroughputRawRead(statisticsThroughputRawRead *int64) {
	o.StatisticsThroughputRawRead = statisticsThroughputRawRead
}

// WithStatisticsThroughputRawTotal adds the statisticsThroughputRawTotal to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithStatisticsThroughputRawTotal(statisticsThroughputRawTotal *int64) *AggregateCollectionGetParams {
	o.SetStatisticsThroughputRawTotal(statisticsThroughputRawTotal)
	return o
}

// SetStatisticsThroughputRawTotal adds the statisticsThroughputRawTotal to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetStatisticsThroughputRawTotal(statisticsThroughputRawTotal *int64) {
	o.StatisticsThroughputRawTotal = statisticsThroughputRawTotal
}

// WithStatisticsThroughputRawWrite adds the statisticsThroughputRawWrite to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithStatisticsThroughputRawWrite(statisticsThroughputRawWrite *int64) *AggregateCollectionGetParams {
	o.SetStatisticsThroughputRawWrite(statisticsThroughputRawWrite)
	return o
}

// SetStatisticsThroughputRawWrite adds the statisticsThroughputRawWrite to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetStatisticsThroughputRawWrite(statisticsThroughputRawWrite *int64) {
	o.StatisticsThroughputRawWrite = statisticsThroughputRawWrite
}

// WithStatisticsTimestamp adds the statisticsTimestamp to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithStatisticsTimestamp(statisticsTimestamp *string) *AggregateCollectionGetParams {
	o.SetStatisticsTimestamp(statisticsTimestamp)
	return o
}

// SetStatisticsTimestamp adds the statisticsTimestamp to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetStatisticsTimestamp(statisticsTimestamp *string) {
	o.StatisticsTimestamp = statisticsTimestamp
}

// WithUUID adds the uuid to the aggregate collection get params
func (o *AggregateCollectionGetParams) WithUUID(uuid *string) *AggregateCollectionGetParams {
	o.SetUUID(uuid)
	return o
}

// SetUUID adds the uuid to the aggregate collection get params
func (o *AggregateCollectionGetParams) SetUUID(uuid *string) {
	o.UUID = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *AggregateCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.BlockStorageHybridCacheDiskCount != nil {

		// query param block_storage.hybrid_cache.disk_count
		var qrBlockStorageHybridCacheDiskCount int64
		if o.BlockStorageHybridCacheDiskCount != nil {
			qrBlockStorageHybridCacheDiskCount = *o.BlockStorageHybridCacheDiskCount
		}
		qBlockStorageHybridCacheDiskCount := swag.FormatInt64(qrBlockStorageHybridCacheDiskCount)
		if qBlockStorageHybridCacheDiskCount != "" {
			if err := r.SetQueryParam("block_storage.hybrid_cache.disk_count", qBlockStorageHybridCacheDiskCount); err != nil {
				return err
			}
		}

	}

	if o.BlockStorageHybridCacheEnabled != nil {

		// query param block_storage.hybrid_cache.enabled
		var qrBlockStorageHybridCacheEnabled bool
		if o.BlockStorageHybridCacheEnabled != nil {
			qrBlockStorageHybridCacheEnabled = *o.BlockStorageHybridCacheEnabled
		}
		qBlockStorageHybridCacheEnabled := swag.FormatBool(qrBlockStorageHybridCacheEnabled)
		if qBlockStorageHybridCacheEnabled != "" {
			if err := r.SetQueryParam("block_storage.hybrid_cache.enabled", qBlockStorageHybridCacheEnabled); err != nil {
				return err
			}
		}

	}

	if o.BlockStorageHybridCacheRaidType != nil {

		// query param block_storage.hybrid_cache.raid_type
		var qrBlockStorageHybridCacheRaidType string
		if o.BlockStorageHybridCacheRaidType != nil {
			qrBlockStorageHybridCacheRaidType = *o.BlockStorageHybridCacheRaidType
		}
		qBlockStorageHybridCacheRaidType := qrBlockStorageHybridCacheRaidType
		if qBlockStorageHybridCacheRaidType != "" {
			if err := r.SetQueryParam("block_storage.hybrid_cache.raid_type", qBlockStorageHybridCacheRaidType); err != nil {
				return err
			}
		}

	}

	if o.BlockStorageHybridCacheSize != nil {

		// query param block_storage.hybrid_cache.size
		var qrBlockStorageHybridCacheSize int64
		if o.BlockStorageHybridCacheSize != nil {
			qrBlockStorageHybridCacheSize = *o.BlockStorageHybridCacheSize
		}
		qBlockStorageHybridCacheSize := swag.FormatInt64(qrBlockStorageHybridCacheSize)
		if qBlockStorageHybridCacheSize != "" {
			if err := r.SetQueryParam("block_storage.hybrid_cache.size", qBlockStorageHybridCacheSize); err != nil {
				return err
			}
		}

	}

	if o.BlockStorageHybridCacheUsed != nil {

		// query param block_storage.hybrid_cache.used
		var qrBlockStorageHybridCacheUsed int64
		if o.BlockStorageHybridCacheUsed != nil {
			qrBlockStorageHybridCacheUsed = *o.BlockStorageHybridCacheUsed
		}
		qBlockStorageHybridCacheUsed := swag.FormatInt64(qrBlockStorageHybridCacheUsed)
		if qBlockStorageHybridCacheUsed != "" {
			if err := r.SetQueryParam("block_storage.hybrid_cache.used", qBlockStorageHybridCacheUsed); err != nil {
				return err
			}
		}

	}

	if o.BlockStorageMirrorEnabled != nil {

		// query param block_storage.mirror.enabled
		var qrBlockStorageMirrorEnabled bool
		if o.BlockStorageMirrorEnabled != nil {
			qrBlockStorageMirrorEnabled = *o.BlockStorageMirrorEnabled
		}
		qBlockStorageMirrorEnabled := swag.FormatBool(qrBlockStorageMirrorEnabled)
		if qBlockStorageMirrorEnabled != "" {
			if err := r.SetQueryParam("block_storage.mirror.enabled", qBlockStorageMirrorEnabled); err != nil {
				return err
			}
		}

	}

	if o.BlockStorageMirrorState != nil {

		// query param block_storage.mirror.state
		var qrBlockStorageMirrorState string
		if o.BlockStorageMirrorState != nil {
			qrBlockStorageMirrorState = *o.BlockStorageMirrorState
		}
		qBlockStorageMirrorState := qrBlockStorageMirrorState
		if qBlockStorageMirrorState != "" {
			if err := r.SetQueryParam("block_storage.mirror.state", qBlockStorageMirrorState); err != nil {
				return err
			}
		}

	}

	if o.BlockStoragePlexesName != nil {

		// query param block_storage.plexes.name
		var qrBlockStoragePlexesName string
		if o.BlockStoragePlexesName != nil {
			qrBlockStoragePlexesName = *o.BlockStoragePlexesName
		}
		qBlockStoragePlexesName := qrBlockStoragePlexesName
		if qBlockStoragePlexesName != "" {
			if err := r.SetQueryParam("block_storage.plexes.name", qBlockStoragePlexesName); err != nil {
				return err
			}
		}

	}

	if o.BlockStoragePrimaryChecksumStyle != nil {

		// query param block_storage.primary.checksum_style
		var qrBlockStoragePrimaryChecksumStyle string
		if o.BlockStoragePrimaryChecksumStyle != nil {
			qrBlockStoragePrimaryChecksumStyle = *o.BlockStoragePrimaryChecksumStyle
		}
		qBlockStoragePrimaryChecksumStyle := qrBlockStoragePrimaryChecksumStyle
		if qBlockStoragePrimaryChecksumStyle != "" {
			if err := r.SetQueryParam("block_storage.primary.checksum_style", qBlockStoragePrimaryChecksumStyle); err != nil {
				return err
			}
		}

	}

	if o.BlockStoragePrimaryDiskClass != nil {

		// query param block_storage.primary.disk_class
		var qrBlockStoragePrimaryDiskClass string
		if o.BlockStoragePrimaryDiskClass != nil {
			qrBlockStoragePrimaryDiskClass = *o.BlockStoragePrimaryDiskClass
		}
		qBlockStoragePrimaryDiskClass := qrBlockStoragePrimaryDiskClass
		if qBlockStoragePrimaryDiskClass != "" {
			if err := r.SetQueryParam("block_storage.primary.disk_class", qBlockStoragePrimaryDiskClass); err != nil {
				return err
			}
		}

	}

	if o.BlockStoragePrimaryDiskCount != nil {

		// query param block_storage.primary.disk_count
		var qrBlockStoragePrimaryDiskCount int64
		if o.BlockStoragePrimaryDiskCount != nil {
			qrBlockStoragePrimaryDiskCount = *o.BlockStoragePrimaryDiskCount
		}
		qBlockStoragePrimaryDiskCount := swag.FormatInt64(qrBlockStoragePrimaryDiskCount)
		if qBlockStoragePrimaryDiskCount != "" {
			if err := r.SetQueryParam("block_storage.primary.disk_count", qBlockStoragePrimaryDiskCount); err != nil {
				return err
			}
		}

	}

	if o.BlockStoragePrimaryDiskType != nil {

		// query param block_storage.primary.disk_type
		var qrBlockStoragePrimaryDiskType string
		if o.BlockStoragePrimaryDiskType != nil {
			qrBlockStoragePrimaryDiskType = *o.BlockStoragePrimaryDiskType
		}
		qBlockStoragePrimaryDiskType := qrBlockStoragePrimaryDiskType
		if qBlockStoragePrimaryDiskType != "" {
			if err := r.SetQueryParam("block_storage.primary.disk_type", qBlockStoragePrimaryDiskType); err != nil {
				return err
			}
		}

	}

	if o.BlockStoragePrimaryRaidSize != nil {

		// query param block_storage.primary.raid_size
		var qrBlockStoragePrimaryRaidSize int64
		if o.BlockStoragePrimaryRaidSize != nil {
			qrBlockStoragePrimaryRaidSize = *o.BlockStoragePrimaryRaidSize
		}
		qBlockStoragePrimaryRaidSize := swag.FormatInt64(qrBlockStoragePrimaryRaidSize)
		if qBlockStoragePrimaryRaidSize != "" {
			if err := r.SetQueryParam("block_storage.primary.raid_size", qBlockStoragePrimaryRaidSize); err != nil {
				return err
			}
		}

	}

	if o.BlockStoragePrimaryRaidType != nil {

		// query param block_storage.primary.raid_type
		var qrBlockStoragePrimaryRaidType string
		if o.BlockStoragePrimaryRaidType != nil {
			qrBlockStoragePrimaryRaidType = *o.BlockStoragePrimaryRaidType
		}
		qBlockStoragePrimaryRaidType := qrBlockStoragePrimaryRaidType
		if qBlockStoragePrimaryRaidType != "" {
			if err := r.SetQueryParam("block_storage.primary.raid_type", qBlockStoragePrimaryRaidType); err != nil {
				return err
			}
		}

	}

	if o.CreateTime != nil {

		// query param create_time
		var qrCreateTime string
		if o.CreateTime != nil {
			qrCreateTime = *o.CreateTime
		}
		qCreateTime := qrCreateTime
		if qCreateTime != "" {
			if err := r.SetQueryParam("create_time", qCreateTime); err != nil {
				return err
			}
		}

	}

	if o.DataEncryptionDriveProtectionEnabled != nil {

		// query param data_encryption.drive_protection_enabled
		var qrDataEncryptionDriveProtectionEnabled bool
		if o.DataEncryptionDriveProtectionEnabled != nil {
			qrDataEncryptionDriveProtectionEnabled = *o.DataEncryptionDriveProtectionEnabled
		}
		qDataEncryptionDriveProtectionEnabled := swag.FormatBool(qrDataEncryptionDriveProtectionEnabled)
		if qDataEncryptionDriveProtectionEnabled != "" {
			if err := r.SetQueryParam("data_encryption.drive_protection_enabled", qDataEncryptionDriveProtectionEnabled); err != nil {
				return err
			}
		}

	}

	if o.DataEncryptionSoftwareEncryptionEnabled != nil {

		// query param data_encryption.software_encryption_enabled
		var qrDataEncryptionSoftwareEncryptionEnabled bool
		if o.DataEncryptionSoftwareEncryptionEnabled != nil {
			qrDataEncryptionSoftwareEncryptionEnabled = *o.DataEncryptionSoftwareEncryptionEnabled
		}
		qDataEncryptionSoftwareEncryptionEnabled := swag.FormatBool(qrDataEncryptionSoftwareEncryptionEnabled)
		if qDataEncryptionSoftwareEncryptionEnabled != "" {
			if err := r.SetQueryParam("data_encryption.software_encryption_enabled", qDataEncryptionSoftwareEncryptionEnabled); err != nil {
				return err
			}
		}

	}

	if o.DrHomeNodeName != nil {

		// query param dr_home_node.name
		var qrDrHomeNodeName string
		if o.DrHomeNodeName != nil {
			qrDrHomeNodeName = *o.DrHomeNodeName
		}
		qDrHomeNodeName := qrDrHomeNodeName
		if qDrHomeNodeName != "" {
			if err := r.SetQueryParam("dr_home_node.name", qDrHomeNodeName); err != nil {
				return err
			}
		}

	}

	if o.DrHomeNodeUUID != nil {

		// query param dr_home_node.uuid
		var qrDrHomeNodeUUID string
		if o.DrHomeNodeUUID != nil {
			qrDrHomeNodeUUID = *o.DrHomeNodeUUID
		}
		qDrHomeNodeUUID := qrDrHomeNodeUUID
		if qDrHomeNodeUUID != "" {
			if err := r.SetQueryParam("dr_home_node.uuid", qDrHomeNodeUUID); err != nil {
				return err
			}
		}

	}

	valuesFields := o.Fields

	joinedFields := swag.JoinByFormat(valuesFields, "csv")
	// query array param fields
	if err := r.SetQueryParam("fields", joinedFields...); err != nil {
		return err
	}

	if o.HomeNodeName != nil {

		// query param home_node.name
		var qrHomeNodeName string
		if o.HomeNodeName != nil {
			qrHomeNodeName = *o.HomeNodeName
		}
		qHomeNodeName := qrHomeNodeName
		if qHomeNodeName != "" {
			if err := r.SetQueryParam("home_node.name", qHomeNodeName); err != nil {
				return err
			}
		}

	}

	if o.HomeNodeUUID != nil {

		// query param home_node.uuid
		var qrHomeNodeUUID string
		if o.HomeNodeUUID != nil {
			qrHomeNodeUUID = *o.HomeNodeUUID
		}
		qHomeNodeUUID := qrHomeNodeUUID
		if qHomeNodeUUID != "" {
			if err := r.SetQueryParam("home_node.uuid", qHomeNodeUUID); err != nil {
				return err
			}
		}

	}

	if o.MaxRecords != nil {

		// query param max_records
		var qrMaxRecords int64
		if o.MaxRecords != nil {
			qrMaxRecords = *o.MaxRecords
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {
			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}

	}

	if o.MetricDuration != nil {

		// query param metric.duration
		var qrMetricDuration string
		if o.MetricDuration != nil {
			qrMetricDuration = *o.MetricDuration
		}
		qMetricDuration := qrMetricDuration
		if qMetricDuration != "" {
			if err := r.SetQueryParam("metric.duration", qMetricDuration); err != nil {
				return err
			}
		}

	}

	if o.MetricIopsOther != nil {

		// query param metric.iops.other
		var qrMetricIopsOther int64
		if o.MetricIopsOther != nil {
			qrMetricIopsOther = *o.MetricIopsOther
		}
		qMetricIopsOther := swag.FormatInt64(qrMetricIopsOther)
		if qMetricIopsOther != "" {
			if err := r.SetQueryParam("metric.iops.other", qMetricIopsOther); err != nil {
				return err
			}
		}

	}

	if o.MetricIopsRead != nil {

		// query param metric.iops.read
		var qrMetricIopsRead int64
		if o.MetricIopsRead != nil {
			qrMetricIopsRead = *o.MetricIopsRead
		}
		qMetricIopsRead := swag.FormatInt64(qrMetricIopsRead)
		if qMetricIopsRead != "" {
			if err := r.SetQueryParam("metric.iops.read", qMetricIopsRead); err != nil {
				return err
			}
		}

	}

	if o.MetricIopsTotal != nil {

		// query param metric.iops.total
		var qrMetricIopsTotal int64
		if o.MetricIopsTotal != nil {
			qrMetricIopsTotal = *o.MetricIopsTotal
		}
		qMetricIopsTotal := swag.FormatInt64(qrMetricIopsTotal)
		if qMetricIopsTotal != "" {
			if err := r.SetQueryParam("metric.iops.total", qMetricIopsTotal); err != nil {
				return err
			}
		}

	}

	if o.MetricIopsWrite != nil {

		// query param metric.iops.write
		var qrMetricIopsWrite int64
		if o.MetricIopsWrite != nil {
			qrMetricIopsWrite = *o.MetricIopsWrite
		}
		qMetricIopsWrite := swag.FormatInt64(qrMetricIopsWrite)
		if qMetricIopsWrite != "" {
			if err := r.SetQueryParam("metric.iops.write", qMetricIopsWrite); err != nil {
				return err
			}
		}

	}

	if o.MetricLatencyOther != nil {

		// query param metric.latency.other
		var qrMetricLatencyOther int64
		if o.MetricLatencyOther != nil {
			qrMetricLatencyOther = *o.MetricLatencyOther
		}
		qMetricLatencyOther := swag.FormatInt64(qrMetricLatencyOther)
		if qMetricLatencyOther != "" {
			if err := r.SetQueryParam("metric.latency.other", qMetricLatencyOther); err != nil {
				return err
			}
		}

	}

	if o.MetricLatencyRead != nil {

		// query param metric.latency.read
		var qrMetricLatencyRead int64
		if o.MetricLatencyRead != nil {
			qrMetricLatencyRead = *o.MetricLatencyRead
		}
		qMetricLatencyRead := swag.FormatInt64(qrMetricLatencyRead)
		if qMetricLatencyRead != "" {
			if err := r.SetQueryParam("metric.latency.read", qMetricLatencyRead); err != nil {
				return err
			}
		}

	}

	if o.MetricLatencyTotal != nil {

		// query param metric.latency.total
		var qrMetricLatencyTotal int64
		if o.MetricLatencyTotal != nil {
			qrMetricLatencyTotal = *o.MetricLatencyTotal
		}
		qMetricLatencyTotal := swag.FormatInt64(qrMetricLatencyTotal)
		if qMetricLatencyTotal != "" {
			if err := r.SetQueryParam("metric.latency.total", qMetricLatencyTotal); err != nil {
				return err
			}
		}

	}

	if o.MetricLatencyWrite != nil {

		// query param metric.latency.write
		var qrMetricLatencyWrite int64
		if o.MetricLatencyWrite != nil {
			qrMetricLatencyWrite = *o.MetricLatencyWrite
		}
		qMetricLatencyWrite := swag.FormatInt64(qrMetricLatencyWrite)
		if qMetricLatencyWrite != "" {
			if err := r.SetQueryParam("metric.latency.write", qMetricLatencyWrite); err != nil {
				return err
			}
		}

	}

	if o.MetricStatus != nil {

		// query param metric.status
		var qrMetricStatus string
		if o.MetricStatus != nil {
			qrMetricStatus = *o.MetricStatus
		}
		qMetricStatus := qrMetricStatus
		if qMetricStatus != "" {
			if err := r.SetQueryParam("metric.status", qMetricStatus); err != nil {
				return err
			}
		}

	}

	if o.MetricThroughputOther != nil {

		// query param metric.throughput.other
		var qrMetricThroughputOther int64
		if o.MetricThroughputOther != nil {
			qrMetricThroughputOther = *o.MetricThroughputOther
		}
		qMetricThroughputOther := swag.FormatInt64(qrMetricThroughputOther)
		if qMetricThroughputOther != "" {
			if err := r.SetQueryParam("metric.throughput.other", qMetricThroughputOther); err != nil {
				return err
			}
		}

	}

	if o.MetricThroughputRead != nil {

		// query param metric.throughput.read
		var qrMetricThroughputRead int64
		if o.MetricThroughputRead != nil {
			qrMetricThroughputRead = *o.MetricThroughputRead
		}
		qMetricThroughputRead := swag.FormatInt64(qrMetricThroughputRead)
		if qMetricThroughputRead != "" {
			if err := r.SetQueryParam("metric.throughput.read", qMetricThroughputRead); err != nil {
				return err
			}
		}

	}

	if o.MetricThroughputTotal != nil {

		// query param metric.throughput.total
		var qrMetricThroughputTotal int64
		if o.MetricThroughputTotal != nil {
			qrMetricThroughputTotal = *o.MetricThroughputTotal
		}
		qMetricThroughputTotal := swag.FormatInt64(qrMetricThroughputTotal)
		if qMetricThroughputTotal != "" {
			if err := r.SetQueryParam("metric.throughput.total", qMetricThroughputTotal); err != nil {
				return err
			}
		}

	}

	if o.MetricThroughputWrite != nil {

		// query param metric.throughput.write
		var qrMetricThroughputWrite int64
		if o.MetricThroughputWrite != nil {
			qrMetricThroughputWrite = *o.MetricThroughputWrite
		}
		qMetricThroughputWrite := swag.FormatInt64(qrMetricThroughputWrite)
		if qMetricThroughputWrite != "" {
			if err := r.SetQueryParam("metric.throughput.write", qMetricThroughputWrite); err != nil {
				return err
			}
		}

	}

	if o.MetricTimestamp != nil {

		// query param metric.timestamp
		var qrMetricTimestamp string
		if o.MetricTimestamp != nil {
			qrMetricTimestamp = *o.MetricTimestamp
		}
		qMetricTimestamp := qrMetricTimestamp
		if qMetricTimestamp != "" {
			if err := r.SetQueryParam("metric.timestamp", qMetricTimestamp); err != nil {
				return err
			}
		}

	}

	if o.Name != nil {

		// query param name
		var qrName string
		if o.Name != nil {
			qrName = *o.Name
		}
		qName := qrName
		if qName != "" {
			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}

	}

	if o.NodeName != nil {

		// query param node.name
		var qrNodeName string
		if o.NodeName != nil {
			qrNodeName = *o.NodeName
		}
		qNodeName := qrNodeName
		if qNodeName != "" {
			if err := r.SetQueryParam("node.name", qNodeName); err != nil {
				return err
			}
		}

	}

	if o.NodeUUID != nil {

		// query param node.uuid
		var qrNodeUUID string
		if o.NodeUUID != nil {
			qrNodeUUID = *o.NodeUUID
		}
		qNodeUUID := qrNodeUUID
		if qNodeUUID != "" {
			if err := r.SetQueryParam("node.uuid", qNodeUUID); err != nil {
				return err
			}
		}

	}

	valuesOrderBy := o.OrderBy

	joinedOrderBy := swag.JoinByFormat(valuesOrderBy, "csv")
	// query array param order_by
	if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
		return err
	}

	if o.Recommend != nil {

		// query param recommend
		var qrRecommend bool
		if o.Recommend != nil {
			qrRecommend = *o.Recommend
		}
		qRecommend := swag.FormatBool(qrRecommend)
		if qRecommend != "" {
			if err := r.SetQueryParam("recommend", qRecommend); err != nil {
				return err
			}
		}

	}

	if o.ReturnRecords != nil {

		// query param return_records
		var qrReturnRecords bool
		if o.ReturnRecords != nil {
			qrReturnRecords = *o.ReturnRecords
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {
			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}

	}

	if o.ReturnTimeout != nil {

		// query param return_timeout
		var qrReturnTimeout int64
		if o.ReturnTimeout != nil {
			qrReturnTimeout = *o.ReturnTimeout
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {
			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}

	}

	if o.ShowSpares != nil {

		// query param show_spares
		var qrShowSpares bool
		if o.ShowSpares != nil {
			qrShowSpares = *o.ShowSpares
		}
		qShowSpares := swag.FormatBool(qrShowSpares)
		if qShowSpares != "" {
			if err := r.SetQueryParam("show_spares", qShowSpares); err != nil {
				return err
			}
		}

	}

	if o.SnaplockType != nil {

		// query param snaplock_type
		var qrSnaplockType string
		if o.SnaplockType != nil {
			qrSnaplockType = *o.SnaplockType
		}
		qSnaplockType := qrSnaplockType
		if qSnaplockType != "" {
			if err := r.SetQueryParam("snaplock_type", qSnaplockType); err != nil {
				return err
			}
		}

	}

	if o.SpaceBlockStorageAvailable != nil {

		// query param space.block_storage.available
		var qrSpaceBlockStorageAvailable int64
		if o.SpaceBlockStorageAvailable != nil {
			qrSpaceBlockStorageAvailable = *o.SpaceBlockStorageAvailable
		}
		qSpaceBlockStorageAvailable := swag.FormatInt64(qrSpaceBlockStorageAvailable)
		if qSpaceBlockStorageAvailable != "" {
			if err := r.SetQueryParam("space.block_storage.available", qSpaceBlockStorageAvailable); err != nil {
				return err
			}
		}

	}

	if o.SpaceBlockStorageFullThresholdPercent != nil {

		// query param space.block_storage.full_threshold_percent
		var qrSpaceBlockStorageFullThresholdPercent int64
		if o.SpaceBlockStorageFullThresholdPercent != nil {
			qrSpaceBlockStorageFullThresholdPercent = *o.SpaceBlockStorageFullThresholdPercent
		}
		qSpaceBlockStorageFullThresholdPercent := swag.FormatInt64(qrSpaceBlockStorageFullThresholdPercent)
		if qSpaceBlockStorageFullThresholdPercent != "" {
			if err := r.SetQueryParam("space.block_storage.full_threshold_percent", qSpaceBlockStorageFullThresholdPercent); err != nil {
				return err
			}
		}

	}

	if o.SpaceBlockStorageInactiveUserData != nil {

		// query param space.block_storage.inactive_user_data
		var qrSpaceBlockStorageInactiveUserData int64
		if o.SpaceBlockStorageInactiveUserData != nil {
			qrSpaceBlockStorageInactiveUserData = *o.SpaceBlockStorageInactiveUserData
		}
		qSpaceBlockStorageInactiveUserData := swag.FormatInt64(qrSpaceBlockStorageInactiveUserData)
		if qSpaceBlockStorageInactiveUserData != "" {
			if err := r.SetQueryParam("space.block_storage.inactive_user_data", qSpaceBlockStorageInactiveUserData); err != nil {
				return err
			}
		}

	}

	if o.SpaceBlockStorageSize != nil {

		// query param space.block_storage.size
		var qrSpaceBlockStorageSize int64
		if o.SpaceBlockStorageSize != nil {
			qrSpaceBlockStorageSize = *o.SpaceBlockStorageSize
		}
		qSpaceBlockStorageSize := swag.FormatInt64(qrSpaceBlockStorageSize)
		if qSpaceBlockStorageSize != "" {
			if err := r.SetQueryParam("space.block_storage.size", qSpaceBlockStorageSize); err != nil {
				return err
			}
		}

	}

	if o.SpaceBlockStorageUsed != nil {

		// query param space.block_storage.used
		var qrSpaceBlockStorageUsed int64
		if o.SpaceBlockStorageUsed != nil {
			qrSpaceBlockStorageUsed = *o.SpaceBlockStorageUsed
		}
		qSpaceBlockStorageUsed := swag.FormatInt64(qrSpaceBlockStorageUsed)
		if qSpaceBlockStorageUsed != "" {
			if err := r.SetQueryParam("space.block_storage.used", qSpaceBlockStorageUsed); err != nil {
				return err
			}
		}

	}

	if o.SpaceCloudStorageUsed != nil {

		// query param space.cloud_storage.used
		var qrSpaceCloudStorageUsed int64
		if o.SpaceCloudStorageUsed != nil {
			qrSpaceCloudStorageUsed = *o.SpaceCloudStorageUsed
		}
		qSpaceCloudStorageUsed := swag.FormatInt64(qrSpaceCloudStorageUsed)
		if qSpaceCloudStorageUsed != "" {
			if err := r.SetQueryParam("space.cloud_storage.used", qSpaceCloudStorageUsed); err != nil {
				return err
			}
		}

	}

	if o.SpaceEfficiencyLogicalUsed != nil {

		// query param space.efficiency.logical_used
		var qrSpaceEfficiencyLogicalUsed int64
		if o.SpaceEfficiencyLogicalUsed != nil {
			qrSpaceEfficiencyLogicalUsed = *o.SpaceEfficiencyLogicalUsed
		}
		qSpaceEfficiencyLogicalUsed := swag.FormatInt64(qrSpaceEfficiencyLogicalUsed)
		if qSpaceEfficiencyLogicalUsed != "" {
			if err := r.SetQueryParam("space.efficiency.logical_used", qSpaceEfficiencyLogicalUsed); err != nil {
				return err
			}
		}

	}

	if o.SpaceEfficiencyRatio != nil {

		// query param space.efficiency.ratio
		var qrSpaceEfficiencyRatio float64
		if o.SpaceEfficiencyRatio != nil {
			qrSpaceEfficiencyRatio = *o.SpaceEfficiencyRatio
		}
		qSpaceEfficiencyRatio := swag.FormatFloat64(qrSpaceEfficiencyRatio)
		if qSpaceEfficiencyRatio != "" {
			if err := r.SetQueryParam("space.efficiency.ratio", qSpaceEfficiencyRatio); err != nil {
				return err
			}
		}

	}

	if o.SpaceEfficiencySavings != nil {

		// query param space.efficiency.savings
		var qrSpaceEfficiencySavings int64
		if o.SpaceEfficiencySavings != nil {
			qrSpaceEfficiencySavings = *o.SpaceEfficiencySavings
		}
		qSpaceEfficiencySavings := swag.FormatInt64(qrSpaceEfficiencySavings)
		if qSpaceEfficiencySavings != "" {
			if err := r.SetQueryParam("space.efficiency.savings", qSpaceEfficiencySavings); err != nil {
				return err
			}
		}

	}

	if o.SpaceEfficiencyWithoutSnapshotsLogicalUsed != nil {

		// query param space.efficiency_without_snapshots.logical_used
		var qrSpaceEfficiencyWithoutSnapshotsLogicalUsed int64
		if o.SpaceEfficiencyWithoutSnapshotsLogicalUsed != nil {
			qrSpaceEfficiencyWithoutSnapshotsLogicalUsed = *o.SpaceEfficiencyWithoutSnapshotsLogicalUsed
		}
		qSpaceEfficiencyWithoutSnapshotsLogicalUsed := swag.FormatInt64(qrSpaceEfficiencyWithoutSnapshotsLogicalUsed)
		if qSpaceEfficiencyWithoutSnapshotsLogicalUsed != "" {
			if err := r.SetQueryParam("space.efficiency_without_snapshots.logical_used", qSpaceEfficiencyWithoutSnapshotsLogicalUsed); err != nil {
				return err
			}
		}

	}

	if o.SpaceEfficiencyWithoutSnapshotsRatio != nil {

		// query param space.efficiency_without_snapshots.ratio
		var qrSpaceEfficiencyWithoutSnapshotsRatio float64
		if o.SpaceEfficiencyWithoutSnapshotsRatio != nil {
			qrSpaceEfficiencyWithoutSnapshotsRatio = *o.SpaceEfficiencyWithoutSnapshotsRatio
		}
		qSpaceEfficiencyWithoutSnapshotsRatio := swag.FormatFloat64(qrSpaceEfficiencyWithoutSnapshotsRatio)
		if qSpaceEfficiencyWithoutSnapshotsRatio != "" {
			if err := r.SetQueryParam("space.efficiency_without_snapshots.ratio", qSpaceEfficiencyWithoutSnapshotsRatio); err != nil {
				return err
			}
		}

	}

	if o.SpaceEfficiencyWithoutSnapshotsSavings != nil {

		// query param space.efficiency_without_snapshots.savings
		var qrSpaceEfficiencyWithoutSnapshotsSavings int64
		if o.SpaceEfficiencyWithoutSnapshotsSavings != nil {
			qrSpaceEfficiencyWithoutSnapshotsSavings = *o.SpaceEfficiencyWithoutSnapshotsSavings
		}
		qSpaceEfficiencyWithoutSnapshotsSavings := swag.FormatInt64(qrSpaceEfficiencyWithoutSnapshotsSavings)
		if qSpaceEfficiencyWithoutSnapshotsSavings != "" {
			if err := r.SetQueryParam("space.efficiency_without_snapshots.savings", qSpaceEfficiencyWithoutSnapshotsSavings); err != nil {
				return err
			}
		}

	}

	if o.SpaceFootprint != nil {

		// query param space.footprint
		var qrSpaceFootprint int64
		if o.SpaceFootprint != nil {
			qrSpaceFootprint = *o.SpaceFootprint
		}
		qSpaceFootprint := swag.FormatInt64(qrSpaceFootprint)
		if qSpaceFootprint != "" {
			if err := r.SetQueryParam("space.footprint", qSpaceFootprint); err != nil {
				return err
			}
		}

	}

	if o.State != nil {

		// query param state
		var qrState string
		if o.State != nil {
			qrState = *o.State
		}
		qState := qrState
		if qState != "" {
			if err := r.SetQueryParam("state", qState); err != nil {
				return err
			}
		}

	}

	if o.StatisticsIopsRawOther != nil {

		// query param statistics.iops_raw.other
		var qrStatisticsIopsRawOther int64
		if o.StatisticsIopsRawOther != nil {
			qrStatisticsIopsRawOther = *o.StatisticsIopsRawOther
		}
		qStatisticsIopsRawOther := swag.FormatInt64(qrStatisticsIopsRawOther)
		if qStatisticsIopsRawOther != "" {
			if err := r.SetQueryParam("statistics.iops_raw.other", qStatisticsIopsRawOther); err != nil {
				return err
			}
		}

	}

	if o.StatisticsIopsRawRead != nil {

		// query param statistics.iops_raw.read
		var qrStatisticsIopsRawRead int64
		if o.StatisticsIopsRawRead != nil {
			qrStatisticsIopsRawRead = *o.StatisticsIopsRawRead
		}
		qStatisticsIopsRawRead := swag.FormatInt64(qrStatisticsIopsRawRead)
		if qStatisticsIopsRawRead != "" {
			if err := r.SetQueryParam("statistics.iops_raw.read", qStatisticsIopsRawRead); err != nil {
				return err
			}
		}

	}

	if o.StatisticsIopsRawTotal != nil {

		// query param statistics.iops_raw.total
		var qrStatisticsIopsRawTotal int64
		if o.StatisticsIopsRawTotal != nil {
			qrStatisticsIopsRawTotal = *o.StatisticsIopsRawTotal
		}
		qStatisticsIopsRawTotal := swag.FormatInt64(qrStatisticsIopsRawTotal)
		if qStatisticsIopsRawTotal != "" {
			if err := r.SetQueryParam("statistics.iops_raw.total", qStatisticsIopsRawTotal); err != nil {
				return err
			}
		}

	}

	if o.StatisticsIopsRawWrite != nil {

		// query param statistics.iops_raw.write
		var qrStatisticsIopsRawWrite int64
		if o.StatisticsIopsRawWrite != nil {
			qrStatisticsIopsRawWrite = *o.StatisticsIopsRawWrite
		}
		qStatisticsIopsRawWrite := swag.FormatInt64(qrStatisticsIopsRawWrite)
		if qStatisticsIopsRawWrite != "" {
			if err := r.SetQueryParam("statistics.iops_raw.write", qStatisticsIopsRawWrite); err != nil {
				return err
			}
		}

	}

	if o.StatisticsLatencyRawOther != nil {

		// query param statistics.latency_raw.other
		var qrStatisticsLatencyRawOther int64
		if o.StatisticsLatencyRawOther != nil {
			qrStatisticsLatencyRawOther = *o.StatisticsLatencyRawOther
		}
		qStatisticsLatencyRawOther := swag.FormatInt64(qrStatisticsLatencyRawOther)
		if qStatisticsLatencyRawOther != "" {
			if err := r.SetQueryParam("statistics.latency_raw.other", qStatisticsLatencyRawOther); err != nil {
				return err
			}
		}

	}

	if o.StatisticsLatencyRawRead != nil {

		// query param statistics.latency_raw.read
		var qrStatisticsLatencyRawRead int64
		if o.StatisticsLatencyRawRead != nil {
			qrStatisticsLatencyRawRead = *o.StatisticsLatencyRawRead
		}
		qStatisticsLatencyRawRead := swag.FormatInt64(qrStatisticsLatencyRawRead)
		if qStatisticsLatencyRawRead != "" {
			if err := r.SetQueryParam("statistics.latency_raw.read", qStatisticsLatencyRawRead); err != nil {
				return err
			}
		}

	}

	if o.StatisticsLatencyRawTotal != nil {

		// query param statistics.latency_raw.total
		var qrStatisticsLatencyRawTotal int64
		if o.StatisticsLatencyRawTotal != nil {
			qrStatisticsLatencyRawTotal = *o.StatisticsLatencyRawTotal
		}
		qStatisticsLatencyRawTotal := swag.FormatInt64(qrStatisticsLatencyRawTotal)
		if qStatisticsLatencyRawTotal != "" {
			if err := r.SetQueryParam("statistics.latency_raw.total", qStatisticsLatencyRawTotal); err != nil {
				return err
			}
		}

	}

	if o.StatisticsLatencyRawWrite != nil {

		// query param statistics.latency_raw.write
		var qrStatisticsLatencyRawWrite int64
		if o.StatisticsLatencyRawWrite != nil {
			qrStatisticsLatencyRawWrite = *o.StatisticsLatencyRawWrite
		}
		qStatisticsLatencyRawWrite := swag.FormatInt64(qrStatisticsLatencyRawWrite)
		if qStatisticsLatencyRawWrite != "" {
			if err := r.SetQueryParam("statistics.latency_raw.write", qStatisticsLatencyRawWrite); err != nil {
				return err
			}
		}

	}

	if o.StatisticsStatus != nil {

		// query param statistics.status
		var qrStatisticsStatus string
		if o.StatisticsStatus != nil {
			qrStatisticsStatus = *o.StatisticsStatus
		}
		qStatisticsStatus := qrStatisticsStatus
		if qStatisticsStatus != "" {
			if err := r.SetQueryParam("statistics.status", qStatisticsStatus); err != nil {
				return err
			}
		}

	}

	if o.StatisticsThroughputRawOther != nil {

		// query param statistics.throughput_raw.other
		var qrStatisticsThroughputRawOther int64
		if o.StatisticsThroughputRawOther != nil {
			qrStatisticsThroughputRawOther = *o.StatisticsThroughputRawOther
		}
		qStatisticsThroughputRawOther := swag.FormatInt64(qrStatisticsThroughputRawOther)
		if qStatisticsThroughputRawOther != "" {
			if err := r.SetQueryParam("statistics.throughput_raw.other", qStatisticsThroughputRawOther); err != nil {
				return err
			}
		}

	}

	if o.StatisticsThroughputRawRead != nil {

		// query param statistics.throughput_raw.read
		var qrStatisticsThroughputRawRead int64
		if o.StatisticsThroughputRawRead != nil {
			qrStatisticsThroughputRawRead = *o.StatisticsThroughputRawRead
		}
		qStatisticsThroughputRawRead := swag.FormatInt64(qrStatisticsThroughputRawRead)
		if qStatisticsThroughputRawRead != "" {
			if err := r.SetQueryParam("statistics.throughput_raw.read", qStatisticsThroughputRawRead); err != nil {
				return err
			}
		}

	}

	if o.StatisticsThroughputRawTotal != nil {

		// query param statistics.throughput_raw.total
		var qrStatisticsThroughputRawTotal int64
		if o.StatisticsThroughputRawTotal != nil {
			qrStatisticsThroughputRawTotal = *o.StatisticsThroughputRawTotal
		}
		qStatisticsThroughputRawTotal := swag.FormatInt64(qrStatisticsThroughputRawTotal)
		if qStatisticsThroughputRawTotal != "" {
			if err := r.SetQueryParam("statistics.throughput_raw.total", qStatisticsThroughputRawTotal); err != nil {
				return err
			}
		}

	}

	if o.StatisticsThroughputRawWrite != nil {

		// query param statistics.throughput_raw.write
		var qrStatisticsThroughputRawWrite int64
		if o.StatisticsThroughputRawWrite != nil {
			qrStatisticsThroughputRawWrite = *o.StatisticsThroughputRawWrite
		}
		qStatisticsThroughputRawWrite := swag.FormatInt64(qrStatisticsThroughputRawWrite)
		if qStatisticsThroughputRawWrite != "" {
			if err := r.SetQueryParam("statistics.throughput_raw.write", qStatisticsThroughputRawWrite); err != nil {
				return err
			}
		}

	}

	if o.StatisticsTimestamp != nil {

		// query param statistics.timestamp
		var qrStatisticsTimestamp string
		if o.StatisticsTimestamp != nil {
			qrStatisticsTimestamp = *o.StatisticsTimestamp
		}
		qStatisticsTimestamp := qrStatisticsTimestamp
		if qStatisticsTimestamp != "" {
			if err := r.SetQueryParam("statistics.timestamp", qStatisticsTimestamp); err != nil {
				return err
			}
		}

	}

	if o.UUID != nil {

		// query param uuid
		var qrUUID string
		if o.UUID != nil {
			qrUUID = *o.UUID
		}
		qUUID := qrUUID
		if qUUID != "" {
			if err := r.SetQueryParam("uuid", qUUID); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
