// Code generated by go-swagger; DO NOT EDIT.

package storage

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/greenqloud/ontap-rest-client/ntapmodel"
)

// AggregateCollectionGetReader is a Reader for the AggregateCollectionGet structure.
type AggregateCollectionGetReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *AggregateCollectionGetReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewAggregateCollectionGetOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewAggregateCollectionGetDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewAggregateCollectionGetOK creates a AggregateCollectionGetOK with default headers values
func NewAggregateCollectionGetOK() *AggregateCollectionGetOK {
	return &AggregateCollectionGetOK{}
}

/*AggregateCollectionGetOK handles this case with default header values.

OK
*/
type AggregateCollectionGetOK struct {
	Payload *ntapmodel.AggregateResponse
}

func (o *AggregateCollectionGetOK) Error() string {
	return fmt.Sprintf("[GET /storage/aggregates][%d] aggregateCollectionGetOK  %+v", 200, o.Payload)
}

func (o *AggregateCollectionGetOK) GetPayload() *ntapmodel.AggregateResponse {
	return o.Payload
}

func (o *AggregateCollectionGetOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(ntapmodel.AggregateResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewAggregateCollectionGetDefault creates a AggregateCollectionGetDefault with default headers values
func NewAggregateCollectionGetDefault(code int) *AggregateCollectionGetDefault {
	return &AggregateCollectionGetDefault{
		_statusCode: code,
	}
}

/*AggregateCollectionGetDefault handles this case with default header values.

ONTAP Error Response Codes
| Error Code | Description |
| ---------- | ----------- |
| 787092 | The target field cannot be specified for this operation. |
| 8586225 | Encountered unexpected error in retrieving metrics and statistics for an aggregate. |
| 19726341 | Not enough eligible spare disks are available on the node. |
| 19726344 | No recommendation can be made for this cluster. |
| 19726357 | Aggregate recommendations are not supported on MetroCluster. |
| 19726358 | Aggregate recommendations are not supported on ONTAP Cloud. |
| 19726382 | Another provisioning operation is in progress on this cluster. Wait a few minutes, and try the operation again. |
| 19726386 | Encountered an error when retrieving licensing information on this cluster. |

*/
type AggregateCollectionGetDefault struct {
	_statusCode int

	Payload *ntapmodel.ErrorResponse
}

// Code gets the status code for the aggregate collection get default response
func (o *AggregateCollectionGetDefault) Code() int {
	return o._statusCode
}

func (o *AggregateCollectionGetDefault) Error() string {
	return fmt.Sprintf("[GET /storage/aggregates][%d] aggregate_collection_get default  %+v", o._statusCode, o.Payload)
}

func (o *AggregateCollectionGetDefault) GetPayload() *ntapmodel.ErrorResponse {
	return o.Payload
}

func (o *AggregateCollectionGetDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(ntapmodel.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
