// Code generated by go-swagger; DO NOT EDIT.

package storage

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewQosPolicyCollectionGetParams creates a new QosPolicyCollectionGetParams object
// with the default values initialized.
func NewQosPolicyCollectionGetParams() *QosPolicyCollectionGetParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &QosPolicyCollectionGetParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewQosPolicyCollectionGetParamsWithTimeout creates a new QosPolicyCollectionGetParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewQosPolicyCollectionGetParamsWithTimeout(timeout time.Duration) *QosPolicyCollectionGetParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &QosPolicyCollectionGetParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		timeout: timeout,
	}
}

// NewQosPolicyCollectionGetParamsWithContext creates a new QosPolicyCollectionGetParams object
// with the default values initialized, and the ability to set a context for a request
func NewQosPolicyCollectionGetParamsWithContext(ctx context.Context) *QosPolicyCollectionGetParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &QosPolicyCollectionGetParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		Context: ctx,
	}
}

// NewQosPolicyCollectionGetParamsWithHTTPClient creates a new QosPolicyCollectionGetParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewQosPolicyCollectionGetParamsWithHTTPClient(client *http.Client) *QosPolicyCollectionGetParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &QosPolicyCollectionGetParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,
		HTTPClient:    client,
	}
}

/*QosPolicyCollectionGetParams contains all the parameters to send to the API endpoint
for the qos policy collection get operation typically these are written to a http.Request
*/
type QosPolicyCollectionGetParams struct {

	/*AdaptiveAbsoluteMinIops
	  Filter by adaptive.absolute_min_iops

	*/
	AdaptiveAbsoluteMinIops *int64
	/*AdaptiveExpectedIops
	  Filter by adaptive.expected_iops

	*/
	AdaptiveExpectedIops *int64
	/*AdaptivePeakIops
	  Filter by adaptive.peak_iops

	*/
	AdaptivePeakIops *int64
	/*Fields
	  Specify the fields to return.

	*/
	Fields []string
	/*FixedCapacityShared
	  Filter by fixed.capacity_shared

	*/
	FixedCapacityShared *bool
	/*FixedMaxThroughputIops
	  Filter by fixed.max_throughput_iops

	*/
	FixedMaxThroughputIops *int64
	/*FixedMaxThroughputMbps
	  Filter by fixed.max_throughput_mbps

	*/
	FixedMaxThroughputMbps *int64
	/*FixedMinThroughputIops
	  Filter by fixed.min_throughput_iops

	*/
	FixedMinThroughputIops *int64
	/*MaxRecords
	  Limit the number of records returned.

	*/
	MaxRecords *int64
	/*Name
	  Filter by name

	*/
	Name *string
	/*ObjectCount
	  Filter by object_count

	*/
	ObjectCount *int64
	/*OrderBy
	  Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.

	*/
	OrderBy []string
	/*ReturnRecords
	  The default is true for GET calls.  When set to false, only the number of records is returned.

	*/
	ReturnRecords *bool
	/*ReturnTimeout
	  The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	*/
	ReturnTimeout *int64
	/*Svm
	  Filter by svm (alias of svm.name)

	*/
	Svm *string
	/*SvmName
	  Filter by svm.name

	*/
	SvmName *string
	/*SvmUUID
	  Filter by svm.uuid

	*/
	SvmUUID *string
	/*UUID
	  Filter by uuid

	*/
	UUID *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the qos policy collection get params
func (o *QosPolicyCollectionGetParams) WithTimeout(timeout time.Duration) *QosPolicyCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the qos policy collection get params
func (o *QosPolicyCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the qos policy collection get params
func (o *QosPolicyCollectionGetParams) WithContext(ctx context.Context) *QosPolicyCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the qos policy collection get params
func (o *QosPolicyCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the qos policy collection get params
func (o *QosPolicyCollectionGetParams) WithHTTPClient(client *http.Client) *QosPolicyCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the qos policy collection get params
func (o *QosPolicyCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAdaptiveAbsoluteMinIops adds the adaptiveAbsoluteMinIops to the qos policy collection get params
func (o *QosPolicyCollectionGetParams) WithAdaptiveAbsoluteMinIops(adaptiveAbsoluteMinIops *int64) *QosPolicyCollectionGetParams {
	o.SetAdaptiveAbsoluteMinIops(adaptiveAbsoluteMinIops)
	return o
}

// SetAdaptiveAbsoluteMinIops adds the adaptiveAbsoluteMinIops to the qos policy collection get params
func (o *QosPolicyCollectionGetParams) SetAdaptiveAbsoluteMinIops(adaptiveAbsoluteMinIops *int64) {
	o.AdaptiveAbsoluteMinIops = adaptiveAbsoluteMinIops
}

// WithAdaptiveExpectedIops adds the adaptiveExpectedIops to the qos policy collection get params
func (o *QosPolicyCollectionGetParams) WithAdaptiveExpectedIops(adaptiveExpectedIops *int64) *QosPolicyCollectionGetParams {
	o.SetAdaptiveExpectedIops(adaptiveExpectedIops)
	return o
}

// SetAdaptiveExpectedIops adds the adaptiveExpectedIops to the qos policy collection get params
func (o *QosPolicyCollectionGetParams) SetAdaptiveExpectedIops(adaptiveExpectedIops *int64) {
	o.AdaptiveExpectedIops = adaptiveExpectedIops
}

// WithAdaptivePeakIops adds the adaptivePeakIops to the qos policy collection get params
func (o *QosPolicyCollectionGetParams) WithAdaptivePeakIops(adaptivePeakIops *int64) *QosPolicyCollectionGetParams {
	o.SetAdaptivePeakIops(adaptivePeakIops)
	return o
}

// SetAdaptivePeakIops adds the adaptivePeakIops to the qos policy collection get params
func (o *QosPolicyCollectionGetParams) SetAdaptivePeakIops(adaptivePeakIops *int64) {
	o.AdaptivePeakIops = adaptivePeakIops
}

// WithFields adds the fields to the qos policy collection get params
func (o *QosPolicyCollectionGetParams) WithFields(fields []string) *QosPolicyCollectionGetParams {
	o.SetFields(fields)
	return o
}

// SetFields adds the fields to the qos policy collection get params
func (o *QosPolicyCollectionGetParams) SetFields(fields []string) {
	o.Fields = fields
}

// WithFixedCapacityShared adds the fixedCapacityShared to the qos policy collection get params
func (o *QosPolicyCollectionGetParams) WithFixedCapacityShared(fixedCapacityShared *bool) *QosPolicyCollectionGetParams {
	o.SetFixedCapacityShared(fixedCapacityShared)
	return o
}

// SetFixedCapacityShared adds the fixedCapacityShared to the qos policy collection get params
func (o *QosPolicyCollectionGetParams) SetFixedCapacityShared(fixedCapacityShared *bool) {
	o.FixedCapacityShared = fixedCapacityShared
}

// WithFixedMaxThroughputIops adds the fixedMaxThroughputIops to the qos policy collection get params
func (o *QosPolicyCollectionGetParams) WithFixedMaxThroughputIops(fixedMaxThroughputIops *int64) *QosPolicyCollectionGetParams {
	o.SetFixedMaxThroughputIops(fixedMaxThroughputIops)
	return o
}

// SetFixedMaxThroughputIops adds the fixedMaxThroughputIops to the qos policy collection get params
func (o *QosPolicyCollectionGetParams) SetFixedMaxThroughputIops(fixedMaxThroughputIops *int64) {
	o.FixedMaxThroughputIops = fixedMaxThroughputIops
}

// WithFixedMaxThroughputMbps adds the fixedMaxThroughputMbps to the qos policy collection get params
func (o *QosPolicyCollectionGetParams) WithFixedMaxThroughputMbps(fixedMaxThroughputMbps *int64) *QosPolicyCollectionGetParams {
	o.SetFixedMaxThroughputMbps(fixedMaxThroughputMbps)
	return o
}

// SetFixedMaxThroughputMbps adds the fixedMaxThroughputMbps to the qos policy collection get params
func (o *QosPolicyCollectionGetParams) SetFixedMaxThroughputMbps(fixedMaxThroughputMbps *int64) {
	o.FixedMaxThroughputMbps = fixedMaxThroughputMbps
}

// WithFixedMinThroughputIops adds the fixedMinThroughputIops to the qos policy collection get params
func (o *QosPolicyCollectionGetParams) WithFixedMinThroughputIops(fixedMinThroughputIops *int64) *QosPolicyCollectionGetParams {
	o.SetFixedMinThroughputIops(fixedMinThroughputIops)
	return o
}

// SetFixedMinThroughputIops adds the fixedMinThroughputIops to the qos policy collection get params
func (o *QosPolicyCollectionGetParams) SetFixedMinThroughputIops(fixedMinThroughputIops *int64) {
	o.FixedMinThroughputIops = fixedMinThroughputIops
}

// WithMaxRecords adds the maxRecords to the qos policy collection get params
func (o *QosPolicyCollectionGetParams) WithMaxRecords(maxRecords *int64) *QosPolicyCollectionGetParams {
	o.SetMaxRecords(maxRecords)
	return o
}

// SetMaxRecords adds the maxRecords to the qos policy collection get params
func (o *QosPolicyCollectionGetParams) SetMaxRecords(maxRecords *int64) {
	o.MaxRecords = maxRecords
}

// WithName adds the name to the qos policy collection get params
func (o *QosPolicyCollectionGetParams) WithName(name *string) *QosPolicyCollectionGetParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the qos policy collection get params
func (o *QosPolicyCollectionGetParams) SetName(name *string) {
	o.Name = name
}

// WithObjectCount adds the objectCount to the qos policy collection get params
func (o *QosPolicyCollectionGetParams) WithObjectCount(objectCount *int64) *QosPolicyCollectionGetParams {
	o.SetObjectCount(objectCount)
	return o
}

// SetObjectCount adds the objectCount to the qos policy collection get params
func (o *QosPolicyCollectionGetParams) SetObjectCount(objectCount *int64) {
	o.ObjectCount = objectCount
}

// WithOrderBy adds the orderBy to the qos policy collection get params
func (o *QosPolicyCollectionGetParams) WithOrderBy(orderBy []string) *QosPolicyCollectionGetParams {
	o.SetOrderBy(orderBy)
	return o
}

// SetOrderBy adds the orderBy to the qos policy collection get params
func (o *QosPolicyCollectionGetParams) SetOrderBy(orderBy []string) {
	o.OrderBy = orderBy
}

// WithReturnRecords adds the returnRecords to the qos policy collection get params
func (o *QosPolicyCollectionGetParams) WithReturnRecords(returnRecords *bool) *QosPolicyCollectionGetParams {
	o.SetReturnRecords(returnRecords)
	return o
}

// SetReturnRecords adds the returnRecords to the qos policy collection get params
func (o *QosPolicyCollectionGetParams) SetReturnRecords(returnRecords *bool) {
	o.ReturnRecords = returnRecords
}

// WithReturnTimeout adds the returnTimeout to the qos policy collection get params
func (o *QosPolicyCollectionGetParams) WithReturnTimeout(returnTimeout *int64) *QosPolicyCollectionGetParams {
	o.SetReturnTimeout(returnTimeout)
	return o
}

// SetReturnTimeout adds the returnTimeout to the qos policy collection get params
func (o *QosPolicyCollectionGetParams) SetReturnTimeout(returnTimeout *int64) {
	o.ReturnTimeout = returnTimeout
}

// WithSvm adds the svm to the qos policy collection get params
func (o *QosPolicyCollectionGetParams) WithSvm(svm *string) *QosPolicyCollectionGetParams {
	o.SetSvm(svm)
	return o
}

// SetSvm adds the svm to the qos policy collection get params
func (o *QosPolicyCollectionGetParams) SetSvm(svm *string) {
	o.Svm = svm
}

// WithSvmName adds the svmName to the qos policy collection get params
func (o *QosPolicyCollectionGetParams) WithSvmName(svmName *string) *QosPolicyCollectionGetParams {
	o.SetSvmName(svmName)
	return o
}

// SetSvmName adds the svmName to the qos policy collection get params
func (o *QosPolicyCollectionGetParams) SetSvmName(svmName *string) {
	o.SvmName = svmName
}

// WithSvmUUID adds the svmUUID to the qos policy collection get params
func (o *QosPolicyCollectionGetParams) WithSvmUUID(svmUUID *string) *QosPolicyCollectionGetParams {
	o.SetSvmUUID(svmUUID)
	return o
}

// SetSvmUUID adds the svmUuid to the qos policy collection get params
func (o *QosPolicyCollectionGetParams) SetSvmUUID(svmUUID *string) {
	o.SvmUUID = svmUUID
}

// WithUUID adds the uuid to the qos policy collection get params
func (o *QosPolicyCollectionGetParams) WithUUID(uuid *string) *QosPolicyCollectionGetParams {
	o.SetUUID(uuid)
	return o
}

// SetUUID adds the uuid to the qos policy collection get params
func (o *QosPolicyCollectionGetParams) SetUUID(uuid *string) {
	o.UUID = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *QosPolicyCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.AdaptiveAbsoluteMinIops != nil {

		// query param adaptive.absolute_min_iops
		var qrAdaptiveAbsoluteMinIops int64
		if o.AdaptiveAbsoluteMinIops != nil {
			qrAdaptiveAbsoluteMinIops = *o.AdaptiveAbsoluteMinIops
		}
		qAdaptiveAbsoluteMinIops := swag.FormatInt64(qrAdaptiveAbsoluteMinIops)
		if qAdaptiveAbsoluteMinIops != "" {
			if err := r.SetQueryParam("adaptive.absolute_min_iops", qAdaptiveAbsoluteMinIops); err != nil {
				return err
			}
		}

	}

	if o.AdaptiveExpectedIops != nil {

		// query param adaptive.expected_iops
		var qrAdaptiveExpectedIops int64
		if o.AdaptiveExpectedIops != nil {
			qrAdaptiveExpectedIops = *o.AdaptiveExpectedIops
		}
		qAdaptiveExpectedIops := swag.FormatInt64(qrAdaptiveExpectedIops)
		if qAdaptiveExpectedIops != "" {
			if err := r.SetQueryParam("adaptive.expected_iops", qAdaptiveExpectedIops); err != nil {
				return err
			}
		}

	}

	if o.AdaptivePeakIops != nil {

		// query param adaptive.peak_iops
		var qrAdaptivePeakIops int64
		if o.AdaptivePeakIops != nil {
			qrAdaptivePeakIops = *o.AdaptivePeakIops
		}
		qAdaptivePeakIops := swag.FormatInt64(qrAdaptivePeakIops)
		if qAdaptivePeakIops != "" {
			if err := r.SetQueryParam("adaptive.peak_iops", qAdaptivePeakIops); err != nil {
				return err
			}
		}

	}

	valuesFields := o.Fields

	joinedFields := swag.JoinByFormat(valuesFields, "csv")
	// query array param fields
	if err := r.SetQueryParam("fields", joinedFields...); err != nil {
		return err
	}

	if o.FixedCapacityShared != nil {

		// query param fixed.capacity_shared
		var qrFixedCapacityShared bool
		if o.FixedCapacityShared != nil {
			qrFixedCapacityShared = *o.FixedCapacityShared
		}
		qFixedCapacityShared := swag.FormatBool(qrFixedCapacityShared)
		if qFixedCapacityShared != "" {
			if err := r.SetQueryParam("fixed.capacity_shared", qFixedCapacityShared); err != nil {
				return err
			}
		}

	}

	if o.FixedMaxThroughputIops != nil {

		// query param fixed.max_throughput_iops
		var qrFixedMaxThroughputIops int64
		if o.FixedMaxThroughputIops != nil {
			qrFixedMaxThroughputIops = *o.FixedMaxThroughputIops
		}
		qFixedMaxThroughputIops := swag.FormatInt64(qrFixedMaxThroughputIops)
		if qFixedMaxThroughputIops != "" {
			if err := r.SetQueryParam("fixed.max_throughput_iops", qFixedMaxThroughputIops); err != nil {
				return err
			}
		}

	}

	if o.FixedMaxThroughputMbps != nil {

		// query param fixed.max_throughput_mbps
		var qrFixedMaxThroughputMbps int64
		if o.FixedMaxThroughputMbps != nil {
			qrFixedMaxThroughputMbps = *o.FixedMaxThroughputMbps
		}
		qFixedMaxThroughputMbps := swag.FormatInt64(qrFixedMaxThroughputMbps)
		if qFixedMaxThroughputMbps != "" {
			if err := r.SetQueryParam("fixed.max_throughput_mbps", qFixedMaxThroughputMbps); err != nil {
				return err
			}
		}

	}

	if o.FixedMinThroughputIops != nil {

		// query param fixed.min_throughput_iops
		var qrFixedMinThroughputIops int64
		if o.FixedMinThroughputIops != nil {
			qrFixedMinThroughputIops = *o.FixedMinThroughputIops
		}
		qFixedMinThroughputIops := swag.FormatInt64(qrFixedMinThroughputIops)
		if qFixedMinThroughputIops != "" {
			if err := r.SetQueryParam("fixed.min_throughput_iops", qFixedMinThroughputIops); err != nil {
				return err
			}
		}

	}

	if o.MaxRecords != nil {

		// query param max_records
		var qrMaxRecords int64
		if o.MaxRecords != nil {
			qrMaxRecords = *o.MaxRecords
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {
			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}

	}

	if o.Name != nil {

		// query param name
		var qrName string
		if o.Name != nil {
			qrName = *o.Name
		}
		qName := qrName
		if qName != "" {
			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}

	}

	if o.ObjectCount != nil {

		// query param object_count
		var qrObjectCount int64
		if o.ObjectCount != nil {
			qrObjectCount = *o.ObjectCount
		}
		qObjectCount := swag.FormatInt64(qrObjectCount)
		if qObjectCount != "" {
			if err := r.SetQueryParam("object_count", qObjectCount); err != nil {
				return err
			}
		}

	}

	valuesOrderBy := o.OrderBy

	joinedOrderBy := swag.JoinByFormat(valuesOrderBy, "csv")
	// query array param order_by
	if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
		return err
	}

	if o.ReturnRecords != nil {

		// query param return_records
		var qrReturnRecords bool
		if o.ReturnRecords != nil {
			qrReturnRecords = *o.ReturnRecords
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {
			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}

	}

	if o.ReturnTimeout != nil {

		// query param return_timeout
		var qrReturnTimeout int64
		if o.ReturnTimeout != nil {
			qrReturnTimeout = *o.ReturnTimeout
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {
			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}

	}

	if o.Svm != nil {

		// query param svm
		var qrSvm string
		if o.Svm != nil {
			qrSvm = *o.Svm
		}
		qSvm := qrSvm
		if qSvm != "" {
			if err := r.SetQueryParam("svm", qSvm); err != nil {
				return err
			}
		}

	}

	if o.SvmName != nil {

		// query param svm.name
		var qrSvmName string
		if o.SvmName != nil {
			qrSvmName = *o.SvmName
		}
		qSvmName := qrSvmName
		if qSvmName != "" {
			if err := r.SetQueryParam("svm.name", qSvmName); err != nil {
				return err
			}
		}

	}

	if o.SvmUUID != nil {

		// query param svm.uuid
		var qrSvmUUID string
		if o.SvmUUID != nil {
			qrSvmUUID = *o.SvmUUID
		}
		qSvmUUID := qrSvmUUID
		if qSvmUUID != "" {
			if err := r.SetQueryParam("svm.uuid", qSvmUUID); err != nil {
				return err
			}
		}

	}

	if o.UUID != nil {

		// query param uuid
		var qrUUID string
		if o.UUID != nil {
			qrUUID = *o.UUID
		}
		qUUID := qrUUID
		if qUUID != "" {
			if err := r.SetQueryParam("uuid", qUUID); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
