// Code generated by go-swagger; DO NOT EDIT.

package storage

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/greenqloud/ontap-rest-client/ntapmodel"
)

// NewQosPolicyCreateParams creates a new QosPolicyCreateParams object
// with the default values initialized.
func NewQosPolicyCreateParams() *QosPolicyCreateParams {
	var (
		returnRecordsDefault = bool(false)
		returnTimeoutDefault = int64(0)
	)
	return &QosPolicyCreateParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewQosPolicyCreateParamsWithTimeout creates a new QosPolicyCreateParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewQosPolicyCreateParamsWithTimeout(timeout time.Duration) *QosPolicyCreateParams {
	var (
		returnRecordsDefault = bool(false)
		returnTimeoutDefault = int64(0)
	)
	return &QosPolicyCreateParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		timeout: timeout,
	}
}

// NewQosPolicyCreateParamsWithContext creates a new QosPolicyCreateParams object
// with the default values initialized, and the ability to set a context for a request
func NewQosPolicyCreateParamsWithContext(ctx context.Context) *QosPolicyCreateParams {
	var (
		returnRecordsDefault = bool(false)
		returnTimeoutDefault = int64(0)
	)
	return &QosPolicyCreateParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		Context: ctx,
	}
}

// NewQosPolicyCreateParamsWithHTTPClient creates a new QosPolicyCreateParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewQosPolicyCreateParamsWithHTTPClient(client *http.Client) *QosPolicyCreateParams {
	var (
		returnRecordsDefault = bool(false)
		returnTimeoutDefault = int64(0)
	)
	return &QosPolicyCreateParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,
		HTTPClient:    client,
	}
}

/*QosPolicyCreateParams contains all the parameters to send to the API endpoint
for the qos policy create operation typically these are written to a http.Request
*/
type QosPolicyCreateParams struct {

	/*Info
	  Info specification

	*/
	Info *ntapmodel.QosPolicy
	/*ReturnRecords
	  The default is false.  If set to true, the records are returned.

	*/
	ReturnRecords *bool
	/*ReturnTimeout
	  The number of seconds to allow the call to execute before returning. When doing a POST, PATCH, or DELETE operation on a single record, the default is 0 seconds.  This means that if an asynchronous operation is started, the server immediately returns HTTP code 202 (Accepted) along with a link to the job.  If a non-zero value is specified for POST, PATCH, or DELETE operations, ONTAP waits that length of time to see if the job completes so it can return something other than 202.

	*/
	ReturnTimeout *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the qos policy create params
func (o *QosPolicyCreateParams) WithTimeout(timeout time.Duration) *QosPolicyCreateParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the qos policy create params
func (o *QosPolicyCreateParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the qos policy create params
func (o *QosPolicyCreateParams) WithContext(ctx context.Context) *QosPolicyCreateParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the qos policy create params
func (o *QosPolicyCreateParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the qos policy create params
func (o *QosPolicyCreateParams) WithHTTPClient(client *http.Client) *QosPolicyCreateParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the qos policy create params
func (o *QosPolicyCreateParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithInfo adds the info to the qos policy create params
func (o *QosPolicyCreateParams) WithInfo(info *ntapmodel.QosPolicy) *QosPolicyCreateParams {
	o.SetInfo(info)
	return o
}

// SetInfo adds the info to the qos policy create params
func (o *QosPolicyCreateParams) SetInfo(info *ntapmodel.QosPolicy) {
	o.Info = info
}

// WithReturnRecords adds the returnRecords to the qos policy create params
func (o *QosPolicyCreateParams) WithReturnRecords(returnRecords *bool) *QosPolicyCreateParams {
	o.SetReturnRecords(returnRecords)
	return o
}

// SetReturnRecords adds the returnRecords to the qos policy create params
func (o *QosPolicyCreateParams) SetReturnRecords(returnRecords *bool) {
	o.ReturnRecords = returnRecords
}

// WithReturnTimeout adds the returnTimeout to the qos policy create params
func (o *QosPolicyCreateParams) WithReturnTimeout(returnTimeout *int64) *QosPolicyCreateParams {
	o.SetReturnTimeout(returnTimeout)
	return o
}

// SetReturnTimeout adds the returnTimeout to the qos policy create params
func (o *QosPolicyCreateParams) SetReturnTimeout(returnTimeout *int64) {
	o.ReturnTimeout = returnTimeout
}

// WriteToRequest writes these params to a swagger request
func (o *QosPolicyCreateParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Info != nil {
		if err := r.SetBodyParam(o.Info); err != nil {
			return err
		}
	}

	if o.ReturnRecords != nil {

		// query param return_records
		var qrReturnRecords bool
		if o.ReturnRecords != nil {
			qrReturnRecords = *o.ReturnRecords
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {
			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}

	}

	if o.ReturnTimeout != nil {

		// query param return_timeout
		var qrReturnTimeout int64
		if o.ReturnTimeout != nil {
			qrReturnTimeout = *o.ReturnTimeout
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {
			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
