// Code generated by go-swagger; DO NOT EDIT.

package storage

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/greenqloud/ontap-rest-client/ntapmodel"
)

// QosPolicyCreateReader is a Reader for the QosPolicyCreate structure.
type QosPolicyCreateReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *QosPolicyCreateReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 202:
		result := NewQosPolicyCreateAccepted()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewQosPolicyCreateDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewQosPolicyCreateAccepted creates a QosPolicyCreateAccepted with default headers values
func NewQosPolicyCreateAccepted() *QosPolicyCreateAccepted {
	return &QosPolicyCreateAccepted{}
}

/*QosPolicyCreateAccepted handles this case with default header values.

Accepted
*/
type QosPolicyCreateAccepted struct {
	Payload *ntapmodel.JobLinkResponse
}

func (o *QosPolicyCreateAccepted) Error() string {
	return fmt.Sprintf("[POST /storage/qos/policies][%d] qosPolicyCreateAccepted  %+v", 202, o.Payload)
}

func (o *QosPolicyCreateAccepted) GetPayload() *ntapmodel.JobLinkResponse {
	return o.Payload
}

func (o *QosPolicyCreateAccepted) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(ntapmodel.JobLinkResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewQosPolicyCreateDefault creates a QosPolicyCreateDefault with default headers values
func NewQosPolicyCreateDefault(code int) *QosPolicyCreateDefault {
	return &QosPolicyCreateDefault{
		_statusCode: code,
	}
}

/*QosPolicyCreateDefault handles this case with default header values.

ONTAP Error Response Codes
| Error Code | Description |
| ---------- | ----------- |
| 8454147 | The maximum limit for QoS policies has been reached. |
| 8454154 | The name specified for creating conflicts with an existing QoS policy name. |
| 8454260 | Invalid value for maximum and minimum fields. Valid values for max_throughput_iops and max_throughput_mbps combination is for the ratio of max_throughput_mbps and max_throughput_iops to be within 1 to 4096. |
| 8454273 | Invalid value for an adaptive field. Value should be non-zero. |
| 8454277 | The name specified for creating an adaptive QoS policy conflicts with an existing fixed QoS policy name. |
| 8454278 | The name specified for creating a fixed QoS policy conflicts with an existing adaptive QoS policy name. |

*/
type QosPolicyCreateDefault struct {
	_statusCode int

	Payload *ntapmodel.ErrorResponse
}

// Code gets the status code for the qos policy create default response
func (o *QosPolicyCreateDefault) Code() int {
	return o._statusCode
}

func (o *QosPolicyCreateDefault) Error() string {
	return fmt.Sprintf("[POST /storage/qos/policies][%d] qos_policy_create default  %+v", o._statusCode, o.Payload)
}

func (o *QosPolicyCreateDefault) GetPayload() *ntapmodel.ErrorResponse {
	return o.Payload
}

func (o *QosPolicyCreateDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(ntapmodel.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
