// Code generated by go-swagger; DO NOT EDIT.

package storage

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewQosPolicyDeleteParams creates a new QosPolicyDeleteParams object
// with the default values initialized.
func NewQosPolicyDeleteParams() *QosPolicyDeleteParams {
	var (
		returnTimeoutDefault = int64(0)
	)
	return &QosPolicyDeleteParams{
		ReturnTimeout: &returnTimeoutDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewQosPolicyDeleteParamsWithTimeout creates a new QosPolicyDeleteParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewQosPolicyDeleteParamsWithTimeout(timeout time.Duration) *QosPolicyDeleteParams {
	var (
		returnTimeoutDefault = int64(0)
	)
	return &QosPolicyDeleteParams{
		ReturnTimeout: &returnTimeoutDefault,

		timeout: timeout,
	}
}

// NewQosPolicyDeleteParamsWithContext creates a new QosPolicyDeleteParams object
// with the default values initialized, and the ability to set a context for a request
func NewQosPolicyDeleteParamsWithContext(ctx context.Context) *QosPolicyDeleteParams {
	var (
		returnTimeoutDefault = int64(0)
	)
	return &QosPolicyDeleteParams{
		ReturnTimeout: &returnTimeoutDefault,

		Context: ctx,
	}
}

// NewQosPolicyDeleteParamsWithHTTPClient creates a new QosPolicyDeleteParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewQosPolicyDeleteParamsWithHTTPClient(client *http.Client) *QosPolicyDeleteParams {
	var (
		returnTimeoutDefault = int64(0)
	)
	return &QosPolicyDeleteParams{
		ReturnTimeout: &returnTimeoutDefault,
		HTTPClient:    client,
	}
}

/*QosPolicyDeleteParams contains all the parameters to send to the API endpoint
for the qos policy delete operation typically these are written to a http.Request
*/
type QosPolicyDeleteParams struct {

	/*ReturnTimeout
	  The number of seconds to allow the call to execute before returning. When doing a POST, PATCH, or DELETE operation on a single record, the default is 0 seconds.  This means that if an asynchronous operation is started, the server immediately returns HTTP code 202 (Accepted) along with a link to the job.  If a non-zero value is specified for POST, PATCH, or DELETE operations, ONTAP waits that length of time to see if the job completes so it can return something other than 202.

	*/
	ReturnTimeout *int64
	/*UUID*/
	UUID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the qos policy delete params
func (o *QosPolicyDeleteParams) WithTimeout(timeout time.Duration) *QosPolicyDeleteParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the qos policy delete params
func (o *QosPolicyDeleteParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the qos policy delete params
func (o *QosPolicyDeleteParams) WithContext(ctx context.Context) *QosPolicyDeleteParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the qos policy delete params
func (o *QosPolicyDeleteParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the qos policy delete params
func (o *QosPolicyDeleteParams) WithHTTPClient(client *http.Client) *QosPolicyDeleteParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the qos policy delete params
func (o *QosPolicyDeleteParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithReturnTimeout adds the returnTimeout to the qos policy delete params
func (o *QosPolicyDeleteParams) WithReturnTimeout(returnTimeout *int64) *QosPolicyDeleteParams {
	o.SetReturnTimeout(returnTimeout)
	return o
}

// SetReturnTimeout adds the returnTimeout to the qos policy delete params
func (o *QosPolicyDeleteParams) SetReturnTimeout(returnTimeout *int64) {
	o.ReturnTimeout = returnTimeout
}

// WithUUID adds the uuid to the qos policy delete params
func (o *QosPolicyDeleteParams) WithUUID(uuid string) *QosPolicyDeleteParams {
	o.SetUUID(uuid)
	return o
}

// SetUUID adds the uuid to the qos policy delete params
func (o *QosPolicyDeleteParams) SetUUID(uuid string) {
	o.UUID = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *QosPolicyDeleteParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.ReturnTimeout != nil {

		// query param return_timeout
		var qrReturnTimeout int64
		if o.ReturnTimeout != nil {
			qrReturnTimeout = *o.ReturnTimeout
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {
			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}

	}

	// path param uuid
	if err := r.SetPathParam("uuid", o.UUID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
