// Code generated by go-swagger; DO NOT EDIT.

package storage

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/greenqloud/ontap-rest-client/ntapmodel"
)

// NewStorageVolumesUUIDSnapshotsPostParams creates a new StorageVolumesUUIDSnapshotsPostParams object
// with the default values initialized.
func NewStorageVolumesUUIDSnapshotsPostParams() *StorageVolumesUUIDSnapshotsPostParams {
	var (
		returnRecordsDefault = bool(false)
		returnTimeoutDefault = int64(0)
	)
	return &StorageVolumesUUIDSnapshotsPostParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewStorageVolumesUUIDSnapshotsPostParamsWithTimeout creates a new StorageVolumesUUIDSnapshotsPostParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewStorageVolumesUUIDSnapshotsPostParamsWithTimeout(timeout time.Duration) *StorageVolumesUUIDSnapshotsPostParams {
	var (
		returnRecordsDefault = bool(false)
		returnTimeoutDefault = int64(0)
	)
	return &StorageVolumesUUIDSnapshotsPostParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		timeout: timeout,
	}
}

// NewStorageVolumesUUIDSnapshotsPostParamsWithContext creates a new StorageVolumesUUIDSnapshotsPostParams object
// with the default values initialized, and the ability to set a context for a request
func NewStorageVolumesUUIDSnapshotsPostParamsWithContext(ctx context.Context) *StorageVolumesUUIDSnapshotsPostParams {
	var (
		returnRecordsDefault = bool(false)
		returnTimeoutDefault = int64(0)
	)
	return &StorageVolumesUUIDSnapshotsPostParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		Context: ctx,
	}
}

// NewStorageVolumesUUIDSnapshotsPostParamsWithHTTPClient creates a new StorageVolumesUUIDSnapshotsPostParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewStorageVolumesUUIDSnapshotsPostParamsWithHTTPClient(client *http.Client) *StorageVolumesUUIDSnapshotsPostParams {
	var (
		returnRecordsDefault = bool(false)
		returnTimeoutDefault = int64(0)
	)
	return &StorageVolumesUUIDSnapshotsPostParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,
		HTTPClient:    client,
	}
}

/*StorageVolumesUUIDSnapshotsPostParams contains all the parameters to send to the API endpoint
for the storage volumes uuid snapshots post operation typically these are written to a http.Request
*/
type StorageVolumesUUIDSnapshotsPostParams struct {

	/*Info
	  snapshot information

	*/
	Info *ntapmodel.SnapshotPost
	/*ReturnRecords
	  The default is false.  If set to true, the records are returned.

	*/
	ReturnRecords *bool
	/*ReturnTimeout
	  The number of seconds to allow the call to execute before returning. When doing a POST, PATCH, or DELETE operation on a single record, the default is 0 seconds.  This means that if an asynchronous operation is started, the server immediately returns HTTP code 202 (Accepted) along with a link to the job.  If a non-zero value is specified for POST, PATCH, or DELETE operations, ONTAP waits that length of time to see if the job completes so it can return something other than 202.

	*/
	ReturnTimeout *int64
	/*UUID
	  volume uuid

	*/
	UUID strfmt.UUID

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the storage volumes uuid snapshots post params
func (o *StorageVolumesUUIDSnapshotsPostParams) WithTimeout(timeout time.Duration) *StorageVolumesUUIDSnapshotsPostParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the storage volumes uuid snapshots post params
func (o *StorageVolumesUUIDSnapshotsPostParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the storage volumes uuid snapshots post params
func (o *StorageVolumesUUIDSnapshotsPostParams) WithContext(ctx context.Context) *StorageVolumesUUIDSnapshotsPostParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the storage volumes uuid snapshots post params
func (o *StorageVolumesUUIDSnapshotsPostParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the storage volumes uuid snapshots post params
func (o *StorageVolumesUUIDSnapshotsPostParams) WithHTTPClient(client *http.Client) *StorageVolumesUUIDSnapshotsPostParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the storage volumes uuid snapshots post params
func (o *StorageVolumesUUIDSnapshotsPostParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithInfo adds the info to the storage volumes uuid snapshots post params
func (o *StorageVolumesUUIDSnapshotsPostParams) WithInfo(info *ntapmodel.SnapshotPost) *StorageVolumesUUIDSnapshotsPostParams {
	o.SetInfo(info)
	return o
}

// SetInfo adds the info to the storage volumes uuid snapshots post params
func (o *StorageVolumesUUIDSnapshotsPostParams) SetInfo(info *ntapmodel.SnapshotPost) {
	o.Info = info
}

// WithReturnRecords adds the returnRecords to the storage volumes uuid snapshots post params
func (o *StorageVolumesUUIDSnapshotsPostParams) WithReturnRecords(returnRecords *bool) *StorageVolumesUUIDSnapshotsPostParams {
	o.SetReturnRecords(returnRecords)
	return o
}

// SetReturnRecords adds the returnRecords to the storage volumes uuid snapshots post params
func (o *StorageVolumesUUIDSnapshotsPostParams) SetReturnRecords(returnRecords *bool) {
	o.ReturnRecords = returnRecords
}

// WithReturnTimeout adds the returnTimeout to the storage volumes uuid snapshots post params
func (o *StorageVolumesUUIDSnapshotsPostParams) WithReturnTimeout(returnTimeout *int64) *StorageVolumesUUIDSnapshotsPostParams {
	o.SetReturnTimeout(returnTimeout)
	return o
}

// SetReturnTimeout adds the returnTimeout to the storage volumes uuid snapshots post params
func (o *StorageVolumesUUIDSnapshotsPostParams) SetReturnTimeout(returnTimeout *int64) {
	o.ReturnTimeout = returnTimeout
}

// WithUUID adds the uuid to the storage volumes uuid snapshots post params
func (o *StorageVolumesUUIDSnapshotsPostParams) WithUUID(uuid strfmt.UUID) *StorageVolumesUUIDSnapshotsPostParams {
	o.SetUUID(uuid)
	return o
}

// SetUUID adds the uuid to the storage volumes uuid snapshots post params
func (o *StorageVolumesUUIDSnapshotsPostParams) SetUUID(uuid strfmt.UUID) {
	o.UUID = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *StorageVolumesUUIDSnapshotsPostParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Info != nil {
		if err := r.SetBodyParam(o.Info); err != nil {
			return err
		}
	}

	if o.ReturnRecords != nil {

		// query param return_records
		var qrReturnRecords bool
		if o.ReturnRecords != nil {
			qrReturnRecords = *o.ReturnRecords
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {
			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}

	}

	if o.ReturnTimeout != nil {

		// query param return_timeout
		var qrReturnTimeout int64
		if o.ReturnTimeout != nil {
			qrReturnTimeout = *o.ReturnTimeout
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {
			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}

	}

	// path param uuid
	if err := r.SetPathParam("uuid", o.UUID.String()); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
