// Code generated by go-swagger; DO NOT EDIT.

package storage

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewVolumeCollectionGetParams creates a new VolumeCollectionGetParams object
// with the default values initialized.
func NewVolumeCollectionGetParams() *VolumeCollectionGetParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &VolumeCollectionGetParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewVolumeCollectionGetParamsWithTimeout creates a new VolumeCollectionGetParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewVolumeCollectionGetParamsWithTimeout(timeout time.Duration) *VolumeCollectionGetParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &VolumeCollectionGetParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		timeout: timeout,
	}
}

// NewVolumeCollectionGetParamsWithContext creates a new VolumeCollectionGetParams object
// with the default values initialized, and the ability to set a context for a request
func NewVolumeCollectionGetParamsWithContext(ctx context.Context) *VolumeCollectionGetParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &VolumeCollectionGetParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		Context: ctx,
	}
}

// NewVolumeCollectionGetParamsWithHTTPClient creates a new VolumeCollectionGetParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewVolumeCollectionGetParamsWithHTTPClient(client *http.Client) *VolumeCollectionGetParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &VolumeCollectionGetParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,
		HTTPClient:    client,
	}
}

/*VolumeCollectionGetParams contains all the parameters to send to the API endpoint
for the volume collection get operation typically these are written to a http.Request
*/
type VolumeCollectionGetParams struct {

	/*AggregatesName
	  Filter by aggregates.name

	*/
	AggregatesName *string
	/*AggregatesUUID
	  Filter by aggregates.uuid

	*/
	AggregatesUUID *string
	/*ApplicationName
	  Filter by application.name

	*/
	ApplicationName *string
	/*ApplicationUUID
	  Filter by application.uuid

	*/
	ApplicationUUID *string
	/*AutosizeGrowThreshold
	  Filter by autosize.grow_threshold

	*/
	AutosizeGrowThreshold *int64
	/*AutosizeMaximum
	  Filter by autosize.maximum

	*/
	AutosizeMaximum *int64
	/*AutosizeMinimum
	  Filter by autosize.minimum

	*/
	AutosizeMinimum *int64
	/*AutosizeMode
	  Filter by autosize.mode

	*/
	AutosizeMode *string
	/*AutosizeShrinkThreshold
	  Filter by autosize.shrink_threshold

	*/
	AutosizeShrinkThreshold *int64
	/*CloneIsFlexclone
	  Filter by clone.is_flexclone

	*/
	CloneIsFlexclone *bool
	/*CloneParentSnapshotName
	  Filter by clone.parent_snapshot.name

	*/
	CloneParentSnapshotName *string
	/*CloneParentSnapshotUUID
	  Filter by clone.parent_snapshot.uuid

	*/
	CloneParentSnapshotUUID *string
	/*CloneParentSvmName
	  Filter by clone.parent_svm.name

	*/
	CloneParentSvmName *string
	/*CloneParentSvmUUID
	  Filter by clone.parent_svm.uuid

	*/
	CloneParentSvmUUID *string
	/*CloneParentVolumeName
	  Filter by clone.parent_volume.name

	*/
	CloneParentVolumeName *string
	/*CloneParentVolumeUUID
	  Filter by clone.parent_volume.uuid

	*/
	CloneParentVolumeUUID *string
	/*CloneSplitCompletePercent
	  Filter by clone.split_complete_percent

	*/
	CloneSplitCompletePercent *int64
	/*CloneSplitEstimate
	  Filter by clone.split_estimate

	*/
	CloneSplitEstimate *int64
	/*CloneSplitInitiated
	  Filter by clone.split_initiated

	*/
	CloneSplitInitiated *bool
	/*Comment
	  Filter by comment

	*/
	Comment *string
	/*ConsistencyGroupName
	  Filter by consistency_group.name

	*/
	ConsistencyGroupName *string
	/*CreateTime
	  Filter by create_time

	*/
	CreateTime *string
	/*EfficiencyCompaction
	  Filter by efficiency.compaction

	*/
	EfficiencyCompaction *string
	/*EfficiencyCompression
	  Filter by efficiency.compression

	*/
	EfficiencyCompression *string
	/*EfficiencyCrossVolumeDedupe
	  Filter by efficiency.cross_volume_dedupe

	*/
	EfficiencyCrossVolumeDedupe *string
	/*EfficiencyDedupe
	  Filter by efficiency.dedupe

	*/
	EfficiencyDedupe *string
	/*EfficiencyPolicyName
	  Filter by efficiency.policy.name

	*/
	EfficiencyPolicyName *string
	/*EncryptionEnabled
	  Filter by encryption.enabled

	*/
	EncryptionEnabled *bool
	/*EncryptionKeyID
	  Filter by encryption.key_id

	*/
	EncryptionKeyID *string
	/*EncryptionRekey
	  Filter by encryption.rekey

	*/
	EncryptionRekey *bool
	/*EncryptionState
	  Filter by encryption.state

	*/
	EncryptionState *string
	/*EncryptionStatusCode
	  Filter by encryption.status.code

	*/
	EncryptionStatusCode *string
	/*EncryptionStatusMessage
	  Filter by encryption.status.message

	*/
	EncryptionStatusMessage *string
	/*EncryptionType
	  Filter by encryption.type

	*/
	EncryptionType *string
	/*ErrorStateHasBadBlocks
	  Filter by error_state.has_bad_blocks

	*/
	ErrorStateHasBadBlocks *bool
	/*ErrorStateIsInconsistent
	  Filter by error_state.is_inconsistent

	*/
	ErrorStateIsInconsistent *bool
	/*Fields
	  Specify the fields to return.

	*/
	Fields []string
	/*FilesMaximum
	  Filter by files.maximum

	*/
	FilesMaximum *int64
	/*FilesUsed
	  Filter by files.used

	*/
	FilesUsed *int64
	/*FlexcacheEndpointType
	  Filter by flexcache_endpoint_type

	*/
	FlexcacheEndpointType *string
	/*GuaranteeHonored
	  Filter by guarantee.honored

	*/
	GuaranteeHonored *bool
	/*GuaranteeType
	  Filter by guarantee.type

	*/
	GuaranteeType *string
	/*IsSvmRoot
	  Filter by is_svm_root

	*/
	IsSvmRoot *bool
	/*Language
	  Filter by language

	*/
	Language *string
	/*MaxRecords
	  Limit the number of records returned.

	*/
	MaxRecords *int64
	/*MetricCloudDuration
	  Filter by metric.cloud.duration

	*/
	MetricCloudDuration *string
	/*MetricCloudIopsOther
	  Filter by metric.cloud.iops.other

	*/
	MetricCloudIopsOther *int64
	/*MetricCloudIopsRead
	  Filter by metric.cloud.iops.read

	*/
	MetricCloudIopsRead *int64
	/*MetricCloudIopsTotal
	  Filter by metric.cloud.iops.total

	*/
	MetricCloudIopsTotal *int64
	/*MetricCloudIopsWrite
	  Filter by metric.cloud.iops.write

	*/
	MetricCloudIopsWrite *int64
	/*MetricCloudLatencyOther
	  Filter by metric.cloud.latency.other

	*/
	MetricCloudLatencyOther *int64
	/*MetricCloudLatencyRead
	  Filter by metric.cloud.latency.read

	*/
	MetricCloudLatencyRead *int64
	/*MetricCloudLatencyTotal
	  Filter by metric.cloud.latency.total

	*/
	MetricCloudLatencyTotal *int64
	/*MetricCloudLatencyWrite
	  Filter by metric.cloud.latency.write

	*/
	MetricCloudLatencyWrite *int64
	/*MetricCloudStatus
	  Filter by metric.cloud.status

	*/
	MetricCloudStatus *string
	/*MetricCloudTimestamp
	  Filter by metric.cloud.timestamp

	*/
	MetricCloudTimestamp *string
	/*MetricDuration
	  Filter by metric.duration

	*/
	MetricDuration *string
	/*MetricIopsOther
	  Filter by metric.iops.other

	*/
	MetricIopsOther *int64
	/*MetricIopsRead
	  Filter by metric.iops.read

	*/
	MetricIopsRead *int64
	/*MetricIopsTotal
	  Filter by metric.iops.total

	*/
	MetricIopsTotal *int64
	/*MetricIopsWrite
	  Filter by metric.iops.write

	*/
	MetricIopsWrite *int64
	/*MetricLatencyOther
	  Filter by metric.latency.other

	*/
	MetricLatencyOther *int64
	/*MetricLatencyRead
	  Filter by metric.latency.read

	*/
	MetricLatencyRead *int64
	/*MetricLatencyTotal
	  Filter by metric.latency.total

	*/
	MetricLatencyTotal *int64
	/*MetricLatencyWrite
	  Filter by metric.latency.write

	*/
	MetricLatencyWrite *int64
	/*MetricStatus
	  Filter by metric.status

	*/
	MetricStatus *string
	/*MetricThroughputOther
	  Filter by metric.throughput.other

	*/
	MetricThroughputOther *int64
	/*MetricThroughputRead
	  Filter by metric.throughput.read

	*/
	MetricThroughputRead *int64
	/*MetricThroughputTotal
	  Filter by metric.throughput.total

	*/
	MetricThroughputTotal *int64
	/*MetricThroughputWrite
	  Filter by metric.throughput.write

	*/
	MetricThroughputWrite *int64
	/*MetricTimestamp
	  Filter by metric.timestamp

	*/
	MetricTimestamp *string
	/*MovementCutoverWindow
	  Filter by movement.cutover_window

	*/
	MovementCutoverWindow *int64
	/*MovementDestinationAggregateName
	  Filter by movement.destination_aggregate.name

	*/
	MovementDestinationAggregateName *string
	/*MovementDestinationAggregateUUID
	  Filter by movement.destination_aggregate.uuid

	*/
	MovementDestinationAggregateUUID *string
	/*MovementPercentComplete
	  Filter by movement.percent_complete

	*/
	MovementPercentComplete *int64
	/*MovementState
	  Filter by movement.state

	*/
	MovementState *string
	/*Name
	  Filter by name

	*/
	Name *string
	/*NasExportPolicyID
	  Filter by nas.export_policy.id

	*/
	NasExportPolicyID *int64
	/*NasExportPolicyName
	  Filter by nas.export_policy.name

	*/
	NasExportPolicyName *string
	/*NasGid
	  Filter by nas.gid

	*/
	NasGid *int64
	/*NasPath
	  Filter by nas.path

	*/
	NasPath *string
	/*NasSecurityStyle
	  Filter by nas.security_style

	*/
	NasSecurityStyle *string
	/*NasUID
	  Filter by nas.uid

	*/
	NasUID *int64
	/*NasUnixPermissions
	  Filter by nas.unix_permissions

	*/
	NasUnixPermissions *int64
	/*OrderBy
	  Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.

	*/
	OrderBy []string
	/*QosPolicyMaxThroughputIops
	  Filter by qos.policy.max_throughput_iops

	*/
	QosPolicyMaxThroughputIops *int64
	/*QosPolicyMaxThroughputMbps
	  Filter by qos.policy.max_throughput_mbps

	*/
	QosPolicyMaxThroughputMbps *int64
	/*QosPolicyMinThroughputIops
	  Filter by qos.policy.min_throughput_iops

	*/
	QosPolicyMinThroughputIops *int64
	/*QosPolicyName
	  Filter by qos.policy.name

	*/
	QosPolicyName *string
	/*QosPolicyUUID
	  Filter by qos.policy.uuid

	*/
	QosPolicyUUID *string
	/*QuotaState
	  Filter by quota.state

	*/
	QuotaState *string
	/*ReturnRecords
	  The default is true for GET calls.  When set to false, only the number of records is returned.

	*/
	ReturnRecords *bool
	/*ReturnTimeout
	  The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	*/
	ReturnTimeout *int64
	/*Size
	  Filter by size

	*/
	Size *int64
	/*SnaplockAppendModeEnabled
	  Filter by snaplock.append_mode_enabled

	*/
	SnaplockAppendModeEnabled *bool
	/*SnaplockAutocommitPeriod
	  Filter by snaplock.autocommit_period

	*/
	SnaplockAutocommitPeriod *string
	/*SnaplockComplianceClockTime
	  Filter by snaplock.compliance_clock_time

	*/
	SnaplockComplianceClockTime *string
	/*SnaplockExpiryTime
	  Filter by snaplock.expiry_time

	*/
	SnaplockExpiryTime *string
	/*SnaplockIsAuditLog
	  Filter by snaplock.is_audit_log

	*/
	SnaplockIsAuditLog *bool
	/*SnaplockLitigationCount
	  Filter by snaplock.litigation_count

	*/
	SnaplockLitigationCount *int64
	/*SnaplockPrivilegedDelete
	  Filter by snaplock.privileged_delete

	*/
	SnaplockPrivilegedDelete *string
	/*SnaplockRetentionDefault
	  Filter by snaplock.retention.default

	*/
	SnaplockRetentionDefault *string
	/*SnaplockRetentionMaximum
	  Filter by snaplock.retention.maximum

	*/
	SnaplockRetentionMaximum *string
	/*SnaplockRetentionMinimum
	  Filter by snaplock.retention.minimum

	*/
	SnaplockRetentionMinimum *string
	/*SnaplockType
	  Filter by snaplock.type

	*/
	SnaplockType *string
	/*SnapmirrorIsProtected
	  Filter by snapmirror.is_protected

	*/
	SnapmirrorIsProtected *bool
	/*SnapshotPolicyName
	  Filter by snapshot_policy.name

	*/
	SnapshotPolicyName *string
	/*SnapshotPolicyUUID
	  Filter by snapshot_policy.uuid

	*/
	SnapshotPolicyUUID *string
	/*SpaceAvailable
	  Filter by space.available

	*/
	SpaceAvailable *int64
	/*SpaceBlockStorageInactiveUserData
	  Filter by space.block_storage_inactive_user_data

	*/
	SpaceBlockStorageInactiveUserData *int64
	/*SpaceCapacityTierFootprint
	  Filter by space.capacity_tier_footprint

	*/
	SpaceCapacityTierFootprint *int64
	/*SpaceFootprint
	  Filter by space.footprint

	*/
	SpaceFootprint *int64
	/*SpaceLogicalSpaceAvailable
	  Filter by space.logical_space.available

	*/
	SpaceLogicalSpaceAvailable *int64
	/*SpaceLogicalSpaceEnforcement
	  Filter by space.logical_space.enforcement

	*/
	SpaceLogicalSpaceEnforcement *bool
	/*SpaceLogicalSpaceReporting
	  Filter by space.logical_space.reporting

	*/
	SpaceLogicalSpaceReporting *bool
	/*SpaceLogicalSpaceUsedByAfs
	  Filter by space.logical_space.used_by_afs

	*/
	SpaceLogicalSpaceUsedByAfs *int64
	/*SpaceMetadata
	  Filter by space.metadata

	*/
	SpaceMetadata *int64
	/*SpaceOverProvisioned
	  Filter by space.over_provisioned

	*/
	SpaceOverProvisioned *int64
	/*SpaceSize
	  Filter by space.size

	*/
	SpaceSize *int64
	/*SpaceSnapshotReservePercent
	  Filter by space.snapshot.reserve_percent

	*/
	SpaceSnapshotReservePercent *int64
	/*SpaceSnapshotUsed
	  Filter by space.snapshot.used

	*/
	SpaceSnapshotUsed *int64
	/*SpaceUsed
	  Filter by space.used

	*/
	SpaceUsed *int64
	/*State
	  Filter by state

	*/
	State *string
	/*StatisticsCloudIopsRawOther
	  Filter by statistics.cloud.iops_raw.other

	*/
	StatisticsCloudIopsRawOther *int64
	/*StatisticsCloudIopsRawRead
	  Filter by statistics.cloud.iops_raw.read

	*/
	StatisticsCloudIopsRawRead *int64
	/*StatisticsCloudIopsRawTotal
	  Filter by statistics.cloud.iops_raw.total

	*/
	StatisticsCloudIopsRawTotal *int64
	/*StatisticsCloudIopsRawWrite
	  Filter by statistics.cloud.iops_raw.write

	*/
	StatisticsCloudIopsRawWrite *int64
	/*StatisticsCloudLatencyRawOther
	  Filter by statistics.cloud.latency_raw.other

	*/
	StatisticsCloudLatencyRawOther *int64
	/*StatisticsCloudLatencyRawRead
	  Filter by statistics.cloud.latency_raw.read

	*/
	StatisticsCloudLatencyRawRead *int64
	/*StatisticsCloudLatencyRawTotal
	  Filter by statistics.cloud.latency_raw.total

	*/
	StatisticsCloudLatencyRawTotal *int64
	/*StatisticsCloudLatencyRawWrite
	  Filter by statistics.cloud.latency_raw.write

	*/
	StatisticsCloudLatencyRawWrite *int64
	/*StatisticsCloudStatus
	  Filter by statistics.cloud.status

	*/
	StatisticsCloudStatus *string
	/*StatisticsCloudTimestamp
	  Filter by statistics.cloud.timestamp

	*/
	StatisticsCloudTimestamp *string
	/*StatisticsIopsRawOther
	  Filter by statistics.iops_raw.other

	*/
	StatisticsIopsRawOther *int64
	/*StatisticsIopsRawRead
	  Filter by statistics.iops_raw.read

	*/
	StatisticsIopsRawRead *int64
	/*StatisticsIopsRawTotal
	  Filter by statistics.iops_raw.total

	*/
	StatisticsIopsRawTotal *int64
	/*StatisticsIopsRawWrite
	  Filter by statistics.iops_raw.write

	*/
	StatisticsIopsRawWrite *int64
	/*StatisticsLatencyRawOther
	  Filter by statistics.latency_raw.other

	*/
	StatisticsLatencyRawOther *int64
	/*StatisticsLatencyRawRead
	  Filter by statistics.latency_raw.read

	*/
	StatisticsLatencyRawRead *int64
	/*StatisticsLatencyRawTotal
	  Filter by statistics.latency_raw.total

	*/
	StatisticsLatencyRawTotal *int64
	/*StatisticsLatencyRawWrite
	  Filter by statistics.latency_raw.write

	*/
	StatisticsLatencyRawWrite *int64
	/*StatisticsStatus
	  Filter by statistics.status

	*/
	StatisticsStatus *string
	/*StatisticsThroughputRawOther
	  Filter by statistics.throughput_raw.other

	*/
	StatisticsThroughputRawOther *int64
	/*StatisticsThroughputRawRead
	  Filter by statistics.throughput_raw.read

	*/
	StatisticsThroughputRawRead *int64
	/*StatisticsThroughputRawTotal
	  Filter by statistics.throughput_raw.total

	*/
	StatisticsThroughputRawTotal *int64
	/*StatisticsThroughputRawWrite
	  Filter by statistics.throughput_raw.write

	*/
	StatisticsThroughputRawWrite *int64
	/*StatisticsTimestamp
	  Filter by statistics.timestamp

	*/
	StatisticsTimestamp *string
	/*Style
	  Filter by style

	*/
	Style *string
	/*Svm
	  Filter by svm (alias of svm.name)

	*/
	Svm *string
	/*SvmName
	  Filter by svm.name

	*/
	SvmName *string
	/*SvmUUID
	  Filter by svm.uuid

	*/
	SvmUUID *string
	/*TieringPolicy
	  Filter by tiering.policy

	*/
	TieringPolicy *string
	/*Type
	  Filter by type

	*/
	Type *string
	/*UUID
	  Filter by uuid

	*/
	UUID *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the volume collection get params
func (o *VolumeCollectionGetParams) WithTimeout(timeout time.Duration) *VolumeCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the volume collection get params
func (o *VolumeCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the volume collection get params
func (o *VolumeCollectionGetParams) WithContext(ctx context.Context) *VolumeCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the volume collection get params
func (o *VolumeCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the volume collection get params
func (o *VolumeCollectionGetParams) WithHTTPClient(client *http.Client) *VolumeCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the volume collection get params
func (o *VolumeCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAggregatesName adds the aggregatesName to the volume collection get params
func (o *VolumeCollectionGetParams) WithAggregatesName(aggregatesName *string) *VolumeCollectionGetParams {
	o.SetAggregatesName(aggregatesName)
	return o
}

// SetAggregatesName adds the aggregatesName to the volume collection get params
func (o *VolumeCollectionGetParams) SetAggregatesName(aggregatesName *string) {
	o.AggregatesName = aggregatesName
}

// WithAggregatesUUID adds the aggregatesUUID to the volume collection get params
func (o *VolumeCollectionGetParams) WithAggregatesUUID(aggregatesUUID *string) *VolumeCollectionGetParams {
	o.SetAggregatesUUID(aggregatesUUID)
	return o
}

// SetAggregatesUUID adds the aggregatesUuid to the volume collection get params
func (o *VolumeCollectionGetParams) SetAggregatesUUID(aggregatesUUID *string) {
	o.AggregatesUUID = aggregatesUUID
}

// WithApplicationName adds the applicationName to the volume collection get params
func (o *VolumeCollectionGetParams) WithApplicationName(applicationName *string) *VolumeCollectionGetParams {
	o.SetApplicationName(applicationName)
	return o
}

// SetApplicationName adds the applicationName to the volume collection get params
func (o *VolumeCollectionGetParams) SetApplicationName(applicationName *string) {
	o.ApplicationName = applicationName
}

// WithApplicationUUID adds the applicationUUID to the volume collection get params
func (o *VolumeCollectionGetParams) WithApplicationUUID(applicationUUID *string) *VolumeCollectionGetParams {
	o.SetApplicationUUID(applicationUUID)
	return o
}

// SetApplicationUUID adds the applicationUuid to the volume collection get params
func (o *VolumeCollectionGetParams) SetApplicationUUID(applicationUUID *string) {
	o.ApplicationUUID = applicationUUID
}

// WithAutosizeGrowThreshold adds the autosizeGrowThreshold to the volume collection get params
func (o *VolumeCollectionGetParams) WithAutosizeGrowThreshold(autosizeGrowThreshold *int64) *VolumeCollectionGetParams {
	o.SetAutosizeGrowThreshold(autosizeGrowThreshold)
	return o
}

// SetAutosizeGrowThreshold adds the autosizeGrowThreshold to the volume collection get params
func (o *VolumeCollectionGetParams) SetAutosizeGrowThreshold(autosizeGrowThreshold *int64) {
	o.AutosizeGrowThreshold = autosizeGrowThreshold
}

// WithAutosizeMaximum adds the autosizeMaximum to the volume collection get params
func (o *VolumeCollectionGetParams) WithAutosizeMaximum(autosizeMaximum *int64) *VolumeCollectionGetParams {
	o.SetAutosizeMaximum(autosizeMaximum)
	return o
}

// SetAutosizeMaximum adds the autosizeMaximum to the volume collection get params
func (o *VolumeCollectionGetParams) SetAutosizeMaximum(autosizeMaximum *int64) {
	o.AutosizeMaximum = autosizeMaximum
}

// WithAutosizeMinimum adds the autosizeMinimum to the volume collection get params
func (o *VolumeCollectionGetParams) WithAutosizeMinimum(autosizeMinimum *int64) *VolumeCollectionGetParams {
	o.SetAutosizeMinimum(autosizeMinimum)
	return o
}

// SetAutosizeMinimum adds the autosizeMinimum to the volume collection get params
func (o *VolumeCollectionGetParams) SetAutosizeMinimum(autosizeMinimum *int64) {
	o.AutosizeMinimum = autosizeMinimum
}

// WithAutosizeMode adds the autosizeMode to the volume collection get params
func (o *VolumeCollectionGetParams) WithAutosizeMode(autosizeMode *string) *VolumeCollectionGetParams {
	o.SetAutosizeMode(autosizeMode)
	return o
}

// SetAutosizeMode adds the autosizeMode to the volume collection get params
func (o *VolumeCollectionGetParams) SetAutosizeMode(autosizeMode *string) {
	o.AutosizeMode = autosizeMode
}

// WithAutosizeShrinkThreshold adds the autosizeShrinkThreshold to the volume collection get params
func (o *VolumeCollectionGetParams) WithAutosizeShrinkThreshold(autosizeShrinkThreshold *int64) *VolumeCollectionGetParams {
	o.SetAutosizeShrinkThreshold(autosizeShrinkThreshold)
	return o
}

// SetAutosizeShrinkThreshold adds the autosizeShrinkThreshold to the volume collection get params
func (o *VolumeCollectionGetParams) SetAutosizeShrinkThreshold(autosizeShrinkThreshold *int64) {
	o.AutosizeShrinkThreshold = autosizeShrinkThreshold
}

// WithCloneIsFlexclone adds the cloneIsFlexclone to the volume collection get params
func (o *VolumeCollectionGetParams) WithCloneIsFlexclone(cloneIsFlexclone *bool) *VolumeCollectionGetParams {
	o.SetCloneIsFlexclone(cloneIsFlexclone)
	return o
}

// SetCloneIsFlexclone adds the cloneIsFlexclone to the volume collection get params
func (o *VolumeCollectionGetParams) SetCloneIsFlexclone(cloneIsFlexclone *bool) {
	o.CloneIsFlexclone = cloneIsFlexclone
}

// WithCloneParentSnapshotName adds the cloneParentSnapshotName to the volume collection get params
func (o *VolumeCollectionGetParams) WithCloneParentSnapshotName(cloneParentSnapshotName *string) *VolumeCollectionGetParams {
	o.SetCloneParentSnapshotName(cloneParentSnapshotName)
	return o
}

// SetCloneParentSnapshotName adds the cloneParentSnapshotName to the volume collection get params
func (o *VolumeCollectionGetParams) SetCloneParentSnapshotName(cloneParentSnapshotName *string) {
	o.CloneParentSnapshotName = cloneParentSnapshotName
}

// WithCloneParentSnapshotUUID adds the cloneParentSnapshotUUID to the volume collection get params
func (o *VolumeCollectionGetParams) WithCloneParentSnapshotUUID(cloneParentSnapshotUUID *string) *VolumeCollectionGetParams {
	o.SetCloneParentSnapshotUUID(cloneParentSnapshotUUID)
	return o
}

// SetCloneParentSnapshotUUID adds the cloneParentSnapshotUuid to the volume collection get params
func (o *VolumeCollectionGetParams) SetCloneParentSnapshotUUID(cloneParentSnapshotUUID *string) {
	o.CloneParentSnapshotUUID = cloneParentSnapshotUUID
}

// WithCloneParentSvmName adds the cloneParentSvmName to the volume collection get params
func (o *VolumeCollectionGetParams) WithCloneParentSvmName(cloneParentSvmName *string) *VolumeCollectionGetParams {
	o.SetCloneParentSvmName(cloneParentSvmName)
	return o
}

// SetCloneParentSvmName adds the cloneParentSvmName to the volume collection get params
func (o *VolumeCollectionGetParams) SetCloneParentSvmName(cloneParentSvmName *string) {
	o.CloneParentSvmName = cloneParentSvmName
}

// WithCloneParentSvmUUID adds the cloneParentSvmUUID to the volume collection get params
func (o *VolumeCollectionGetParams) WithCloneParentSvmUUID(cloneParentSvmUUID *string) *VolumeCollectionGetParams {
	o.SetCloneParentSvmUUID(cloneParentSvmUUID)
	return o
}

// SetCloneParentSvmUUID adds the cloneParentSvmUuid to the volume collection get params
func (o *VolumeCollectionGetParams) SetCloneParentSvmUUID(cloneParentSvmUUID *string) {
	o.CloneParentSvmUUID = cloneParentSvmUUID
}

// WithCloneParentVolumeName adds the cloneParentVolumeName to the volume collection get params
func (o *VolumeCollectionGetParams) WithCloneParentVolumeName(cloneParentVolumeName *string) *VolumeCollectionGetParams {
	o.SetCloneParentVolumeName(cloneParentVolumeName)
	return o
}

// SetCloneParentVolumeName adds the cloneParentVolumeName to the volume collection get params
func (o *VolumeCollectionGetParams) SetCloneParentVolumeName(cloneParentVolumeName *string) {
	o.CloneParentVolumeName = cloneParentVolumeName
}

// WithCloneParentVolumeUUID adds the cloneParentVolumeUUID to the volume collection get params
func (o *VolumeCollectionGetParams) WithCloneParentVolumeUUID(cloneParentVolumeUUID *string) *VolumeCollectionGetParams {
	o.SetCloneParentVolumeUUID(cloneParentVolumeUUID)
	return o
}

// SetCloneParentVolumeUUID adds the cloneParentVolumeUuid to the volume collection get params
func (o *VolumeCollectionGetParams) SetCloneParentVolumeUUID(cloneParentVolumeUUID *string) {
	o.CloneParentVolumeUUID = cloneParentVolumeUUID
}

// WithCloneSplitCompletePercent adds the cloneSplitCompletePercent to the volume collection get params
func (o *VolumeCollectionGetParams) WithCloneSplitCompletePercent(cloneSplitCompletePercent *int64) *VolumeCollectionGetParams {
	o.SetCloneSplitCompletePercent(cloneSplitCompletePercent)
	return o
}

// SetCloneSplitCompletePercent adds the cloneSplitCompletePercent to the volume collection get params
func (o *VolumeCollectionGetParams) SetCloneSplitCompletePercent(cloneSplitCompletePercent *int64) {
	o.CloneSplitCompletePercent = cloneSplitCompletePercent
}

// WithCloneSplitEstimate adds the cloneSplitEstimate to the volume collection get params
func (o *VolumeCollectionGetParams) WithCloneSplitEstimate(cloneSplitEstimate *int64) *VolumeCollectionGetParams {
	o.SetCloneSplitEstimate(cloneSplitEstimate)
	return o
}

// SetCloneSplitEstimate adds the cloneSplitEstimate to the volume collection get params
func (o *VolumeCollectionGetParams) SetCloneSplitEstimate(cloneSplitEstimate *int64) {
	o.CloneSplitEstimate = cloneSplitEstimate
}

// WithCloneSplitInitiated adds the cloneSplitInitiated to the volume collection get params
func (o *VolumeCollectionGetParams) WithCloneSplitInitiated(cloneSplitInitiated *bool) *VolumeCollectionGetParams {
	o.SetCloneSplitInitiated(cloneSplitInitiated)
	return o
}

// SetCloneSplitInitiated adds the cloneSplitInitiated to the volume collection get params
func (o *VolumeCollectionGetParams) SetCloneSplitInitiated(cloneSplitInitiated *bool) {
	o.CloneSplitInitiated = cloneSplitInitiated
}

// WithComment adds the comment to the volume collection get params
func (o *VolumeCollectionGetParams) WithComment(comment *string) *VolumeCollectionGetParams {
	o.SetComment(comment)
	return o
}

// SetComment adds the comment to the volume collection get params
func (o *VolumeCollectionGetParams) SetComment(comment *string) {
	o.Comment = comment
}

// WithConsistencyGroupName adds the consistencyGroupName to the volume collection get params
func (o *VolumeCollectionGetParams) WithConsistencyGroupName(consistencyGroupName *string) *VolumeCollectionGetParams {
	o.SetConsistencyGroupName(consistencyGroupName)
	return o
}

// SetConsistencyGroupName adds the consistencyGroupName to the volume collection get params
func (o *VolumeCollectionGetParams) SetConsistencyGroupName(consistencyGroupName *string) {
	o.ConsistencyGroupName = consistencyGroupName
}

// WithCreateTime adds the createTime to the volume collection get params
func (o *VolumeCollectionGetParams) WithCreateTime(createTime *string) *VolumeCollectionGetParams {
	o.SetCreateTime(createTime)
	return o
}

// SetCreateTime adds the createTime to the volume collection get params
func (o *VolumeCollectionGetParams) SetCreateTime(createTime *string) {
	o.CreateTime = createTime
}

// WithEfficiencyCompaction adds the efficiencyCompaction to the volume collection get params
func (o *VolumeCollectionGetParams) WithEfficiencyCompaction(efficiencyCompaction *string) *VolumeCollectionGetParams {
	o.SetEfficiencyCompaction(efficiencyCompaction)
	return o
}

// SetEfficiencyCompaction adds the efficiencyCompaction to the volume collection get params
func (o *VolumeCollectionGetParams) SetEfficiencyCompaction(efficiencyCompaction *string) {
	o.EfficiencyCompaction = efficiencyCompaction
}

// WithEfficiencyCompression adds the efficiencyCompression to the volume collection get params
func (o *VolumeCollectionGetParams) WithEfficiencyCompression(efficiencyCompression *string) *VolumeCollectionGetParams {
	o.SetEfficiencyCompression(efficiencyCompression)
	return o
}

// SetEfficiencyCompression adds the efficiencyCompression to the volume collection get params
func (o *VolumeCollectionGetParams) SetEfficiencyCompression(efficiencyCompression *string) {
	o.EfficiencyCompression = efficiencyCompression
}

// WithEfficiencyCrossVolumeDedupe adds the efficiencyCrossVolumeDedupe to the volume collection get params
func (o *VolumeCollectionGetParams) WithEfficiencyCrossVolumeDedupe(efficiencyCrossVolumeDedupe *string) *VolumeCollectionGetParams {
	o.SetEfficiencyCrossVolumeDedupe(efficiencyCrossVolumeDedupe)
	return o
}

// SetEfficiencyCrossVolumeDedupe adds the efficiencyCrossVolumeDedupe to the volume collection get params
func (o *VolumeCollectionGetParams) SetEfficiencyCrossVolumeDedupe(efficiencyCrossVolumeDedupe *string) {
	o.EfficiencyCrossVolumeDedupe = efficiencyCrossVolumeDedupe
}

// WithEfficiencyDedupe adds the efficiencyDedupe to the volume collection get params
func (o *VolumeCollectionGetParams) WithEfficiencyDedupe(efficiencyDedupe *string) *VolumeCollectionGetParams {
	o.SetEfficiencyDedupe(efficiencyDedupe)
	return o
}

// SetEfficiencyDedupe adds the efficiencyDedupe to the volume collection get params
func (o *VolumeCollectionGetParams) SetEfficiencyDedupe(efficiencyDedupe *string) {
	o.EfficiencyDedupe = efficiencyDedupe
}

// WithEfficiencyPolicyName adds the efficiencyPolicyName to the volume collection get params
func (o *VolumeCollectionGetParams) WithEfficiencyPolicyName(efficiencyPolicyName *string) *VolumeCollectionGetParams {
	o.SetEfficiencyPolicyName(efficiencyPolicyName)
	return o
}

// SetEfficiencyPolicyName adds the efficiencyPolicyName to the volume collection get params
func (o *VolumeCollectionGetParams) SetEfficiencyPolicyName(efficiencyPolicyName *string) {
	o.EfficiencyPolicyName = efficiencyPolicyName
}

// WithEncryptionEnabled adds the encryptionEnabled to the volume collection get params
func (o *VolumeCollectionGetParams) WithEncryptionEnabled(encryptionEnabled *bool) *VolumeCollectionGetParams {
	o.SetEncryptionEnabled(encryptionEnabled)
	return o
}

// SetEncryptionEnabled adds the encryptionEnabled to the volume collection get params
func (o *VolumeCollectionGetParams) SetEncryptionEnabled(encryptionEnabled *bool) {
	o.EncryptionEnabled = encryptionEnabled
}

// WithEncryptionKeyID adds the encryptionKeyID to the volume collection get params
func (o *VolumeCollectionGetParams) WithEncryptionKeyID(encryptionKeyID *string) *VolumeCollectionGetParams {
	o.SetEncryptionKeyID(encryptionKeyID)
	return o
}

// SetEncryptionKeyID adds the encryptionKeyId to the volume collection get params
func (o *VolumeCollectionGetParams) SetEncryptionKeyID(encryptionKeyID *string) {
	o.EncryptionKeyID = encryptionKeyID
}

// WithEncryptionRekey adds the encryptionRekey to the volume collection get params
func (o *VolumeCollectionGetParams) WithEncryptionRekey(encryptionRekey *bool) *VolumeCollectionGetParams {
	o.SetEncryptionRekey(encryptionRekey)
	return o
}

// SetEncryptionRekey adds the encryptionRekey to the volume collection get params
func (o *VolumeCollectionGetParams) SetEncryptionRekey(encryptionRekey *bool) {
	o.EncryptionRekey = encryptionRekey
}

// WithEncryptionState adds the encryptionState to the volume collection get params
func (o *VolumeCollectionGetParams) WithEncryptionState(encryptionState *string) *VolumeCollectionGetParams {
	o.SetEncryptionState(encryptionState)
	return o
}

// SetEncryptionState adds the encryptionState to the volume collection get params
func (o *VolumeCollectionGetParams) SetEncryptionState(encryptionState *string) {
	o.EncryptionState = encryptionState
}

// WithEncryptionStatusCode adds the encryptionStatusCode to the volume collection get params
func (o *VolumeCollectionGetParams) WithEncryptionStatusCode(encryptionStatusCode *string) *VolumeCollectionGetParams {
	o.SetEncryptionStatusCode(encryptionStatusCode)
	return o
}

// SetEncryptionStatusCode adds the encryptionStatusCode to the volume collection get params
func (o *VolumeCollectionGetParams) SetEncryptionStatusCode(encryptionStatusCode *string) {
	o.EncryptionStatusCode = encryptionStatusCode
}

// WithEncryptionStatusMessage adds the encryptionStatusMessage to the volume collection get params
func (o *VolumeCollectionGetParams) WithEncryptionStatusMessage(encryptionStatusMessage *string) *VolumeCollectionGetParams {
	o.SetEncryptionStatusMessage(encryptionStatusMessage)
	return o
}

// SetEncryptionStatusMessage adds the encryptionStatusMessage to the volume collection get params
func (o *VolumeCollectionGetParams) SetEncryptionStatusMessage(encryptionStatusMessage *string) {
	o.EncryptionStatusMessage = encryptionStatusMessage
}

// WithEncryptionType adds the encryptionType to the volume collection get params
func (o *VolumeCollectionGetParams) WithEncryptionType(encryptionType *string) *VolumeCollectionGetParams {
	o.SetEncryptionType(encryptionType)
	return o
}

// SetEncryptionType adds the encryptionType to the volume collection get params
func (o *VolumeCollectionGetParams) SetEncryptionType(encryptionType *string) {
	o.EncryptionType = encryptionType
}

// WithErrorStateHasBadBlocks adds the errorStateHasBadBlocks to the volume collection get params
func (o *VolumeCollectionGetParams) WithErrorStateHasBadBlocks(errorStateHasBadBlocks *bool) *VolumeCollectionGetParams {
	o.SetErrorStateHasBadBlocks(errorStateHasBadBlocks)
	return o
}

// SetErrorStateHasBadBlocks adds the errorStateHasBadBlocks to the volume collection get params
func (o *VolumeCollectionGetParams) SetErrorStateHasBadBlocks(errorStateHasBadBlocks *bool) {
	o.ErrorStateHasBadBlocks = errorStateHasBadBlocks
}

// WithErrorStateIsInconsistent adds the errorStateIsInconsistent to the volume collection get params
func (o *VolumeCollectionGetParams) WithErrorStateIsInconsistent(errorStateIsInconsistent *bool) *VolumeCollectionGetParams {
	o.SetErrorStateIsInconsistent(errorStateIsInconsistent)
	return o
}

// SetErrorStateIsInconsistent adds the errorStateIsInconsistent to the volume collection get params
func (o *VolumeCollectionGetParams) SetErrorStateIsInconsistent(errorStateIsInconsistent *bool) {
	o.ErrorStateIsInconsistent = errorStateIsInconsistent
}

// WithFields adds the fields to the volume collection get params
func (o *VolumeCollectionGetParams) WithFields(fields []string) *VolumeCollectionGetParams {
	o.SetFields(fields)
	return o
}

// SetFields adds the fields to the volume collection get params
func (o *VolumeCollectionGetParams) SetFields(fields []string) {
	o.Fields = fields
}

// WithFilesMaximum adds the filesMaximum to the volume collection get params
func (o *VolumeCollectionGetParams) WithFilesMaximum(filesMaximum *int64) *VolumeCollectionGetParams {
	o.SetFilesMaximum(filesMaximum)
	return o
}

// SetFilesMaximum adds the filesMaximum to the volume collection get params
func (o *VolumeCollectionGetParams) SetFilesMaximum(filesMaximum *int64) {
	o.FilesMaximum = filesMaximum
}

// WithFilesUsed adds the filesUsed to the volume collection get params
func (o *VolumeCollectionGetParams) WithFilesUsed(filesUsed *int64) *VolumeCollectionGetParams {
	o.SetFilesUsed(filesUsed)
	return o
}

// SetFilesUsed adds the filesUsed to the volume collection get params
func (o *VolumeCollectionGetParams) SetFilesUsed(filesUsed *int64) {
	o.FilesUsed = filesUsed
}

// WithFlexcacheEndpointType adds the flexcacheEndpointType to the volume collection get params
func (o *VolumeCollectionGetParams) WithFlexcacheEndpointType(flexcacheEndpointType *string) *VolumeCollectionGetParams {
	o.SetFlexcacheEndpointType(flexcacheEndpointType)
	return o
}

// SetFlexcacheEndpointType adds the flexcacheEndpointType to the volume collection get params
func (o *VolumeCollectionGetParams) SetFlexcacheEndpointType(flexcacheEndpointType *string) {
	o.FlexcacheEndpointType = flexcacheEndpointType
}

// WithGuaranteeHonored adds the guaranteeHonored to the volume collection get params
func (o *VolumeCollectionGetParams) WithGuaranteeHonored(guaranteeHonored *bool) *VolumeCollectionGetParams {
	o.SetGuaranteeHonored(guaranteeHonored)
	return o
}

// SetGuaranteeHonored adds the guaranteeHonored to the volume collection get params
func (o *VolumeCollectionGetParams) SetGuaranteeHonored(guaranteeHonored *bool) {
	o.GuaranteeHonored = guaranteeHonored
}

// WithGuaranteeType adds the guaranteeType to the volume collection get params
func (o *VolumeCollectionGetParams) WithGuaranteeType(guaranteeType *string) *VolumeCollectionGetParams {
	o.SetGuaranteeType(guaranteeType)
	return o
}

// SetGuaranteeType adds the guaranteeType to the volume collection get params
func (o *VolumeCollectionGetParams) SetGuaranteeType(guaranteeType *string) {
	o.GuaranteeType = guaranteeType
}

// WithIsSvmRoot adds the isSvmRoot to the volume collection get params
func (o *VolumeCollectionGetParams) WithIsSvmRoot(isSvmRoot *bool) *VolumeCollectionGetParams {
	o.SetIsSvmRoot(isSvmRoot)
	return o
}

// SetIsSvmRoot adds the isSvmRoot to the volume collection get params
func (o *VolumeCollectionGetParams) SetIsSvmRoot(isSvmRoot *bool) {
	o.IsSvmRoot = isSvmRoot
}

// WithLanguage adds the language to the volume collection get params
func (o *VolumeCollectionGetParams) WithLanguage(language *string) *VolumeCollectionGetParams {
	o.SetLanguage(language)
	return o
}

// SetLanguage adds the language to the volume collection get params
func (o *VolumeCollectionGetParams) SetLanguage(language *string) {
	o.Language = language
}

// WithMaxRecords adds the maxRecords to the volume collection get params
func (o *VolumeCollectionGetParams) WithMaxRecords(maxRecords *int64) *VolumeCollectionGetParams {
	o.SetMaxRecords(maxRecords)
	return o
}

// SetMaxRecords adds the maxRecords to the volume collection get params
func (o *VolumeCollectionGetParams) SetMaxRecords(maxRecords *int64) {
	o.MaxRecords = maxRecords
}

// WithMetricCloudDuration adds the metricCloudDuration to the volume collection get params
func (o *VolumeCollectionGetParams) WithMetricCloudDuration(metricCloudDuration *string) *VolumeCollectionGetParams {
	o.SetMetricCloudDuration(metricCloudDuration)
	return o
}

// SetMetricCloudDuration adds the metricCloudDuration to the volume collection get params
func (o *VolumeCollectionGetParams) SetMetricCloudDuration(metricCloudDuration *string) {
	o.MetricCloudDuration = metricCloudDuration
}

// WithMetricCloudIopsOther adds the metricCloudIopsOther to the volume collection get params
func (o *VolumeCollectionGetParams) WithMetricCloudIopsOther(metricCloudIopsOther *int64) *VolumeCollectionGetParams {
	o.SetMetricCloudIopsOther(metricCloudIopsOther)
	return o
}

// SetMetricCloudIopsOther adds the metricCloudIopsOther to the volume collection get params
func (o *VolumeCollectionGetParams) SetMetricCloudIopsOther(metricCloudIopsOther *int64) {
	o.MetricCloudIopsOther = metricCloudIopsOther
}

// WithMetricCloudIopsRead adds the metricCloudIopsRead to the volume collection get params
func (o *VolumeCollectionGetParams) WithMetricCloudIopsRead(metricCloudIopsRead *int64) *VolumeCollectionGetParams {
	o.SetMetricCloudIopsRead(metricCloudIopsRead)
	return o
}

// SetMetricCloudIopsRead adds the metricCloudIopsRead to the volume collection get params
func (o *VolumeCollectionGetParams) SetMetricCloudIopsRead(metricCloudIopsRead *int64) {
	o.MetricCloudIopsRead = metricCloudIopsRead
}

// WithMetricCloudIopsTotal adds the metricCloudIopsTotal to the volume collection get params
func (o *VolumeCollectionGetParams) WithMetricCloudIopsTotal(metricCloudIopsTotal *int64) *VolumeCollectionGetParams {
	o.SetMetricCloudIopsTotal(metricCloudIopsTotal)
	return o
}

// SetMetricCloudIopsTotal adds the metricCloudIopsTotal to the volume collection get params
func (o *VolumeCollectionGetParams) SetMetricCloudIopsTotal(metricCloudIopsTotal *int64) {
	o.MetricCloudIopsTotal = metricCloudIopsTotal
}

// WithMetricCloudIopsWrite adds the metricCloudIopsWrite to the volume collection get params
func (o *VolumeCollectionGetParams) WithMetricCloudIopsWrite(metricCloudIopsWrite *int64) *VolumeCollectionGetParams {
	o.SetMetricCloudIopsWrite(metricCloudIopsWrite)
	return o
}

// SetMetricCloudIopsWrite adds the metricCloudIopsWrite to the volume collection get params
func (o *VolumeCollectionGetParams) SetMetricCloudIopsWrite(metricCloudIopsWrite *int64) {
	o.MetricCloudIopsWrite = metricCloudIopsWrite
}

// WithMetricCloudLatencyOther adds the metricCloudLatencyOther to the volume collection get params
func (o *VolumeCollectionGetParams) WithMetricCloudLatencyOther(metricCloudLatencyOther *int64) *VolumeCollectionGetParams {
	o.SetMetricCloudLatencyOther(metricCloudLatencyOther)
	return o
}

// SetMetricCloudLatencyOther adds the metricCloudLatencyOther to the volume collection get params
func (o *VolumeCollectionGetParams) SetMetricCloudLatencyOther(metricCloudLatencyOther *int64) {
	o.MetricCloudLatencyOther = metricCloudLatencyOther
}

// WithMetricCloudLatencyRead adds the metricCloudLatencyRead to the volume collection get params
func (o *VolumeCollectionGetParams) WithMetricCloudLatencyRead(metricCloudLatencyRead *int64) *VolumeCollectionGetParams {
	o.SetMetricCloudLatencyRead(metricCloudLatencyRead)
	return o
}

// SetMetricCloudLatencyRead adds the metricCloudLatencyRead to the volume collection get params
func (o *VolumeCollectionGetParams) SetMetricCloudLatencyRead(metricCloudLatencyRead *int64) {
	o.MetricCloudLatencyRead = metricCloudLatencyRead
}

// WithMetricCloudLatencyTotal adds the metricCloudLatencyTotal to the volume collection get params
func (o *VolumeCollectionGetParams) WithMetricCloudLatencyTotal(metricCloudLatencyTotal *int64) *VolumeCollectionGetParams {
	o.SetMetricCloudLatencyTotal(metricCloudLatencyTotal)
	return o
}

// SetMetricCloudLatencyTotal adds the metricCloudLatencyTotal to the volume collection get params
func (o *VolumeCollectionGetParams) SetMetricCloudLatencyTotal(metricCloudLatencyTotal *int64) {
	o.MetricCloudLatencyTotal = metricCloudLatencyTotal
}

// WithMetricCloudLatencyWrite adds the metricCloudLatencyWrite to the volume collection get params
func (o *VolumeCollectionGetParams) WithMetricCloudLatencyWrite(metricCloudLatencyWrite *int64) *VolumeCollectionGetParams {
	o.SetMetricCloudLatencyWrite(metricCloudLatencyWrite)
	return o
}

// SetMetricCloudLatencyWrite adds the metricCloudLatencyWrite to the volume collection get params
func (o *VolumeCollectionGetParams) SetMetricCloudLatencyWrite(metricCloudLatencyWrite *int64) {
	o.MetricCloudLatencyWrite = metricCloudLatencyWrite
}

// WithMetricCloudStatus adds the metricCloudStatus to the volume collection get params
func (o *VolumeCollectionGetParams) WithMetricCloudStatus(metricCloudStatus *string) *VolumeCollectionGetParams {
	o.SetMetricCloudStatus(metricCloudStatus)
	return o
}

// SetMetricCloudStatus adds the metricCloudStatus to the volume collection get params
func (o *VolumeCollectionGetParams) SetMetricCloudStatus(metricCloudStatus *string) {
	o.MetricCloudStatus = metricCloudStatus
}

// WithMetricCloudTimestamp adds the metricCloudTimestamp to the volume collection get params
func (o *VolumeCollectionGetParams) WithMetricCloudTimestamp(metricCloudTimestamp *string) *VolumeCollectionGetParams {
	o.SetMetricCloudTimestamp(metricCloudTimestamp)
	return o
}

// SetMetricCloudTimestamp adds the metricCloudTimestamp to the volume collection get params
func (o *VolumeCollectionGetParams) SetMetricCloudTimestamp(metricCloudTimestamp *string) {
	o.MetricCloudTimestamp = metricCloudTimestamp
}

// WithMetricDuration adds the metricDuration to the volume collection get params
func (o *VolumeCollectionGetParams) WithMetricDuration(metricDuration *string) *VolumeCollectionGetParams {
	o.SetMetricDuration(metricDuration)
	return o
}

// SetMetricDuration adds the metricDuration to the volume collection get params
func (o *VolumeCollectionGetParams) SetMetricDuration(metricDuration *string) {
	o.MetricDuration = metricDuration
}

// WithMetricIopsOther adds the metricIopsOther to the volume collection get params
func (o *VolumeCollectionGetParams) WithMetricIopsOther(metricIopsOther *int64) *VolumeCollectionGetParams {
	o.SetMetricIopsOther(metricIopsOther)
	return o
}

// SetMetricIopsOther adds the metricIopsOther to the volume collection get params
func (o *VolumeCollectionGetParams) SetMetricIopsOther(metricIopsOther *int64) {
	o.MetricIopsOther = metricIopsOther
}

// WithMetricIopsRead adds the metricIopsRead to the volume collection get params
func (o *VolumeCollectionGetParams) WithMetricIopsRead(metricIopsRead *int64) *VolumeCollectionGetParams {
	o.SetMetricIopsRead(metricIopsRead)
	return o
}

// SetMetricIopsRead adds the metricIopsRead to the volume collection get params
func (o *VolumeCollectionGetParams) SetMetricIopsRead(metricIopsRead *int64) {
	o.MetricIopsRead = metricIopsRead
}

// WithMetricIopsTotal adds the metricIopsTotal to the volume collection get params
func (o *VolumeCollectionGetParams) WithMetricIopsTotal(metricIopsTotal *int64) *VolumeCollectionGetParams {
	o.SetMetricIopsTotal(metricIopsTotal)
	return o
}

// SetMetricIopsTotal adds the metricIopsTotal to the volume collection get params
func (o *VolumeCollectionGetParams) SetMetricIopsTotal(metricIopsTotal *int64) {
	o.MetricIopsTotal = metricIopsTotal
}

// WithMetricIopsWrite adds the metricIopsWrite to the volume collection get params
func (o *VolumeCollectionGetParams) WithMetricIopsWrite(metricIopsWrite *int64) *VolumeCollectionGetParams {
	o.SetMetricIopsWrite(metricIopsWrite)
	return o
}

// SetMetricIopsWrite adds the metricIopsWrite to the volume collection get params
func (o *VolumeCollectionGetParams) SetMetricIopsWrite(metricIopsWrite *int64) {
	o.MetricIopsWrite = metricIopsWrite
}

// WithMetricLatencyOther adds the metricLatencyOther to the volume collection get params
func (o *VolumeCollectionGetParams) WithMetricLatencyOther(metricLatencyOther *int64) *VolumeCollectionGetParams {
	o.SetMetricLatencyOther(metricLatencyOther)
	return o
}

// SetMetricLatencyOther adds the metricLatencyOther to the volume collection get params
func (o *VolumeCollectionGetParams) SetMetricLatencyOther(metricLatencyOther *int64) {
	o.MetricLatencyOther = metricLatencyOther
}

// WithMetricLatencyRead adds the metricLatencyRead to the volume collection get params
func (o *VolumeCollectionGetParams) WithMetricLatencyRead(metricLatencyRead *int64) *VolumeCollectionGetParams {
	o.SetMetricLatencyRead(metricLatencyRead)
	return o
}

// SetMetricLatencyRead adds the metricLatencyRead to the volume collection get params
func (o *VolumeCollectionGetParams) SetMetricLatencyRead(metricLatencyRead *int64) {
	o.MetricLatencyRead = metricLatencyRead
}

// WithMetricLatencyTotal adds the metricLatencyTotal to the volume collection get params
func (o *VolumeCollectionGetParams) WithMetricLatencyTotal(metricLatencyTotal *int64) *VolumeCollectionGetParams {
	o.SetMetricLatencyTotal(metricLatencyTotal)
	return o
}

// SetMetricLatencyTotal adds the metricLatencyTotal to the volume collection get params
func (o *VolumeCollectionGetParams) SetMetricLatencyTotal(metricLatencyTotal *int64) {
	o.MetricLatencyTotal = metricLatencyTotal
}

// WithMetricLatencyWrite adds the metricLatencyWrite to the volume collection get params
func (o *VolumeCollectionGetParams) WithMetricLatencyWrite(metricLatencyWrite *int64) *VolumeCollectionGetParams {
	o.SetMetricLatencyWrite(metricLatencyWrite)
	return o
}

// SetMetricLatencyWrite adds the metricLatencyWrite to the volume collection get params
func (o *VolumeCollectionGetParams) SetMetricLatencyWrite(metricLatencyWrite *int64) {
	o.MetricLatencyWrite = metricLatencyWrite
}

// WithMetricStatus adds the metricStatus to the volume collection get params
func (o *VolumeCollectionGetParams) WithMetricStatus(metricStatus *string) *VolumeCollectionGetParams {
	o.SetMetricStatus(metricStatus)
	return o
}

// SetMetricStatus adds the metricStatus to the volume collection get params
func (o *VolumeCollectionGetParams) SetMetricStatus(metricStatus *string) {
	o.MetricStatus = metricStatus
}

// WithMetricThroughputOther adds the metricThroughputOther to the volume collection get params
func (o *VolumeCollectionGetParams) WithMetricThroughputOther(metricThroughputOther *int64) *VolumeCollectionGetParams {
	o.SetMetricThroughputOther(metricThroughputOther)
	return o
}

// SetMetricThroughputOther adds the metricThroughputOther to the volume collection get params
func (o *VolumeCollectionGetParams) SetMetricThroughputOther(metricThroughputOther *int64) {
	o.MetricThroughputOther = metricThroughputOther
}

// WithMetricThroughputRead adds the metricThroughputRead to the volume collection get params
func (o *VolumeCollectionGetParams) WithMetricThroughputRead(metricThroughputRead *int64) *VolumeCollectionGetParams {
	o.SetMetricThroughputRead(metricThroughputRead)
	return o
}

// SetMetricThroughputRead adds the metricThroughputRead to the volume collection get params
func (o *VolumeCollectionGetParams) SetMetricThroughputRead(metricThroughputRead *int64) {
	o.MetricThroughputRead = metricThroughputRead
}

// WithMetricThroughputTotal adds the metricThroughputTotal to the volume collection get params
func (o *VolumeCollectionGetParams) WithMetricThroughputTotal(metricThroughputTotal *int64) *VolumeCollectionGetParams {
	o.SetMetricThroughputTotal(metricThroughputTotal)
	return o
}

// SetMetricThroughputTotal adds the metricThroughputTotal to the volume collection get params
func (o *VolumeCollectionGetParams) SetMetricThroughputTotal(metricThroughputTotal *int64) {
	o.MetricThroughputTotal = metricThroughputTotal
}

// WithMetricThroughputWrite adds the metricThroughputWrite to the volume collection get params
func (o *VolumeCollectionGetParams) WithMetricThroughputWrite(metricThroughputWrite *int64) *VolumeCollectionGetParams {
	o.SetMetricThroughputWrite(metricThroughputWrite)
	return o
}

// SetMetricThroughputWrite adds the metricThroughputWrite to the volume collection get params
func (o *VolumeCollectionGetParams) SetMetricThroughputWrite(metricThroughputWrite *int64) {
	o.MetricThroughputWrite = metricThroughputWrite
}

// WithMetricTimestamp adds the metricTimestamp to the volume collection get params
func (o *VolumeCollectionGetParams) WithMetricTimestamp(metricTimestamp *string) *VolumeCollectionGetParams {
	o.SetMetricTimestamp(metricTimestamp)
	return o
}

// SetMetricTimestamp adds the metricTimestamp to the volume collection get params
func (o *VolumeCollectionGetParams) SetMetricTimestamp(metricTimestamp *string) {
	o.MetricTimestamp = metricTimestamp
}

// WithMovementCutoverWindow adds the movementCutoverWindow to the volume collection get params
func (o *VolumeCollectionGetParams) WithMovementCutoverWindow(movementCutoverWindow *int64) *VolumeCollectionGetParams {
	o.SetMovementCutoverWindow(movementCutoverWindow)
	return o
}

// SetMovementCutoverWindow adds the movementCutoverWindow to the volume collection get params
func (o *VolumeCollectionGetParams) SetMovementCutoverWindow(movementCutoverWindow *int64) {
	o.MovementCutoverWindow = movementCutoverWindow
}

// WithMovementDestinationAggregateName adds the movementDestinationAggregateName to the volume collection get params
func (o *VolumeCollectionGetParams) WithMovementDestinationAggregateName(movementDestinationAggregateName *string) *VolumeCollectionGetParams {
	o.SetMovementDestinationAggregateName(movementDestinationAggregateName)
	return o
}

// SetMovementDestinationAggregateName adds the movementDestinationAggregateName to the volume collection get params
func (o *VolumeCollectionGetParams) SetMovementDestinationAggregateName(movementDestinationAggregateName *string) {
	o.MovementDestinationAggregateName = movementDestinationAggregateName
}

// WithMovementDestinationAggregateUUID adds the movementDestinationAggregateUUID to the volume collection get params
func (o *VolumeCollectionGetParams) WithMovementDestinationAggregateUUID(movementDestinationAggregateUUID *string) *VolumeCollectionGetParams {
	o.SetMovementDestinationAggregateUUID(movementDestinationAggregateUUID)
	return o
}

// SetMovementDestinationAggregateUUID adds the movementDestinationAggregateUuid to the volume collection get params
func (o *VolumeCollectionGetParams) SetMovementDestinationAggregateUUID(movementDestinationAggregateUUID *string) {
	o.MovementDestinationAggregateUUID = movementDestinationAggregateUUID
}

// WithMovementPercentComplete adds the movementPercentComplete to the volume collection get params
func (o *VolumeCollectionGetParams) WithMovementPercentComplete(movementPercentComplete *int64) *VolumeCollectionGetParams {
	o.SetMovementPercentComplete(movementPercentComplete)
	return o
}

// SetMovementPercentComplete adds the movementPercentComplete to the volume collection get params
func (o *VolumeCollectionGetParams) SetMovementPercentComplete(movementPercentComplete *int64) {
	o.MovementPercentComplete = movementPercentComplete
}

// WithMovementState adds the movementState to the volume collection get params
func (o *VolumeCollectionGetParams) WithMovementState(movementState *string) *VolumeCollectionGetParams {
	o.SetMovementState(movementState)
	return o
}

// SetMovementState adds the movementState to the volume collection get params
func (o *VolumeCollectionGetParams) SetMovementState(movementState *string) {
	o.MovementState = movementState
}

// WithName adds the name to the volume collection get params
func (o *VolumeCollectionGetParams) WithName(name *string) *VolumeCollectionGetParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the volume collection get params
func (o *VolumeCollectionGetParams) SetName(name *string) {
	o.Name = name
}

// WithNasExportPolicyID adds the nasExportPolicyID to the volume collection get params
func (o *VolumeCollectionGetParams) WithNasExportPolicyID(nasExportPolicyID *int64) *VolumeCollectionGetParams {
	o.SetNasExportPolicyID(nasExportPolicyID)
	return o
}

// SetNasExportPolicyID adds the nasExportPolicyId to the volume collection get params
func (o *VolumeCollectionGetParams) SetNasExportPolicyID(nasExportPolicyID *int64) {
	o.NasExportPolicyID = nasExportPolicyID
}

// WithNasExportPolicyName adds the nasExportPolicyName to the volume collection get params
func (o *VolumeCollectionGetParams) WithNasExportPolicyName(nasExportPolicyName *string) *VolumeCollectionGetParams {
	o.SetNasExportPolicyName(nasExportPolicyName)
	return o
}

// SetNasExportPolicyName adds the nasExportPolicyName to the volume collection get params
func (o *VolumeCollectionGetParams) SetNasExportPolicyName(nasExportPolicyName *string) {
	o.NasExportPolicyName = nasExportPolicyName
}

// WithNasGid adds the nasGid to the volume collection get params
func (o *VolumeCollectionGetParams) WithNasGid(nasGid *int64) *VolumeCollectionGetParams {
	o.SetNasGid(nasGid)
	return o
}

// SetNasGid adds the nasGid to the volume collection get params
func (o *VolumeCollectionGetParams) SetNasGid(nasGid *int64) {
	o.NasGid = nasGid
}

// WithNasPath adds the nasPath to the volume collection get params
func (o *VolumeCollectionGetParams) WithNasPath(nasPath *string) *VolumeCollectionGetParams {
	o.SetNasPath(nasPath)
	return o
}

// SetNasPath adds the nasPath to the volume collection get params
func (o *VolumeCollectionGetParams) SetNasPath(nasPath *string) {
	o.NasPath = nasPath
}

// WithNasSecurityStyle adds the nasSecurityStyle to the volume collection get params
func (o *VolumeCollectionGetParams) WithNasSecurityStyle(nasSecurityStyle *string) *VolumeCollectionGetParams {
	o.SetNasSecurityStyle(nasSecurityStyle)
	return o
}

// SetNasSecurityStyle adds the nasSecurityStyle to the volume collection get params
func (o *VolumeCollectionGetParams) SetNasSecurityStyle(nasSecurityStyle *string) {
	o.NasSecurityStyle = nasSecurityStyle
}

// WithNasUID adds the nasUID to the volume collection get params
func (o *VolumeCollectionGetParams) WithNasUID(nasUID *int64) *VolumeCollectionGetParams {
	o.SetNasUID(nasUID)
	return o
}

// SetNasUID adds the nasUid to the volume collection get params
func (o *VolumeCollectionGetParams) SetNasUID(nasUID *int64) {
	o.NasUID = nasUID
}

// WithNasUnixPermissions adds the nasUnixPermissions to the volume collection get params
func (o *VolumeCollectionGetParams) WithNasUnixPermissions(nasUnixPermissions *int64) *VolumeCollectionGetParams {
	o.SetNasUnixPermissions(nasUnixPermissions)
	return o
}

// SetNasUnixPermissions adds the nasUnixPermissions to the volume collection get params
func (o *VolumeCollectionGetParams) SetNasUnixPermissions(nasUnixPermissions *int64) {
	o.NasUnixPermissions = nasUnixPermissions
}

// WithOrderBy adds the orderBy to the volume collection get params
func (o *VolumeCollectionGetParams) WithOrderBy(orderBy []string) *VolumeCollectionGetParams {
	o.SetOrderBy(orderBy)
	return o
}

// SetOrderBy adds the orderBy to the volume collection get params
func (o *VolumeCollectionGetParams) SetOrderBy(orderBy []string) {
	o.OrderBy = orderBy
}

// WithQosPolicyMaxThroughputIops adds the qosPolicyMaxThroughputIops to the volume collection get params
func (o *VolumeCollectionGetParams) WithQosPolicyMaxThroughputIops(qosPolicyMaxThroughputIops *int64) *VolumeCollectionGetParams {
	o.SetQosPolicyMaxThroughputIops(qosPolicyMaxThroughputIops)
	return o
}

// SetQosPolicyMaxThroughputIops adds the qosPolicyMaxThroughputIops to the volume collection get params
func (o *VolumeCollectionGetParams) SetQosPolicyMaxThroughputIops(qosPolicyMaxThroughputIops *int64) {
	o.QosPolicyMaxThroughputIops = qosPolicyMaxThroughputIops
}

// WithQosPolicyMaxThroughputMbps adds the qosPolicyMaxThroughputMbps to the volume collection get params
func (o *VolumeCollectionGetParams) WithQosPolicyMaxThroughputMbps(qosPolicyMaxThroughputMbps *int64) *VolumeCollectionGetParams {
	o.SetQosPolicyMaxThroughputMbps(qosPolicyMaxThroughputMbps)
	return o
}

// SetQosPolicyMaxThroughputMbps adds the qosPolicyMaxThroughputMbps to the volume collection get params
func (o *VolumeCollectionGetParams) SetQosPolicyMaxThroughputMbps(qosPolicyMaxThroughputMbps *int64) {
	o.QosPolicyMaxThroughputMbps = qosPolicyMaxThroughputMbps
}

// WithQosPolicyMinThroughputIops adds the qosPolicyMinThroughputIops to the volume collection get params
func (o *VolumeCollectionGetParams) WithQosPolicyMinThroughputIops(qosPolicyMinThroughputIops *int64) *VolumeCollectionGetParams {
	o.SetQosPolicyMinThroughputIops(qosPolicyMinThroughputIops)
	return o
}

// SetQosPolicyMinThroughputIops adds the qosPolicyMinThroughputIops to the volume collection get params
func (o *VolumeCollectionGetParams) SetQosPolicyMinThroughputIops(qosPolicyMinThroughputIops *int64) {
	o.QosPolicyMinThroughputIops = qosPolicyMinThroughputIops
}

// WithQosPolicyName adds the qosPolicyName to the volume collection get params
func (o *VolumeCollectionGetParams) WithQosPolicyName(qosPolicyName *string) *VolumeCollectionGetParams {
	o.SetQosPolicyName(qosPolicyName)
	return o
}

// SetQosPolicyName adds the qosPolicyName to the volume collection get params
func (o *VolumeCollectionGetParams) SetQosPolicyName(qosPolicyName *string) {
	o.QosPolicyName = qosPolicyName
}

// WithQosPolicyUUID adds the qosPolicyUUID to the volume collection get params
func (o *VolumeCollectionGetParams) WithQosPolicyUUID(qosPolicyUUID *string) *VolumeCollectionGetParams {
	o.SetQosPolicyUUID(qosPolicyUUID)
	return o
}

// SetQosPolicyUUID adds the qosPolicyUuid to the volume collection get params
func (o *VolumeCollectionGetParams) SetQosPolicyUUID(qosPolicyUUID *string) {
	o.QosPolicyUUID = qosPolicyUUID
}

// WithQuotaState adds the quotaState to the volume collection get params
func (o *VolumeCollectionGetParams) WithQuotaState(quotaState *string) *VolumeCollectionGetParams {
	o.SetQuotaState(quotaState)
	return o
}

// SetQuotaState adds the quotaState to the volume collection get params
func (o *VolumeCollectionGetParams) SetQuotaState(quotaState *string) {
	o.QuotaState = quotaState
}

// WithReturnRecords adds the returnRecords to the volume collection get params
func (o *VolumeCollectionGetParams) WithReturnRecords(returnRecords *bool) *VolumeCollectionGetParams {
	o.SetReturnRecords(returnRecords)
	return o
}

// SetReturnRecords adds the returnRecords to the volume collection get params
func (o *VolumeCollectionGetParams) SetReturnRecords(returnRecords *bool) {
	o.ReturnRecords = returnRecords
}

// WithReturnTimeout adds the returnTimeout to the volume collection get params
func (o *VolumeCollectionGetParams) WithReturnTimeout(returnTimeout *int64) *VolumeCollectionGetParams {
	o.SetReturnTimeout(returnTimeout)
	return o
}

// SetReturnTimeout adds the returnTimeout to the volume collection get params
func (o *VolumeCollectionGetParams) SetReturnTimeout(returnTimeout *int64) {
	o.ReturnTimeout = returnTimeout
}

// WithSize adds the size to the volume collection get params
func (o *VolumeCollectionGetParams) WithSize(size *int64) *VolumeCollectionGetParams {
	o.SetSize(size)
	return o
}

// SetSize adds the size to the volume collection get params
func (o *VolumeCollectionGetParams) SetSize(size *int64) {
	o.Size = size
}

// WithSnaplockAppendModeEnabled adds the snaplockAppendModeEnabled to the volume collection get params
func (o *VolumeCollectionGetParams) WithSnaplockAppendModeEnabled(snaplockAppendModeEnabled *bool) *VolumeCollectionGetParams {
	o.SetSnaplockAppendModeEnabled(snaplockAppendModeEnabled)
	return o
}

// SetSnaplockAppendModeEnabled adds the snaplockAppendModeEnabled to the volume collection get params
func (o *VolumeCollectionGetParams) SetSnaplockAppendModeEnabled(snaplockAppendModeEnabled *bool) {
	o.SnaplockAppendModeEnabled = snaplockAppendModeEnabled
}

// WithSnaplockAutocommitPeriod adds the snaplockAutocommitPeriod to the volume collection get params
func (o *VolumeCollectionGetParams) WithSnaplockAutocommitPeriod(snaplockAutocommitPeriod *string) *VolumeCollectionGetParams {
	o.SetSnaplockAutocommitPeriod(snaplockAutocommitPeriod)
	return o
}

// SetSnaplockAutocommitPeriod adds the snaplockAutocommitPeriod to the volume collection get params
func (o *VolumeCollectionGetParams) SetSnaplockAutocommitPeriod(snaplockAutocommitPeriod *string) {
	o.SnaplockAutocommitPeriod = snaplockAutocommitPeriod
}

// WithSnaplockComplianceClockTime adds the snaplockComplianceClockTime to the volume collection get params
func (o *VolumeCollectionGetParams) WithSnaplockComplianceClockTime(snaplockComplianceClockTime *string) *VolumeCollectionGetParams {
	o.SetSnaplockComplianceClockTime(snaplockComplianceClockTime)
	return o
}

// SetSnaplockComplianceClockTime adds the snaplockComplianceClockTime to the volume collection get params
func (o *VolumeCollectionGetParams) SetSnaplockComplianceClockTime(snaplockComplianceClockTime *string) {
	o.SnaplockComplianceClockTime = snaplockComplianceClockTime
}

// WithSnaplockExpiryTime adds the snaplockExpiryTime to the volume collection get params
func (o *VolumeCollectionGetParams) WithSnaplockExpiryTime(snaplockExpiryTime *string) *VolumeCollectionGetParams {
	o.SetSnaplockExpiryTime(snaplockExpiryTime)
	return o
}

// SetSnaplockExpiryTime adds the snaplockExpiryTime to the volume collection get params
func (o *VolumeCollectionGetParams) SetSnaplockExpiryTime(snaplockExpiryTime *string) {
	o.SnaplockExpiryTime = snaplockExpiryTime
}

// WithSnaplockIsAuditLog adds the snaplockIsAuditLog to the volume collection get params
func (o *VolumeCollectionGetParams) WithSnaplockIsAuditLog(snaplockIsAuditLog *bool) *VolumeCollectionGetParams {
	o.SetSnaplockIsAuditLog(snaplockIsAuditLog)
	return o
}

// SetSnaplockIsAuditLog adds the snaplockIsAuditLog to the volume collection get params
func (o *VolumeCollectionGetParams) SetSnaplockIsAuditLog(snaplockIsAuditLog *bool) {
	o.SnaplockIsAuditLog = snaplockIsAuditLog
}

// WithSnaplockLitigationCount adds the snaplockLitigationCount to the volume collection get params
func (o *VolumeCollectionGetParams) WithSnaplockLitigationCount(snaplockLitigationCount *int64) *VolumeCollectionGetParams {
	o.SetSnaplockLitigationCount(snaplockLitigationCount)
	return o
}

// SetSnaplockLitigationCount adds the snaplockLitigationCount to the volume collection get params
func (o *VolumeCollectionGetParams) SetSnaplockLitigationCount(snaplockLitigationCount *int64) {
	o.SnaplockLitigationCount = snaplockLitigationCount
}

// WithSnaplockPrivilegedDelete adds the snaplockPrivilegedDelete to the volume collection get params
func (o *VolumeCollectionGetParams) WithSnaplockPrivilegedDelete(snaplockPrivilegedDelete *string) *VolumeCollectionGetParams {
	o.SetSnaplockPrivilegedDelete(snaplockPrivilegedDelete)
	return o
}

// SetSnaplockPrivilegedDelete adds the snaplockPrivilegedDelete to the volume collection get params
func (o *VolumeCollectionGetParams) SetSnaplockPrivilegedDelete(snaplockPrivilegedDelete *string) {
	o.SnaplockPrivilegedDelete = snaplockPrivilegedDelete
}

// WithSnaplockRetentionDefault adds the snaplockRetentionDefault to the volume collection get params
func (o *VolumeCollectionGetParams) WithSnaplockRetentionDefault(snaplockRetentionDefault *string) *VolumeCollectionGetParams {
	o.SetSnaplockRetentionDefault(snaplockRetentionDefault)
	return o
}

// SetSnaplockRetentionDefault adds the snaplockRetentionDefault to the volume collection get params
func (o *VolumeCollectionGetParams) SetSnaplockRetentionDefault(snaplockRetentionDefault *string) {
	o.SnaplockRetentionDefault = snaplockRetentionDefault
}

// WithSnaplockRetentionMaximum adds the snaplockRetentionMaximum to the volume collection get params
func (o *VolumeCollectionGetParams) WithSnaplockRetentionMaximum(snaplockRetentionMaximum *string) *VolumeCollectionGetParams {
	o.SetSnaplockRetentionMaximum(snaplockRetentionMaximum)
	return o
}

// SetSnaplockRetentionMaximum adds the snaplockRetentionMaximum to the volume collection get params
func (o *VolumeCollectionGetParams) SetSnaplockRetentionMaximum(snaplockRetentionMaximum *string) {
	o.SnaplockRetentionMaximum = snaplockRetentionMaximum
}

// WithSnaplockRetentionMinimum adds the snaplockRetentionMinimum to the volume collection get params
func (o *VolumeCollectionGetParams) WithSnaplockRetentionMinimum(snaplockRetentionMinimum *string) *VolumeCollectionGetParams {
	o.SetSnaplockRetentionMinimum(snaplockRetentionMinimum)
	return o
}

// SetSnaplockRetentionMinimum adds the snaplockRetentionMinimum to the volume collection get params
func (o *VolumeCollectionGetParams) SetSnaplockRetentionMinimum(snaplockRetentionMinimum *string) {
	o.SnaplockRetentionMinimum = snaplockRetentionMinimum
}

// WithSnaplockType adds the snaplockType to the volume collection get params
func (o *VolumeCollectionGetParams) WithSnaplockType(snaplockType *string) *VolumeCollectionGetParams {
	o.SetSnaplockType(snaplockType)
	return o
}

// SetSnaplockType adds the snaplockType to the volume collection get params
func (o *VolumeCollectionGetParams) SetSnaplockType(snaplockType *string) {
	o.SnaplockType = snaplockType
}

// WithSnapmirrorIsProtected adds the snapmirrorIsProtected to the volume collection get params
func (o *VolumeCollectionGetParams) WithSnapmirrorIsProtected(snapmirrorIsProtected *bool) *VolumeCollectionGetParams {
	o.SetSnapmirrorIsProtected(snapmirrorIsProtected)
	return o
}

// SetSnapmirrorIsProtected adds the snapmirrorIsProtected to the volume collection get params
func (o *VolumeCollectionGetParams) SetSnapmirrorIsProtected(snapmirrorIsProtected *bool) {
	o.SnapmirrorIsProtected = snapmirrorIsProtected
}

// WithSnapshotPolicyName adds the snapshotPolicyName to the volume collection get params
func (o *VolumeCollectionGetParams) WithSnapshotPolicyName(snapshotPolicyName *string) *VolumeCollectionGetParams {
	o.SetSnapshotPolicyName(snapshotPolicyName)
	return o
}

// SetSnapshotPolicyName adds the snapshotPolicyName to the volume collection get params
func (o *VolumeCollectionGetParams) SetSnapshotPolicyName(snapshotPolicyName *string) {
	o.SnapshotPolicyName = snapshotPolicyName
}

// WithSnapshotPolicyUUID adds the snapshotPolicyUUID to the volume collection get params
func (o *VolumeCollectionGetParams) WithSnapshotPolicyUUID(snapshotPolicyUUID *string) *VolumeCollectionGetParams {
	o.SetSnapshotPolicyUUID(snapshotPolicyUUID)
	return o
}

// SetSnapshotPolicyUUID adds the snapshotPolicyUuid to the volume collection get params
func (o *VolumeCollectionGetParams) SetSnapshotPolicyUUID(snapshotPolicyUUID *string) {
	o.SnapshotPolicyUUID = snapshotPolicyUUID
}

// WithSpaceAvailable adds the spaceAvailable to the volume collection get params
func (o *VolumeCollectionGetParams) WithSpaceAvailable(spaceAvailable *int64) *VolumeCollectionGetParams {
	o.SetSpaceAvailable(spaceAvailable)
	return o
}

// SetSpaceAvailable adds the spaceAvailable to the volume collection get params
func (o *VolumeCollectionGetParams) SetSpaceAvailable(spaceAvailable *int64) {
	o.SpaceAvailable = spaceAvailable
}

// WithSpaceBlockStorageInactiveUserData adds the spaceBlockStorageInactiveUserData to the volume collection get params
func (o *VolumeCollectionGetParams) WithSpaceBlockStorageInactiveUserData(spaceBlockStorageInactiveUserData *int64) *VolumeCollectionGetParams {
	o.SetSpaceBlockStorageInactiveUserData(spaceBlockStorageInactiveUserData)
	return o
}

// SetSpaceBlockStorageInactiveUserData adds the spaceBlockStorageInactiveUserData to the volume collection get params
func (o *VolumeCollectionGetParams) SetSpaceBlockStorageInactiveUserData(spaceBlockStorageInactiveUserData *int64) {
	o.SpaceBlockStorageInactiveUserData = spaceBlockStorageInactiveUserData
}

// WithSpaceCapacityTierFootprint adds the spaceCapacityTierFootprint to the volume collection get params
func (o *VolumeCollectionGetParams) WithSpaceCapacityTierFootprint(spaceCapacityTierFootprint *int64) *VolumeCollectionGetParams {
	o.SetSpaceCapacityTierFootprint(spaceCapacityTierFootprint)
	return o
}

// SetSpaceCapacityTierFootprint adds the spaceCapacityTierFootprint to the volume collection get params
func (o *VolumeCollectionGetParams) SetSpaceCapacityTierFootprint(spaceCapacityTierFootprint *int64) {
	o.SpaceCapacityTierFootprint = spaceCapacityTierFootprint
}

// WithSpaceFootprint adds the spaceFootprint to the volume collection get params
func (o *VolumeCollectionGetParams) WithSpaceFootprint(spaceFootprint *int64) *VolumeCollectionGetParams {
	o.SetSpaceFootprint(spaceFootprint)
	return o
}

// SetSpaceFootprint adds the spaceFootprint to the volume collection get params
func (o *VolumeCollectionGetParams) SetSpaceFootprint(spaceFootprint *int64) {
	o.SpaceFootprint = spaceFootprint
}

// WithSpaceLogicalSpaceAvailable adds the spaceLogicalSpaceAvailable to the volume collection get params
func (o *VolumeCollectionGetParams) WithSpaceLogicalSpaceAvailable(spaceLogicalSpaceAvailable *int64) *VolumeCollectionGetParams {
	o.SetSpaceLogicalSpaceAvailable(spaceLogicalSpaceAvailable)
	return o
}

// SetSpaceLogicalSpaceAvailable adds the spaceLogicalSpaceAvailable to the volume collection get params
func (o *VolumeCollectionGetParams) SetSpaceLogicalSpaceAvailable(spaceLogicalSpaceAvailable *int64) {
	o.SpaceLogicalSpaceAvailable = spaceLogicalSpaceAvailable
}

// WithSpaceLogicalSpaceEnforcement adds the spaceLogicalSpaceEnforcement to the volume collection get params
func (o *VolumeCollectionGetParams) WithSpaceLogicalSpaceEnforcement(spaceLogicalSpaceEnforcement *bool) *VolumeCollectionGetParams {
	o.SetSpaceLogicalSpaceEnforcement(spaceLogicalSpaceEnforcement)
	return o
}

// SetSpaceLogicalSpaceEnforcement adds the spaceLogicalSpaceEnforcement to the volume collection get params
func (o *VolumeCollectionGetParams) SetSpaceLogicalSpaceEnforcement(spaceLogicalSpaceEnforcement *bool) {
	o.SpaceLogicalSpaceEnforcement = spaceLogicalSpaceEnforcement
}

// WithSpaceLogicalSpaceReporting adds the spaceLogicalSpaceReporting to the volume collection get params
func (o *VolumeCollectionGetParams) WithSpaceLogicalSpaceReporting(spaceLogicalSpaceReporting *bool) *VolumeCollectionGetParams {
	o.SetSpaceLogicalSpaceReporting(spaceLogicalSpaceReporting)
	return o
}

// SetSpaceLogicalSpaceReporting adds the spaceLogicalSpaceReporting to the volume collection get params
func (o *VolumeCollectionGetParams) SetSpaceLogicalSpaceReporting(spaceLogicalSpaceReporting *bool) {
	o.SpaceLogicalSpaceReporting = spaceLogicalSpaceReporting
}

// WithSpaceLogicalSpaceUsedByAfs adds the spaceLogicalSpaceUsedByAfs to the volume collection get params
func (o *VolumeCollectionGetParams) WithSpaceLogicalSpaceUsedByAfs(spaceLogicalSpaceUsedByAfs *int64) *VolumeCollectionGetParams {
	o.SetSpaceLogicalSpaceUsedByAfs(spaceLogicalSpaceUsedByAfs)
	return o
}

// SetSpaceLogicalSpaceUsedByAfs adds the spaceLogicalSpaceUsedByAfs to the volume collection get params
func (o *VolumeCollectionGetParams) SetSpaceLogicalSpaceUsedByAfs(spaceLogicalSpaceUsedByAfs *int64) {
	o.SpaceLogicalSpaceUsedByAfs = spaceLogicalSpaceUsedByAfs
}

// WithSpaceMetadata adds the spaceMetadata to the volume collection get params
func (o *VolumeCollectionGetParams) WithSpaceMetadata(spaceMetadata *int64) *VolumeCollectionGetParams {
	o.SetSpaceMetadata(spaceMetadata)
	return o
}

// SetSpaceMetadata adds the spaceMetadata to the volume collection get params
func (o *VolumeCollectionGetParams) SetSpaceMetadata(spaceMetadata *int64) {
	o.SpaceMetadata = spaceMetadata
}

// WithSpaceOverProvisioned adds the spaceOverProvisioned to the volume collection get params
func (o *VolumeCollectionGetParams) WithSpaceOverProvisioned(spaceOverProvisioned *int64) *VolumeCollectionGetParams {
	o.SetSpaceOverProvisioned(spaceOverProvisioned)
	return o
}

// SetSpaceOverProvisioned adds the spaceOverProvisioned to the volume collection get params
func (o *VolumeCollectionGetParams) SetSpaceOverProvisioned(spaceOverProvisioned *int64) {
	o.SpaceOverProvisioned = spaceOverProvisioned
}

// WithSpaceSize adds the spaceSize to the volume collection get params
func (o *VolumeCollectionGetParams) WithSpaceSize(spaceSize *int64) *VolumeCollectionGetParams {
	o.SetSpaceSize(spaceSize)
	return o
}

// SetSpaceSize adds the spaceSize to the volume collection get params
func (o *VolumeCollectionGetParams) SetSpaceSize(spaceSize *int64) {
	o.SpaceSize = spaceSize
}

// WithSpaceSnapshotReservePercent adds the spaceSnapshotReservePercent to the volume collection get params
func (o *VolumeCollectionGetParams) WithSpaceSnapshotReservePercent(spaceSnapshotReservePercent *int64) *VolumeCollectionGetParams {
	o.SetSpaceSnapshotReservePercent(spaceSnapshotReservePercent)
	return o
}

// SetSpaceSnapshotReservePercent adds the spaceSnapshotReservePercent to the volume collection get params
func (o *VolumeCollectionGetParams) SetSpaceSnapshotReservePercent(spaceSnapshotReservePercent *int64) {
	o.SpaceSnapshotReservePercent = spaceSnapshotReservePercent
}

// WithSpaceSnapshotUsed adds the spaceSnapshotUsed to the volume collection get params
func (o *VolumeCollectionGetParams) WithSpaceSnapshotUsed(spaceSnapshotUsed *int64) *VolumeCollectionGetParams {
	o.SetSpaceSnapshotUsed(spaceSnapshotUsed)
	return o
}

// SetSpaceSnapshotUsed adds the spaceSnapshotUsed to the volume collection get params
func (o *VolumeCollectionGetParams) SetSpaceSnapshotUsed(spaceSnapshotUsed *int64) {
	o.SpaceSnapshotUsed = spaceSnapshotUsed
}

// WithSpaceUsed adds the spaceUsed to the volume collection get params
func (o *VolumeCollectionGetParams) WithSpaceUsed(spaceUsed *int64) *VolumeCollectionGetParams {
	o.SetSpaceUsed(spaceUsed)
	return o
}

// SetSpaceUsed adds the spaceUsed to the volume collection get params
func (o *VolumeCollectionGetParams) SetSpaceUsed(spaceUsed *int64) {
	o.SpaceUsed = spaceUsed
}

// WithState adds the state to the volume collection get params
func (o *VolumeCollectionGetParams) WithState(state *string) *VolumeCollectionGetParams {
	o.SetState(state)
	return o
}

// SetState adds the state to the volume collection get params
func (o *VolumeCollectionGetParams) SetState(state *string) {
	o.State = state
}

// WithStatisticsCloudIopsRawOther adds the statisticsCloudIopsRawOther to the volume collection get params
func (o *VolumeCollectionGetParams) WithStatisticsCloudIopsRawOther(statisticsCloudIopsRawOther *int64) *VolumeCollectionGetParams {
	o.SetStatisticsCloudIopsRawOther(statisticsCloudIopsRawOther)
	return o
}

// SetStatisticsCloudIopsRawOther adds the statisticsCloudIopsRawOther to the volume collection get params
func (o *VolumeCollectionGetParams) SetStatisticsCloudIopsRawOther(statisticsCloudIopsRawOther *int64) {
	o.StatisticsCloudIopsRawOther = statisticsCloudIopsRawOther
}

// WithStatisticsCloudIopsRawRead adds the statisticsCloudIopsRawRead to the volume collection get params
func (o *VolumeCollectionGetParams) WithStatisticsCloudIopsRawRead(statisticsCloudIopsRawRead *int64) *VolumeCollectionGetParams {
	o.SetStatisticsCloudIopsRawRead(statisticsCloudIopsRawRead)
	return o
}

// SetStatisticsCloudIopsRawRead adds the statisticsCloudIopsRawRead to the volume collection get params
func (o *VolumeCollectionGetParams) SetStatisticsCloudIopsRawRead(statisticsCloudIopsRawRead *int64) {
	o.StatisticsCloudIopsRawRead = statisticsCloudIopsRawRead
}

// WithStatisticsCloudIopsRawTotal adds the statisticsCloudIopsRawTotal to the volume collection get params
func (o *VolumeCollectionGetParams) WithStatisticsCloudIopsRawTotal(statisticsCloudIopsRawTotal *int64) *VolumeCollectionGetParams {
	o.SetStatisticsCloudIopsRawTotal(statisticsCloudIopsRawTotal)
	return o
}

// SetStatisticsCloudIopsRawTotal adds the statisticsCloudIopsRawTotal to the volume collection get params
func (o *VolumeCollectionGetParams) SetStatisticsCloudIopsRawTotal(statisticsCloudIopsRawTotal *int64) {
	o.StatisticsCloudIopsRawTotal = statisticsCloudIopsRawTotal
}

// WithStatisticsCloudIopsRawWrite adds the statisticsCloudIopsRawWrite to the volume collection get params
func (o *VolumeCollectionGetParams) WithStatisticsCloudIopsRawWrite(statisticsCloudIopsRawWrite *int64) *VolumeCollectionGetParams {
	o.SetStatisticsCloudIopsRawWrite(statisticsCloudIopsRawWrite)
	return o
}

// SetStatisticsCloudIopsRawWrite adds the statisticsCloudIopsRawWrite to the volume collection get params
func (o *VolumeCollectionGetParams) SetStatisticsCloudIopsRawWrite(statisticsCloudIopsRawWrite *int64) {
	o.StatisticsCloudIopsRawWrite = statisticsCloudIopsRawWrite
}

// WithStatisticsCloudLatencyRawOther adds the statisticsCloudLatencyRawOther to the volume collection get params
func (o *VolumeCollectionGetParams) WithStatisticsCloudLatencyRawOther(statisticsCloudLatencyRawOther *int64) *VolumeCollectionGetParams {
	o.SetStatisticsCloudLatencyRawOther(statisticsCloudLatencyRawOther)
	return o
}

// SetStatisticsCloudLatencyRawOther adds the statisticsCloudLatencyRawOther to the volume collection get params
func (o *VolumeCollectionGetParams) SetStatisticsCloudLatencyRawOther(statisticsCloudLatencyRawOther *int64) {
	o.StatisticsCloudLatencyRawOther = statisticsCloudLatencyRawOther
}

// WithStatisticsCloudLatencyRawRead adds the statisticsCloudLatencyRawRead to the volume collection get params
func (o *VolumeCollectionGetParams) WithStatisticsCloudLatencyRawRead(statisticsCloudLatencyRawRead *int64) *VolumeCollectionGetParams {
	o.SetStatisticsCloudLatencyRawRead(statisticsCloudLatencyRawRead)
	return o
}

// SetStatisticsCloudLatencyRawRead adds the statisticsCloudLatencyRawRead to the volume collection get params
func (o *VolumeCollectionGetParams) SetStatisticsCloudLatencyRawRead(statisticsCloudLatencyRawRead *int64) {
	o.StatisticsCloudLatencyRawRead = statisticsCloudLatencyRawRead
}

// WithStatisticsCloudLatencyRawTotal adds the statisticsCloudLatencyRawTotal to the volume collection get params
func (o *VolumeCollectionGetParams) WithStatisticsCloudLatencyRawTotal(statisticsCloudLatencyRawTotal *int64) *VolumeCollectionGetParams {
	o.SetStatisticsCloudLatencyRawTotal(statisticsCloudLatencyRawTotal)
	return o
}

// SetStatisticsCloudLatencyRawTotal adds the statisticsCloudLatencyRawTotal to the volume collection get params
func (o *VolumeCollectionGetParams) SetStatisticsCloudLatencyRawTotal(statisticsCloudLatencyRawTotal *int64) {
	o.StatisticsCloudLatencyRawTotal = statisticsCloudLatencyRawTotal
}

// WithStatisticsCloudLatencyRawWrite adds the statisticsCloudLatencyRawWrite to the volume collection get params
func (o *VolumeCollectionGetParams) WithStatisticsCloudLatencyRawWrite(statisticsCloudLatencyRawWrite *int64) *VolumeCollectionGetParams {
	o.SetStatisticsCloudLatencyRawWrite(statisticsCloudLatencyRawWrite)
	return o
}

// SetStatisticsCloudLatencyRawWrite adds the statisticsCloudLatencyRawWrite to the volume collection get params
func (o *VolumeCollectionGetParams) SetStatisticsCloudLatencyRawWrite(statisticsCloudLatencyRawWrite *int64) {
	o.StatisticsCloudLatencyRawWrite = statisticsCloudLatencyRawWrite
}

// WithStatisticsCloudStatus adds the statisticsCloudStatus to the volume collection get params
func (o *VolumeCollectionGetParams) WithStatisticsCloudStatus(statisticsCloudStatus *string) *VolumeCollectionGetParams {
	o.SetStatisticsCloudStatus(statisticsCloudStatus)
	return o
}

// SetStatisticsCloudStatus adds the statisticsCloudStatus to the volume collection get params
func (o *VolumeCollectionGetParams) SetStatisticsCloudStatus(statisticsCloudStatus *string) {
	o.StatisticsCloudStatus = statisticsCloudStatus
}

// WithStatisticsCloudTimestamp adds the statisticsCloudTimestamp to the volume collection get params
func (o *VolumeCollectionGetParams) WithStatisticsCloudTimestamp(statisticsCloudTimestamp *string) *VolumeCollectionGetParams {
	o.SetStatisticsCloudTimestamp(statisticsCloudTimestamp)
	return o
}

// SetStatisticsCloudTimestamp adds the statisticsCloudTimestamp to the volume collection get params
func (o *VolumeCollectionGetParams) SetStatisticsCloudTimestamp(statisticsCloudTimestamp *string) {
	o.StatisticsCloudTimestamp = statisticsCloudTimestamp
}

// WithStatisticsIopsRawOther adds the statisticsIopsRawOther to the volume collection get params
func (o *VolumeCollectionGetParams) WithStatisticsIopsRawOther(statisticsIopsRawOther *int64) *VolumeCollectionGetParams {
	o.SetStatisticsIopsRawOther(statisticsIopsRawOther)
	return o
}

// SetStatisticsIopsRawOther adds the statisticsIopsRawOther to the volume collection get params
func (o *VolumeCollectionGetParams) SetStatisticsIopsRawOther(statisticsIopsRawOther *int64) {
	o.StatisticsIopsRawOther = statisticsIopsRawOther
}

// WithStatisticsIopsRawRead adds the statisticsIopsRawRead to the volume collection get params
func (o *VolumeCollectionGetParams) WithStatisticsIopsRawRead(statisticsIopsRawRead *int64) *VolumeCollectionGetParams {
	o.SetStatisticsIopsRawRead(statisticsIopsRawRead)
	return o
}

// SetStatisticsIopsRawRead adds the statisticsIopsRawRead to the volume collection get params
func (o *VolumeCollectionGetParams) SetStatisticsIopsRawRead(statisticsIopsRawRead *int64) {
	o.StatisticsIopsRawRead = statisticsIopsRawRead
}

// WithStatisticsIopsRawTotal adds the statisticsIopsRawTotal to the volume collection get params
func (o *VolumeCollectionGetParams) WithStatisticsIopsRawTotal(statisticsIopsRawTotal *int64) *VolumeCollectionGetParams {
	o.SetStatisticsIopsRawTotal(statisticsIopsRawTotal)
	return o
}

// SetStatisticsIopsRawTotal adds the statisticsIopsRawTotal to the volume collection get params
func (o *VolumeCollectionGetParams) SetStatisticsIopsRawTotal(statisticsIopsRawTotal *int64) {
	o.StatisticsIopsRawTotal = statisticsIopsRawTotal
}

// WithStatisticsIopsRawWrite adds the statisticsIopsRawWrite to the volume collection get params
func (o *VolumeCollectionGetParams) WithStatisticsIopsRawWrite(statisticsIopsRawWrite *int64) *VolumeCollectionGetParams {
	o.SetStatisticsIopsRawWrite(statisticsIopsRawWrite)
	return o
}

// SetStatisticsIopsRawWrite adds the statisticsIopsRawWrite to the volume collection get params
func (o *VolumeCollectionGetParams) SetStatisticsIopsRawWrite(statisticsIopsRawWrite *int64) {
	o.StatisticsIopsRawWrite = statisticsIopsRawWrite
}

// WithStatisticsLatencyRawOther adds the statisticsLatencyRawOther to the volume collection get params
func (o *VolumeCollectionGetParams) WithStatisticsLatencyRawOther(statisticsLatencyRawOther *int64) *VolumeCollectionGetParams {
	o.SetStatisticsLatencyRawOther(statisticsLatencyRawOther)
	return o
}

// SetStatisticsLatencyRawOther adds the statisticsLatencyRawOther to the volume collection get params
func (o *VolumeCollectionGetParams) SetStatisticsLatencyRawOther(statisticsLatencyRawOther *int64) {
	o.StatisticsLatencyRawOther = statisticsLatencyRawOther
}

// WithStatisticsLatencyRawRead adds the statisticsLatencyRawRead to the volume collection get params
func (o *VolumeCollectionGetParams) WithStatisticsLatencyRawRead(statisticsLatencyRawRead *int64) *VolumeCollectionGetParams {
	o.SetStatisticsLatencyRawRead(statisticsLatencyRawRead)
	return o
}

// SetStatisticsLatencyRawRead adds the statisticsLatencyRawRead to the volume collection get params
func (o *VolumeCollectionGetParams) SetStatisticsLatencyRawRead(statisticsLatencyRawRead *int64) {
	o.StatisticsLatencyRawRead = statisticsLatencyRawRead
}

// WithStatisticsLatencyRawTotal adds the statisticsLatencyRawTotal to the volume collection get params
func (o *VolumeCollectionGetParams) WithStatisticsLatencyRawTotal(statisticsLatencyRawTotal *int64) *VolumeCollectionGetParams {
	o.SetStatisticsLatencyRawTotal(statisticsLatencyRawTotal)
	return o
}

// SetStatisticsLatencyRawTotal adds the statisticsLatencyRawTotal to the volume collection get params
func (o *VolumeCollectionGetParams) SetStatisticsLatencyRawTotal(statisticsLatencyRawTotal *int64) {
	o.StatisticsLatencyRawTotal = statisticsLatencyRawTotal
}

// WithStatisticsLatencyRawWrite adds the statisticsLatencyRawWrite to the volume collection get params
func (o *VolumeCollectionGetParams) WithStatisticsLatencyRawWrite(statisticsLatencyRawWrite *int64) *VolumeCollectionGetParams {
	o.SetStatisticsLatencyRawWrite(statisticsLatencyRawWrite)
	return o
}

// SetStatisticsLatencyRawWrite adds the statisticsLatencyRawWrite to the volume collection get params
func (o *VolumeCollectionGetParams) SetStatisticsLatencyRawWrite(statisticsLatencyRawWrite *int64) {
	o.StatisticsLatencyRawWrite = statisticsLatencyRawWrite
}

// WithStatisticsStatus adds the statisticsStatus to the volume collection get params
func (o *VolumeCollectionGetParams) WithStatisticsStatus(statisticsStatus *string) *VolumeCollectionGetParams {
	o.SetStatisticsStatus(statisticsStatus)
	return o
}

// SetStatisticsStatus adds the statisticsStatus to the volume collection get params
func (o *VolumeCollectionGetParams) SetStatisticsStatus(statisticsStatus *string) {
	o.StatisticsStatus = statisticsStatus
}

// WithStatisticsThroughputRawOther adds the statisticsThroughputRawOther to the volume collection get params
func (o *VolumeCollectionGetParams) WithStatisticsThroughputRawOther(statisticsThroughputRawOther *int64) *VolumeCollectionGetParams {
	o.SetStatisticsThroughputRawOther(statisticsThroughputRawOther)
	return o
}

// SetStatisticsThroughputRawOther adds the statisticsThroughputRawOther to the volume collection get params
func (o *VolumeCollectionGetParams) SetStatisticsThroughputRawOther(statisticsThroughputRawOther *int64) {
	o.StatisticsThroughputRawOther = statisticsThroughputRawOther
}

// WithStatisticsThroughputRawRead adds the statisticsThroughputRawRead to the volume collection get params
func (o *VolumeCollectionGetParams) WithStatisticsThroughputRawRead(statisticsThroughputRawRead *int64) *VolumeCollectionGetParams {
	o.SetStatisticsThroughputRawRead(statisticsThroughputRawRead)
	return o
}

// SetStatisticsThroughputRawRead adds the statisticsThroughputRawRead to the volume collection get params
func (o *VolumeCollectionGetParams) SetStatisticsThroughputRawRead(statisticsThroughputRawRead *int64) {
	o.StatisticsThroughputRawRead = statisticsThroughputRawRead
}

// WithStatisticsThroughputRawTotal adds the statisticsThroughputRawTotal to the volume collection get params
func (o *VolumeCollectionGetParams) WithStatisticsThroughputRawTotal(statisticsThroughputRawTotal *int64) *VolumeCollectionGetParams {
	o.SetStatisticsThroughputRawTotal(statisticsThroughputRawTotal)
	return o
}

// SetStatisticsThroughputRawTotal adds the statisticsThroughputRawTotal to the volume collection get params
func (o *VolumeCollectionGetParams) SetStatisticsThroughputRawTotal(statisticsThroughputRawTotal *int64) {
	o.StatisticsThroughputRawTotal = statisticsThroughputRawTotal
}

// WithStatisticsThroughputRawWrite adds the statisticsThroughputRawWrite to the volume collection get params
func (o *VolumeCollectionGetParams) WithStatisticsThroughputRawWrite(statisticsThroughputRawWrite *int64) *VolumeCollectionGetParams {
	o.SetStatisticsThroughputRawWrite(statisticsThroughputRawWrite)
	return o
}

// SetStatisticsThroughputRawWrite adds the statisticsThroughputRawWrite to the volume collection get params
func (o *VolumeCollectionGetParams) SetStatisticsThroughputRawWrite(statisticsThroughputRawWrite *int64) {
	o.StatisticsThroughputRawWrite = statisticsThroughputRawWrite
}

// WithStatisticsTimestamp adds the statisticsTimestamp to the volume collection get params
func (o *VolumeCollectionGetParams) WithStatisticsTimestamp(statisticsTimestamp *string) *VolumeCollectionGetParams {
	o.SetStatisticsTimestamp(statisticsTimestamp)
	return o
}

// SetStatisticsTimestamp adds the statisticsTimestamp to the volume collection get params
func (o *VolumeCollectionGetParams) SetStatisticsTimestamp(statisticsTimestamp *string) {
	o.StatisticsTimestamp = statisticsTimestamp
}

// WithStyle adds the style to the volume collection get params
func (o *VolumeCollectionGetParams) WithStyle(style *string) *VolumeCollectionGetParams {
	o.SetStyle(style)
	return o
}

// SetStyle adds the style to the volume collection get params
func (o *VolumeCollectionGetParams) SetStyle(style *string) {
	o.Style = style
}

// WithSvm adds the svm to the volume collection get params
func (o *VolumeCollectionGetParams) WithSvm(svm *string) *VolumeCollectionGetParams {
	o.SetSvm(svm)
	return o
}

// SetSvm adds the svm to the volume collection get params
func (o *VolumeCollectionGetParams) SetSvm(svm *string) {
	o.Svm = svm
}

// WithSvmName adds the svmName to the volume collection get params
func (o *VolumeCollectionGetParams) WithSvmName(svmName *string) *VolumeCollectionGetParams {
	o.SetSvmName(svmName)
	return o
}

// SetSvmName adds the svmName to the volume collection get params
func (o *VolumeCollectionGetParams) SetSvmName(svmName *string) {
	o.SvmName = svmName
}

// WithSvmUUID adds the svmUUID to the volume collection get params
func (o *VolumeCollectionGetParams) WithSvmUUID(svmUUID *string) *VolumeCollectionGetParams {
	o.SetSvmUUID(svmUUID)
	return o
}

// SetSvmUUID adds the svmUuid to the volume collection get params
func (o *VolumeCollectionGetParams) SetSvmUUID(svmUUID *string) {
	o.SvmUUID = svmUUID
}

// WithTieringPolicy adds the tieringPolicy to the volume collection get params
func (o *VolumeCollectionGetParams) WithTieringPolicy(tieringPolicy *string) *VolumeCollectionGetParams {
	o.SetTieringPolicy(tieringPolicy)
	return o
}

// SetTieringPolicy adds the tieringPolicy to the volume collection get params
func (o *VolumeCollectionGetParams) SetTieringPolicy(tieringPolicy *string) {
	o.TieringPolicy = tieringPolicy
}

// WithType adds the typeVar to the volume collection get params
func (o *VolumeCollectionGetParams) WithType(typeVar *string) *VolumeCollectionGetParams {
	o.SetType(typeVar)
	return o
}

// SetType adds the type to the volume collection get params
func (o *VolumeCollectionGetParams) SetType(typeVar *string) {
	o.Type = typeVar
}

// WithUUID adds the uuid to the volume collection get params
func (o *VolumeCollectionGetParams) WithUUID(uuid *string) *VolumeCollectionGetParams {
	o.SetUUID(uuid)
	return o
}

// SetUUID adds the uuid to the volume collection get params
func (o *VolumeCollectionGetParams) SetUUID(uuid *string) {
	o.UUID = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *VolumeCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.AggregatesName != nil {

		// query param aggregates.name
		var qrAggregatesName string
		if o.AggregatesName != nil {
			qrAggregatesName = *o.AggregatesName
		}
		qAggregatesName := qrAggregatesName
		if qAggregatesName != "" {
			if err := r.SetQueryParam("aggregates.name", qAggregatesName); err != nil {
				return err
			}
		}

	}

	if o.AggregatesUUID != nil {

		// query param aggregates.uuid
		var qrAggregatesUUID string
		if o.AggregatesUUID != nil {
			qrAggregatesUUID = *o.AggregatesUUID
		}
		qAggregatesUUID := qrAggregatesUUID
		if qAggregatesUUID != "" {
			if err := r.SetQueryParam("aggregates.uuid", qAggregatesUUID); err != nil {
				return err
			}
		}

	}

	if o.ApplicationName != nil {

		// query param application.name
		var qrApplicationName string
		if o.ApplicationName != nil {
			qrApplicationName = *o.ApplicationName
		}
		qApplicationName := qrApplicationName
		if qApplicationName != "" {
			if err := r.SetQueryParam("application.name", qApplicationName); err != nil {
				return err
			}
		}

	}

	if o.ApplicationUUID != nil {

		// query param application.uuid
		var qrApplicationUUID string
		if o.ApplicationUUID != nil {
			qrApplicationUUID = *o.ApplicationUUID
		}
		qApplicationUUID := qrApplicationUUID
		if qApplicationUUID != "" {
			if err := r.SetQueryParam("application.uuid", qApplicationUUID); err != nil {
				return err
			}
		}

	}

	if o.AutosizeGrowThreshold != nil {

		// query param autosize.grow_threshold
		var qrAutosizeGrowThreshold int64
		if o.AutosizeGrowThreshold != nil {
			qrAutosizeGrowThreshold = *o.AutosizeGrowThreshold
		}
		qAutosizeGrowThreshold := swag.FormatInt64(qrAutosizeGrowThreshold)
		if qAutosizeGrowThreshold != "" {
			if err := r.SetQueryParam("autosize.grow_threshold", qAutosizeGrowThreshold); err != nil {
				return err
			}
		}

	}

	if o.AutosizeMaximum != nil {

		// query param autosize.maximum
		var qrAutosizeMaximum int64
		if o.AutosizeMaximum != nil {
			qrAutosizeMaximum = *o.AutosizeMaximum
		}
		qAutosizeMaximum := swag.FormatInt64(qrAutosizeMaximum)
		if qAutosizeMaximum != "" {
			if err := r.SetQueryParam("autosize.maximum", qAutosizeMaximum); err != nil {
				return err
			}
		}

	}

	if o.AutosizeMinimum != nil {

		// query param autosize.minimum
		var qrAutosizeMinimum int64
		if o.AutosizeMinimum != nil {
			qrAutosizeMinimum = *o.AutosizeMinimum
		}
		qAutosizeMinimum := swag.FormatInt64(qrAutosizeMinimum)
		if qAutosizeMinimum != "" {
			if err := r.SetQueryParam("autosize.minimum", qAutosizeMinimum); err != nil {
				return err
			}
		}

	}

	if o.AutosizeMode != nil {

		// query param autosize.mode
		var qrAutosizeMode string
		if o.AutosizeMode != nil {
			qrAutosizeMode = *o.AutosizeMode
		}
		qAutosizeMode := qrAutosizeMode
		if qAutosizeMode != "" {
			if err := r.SetQueryParam("autosize.mode", qAutosizeMode); err != nil {
				return err
			}
		}

	}

	if o.AutosizeShrinkThreshold != nil {

		// query param autosize.shrink_threshold
		var qrAutosizeShrinkThreshold int64
		if o.AutosizeShrinkThreshold != nil {
			qrAutosizeShrinkThreshold = *o.AutosizeShrinkThreshold
		}
		qAutosizeShrinkThreshold := swag.FormatInt64(qrAutosizeShrinkThreshold)
		if qAutosizeShrinkThreshold != "" {
			if err := r.SetQueryParam("autosize.shrink_threshold", qAutosizeShrinkThreshold); err != nil {
				return err
			}
		}

	}

	if o.CloneIsFlexclone != nil {

		// query param clone.is_flexclone
		var qrCloneIsFlexclone bool
		if o.CloneIsFlexclone != nil {
			qrCloneIsFlexclone = *o.CloneIsFlexclone
		}
		qCloneIsFlexclone := swag.FormatBool(qrCloneIsFlexclone)
		if qCloneIsFlexclone != "" {
			if err := r.SetQueryParam("clone.is_flexclone", qCloneIsFlexclone); err != nil {
				return err
			}
		}

	}

	if o.CloneParentSnapshotName != nil {

		// query param clone.parent_snapshot.name
		var qrCloneParentSnapshotName string
		if o.CloneParentSnapshotName != nil {
			qrCloneParentSnapshotName = *o.CloneParentSnapshotName
		}
		qCloneParentSnapshotName := qrCloneParentSnapshotName
		if qCloneParentSnapshotName != "" {
			if err := r.SetQueryParam("clone.parent_snapshot.name", qCloneParentSnapshotName); err != nil {
				return err
			}
		}

	}

	if o.CloneParentSnapshotUUID != nil {

		// query param clone.parent_snapshot.uuid
		var qrCloneParentSnapshotUUID string
		if o.CloneParentSnapshotUUID != nil {
			qrCloneParentSnapshotUUID = *o.CloneParentSnapshotUUID
		}
		qCloneParentSnapshotUUID := qrCloneParentSnapshotUUID
		if qCloneParentSnapshotUUID != "" {
			if err := r.SetQueryParam("clone.parent_snapshot.uuid", qCloneParentSnapshotUUID); err != nil {
				return err
			}
		}

	}

	if o.CloneParentSvmName != nil {

		// query param clone.parent_svm.name
		var qrCloneParentSvmName string
		if o.CloneParentSvmName != nil {
			qrCloneParentSvmName = *o.CloneParentSvmName
		}
		qCloneParentSvmName := qrCloneParentSvmName
		if qCloneParentSvmName != "" {
			if err := r.SetQueryParam("clone.parent_svm.name", qCloneParentSvmName); err != nil {
				return err
			}
		}

	}

	if o.CloneParentSvmUUID != nil {

		// query param clone.parent_svm.uuid
		var qrCloneParentSvmUUID string
		if o.CloneParentSvmUUID != nil {
			qrCloneParentSvmUUID = *o.CloneParentSvmUUID
		}
		qCloneParentSvmUUID := qrCloneParentSvmUUID
		if qCloneParentSvmUUID != "" {
			if err := r.SetQueryParam("clone.parent_svm.uuid", qCloneParentSvmUUID); err != nil {
				return err
			}
		}

	}

	if o.CloneParentVolumeName != nil {

		// query param clone.parent_volume.name
		var qrCloneParentVolumeName string
		if o.CloneParentVolumeName != nil {
			qrCloneParentVolumeName = *o.CloneParentVolumeName
		}
		qCloneParentVolumeName := qrCloneParentVolumeName
		if qCloneParentVolumeName != "" {
			if err := r.SetQueryParam("clone.parent_volume.name", qCloneParentVolumeName); err != nil {
				return err
			}
		}

	}

	if o.CloneParentVolumeUUID != nil {

		// query param clone.parent_volume.uuid
		var qrCloneParentVolumeUUID string
		if o.CloneParentVolumeUUID != nil {
			qrCloneParentVolumeUUID = *o.CloneParentVolumeUUID
		}
		qCloneParentVolumeUUID := qrCloneParentVolumeUUID
		if qCloneParentVolumeUUID != "" {
			if err := r.SetQueryParam("clone.parent_volume.uuid", qCloneParentVolumeUUID); err != nil {
				return err
			}
		}

	}

	if o.CloneSplitCompletePercent != nil {

		// query param clone.split_complete_percent
		var qrCloneSplitCompletePercent int64
		if o.CloneSplitCompletePercent != nil {
			qrCloneSplitCompletePercent = *o.CloneSplitCompletePercent
		}
		qCloneSplitCompletePercent := swag.FormatInt64(qrCloneSplitCompletePercent)
		if qCloneSplitCompletePercent != "" {
			if err := r.SetQueryParam("clone.split_complete_percent", qCloneSplitCompletePercent); err != nil {
				return err
			}
		}

	}

	if o.CloneSplitEstimate != nil {

		// query param clone.split_estimate
		var qrCloneSplitEstimate int64
		if o.CloneSplitEstimate != nil {
			qrCloneSplitEstimate = *o.CloneSplitEstimate
		}
		qCloneSplitEstimate := swag.FormatInt64(qrCloneSplitEstimate)
		if qCloneSplitEstimate != "" {
			if err := r.SetQueryParam("clone.split_estimate", qCloneSplitEstimate); err != nil {
				return err
			}
		}

	}

	if o.CloneSplitInitiated != nil {

		// query param clone.split_initiated
		var qrCloneSplitInitiated bool
		if o.CloneSplitInitiated != nil {
			qrCloneSplitInitiated = *o.CloneSplitInitiated
		}
		qCloneSplitInitiated := swag.FormatBool(qrCloneSplitInitiated)
		if qCloneSplitInitiated != "" {
			if err := r.SetQueryParam("clone.split_initiated", qCloneSplitInitiated); err != nil {
				return err
			}
		}

	}

	if o.Comment != nil {

		// query param comment
		var qrComment string
		if o.Comment != nil {
			qrComment = *o.Comment
		}
		qComment := qrComment
		if qComment != "" {
			if err := r.SetQueryParam("comment", qComment); err != nil {
				return err
			}
		}

	}

	if o.ConsistencyGroupName != nil {

		// query param consistency_group.name
		var qrConsistencyGroupName string
		if o.ConsistencyGroupName != nil {
			qrConsistencyGroupName = *o.ConsistencyGroupName
		}
		qConsistencyGroupName := qrConsistencyGroupName
		if qConsistencyGroupName != "" {
			if err := r.SetQueryParam("consistency_group.name", qConsistencyGroupName); err != nil {
				return err
			}
		}

	}

	if o.CreateTime != nil {

		// query param create_time
		var qrCreateTime string
		if o.CreateTime != nil {
			qrCreateTime = *o.CreateTime
		}
		qCreateTime := qrCreateTime
		if qCreateTime != "" {
			if err := r.SetQueryParam("create_time", qCreateTime); err != nil {
				return err
			}
		}

	}

	if o.EfficiencyCompaction != nil {

		// query param efficiency.compaction
		var qrEfficiencyCompaction string
		if o.EfficiencyCompaction != nil {
			qrEfficiencyCompaction = *o.EfficiencyCompaction
		}
		qEfficiencyCompaction := qrEfficiencyCompaction
		if qEfficiencyCompaction != "" {
			if err := r.SetQueryParam("efficiency.compaction", qEfficiencyCompaction); err != nil {
				return err
			}
		}

	}

	if o.EfficiencyCompression != nil {

		// query param efficiency.compression
		var qrEfficiencyCompression string
		if o.EfficiencyCompression != nil {
			qrEfficiencyCompression = *o.EfficiencyCompression
		}
		qEfficiencyCompression := qrEfficiencyCompression
		if qEfficiencyCompression != "" {
			if err := r.SetQueryParam("efficiency.compression", qEfficiencyCompression); err != nil {
				return err
			}
		}

	}

	if o.EfficiencyCrossVolumeDedupe != nil {

		// query param efficiency.cross_volume_dedupe
		var qrEfficiencyCrossVolumeDedupe string
		if o.EfficiencyCrossVolumeDedupe != nil {
			qrEfficiencyCrossVolumeDedupe = *o.EfficiencyCrossVolumeDedupe
		}
		qEfficiencyCrossVolumeDedupe := qrEfficiencyCrossVolumeDedupe
		if qEfficiencyCrossVolumeDedupe != "" {
			if err := r.SetQueryParam("efficiency.cross_volume_dedupe", qEfficiencyCrossVolumeDedupe); err != nil {
				return err
			}
		}

	}

	if o.EfficiencyDedupe != nil {

		// query param efficiency.dedupe
		var qrEfficiencyDedupe string
		if o.EfficiencyDedupe != nil {
			qrEfficiencyDedupe = *o.EfficiencyDedupe
		}
		qEfficiencyDedupe := qrEfficiencyDedupe
		if qEfficiencyDedupe != "" {
			if err := r.SetQueryParam("efficiency.dedupe", qEfficiencyDedupe); err != nil {
				return err
			}
		}

	}

	if o.EfficiencyPolicyName != nil {

		// query param efficiency.policy.name
		var qrEfficiencyPolicyName string
		if o.EfficiencyPolicyName != nil {
			qrEfficiencyPolicyName = *o.EfficiencyPolicyName
		}
		qEfficiencyPolicyName := qrEfficiencyPolicyName
		if qEfficiencyPolicyName != "" {
			if err := r.SetQueryParam("efficiency.policy.name", qEfficiencyPolicyName); err != nil {
				return err
			}
		}

	}

	if o.EncryptionEnabled != nil {

		// query param encryption.enabled
		var qrEncryptionEnabled bool
		if o.EncryptionEnabled != nil {
			qrEncryptionEnabled = *o.EncryptionEnabled
		}
		qEncryptionEnabled := swag.FormatBool(qrEncryptionEnabled)
		if qEncryptionEnabled != "" {
			if err := r.SetQueryParam("encryption.enabled", qEncryptionEnabled); err != nil {
				return err
			}
		}

	}

	if o.EncryptionKeyID != nil {

		// query param encryption.key_id
		var qrEncryptionKeyID string
		if o.EncryptionKeyID != nil {
			qrEncryptionKeyID = *o.EncryptionKeyID
		}
		qEncryptionKeyID := qrEncryptionKeyID
		if qEncryptionKeyID != "" {
			if err := r.SetQueryParam("encryption.key_id", qEncryptionKeyID); err != nil {
				return err
			}
		}

	}

	if o.EncryptionRekey != nil {

		// query param encryption.rekey
		var qrEncryptionRekey bool
		if o.EncryptionRekey != nil {
			qrEncryptionRekey = *o.EncryptionRekey
		}
		qEncryptionRekey := swag.FormatBool(qrEncryptionRekey)
		if qEncryptionRekey != "" {
			if err := r.SetQueryParam("encryption.rekey", qEncryptionRekey); err != nil {
				return err
			}
		}

	}

	if o.EncryptionState != nil {

		// query param encryption.state
		var qrEncryptionState string
		if o.EncryptionState != nil {
			qrEncryptionState = *o.EncryptionState
		}
		qEncryptionState := qrEncryptionState
		if qEncryptionState != "" {
			if err := r.SetQueryParam("encryption.state", qEncryptionState); err != nil {
				return err
			}
		}

	}

	if o.EncryptionStatusCode != nil {

		// query param encryption.status.code
		var qrEncryptionStatusCode string
		if o.EncryptionStatusCode != nil {
			qrEncryptionStatusCode = *o.EncryptionStatusCode
		}
		qEncryptionStatusCode := qrEncryptionStatusCode
		if qEncryptionStatusCode != "" {
			if err := r.SetQueryParam("encryption.status.code", qEncryptionStatusCode); err != nil {
				return err
			}
		}

	}

	if o.EncryptionStatusMessage != nil {

		// query param encryption.status.message
		var qrEncryptionStatusMessage string
		if o.EncryptionStatusMessage != nil {
			qrEncryptionStatusMessage = *o.EncryptionStatusMessage
		}
		qEncryptionStatusMessage := qrEncryptionStatusMessage
		if qEncryptionStatusMessage != "" {
			if err := r.SetQueryParam("encryption.status.message", qEncryptionStatusMessage); err != nil {
				return err
			}
		}

	}

	if o.EncryptionType != nil {

		// query param encryption.type
		var qrEncryptionType string
		if o.EncryptionType != nil {
			qrEncryptionType = *o.EncryptionType
		}
		qEncryptionType := qrEncryptionType
		if qEncryptionType != "" {
			if err := r.SetQueryParam("encryption.type", qEncryptionType); err != nil {
				return err
			}
		}

	}

	if o.ErrorStateHasBadBlocks != nil {

		// query param error_state.has_bad_blocks
		var qrErrorStateHasBadBlocks bool
		if o.ErrorStateHasBadBlocks != nil {
			qrErrorStateHasBadBlocks = *o.ErrorStateHasBadBlocks
		}
		qErrorStateHasBadBlocks := swag.FormatBool(qrErrorStateHasBadBlocks)
		if qErrorStateHasBadBlocks != "" {
			if err := r.SetQueryParam("error_state.has_bad_blocks", qErrorStateHasBadBlocks); err != nil {
				return err
			}
		}

	}

	if o.ErrorStateIsInconsistent != nil {

		// query param error_state.is_inconsistent
		var qrErrorStateIsInconsistent bool
		if o.ErrorStateIsInconsistent != nil {
			qrErrorStateIsInconsistent = *o.ErrorStateIsInconsistent
		}
		qErrorStateIsInconsistent := swag.FormatBool(qrErrorStateIsInconsistent)
		if qErrorStateIsInconsistent != "" {
			if err := r.SetQueryParam("error_state.is_inconsistent", qErrorStateIsInconsistent); err != nil {
				return err
			}
		}

	}

	valuesFields := o.Fields

	joinedFields := swag.JoinByFormat(valuesFields, "csv")
	// query array param fields
	if err := r.SetQueryParam("fields", joinedFields...); err != nil {
		return err
	}

	if o.FilesMaximum != nil {

		// query param files.maximum
		var qrFilesMaximum int64
		if o.FilesMaximum != nil {
			qrFilesMaximum = *o.FilesMaximum
		}
		qFilesMaximum := swag.FormatInt64(qrFilesMaximum)
		if qFilesMaximum != "" {
			if err := r.SetQueryParam("files.maximum", qFilesMaximum); err != nil {
				return err
			}
		}

	}

	if o.FilesUsed != nil {

		// query param files.used
		var qrFilesUsed int64
		if o.FilesUsed != nil {
			qrFilesUsed = *o.FilesUsed
		}
		qFilesUsed := swag.FormatInt64(qrFilesUsed)
		if qFilesUsed != "" {
			if err := r.SetQueryParam("files.used", qFilesUsed); err != nil {
				return err
			}
		}

	}

	if o.FlexcacheEndpointType != nil {

		// query param flexcache_endpoint_type
		var qrFlexcacheEndpointType string
		if o.FlexcacheEndpointType != nil {
			qrFlexcacheEndpointType = *o.FlexcacheEndpointType
		}
		qFlexcacheEndpointType := qrFlexcacheEndpointType
		if qFlexcacheEndpointType != "" {
			if err := r.SetQueryParam("flexcache_endpoint_type", qFlexcacheEndpointType); err != nil {
				return err
			}
		}

	}

	if o.GuaranteeHonored != nil {

		// query param guarantee.honored
		var qrGuaranteeHonored bool
		if o.GuaranteeHonored != nil {
			qrGuaranteeHonored = *o.GuaranteeHonored
		}
		qGuaranteeHonored := swag.FormatBool(qrGuaranteeHonored)
		if qGuaranteeHonored != "" {
			if err := r.SetQueryParam("guarantee.honored", qGuaranteeHonored); err != nil {
				return err
			}
		}

	}

	if o.GuaranteeType != nil {

		// query param guarantee.type
		var qrGuaranteeType string
		if o.GuaranteeType != nil {
			qrGuaranteeType = *o.GuaranteeType
		}
		qGuaranteeType := qrGuaranteeType
		if qGuaranteeType != "" {
			if err := r.SetQueryParam("guarantee.type", qGuaranteeType); err != nil {
				return err
			}
		}

	}

	if o.IsSvmRoot != nil {

		// query param is_svm_root
		var qrIsSvmRoot bool
		if o.IsSvmRoot != nil {
			qrIsSvmRoot = *o.IsSvmRoot
		}
		qIsSvmRoot := swag.FormatBool(qrIsSvmRoot)
		if qIsSvmRoot != "" {
			if err := r.SetQueryParam("is_svm_root", qIsSvmRoot); err != nil {
				return err
			}
		}

	}

	if o.Language != nil {

		// query param language
		var qrLanguage string
		if o.Language != nil {
			qrLanguage = *o.Language
		}
		qLanguage := qrLanguage
		if qLanguage != "" {
			if err := r.SetQueryParam("language", qLanguage); err != nil {
				return err
			}
		}

	}

	if o.MaxRecords != nil {

		// query param max_records
		var qrMaxRecords int64
		if o.MaxRecords != nil {
			qrMaxRecords = *o.MaxRecords
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {
			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}

	}

	if o.MetricCloudDuration != nil {

		// query param metric.cloud.duration
		var qrMetricCloudDuration string
		if o.MetricCloudDuration != nil {
			qrMetricCloudDuration = *o.MetricCloudDuration
		}
		qMetricCloudDuration := qrMetricCloudDuration
		if qMetricCloudDuration != "" {
			if err := r.SetQueryParam("metric.cloud.duration", qMetricCloudDuration); err != nil {
				return err
			}
		}

	}

	if o.MetricCloudIopsOther != nil {

		// query param metric.cloud.iops.other
		var qrMetricCloudIopsOther int64
		if o.MetricCloudIopsOther != nil {
			qrMetricCloudIopsOther = *o.MetricCloudIopsOther
		}
		qMetricCloudIopsOther := swag.FormatInt64(qrMetricCloudIopsOther)
		if qMetricCloudIopsOther != "" {
			if err := r.SetQueryParam("metric.cloud.iops.other", qMetricCloudIopsOther); err != nil {
				return err
			}
		}

	}

	if o.MetricCloudIopsRead != nil {

		// query param metric.cloud.iops.read
		var qrMetricCloudIopsRead int64
		if o.MetricCloudIopsRead != nil {
			qrMetricCloudIopsRead = *o.MetricCloudIopsRead
		}
		qMetricCloudIopsRead := swag.FormatInt64(qrMetricCloudIopsRead)
		if qMetricCloudIopsRead != "" {
			if err := r.SetQueryParam("metric.cloud.iops.read", qMetricCloudIopsRead); err != nil {
				return err
			}
		}

	}

	if o.MetricCloudIopsTotal != nil {

		// query param metric.cloud.iops.total
		var qrMetricCloudIopsTotal int64
		if o.MetricCloudIopsTotal != nil {
			qrMetricCloudIopsTotal = *o.MetricCloudIopsTotal
		}
		qMetricCloudIopsTotal := swag.FormatInt64(qrMetricCloudIopsTotal)
		if qMetricCloudIopsTotal != "" {
			if err := r.SetQueryParam("metric.cloud.iops.total", qMetricCloudIopsTotal); err != nil {
				return err
			}
		}

	}

	if o.MetricCloudIopsWrite != nil {

		// query param metric.cloud.iops.write
		var qrMetricCloudIopsWrite int64
		if o.MetricCloudIopsWrite != nil {
			qrMetricCloudIopsWrite = *o.MetricCloudIopsWrite
		}
		qMetricCloudIopsWrite := swag.FormatInt64(qrMetricCloudIopsWrite)
		if qMetricCloudIopsWrite != "" {
			if err := r.SetQueryParam("metric.cloud.iops.write", qMetricCloudIopsWrite); err != nil {
				return err
			}
		}

	}

	if o.MetricCloudLatencyOther != nil {

		// query param metric.cloud.latency.other
		var qrMetricCloudLatencyOther int64
		if o.MetricCloudLatencyOther != nil {
			qrMetricCloudLatencyOther = *o.MetricCloudLatencyOther
		}
		qMetricCloudLatencyOther := swag.FormatInt64(qrMetricCloudLatencyOther)
		if qMetricCloudLatencyOther != "" {
			if err := r.SetQueryParam("metric.cloud.latency.other", qMetricCloudLatencyOther); err != nil {
				return err
			}
		}

	}

	if o.MetricCloudLatencyRead != nil {

		// query param metric.cloud.latency.read
		var qrMetricCloudLatencyRead int64
		if o.MetricCloudLatencyRead != nil {
			qrMetricCloudLatencyRead = *o.MetricCloudLatencyRead
		}
		qMetricCloudLatencyRead := swag.FormatInt64(qrMetricCloudLatencyRead)
		if qMetricCloudLatencyRead != "" {
			if err := r.SetQueryParam("metric.cloud.latency.read", qMetricCloudLatencyRead); err != nil {
				return err
			}
		}

	}

	if o.MetricCloudLatencyTotal != nil {

		// query param metric.cloud.latency.total
		var qrMetricCloudLatencyTotal int64
		if o.MetricCloudLatencyTotal != nil {
			qrMetricCloudLatencyTotal = *o.MetricCloudLatencyTotal
		}
		qMetricCloudLatencyTotal := swag.FormatInt64(qrMetricCloudLatencyTotal)
		if qMetricCloudLatencyTotal != "" {
			if err := r.SetQueryParam("metric.cloud.latency.total", qMetricCloudLatencyTotal); err != nil {
				return err
			}
		}

	}

	if o.MetricCloudLatencyWrite != nil {

		// query param metric.cloud.latency.write
		var qrMetricCloudLatencyWrite int64
		if o.MetricCloudLatencyWrite != nil {
			qrMetricCloudLatencyWrite = *o.MetricCloudLatencyWrite
		}
		qMetricCloudLatencyWrite := swag.FormatInt64(qrMetricCloudLatencyWrite)
		if qMetricCloudLatencyWrite != "" {
			if err := r.SetQueryParam("metric.cloud.latency.write", qMetricCloudLatencyWrite); err != nil {
				return err
			}
		}

	}

	if o.MetricCloudStatus != nil {

		// query param metric.cloud.status
		var qrMetricCloudStatus string
		if o.MetricCloudStatus != nil {
			qrMetricCloudStatus = *o.MetricCloudStatus
		}
		qMetricCloudStatus := qrMetricCloudStatus
		if qMetricCloudStatus != "" {
			if err := r.SetQueryParam("metric.cloud.status", qMetricCloudStatus); err != nil {
				return err
			}
		}

	}

	if o.MetricCloudTimestamp != nil {

		// query param metric.cloud.timestamp
		var qrMetricCloudTimestamp string
		if o.MetricCloudTimestamp != nil {
			qrMetricCloudTimestamp = *o.MetricCloudTimestamp
		}
		qMetricCloudTimestamp := qrMetricCloudTimestamp
		if qMetricCloudTimestamp != "" {
			if err := r.SetQueryParam("metric.cloud.timestamp", qMetricCloudTimestamp); err != nil {
				return err
			}
		}

	}

	if o.MetricDuration != nil {

		// query param metric.duration
		var qrMetricDuration string
		if o.MetricDuration != nil {
			qrMetricDuration = *o.MetricDuration
		}
		qMetricDuration := qrMetricDuration
		if qMetricDuration != "" {
			if err := r.SetQueryParam("metric.duration", qMetricDuration); err != nil {
				return err
			}
		}

	}

	if o.MetricIopsOther != nil {

		// query param metric.iops.other
		var qrMetricIopsOther int64
		if o.MetricIopsOther != nil {
			qrMetricIopsOther = *o.MetricIopsOther
		}
		qMetricIopsOther := swag.FormatInt64(qrMetricIopsOther)
		if qMetricIopsOther != "" {
			if err := r.SetQueryParam("metric.iops.other", qMetricIopsOther); err != nil {
				return err
			}
		}

	}

	if o.MetricIopsRead != nil {

		// query param metric.iops.read
		var qrMetricIopsRead int64
		if o.MetricIopsRead != nil {
			qrMetricIopsRead = *o.MetricIopsRead
		}
		qMetricIopsRead := swag.FormatInt64(qrMetricIopsRead)
		if qMetricIopsRead != "" {
			if err := r.SetQueryParam("metric.iops.read", qMetricIopsRead); err != nil {
				return err
			}
		}

	}

	if o.MetricIopsTotal != nil {

		// query param metric.iops.total
		var qrMetricIopsTotal int64
		if o.MetricIopsTotal != nil {
			qrMetricIopsTotal = *o.MetricIopsTotal
		}
		qMetricIopsTotal := swag.FormatInt64(qrMetricIopsTotal)
		if qMetricIopsTotal != "" {
			if err := r.SetQueryParam("metric.iops.total", qMetricIopsTotal); err != nil {
				return err
			}
		}

	}

	if o.MetricIopsWrite != nil {

		// query param metric.iops.write
		var qrMetricIopsWrite int64
		if o.MetricIopsWrite != nil {
			qrMetricIopsWrite = *o.MetricIopsWrite
		}
		qMetricIopsWrite := swag.FormatInt64(qrMetricIopsWrite)
		if qMetricIopsWrite != "" {
			if err := r.SetQueryParam("metric.iops.write", qMetricIopsWrite); err != nil {
				return err
			}
		}

	}

	if o.MetricLatencyOther != nil {

		// query param metric.latency.other
		var qrMetricLatencyOther int64
		if o.MetricLatencyOther != nil {
			qrMetricLatencyOther = *o.MetricLatencyOther
		}
		qMetricLatencyOther := swag.FormatInt64(qrMetricLatencyOther)
		if qMetricLatencyOther != "" {
			if err := r.SetQueryParam("metric.latency.other", qMetricLatencyOther); err != nil {
				return err
			}
		}

	}

	if o.MetricLatencyRead != nil {

		// query param metric.latency.read
		var qrMetricLatencyRead int64
		if o.MetricLatencyRead != nil {
			qrMetricLatencyRead = *o.MetricLatencyRead
		}
		qMetricLatencyRead := swag.FormatInt64(qrMetricLatencyRead)
		if qMetricLatencyRead != "" {
			if err := r.SetQueryParam("metric.latency.read", qMetricLatencyRead); err != nil {
				return err
			}
		}

	}

	if o.MetricLatencyTotal != nil {

		// query param metric.latency.total
		var qrMetricLatencyTotal int64
		if o.MetricLatencyTotal != nil {
			qrMetricLatencyTotal = *o.MetricLatencyTotal
		}
		qMetricLatencyTotal := swag.FormatInt64(qrMetricLatencyTotal)
		if qMetricLatencyTotal != "" {
			if err := r.SetQueryParam("metric.latency.total", qMetricLatencyTotal); err != nil {
				return err
			}
		}

	}

	if o.MetricLatencyWrite != nil {

		// query param metric.latency.write
		var qrMetricLatencyWrite int64
		if o.MetricLatencyWrite != nil {
			qrMetricLatencyWrite = *o.MetricLatencyWrite
		}
		qMetricLatencyWrite := swag.FormatInt64(qrMetricLatencyWrite)
		if qMetricLatencyWrite != "" {
			if err := r.SetQueryParam("metric.latency.write", qMetricLatencyWrite); err != nil {
				return err
			}
		}

	}

	if o.MetricStatus != nil {

		// query param metric.status
		var qrMetricStatus string
		if o.MetricStatus != nil {
			qrMetricStatus = *o.MetricStatus
		}
		qMetricStatus := qrMetricStatus
		if qMetricStatus != "" {
			if err := r.SetQueryParam("metric.status", qMetricStatus); err != nil {
				return err
			}
		}

	}

	if o.MetricThroughputOther != nil {

		// query param metric.throughput.other
		var qrMetricThroughputOther int64
		if o.MetricThroughputOther != nil {
			qrMetricThroughputOther = *o.MetricThroughputOther
		}
		qMetricThroughputOther := swag.FormatInt64(qrMetricThroughputOther)
		if qMetricThroughputOther != "" {
			if err := r.SetQueryParam("metric.throughput.other", qMetricThroughputOther); err != nil {
				return err
			}
		}

	}

	if o.MetricThroughputRead != nil {

		// query param metric.throughput.read
		var qrMetricThroughputRead int64
		if o.MetricThroughputRead != nil {
			qrMetricThroughputRead = *o.MetricThroughputRead
		}
		qMetricThroughputRead := swag.FormatInt64(qrMetricThroughputRead)
		if qMetricThroughputRead != "" {
			if err := r.SetQueryParam("metric.throughput.read", qMetricThroughputRead); err != nil {
				return err
			}
		}

	}

	if o.MetricThroughputTotal != nil {

		// query param metric.throughput.total
		var qrMetricThroughputTotal int64
		if o.MetricThroughputTotal != nil {
			qrMetricThroughputTotal = *o.MetricThroughputTotal
		}
		qMetricThroughputTotal := swag.FormatInt64(qrMetricThroughputTotal)
		if qMetricThroughputTotal != "" {
			if err := r.SetQueryParam("metric.throughput.total", qMetricThroughputTotal); err != nil {
				return err
			}
		}

	}

	if o.MetricThroughputWrite != nil {

		// query param metric.throughput.write
		var qrMetricThroughputWrite int64
		if o.MetricThroughputWrite != nil {
			qrMetricThroughputWrite = *o.MetricThroughputWrite
		}
		qMetricThroughputWrite := swag.FormatInt64(qrMetricThroughputWrite)
		if qMetricThroughputWrite != "" {
			if err := r.SetQueryParam("metric.throughput.write", qMetricThroughputWrite); err != nil {
				return err
			}
		}

	}

	if o.MetricTimestamp != nil {

		// query param metric.timestamp
		var qrMetricTimestamp string
		if o.MetricTimestamp != nil {
			qrMetricTimestamp = *o.MetricTimestamp
		}
		qMetricTimestamp := qrMetricTimestamp
		if qMetricTimestamp != "" {
			if err := r.SetQueryParam("metric.timestamp", qMetricTimestamp); err != nil {
				return err
			}
		}

	}

	if o.MovementCutoverWindow != nil {

		// query param movement.cutover_window
		var qrMovementCutoverWindow int64
		if o.MovementCutoverWindow != nil {
			qrMovementCutoverWindow = *o.MovementCutoverWindow
		}
		qMovementCutoverWindow := swag.FormatInt64(qrMovementCutoverWindow)
		if qMovementCutoverWindow != "" {
			if err := r.SetQueryParam("movement.cutover_window", qMovementCutoverWindow); err != nil {
				return err
			}
		}

	}

	if o.MovementDestinationAggregateName != nil {

		// query param movement.destination_aggregate.name
		var qrMovementDestinationAggregateName string
		if o.MovementDestinationAggregateName != nil {
			qrMovementDestinationAggregateName = *o.MovementDestinationAggregateName
		}
		qMovementDestinationAggregateName := qrMovementDestinationAggregateName
		if qMovementDestinationAggregateName != "" {
			if err := r.SetQueryParam("movement.destination_aggregate.name", qMovementDestinationAggregateName); err != nil {
				return err
			}
		}

	}

	if o.MovementDestinationAggregateUUID != nil {

		// query param movement.destination_aggregate.uuid
		var qrMovementDestinationAggregateUUID string
		if o.MovementDestinationAggregateUUID != nil {
			qrMovementDestinationAggregateUUID = *o.MovementDestinationAggregateUUID
		}
		qMovementDestinationAggregateUUID := qrMovementDestinationAggregateUUID
		if qMovementDestinationAggregateUUID != "" {
			if err := r.SetQueryParam("movement.destination_aggregate.uuid", qMovementDestinationAggregateUUID); err != nil {
				return err
			}
		}

	}

	if o.MovementPercentComplete != nil {

		// query param movement.percent_complete
		var qrMovementPercentComplete int64
		if o.MovementPercentComplete != nil {
			qrMovementPercentComplete = *o.MovementPercentComplete
		}
		qMovementPercentComplete := swag.FormatInt64(qrMovementPercentComplete)
		if qMovementPercentComplete != "" {
			if err := r.SetQueryParam("movement.percent_complete", qMovementPercentComplete); err != nil {
				return err
			}
		}

	}

	if o.MovementState != nil {

		// query param movement.state
		var qrMovementState string
		if o.MovementState != nil {
			qrMovementState = *o.MovementState
		}
		qMovementState := qrMovementState
		if qMovementState != "" {
			if err := r.SetQueryParam("movement.state", qMovementState); err != nil {
				return err
			}
		}

	}

	if o.Name != nil {

		// query param name
		var qrName string
		if o.Name != nil {
			qrName = *o.Name
		}
		qName := qrName
		if qName != "" {
			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}

	}

	if o.NasExportPolicyID != nil {

		// query param nas.export_policy.id
		var qrNasExportPolicyID int64
		if o.NasExportPolicyID != nil {
			qrNasExportPolicyID = *o.NasExportPolicyID
		}
		qNasExportPolicyID := swag.FormatInt64(qrNasExportPolicyID)
		if qNasExportPolicyID != "" {
			if err := r.SetQueryParam("nas.export_policy.id", qNasExportPolicyID); err != nil {
				return err
			}
		}

	}

	if o.NasExportPolicyName != nil {

		// query param nas.export_policy.name
		var qrNasExportPolicyName string
		if o.NasExportPolicyName != nil {
			qrNasExportPolicyName = *o.NasExportPolicyName
		}
		qNasExportPolicyName := qrNasExportPolicyName
		if qNasExportPolicyName != "" {
			if err := r.SetQueryParam("nas.export_policy.name", qNasExportPolicyName); err != nil {
				return err
			}
		}

	}

	if o.NasGid != nil {

		// query param nas.gid
		var qrNasGid int64
		if o.NasGid != nil {
			qrNasGid = *o.NasGid
		}
		qNasGid := swag.FormatInt64(qrNasGid)
		if qNasGid != "" {
			if err := r.SetQueryParam("nas.gid", qNasGid); err != nil {
				return err
			}
		}

	}

	if o.NasPath != nil {

		// query param nas.path
		var qrNasPath string
		if o.NasPath != nil {
			qrNasPath = *o.NasPath
		}
		qNasPath := qrNasPath
		if qNasPath != "" {
			if err := r.SetQueryParam("nas.path", qNasPath); err != nil {
				return err
			}
		}

	}

	if o.NasSecurityStyle != nil {

		// query param nas.security_style
		var qrNasSecurityStyle string
		if o.NasSecurityStyle != nil {
			qrNasSecurityStyle = *o.NasSecurityStyle
		}
		qNasSecurityStyle := qrNasSecurityStyle
		if qNasSecurityStyle != "" {
			if err := r.SetQueryParam("nas.security_style", qNasSecurityStyle); err != nil {
				return err
			}
		}

	}

	if o.NasUID != nil {

		// query param nas.uid
		var qrNasUID int64
		if o.NasUID != nil {
			qrNasUID = *o.NasUID
		}
		qNasUID := swag.FormatInt64(qrNasUID)
		if qNasUID != "" {
			if err := r.SetQueryParam("nas.uid", qNasUID); err != nil {
				return err
			}
		}

	}

	if o.NasUnixPermissions != nil {

		// query param nas.unix_permissions
		var qrNasUnixPermissions int64
		if o.NasUnixPermissions != nil {
			qrNasUnixPermissions = *o.NasUnixPermissions
		}
		qNasUnixPermissions := swag.FormatInt64(qrNasUnixPermissions)
		if qNasUnixPermissions != "" {
			if err := r.SetQueryParam("nas.unix_permissions", qNasUnixPermissions); err != nil {
				return err
			}
		}

	}

	valuesOrderBy := o.OrderBy

	joinedOrderBy := swag.JoinByFormat(valuesOrderBy, "csv")
	// query array param order_by
	if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
		return err
	}

	if o.QosPolicyMaxThroughputIops != nil {

		// query param qos.policy.max_throughput_iops
		var qrQosPolicyMaxThroughputIops int64
		if o.QosPolicyMaxThroughputIops != nil {
			qrQosPolicyMaxThroughputIops = *o.QosPolicyMaxThroughputIops
		}
		qQosPolicyMaxThroughputIops := swag.FormatInt64(qrQosPolicyMaxThroughputIops)
		if qQosPolicyMaxThroughputIops != "" {
			if err := r.SetQueryParam("qos.policy.max_throughput_iops", qQosPolicyMaxThroughputIops); err != nil {
				return err
			}
		}

	}

	if o.QosPolicyMaxThroughputMbps != nil {

		// query param qos.policy.max_throughput_mbps
		var qrQosPolicyMaxThroughputMbps int64
		if o.QosPolicyMaxThroughputMbps != nil {
			qrQosPolicyMaxThroughputMbps = *o.QosPolicyMaxThroughputMbps
		}
		qQosPolicyMaxThroughputMbps := swag.FormatInt64(qrQosPolicyMaxThroughputMbps)
		if qQosPolicyMaxThroughputMbps != "" {
			if err := r.SetQueryParam("qos.policy.max_throughput_mbps", qQosPolicyMaxThroughputMbps); err != nil {
				return err
			}
		}

	}

	if o.QosPolicyMinThroughputIops != nil {

		// query param qos.policy.min_throughput_iops
		var qrQosPolicyMinThroughputIops int64
		if o.QosPolicyMinThroughputIops != nil {
			qrQosPolicyMinThroughputIops = *o.QosPolicyMinThroughputIops
		}
		qQosPolicyMinThroughputIops := swag.FormatInt64(qrQosPolicyMinThroughputIops)
		if qQosPolicyMinThroughputIops != "" {
			if err := r.SetQueryParam("qos.policy.min_throughput_iops", qQosPolicyMinThroughputIops); err != nil {
				return err
			}
		}

	}

	if o.QosPolicyName != nil {

		// query param qos.policy.name
		var qrQosPolicyName string
		if o.QosPolicyName != nil {
			qrQosPolicyName = *o.QosPolicyName
		}
		qQosPolicyName := qrQosPolicyName
		if qQosPolicyName != "" {
			if err := r.SetQueryParam("qos.policy.name", qQosPolicyName); err != nil {
				return err
			}
		}

	}

	if o.QosPolicyUUID != nil {

		// query param qos.policy.uuid
		var qrQosPolicyUUID string
		if o.QosPolicyUUID != nil {
			qrQosPolicyUUID = *o.QosPolicyUUID
		}
		qQosPolicyUUID := qrQosPolicyUUID
		if qQosPolicyUUID != "" {
			if err := r.SetQueryParam("qos.policy.uuid", qQosPolicyUUID); err != nil {
				return err
			}
		}

	}

	if o.QuotaState != nil {

		// query param quota.state
		var qrQuotaState string
		if o.QuotaState != nil {
			qrQuotaState = *o.QuotaState
		}
		qQuotaState := qrQuotaState
		if qQuotaState != "" {
			if err := r.SetQueryParam("quota.state", qQuotaState); err != nil {
				return err
			}
		}

	}

	if o.ReturnRecords != nil {

		// query param return_records
		var qrReturnRecords bool
		if o.ReturnRecords != nil {
			qrReturnRecords = *o.ReturnRecords
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {
			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}

	}

	if o.ReturnTimeout != nil {

		// query param return_timeout
		var qrReturnTimeout int64
		if o.ReturnTimeout != nil {
			qrReturnTimeout = *o.ReturnTimeout
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {
			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}

	}

	if o.Size != nil {

		// query param size
		var qrSize int64
		if o.Size != nil {
			qrSize = *o.Size
		}
		qSize := swag.FormatInt64(qrSize)
		if qSize != "" {
			if err := r.SetQueryParam("size", qSize); err != nil {
				return err
			}
		}

	}

	if o.SnaplockAppendModeEnabled != nil {

		// query param snaplock.append_mode_enabled
		var qrSnaplockAppendModeEnabled bool
		if o.SnaplockAppendModeEnabled != nil {
			qrSnaplockAppendModeEnabled = *o.SnaplockAppendModeEnabled
		}
		qSnaplockAppendModeEnabled := swag.FormatBool(qrSnaplockAppendModeEnabled)
		if qSnaplockAppendModeEnabled != "" {
			if err := r.SetQueryParam("snaplock.append_mode_enabled", qSnaplockAppendModeEnabled); err != nil {
				return err
			}
		}

	}

	if o.SnaplockAutocommitPeriod != nil {

		// query param snaplock.autocommit_period
		var qrSnaplockAutocommitPeriod string
		if o.SnaplockAutocommitPeriod != nil {
			qrSnaplockAutocommitPeriod = *o.SnaplockAutocommitPeriod
		}
		qSnaplockAutocommitPeriod := qrSnaplockAutocommitPeriod
		if qSnaplockAutocommitPeriod != "" {
			if err := r.SetQueryParam("snaplock.autocommit_period", qSnaplockAutocommitPeriod); err != nil {
				return err
			}
		}

	}

	if o.SnaplockComplianceClockTime != nil {

		// query param snaplock.compliance_clock_time
		var qrSnaplockComplianceClockTime string
		if o.SnaplockComplianceClockTime != nil {
			qrSnaplockComplianceClockTime = *o.SnaplockComplianceClockTime
		}
		qSnaplockComplianceClockTime := qrSnaplockComplianceClockTime
		if qSnaplockComplianceClockTime != "" {
			if err := r.SetQueryParam("snaplock.compliance_clock_time", qSnaplockComplianceClockTime); err != nil {
				return err
			}
		}

	}

	if o.SnaplockExpiryTime != nil {

		// query param snaplock.expiry_time
		var qrSnaplockExpiryTime string
		if o.SnaplockExpiryTime != nil {
			qrSnaplockExpiryTime = *o.SnaplockExpiryTime
		}
		qSnaplockExpiryTime := qrSnaplockExpiryTime
		if qSnaplockExpiryTime != "" {
			if err := r.SetQueryParam("snaplock.expiry_time", qSnaplockExpiryTime); err != nil {
				return err
			}
		}

	}

	if o.SnaplockIsAuditLog != nil {

		// query param snaplock.is_audit_log
		var qrSnaplockIsAuditLog bool
		if o.SnaplockIsAuditLog != nil {
			qrSnaplockIsAuditLog = *o.SnaplockIsAuditLog
		}
		qSnaplockIsAuditLog := swag.FormatBool(qrSnaplockIsAuditLog)
		if qSnaplockIsAuditLog != "" {
			if err := r.SetQueryParam("snaplock.is_audit_log", qSnaplockIsAuditLog); err != nil {
				return err
			}
		}

	}

	if o.SnaplockLitigationCount != nil {

		// query param snaplock.litigation_count
		var qrSnaplockLitigationCount int64
		if o.SnaplockLitigationCount != nil {
			qrSnaplockLitigationCount = *o.SnaplockLitigationCount
		}
		qSnaplockLitigationCount := swag.FormatInt64(qrSnaplockLitigationCount)
		if qSnaplockLitigationCount != "" {
			if err := r.SetQueryParam("snaplock.litigation_count", qSnaplockLitigationCount); err != nil {
				return err
			}
		}

	}

	if o.SnaplockPrivilegedDelete != nil {

		// query param snaplock.privileged_delete
		var qrSnaplockPrivilegedDelete string
		if o.SnaplockPrivilegedDelete != nil {
			qrSnaplockPrivilegedDelete = *o.SnaplockPrivilegedDelete
		}
		qSnaplockPrivilegedDelete := qrSnaplockPrivilegedDelete
		if qSnaplockPrivilegedDelete != "" {
			if err := r.SetQueryParam("snaplock.privileged_delete", qSnaplockPrivilegedDelete); err != nil {
				return err
			}
		}

	}

	if o.SnaplockRetentionDefault != nil {

		// query param snaplock.retention.default
		var qrSnaplockRetentionDefault string
		if o.SnaplockRetentionDefault != nil {
			qrSnaplockRetentionDefault = *o.SnaplockRetentionDefault
		}
		qSnaplockRetentionDefault := qrSnaplockRetentionDefault
		if qSnaplockRetentionDefault != "" {
			if err := r.SetQueryParam("snaplock.retention.default", qSnaplockRetentionDefault); err != nil {
				return err
			}
		}

	}

	if o.SnaplockRetentionMaximum != nil {

		// query param snaplock.retention.maximum
		var qrSnaplockRetentionMaximum string
		if o.SnaplockRetentionMaximum != nil {
			qrSnaplockRetentionMaximum = *o.SnaplockRetentionMaximum
		}
		qSnaplockRetentionMaximum := qrSnaplockRetentionMaximum
		if qSnaplockRetentionMaximum != "" {
			if err := r.SetQueryParam("snaplock.retention.maximum", qSnaplockRetentionMaximum); err != nil {
				return err
			}
		}

	}

	if o.SnaplockRetentionMinimum != nil {

		// query param snaplock.retention.minimum
		var qrSnaplockRetentionMinimum string
		if o.SnaplockRetentionMinimum != nil {
			qrSnaplockRetentionMinimum = *o.SnaplockRetentionMinimum
		}
		qSnaplockRetentionMinimum := qrSnaplockRetentionMinimum
		if qSnaplockRetentionMinimum != "" {
			if err := r.SetQueryParam("snaplock.retention.minimum", qSnaplockRetentionMinimum); err != nil {
				return err
			}
		}

	}

	if o.SnaplockType != nil {

		// query param snaplock.type
		var qrSnaplockType string
		if o.SnaplockType != nil {
			qrSnaplockType = *o.SnaplockType
		}
		qSnaplockType := qrSnaplockType
		if qSnaplockType != "" {
			if err := r.SetQueryParam("snaplock.type", qSnaplockType); err != nil {
				return err
			}
		}

	}

	if o.SnapmirrorIsProtected != nil {

		// query param snapmirror.is_protected
		var qrSnapmirrorIsProtected bool
		if o.SnapmirrorIsProtected != nil {
			qrSnapmirrorIsProtected = *o.SnapmirrorIsProtected
		}
		qSnapmirrorIsProtected := swag.FormatBool(qrSnapmirrorIsProtected)
		if qSnapmirrorIsProtected != "" {
			if err := r.SetQueryParam("snapmirror.is_protected", qSnapmirrorIsProtected); err != nil {
				return err
			}
		}

	}

	if o.SnapshotPolicyName != nil {

		// query param snapshot_policy.name
		var qrSnapshotPolicyName string
		if o.SnapshotPolicyName != nil {
			qrSnapshotPolicyName = *o.SnapshotPolicyName
		}
		qSnapshotPolicyName := qrSnapshotPolicyName
		if qSnapshotPolicyName != "" {
			if err := r.SetQueryParam("snapshot_policy.name", qSnapshotPolicyName); err != nil {
				return err
			}
		}

	}

	if o.SnapshotPolicyUUID != nil {

		// query param snapshot_policy.uuid
		var qrSnapshotPolicyUUID string
		if o.SnapshotPolicyUUID != nil {
			qrSnapshotPolicyUUID = *o.SnapshotPolicyUUID
		}
		qSnapshotPolicyUUID := qrSnapshotPolicyUUID
		if qSnapshotPolicyUUID != "" {
			if err := r.SetQueryParam("snapshot_policy.uuid", qSnapshotPolicyUUID); err != nil {
				return err
			}
		}

	}

	if o.SpaceAvailable != nil {

		// query param space.available
		var qrSpaceAvailable int64
		if o.SpaceAvailable != nil {
			qrSpaceAvailable = *o.SpaceAvailable
		}
		qSpaceAvailable := swag.FormatInt64(qrSpaceAvailable)
		if qSpaceAvailable != "" {
			if err := r.SetQueryParam("space.available", qSpaceAvailable); err != nil {
				return err
			}
		}

	}

	if o.SpaceBlockStorageInactiveUserData != nil {

		// query param space.block_storage_inactive_user_data
		var qrSpaceBlockStorageInactiveUserData int64
		if o.SpaceBlockStorageInactiveUserData != nil {
			qrSpaceBlockStorageInactiveUserData = *o.SpaceBlockStorageInactiveUserData
		}
		qSpaceBlockStorageInactiveUserData := swag.FormatInt64(qrSpaceBlockStorageInactiveUserData)
		if qSpaceBlockStorageInactiveUserData != "" {
			if err := r.SetQueryParam("space.block_storage_inactive_user_data", qSpaceBlockStorageInactiveUserData); err != nil {
				return err
			}
		}

	}

	if o.SpaceCapacityTierFootprint != nil {

		// query param space.capacity_tier_footprint
		var qrSpaceCapacityTierFootprint int64
		if o.SpaceCapacityTierFootprint != nil {
			qrSpaceCapacityTierFootprint = *o.SpaceCapacityTierFootprint
		}
		qSpaceCapacityTierFootprint := swag.FormatInt64(qrSpaceCapacityTierFootprint)
		if qSpaceCapacityTierFootprint != "" {
			if err := r.SetQueryParam("space.capacity_tier_footprint", qSpaceCapacityTierFootprint); err != nil {
				return err
			}
		}

	}

	if o.SpaceFootprint != nil {

		// query param space.footprint
		var qrSpaceFootprint int64
		if o.SpaceFootprint != nil {
			qrSpaceFootprint = *o.SpaceFootprint
		}
		qSpaceFootprint := swag.FormatInt64(qrSpaceFootprint)
		if qSpaceFootprint != "" {
			if err := r.SetQueryParam("space.footprint", qSpaceFootprint); err != nil {
				return err
			}
		}

	}

	if o.SpaceLogicalSpaceAvailable != nil {

		// query param space.logical_space.available
		var qrSpaceLogicalSpaceAvailable int64
		if o.SpaceLogicalSpaceAvailable != nil {
			qrSpaceLogicalSpaceAvailable = *o.SpaceLogicalSpaceAvailable
		}
		qSpaceLogicalSpaceAvailable := swag.FormatInt64(qrSpaceLogicalSpaceAvailable)
		if qSpaceLogicalSpaceAvailable != "" {
			if err := r.SetQueryParam("space.logical_space.available", qSpaceLogicalSpaceAvailable); err != nil {
				return err
			}
		}

	}

	if o.SpaceLogicalSpaceEnforcement != nil {

		// query param space.logical_space.enforcement
		var qrSpaceLogicalSpaceEnforcement bool
		if o.SpaceLogicalSpaceEnforcement != nil {
			qrSpaceLogicalSpaceEnforcement = *o.SpaceLogicalSpaceEnforcement
		}
		qSpaceLogicalSpaceEnforcement := swag.FormatBool(qrSpaceLogicalSpaceEnforcement)
		if qSpaceLogicalSpaceEnforcement != "" {
			if err := r.SetQueryParam("space.logical_space.enforcement", qSpaceLogicalSpaceEnforcement); err != nil {
				return err
			}
		}

	}

	if o.SpaceLogicalSpaceReporting != nil {

		// query param space.logical_space.reporting
		var qrSpaceLogicalSpaceReporting bool
		if o.SpaceLogicalSpaceReporting != nil {
			qrSpaceLogicalSpaceReporting = *o.SpaceLogicalSpaceReporting
		}
		qSpaceLogicalSpaceReporting := swag.FormatBool(qrSpaceLogicalSpaceReporting)
		if qSpaceLogicalSpaceReporting != "" {
			if err := r.SetQueryParam("space.logical_space.reporting", qSpaceLogicalSpaceReporting); err != nil {
				return err
			}
		}

	}

	if o.SpaceLogicalSpaceUsedByAfs != nil {

		// query param space.logical_space.used_by_afs
		var qrSpaceLogicalSpaceUsedByAfs int64
		if o.SpaceLogicalSpaceUsedByAfs != nil {
			qrSpaceLogicalSpaceUsedByAfs = *o.SpaceLogicalSpaceUsedByAfs
		}
		qSpaceLogicalSpaceUsedByAfs := swag.FormatInt64(qrSpaceLogicalSpaceUsedByAfs)
		if qSpaceLogicalSpaceUsedByAfs != "" {
			if err := r.SetQueryParam("space.logical_space.used_by_afs", qSpaceLogicalSpaceUsedByAfs); err != nil {
				return err
			}
		}

	}

	if o.SpaceMetadata != nil {

		// query param space.metadata
		var qrSpaceMetadata int64
		if o.SpaceMetadata != nil {
			qrSpaceMetadata = *o.SpaceMetadata
		}
		qSpaceMetadata := swag.FormatInt64(qrSpaceMetadata)
		if qSpaceMetadata != "" {
			if err := r.SetQueryParam("space.metadata", qSpaceMetadata); err != nil {
				return err
			}
		}

	}

	if o.SpaceOverProvisioned != nil {

		// query param space.over_provisioned
		var qrSpaceOverProvisioned int64
		if o.SpaceOverProvisioned != nil {
			qrSpaceOverProvisioned = *o.SpaceOverProvisioned
		}
		qSpaceOverProvisioned := swag.FormatInt64(qrSpaceOverProvisioned)
		if qSpaceOverProvisioned != "" {
			if err := r.SetQueryParam("space.over_provisioned", qSpaceOverProvisioned); err != nil {
				return err
			}
		}

	}

	if o.SpaceSize != nil {

		// query param space.size
		var qrSpaceSize int64
		if o.SpaceSize != nil {
			qrSpaceSize = *o.SpaceSize
		}
		qSpaceSize := swag.FormatInt64(qrSpaceSize)
		if qSpaceSize != "" {
			if err := r.SetQueryParam("space.size", qSpaceSize); err != nil {
				return err
			}
		}

	}

	if o.SpaceSnapshotReservePercent != nil {

		// query param space.snapshot.reserve_percent
		var qrSpaceSnapshotReservePercent int64
		if o.SpaceSnapshotReservePercent != nil {
			qrSpaceSnapshotReservePercent = *o.SpaceSnapshotReservePercent
		}
		qSpaceSnapshotReservePercent := swag.FormatInt64(qrSpaceSnapshotReservePercent)
		if qSpaceSnapshotReservePercent != "" {
			if err := r.SetQueryParam("space.snapshot.reserve_percent", qSpaceSnapshotReservePercent); err != nil {
				return err
			}
		}

	}

	if o.SpaceSnapshotUsed != nil {

		// query param space.snapshot.used
		var qrSpaceSnapshotUsed int64
		if o.SpaceSnapshotUsed != nil {
			qrSpaceSnapshotUsed = *o.SpaceSnapshotUsed
		}
		qSpaceSnapshotUsed := swag.FormatInt64(qrSpaceSnapshotUsed)
		if qSpaceSnapshotUsed != "" {
			if err := r.SetQueryParam("space.snapshot.used", qSpaceSnapshotUsed); err != nil {
				return err
			}
		}

	}

	if o.SpaceUsed != nil {

		// query param space.used
		var qrSpaceUsed int64
		if o.SpaceUsed != nil {
			qrSpaceUsed = *o.SpaceUsed
		}
		qSpaceUsed := swag.FormatInt64(qrSpaceUsed)
		if qSpaceUsed != "" {
			if err := r.SetQueryParam("space.used", qSpaceUsed); err != nil {
				return err
			}
		}

	}

	if o.State != nil {

		// query param state
		var qrState string
		if o.State != nil {
			qrState = *o.State
		}
		qState := qrState
		if qState != "" {
			if err := r.SetQueryParam("state", qState); err != nil {
				return err
			}
		}

	}

	if o.StatisticsCloudIopsRawOther != nil {

		// query param statistics.cloud.iops_raw.other
		var qrStatisticsCloudIopsRawOther int64
		if o.StatisticsCloudIopsRawOther != nil {
			qrStatisticsCloudIopsRawOther = *o.StatisticsCloudIopsRawOther
		}
		qStatisticsCloudIopsRawOther := swag.FormatInt64(qrStatisticsCloudIopsRawOther)
		if qStatisticsCloudIopsRawOther != "" {
			if err := r.SetQueryParam("statistics.cloud.iops_raw.other", qStatisticsCloudIopsRawOther); err != nil {
				return err
			}
		}

	}

	if o.StatisticsCloudIopsRawRead != nil {

		// query param statistics.cloud.iops_raw.read
		var qrStatisticsCloudIopsRawRead int64
		if o.StatisticsCloudIopsRawRead != nil {
			qrStatisticsCloudIopsRawRead = *o.StatisticsCloudIopsRawRead
		}
		qStatisticsCloudIopsRawRead := swag.FormatInt64(qrStatisticsCloudIopsRawRead)
		if qStatisticsCloudIopsRawRead != "" {
			if err := r.SetQueryParam("statistics.cloud.iops_raw.read", qStatisticsCloudIopsRawRead); err != nil {
				return err
			}
		}

	}

	if o.StatisticsCloudIopsRawTotal != nil {

		// query param statistics.cloud.iops_raw.total
		var qrStatisticsCloudIopsRawTotal int64
		if o.StatisticsCloudIopsRawTotal != nil {
			qrStatisticsCloudIopsRawTotal = *o.StatisticsCloudIopsRawTotal
		}
		qStatisticsCloudIopsRawTotal := swag.FormatInt64(qrStatisticsCloudIopsRawTotal)
		if qStatisticsCloudIopsRawTotal != "" {
			if err := r.SetQueryParam("statistics.cloud.iops_raw.total", qStatisticsCloudIopsRawTotal); err != nil {
				return err
			}
		}

	}

	if o.StatisticsCloudIopsRawWrite != nil {

		// query param statistics.cloud.iops_raw.write
		var qrStatisticsCloudIopsRawWrite int64
		if o.StatisticsCloudIopsRawWrite != nil {
			qrStatisticsCloudIopsRawWrite = *o.StatisticsCloudIopsRawWrite
		}
		qStatisticsCloudIopsRawWrite := swag.FormatInt64(qrStatisticsCloudIopsRawWrite)
		if qStatisticsCloudIopsRawWrite != "" {
			if err := r.SetQueryParam("statistics.cloud.iops_raw.write", qStatisticsCloudIopsRawWrite); err != nil {
				return err
			}
		}

	}

	if o.StatisticsCloudLatencyRawOther != nil {

		// query param statistics.cloud.latency_raw.other
		var qrStatisticsCloudLatencyRawOther int64
		if o.StatisticsCloudLatencyRawOther != nil {
			qrStatisticsCloudLatencyRawOther = *o.StatisticsCloudLatencyRawOther
		}
		qStatisticsCloudLatencyRawOther := swag.FormatInt64(qrStatisticsCloudLatencyRawOther)
		if qStatisticsCloudLatencyRawOther != "" {
			if err := r.SetQueryParam("statistics.cloud.latency_raw.other", qStatisticsCloudLatencyRawOther); err != nil {
				return err
			}
		}

	}

	if o.StatisticsCloudLatencyRawRead != nil {

		// query param statistics.cloud.latency_raw.read
		var qrStatisticsCloudLatencyRawRead int64
		if o.StatisticsCloudLatencyRawRead != nil {
			qrStatisticsCloudLatencyRawRead = *o.StatisticsCloudLatencyRawRead
		}
		qStatisticsCloudLatencyRawRead := swag.FormatInt64(qrStatisticsCloudLatencyRawRead)
		if qStatisticsCloudLatencyRawRead != "" {
			if err := r.SetQueryParam("statistics.cloud.latency_raw.read", qStatisticsCloudLatencyRawRead); err != nil {
				return err
			}
		}

	}

	if o.StatisticsCloudLatencyRawTotal != nil {

		// query param statistics.cloud.latency_raw.total
		var qrStatisticsCloudLatencyRawTotal int64
		if o.StatisticsCloudLatencyRawTotal != nil {
			qrStatisticsCloudLatencyRawTotal = *o.StatisticsCloudLatencyRawTotal
		}
		qStatisticsCloudLatencyRawTotal := swag.FormatInt64(qrStatisticsCloudLatencyRawTotal)
		if qStatisticsCloudLatencyRawTotal != "" {
			if err := r.SetQueryParam("statistics.cloud.latency_raw.total", qStatisticsCloudLatencyRawTotal); err != nil {
				return err
			}
		}

	}

	if o.StatisticsCloudLatencyRawWrite != nil {

		// query param statistics.cloud.latency_raw.write
		var qrStatisticsCloudLatencyRawWrite int64
		if o.StatisticsCloudLatencyRawWrite != nil {
			qrStatisticsCloudLatencyRawWrite = *o.StatisticsCloudLatencyRawWrite
		}
		qStatisticsCloudLatencyRawWrite := swag.FormatInt64(qrStatisticsCloudLatencyRawWrite)
		if qStatisticsCloudLatencyRawWrite != "" {
			if err := r.SetQueryParam("statistics.cloud.latency_raw.write", qStatisticsCloudLatencyRawWrite); err != nil {
				return err
			}
		}

	}

	if o.StatisticsCloudStatus != nil {

		// query param statistics.cloud.status
		var qrStatisticsCloudStatus string
		if o.StatisticsCloudStatus != nil {
			qrStatisticsCloudStatus = *o.StatisticsCloudStatus
		}
		qStatisticsCloudStatus := qrStatisticsCloudStatus
		if qStatisticsCloudStatus != "" {
			if err := r.SetQueryParam("statistics.cloud.status", qStatisticsCloudStatus); err != nil {
				return err
			}
		}

	}

	if o.StatisticsCloudTimestamp != nil {

		// query param statistics.cloud.timestamp
		var qrStatisticsCloudTimestamp string
		if o.StatisticsCloudTimestamp != nil {
			qrStatisticsCloudTimestamp = *o.StatisticsCloudTimestamp
		}
		qStatisticsCloudTimestamp := qrStatisticsCloudTimestamp
		if qStatisticsCloudTimestamp != "" {
			if err := r.SetQueryParam("statistics.cloud.timestamp", qStatisticsCloudTimestamp); err != nil {
				return err
			}
		}

	}

	if o.StatisticsIopsRawOther != nil {

		// query param statistics.iops_raw.other
		var qrStatisticsIopsRawOther int64
		if o.StatisticsIopsRawOther != nil {
			qrStatisticsIopsRawOther = *o.StatisticsIopsRawOther
		}
		qStatisticsIopsRawOther := swag.FormatInt64(qrStatisticsIopsRawOther)
		if qStatisticsIopsRawOther != "" {
			if err := r.SetQueryParam("statistics.iops_raw.other", qStatisticsIopsRawOther); err != nil {
				return err
			}
		}

	}

	if o.StatisticsIopsRawRead != nil {

		// query param statistics.iops_raw.read
		var qrStatisticsIopsRawRead int64
		if o.StatisticsIopsRawRead != nil {
			qrStatisticsIopsRawRead = *o.StatisticsIopsRawRead
		}
		qStatisticsIopsRawRead := swag.FormatInt64(qrStatisticsIopsRawRead)
		if qStatisticsIopsRawRead != "" {
			if err := r.SetQueryParam("statistics.iops_raw.read", qStatisticsIopsRawRead); err != nil {
				return err
			}
		}

	}

	if o.StatisticsIopsRawTotal != nil {

		// query param statistics.iops_raw.total
		var qrStatisticsIopsRawTotal int64
		if o.StatisticsIopsRawTotal != nil {
			qrStatisticsIopsRawTotal = *o.StatisticsIopsRawTotal
		}
		qStatisticsIopsRawTotal := swag.FormatInt64(qrStatisticsIopsRawTotal)
		if qStatisticsIopsRawTotal != "" {
			if err := r.SetQueryParam("statistics.iops_raw.total", qStatisticsIopsRawTotal); err != nil {
				return err
			}
		}

	}

	if o.StatisticsIopsRawWrite != nil {

		// query param statistics.iops_raw.write
		var qrStatisticsIopsRawWrite int64
		if o.StatisticsIopsRawWrite != nil {
			qrStatisticsIopsRawWrite = *o.StatisticsIopsRawWrite
		}
		qStatisticsIopsRawWrite := swag.FormatInt64(qrStatisticsIopsRawWrite)
		if qStatisticsIopsRawWrite != "" {
			if err := r.SetQueryParam("statistics.iops_raw.write", qStatisticsIopsRawWrite); err != nil {
				return err
			}
		}

	}

	if o.StatisticsLatencyRawOther != nil {

		// query param statistics.latency_raw.other
		var qrStatisticsLatencyRawOther int64
		if o.StatisticsLatencyRawOther != nil {
			qrStatisticsLatencyRawOther = *o.StatisticsLatencyRawOther
		}
		qStatisticsLatencyRawOther := swag.FormatInt64(qrStatisticsLatencyRawOther)
		if qStatisticsLatencyRawOther != "" {
			if err := r.SetQueryParam("statistics.latency_raw.other", qStatisticsLatencyRawOther); err != nil {
				return err
			}
		}

	}

	if o.StatisticsLatencyRawRead != nil {

		// query param statistics.latency_raw.read
		var qrStatisticsLatencyRawRead int64
		if o.StatisticsLatencyRawRead != nil {
			qrStatisticsLatencyRawRead = *o.StatisticsLatencyRawRead
		}
		qStatisticsLatencyRawRead := swag.FormatInt64(qrStatisticsLatencyRawRead)
		if qStatisticsLatencyRawRead != "" {
			if err := r.SetQueryParam("statistics.latency_raw.read", qStatisticsLatencyRawRead); err != nil {
				return err
			}
		}

	}

	if o.StatisticsLatencyRawTotal != nil {

		// query param statistics.latency_raw.total
		var qrStatisticsLatencyRawTotal int64
		if o.StatisticsLatencyRawTotal != nil {
			qrStatisticsLatencyRawTotal = *o.StatisticsLatencyRawTotal
		}
		qStatisticsLatencyRawTotal := swag.FormatInt64(qrStatisticsLatencyRawTotal)
		if qStatisticsLatencyRawTotal != "" {
			if err := r.SetQueryParam("statistics.latency_raw.total", qStatisticsLatencyRawTotal); err != nil {
				return err
			}
		}

	}

	if o.StatisticsLatencyRawWrite != nil {

		// query param statistics.latency_raw.write
		var qrStatisticsLatencyRawWrite int64
		if o.StatisticsLatencyRawWrite != nil {
			qrStatisticsLatencyRawWrite = *o.StatisticsLatencyRawWrite
		}
		qStatisticsLatencyRawWrite := swag.FormatInt64(qrStatisticsLatencyRawWrite)
		if qStatisticsLatencyRawWrite != "" {
			if err := r.SetQueryParam("statistics.latency_raw.write", qStatisticsLatencyRawWrite); err != nil {
				return err
			}
		}

	}

	if o.StatisticsStatus != nil {

		// query param statistics.status
		var qrStatisticsStatus string
		if o.StatisticsStatus != nil {
			qrStatisticsStatus = *o.StatisticsStatus
		}
		qStatisticsStatus := qrStatisticsStatus
		if qStatisticsStatus != "" {
			if err := r.SetQueryParam("statistics.status", qStatisticsStatus); err != nil {
				return err
			}
		}

	}

	if o.StatisticsThroughputRawOther != nil {

		// query param statistics.throughput_raw.other
		var qrStatisticsThroughputRawOther int64
		if o.StatisticsThroughputRawOther != nil {
			qrStatisticsThroughputRawOther = *o.StatisticsThroughputRawOther
		}
		qStatisticsThroughputRawOther := swag.FormatInt64(qrStatisticsThroughputRawOther)
		if qStatisticsThroughputRawOther != "" {
			if err := r.SetQueryParam("statistics.throughput_raw.other", qStatisticsThroughputRawOther); err != nil {
				return err
			}
		}

	}

	if o.StatisticsThroughputRawRead != nil {

		// query param statistics.throughput_raw.read
		var qrStatisticsThroughputRawRead int64
		if o.StatisticsThroughputRawRead != nil {
			qrStatisticsThroughputRawRead = *o.StatisticsThroughputRawRead
		}
		qStatisticsThroughputRawRead := swag.FormatInt64(qrStatisticsThroughputRawRead)
		if qStatisticsThroughputRawRead != "" {
			if err := r.SetQueryParam("statistics.throughput_raw.read", qStatisticsThroughputRawRead); err != nil {
				return err
			}
		}

	}

	if o.StatisticsThroughputRawTotal != nil {

		// query param statistics.throughput_raw.total
		var qrStatisticsThroughputRawTotal int64
		if o.StatisticsThroughputRawTotal != nil {
			qrStatisticsThroughputRawTotal = *o.StatisticsThroughputRawTotal
		}
		qStatisticsThroughputRawTotal := swag.FormatInt64(qrStatisticsThroughputRawTotal)
		if qStatisticsThroughputRawTotal != "" {
			if err := r.SetQueryParam("statistics.throughput_raw.total", qStatisticsThroughputRawTotal); err != nil {
				return err
			}
		}

	}

	if o.StatisticsThroughputRawWrite != nil {

		// query param statistics.throughput_raw.write
		var qrStatisticsThroughputRawWrite int64
		if o.StatisticsThroughputRawWrite != nil {
			qrStatisticsThroughputRawWrite = *o.StatisticsThroughputRawWrite
		}
		qStatisticsThroughputRawWrite := swag.FormatInt64(qrStatisticsThroughputRawWrite)
		if qStatisticsThroughputRawWrite != "" {
			if err := r.SetQueryParam("statistics.throughput_raw.write", qStatisticsThroughputRawWrite); err != nil {
				return err
			}
		}

	}

	if o.StatisticsTimestamp != nil {

		// query param statistics.timestamp
		var qrStatisticsTimestamp string
		if o.StatisticsTimestamp != nil {
			qrStatisticsTimestamp = *o.StatisticsTimestamp
		}
		qStatisticsTimestamp := qrStatisticsTimestamp
		if qStatisticsTimestamp != "" {
			if err := r.SetQueryParam("statistics.timestamp", qStatisticsTimestamp); err != nil {
				return err
			}
		}

	}

	if o.Style != nil {

		// query param style
		var qrStyle string
		if o.Style != nil {
			qrStyle = *o.Style
		}
		qStyle := qrStyle
		if qStyle != "" {
			if err := r.SetQueryParam("style", qStyle); err != nil {
				return err
			}
		}

	}

	if o.Svm != nil {

		// query param svm
		var qrSvm string
		if o.Svm != nil {
			qrSvm = *o.Svm
		}
		qSvm := qrSvm
		if qSvm != "" {
			if err := r.SetQueryParam("svm", qSvm); err != nil {
				return err
			}
		}

	}

	if o.SvmName != nil {

		// query param svm.name
		var qrSvmName string
		if o.SvmName != nil {
			qrSvmName = *o.SvmName
		}
		qSvmName := qrSvmName
		if qSvmName != "" {
			if err := r.SetQueryParam("svm.name", qSvmName); err != nil {
				return err
			}
		}

	}

	if o.SvmUUID != nil {

		// query param svm.uuid
		var qrSvmUUID string
		if o.SvmUUID != nil {
			qrSvmUUID = *o.SvmUUID
		}
		qSvmUUID := qrSvmUUID
		if qSvmUUID != "" {
			if err := r.SetQueryParam("svm.uuid", qSvmUUID); err != nil {
				return err
			}
		}

	}

	if o.TieringPolicy != nil {

		// query param tiering.policy
		var qrTieringPolicy string
		if o.TieringPolicy != nil {
			qrTieringPolicy = *o.TieringPolicy
		}
		qTieringPolicy := qrTieringPolicy
		if qTieringPolicy != "" {
			if err := r.SetQueryParam("tiering.policy", qTieringPolicy); err != nil {
				return err
			}
		}

	}

	if o.Type != nil {

		// query param type
		var qrType string
		if o.Type != nil {
			qrType = *o.Type
		}
		qType := qrType
		if qType != "" {
			if err := r.SetQueryParam("type", qType); err != nil {
				return err
			}
		}

	}

	if o.UUID != nil {

		// query param uuid
		var qrUUID string
		if o.UUID != nil {
			qrUUID = *o.UUID
		}
		qUUID := qrUUID
		if qUUID != "" {
			if err := r.SetQueryParam("uuid", qUUID); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
