// Code generated by go-swagger; DO NOT EDIT.

package storage

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/greenqloud/ontap-rest-client/ntapmodel"
)

// NewVolumeModifyParams creates a new VolumeModifyParams object
// with the default values initialized.
func NewVolumeModifyParams() *VolumeModifyParams {
	var (
		returnTimeoutDefault = int64(0)
		sizingMethodDefault  = string("use_existing_resources")
	)
	return &VolumeModifyParams{
		ReturnTimeout: &returnTimeoutDefault,
		SizingMethod:  &sizingMethodDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewVolumeModifyParamsWithTimeout creates a new VolumeModifyParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewVolumeModifyParamsWithTimeout(timeout time.Duration) *VolumeModifyParams {
	var (
		returnTimeoutDefault = int64(0)
		sizingMethodDefault  = string("use_existing_resources")
	)
	return &VolumeModifyParams{
		ReturnTimeout: &returnTimeoutDefault,
		SizingMethod:  &sizingMethodDefault,

		timeout: timeout,
	}
}

// NewVolumeModifyParamsWithContext creates a new VolumeModifyParams object
// with the default values initialized, and the ability to set a context for a request
func NewVolumeModifyParamsWithContext(ctx context.Context) *VolumeModifyParams {
	var (
		returnTimeoutDefault = int64(0)
		sizingMethodDefault  = string("use_existing_resources")
	)
	return &VolumeModifyParams{
		ReturnTimeout: &returnTimeoutDefault,
		SizingMethod:  &sizingMethodDefault,

		Context: ctx,
	}
}

// NewVolumeModifyParamsWithHTTPClient creates a new VolumeModifyParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewVolumeModifyParamsWithHTTPClient(client *http.Client) *VolumeModifyParams {
	var (
		returnTimeoutDefault = int64(0)
		sizingMethodDefault  = string("use_existing_resources")
	)
	return &VolumeModifyParams{
		ReturnTimeout: &returnTimeoutDefault,
		SizingMethod:  &sizingMethodDefault,
		HTTPClient:    client,
	}
}

/*VolumeModifyParams contains all the parameters to send to the API endpoint
for the volume modify operation typically these are written to a http.Request
*/
type VolumeModifyParams struct {

	/*Info
	  Info specification

	*/
	Info *ntapmodel.Volume
	/*RestoreToSnapshotName
	  Name of the Snapshot copy to restore volume to the point in time the Snapshot copy was taken.

	*/
	RestoreToSnapshotName *string
	/*RestoreToSnapshotUUID
	  UUID of the Snapshot copy to restore volume to the point in time the Snapshot copy was taken.

	*/
	RestoreToSnapshotUUID *string
	/*ReturnTimeout
	  The number of seconds to allow the call to execute before returning. When doing a POST, PATCH, or DELETE operation on a single record, the default is 0 seconds.  This means that if an asynchronous operation is started, the server immediately returns HTTP code 202 (Accepted) along with a link to the job.  If a non-zero value is specified for POST, PATCH, or DELETE operations, ONTAP waits that length of time to see if the job completes so it can return something other than 202.

	*/
	ReturnTimeout *int64
	/*SizingMethod
	  Represents the method to modify the size of a Flexgroup. The following methods are supported:
	* use_existing_resources - Increases or decreases the size of the FlexGroup by increasing or decreasing the size of the current FlexGroup resources
	* add_new_resources - Increases the size of the FlexGroup by adding new resources


	*/
	SizingMethod *string
	/*UUID
	  Unique identifier of the volume.

	*/
	UUID string
	/*ValidateOnly
	  Validate the operation and its parameters, without actually performing the operation.

	*/
	ValidateOnly *bool

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the volume modify params
func (o *VolumeModifyParams) WithTimeout(timeout time.Duration) *VolumeModifyParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the volume modify params
func (o *VolumeModifyParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the volume modify params
func (o *VolumeModifyParams) WithContext(ctx context.Context) *VolumeModifyParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the volume modify params
func (o *VolumeModifyParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the volume modify params
func (o *VolumeModifyParams) WithHTTPClient(client *http.Client) *VolumeModifyParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the volume modify params
func (o *VolumeModifyParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithInfo adds the info to the volume modify params
func (o *VolumeModifyParams) WithInfo(info *ntapmodel.Volume) *VolumeModifyParams {
	o.SetInfo(info)
	return o
}

// SetInfo adds the info to the volume modify params
func (o *VolumeModifyParams) SetInfo(info *ntapmodel.Volume) {
	o.Info = info
}

// WithRestoreToSnapshotName adds the restoreToSnapshotName to the volume modify params
func (o *VolumeModifyParams) WithRestoreToSnapshotName(restoreToSnapshotName *string) *VolumeModifyParams {
	o.SetRestoreToSnapshotName(restoreToSnapshotName)
	return o
}

// SetRestoreToSnapshotName adds the restoreToSnapshotName to the volume modify params
func (o *VolumeModifyParams) SetRestoreToSnapshotName(restoreToSnapshotName *string) {
	o.RestoreToSnapshotName = restoreToSnapshotName
}

// WithRestoreToSnapshotUUID adds the restoreToSnapshotUUID to the volume modify params
func (o *VolumeModifyParams) WithRestoreToSnapshotUUID(restoreToSnapshotUUID *string) *VolumeModifyParams {
	o.SetRestoreToSnapshotUUID(restoreToSnapshotUUID)
	return o
}

// SetRestoreToSnapshotUUID adds the restoreToSnapshotUuid to the volume modify params
func (o *VolumeModifyParams) SetRestoreToSnapshotUUID(restoreToSnapshotUUID *string) {
	o.RestoreToSnapshotUUID = restoreToSnapshotUUID
}

// WithReturnTimeout adds the returnTimeout to the volume modify params
func (o *VolumeModifyParams) WithReturnTimeout(returnTimeout *int64) *VolumeModifyParams {
	o.SetReturnTimeout(returnTimeout)
	return o
}

// SetReturnTimeout adds the returnTimeout to the volume modify params
func (o *VolumeModifyParams) SetReturnTimeout(returnTimeout *int64) {
	o.ReturnTimeout = returnTimeout
}

// WithSizingMethod adds the sizingMethod to the volume modify params
func (o *VolumeModifyParams) WithSizingMethod(sizingMethod *string) *VolumeModifyParams {
	o.SetSizingMethod(sizingMethod)
	return o
}

// SetSizingMethod adds the sizingMethod to the volume modify params
func (o *VolumeModifyParams) SetSizingMethod(sizingMethod *string) {
	o.SizingMethod = sizingMethod
}

// WithUUID adds the uuid to the volume modify params
func (o *VolumeModifyParams) WithUUID(uuid string) *VolumeModifyParams {
	o.SetUUID(uuid)
	return o
}

// SetUUID adds the uuid to the volume modify params
func (o *VolumeModifyParams) SetUUID(uuid string) {
	o.UUID = uuid
}

// WithValidateOnly adds the validateOnly to the volume modify params
func (o *VolumeModifyParams) WithValidateOnly(validateOnly *bool) *VolumeModifyParams {
	o.SetValidateOnly(validateOnly)
	return o
}

// SetValidateOnly adds the validateOnly to the volume modify params
func (o *VolumeModifyParams) SetValidateOnly(validateOnly *bool) {
	o.ValidateOnly = validateOnly
}

// WriteToRequest writes these params to a swagger request
func (o *VolumeModifyParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Info != nil {
		if err := r.SetBodyParam(o.Info); err != nil {
			return err
		}
	}

	if o.RestoreToSnapshotName != nil {

		// query param restore_to.snapshot.name
		var qrRestoreToSnapshotName string
		if o.RestoreToSnapshotName != nil {
			qrRestoreToSnapshotName = *o.RestoreToSnapshotName
		}
		qRestoreToSnapshotName := qrRestoreToSnapshotName
		if qRestoreToSnapshotName != "" {
			if err := r.SetQueryParam("restore_to.snapshot.name", qRestoreToSnapshotName); err != nil {
				return err
			}
		}

	}

	if o.RestoreToSnapshotUUID != nil {

		// query param restore_to.snapshot.uuid
		var qrRestoreToSnapshotUUID string
		if o.RestoreToSnapshotUUID != nil {
			qrRestoreToSnapshotUUID = *o.RestoreToSnapshotUUID
		}
		qRestoreToSnapshotUUID := qrRestoreToSnapshotUUID
		if qRestoreToSnapshotUUID != "" {
			if err := r.SetQueryParam("restore_to.snapshot.uuid", qRestoreToSnapshotUUID); err != nil {
				return err
			}
		}

	}

	if o.ReturnTimeout != nil {

		// query param return_timeout
		var qrReturnTimeout int64
		if o.ReturnTimeout != nil {
			qrReturnTimeout = *o.ReturnTimeout
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {
			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}

	}

	if o.SizingMethod != nil {

		// query param sizing_method
		var qrSizingMethod string
		if o.SizingMethod != nil {
			qrSizingMethod = *o.SizingMethod
		}
		qSizingMethod := qrSizingMethod
		if qSizingMethod != "" {
			if err := r.SetQueryParam("sizing_method", qSizingMethod); err != nil {
				return err
			}
		}

	}

	// path param uuid
	if err := r.SetPathParam("uuid", o.UUID); err != nil {
		return err
	}

	if o.ValidateOnly != nil {

		// query param validate_only
		var qrValidateOnly bool
		if o.ValidateOnly != nil {
			qrValidateOnly = *o.ValidateOnly
		}
		qValidateOnly := swag.FormatBool(qrValidateOnly)
		if qValidateOnly != "" {
			if err := r.SetQueryParam("validate_only", qValidateOnly); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
