// Code generated by go-swagger; DO NOT EDIT.

package svm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewSnapmirrorGetParams creates a new SnapmirrorGetParams object
// with the default values initialized.
func NewSnapmirrorGetParams() *SnapmirrorGetParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &SnapmirrorGetParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewSnapmirrorGetParamsWithTimeout creates a new SnapmirrorGetParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewSnapmirrorGetParamsWithTimeout(timeout time.Duration) *SnapmirrorGetParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &SnapmirrorGetParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		timeout: timeout,
	}
}

// NewSnapmirrorGetParamsWithContext creates a new SnapmirrorGetParams object
// with the default values initialized, and the ability to set a context for a request
func NewSnapmirrorGetParamsWithContext(ctx context.Context) *SnapmirrorGetParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &SnapmirrorGetParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		Context: ctx,
	}
}

// NewSnapmirrorGetParamsWithHTTPClient creates a new SnapmirrorGetParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewSnapmirrorGetParamsWithHTTPClient(client *http.Client) *SnapmirrorGetParams {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &SnapmirrorGetParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,
		HTTPClient:    client,
	}
}

/*SnapmirrorGetParams contains all the parameters to send to the API endpoint
for the snapmirror get operation typically these are written to a http.Request
*/
type SnapmirrorGetParams struct {

	/*DestinationVolumeNode
	  Filter by destination-volume-node

	*/
	DestinationVolumeNode *string
	/*Fields
	  Specify the fields to return.

	*/
	Fields []string
	/*MaxRecords
	  Limit the number of records returned.

	*/
	MaxRecords *int64
	/*OrderBy
	  Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.

	*/
	OrderBy []string
	/*ReturnRecords
	  The default is true for GET calls.  When set to false, only the number of records is returned.

	*/
	ReturnRecords *bool
	/*ReturnTimeout
	  The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	*/
	ReturnTimeout *int64
	/*Status
	  Filter by status

	*/
	Status *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the snapmirror get params
func (o *SnapmirrorGetParams) WithTimeout(timeout time.Duration) *SnapmirrorGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the snapmirror get params
func (o *SnapmirrorGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the snapmirror get params
func (o *SnapmirrorGetParams) WithContext(ctx context.Context) *SnapmirrorGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the snapmirror get params
func (o *SnapmirrorGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the snapmirror get params
func (o *SnapmirrorGetParams) WithHTTPClient(client *http.Client) *SnapmirrorGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the snapmirror get params
func (o *SnapmirrorGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithDestinationVolumeNode adds the destinationVolumeNode to the snapmirror get params
func (o *SnapmirrorGetParams) WithDestinationVolumeNode(destinationVolumeNode *string) *SnapmirrorGetParams {
	o.SetDestinationVolumeNode(destinationVolumeNode)
	return o
}

// SetDestinationVolumeNode adds the destinationVolumeNode to the snapmirror get params
func (o *SnapmirrorGetParams) SetDestinationVolumeNode(destinationVolumeNode *string) {
	o.DestinationVolumeNode = destinationVolumeNode
}

// WithFields adds the fields to the snapmirror get params
func (o *SnapmirrorGetParams) WithFields(fields []string) *SnapmirrorGetParams {
	o.SetFields(fields)
	return o
}

// SetFields adds the fields to the snapmirror get params
func (o *SnapmirrorGetParams) SetFields(fields []string) {
	o.Fields = fields
}

// WithMaxRecords adds the maxRecords to the snapmirror get params
func (o *SnapmirrorGetParams) WithMaxRecords(maxRecords *int64) *SnapmirrorGetParams {
	o.SetMaxRecords(maxRecords)
	return o
}

// SetMaxRecords adds the maxRecords to the snapmirror get params
func (o *SnapmirrorGetParams) SetMaxRecords(maxRecords *int64) {
	o.MaxRecords = maxRecords
}

// WithOrderBy adds the orderBy to the snapmirror get params
func (o *SnapmirrorGetParams) WithOrderBy(orderBy []string) *SnapmirrorGetParams {
	o.SetOrderBy(orderBy)
	return o
}

// SetOrderBy adds the orderBy to the snapmirror get params
func (o *SnapmirrorGetParams) SetOrderBy(orderBy []string) {
	o.OrderBy = orderBy
}

// WithReturnRecords adds the returnRecords to the snapmirror get params
func (o *SnapmirrorGetParams) WithReturnRecords(returnRecords *bool) *SnapmirrorGetParams {
	o.SetReturnRecords(returnRecords)
	return o
}

// SetReturnRecords adds the returnRecords to the snapmirror get params
func (o *SnapmirrorGetParams) SetReturnRecords(returnRecords *bool) {
	o.ReturnRecords = returnRecords
}

// WithReturnTimeout adds the returnTimeout to the snapmirror get params
func (o *SnapmirrorGetParams) WithReturnTimeout(returnTimeout *int64) *SnapmirrorGetParams {
	o.SetReturnTimeout(returnTimeout)
	return o
}

// SetReturnTimeout adds the returnTimeout to the snapmirror get params
func (o *SnapmirrorGetParams) SetReturnTimeout(returnTimeout *int64) {
	o.ReturnTimeout = returnTimeout
}

// WithStatus adds the status to the snapmirror get params
func (o *SnapmirrorGetParams) WithStatus(status *string) *SnapmirrorGetParams {
	o.SetStatus(status)
	return o
}

// SetStatus adds the status to the snapmirror get params
func (o *SnapmirrorGetParams) SetStatus(status *string) {
	o.Status = status
}

// WriteToRequest writes these params to a swagger request
func (o *SnapmirrorGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.DestinationVolumeNode != nil {

		// query param destination-volume-node
		var qrDestinationVolumeNode string
		if o.DestinationVolumeNode != nil {
			qrDestinationVolumeNode = *o.DestinationVolumeNode
		}
		qDestinationVolumeNode := qrDestinationVolumeNode
		if qDestinationVolumeNode != "" {
			if err := r.SetQueryParam("destination-volume-node", qDestinationVolumeNode); err != nil {
				return err
			}
		}

	}

	valuesFields := o.Fields

	joinedFields := swag.JoinByFormat(valuesFields, "csv")
	// query array param fields
	if err := r.SetQueryParam("fields", joinedFields...); err != nil {
		return err
	}

	if o.MaxRecords != nil {

		// query param max_records
		var qrMaxRecords int64
		if o.MaxRecords != nil {
			qrMaxRecords = *o.MaxRecords
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {
			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}

	}

	valuesOrderBy := o.OrderBy

	joinedOrderBy := swag.JoinByFormat(valuesOrderBy, "csv")
	// query array param order_by
	if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
		return err
	}

	if o.ReturnRecords != nil {

		// query param return_records
		var qrReturnRecords bool
		if o.ReturnRecords != nil {
			qrReturnRecords = *o.ReturnRecords
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {
			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}

	}

	if o.ReturnTimeout != nil {

		// query param return_timeout
		var qrReturnTimeout int64
		if o.ReturnTimeout != nil {
			qrReturnTimeout = *o.ReturnTimeout
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {
			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}

	}

	if o.Status != nil {

		// query param status
		var qrStatus string
		if o.Status != nil {
			qrStatus = *o.Status
		}
		qStatus := qrStatus
		if qStatus != "" {
			if err := r.SetQueryParam("status", qStatus); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
