// Code generated by go-swagger; DO NOT EDIT.

package svm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewSvmCollectionGet1Params creates a new SvmCollectionGet1Params object
// with the default values initialized.
func NewSvmCollectionGet1Params() *SvmCollectionGet1Params {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &SvmCollectionGet1Params{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewSvmCollectionGet1ParamsWithTimeout creates a new SvmCollectionGet1Params object
// with the default values initialized, and the ability to set a timeout on a request
func NewSvmCollectionGet1ParamsWithTimeout(timeout time.Duration) *SvmCollectionGet1Params {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &SvmCollectionGet1Params{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		timeout: timeout,
	}
}

// NewSvmCollectionGet1ParamsWithContext creates a new SvmCollectionGet1Params object
// with the default values initialized, and the ability to set a context for a request
func NewSvmCollectionGet1ParamsWithContext(ctx context.Context) *SvmCollectionGet1Params {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &SvmCollectionGet1Params{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,

		Context: ctx,
	}
}

// NewSvmCollectionGet1ParamsWithHTTPClient creates a new SvmCollectionGet1Params object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewSvmCollectionGet1ParamsWithHTTPClient(client *http.Client) *SvmCollectionGet1Params {
	var (
		returnRecordsDefault = bool(true)
		returnTimeoutDefault = int64(15)
	)
	return &SvmCollectionGet1Params{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,
		HTTPClient:    client,
	}
}

/*SvmCollectionGet1Params contains all the parameters to send to the API endpoint
for the svm collection get1 operation typically these are written to a http.Request
*/
type SvmCollectionGet1Params struct {

	/*AggregatesName
	  Filter by aggregates.name

	*/
	AggregatesName *string
	/*AggregatesUUID
	  Filter by aggregates.uuid

	*/
	AggregatesUUID *string
	/*CertificateUUID
	  Filter by certificate.uuid

	*/
	CertificateUUID *string
	/*CifsAdDomainFqdn
	  Filter by cifs.ad_domain.fqdn

	*/
	CifsAdDomainFqdn *string
	/*CifsAdDomainOrganizationalUnit
	  Filter by cifs.ad_domain.organizational_unit

	*/
	CifsAdDomainOrganizationalUnit *string
	/*CifsEnabled
	  Filter by cifs.enabled

	*/
	CifsEnabled *bool
	/*CifsName
	  Filter by cifs.name

	*/
	CifsName *string
	/*Comment
	  Filter by comment

	*/
	Comment *string
	/*DNSDomains
	  Filter by dns.domains

	*/
	DNSDomains *string
	/*DNSServers
	  Filter by dns.servers

	*/
	DNSServers *string
	/*FcInterfacesDataProtocol
	  Filter by fc_interfaces.data_protocol

	*/
	FcInterfacesDataProtocol *string
	/*FcInterfacesName
	  Filter by fc_interfaces.name

	*/
	FcInterfacesName *string
	/*FcpEnabled
	  Filter by fcp.enabled

	*/
	FcpEnabled *bool
	/*Fields
	  Specify the fields to return.

	*/
	Fields []string
	/*IpspaceName
	  Filter by ipspace.name

	*/
	IpspaceName *string
	/*IpspaceUUID
	  Filter by ipspace.uuid

	*/
	IpspaceUUID *string
	/*IscsiEnabled
	  Filter by iscsi.enabled

	*/
	IscsiEnabled *bool
	/*Language
	  Filter by language

	*/
	Language *string
	/*LdapAdDomain
	  Filter by ldap.ad_domain

	*/
	LdapAdDomain *string
	/*LdapBaseDn
	  Filter by ldap.base_dn

	*/
	LdapBaseDn *string
	/*LdapBindDn
	  Filter by ldap.bind_dn

	*/
	LdapBindDn *string
	/*LdapEnabled
	  Filter by ldap.enabled

	*/
	LdapEnabled *bool
	/*LdapServers
	  Filter by ldap.servers

	*/
	LdapServers *string
	/*MaxRecords
	  Limit the number of records returned.

	*/
	MaxRecords *int64
	/*Name
	  Filter by name

	*/
	Name *string
	/*NfsEnabled
	  Filter by nfs.enabled

	*/
	NfsEnabled *bool
	/*NisDomain
	  Filter by nis.domain

	*/
	NisDomain *string
	/*NisEnabled
	  Filter by nis.enabled

	*/
	NisEnabled *bool
	/*NisServers
	  Filter by nis.servers

	*/
	NisServers *string
	/*NsswitchGroup
	  Filter by nsswitch.group

	*/
	NsswitchGroup *string
	/*NsswitchHosts
	  Filter by nsswitch.hosts

	*/
	NsswitchHosts *string
	/*NsswitchNamemap
	  Filter by nsswitch.namemap

	*/
	NsswitchNamemap *string
	/*NsswitchNetgroup
	  Filter by nsswitch.netgroup

	*/
	NsswitchNetgroup *string
	/*NsswitchPasswd
	  Filter by nsswitch.passwd

	*/
	NsswitchPasswd *string
	/*NvmeEnabled
	  Filter by nvme.enabled

	*/
	NvmeEnabled *bool
	/*OrderBy
	  Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.

	*/
	OrderBy []string
	/*ReturnRecords
	  The default is true for GET calls.  When set to false, only the number of records is returned.

	*/
	ReturnRecords *bool
	/*ReturnTimeout
	  The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	*/
	ReturnTimeout *int64
	/*S3Enabled
	  Filter by s3.enabled

	*/
	S3Enabled *bool
	/*S3Name
	  Filter by s3.name

	*/
	S3Name *string
	/*SnapshotPolicyName
	  Filter by snapshot_policy.name

	*/
	SnapshotPolicyName *string
	/*SnapshotPolicyUUID
	  Filter by snapshot_policy.uuid

	*/
	SnapshotPolicyUUID *string
	/*State
	  Filter by state

	*/
	State *string
	/*Subtype
	  Filter by subtype

	*/
	Subtype *string
	/*UUID
	  Filter by uuid

	*/
	UUID *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithTimeout(timeout time.Duration) *SvmCollectionGet1Params {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithContext(ctx context.Context) *SvmCollectionGet1Params {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithHTTPClient(client *http.Client) *SvmCollectionGet1Params {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAggregatesName adds the aggregatesName to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithAggregatesName(aggregatesName *string) *SvmCollectionGet1Params {
	o.SetAggregatesName(aggregatesName)
	return o
}

// SetAggregatesName adds the aggregatesName to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetAggregatesName(aggregatesName *string) {
	o.AggregatesName = aggregatesName
}

// WithAggregatesUUID adds the aggregatesUUID to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithAggregatesUUID(aggregatesUUID *string) *SvmCollectionGet1Params {
	o.SetAggregatesUUID(aggregatesUUID)
	return o
}

// SetAggregatesUUID adds the aggregatesUuid to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetAggregatesUUID(aggregatesUUID *string) {
	o.AggregatesUUID = aggregatesUUID
}

// WithCertificateUUID adds the certificateUUID to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithCertificateUUID(certificateUUID *string) *SvmCollectionGet1Params {
	o.SetCertificateUUID(certificateUUID)
	return o
}

// SetCertificateUUID adds the certificateUuid to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetCertificateUUID(certificateUUID *string) {
	o.CertificateUUID = certificateUUID
}

// WithCifsAdDomainFqdn adds the cifsAdDomainFqdn to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithCifsAdDomainFqdn(cifsAdDomainFqdn *string) *SvmCollectionGet1Params {
	o.SetCifsAdDomainFqdn(cifsAdDomainFqdn)
	return o
}

// SetCifsAdDomainFqdn adds the cifsAdDomainFqdn to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetCifsAdDomainFqdn(cifsAdDomainFqdn *string) {
	o.CifsAdDomainFqdn = cifsAdDomainFqdn
}

// WithCifsAdDomainOrganizationalUnit adds the cifsAdDomainOrganizationalUnit to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithCifsAdDomainOrganizationalUnit(cifsAdDomainOrganizationalUnit *string) *SvmCollectionGet1Params {
	o.SetCifsAdDomainOrganizationalUnit(cifsAdDomainOrganizationalUnit)
	return o
}

// SetCifsAdDomainOrganizationalUnit adds the cifsAdDomainOrganizationalUnit to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetCifsAdDomainOrganizationalUnit(cifsAdDomainOrganizationalUnit *string) {
	o.CifsAdDomainOrganizationalUnit = cifsAdDomainOrganizationalUnit
}

// WithCifsEnabled adds the cifsEnabled to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithCifsEnabled(cifsEnabled *bool) *SvmCollectionGet1Params {
	o.SetCifsEnabled(cifsEnabled)
	return o
}

// SetCifsEnabled adds the cifsEnabled to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetCifsEnabled(cifsEnabled *bool) {
	o.CifsEnabled = cifsEnabled
}

// WithCifsName adds the cifsName to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithCifsName(cifsName *string) *SvmCollectionGet1Params {
	o.SetCifsName(cifsName)
	return o
}

// SetCifsName adds the cifsName to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetCifsName(cifsName *string) {
	o.CifsName = cifsName
}

// WithComment adds the comment to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithComment(comment *string) *SvmCollectionGet1Params {
	o.SetComment(comment)
	return o
}

// SetComment adds the comment to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetComment(comment *string) {
	o.Comment = comment
}

// WithDNSDomains adds the dNSDomains to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithDNSDomains(dNSDomains *string) *SvmCollectionGet1Params {
	o.SetDNSDomains(dNSDomains)
	return o
}

// SetDNSDomains adds the dnsDomains to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetDNSDomains(dNSDomains *string) {
	o.DNSDomains = dNSDomains
}

// WithDNSServers adds the dNSServers to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithDNSServers(dNSServers *string) *SvmCollectionGet1Params {
	o.SetDNSServers(dNSServers)
	return o
}

// SetDNSServers adds the dnsServers to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetDNSServers(dNSServers *string) {
	o.DNSServers = dNSServers
}

// WithFcInterfacesDataProtocol adds the fcInterfacesDataProtocol to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithFcInterfacesDataProtocol(fcInterfacesDataProtocol *string) *SvmCollectionGet1Params {
	o.SetFcInterfacesDataProtocol(fcInterfacesDataProtocol)
	return o
}

// SetFcInterfacesDataProtocol adds the fcInterfacesDataProtocol to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetFcInterfacesDataProtocol(fcInterfacesDataProtocol *string) {
	o.FcInterfacesDataProtocol = fcInterfacesDataProtocol
}

// WithFcInterfacesName adds the fcInterfacesName to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithFcInterfacesName(fcInterfacesName *string) *SvmCollectionGet1Params {
	o.SetFcInterfacesName(fcInterfacesName)
	return o
}

// SetFcInterfacesName adds the fcInterfacesName to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetFcInterfacesName(fcInterfacesName *string) {
	o.FcInterfacesName = fcInterfacesName
}

// WithFcpEnabled adds the fcpEnabled to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithFcpEnabled(fcpEnabled *bool) *SvmCollectionGet1Params {
	o.SetFcpEnabled(fcpEnabled)
	return o
}

// SetFcpEnabled adds the fcpEnabled to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetFcpEnabled(fcpEnabled *bool) {
	o.FcpEnabled = fcpEnabled
}

// WithFields adds the fields to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithFields(fields []string) *SvmCollectionGet1Params {
	o.SetFields(fields)
	return o
}

// SetFields adds the fields to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetFields(fields []string) {
	o.Fields = fields
}

// WithIpspaceName adds the ipspaceName to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithIpspaceName(ipspaceName *string) *SvmCollectionGet1Params {
	o.SetIpspaceName(ipspaceName)
	return o
}

// SetIpspaceName adds the ipspaceName to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetIpspaceName(ipspaceName *string) {
	o.IpspaceName = ipspaceName
}

// WithIpspaceUUID adds the ipspaceUUID to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithIpspaceUUID(ipspaceUUID *string) *SvmCollectionGet1Params {
	o.SetIpspaceUUID(ipspaceUUID)
	return o
}

// SetIpspaceUUID adds the ipspaceUuid to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetIpspaceUUID(ipspaceUUID *string) {
	o.IpspaceUUID = ipspaceUUID
}

// WithIscsiEnabled adds the iscsiEnabled to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithIscsiEnabled(iscsiEnabled *bool) *SvmCollectionGet1Params {
	o.SetIscsiEnabled(iscsiEnabled)
	return o
}

// SetIscsiEnabled adds the iscsiEnabled to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetIscsiEnabled(iscsiEnabled *bool) {
	o.IscsiEnabled = iscsiEnabled
}

// WithLanguage adds the language to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithLanguage(language *string) *SvmCollectionGet1Params {
	o.SetLanguage(language)
	return o
}

// SetLanguage adds the language to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetLanguage(language *string) {
	o.Language = language
}

// WithLdapAdDomain adds the ldapAdDomain to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithLdapAdDomain(ldapAdDomain *string) *SvmCollectionGet1Params {
	o.SetLdapAdDomain(ldapAdDomain)
	return o
}

// SetLdapAdDomain adds the ldapAdDomain to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetLdapAdDomain(ldapAdDomain *string) {
	o.LdapAdDomain = ldapAdDomain
}

// WithLdapBaseDn adds the ldapBaseDn to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithLdapBaseDn(ldapBaseDn *string) *SvmCollectionGet1Params {
	o.SetLdapBaseDn(ldapBaseDn)
	return o
}

// SetLdapBaseDn adds the ldapBaseDn to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetLdapBaseDn(ldapBaseDn *string) {
	o.LdapBaseDn = ldapBaseDn
}

// WithLdapBindDn adds the ldapBindDn to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithLdapBindDn(ldapBindDn *string) *SvmCollectionGet1Params {
	o.SetLdapBindDn(ldapBindDn)
	return o
}

// SetLdapBindDn adds the ldapBindDn to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetLdapBindDn(ldapBindDn *string) {
	o.LdapBindDn = ldapBindDn
}

// WithLdapEnabled adds the ldapEnabled to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithLdapEnabled(ldapEnabled *bool) *SvmCollectionGet1Params {
	o.SetLdapEnabled(ldapEnabled)
	return o
}

// SetLdapEnabled adds the ldapEnabled to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetLdapEnabled(ldapEnabled *bool) {
	o.LdapEnabled = ldapEnabled
}

// WithLdapServers adds the ldapServers to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithLdapServers(ldapServers *string) *SvmCollectionGet1Params {
	o.SetLdapServers(ldapServers)
	return o
}

// SetLdapServers adds the ldapServers to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetLdapServers(ldapServers *string) {
	o.LdapServers = ldapServers
}

// WithMaxRecords adds the maxRecords to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithMaxRecords(maxRecords *int64) *SvmCollectionGet1Params {
	o.SetMaxRecords(maxRecords)
	return o
}

// SetMaxRecords adds the maxRecords to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetMaxRecords(maxRecords *int64) {
	o.MaxRecords = maxRecords
}

// WithName adds the name to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithName(name *string) *SvmCollectionGet1Params {
	o.SetName(name)
	return o
}

// SetName adds the name to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetName(name *string) {
	o.Name = name
}

// WithNfsEnabled adds the nfsEnabled to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithNfsEnabled(nfsEnabled *bool) *SvmCollectionGet1Params {
	o.SetNfsEnabled(nfsEnabled)
	return o
}

// SetNfsEnabled adds the nfsEnabled to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetNfsEnabled(nfsEnabled *bool) {
	o.NfsEnabled = nfsEnabled
}

// WithNisDomain adds the nisDomain to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithNisDomain(nisDomain *string) *SvmCollectionGet1Params {
	o.SetNisDomain(nisDomain)
	return o
}

// SetNisDomain adds the nisDomain to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetNisDomain(nisDomain *string) {
	o.NisDomain = nisDomain
}

// WithNisEnabled adds the nisEnabled to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithNisEnabled(nisEnabled *bool) *SvmCollectionGet1Params {
	o.SetNisEnabled(nisEnabled)
	return o
}

// SetNisEnabled adds the nisEnabled to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetNisEnabled(nisEnabled *bool) {
	o.NisEnabled = nisEnabled
}

// WithNisServers adds the nisServers to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithNisServers(nisServers *string) *SvmCollectionGet1Params {
	o.SetNisServers(nisServers)
	return o
}

// SetNisServers adds the nisServers to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetNisServers(nisServers *string) {
	o.NisServers = nisServers
}

// WithNsswitchGroup adds the nsswitchGroup to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithNsswitchGroup(nsswitchGroup *string) *SvmCollectionGet1Params {
	o.SetNsswitchGroup(nsswitchGroup)
	return o
}

// SetNsswitchGroup adds the nsswitchGroup to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetNsswitchGroup(nsswitchGroup *string) {
	o.NsswitchGroup = nsswitchGroup
}

// WithNsswitchHosts adds the nsswitchHosts to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithNsswitchHosts(nsswitchHosts *string) *SvmCollectionGet1Params {
	o.SetNsswitchHosts(nsswitchHosts)
	return o
}

// SetNsswitchHosts adds the nsswitchHosts to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetNsswitchHosts(nsswitchHosts *string) {
	o.NsswitchHosts = nsswitchHosts
}

// WithNsswitchNamemap adds the nsswitchNamemap to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithNsswitchNamemap(nsswitchNamemap *string) *SvmCollectionGet1Params {
	o.SetNsswitchNamemap(nsswitchNamemap)
	return o
}

// SetNsswitchNamemap adds the nsswitchNamemap to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetNsswitchNamemap(nsswitchNamemap *string) {
	o.NsswitchNamemap = nsswitchNamemap
}

// WithNsswitchNetgroup adds the nsswitchNetgroup to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithNsswitchNetgroup(nsswitchNetgroup *string) *SvmCollectionGet1Params {
	o.SetNsswitchNetgroup(nsswitchNetgroup)
	return o
}

// SetNsswitchNetgroup adds the nsswitchNetgroup to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetNsswitchNetgroup(nsswitchNetgroup *string) {
	o.NsswitchNetgroup = nsswitchNetgroup
}

// WithNsswitchPasswd adds the nsswitchPasswd to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithNsswitchPasswd(nsswitchPasswd *string) *SvmCollectionGet1Params {
	o.SetNsswitchPasswd(nsswitchPasswd)
	return o
}

// SetNsswitchPasswd adds the nsswitchPasswd to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetNsswitchPasswd(nsswitchPasswd *string) {
	o.NsswitchPasswd = nsswitchPasswd
}

// WithNvmeEnabled adds the nvmeEnabled to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithNvmeEnabled(nvmeEnabled *bool) *SvmCollectionGet1Params {
	o.SetNvmeEnabled(nvmeEnabled)
	return o
}

// SetNvmeEnabled adds the nvmeEnabled to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetNvmeEnabled(nvmeEnabled *bool) {
	o.NvmeEnabled = nvmeEnabled
}

// WithOrderBy adds the orderBy to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithOrderBy(orderBy []string) *SvmCollectionGet1Params {
	o.SetOrderBy(orderBy)
	return o
}

// SetOrderBy adds the orderBy to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetOrderBy(orderBy []string) {
	o.OrderBy = orderBy
}

// WithReturnRecords adds the returnRecords to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithReturnRecords(returnRecords *bool) *SvmCollectionGet1Params {
	o.SetReturnRecords(returnRecords)
	return o
}

// SetReturnRecords adds the returnRecords to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetReturnRecords(returnRecords *bool) {
	o.ReturnRecords = returnRecords
}

// WithReturnTimeout adds the returnTimeout to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithReturnTimeout(returnTimeout *int64) *SvmCollectionGet1Params {
	o.SetReturnTimeout(returnTimeout)
	return o
}

// SetReturnTimeout adds the returnTimeout to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetReturnTimeout(returnTimeout *int64) {
	o.ReturnTimeout = returnTimeout
}

// WithS3Enabled adds the s3Enabled to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithS3Enabled(s3Enabled *bool) *SvmCollectionGet1Params {
	o.SetS3Enabled(s3Enabled)
	return o
}

// SetS3Enabled adds the s3Enabled to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetS3Enabled(s3Enabled *bool) {
	o.S3Enabled = s3Enabled
}

// WithS3Name adds the s3Name to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithS3Name(s3Name *string) *SvmCollectionGet1Params {
	o.SetS3Name(s3Name)
	return o
}

// SetS3Name adds the s3Name to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetS3Name(s3Name *string) {
	o.S3Name = s3Name
}

// WithSnapshotPolicyName adds the snapshotPolicyName to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithSnapshotPolicyName(snapshotPolicyName *string) *SvmCollectionGet1Params {
	o.SetSnapshotPolicyName(snapshotPolicyName)
	return o
}

// SetSnapshotPolicyName adds the snapshotPolicyName to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetSnapshotPolicyName(snapshotPolicyName *string) {
	o.SnapshotPolicyName = snapshotPolicyName
}

// WithSnapshotPolicyUUID adds the snapshotPolicyUUID to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithSnapshotPolicyUUID(snapshotPolicyUUID *string) *SvmCollectionGet1Params {
	o.SetSnapshotPolicyUUID(snapshotPolicyUUID)
	return o
}

// SetSnapshotPolicyUUID adds the snapshotPolicyUuid to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetSnapshotPolicyUUID(snapshotPolicyUUID *string) {
	o.SnapshotPolicyUUID = snapshotPolicyUUID
}

// WithState adds the state to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithState(state *string) *SvmCollectionGet1Params {
	o.SetState(state)
	return o
}

// SetState adds the state to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetState(state *string) {
	o.State = state
}

// WithSubtype adds the subtype to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithSubtype(subtype *string) *SvmCollectionGet1Params {
	o.SetSubtype(subtype)
	return o
}

// SetSubtype adds the subtype to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetSubtype(subtype *string) {
	o.Subtype = subtype
}

// WithUUID adds the uuid to the svm collection get1 params
func (o *SvmCollectionGet1Params) WithUUID(uuid *string) *SvmCollectionGet1Params {
	o.SetUUID(uuid)
	return o
}

// SetUUID adds the uuid to the svm collection get1 params
func (o *SvmCollectionGet1Params) SetUUID(uuid *string) {
	o.UUID = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *SvmCollectionGet1Params) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.AggregatesName != nil {

		// query param aggregates.name
		var qrAggregatesName string
		if o.AggregatesName != nil {
			qrAggregatesName = *o.AggregatesName
		}
		qAggregatesName := qrAggregatesName
		if qAggregatesName != "" {
			if err := r.SetQueryParam("aggregates.name", qAggregatesName); err != nil {
				return err
			}
		}

	}

	if o.AggregatesUUID != nil {

		// query param aggregates.uuid
		var qrAggregatesUUID string
		if o.AggregatesUUID != nil {
			qrAggregatesUUID = *o.AggregatesUUID
		}
		qAggregatesUUID := qrAggregatesUUID
		if qAggregatesUUID != "" {
			if err := r.SetQueryParam("aggregates.uuid", qAggregatesUUID); err != nil {
				return err
			}
		}

	}

	if o.CertificateUUID != nil {

		// query param certificate.uuid
		var qrCertificateUUID string
		if o.CertificateUUID != nil {
			qrCertificateUUID = *o.CertificateUUID
		}
		qCertificateUUID := qrCertificateUUID
		if qCertificateUUID != "" {
			if err := r.SetQueryParam("certificate.uuid", qCertificateUUID); err != nil {
				return err
			}
		}

	}

	if o.CifsAdDomainFqdn != nil {

		// query param cifs.ad_domain.fqdn
		var qrCifsAdDomainFqdn string
		if o.CifsAdDomainFqdn != nil {
			qrCifsAdDomainFqdn = *o.CifsAdDomainFqdn
		}
		qCifsAdDomainFqdn := qrCifsAdDomainFqdn
		if qCifsAdDomainFqdn != "" {
			if err := r.SetQueryParam("cifs.ad_domain.fqdn", qCifsAdDomainFqdn); err != nil {
				return err
			}
		}

	}

	if o.CifsAdDomainOrganizationalUnit != nil {

		// query param cifs.ad_domain.organizational_unit
		var qrCifsAdDomainOrganizationalUnit string
		if o.CifsAdDomainOrganizationalUnit != nil {
			qrCifsAdDomainOrganizationalUnit = *o.CifsAdDomainOrganizationalUnit
		}
		qCifsAdDomainOrganizationalUnit := qrCifsAdDomainOrganizationalUnit
		if qCifsAdDomainOrganizationalUnit != "" {
			if err := r.SetQueryParam("cifs.ad_domain.organizational_unit", qCifsAdDomainOrganizationalUnit); err != nil {
				return err
			}
		}

	}

	if o.CifsEnabled != nil {

		// query param cifs.enabled
		var qrCifsEnabled bool
		if o.CifsEnabled != nil {
			qrCifsEnabled = *o.CifsEnabled
		}
		qCifsEnabled := swag.FormatBool(qrCifsEnabled)
		if qCifsEnabled != "" {
			if err := r.SetQueryParam("cifs.enabled", qCifsEnabled); err != nil {
				return err
			}
		}

	}

	if o.CifsName != nil {

		// query param cifs.name
		var qrCifsName string
		if o.CifsName != nil {
			qrCifsName = *o.CifsName
		}
		qCifsName := qrCifsName
		if qCifsName != "" {
			if err := r.SetQueryParam("cifs.name", qCifsName); err != nil {
				return err
			}
		}

	}

	if o.Comment != nil {

		// query param comment
		var qrComment string
		if o.Comment != nil {
			qrComment = *o.Comment
		}
		qComment := qrComment
		if qComment != "" {
			if err := r.SetQueryParam("comment", qComment); err != nil {
				return err
			}
		}

	}

	if o.DNSDomains != nil {

		// query param dns.domains
		var qrDNSDomains string
		if o.DNSDomains != nil {
			qrDNSDomains = *o.DNSDomains
		}
		qDNSDomains := qrDNSDomains
		if qDNSDomains != "" {
			if err := r.SetQueryParam("dns.domains", qDNSDomains); err != nil {
				return err
			}
		}

	}

	if o.DNSServers != nil {

		// query param dns.servers
		var qrDNSServers string
		if o.DNSServers != nil {
			qrDNSServers = *o.DNSServers
		}
		qDNSServers := qrDNSServers
		if qDNSServers != "" {
			if err := r.SetQueryParam("dns.servers", qDNSServers); err != nil {
				return err
			}
		}

	}

	if o.FcInterfacesDataProtocol != nil {

		// query param fc_interfaces.data_protocol
		var qrFcInterfacesDataProtocol string
		if o.FcInterfacesDataProtocol != nil {
			qrFcInterfacesDataProtocol = *o.FcInterfacesDataProtocol
		}
		qFcInterfacesDataProtocol := qrFcInterfacesDataProtocol
		if qFcInterfacesDataProtocol != "" {
			if err := r.SetQueryParam("fc_interfaces.data_protocol", qFcInterfacesDataProtocol); err != nil {
				return err
			}
		}

	}

	if o.FcInterfacesName != nil {

		// query param fc_interfaces.name
		var qrFcInterfacesName string
		if o.FcInterfacesName != nil {
			qrFcInterfacesName = *o.FcInterfacesName
		}
		qFcInterfacesName := qrFcInterfacesName
		if qFcInterfacesName != "" {
			if err := r.SetQueryParam("fc_interfaces.name", qFcInterfacesName); err != nil {
				return err
			}
		}

	}

	if o.FcpEnabled != nil {

		// query param fcp.enabled
		var qrFcpEnabled bool
		if o.FcpEnabled != nil {
			qrFcpEnabled = *o.FcpEnabled
		}
		qFcpEnabled := swag.FormatBool(qrFcpEnabled)
		if qFcpEnabled != "" {
			if err := r.SetQueryParam("fcp.enabled", qFcpEnabled); err != nil {
				return err
			}
		}

	}

	valuesFields := o.Fields

	joinedFields := swag.JoinByFormat(valuesFields, "csv")
	// query array param fields
	if err := r.SetQueryParam("fields", joinedFields...); err != nil {
		return err
	}

	if o.IpspaceName != nil {

		// query param ipspace.name
		var qrIpspaceName string
		if o.IpspaceName != nil {
			qrIpspaceName = *o.IpspaceName
		}
		qIpspaceName := qrIpspaceName
		if qIpspaceName != "" {
			if err := r.SetQueryParam("ipspace.name", qIpspaceName); err != nil {
				return err
			}
		}

	}

	if o.IpspaceUUID != nil {

		// query param ipspace.uuid
		var qrIpspaceUUID string
		if o.IpspaceUUID != nil {
			qrIpspaceUUID = *o.IpspaceUUID
		}
		qIpspaceUUID := qrIpspaceUUID
		if qIpspaceUUID != "" {
			if err := r.SetQueryParam("ipspace.uuid", qIpspaceUUID); err != nil {
				return err
			}
		}

	}

	if o.IscsiEnabled != nil {

		// query param iscsi.enabled
		var qrIscsiEnabled bool
		if o.IscsiEnabled != nil {
			qrIscsiEnabled = *o.IscsiEnabled
		}
		qIscsiEnabled := swag.FormatBool(qrIscsiEnabled)
		if qIscsiEnabled != "" {
			if err := r.SetQueryParam("iscsi.enabled", qIscsiEnabled); err != nil {
				return err
			}
		}

	}

	if o.Language != nil {

		// query param language
		var qrLanguage string
		if o.Language != nil {
			qrLanguage = *o.Language
		}
		qLanguage := qrLanguage
		if qLanguage != "" {
			if err := r.SetQueryParam("language", qLanguage); err != nil {
				return err
			}
		}

	}

	if o.LdapAdDomain != nil {

		// query param ldap.ad_domain
		var qrLdapAdDomain string
		if o.LdapAdDomain != nil {
			qrLdapAdDomain = *o.LdapAdDomain
		}
		qLdapAdDomain := qrLdapAdDomain
		if qLdapAdDomain != "" {
			if err := r.SetQueryParam("ldap.ad_domain", qLdapAdDomain); err != nil {
				return err
			}
		}

	}

	if o.LdapBaseDn != nil {

		// query param ldap.base_dn
		var qrLdapBaseDn string
		if o.LdapBaseDn != nil {
			qrLdapBaseDn = *o.LdapBaseDn
		}
		qLdapBaseDn := qrLdapBaseDn
		if qLdapBaseDn != "" {
			if err := r.SetQueryParam("ldap.base_dn", qLdapBaseDn); err != nil {
				return err
			}
		}

	}

	if o.LdapBindDn != nil {

		// query param ldap.bind_dn
		var qrLdapBindDn string
		if o.LdapBindDn != nil {
			qrLdapBindDn = *o.LdapBindDn
		}
		qLdapBindDn := qrLdapBindDn
		if qLdapBindDn != "" {
			if err := r.SetQueryParam("ldap.bind_dn", qLdapBindDn); err != nil {
				return err
			}
		}

	}

	if o.LdapEnabled != nil {

		// query param ldap.enabled
		var qrLdapEnabled bool
		if o.LdapEnabled != nil {
			qrLdapEnabled = *o.LdapEnabled
		}
		qLdapEnabled := swag.FormatBool(qrLdapEnabled)
		if qLdapEnabled != "" {
			if err := r.SetQueryParam("ldap.enabled", qLdapEnabled); err != nil {
				return err
			}
		}

	}

	if o.LdapServers != nil {

		// query param ldap.servers
		var qrLdapServers string
		if o.LdapServers != nil {
			qrLdapServers = *o.LdapServers
		}
		qLdapServers := qrLdapServers
		if qLdapServers != "" {
			if err := r.SetQueryParam("ldap.servers", qLdapServers); err != nil {
				return err
			}
		}

	}

	if o.MaxRecords != nil {

		// query param max_records
		var qrMaxRecords int64
		if o.MaxRecords != nil {
			qrMaxRecords = *o.MaxRecords
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {
			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}

	}

	if o.Name != nil {

		// query param name
		var qrName string
		if o.Name != nil {
			qrName = *o.Name
		}
		qName := qrName
		if qName != "" {
			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}

	}

	if o.NfsEnabled != nil {

		// query param nfs.enabled
		var qrNfsEnabled bool
		if o.NfsEnabled != nil {
			qrNfsEnabled = *o.NfsEnabled
		}
		qNfsEnabled := swag.FormatBool(qrNfsEnabled)
		if qNfsEnabled != "" {
			if err := r.SetQueryParam("nfs.enabled", qNfsEnabled); err != nil {
				return err
			}
		}

	}

	if o.NisDomain != nil {

		// query param nis.domain
		var qrNisDomain string
		if o.NisDomain != nil {
			qrNisDomain = *o.NisDomain
		}
		qNisDomain := qrNisDomain
		if qNisDomain != "" {
			if err := r.SetQueryParam("nis.domain", qNisDomain); err != nil {
				return err
			}
		}

	}

	if o.NisEnabled != nil {

		// query param nis.enabled
		var qrNisEnabled bool
		if o.NisEnabled != nil {
			qrNisEnabled = *o.NisEnabled
		}
		qNisEnabled := swag.FormatBool(qrNisEnabled)
		if qNisEnabled != "" {
			if err := r.SetQueryParam("nis.enabled", qNisEnabled); err != nil {
				return err
			}
		}

	}

	if o.NisServers != nil {

		// query param nis.servers
		var qrNisServers string
		if o.NisServers != nil {
			qrNisServers = *o.NisServers
		}
		qNisServers := qrNisServers
		if qNisServers != "" {
			if err := r.SetQueryParam("nis.servers", qNisServers); err != nil {
				return err
			}
		}

	}

	if o.NsswitchGroup != nil {

		// query param nsswitch.group
		var qrNsswitchGroup string
		if o.NsswitchGroup != nil {
			qrNsswitchGroup = *o.NsswitchGroup
		}
		qNsswitchGroup := qrNsswitchGroup
		if qNsswitchGroup != "" {
			if err := r.SetQueryParam("nsswitch.group", qNsswitchGroup); err != nil {
				return err
			}
		}

	}

	if o.NsswitchHosts != nil {

		// query param nsswitch.hosts
		var qrNsswitchHosts string
		if o.NsswitchHosts != nil {
			qrNsswitchHosts = *o.NsswitchHosts
		}
		qNsswitchHosts := qrNsswitchHosts
		if qNsswitchHosts != "" {
			if err := r.SetQueryParam("nsswitch.hosts", qNsswitchHosts); err != nil {
				return err
			}
		}

	}

	if o.NsswitchNamemap != nil {

		// query param nsswitch.namemap
		var qrNsswitchNamemap string
		if o.NsswitchNamemap != nil {
			qrNsswitchNamemap = *o.NsswitchNamemap
		}
		qNsswitchNamemap := qrNsswitchNamemap
		if qNsswitchNamemap != "" {
			if err := r.SetQueryParam("nsswitch.namemap", qNsswitchNamemap); err != nil {
				return err
			}
		}

	}

	if o.NsswitchNetgroup != nil {

		// query param nsswitch.netgroup
		var qrNsswitchNetgroup string
		if o.NsswitchNetgroup != nil {
			qrNsswitchNetgroup = *o.NsswitchNetgroup
		}
		qNsswitchNetgroup := qrNsswitchNetgroup
		if qNsswitchNetgroup != "" {
			if err := r.SetQueryParam("nsswitch.netgroup", qNsswitchNetgroup); err != nil {
				return err
			}
		}

	}

	if o.NsswitchPasswd != nil {

		// query param nsswitch.passwd
		var qrNsswitchPasswd string
		if o.NsswitchPasswd != nil {
			qrNsswitchPasswd = *o.NsswitchPasswd
		}
		qNsswitchPasswd := qrNsswitchPasswd
		if qNsswitchPasswd != "" {
			if err := r.SetQueryParam("nsswitch.passwd", qNsswitchPasswd); err != nil {
				return err
			}
		}

	}

	if o.NvmeEnabled != nil {

		// query param nvme.enabled
		var qrNvmeEnabled bool
		if o.NvmeEnabled != nil {
			qrNvmeEnabled = *o.NvmeEnabled
		}
		qNvmeEnabled := swag.FormatBool(qrNvmeEnabled)
		if qNvmeEnabled != "" {
			if err := r.SetQueryParam("nvme.enabled", qNvmeEnabled); err != nil {
				return err
			}
		}

	}

	valuesOrderBy := o.OrderBy

	joinedOrderBy := swag.JoinByFormat(valuesOrderBy, "csv")
	// query array param order_by
	if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
		return err
	}

	if o.ReturnRecords != nil {

		// query param return_records
		var qrReturnRecords bool
		if o.ReturnRecords != nil {
			qrReturnRecords = *o.ReturnRecords
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {
			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}

	}

	if o.ReturnTimeout != nil {

		// query param return_timeout
		var qrReturnTimeout int64
		if o.ReturnTimeout != nil {
			qrReturnTimeout = *o.ReturnTimeout
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {
			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}

	}

	if o.S3Enabled != nil {

		// query param s3.enabled
		var qrS3Enabled bool
		if o.S3Enabled != nil {
			qrS3Enabled = *o.S3Enabled
		}
		qS3Enabled := swag.FormatBool(qrS3Enabled)
		if qS3Enabled != "" {
			if err := r.SetQueryParam("s3.enabled", qS3Enabled); err != nil {
				return err
			}
		}

	}

	if o.S3Name != nil {

		// query param s3.name
		var qrS3Name string
		if o.S3Name != nil {
			qrS3Name = *o.S3Name
		}
		qS3Name := qrS3Name
		if qS3Name != "" {
			if err := r.SetQueryParam("s3.name", qS3Name); err != nil {
				return err
			}
		}

	}

	if o.SnapshotPolicyName != nil {

		// query param snapshot_policy.name
		var qrSnapshotPolicyName string
		if o.SnapshotPolicyName != nil {
			qrSnapshotPolicyName = *o.SnapshotPolicyName
		}
		qSnapshotPolicyName := qrSnapshotPolicyName
		if qSnapshotPolicyName != "" {
			if err := r.SetQueryParam("snapshot_policy.name", qSnapshotPolicyName); err != nil {
				return err
			}
		}

	}

	if o.SnapshotPolicyUUID != nil {

		// query param snapshot_policy.uuid
		var qrSnapshotPolicyUUID string
		if o.SnapshotPolicyUUID != nil {
			qrSnapshotPolicyUUID = *o.SnapshotPolicyUUID
		}
		qSnapshotPolicyUUID := qrSnapshotPolicyUUID
		if qSnapshotPolicyUUID != "" {
			if err := r.SetQueryParam("snapshot_policy.uuid", qSnapshotPolicyUUID); err != nil {
				return err
			}
		}

	}

	if o.State != nil {

		// query param state
		var qrState string
		if o.State != nil {
			qrState = *o.State
		}
		qState := qrState
		if qState != "" {
			if err := r.SetQueryParam("state", qState); err != nil {
				return err
			}
		}

	}

	if o.Subtype != nil {

		// query param subtype
		var qrSubtype string
		if o.Subtype != nil {
			qrSubtype = *o.Subtype
		}
		qSubtype := qrSubtype
		if qSubtype != "" {
			if err := r.SetQueryParam("subtype", qSubtype); err != nil {
				return err
			}
		}

	}

	if o.UUID != nil {

		// query param uuid
		var qrUUID string
		if o.UUID != nil {
			qrUUID = *o.UUID
		}
		qUUID := qrUUID
		if qUUID != "" {
			if err := r.SetQueryParam("uuid", qUUID); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
