// Code generated by go-swagger; DO NOT EDIT.

package svm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"

	ntapmodel "github.com/greenqloud/ontap-rest-client/ntapmodel"
)

// SvmCreate1Reader is a Reader for the SvmCreate1 structure.
type SvmCreate1Reader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *SvmCreate1Reader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 202:
		result := NewSvmCreate1Accepted()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewSvmCreate1Default(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewSvmCreate1Accepted creates a SvmCreate1Accepted with default headers values
func NewSvmCreate1Accepted() *SvmCreate1Accepted {
	return &SvmCreate1Accepted{}
}

/*SvmCreate1Accepted handles this case with default header values.

Accepted
*/
type SvmCreate1Accepted struct {
	Payload *ntapmodel.JobLinkResponse
}

func (o *SvmCreate1Accepted) Error() string {
	return fmt.Sprintf("[POST /private/cli/snapmirror][%d] svmCreate1Accepted  %+v", 202, o.Payload)
}

func (o *SvmCreate1Accepted) GetPayload() *ntapmodel.JobLinkResponse {
	return o.Payload
}

func (o *SvmCreate1Accepted) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(ntapmodel.JobLinkResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewSvmCreate1Default creates a SvmCreate1Default with default headers values
func NewSvmCreate1Default(code int) *SvmCreate1Default {
	return &SvmCreate1Default{
		_statusCode: code,
	}
}

/*SvmCreate1Default handles this case with default header values.

ONTAP Error Response Codes
<br/>
```
| Error codes | Description |
| ----------- | ----------- |
| 2621580     | Cannot specify options other than SVM name, comment and ipspace for a Vserver that is being configured as the destination for SVM DR. |
| 2621634     | \"sync-source\" SVM can only be created in a MetroCluster configuration. |
| 2621657     | \"sync-destination\" SVM can only be created by the system. |
| 13434884    | Cannot create an SVM because of incorrect fields. |
| 13434885    | Non-UTF8 language(s) not supported. |
| 13434888    | IPspace UUID and IPspace name mismatch. |
| 13434889    | Internal Error. Wait and retry. |
| 13434894    | Maximum allowed SVM jobs exceeded. Wait for the existing SVM jobs to complete and try again. |
| 13434908    | Invalid SVM name. The name is already in use by another SVM, IPSpace or cluster. |
| 13434909    | Internal Error. Failed to identify the aggregate to host SVM root volume. |
| 13434910    | Internal Error. Failed to allocate new SVM ID. |
| 13434911    | Invalid SVM name. Maximum supported length is 41 if SVM is of type \\\"sync-source\\\", otherwise 47. |
| 13434912    | Failed to find IPspace. |
| 13434913    | Internal error: Failed to check if an SVM create operation is in progress. Contact technical support for assistance. |
| 13434914    | Request to create the root volume of the SVM failed because there is not enough space in specified aggregate. |
| 13434915    | Failed to unlock the SVM because SVM create or delete job is in progress. Wait a few minutes, and then try the command again. |
| 13434916    | SVM is in the process of being created. Wait a few minutes, and then try the command again. |
| 13434917    | SVM creation successful. |
| 13434918    | IPspace name not provided for creating an SVM. |
```
<br/>

*/
type SvmCreate1Default struct {
	_statusCode int

	Payload *ntapmodel.ErrorResponse
}

// Code gets the status code for the svm create1 default response
func (o *SvmCreate1Default) Code() int {
	return o._statusCode
}

func (o *SvmCreate1Default) Error() string {
	return fmt.Sprintf("[POST /private/cli/snapmirror][%d] svm_create1 default  %+v", o._statusCode, o.Payload)
}

func (o *SvmCreate1Default) GetPayload() *ntapmodel.ErrorResponse {
	return o.Payload
}

func (o *SvmCreate1Default) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(ntapmodel.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
