// Code generated by go-swagger; DO NOT EDIT.

package svm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/greenqloud/ontap-rest-client/ntapmodel"
)

// SvmDeleteReader is a Reader for the SvmDelete structure.
type SvmDeleteReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *SvmDeleteReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 202:
		result := NewSvmDeleteAccepted()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewSvmDeleteDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewSvmDeleteAccepted creates a SvmDeleteAccepted with default headers values
func NewSvmDeleteAccepted() *SvmDeleteAccepted {
	return &SvmDeleteAccepted{}
}

/*SvmDeleteAccepted handles this case with default header values.

Accepted
*/
type SvmDeleteAccepted struct {
	Payload *ntapmodel.JobLinkResponse
}

func (o *SvmDeleteAccepted) Error() string {
	return fmt.Sprintf("[DELETE /svm/svms/{uuid}][%d] svmDeleteAccepted  %+v", 202, o.Payload)
}

func (o *SvmDeleteAccepted) GetPayload() *ntapmodel.JobLinkResponse {
	return o.Payload
}

func (o *SvmDeleteAccepted) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(ntapmodel.JobLinkResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewSvmDeleteDefault creates a SvmDeleteDefault with default headers values
func NewSvmDeleteDefault(code int) *SvmDeleteDefault {
	return &SvmDeleteDefault{
		_statusCode: code,
	}
}

/*SvmDeleteDefault handles this case with default header values.

ONTAP Error Response Codes
<br/>
```
| Error codes | Description |
| ----------- | ----------- |
| 13434894    | Maximum allowed SVM jobs exceeded. Wait and retry. |
```
<br/>

*/
type SvmDeleteDefault struct {
	_statusCode int

	Payload *ntapmodel.ErrorResponse
}

// Code gets the status code for the svm delete default response
func (o *SvmDeleteDefault) Code() int {
	return o._statusCode
}

func (o *SvmDeleteDefault) Error() string {
	return fmt.Sprintf("[DELETE /svm/svms/{uuid}][%d] svm_delete default  %+v", o._statusCode, o.Payload)
}

func (o *SvmDeleteDefault) GetPayload() *ntapmodel.ErrorResponse {
	return o.Payload
}

func (o *SvmDeleteDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(ntapmodel.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
