// Code generated by go-swagger; DO NOT EDIT.

package ntapmodel

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"strconv"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// Aggregate aggregate
// swagger:model aggregate
type Aggregate struct {

	// links
	Links *AggregateLinks `json:"_links,omitempty"`

	// block storage
	BlockStorage *AggregateBlockStorage `json:"block_storage,omitempty"`

	// cloud storage
	CloudStorage *AggregateCloudStorage `json:"cloud_storage,omitempty"`

	// Timestamp of aggregate creation
	// Read Only: true
	CreateTime string `json:"create_time,omitempty"`

	// data encryption
	DataEncryption *AggregateDataEncryption `json:"data_encryption,omitempty"`

	// dr home node
	DrHomeNode *NodeReference `json:"dr_home_node,omitempty"`

	// home node
	HomeNode *NodeReference `json:"home_node,omitempty"`

	// metric
	Metric *PerformanceMetric `json:"metric,omitempty"`

	// Aggregate name
	Name string `json:"name,omitempty"`

	// node
	Node *NodeReference `json:"node,omitempty"`

	// SnapLock type
	// Enum: [non_snaplock compliance enterprise]
	SnaplockType string `json:"snaplock_type,omitempty"`

	// space
	Space *AggregateSpace `json:"space,omitempty"`

	// Operational state of the aggregate
	// Read Only: true
	// Enum: [online onlining offline offlining relocating unmounted restricted inconsistent failed unknown]
	State string `json:"state,omitempty"`

	// statistics
	Statistics *PerformanceMetricRawReference `json:"statistics,omitempty"`

	// Aggregate UUID
	// Read Only: true
	// Format: uuid
	UUID strfmt.UUID `json:"uuid,omitempty"`
}

// Validate validates this aggregate
func (m *Aggregate) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLinks(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateBlockStorage(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateCloudStorage(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateDataEncryption(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateDrHomeNode(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateHomeNode(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateMetric(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateNode(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSnaplockType(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSpace(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateState(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateStatistics(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateUUID(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *Aggregate) validateLinks(formats strfmt.Registry) error {

	if swag.IsZero(m.Links) { // not required
		return nil
	}

	if m.Links != nil {
		if err := m.Links.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("_links")
			}
			return err
		}
	}

	return nil
}

func (m *Aggregate) validateBlockStorage(formats strfmt.Registry) error {

	if swag.IsZero(m.BlockStorage) { // not required
		return nil
	}

	if m.BlockStorage != nil {
		if err := m.BlockStorage.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("block_storage")
			}
			return err
		}
	}

	return nil
}

func (m *Aggregate) validateCloudStorage(formats strfmt.Registry) error {

	if swag.IsZero(m.CloudStorage) { // not required
		return nil
	}

	if m.CloudStorage != nil {
		if err := m.CloudStorage.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("cloud_storage")
			}
			return err
		}
	}

	return nil
}

func (m *Aggregate) validateDataEncryption(formats strfmt.Registry) error {

	if swag.IsZero(m.DataEncryption) { // not required
		return nil
	}

	if m.DataEncryption != nil {
		if err := m.DataEncryption.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("data_encryption")
			}
			return err
		}
	}

	return nil
}

func (m *Aggregate) validateDrHomeNode(formats strfmt.Registry) error {

	if swag.IsZero(m.DrHomeNode) { // not required
		return nil
	}

	if m.DrHomeNode != nil {
		if err := m.DrHomeNode.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("dr_home_node")
			}
			return err
		}
	}

	return nil
}

func (m *Aggregate) validateHomeNode(formats strfmt.Registry) error {

	if swag.IsZero(m.HomeNode) { // not required
		return nil
	}

	if m.HomeNode != nil {
		if err := m.HomeNode.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("home_node")
			}
			return err
		}
	}

	return nil
}

func (m *Aggregate) validateMetric(formats strfmt.Registry) error {

	if swag.IsZero(m.Metric) { // not required
		return nil
	}

	if m.Metric != nil {
		if err := m.Metric.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("metric")
			}
			return err
		}
	}

	return nil
}

func (m *Aggregate) validateNode(formats strfmt.Registry) error {

	if swag.IsZero(m.Node) { // not required
		return nil
	}

	if m.Node != nil {
		if err := m.Node.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("node")
			}
			return err
		}
	}

	return nil
}

var aggregateTypeSnaplockTypePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["non_snaplock","compliance","enterprise"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		aggregateTypeSnaplockTypePropEnum = append(aggregateTypeSnaplockTypePropEnum, v)
	}
}

const (

	// AggregateSnaplockTypeNonSnaplock captures enum value "non_snaplock"
	AggregateSnaplockTypeNonSnaplock string = "non_snaplock"

	// AggregateSnaplockTypeCompliance captures enum value "compliance"
	AggregateSnaplockTypeCompliance string = "compliance"

	// AggregateSnaplockTypeEnterprise captures enum value "enterprise"
	AggregateSnaplockTypeEnterprise string = "enterprise"
)

// prop value enum
func (m *Aggregate) validateSnaplockTypeEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, aggregateTypeSnaplockTypePropEnum); err != nil {
		return err
	}
	return nil
}

func (m *Aggregate) validateSnaplockType(formats strfmt.Registry) error {

	if swag.IsZero(m.SnaplockType) { // not required
		return nil
	}

	// value enum
	if err := m.validateSnaplockTypeEnum("snaplock_type", "body", m.SnaplockType); err != nil {
		return err
	}

	return nil
}

func (m *Aggregate) validateSpace(formats strfmt.Registry) error {

	if swag.IsZero(m.Space) { // not required
		return nil
	}

	if m.Space != nil {
		if err := m.Space.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("space")
			}
			return err
		}
	}

	return nil
}

var aggregateTypeStatePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["online","onlining","offline","offlining","relocating","unmounted","restricted","inconsistent","failed","unknown"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		aggregateTypeStatePropEnum = append(aggregateTypeStatePropEnum, v)
	}
}

const (

	// AggregateStateOnline captures enum value "online"
	AggregateStateOnline string = "online"

	// AggregateStateOnlining captures enum value "onlining"
	AggregateStateOnlining string = "onlining"

	// AggregateStateOffline captures enum value "offline"
	AggregateStateOffline string = "offline"

	// AggregateStateOfflining captures enum value "offlining"
	AggregateStateOfflining string = "offlining"

	// AggregateStateRelocating captures enum value "relocating"
	AggregateStateRelocating string = "relocating"

	// AggregateStateUnmounted captures enum value "unmounted"
	AggregateStateUnmounted string = "unmounted"

	// AggregateStateRestricted captures enum value "restricted"
	AggregateStateRestricted string = "restricted"

	// AggregateStateInconsistent captures enum value "inconsistent"
	AggregateStateInconsistent string = "inconsistent"

	// AggregateStateFailed captures enum value "failed"
	AggregateStateFailed string = "failed"

	// AggregateStateUnknown captures enum value "unknown"
	AggregateStateUnknown string = "unknown"
)

// prop value enum
func (m *Aggregate) validateStateEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, aggregateTypeStatePropEnum); err != nil {
		return err
	}
	return nil
}

func (m *Aggregate) validateState(formats strfmt.Registry) error {

	if swag.IsZero(m.State) { // not required
		return nil
	}

	// value enum
	if err := m.validateStateEnum("state", "body", m.State); err != nil {
		return err
	}

	return nil
}

func (m *Aggregate) validateStatistics(formats strfmt.Registry) error {

	if swag.IsZero(m.Statistics) { // not required
		return nil
	}

	if m.Statistics != nil {
		if err := m.Statistics.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("statistics")
			}
			return err
		}
	}

	return nil
}

func (m *Aggregate) validateUUID(formats strfmt.Registry) error {

	if swag.IsZero(m.UUID) { // not required
		return nil
	}

	if err := validate.FormatOf("uuid", "body", "uuid", m.UUID.String(), formats); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *Aggregate) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *Aggregate) UnmarshalBinary(b []byte) error {
	var res Aggregate
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// AggregateBlockStorage Configuration information for the locally attached portion of the aggregate. When a cloud store is also used by this aggregate, this is referred to as the performance tier.
// swagger:model AggregateBlockStorage
type AggregateBlockStorage struct {

	// hybrid cache
	HybridCache *AggregateBlockStorageHybridCache `json:"hybrid_cache,omitempty"`

	// mirror
	Mirror *AggregateBlockStorageMirror `json:"mirror,omitempty"`

	// Plex reference for each plex in the aggregate.
	// Read Only: true
	Plexes []*PlexReference `json:"plexes"`

	// primary
	Primary *AggregateBlockStoragePrimary `json:"primary,omitempty"`
}

// Validate validates this aggregate block storage
func (m *AggregateBlockStorage) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateHybridCache(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateMirror(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validatePlexes(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validatePrimary(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *AggregateBlockStorage) validateHybridCache(formats strfmt.Registry) error {

	if swag.IsZero(m.HybridCache) { // not required
		return nil
	}

	if m.HybridCache != nil {
		if err := m.HybridCache.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("block_storage" + "." + "hybrid_cache")
			}
			return err
		}
	}

	return nil
}

func (m *AggregateBlockStorage) validateMirror(formats strfmt.Registry) error {

	if swag.IsZero(m.Mirror) { // not required
		return nil
	}

	if m.Mirror != nil {
		if err := m.Mirror.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("block_storage" + "." + "mirror")
			}
			return err
		}
	}

	return nil
}

func (m *AggregateBlockStorage) validatePlexes(formats strfmt.Registry) error {

	if swag.IsZero(m.Plexes) { // not required
		return nil
	}

	for i := 0; i < len(m.Plexes); i++ {
		if swag.IsZero(m.Plexes[i]) { // not required
			continue
		}

		if m.Plexes[i] != nil {
			if err := m.Plexes[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("block_storage" + "." + "plexes" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *AggregateBlockStorage) validatePrimary(formats strfmt.Registry) error {

	if swag.IsZero(m.Primary) { // not required
		return nil
	}

	if m.Primary != nil {
		if err := m.Primary.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("block_storage" + "." + "primary")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *AggregateBlockStorage) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *AggregateBlockStorage) UnmarshalBinary(b []byte) error {
	var res AggregateBlockStorage
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// AggregateBlockStorageHybridCache Contains the configuration for the hybrid cache. The hybrid cache is made up of either whole SSDs or storage pool SSDs.
// swagger:model AggregateBlockStorageHybridCache
type AggregateBlockStorageHybridCache struct {

	// Number of disks used in the cache tier of the aggregate. Only provided when hybrid_cache.enabled is 'true'.
	// Read Only: true
	DiskCount int64 `json:"disk_count,omitempty"`

	// Aggregate uses HDDs with SSDs as a cache
	// Read Only: true
	Enabled *bool `json:"enabled,omitempty"`

	// RAID type for SSD cache of the aggregate. Only provided when hybrid_cache.enabled is 'true'.
	// Read Only: true
	// Enum: [raid_dp raid_tec raid4]
	RaidType string `json:"raid_type,omitempty"`

	// Total usable space in bytes of SSD cache. Only provided when hybrid_cache.enabled is 'true'.
	// Read Only: true
	Size int64 `json:"size,omitempty"`

	// Space used in bytes of SSD cache. Only provided when hybrid_cache.enabled is 'true'.
	// Read Only: true
	Used int64 `json:"used,omitempty"`
}

// Validate validates this aggregate block storage hybrid cache
func (m *AggregateBlockStorageHybridCache) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateRaidType(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var aggregateBlockStorageHybridCacheTypeRaidTypePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["raid_dp","raid_tec","raid4"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		aggregateBlockStorageHybridCacheTypeRaidTypePropEnum = append(aggregateBlockStorageHybridCacheTypeRaidTypePropEnum, v)
	}
}

const (

	// AggregateBlockStorageHybridCacheRaidTypeRaidDp captures enum value "raid_dp"
	AggregateBlockStorageHybridCacheRaidTypeRaidDp string = "raid_dp"

	// AggregateBlockStorageHybridCacheRaidTypeRaidTec captures enum value "raid_tec"
	AggregateBlockStorageHybridCacheRaidTypeRaidTec string = "raid_tec"

	// AggregateBlockStorageHybridCacheRaidTypeRaid4 captures enum value "raid4"
	AggregateBlockStorageHybridCacheRaidTypeRaid4 string = "raid4"
)

// prop value enum
func (m *AggregateBlockStorageHybridCache) validateRaidTypeEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, aggregateBlockStorageHybridCacheTypeRaidTypePropEnum); err != nil {
		return err
	}
	return nil
}

func (m *AggregateBlockStorageHybridCache) validateRaidType(formats strfmt.Registry) error {

	if swag.IsZero(m.RaidType) { // not required
		return nil
	}

	// value enum
	if err := m.validateRaidTypeEnum("block_storage"+"."+"hybrid_cache"+"."+"raid_type", "body", m.RaidType); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *AggregateBlockStorageHybridCache) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *AggregateBlockStorageHybridCache) UnmarshalBinary(b []byte) error {
	var res AggregateBlockStorageHybridCache
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// AggregateBlockStorageMirror aggregate block storage mirror
// swagger:model AggregateBlockStorageMirror
type AggregateBlockStorageMirror struct {

	// Aggregate is SyncMirror protected
	Enabled bool `json:"enabled,omitempty"`

	// state
	// Read Only: true
	// Enum: [unmirrored normal degraded resynchronizing failed]
	State string `json:"state,omitempty"`
}

// Validate validates this aggregate block storage mirror
func (m *AggregateBlockStorageMirror) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateState(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var aggregateBlockStorageMirrorTypeStatePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["unmirrored","normal","degraded","resynchronizing","failed"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		aggregateBlockStorageMirrorTypeStatePropEnum = append(aggregateBlockStorageMirrorTypeStatePropEnum, v)
	}
}

const (

	// AggregateBlockStorageMirrorStateUnmirrored captures enum value "unmirrored"
	AggregateBlockStorageMirrorStateUnmirrored string = "unmirrored"

	// AggregateBlockStorageMirrorStateNormal captures enum value "normal"
	AggregateBlockStorageMirrorStateNormal string = "normal"

	// AggregateBlockStorageMirrorStateDegraded captures enum value "degraded"
	AggregateBlockStorageMirrorStateDegraded string = "degraded"

	// AggregateBlockStorageMirrorStateResynchronizing captures enum value "resynchronizing"
	AggregateBlockStorageMirrorStateResynchronizing string = "resynchronizing"

	// AggregateBlockStorageMirrorStateFailed captures enum value "failed"
	AggregateBlockStorageMirrorStateFailed string = "failed"
)

// prop value enum
func (m *AggregateBlockStorageMirror) validateStateEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, aggregateBlockStorageMirrorTypeStatePropEnum); err != nil {
		return err
	}
	return nil
}

func (m *AggregateBlockStorageMirror) validateState(formats strfmt.Registry) error {

	if swag.IsZero(m.State) { // not required
		return nil
	}

	// value enum
	if err := m.validateStateEnum("block_storage"+"."+"mirror"+"."+"state", "body", m.State); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *AggregateBlockStorageMirror) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *AggregateBlockStorageMirror) UnmarshalBinary(b []byte) error {
	var res AggregateBlockStorageMirror
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// AggregateBlockStoragePrimary Configuration information for the primary storage portion of the aggregate. This excludes the hybrid cache details.
// swagger:model AggregateBlockStoragePrimary
type AggregateBlockStoragePrimary struct {

	// The checksum style used by the aggregate.
	// Enum: [block advanced_zoned mixed]
	ChecksumStyle string `json:"checksum_style,omitempty"`

	// The class of disks being used by the aggregate.
	// Enum: [capacity performance archive solid_state array virtual data_center capacity_flash]
	DiskClass string `json:"disk_class,omitempty"`

	// Number of disks used in the aggregate. This includes parity disks, but excludes disks in the hybrid cache.
	DiskCount int64 `json:"disk_count,omitempty"`

	// The type of disk being used by the aggregate.
	// Read Only: true
	// Enum: [fc lun nl_sas nvme_ssd sas sata scsi ssd vm_disk]
	DiskType string `json:"disk_type,omitempty"`

	// Option to specify the maximum number of disks that can be included in a RAID group.
	RaidSize int64 `json:"raid_size,omitempty"`

	// RAID type of the aggregate.
	// Enum: [raid_dp raid_tec raid0 raid4]
	RaidType string `json:"raid_type,omitempty"`
}

// Validate validates this aggregate block storage primary
func (m *AggregateBlockStoragePrimary) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateChecksumStyle(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateDiskClass(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateDiskType(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateRaidType(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var aggregateBlockStoragePrimaryTypeChecksumStylePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["block","advanced_zoned","mixed"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		aggregateBlockStoragePrimaryTypeChecksumStylePropEnum = append(aggregateBlockStoragePrimaryTypeChecksumStylePropEnum, v)
	}
}

const (

	// AggregateBlockStoragePrimaryChecksumStyleBlock captures enum value "block"
	AggregateBlockStoragePrimaryChecksumStyleBlock string = "block"

	// AggregateBlockStoragePrimaryChecksumStyleAdvancedZoned captures enum value "advanced_zoned"
	AggregateBlockStoragePrimaryChecksumStyleAdvancedZoned string = "advanced_zoned"

	// AggregateBlockStoragePrimaryChecksumStyleMixed captures enum value "mixed"
	AggregateBlockStoragePrimaryChecksumStyleMixed string = "mixed"
)

// prop value enum
func (m *AggregateBlockStoragePrimary) validateChecksumStyleEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, aggregateBlockStoragePrimaryTypeChecksumStylePropEnum); err != nil {
		return err
	}
	return nil
}

func (m *AggregateBlockStoragePrimary) validateChecksumStyle(formats strfmt.Registry) error {

	if swag.IsZero(m.ChecksumStyle) { // not required
		return nil
	}

	// value enum
	if err := m.validateChecksumStyleEnum("block_storage"+"."+"primary"+"."+"checksum_style", "body", m.ChecksumStyle); err != nil {
		return err
	}

	return nil
}

var aggregateBlockStoragePrimaryTypeDiskClassPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["capacity","performance","archive","solid_state","array","virtual","data_center","capacity_flash"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		aggregateBlockStoragePrimaryTypeDiskClassPropEnum = append(aggregateBlockStoragePrimaryTypeDiskClassPropEnum, v)
	}
}

const (

	// AggregateBlockStoragePrimaryDiskClassCapacity captures enum value "capacity"
	AggregateBlockStoragePrimaryDiskClassCapacity string = "capacity"

	// AggregateBlockStoragePrimaryDiskClassPerformance captures enum value "performance"
	AggregateBlockStoragePrimaryDiskClassPerformance string = "performance"

	// AggregateBlockStoragePrimaryDiskClassArchive captures enum value "archive"
	AggregateBlockStoragePrimaryDiskClassArchive string = "archive"

	// AggregateBlockStoragePrimaryDiskClassSolidState captures enum value "solid_state"
	AggregateBlockStoragePrimaryDiskClassSolidState string = "solid_state"

	// AggregateBlockStoragePrimaryDiskClassArray captures enum value "array"
	AggregateBlockStoragePrimaryDiskClassArray string = "array"

	// AggregateBlockStoragePrimaryDiskClassVirtual captures enum value "virtual"
	AggregateBlockStoragePrimaryDiskClassVirtual string = "virtual"

	// AggregateBlockStoragePrimaryDiskClassDataCenter captures enum value "data_center"
	AggregateBlockStoragePrimaryDiskClassDataCenter string = "data_center"

	// AggregateBlockStoragePrimaryDiskClassCapacityFlash captures enum value "capacity_flash"
	AggregateBlockStoragePrimaryDiskClassCapacityFlash string = "capacity_flash"
)

// prop value enum
func (m *AggregateBlockStoragePrimary) validateDiskClassEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, aggregateBlockStoragePrimaryTypeDiskClassPropEnum); err != nil {
		return err
	}
	return nil
}

func (m *AggregateBlockStoragePrimary) validateDiskClass(formats strfmt.Registry) error {

	if swag.IsZero(m.DiskClass) { // not required
		return nil
	}

	// value enum
	if err := m.validateDiskClassEnum("block_storage"+"."+"primary"+"."+"disk_class", "body", m.DiskClass); err != nil {
		return err
	}

	return nil
}

var aggregateBlockStoragePrimaryTypeDiskTypePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["fc","lun","nl_sas","nvme_ssd","sas","sata","scsi","ssd","vm_disk"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		aggregateBlockStoragePrimaryTypeDiskTypePropEnum = append(aggregateBlockStoragePrimaryTypeDiskTypePropEnum, v)
	}
}

const (

	// AggregateBlockStoragePrimaryDiskTypeFc captures enum value "fc"
	AggregateBlockStoragePrimaryDiskTypeFc string = "fc"

	// AggregateBlockStoragePrimaryDiskTypeLun captures enum value "lun"
	AggregateBlockStoragePrimaryDiskTypeLun string = "lun"

	// AggregateBlockStoragePrimaryDiskTypeNlSas captures enum value "nl_sas"
	AggregateBlockStoragePrimaryDiskTypeNlSas string = "nl_sas"

	// AggregateBlockStoragePrimaryDiskTypeNvmeSsd captures enum value "nvme_ssd"
	AggregateBlockStoragePrimaryDiskTypeNvmeSsd string = "nvme_ssd"

	// AggregateBlockStoragePrimaryDiskTypeSas captures enum value "sas"
	AggregateBlockStoragePrimaryDiskTypeSas string = "sas"

	// AggregateBlockStoragePrimaryDiskTypeSata captures enum value "sata"
	AggregateBlockStoragePrimaryDiskTypeSata string = "sata"

	// AggregateBlockStoragePrimaryDiskTypeScsi captures enum value "scsi"
	AggregateBlockStoragePrimaryDiskTypeScsi string = "scsi"

	// AggregateBlockStoragePrimaryDiskTypeSsd captures enum value "ssd"
	AggregateBlockStoragePrimaryDiskTypeSsd string = "ssd"

	// AggregateBlockStoragePrimaryDiskTypeVMDisk captures enum value "vm_disk"
	AggregateBlockStoragePrimaryDiskTypeVMDisk string = "vm_disk"
)

// prop value enum
func (m *AggregateBlockStoragePrimary) validateDiskTypeEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, aggregateBlockStoragePrimaryTypeDiskTypePropEnum); err != nil {
		return err
	}
	return nil
}

func (m *AggregateBlockStoragePrimary) validateDiskType(formats strfmt.Registry) error {

	if swag.IsZero(m.DiskType) { // not required
		return nil
	}

	// value enum
	if err := m.validateDiskTypeEnum("block_storage"+"."+"primary"+"."+"disk_type", "body", m.DiskType); err != nil {
		return err
	}

	return nil
}

var aggregateBlockStoragePrimaryTypeRaidTypePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["raid_dp","raid_tec","raid0","raid4"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		aggregateBlockStoragePrimaryTypeRaidTypePropEnum = append(aggregateBlockStoragePrimaryTypeRaidTypePropEnum, v)
	}
}

const (

	// AggregateBlockStoragePrimaryRaidTypeRaidDp captures enum value "raid_dp"
	AggregateBlockStoragePrimaryRaidTypeRaidDp string = "raid_dp"

	// AggregateBlockStoragePrimaryRaidTypeRaidTec captures enum value "raid_tec"
	AggregateBlockStoragePrimaryRaidTypeRaidTec string = "raid_tec"

	// AggregateBlockStoragePrimaryRaidTypeRaid0 captures enum value "raid0"
	AggregateBlockStoragePrimaryRaidTypeRaid0 string = "raid0"

	// AggregateBlockStoragePrimaryRaidTypeRaid4 captures enum value "raid4"
	AggregateBlockStoragePrimaryRaidTypeRaid4 string = "raid4"
)

// prop value enum
func (m *AggregateBlockStoragePrimary) validateRaidTypeEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, aggregateBlockStoragePrimaryTypeRaidTypePropEnum); err != nil {
		return err
	}
	return nil
}

func (m *AggregateBlockStoragePrimary) validateRaidType(formats strfmt.Registry) error {

	if swag.IsZero(m.RaidType) { // not required
		return nil
	}

	// value enum
	if err := m.validateRaidTypeEnum("block_storage"+"."+"primary"+"."+"raid_type", "body", m.RaidType); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *AggregateBlockStoragePrimary) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *AggregateBlockStoragePrimary) UnmarshalBinary(b []byte) error {
	var res AggregateBlockStoragePrimary
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// AggregateCloudStorage Configuration information for the cloud storage portion of the aggregate. This is referred to as the capacity tier.
// swagger:model AggregateCloudStorage
type AggregateCloudStorage struct {

	// Aggregate is eligible for a cloud store to be attached.
	// Read Only: true
	AttachEligible *bool `json:"attach_eligible,omitempty"`

	// Configuration information for each cloud storage portion of the aggregate.
	// Read Only: true
	Stores []*CloudStorageTier `json:"stores"`

	// The percentage of space in the performance tier that must be used before data is tiered out to the cloud store. Only valid for PATCH operations.
	TieringFullnessThreshold int64 `json:"tiering_fullness_threshold,omitempty"`
}

// Validate validates this aggregate cloud storage
func (m *AggregateCloudStorage) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateStores(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *AggregateCloudStorage) validateStores(formats strfmt.Registry) error {

	if swag.IsZero(m.Stores) { // not required
		return nil
	}

	for i := 0; i < len(m.Stores); i++ {
		if swag.IsZero(m.Stores[i]) { // not required
			continue
		}

		if m.Stores[i] != nil {
			if err := m.Stores[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("cloud_storage" + "." + "stores" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// MarshalBinary interface implementation
func (m *AggregateCloudStorage) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *AggregateCloudStorage) UnmarshalBinary(b []byte) error {
	var res AggregateCloudStorage
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// AggregateDataEncryption aggregate data encryption
// swagger:model AggregateDataEncryption
type AggregateDataEncryption struct {

	// Aggregate uses self-encrypting drives with data protection enabled.
	// Read Only: true
	DriveProtectionEnabled *bool `json:"drive_protection_enabled,omitempty"`

	// NetApp Aggregate Encryption enabled. All data in the aggregate is encrypted.
	// Read Only: true
	SoftwareEncryptionEnabled *bool `json:"software_encryption_enabled,omitempty"`
}

// Validate validates this aggregate data encryption
func (m *AggregateDataEncryption) Validate(formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *AggregateDataEncryption) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *AggregateDataEncryption) UnmarshalBinary(b []byte) error {
	var res AggregateDataEncryption
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// AggregateLinks aggregate links
// swagger:model AggregateLinks
type AggregateLinks struct {

	// self
	Self *Href `json:"self,omitempty"`
}

// Validate validates this aggregate links
func (m *AggregateLinks) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateSelf(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *AggregateLinks) validateSelf(formats strfmt.Registry) error {

	if swag.IsZero(m.Self) { // not required
		return nil
	}

	if m.Self != nil {
		if err := m.Self.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("_links" + "." + "self")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *AggregateLinks) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *AggregateLinks) UnmarshalBinary(b []byte) error {
	var res AggregateLinks
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// AggregateSpace aggregate space
// swagger:model AggregateSpace
type AggregateSpace struct {

	// block storage
	BlockStorage *AggregateSpaceBlockStorage `json:"block_storage,omitempty"`

	// cloud storage
	CloudStorage *AggregateSpaceCloudStorage `json:"cloud_storage,omitempty"`

	// efficiency
	Efficiency *SpaceEfficiency `json:"efficiency,omitempty"`

	// efficiency without snapshots
	EfficiencyWithoutSnapshots *SpaceEfficiency `json:"efficiency_without_snapshots,omitempty"`

	// A summation of volume footprints (including volume guarantees), in bytes. This includes all of the volume footprints in the block_storage tier and the cloud_storage tier.
	// This is an advanced property; there is an added cost to retrieving its value. The field is not populated for either a collection GET or an instance GET unless it is explicitly requested using the <i>fields</i> query parameter containing either footprint or **.
	//
	// Read Only: true
	Footprint int64 `json:"footprint,omitempty"`
}

// Validate validates this aggregate space
func (m *AggregateSpace) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateBlockStorage(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateCloudStorage(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateEfficiency(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateEfficiencyWithoutSnapshots(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *AggregateSpace) validateBlockStorage(formats strfmt.Registry) error {

	if swag.IsZero(m.BlockStorage) { // not required
		return nil
	}

	if m.BlockStorage != nil {
		if err := m.BlockStorage.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("space" + "." + "block_storage")
			}
			return err
		}
	}

	return nil
}

func (m *AggregateSpace) validateCloudStorage(formats strfmt.Registry) error {

	if swag.IsZero(m.CloudStorage) { // not required
		return nil
	}

	if m.CloudStorage != nil {
		if err := m.CloudStorage.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("space" + "." + "cloud_storage")
			}
			return err
		}
	}

	return nil
}

func (m *AggregateSpace) validateEfficiency(formats strfmt.Registry) error {

	if swag.IsZero(m.Efficiency) { // not required
		return nil
	}

	if m.Efficiency != nil {
		if err := m.Efficiency.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("space" + "." + "efficiency")
			}
			return err
		}
	}

	return nil
}

func (m *AggregateSpace) validateEfficiencyWithoutSnapshots(formats strfmt.Registry) error {

	if swag.IsZero(m.EfficiencyWithoutSnapshots) { // not required
		return nil
	}

	if m.EfficiencyWithoutSnapshots != nil {
		if err := m.EfficiencyWithoutSnapshots.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("space" + "." + "efficiency_without_snapshots")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *AggregateSpace) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *AggregateSpace) UnmarshalBinary(b []byte) error {
	var res AggregateSpace
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// AggregateSpaceBlockStorage aggregate space block storage
// swagger:model AggregateSpaceBlockStorage
type AggregateSpaceBlockStorage struct {

	// Space available in bytes
	// Read Only: true
	Available int64 `json:"available"`

	// The aggregate used percentage at which 'monitor.volume.full' EMS is generated.
	// Read Only: true
	FullThresholdPercent int64 `json:"full_threshold_percent,omitempty"`

	// The size that is physically used in the block storage and has a cold temperature, in bytes. This property is only supported if the aggregate is either attached to a cloud store or can be attached to a cloud store.
	// This is an advanced property; there is an added cost to retrieving its value. The field is not populated for either a collection GET or an instance GET unless it is explicitly requested using the <i>fields</i> query parameter containing either block_storage.inactive_user_data or **.
	//
	// Read Only: true
	InactiveUserData int64 `json:"inactive_user_data,omitempty"`

	// Total usable space in bytes, not including WAFL reserve and aggregate Snapshot copy reserve.
	// Read Only: true
	Size int64 `json:"size"`

	// Space used or reserved in bytes. Includes volume guarantees and aggregate metadata.
	// Read Only: true
	Used int64 `json:"used,omitempty"`
}

// Validate validates this aggregate space block storage
func (m *AggregateSpaceBlockStorage) Validate(formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *AggregateSpaceBlockStorage) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *AggregateSpaceBlockStorage) UnmarshalBinary(b []byte) error {
	var res AggregateSpaceBlockStorage
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// AggregateSpaceCloudStorage aggregate space cloud storage
// swagger:model AggregateSpaceCloudStorage
type AggregateSpaceCloudStorage struct {

	// Used space in bytes in the cloud store. Only applicable for aggregate with a cloud store tier.
	// Read Only: true
	Used int64 `json:"used,omitempty"`
}

// Validate validates this aggregate space cloud storage
func (m *AggregateSpaceCloudStorage) Validate(formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *AggregateSpaceCloudStorage) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *AggregateSpaceCloudStorage) UnmarshalBinary(b []byte) error {
	var res AggregateSpaceCloudStorage
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
