// Code generated by go-swagger; DO NOT EDIT.

package ntapmodel

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"strconv"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// AggregateSpare aggregate spare
// swagger:model aggregateSpare
type AggregateSpare struct {

	// The checksum type that has been assigned to the spares
	// Read Only: true
	// Enum: [block advanced_zoned]
	ChecksumStyle string `json:"checksum_style,omitempty"`

	// Disk class of spares
	// Read Only: true
	// Enum: [unknown capacity performance archive solid_state array virtual data_center capacity_flash]
	DiskClass string `json:"disk_class,omitempty"`

	// Available RAID protections and their restrictions
	LayoutRequirements []*LayoutRequirement `json:"layout_requirements"`

	// node
	Node *NodeReference `json:"node,omitempty"`

	// Usable size of each spare in bytes
	// Read Only: true
	Size int64 `json:"size,omitempty"`

	// SyncMirror spare pool
	// Read Only: true
	// Enum: [pool0 pool1]
	SyncmirrorPool string `json:"syncmirror_pool,omitempty"`

	// Total number of usable spares
	// Read Only: true
	Usable int64 `json:"usable,omitempty"`
}

// Validate validates this aggregate spare
func (m *AggregateSpare) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateChecksumStyle(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateDiskClass(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateLayoutRequirements(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateNode(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSyncmirrorPool(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var aggregateSpareTypeChecksumStylePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["block","advanced_zoned"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		aggregateSpareTypeChecksumStylePropEnum = append(aggregateSpareTypeChecksumStylePropEnum, v)
	}
}

const (

	// AggregateSpareChecksumStyleBlock captures enum value "block"
	AggregateSpareChecksumStyleBlock string = "block"

	// AggregateSpareChecksumStyleAdvancedZoned captures enum value "advanced_zoned"
	AggregateSpareChecksumStyleAdvancedZoned string = "advanced_zoned"
)

// prop value enum
func (m *AggregateSpare) validateChecksumStyleEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, aggregateSpareTypeChecksumStylePropEnum); err != nil {
		return err
	}
	return nil
}

func (m *AggregateSpare) validateChecksumStyle(formats strfmt.Registry) error {

	if swag.IsZero(m.ChecksumStyle) { // not required
		return nil
	}

	// value enum
	if err := m.validateChecksumStyleEnum("checksum_style", "body", m.ChecksumStyle); err != nil {
		return err
	}

	return nil
}

var aggregateSpareTypeDiskClassPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["unknown","capacity","performance","archive","solid_state","array","virtual","data_center","capacity_flash"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		aggregateSpareTypeDiskClassPropEnum = append(aggregateSpareTypeDiskClassPropEnum, v)
	}
}

const (

	// AggregateSpareDiskClassUnknown captures enum value "unknown"
	AggregateSpareDiskClassUnknown string = "unknown"

	// AggregateSpareDiskClassCapacity captures enum value "capacity"
	AggregateSpareDiskClassCapacity string = "capacity"

	// AggregateSpareDiskClassPerformance captures enum value "performance"
	AggregateSpareDiskClassPerformance string = "performance"

	// AggregateSpareDiskClassArchive captures enum value "archive"
	AggregateSpareDiskClassArchive string = "archive"

	// AggregateSpareDiskClassSolidState captures enum value "solid_state"
	AggregateSpareDiskClassSolidState string = "solid_state"

	// AggregateSpareDiskClassArray captures enum value "array"
	AggregateSpareDiskClassArray string = "array"

	// AggregateSpareDiskClassVirtual captures enum value "virtual"
	AggregateSpareDiskClassVirtual string = "virtual"

	// AggregateSpareDiskClassDataCenter captures enum value "data_center"
	AggregateSpareDiskClassDataCenter string = "data_center"

	// AggregateSpareDiskClassCapacityFlash captures enum value "capacity_flash"
	AggregateSpareDiskClassCapacityFlash string = "capacity_flash"
)

// prop value enum
func (m *AggregateSpare) validateDiskClassEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, aggregateSpareTypeDiskClassPropEnum); err != nil {
		return err
	}
	return nil
}

func (m *AggregateSpare) validateDiskClass(formats strfmt.Registry) error {

	if swag.IsZero(m.DiskClass) { // not required
		return nil
	}

	// value enum
	if err := m.validateDiskClassEnum("disk_class", "body", m.DiskClass); err != nil {
		return err
	}

	return nil
}

func (m *AggregateSpare) validateLayoutRequirements(formats strfmt.Registry) error {

	if swag.IsZero(m.LayoutRequirements) { // not required
		return nil
	}

	for i := 0; i < len(m.LayoutRequirements); i++ {
		if swag.IsZero(m.LayoutRequirements[i]) { // not required
			continue
		}

		if m.LayoutRequirements[i] != nil {
			if err := m.LayoutRequirements[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("layout_requirements" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *AggregateSpare) validateNode(formats strfmt.Registry) error {

	if swag.IsZero(m.Node) { // not required
		return nil
	}

	if m.Node != nil {
		if err := m.Node.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("node")
			}
			return err
		}
	}

	return nil
}

var aggregateSpareTypeSyncmirrorPoolPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["pool0","pool1"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		aggregateSpareTypeSyncmirrorPoolPropEnum = append(aggregateSpareTypeSyncmirrorPoolPropEnum, v)
	}
}

const (

	// AggregateSpareSyncmirrorPoolPool0 captures enum value "pool0"
	AggregateSpareSyncmirrorPoolPool0 string = "pool0"

	// AggregateSpareSyncmirrorPoolPool1 captures enum value "pool1"
	AggregateSpareSyncmirrorPoolPool1 string = "pool1"
)

// prop value enum
func (m *AggregateSpare) validateSyncmirrorPoolEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, aggregateSpareTypeSyncmirrorPoolPropEnum); err != nil {
		return err
	}
	return nil
}

func (m *AggregateSpare) validateSyncmirrorPool(formats strfmt.Registry) error {

	if swag.IsZero(m.SyncmirrorPool) { // not required
		return nil
	}

	// value enum
	if err := m.validateSyncmirrorPoolEnum("syncmirror_pool", "body", m.SyncmirrorPool); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *AggregateSpare) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *AggregateSpare) UnmarshalBinary(b []byte) error {
	var res AggregateSpare
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
