// Code generated by go-swagger; DO NOT EDIT.

package ntapmodel

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// LayoutRequirement layout requirement
// swagger:model layoutRequirement
type LayoutRequirement struct {

	// Minimum number of disks to create an aggregate
	// Read Only: true
	AggregateMinDisks int64 `json:"aggregate_min_disks,omitempty"`

	// Indicates if this RAID type is the default
	// Read Only: true
	Default *bool `json:"default,omitempty"`

	// raid group
	RaidGroup *LayoutRequirementRaidGroup `json:"raid_group,omitempty"`

	// RAID type
	// Read Only: true
	// Enum: [raid_dp raid_tec raid4 raid0]
	RaidType string `json:"raid_type,omitempty"`
}

// Validate validates this layout requirement
func (m *LayoutRequirement) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateRaidGroup(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateRaidType(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *LayoutRequirement) validateRaidGroup(formats strfmt.Registry) error {

	if swag.IsZero(m.RaidGroup) { // not required
		return nil
	}

	if m.RaidGroup != nil {
		if err := m.RaidGroup.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("raid_group")
			}
			return err
		}
	}

	return nil
}

var layoutRequirementTypeRaidTypePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["raid_dp","raid_tec","raid4","raid0"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		layoutRequirementTypeRaidTypePropEnum = append(layoutRequirementTypeRaidTypePropEnum, v)
	}
}

const (

	// LayoutRequirementRaidTypeRaidDp captures enum value "raid_dp"
	LayoutRequirementRaidTypeRaidDp string = "raid_dp"

	// LayoutRequirementRaidTypeRaidTec captures enum value "raid_tec"
	LayoutRequirementRaidTypeRaidTec string = "raid_tec"

	// LayoutRequirementRaidTypeRaid4 captures enum value "raid4"
	LayoutRequirementRaidTypeRaid4 string = "raid4"

	// LayoutRequirementRaidTypeRaid0 captures enum value "raid0"
	LayoutRequirementRaidTypeRaid0 string = "raid0"
)

// prop value enum
func (m *LayoutRequirement) validateRaidTypeEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, layoutRequirementTypeRaidTypePropEnum); err != nil {
		return err
	}
	return nil
}

func (m *LayoutRequirement) validateRaidType(formats strfmt.Registry) error {

	if swag.IsZero(m.RaidType) { // not required
		return nil
	}

	// value enum
	if err := m.validateRaidTypeEnum("raid_type", "body", m.RaidType); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *LayoutRequirement) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *LayoutRequirement) UnmarshalBinary(b []byte) error {
	var res LayoutRequirement
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// LayoutRequirementRaidGroup layout requirement raid group
// swagger:model LayoutRequirementRaidGroup
type LayoutRequirementRaidGroup struct {

	// Default number of disks in a RAID group
	// Read Only: true
	Default int64 `json:"default,omitempty"`

	// Maximum number of disks allowed in a RAID group
	// Read Only: true
	Max int64 `json:"max,omitempty"`

	// Minimum number of disks allowed in a RAID group
	// Read Only: true
	Min int64 `json:"min,omitempty"`
}

// Validate validates this layout requirement raid group
func (m *LayoutRequirementRaidGroup) Validate(formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *LayoutRequirementRaidGroup) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *LayoutRequirementRaidGroup) UnmarshalBinary(b []byte) error {
	var res LayoutRequirementRaidGroup
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
