// Code generated by go-swagger; DO NOT EDIT.

package ntapmodel

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// PerformanceMetric Performance numbers, such as IOPS latency and throughput.
// swagger:model performanceMetric
type PerformanceMetric struct {

	// links
	Links *PerformanceMetricLinks `json:"_links,omitempty"`

	// The duration over which this sample is calculated. The time durations are represented in the ISO-8601 standard format. Samples can be calculated over the following durations:
	//
	// Read Only: true
	// Enum: [PT15S PT4M PT30M PT2H P1D PT5M]
	Duration string `json:"duration,omitempty"`

	// iops
	Iops *PerformanceMetricIops `json:"iops,omitempty"`

	// latency
	Latency *PerformanceMetricLatency `json:"latency,omitempty"`

	// Errors associated with the sample. For example, if the aggregation of data over multiple nodes fails, then any partial errors might return "ok" on success or "error" on an internal uncategorized failure. Whenever a sample collection is missed but done at a later time, it is back filled to the previous 15 second timestamp and tagged with "backfilled_data". "Inconsistent_ delta_time" is encountered when the time between two collections is not the same for all nodes. Therefore, the aggregated value might be over or under inflated. "Negative_delta" is returned when an expected monotonically increasing value has decreased in value. "Inconsistent_old_data" is returned when one or more nodes do not have the latest data.
	// Read Only: true
	// Enum: [ok error partial_no_data partial_no_uuid partial_no_response partial_other_error negative_delta backfilled_data inconsistent_delta_time inconsistent_old_data]
	Status string `json:"status,omitempty"`

	// throughput
	Throughput *PerformanceMetricThroughput `json:"throughput,omitempty"`

	// The timestamp of the performance data.
	// Read Only: true
	// Format: date-time
	Timestamp *strfmt.DateTime `json:"timestamp,omitempty"`
}

// Validate validates this performance metric
func (m *PerformanceMetric) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLinks(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateDuration(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateIops(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateLatency(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateStatus(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateThroughput(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateTimestamp(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *PerformanceMetric) validateLinks(formats strfmt.Registry) error {

	if swag.IsZero(m.Links) { // not required
		return nil
	}

	if m.Links != nil {
		if err := m.Links.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("_links")
			}
			return err
		}
	}

	return nil
}

var performanceMetricTypeDurationPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["PT15S","PT4M","PT30M","PT2H","P1D","PT5M"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		performanceMetricTypeDurationPropEnum = append(performanceMetricTypeDurationPropEnum, v)
	}
}

const (

	// PerformanceMetricDurationPT15S captures enum value "PT15S"
	PerformanceMetricDurationPT15S string = "PT15S"

	// PerformanceMetricDurationPT4M captures enum value "PT4M"
	PerformanceMetricDurationPT4M string = "PT4M"

	// PerformanceMetricDurationPT30M captures enum value "PT30M"
	PerformanceMetricDurationPT30M string = "PT30M"

	// PerformanceMetricDurationPT2H captures enum value "PT2H"
	PerformanceMetricDurationPT2H string = "PT2H"

	// PerformanceMetricDurationP1D captures enum value "P1D"
	PerformanceMetricDurationP1D string = "P1D"

	// PerformanceMetricDurationPT5M captures enum value "PT5M"
	PerformanceMetricDurationPT5M string = "PT5M"
)

// prop value enum
func (m *PerformanceMetric) validateDurationEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, performanceMetricTypeDurationPropEnum); err != nil {
		return err
	}
	return nil
}

func (m *PerformanceMetric) validateDuration(formats strfmt.Registry) error {

	if swag.IsZero(m.Duration) { // not required
		return nil
	}

	// value enum
	if err := m.validateDurationEnum("duration", "body", m.Duration); err != nil {
		return err
	}

	return nil
}

func (m *PerformanceMetric) validateIops(formats strfmt.Registry) error {

	if swag.IsZero(m.Iops) { // not required
		return nil
	}

	if m.Iops != nil {
		if err := m.Iops.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("iops")
			}
			return err
		}
	}

	return nil
}

func (m *PerformanceMetric) validateLatency(formats strfmt.Registry) error {

	if swag.IsZero(m.Latency) { // not required
		return nil
	}

	if m.Latency != nil {
		if err := m.Latency.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("latency")
			}
			return err
		}
	}

	return nil
}

var performanceMetricTypeStatusPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["ok","error","partial_no_data","partial_no_uuid","partial_no_response","partial_other_error","negative_delta","backfilled_data","inconsistent_delta_time","inconsistent_old_data"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		performanceMetricTypeStatusPropEnum = append(performanceMetricTypeStatusPropEnum, v)
	}
}

const (

	// PerformanceMetricStatusOk captures enum value "ok"
	PerformanceMetricStatusOk string = "ok"

	// PerformanceMetricStatusError captures enum value "error"
	PerformanceMetricStatusError string = "error"

	// PerformanceMetricStatusPartialNoData captures enum value "partial_no_data"
	PerformanceMetricStatusPartialNoData string = "partial_no_data"

	// PerformanceMetricStatusPartialNoUUID captures enum value "partial_no_uuid"
	PerformanceMetricStatusPartialNoUUID string = "partial_no_uuid"

	// PerformanceMetricStatusPartialNoResponse captures enum value "partial_no_response"
	PerformanceMetricStatusPartialNoResponse string = "partial_no_response"

	// PerformanceMetricStatusPartialOtherError captures enum value "partial_other_error"
	PerformanceMetricStatusPartialOtherError string = "partial_other_error"

	// PerformanceMetricStatusNegativeDelta captures enum value "negative_delta"
	PerformanceMetricStatusNegativeDelta string = "negative_delta"

	// PerformanceMetricStatusBackfilledData captures enum value "backfilled_data"
	PerformanceMetricStatusBackfilledData string = "backfilled_data"

	// PerformanceMetricStatusInconsistentDeltaTime captures enum value "inconsistent_delta_time"
	PerformanceMetricStatusInconsistentDeltaTime string = "inconsistent_delta_time"

	// PerformanceMetricStatusInconsistentOldData captures enum value "inconsistent_old_data"
	PerformanceMetricStatusInconsistentOldData string = "inconsistent_old_data"
)

// prop value enum
func (m *PerformanceMetric) validateStatusEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, performanceMetricTypeStatusPropEnum); err != nil {
		return err
	}
	return nil
}

func (m *PerformanceMetric) validateStatus(formats strfmt.Registry) error {

	if swag.IsZero(m.Status) { // not required
		return nil
	}

	// value enum
	if err := m.validateStatusEnum("status", "body", m.Status); err != nil {
		return err
	}

	return nil
}

func (m *PerformanceMetric) validateThroughput(formats strfmt.Registry) error {

	if swag.IsZero(m.Throughput) { // not required
		return nil
	}

	if m.Throughput != nil {
		if err := m.Throughput.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("throughput")
			}
			return err
		}
	}

	return nil
}

func (m *PerformanceMetric) validateTimestamp(formats strfmt.Registry) error {

	if swag.IsZero(m.Timestamp) { // not required
		return nil
	}

	if err := validate.FormatOf("timestamp", "body", "date-time", m.Timestamp.String(), formats); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *PerformanceMetric) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *PerformanceMetric) UnmarshalBinary(b []byte) error {
	var res PerformanceMetric
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// PerformanceMetricIops The rate of I/O operations observed at the storage object.
// swagger:model PerformanceMetricIops
type PerformanceMetricIops struct {

	// Performance metric for other I/O operations. Other I/O operations can be metadata operations, such as directory lookups and so on.
	Other int64 `json:"other,omitempty"`

	// Performance metric for read I/O operations.
	Read int64 `json:"read,omitempty"`

	// Performance metric aggregated over all types of I/O operations.
	Total int64 `json:"total,omitempty"`

	// Peformance metric for write I/O operations.
	Write int64 `json:"write,omitempty"`
}

// Validate validates this performance metric iops
func (m *PerformanceMetricIops) Validate(formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *PerformanceMetricIops) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *PerformanceMetricIops) UnmarshalBinary(b []byte) error {
	var res PerformanceMetricIops
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// PerformanceMetricLatency The round trip latency in microseconds observed at the storage object.
// swagger:model PerformanceMetricLatency
type PerformanceMetricLatency struct {

	// Performance metric for other I/O operations. Other I/O operations can be metadata operations, such as directory lookups and so on.
	Other int64 `json:"other,omitempty"`

	// Performance metric for read I/O operations.
	Read int64 `json:"read,omitempty"`

	// Performance metric aggregated over all types of I/O operations.
	Total int64 `json:"total,omitempty"`

	// Peformance metric for write I/O operations.
	Write int64 `json:"write,omitempty"`
}

// Validate validates this performance metric latency
func (m *PerformanceMetricLatency) Validate(formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *PerformanceMetricLatency) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *PerformanceMetricLatency) UnmarshalBinary(b []byte) error {
	var res PerformanceMetricLatency
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// PerformanceMetricLinks performance metric links
// swagger:model PerformanceMetricLinks
type PerformanceMetricLinks struct {

	// self
	Self *Href `json:"self,omitempty"`
}

// Validate validates this performance metric links
func (m *PerformanceMetricLinks) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateSelf(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *PerformanceMetricLinks) validateSelf(formats strfmt.Registry) error {

	if swag.IsZero(m.Self) { // not required
		return nil
	}

	if m.Self != nil {
		if err := m.Self.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("_links" + "." + "self")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *PerformanceMetricLinks) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *PerformanceMetricLinks) UnmarshalBinary(b []byte) error {
	var res PerformanceMetricLinks
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// PerformanceMetricThroughput The rate of throughput bytes per second observed at the storage object.
// swagger:model PerformanceMetricThroughput
type PerformanceMetricThroughput struct {

	// Performance metric for other I/O operations. Other I/O operations can be metadata operations, such as directory lookups and so on.
	Other int64 `json:"other,omitempty"`

	// Performance metric for read I/O operations.
	Read int64 `json:"read,omitempty"`

	// Performance metric aggregated over all types of I/O operations.
	Total int64 `json:"total,omitempty"`

	// Peformance metric for write I/O operations.
	Write int64 `json:"write,omitempty"`
}

// Validate validates this performance metric throughput
func (m *PerformanceMetricThroughput) Validate(formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *PerformanceMetricThroughput) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *PerformanceMetricThroughput) UnmarshalBinary(b []byte) error {
	var res PerformanceMetricThroughput
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
