// Code generated by go-swagger; DO NOT EDIT.

package ntapmodel

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"strconv"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// Port port
// swagger:model port
type Port struct {

	// links
	Links *PortLinks `json:"_links,omitempty"`

	// broadcast domain
	BroadcastDomain *BroadcastDomainReference `json:"broadcast_domain,omitempty"`

	// enabled
	Enabled bool `json:"enabled,omitempty"`

	// lag
	Lag *PortLag `json:"lag,omitempty"`

	// mac address
	// Read Only: true
	MacAddress string `json:"mac_address,omitempty"`

	// MTU of the port in bytes. Set by broadcast domain.
	// Read Only: true
	// Minimum: 68
	Mtu int64 `json:"mtu,omitempty"`

	// Portname, such as e0a, e1b-100 (VLAN on ethernet), a0c (LAG/ifgrp), a0d-200 (vlan on LAG/ifgrp)
	// Read Only: true
	Name string `json:"name,omitempty"`

	// node
	Node *NodeReference `json:"node,omitempty"`

	// Link speed in Mbps
	// Read Only: true
	Speed int64 `json:"speed,omitempty"`

	// Operational state of the port.
	// Read Only: true
	// Enum: [up down]
	State string `json:"state,omitempty"`

	// Type of physical or virtual port
	// Enum: [vlan physical lag]
	Type string `json:"type,omitempty"`

	// Port UUID
	// Read Only: true
	// Format: uuid
	UUID strfmt.UUID `json:"uuid,omitempty"`

	// vlan
	Vlan *PortVlan `json:"vlan,omitempty"`
}

// Validate validates this port
func (m *Port) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLinks(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateBroadcastDomain(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateLag(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateMtu(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateNode(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateState(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateType(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateUUID(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateVlan(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *Port) validateLinks(formats strfmt.Registry) error {

	if swag.IsZero(m.Links) { // not required
		return nil
	}

	if m.Links != nil {
		if err := m.Links.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("_links")
			}
			return err
		}
	}

	return nil
}

func (m *Port) validateBroadcastDomain(formats strfmt.Registry) error {

	if swag.IsZero(m.BroadcastDomain) { // not required
		return nil
	}

	if m.BroadcastDomain != nil {
		if err := m.BroadcastDomain.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("broadcast_domain")
			}
			return err
		}
	}

	return nil
}

func (m *Port) validateLag(formats strfmt.Registry) error {

	if swag.IsZero(m.Lag) { // not required
		return nil
	}

	if m.Lag != nil {
		if err := m.Lag.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("lag")
			}
			return err
		}
	}

	return nil
}

func (m *Port) validateMtu(formats strfmt.Registry) error {

	if swag.IsZero(m.Mtu) { // not required
		return nil
	}

	if err := validate.MinimumInt("mtu", "body", int64(m.Mtu), 68, false); err != nil {
		return err
	}

	return nil
}

func (m *Port) validateNode(formats strfmt.Registry) error {

	if swag.IsZero(m.Node) { // not required
		return nil
	}

	if m.Node != nil {
		if err := m.Node.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("node")
			}
			return err
		}
	}

	return nil
}

var portTypeStatePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["up","down"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		portTypeStatePropEnum = append(portTypeStatePropEnum, v)
	}
}

const (

	// PortStateUp captures enum value "up"
	PortStateUp string = "up"

	// PortStateDown captures enum value "down"
	PortStateDown string = "down"
)

// prop value enum
func (m *Port) validateStateEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, portTypeStatePropEnum); err != nil {
		return err
	}
	return nil
}

func (m *Port) validateState(formats strfmt.Registry) error {

	if swag.IsZero(m.State) { // not required
		return nil
	}

	// value enum
	if err := m.validateStateEnum("state", "body", m.State); err != nil {
		return err
	}

	return nil
}

var portTypeTypePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["vlan","physical","lag"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		portTypeTypePropEnum = append(portTypeTypePropEnum, v)
	}
}

const (

	// PortTypeVlan captures enum value "vlan"
	PortTypeVlan string = "vlan"

	// PortTypePhysical captures enum value "physical"
	PortTypePhysical string = "physical"

	// PortTypeLag captures enum value "lag"
	PortTypeLag string = "lag"
)

// prop value enum
func (m *Port) validateTypeEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, portTypeTypePropEnum); err != nil {
		return err
	}
	return nil
}

func (m *Port) validateType(formats strfmt.Registry) error {

	if swag.IsZero(m.Type) { // not required
		return nil
	}

	// value enum
	if err := m.validateTypeEnum("type", "body", m.Type); err != nil {
		return err
	}

	return nil
}

func (m *Port) validateUUID(formats strfmt.Registry) error {

	if swag.IsZero(m.UUID) { // not required
		return nil
	}

	if err := validate.FormatOf("uuid", "body", "uuid", m.UUID.String(), formats); err != nil {
		return err
	}

	return nil
}

func (m *Port) validateVlan(formats strfmt.Registry) error {

	if swag.IsZero(m.Vlan) { // not required
		return nil
	}

	if m.Vlan != nil {
		if err := m.Vlan.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("vlan")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *Port) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *Port) UnmarshalBinary(b []byte) error {
	var res Port
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// PortLag port lag
// swagger:model PortLag
type PortLag struct {

	// Active ports of a LAG (ifgrp). (Some member ports may be inactive.)
	// Read Only: true
	ActivePorts []*PortReference `json:"active_ports"`

	// Policy for mapping flows to ports for outbound packets through a LAG (ifgrp).
	// Enum: [port ip mac sequential]
	DistributionPolicy string `json:"distribution_policy,omitempty"`

	// member ports
	MemberPorts []*PortReference `json:"member_ports"`

	// Determines how the ports interact with the switch.
	// Enum: [multimode_lacp multimode singlemode]
	Mode string `json:"mode,omitempty"`
}

// Validate validates this port lag
func (m *PortLag) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateActivePorts(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateDistributionPolicy(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateMemberPorts(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateMode(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *PortLag) validateActivePorts(formats strfmt.Registry) error {

	if swag.IsZero(m.ActivePorts) { // not required
		return nil
	}

	for i := 0; i < len(m.ActivePorts); i++ {
		if swag.IsZero(m.ActivePorts[i]) { // not required
			continue
		}

		if m.ActivePorts[i] != nil {
			if err := m.ActivePorts[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("lag" + "." + "active_ports" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

var portLagTypeDistributionPolicyPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["port","ip","mac","sequential"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		portLagTypeDistributionPolicyPropEnum = append(portLagTypeDistributionPolicyPropEnum, v)
	}
}

const (

	// PortLagDistributionPolicyPort captures enum value "port"
	PortLagDistributionPolicyPort string = "port"

	// PortLagDistributionPolicyIP captures enum value "ip"
	PortLagDistributionPolicyIP string = "ip"

	// PortLagDistributionPolicyMac captures enum value "mac"
	PortLagDistributionPolicyMac string = "mac"

	// PortLagDistributionPolicySequential captures enum value "sequential"
	PortLagDistributionPolicySequential string = "sequential"
)

// prop value enum
func (m *PortLag) validateDistributionPolicyEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, portLagTypeDistributionPolicyPropEnum); err != nil {
		return err
	}
	return nil
}

func (m *PortLag) validateDistributionPolicy(formats strfmt.Registry) error {

	if swag.IsZero(m.DistributionPolicy) { // not required
		return nil
	}

	// value enum
	if err := m.validateDistributionPolicyEnum("lag"+"."+"distribution_policy", "body", m.DistributionPolicy); err != nil {
		return err
	}

	return nil
}

func (m *PortLag) validateMemberPorts(formats strfmt.Registry) error {

	if swag.IsZero(m.MemberPorts) { // not required
		return nil
	}

	for i := 0; i < len(m.MemberPorts); i++ {
		if swag.IsZero(m.MemberPorts[i]) { // not required
			continue
		}

		if m.MemberPorts[i] != nil {
			if err := m.MemberPorts[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("lag" + "." + "member_ports" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

var portLagTypeModePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["multimode_lacp","multimode","singlemode"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		portLagTypeModePropEnum = append(portLagTypeModePropEnum, v)
	}
}

const (

	// PortLagModeMultimodeLacp captures enum value "multimode_lacp"
	PortLagModeMultimodeLacp string = "multimode_lacp"

	// PortLagModeMultimode captures enum value "multimode"
	PortLagModeMultimode string = "multimode"

	// PortLagModeSinglemode captures enum value "singlemode"
	PortLagModeSinglemode string = "singlemode"
)

// prop value enum
func (m *PortLag) validateModeEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, portLagTypeModePropEnum); err != nil {
		return err
	}
	return nil
}

func (m *PortLag) validateMode(formats strfmt.Registry) error {

	if swag.IsZero(m.Mode) { // not required
		return nil
	}

	// value enum
	if err := m.validateModeEnum("lag"+"."+"mode", "body", m.Mode); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *PortLag) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *PortLag) UnmarshalBinary(b []byte) error {
	var res PortLag
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// PortLinks port links
// swagger:model PortLinks
type PortLinks struct {

	// self
	Self *Href `json:"self,omitempty"`
}

// Validate validates this port links
func (m *PortLinks) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateSelf(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *PortLinks) validateSelf(formats strfmt.Registry) error {

	if swag.IsZero(m.Self) { // not required
		return nil
	}

	if m.Self != nil {
		if err := m.Self.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("_links" + "." + "self")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *PortLinks) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *PortLinks) UnmarshalBinary(b []byte) error {
	var res PortLinks
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// PortVlan port vlan
// swagger:model PortVlan
type PortVlan struct {

	// base port
	BasePort *PortReference `json:"base_port,omitempty"`

	// VLAN ID
	// Maximum: 4095
	// Minimum: 0
	Tag *int64 `json:"tag,omitempty"`
}

// Validate validates this port vlan
func (m *PortVlan) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateBasePort(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateTag(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *PortVlan) validateBasePort(formats strfmt.Registry) error {

	if swag.IsZero(m.BasePort) { // not required
		return nil
	}

	if m.BasePort != nil {
		if err := m.BasePort.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("vlan" + "." + "base_port")
			}
			return err
		}
	}

	return nil
}

func (m *PortVlan) validateTag(formats strfmt.Registry) error {

	if swag.IsZero(m.Tag) { // not required
		return nil
	}

	if err := validate.MinimumInt("vlan"+"."+"tag", "body", int64(*m.Tag), 0, false); err != nil {
		return err
	}

	if err := validate.MaximumInt("vlan"+"."+"tag", "body", int64(*m.Tag), 4095, false); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *PortVlan) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *PortVlan) UnmarshalBinary(b []byte) error {
	var res PortVlan
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
