// Code generated by go-swagger; DO NOT EDIT.

package ntapmodel

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// PrivateCliVolume Details about a volume fetched through private interface. This can be extended as needed if new fields are sought through this path.  In general you should use that /storage/volume path for most queries. This interface is used to get access to volume information that is not available through the standard REST path, such as FlexGroup constituent information.
// swagger:model privateCliVolume
type PrivateCliVolume struct {

	// The list of aggregate names that volume is housed on.
	AggrList []string `json:"aggr_list"`

	// A comment associated with a volume.
	Comment string `json:"comment,omitempty"`

	// The junction path
	JunctionPath string `json:"junction_path,omitempty"`

	// The name of the node.
	Node string `json:"node,omitempty"`

	// Total usable space in bytes, not including WAFL reserve and aggregate Snapshot copy reserve.
	Size int64 `json:"size"`

	// Tiering policy for FabricPool
	// Enum: [all auto backup none snapshot_only]
	TieringPolicy string `json:"tiering_policy,omitempty"`

	// Type of the volume - read write, data protection, or load sharing.
	// Enum: [rw dp ls]
	Type string `json:"type,omitempty"`

	// The name of the volume.
	Volume string `json:"volume,omitempty"`

	// The SVM that this volume belongs to.
	Vserver string `json:"vserver,omitempty"`
}

// Validate validates this private cli volume
func (m *PrivateCliVolume) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateTieringPolicy(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateType(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var privateCliVolumeTypeTieringPolicyPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["all","auto","backup","none","snapshot_only"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		privateCliVolumeTypeTieringPolicyPropEnum = append(privateCliVolumeTypeTieringPolicyPropEnum, v)
	}
}

const (

	// PrivateCliVolumeTieringPolicyAll captures enum value "all"
	PrivateCliVolumeTieringPolicyAll string = "all"

	// PrivateCliVolumeTieringPolicyAuto captures enum value "auto"
	PrivateCliVolumeTieringPolicyAuto string = "auto"

	// PrivateCliVolumeTieringPolicyBackup captures enum value "backup"
	PrivateCliVolumeTieringPolicyBackup string = "backup"

	// PrivateCliVolumeTieringPolicyNone captures enum value "none"
	PrivateCliVolumeTieringPolicyNone string = "none"

	// PrivateCliVolumeTieringPolicySnapshotOnly captures enum value "snapshot_only"
	PrivateCliVolumeTieringPolicySnapshotOnly string = "snapshot_only"
)

// prop value enum
func (m *PrivateCliVolume) validateTieringPolicyEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, privateCliVolumeTypeTieringPolicyPropEnum); err != nil {
		return err
	}
	return nil
}

func (m *PrivateCliVolume) validateTieringPolicy(formats strfmt.Registry) error {

	if swag.IsZero(m.TieringPolicy) { // not required
		return nil
	}

	// value enum
	if err := m.validateTieringPolicyEnum("tiering_policy", "body", m.TieringPolicy); err != nil {
		return err
	}

	return nil
}

var privateCliVolumeTypeTypePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["rw","dp","ls"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		privateCliVolumeTypeTypePropEnum = append(privateCliVolumeTypeTypePropEnum, v)
	}
}

const (

	// PrivateCliVolumeTypeRw captures enum value "rw"
	PrivateCliVolumeTypeRw string = "rw"

	// PrivateCliVolumeTypeDp captures enum value "dp"
	PrivateCliVolumeTypeDp string = "dp"

	// PrivateCliVolumeTypeLs captures enum value "ls"
	PrivateCliVolumeTypeLs string = "ls"
)

// prop value enum
func (m *PrivateCliVolume) validateTypeEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, privateCliVolumeTypeTypePropEnum); err != nil {
		return err
	}
	return nil
}

func (m *PrivateCliVolume) validateType(formats strfmt.Registry) error {

	if swag.IsZero(m.Type) { // not required
		return nil
	}

	// value enum
	if err := m.validateTypeEnum("type", "body", m.Type); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *PrivateCliVolume) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *PrivateCliVolume) UnmarshalBinary(b []byte) error {
	var res PrivateCliVolume
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
