// Code generated by go-swagger; DO NOT EDIT.

package ntapmodel

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	strfmt "github.com/go-openapi/strfmt"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// PrivateCliVolumeSpace Details about the space usage for volumes. This can be extended as needed if new fields are sought through this path.  In general you should use that /storage/volume path for most queries. This interface is used to get access to volume space information that is not available through the standard REST path, such as FlexGroup constituent information.
// swagger:model privateCliVolumeSpace
type PrivateCliVolumeSpace struct {

	// The UUID of aggregate that holds the volume
	// Format: uuid
	AggregateUUID strfmt.UUID `json:"aggregate_uuid,omitempty"`

	// The logical space usage for the volume.
	LogicalUsed int64 `json:"logical_used,omitempty"`

	// The name of the volume.
	Volume string `json:"volume,omitempty"`

	// The SVM that this volume belongs to.
	Vserver string `json:"vserver,omitempty"`
}

// Validate validates this private cli volume space
func (m *PrivateCliVolumeSpace) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateAggregateUUID(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *PrivateCliVolumeSpace) validateAggregateUUID(formats strfmt.Registry) error {

	if swag.IsZero(m.AggregateUUID) { // not required
		return nil
	}

	if err := validate.FormatOf("aggregate_uuid", "body", "uuid", m.AggregateUUID.String(), formats); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *PrivateCliVolumeSpace) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *PrivateCliVolumeSpace) UnmarshalBinary(b []byte) error {
	var res PrivateCliVolumeSpace
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
