// Code generated by go-swagger; DO NOT EDIT.

package ntapmodel

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// SoftwareStatusDetailsReference software status details reference
// swagger:model softwareStatusDetailsReference
type SoftwareStatusDetailsReference struct {

	// action
	Action *SoftwareStatusDetailsReferenceAction `json:"action,omitempty"`

	// End time for each status phase.
	// Read Only: true
	// Format: date-time
	EndTime strfmt.DateTime `json:"end_time,omitempty"`

	// issue
	Issue *SoftwareStatusDetailsReferenceIssue `json:"issue,omitempty"`

	// Name of the phase to be retrieved for status details.
	// Read Only: true
	Name string `json:"name,omitempty"`

	// node
	Node *SoftwareStatusDetailsReferenceNode `json:"node,omitempty"`

	// Start time for each status phase.
	// Read Only: true
	// Format: date-time
	StartTime strfmt.DateTime `json:"start_time,omitempty"`

	// Status of the phase
	// Read Only: true
	// Enum: [in_progress waiting paused_by_user paused_on_error completed canceled failed pause_pending cancel_pending]
	State string `json:"state,omitempty"`
}

// Validate validates this software status details reference
func (m *SoftwareStatusDetailsReference) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateAction(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateEndTime(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateIssue(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateNode(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateStartTime(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateState(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *SoftwareStatusDetailsReference) validateAction(formats strfmt.Registry) error {

	if swag.IsZero(m.Action) { // not required
		return nil
	}

	if m.Action != nil {
		if err := m.Action.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("action")
			}
			return err
		}
	}

	return nil
}

func (m *SoftwareStatusDetailsReference) validateEndTime(formats strfmt.Registry) error {

	if swag.IsZero(m.EndTime) { // not required
		return nil
	}

	if err := validate.FormatOf("end_time", "body", "date-time", m.EndTime.String(), formats); err != nil {
		return err
	}

	return nil
}

func (m *SoftwareStatusDetailsReference) validateIssue(formats strfmt.Registry) error {

	if swag.IsZero(m.Issue) { // not required
		return nil
	}

	if m.Issue != nil {
		if err := m.Issue.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("issue")
			}
			return err
		}
	}

	return nil
}

func (m *SoftwareStatusDetailsReference) validateNode(formats strfmt.Registry) error {

	if swag.IsZero(m.Node) { // not required
		return nil
	}

	if m.Node != nil {
		if err := m.Node.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("node")
			}
			return err
		}
	}

	return nil
}

func (m *SoftwareStatusDetailsReference) validateStartTime(formats strfmt.Registry) error {

	if swag.IsZero(m.StartTime) { // not required
		return nil
	}

	if err := validate.FormatOf("start_time", "body", "date-time", m.StartTime.String(), formats); err != nil {
		return err
	}

	return nil
}

var softwareStatusDetailsReferenceTypeStatePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["in_progress","waiting","paused_by_user","paused_on_error","completed","canceled","failed","pause_pending","cancel_pending"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		softwareStatusDetailsReferenceTypeStatePropEnum = append(softwareStatusDetailsReferenceTypeStatePropEnum, v)
	}
}

const (

	// SoftwareStatusDetailsReferenceStateInProgress captures enum value "in_progress"
	SoftwareStatusDetailsReferenceStateInProgress string = "in_progress"

	// SoftwareStatusDetailsReferenceStateWaiting captures enum value "waiting"
	SoftwareStatusDetailsReferenceStateWaiting string = "waiting"

	// SoftwareStatusDetailsReferenceStatePausedByUser captures enum value "paused_by_user"
	SoftwareStatusDetailsReferenceStatePausedByUser string = "paused_by_user"

	// SoftwareStatusDetailsReferenceStatePausedOnError captures enum value "paused_on_error"
	SoftwareStatusDetailsReferenceStatePausedOnError string = "paused_on_error"

	// SoftwareStatusDetailsReferenceStateCompleted captures enum value "completed"
	SoftwareStatusDetailsReferenceStateCompleted string = "completed"

	// SoftwareStatusDetailsReferenceStateCanceled captures enum value "canceled"
	SoftwareStatusDetailsReferenceStateCanceled string = "canceled"

	// SoftwareStatusDetailsReferenceStateFailed captures enum value "failed"
	SoftwareStatusDetailsReferenceStateFailed string = "failed"

	// SoftwareStatusDetailsReferenceStatePausePending captures enum value "pause_pending"
	SoftwareStatusDetailsReferenceStatePausePending string = "pause_pending"

	// SoftwareStatusDetailsReferenceStateCancelPending captures enum value "cancel_pending"
	SoftwareStatusDetailsReferenceStateCancelPending string = "cancel_pending"
)

// prop value enum
func (m *SoftwareStatusDetailsReference) validateStateEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, softwareStatusDetailsReferenceTypeStatePropEnum); err != nil {
		return err
	}
	return nil
}

func (m *SoftwareStatusDetailsReference) validateState(formats strfmt.Registry) error {

	if swag.IsZero(m.State) { // not required
		return nil
	}

	// value enum
	if err := m.validateStateEnum("state", "body", m.State); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *SoftwareStatusDetailsReference) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *SoftwareStatusDetailsReference) UnmarshalBinary(b []byte) error {
	var res SoftwareStatusDetailsReference
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// SoftwareStatusDetailsReferenceAction software status details reference action
// swagger:model SoftwareStatusDetailsReferenceAction
type SoftwareStatusDetailsReferenceAction struct {

	// Corrective action to be taken to resolve the status error.
	Message string `json:"message,omitempty"`
}

// Validate validates this software status details reference action
func (m *SoftwareStatusDetailsReferenceAction) Validate(formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *SoftwareStatusDetailsReferenceAction) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *SoftwareStatusDetailsReferenceAction) UnmarshalBinary(b []byte) error {
	var res SoftwareStatusDetailsReferenceAction
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// SoftwareStatusDetailsReferenceIssue software status details reference issue
// swagger:model SoftwareStatusDetailsReferenceIssue
type SoftwareStatusDetailsReferenceIssue struct {

	// Update status details
	Message string `json:"message,omitempty"`
}

// Validate validates this software status details reference issue
func (m *SoftwareStatusDetailsReferenceIssue) Validate(formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *SoftwareStatusDetailsReferenceIssue) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *SoftwareStatusDetailsReferenceIssue) UnmarshalBinary(b []byte) error {
	var res SoftwareStatusDetailsReferenceIssue
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// SoftwareStatusDetailsReferenceNode software status details reference node
// swagger:model SoftwareStatusDetailsReferenceNode
type SoftwareStatusDetailsReferenceNode struct {

	// Name of the node to be retrieved for status details.
	// Read Only: true
	Name string `json:"name,omitempty"`
}

// Validate validates this software status details reference node
func (m *SoftwareStatusDetailsReferenceNode) Validate(formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *SoftwareStatusDetailsReferenceNode) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *SoftwareStatusDetailsReferenceNode) UnmarshalBinary(b []byte) error {
	var res SoftwareStatusDetailsReferenceNode
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
