// Code generated by go-swagger; DO NOT EDIT.

package ntapmodel

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// SoftwareUpdateDetailsReference software update details reference
// swagger:model softwareUpdateDetailsReference
type SoftwareUpdateDetailsReference struct {

	// Elapsed duration for each update phase
	// Read Only: true
	ElapsedDuration int64 `json:"elapsed_duration,omitempty"`

	// Estimated duration for each update phase
	// Read Only: true
	EstimatedDuration int64 `json:"estimated_duration,omitempty"`

	// node
	Node *SoftwareUpdateDetailsReferenceNode `json:"node,omitempty"`

	// Phase details
	// Read Only: true
	Phase string `json:"phase,omitempty"`

	// State of the update phase
	// Read Only: true
	// Enum: [in_progress waiting paused_by_user paused_on_error completed canceled failed pause_pending cancel_pending]
	State string `json:"state,omitempty"`
}

// Validate validates this software update details reference
func (m *SoftwareUpdateDetailsReference) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateNode(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateState(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *SoftwareUpdateDetailsReference) validateNode(formats strfmt.Registry) error {

	if swag.IsZero(m.Node) { // not required
		return nil
	}

	if m.Node != nil {
		if err := m.Node.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("node")
			}
			return err
		}
	}

	return nil
}

var softwareUpdateDetailsReferenceTypeStatePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["in_progress","waiting","paused_by_user","paused_on_error","completed","canceled","failed","pause_pending","cancel_pending"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		softwareUpdateDetailsReferenceTypeStatePropEnum = append(softwareUpdateDetailsReferenceTypeStatePropEnum, v)
	}
}

const (

	// SoftwareUpdateDetailsReferenceStateInProgress captures enum value "in_progress"
	SoftwareUpdateDetailsReferenceStateInProgress string = "in_progress"

	// SoftwareUpdateDetailsReferenceStateWaiting captures enum value "waiting"
	SoftwareUpdateDetailsReferenceStateWaiting string = "waiting"

	// SoftwareUpdateDetailsReferenceStatePausedByUser captures enum value "paused_by_user"
	SoftwareUpdateDetailsReferenceStatePausedByUser string = "paused_by_user"

	// SoftwareUpdateDetailsReferenceStatePausedOnError captures enum value "paused_on_error"
	SoftwareUpdateDetailsReferenceStatePausedOnError string = "paused_on_error"

	// SoftwareUpdateDetailsReferenceStateCompleted captures enum value "completed"
	SoftwareUpdateDetailsReferenceStateCompleted string = "completed"

	// SoftwareUpdateDetailsReferenceStateCanceled captures enum value "canceled"
	SoftwareUpdateDetailsReferenceStateCanceled string = "canceled"

	// SoftwareUpdateDetailsReferenceStateFailed captures enum value "failed"
	SoftwareUpdateDetailsReferenceStateFailed string = "failed"

	// SoftwareUpdateDetailsReferenceStatePausePending captures enum value "pause_pending"
	SoftwareUpdateDetailsReferenceStatePausePending string = "pause_pending"

	// SoftwareUpdateDetailsReferenceStateCancelPending captures enum value "cancel_pending"
	SoftwareUpdateDetailsReferenceStateCancelPending string = "cancel_pending"
)

// prop value enum
func (m *SoftwareUpdateDetailsReference) validateStateEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, softwareUpdateDetailsReferenceTypeStatePropEnum); err != nil {
		return err
	}
	return nil
}

func (m *SoftwareUpdateDetailsReference) validateState(formats strfmt.Registry) error {

	if swag.IsZero(m.State) { // not required
		return nil
	}

	// value enum
	if err := m.validateStateEnum("state", "body", m.State); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *SoftwareUpdateDetailsReference) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *SoftwareUpdateDetailsReference) UnmarshalBinary(b []byte) error {
	var res SoftwareUpdateDetailsReference
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// SoftwareUpdateDetailsReferenceNode software update details reference node
// swagger:model SoftwareUpdateDetailsReferenceNode
type SoftwareUpdateDetailsReferenceNode struct {

	// Name of the node to be retrieved for update details.
	// Read Only: true
	Name string `json:"name,omitempty"`
}

// Validate validates this software update details reference node
func (m *SoftwareUpdateDetailsReferenceNode) Validate(formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *SoftwareUpdateDetailsReferenceNode) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *SoftwareUpdateDetailsReferenceNode) UnmarshalBinary(b []byte) error {
	var res SoftwareUpdateDetailsReferenceNode
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
