// Code generated by go-swagger; DO NOT EDIT.

package ntapmodel

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"strconv"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// SoftwareValidationReference software validation reference
// swagger:model softwareValidationReference
type SoftwareValidationReference struct {

	// Corrective action to resolve errors or warnings for update checks.
	// Read Only: true
	Action []*SoftwareValidationReferenceActionItems0 `json:"action"`

	// Details of the error or warning encountered by the update checks.
	// Read Only: true
	Issue []*SoftwareValidationReferenceIssueItems0 `json:"issue"`

	// Status of this update check.
	// Read Only: true
	// Enum: [warning error]
	Status string `json:"status,omitempty"`

	// Name of the update check to be validated.
	// Read Only: true
	UpdateCheck string `json:"update_check,omitempty"`
}

// Validate validates this software validation reference
func (m *SoftwareValidationReference) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateAction(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateIssue(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateStatus(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *SoftwareValidationReference) validateAction(formats strfmt.Registry) error {

	if swag.IsZero(m.Action) { // not required
		return nil
	}

	for i := 0; i < len(m.Action); i++ {
		if swag.IsZero(m.Action[i]) { // not required
			continue
		}

		if m.Action[i] != nil {
			if err := m.Action[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("action" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *SoftwareValidationReference) validateIssue(formats strfmt.Registry) error {

	if swag.IsZero(m.Issue) { // not required
		return nil
	}

	for i := 0; i < len(m.Issue); i++ {
		if swag.IsZero(m.Issue[i]) { // not required
			continue
		}

		if m.Issue[i] != nil {
			if err := m.Issue[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("issue" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

var softwareValidationReferenceTypeStatusPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["warning","error"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		softwareValidationReferenceTypeStatusPropEnum = append(softwareValidationReferenceTypeStatusPropEnum, v)
	}
}

const (

	// SoftwareValidationReferenceStatusWarning captures enum value "warning"
	SoftwareValidationReferenceStatusWarning string = "warning"

	// SoftwareValidationReferenceStatusError captures enum value "error"
	SoftwareValidationReferenceStatusError string = "error"
)

// prop value enum
func (m *SoftwareValidationReference) validateStatusEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, softwareValidationReferenceTypeStatusPropEnum); err != nil {
		return err
	}
	return nil
}

func (m *SoftwareValidationReference) validateStatus(formats strfmt.Registry) error {

	if swag.IsZero(m.Status) { // not required
		return nil
	}

	// value enum
	if err := m.validateStatusEnum("status", "body", m.Status); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *SoftwareValidationReference) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *SoftwareValidationReference) UnmarshalBinary(b []byte) error {
	var res SoftwareValidationReference
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// SoftwareValidationReferenceActionItems0 software validation reference action items0
// swagger:model SoftwareValidationReferenceActionItems0
type SoftwareValidationReferenceActionItems0 struct {

	// arguments
	// Read Only: true
	Arguments []string `json:"arguments"`

	// Message catalog code of message
	// Read Only: true
	Code int64 `json:"code,omitempty"`

	// Message details
	// Read Only: true
	Message string `json:"message,omitempty"`
}

// Validate validates this software validation reference action items0
func (m *SoftwareValidationReferenceActionItems0) Validate(formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *SoftwareValidationReferenceActionItems0) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *SoftwareValidationReferenceActionItems0) UnmarshalBinary(b []byte) error {
	var res SoftwareValidationReferenceActionItems0
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// SoftwareValidationReferenceIssueItems0 software validation reference issue items0
// swagger:model SoftwareValidationReferenceIssueItems0
type SoftwareValidationReferenceIssueItems0 struct {

	// arguments
	// Read Only: true
	Arguments []string `json:"arguments"`

	// Message catalog code of message
	// Read Only: true
	Code int64 `json:"code,omitempty"`

	// Message details
	// Read Only: true
	Message string `json:"message,omitempty"`
}

// Validate validates this software validation reference issue items0
func (m *SoftwareValidationReferenceIssueItems0) Validate(formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *SoftwareValidationReferenceIssueItems0) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *SoftwareValidationReferenceIssueItems0) UnmarshalBinary(b []byte) error {
	var res SoftwareValidationReferenceIssueItems0
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
