// Code generated by go-swagger; DO NOT EDIT.

package ntapmodel

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"strconv"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// Svm svm
// swagger:model svm
type Svm struct {

	// links
	Links *SvmLinks `json:"_links,omitempty"`

	// List of allowed aggregates for SVM volumes. An administrator is allowed to create volumes on these aggregates.
	Aggregates []*AggregateReference `json:"aggregates,omitempty"`

	// This property is true when the administrator has delegated the aggregates for the SVM volumes.
	// Read Only: true
	AggregatesDelegated *bool `json:"aggregates_delegated,omitempty"`

	// certificate
	Certificate *SecurityCertificateReference `json:"certificate,omitempty"`

	// cifs
	Cifs *SvmCifs `json:"cifs,omitempty"`

	// Comment
	// Max Length: 255
	// Min Length: 0
	Comment *string `json:"comment,omitempty"`

	// dns
	DNS *SvmDNS `json:"dns,omitempty"`

	// FC Interface for the SVM
	FcInterfaces []*FcInterfaceSvm `json:"fc_interfaces,omitempty"`

	// fcp
	Fcp *SvmFcp `json:"fcp,omitempty"`

	// IP interfaces for the SVM
	IPInterfaces []*IPInterfaceSvm `json:"ip_interfaces,omitempty"`

	// ipspace
	Ipspace *IpspaceReference `json:"ipspace,omitempty"`

	// iscsi
	Iscsi *SvmIscsi `json:"iscsi,omitempty"`

	// Default volume language code. UTF-8 encoded languages are valid in POST or PATCH. Non UTF-8 language encodings are for backward compatibility and are not valid input for POST and PATCH requests.
	// Enum: [c da de en en_us es fi fr he it ja ja_jp.pck ko no nl pt sv zh zh.gbk zh_tw zh_tw.big5 c.utf_8 ar ar.utf_8 cs cs.utf_8 da.utf_8 de.utf_8 en.utf_8 en_us.utf_8 es.utf_8 fi.utf_8 fr.utf_8 he.utf_8 hr hr.utf_8 hu hu.utf_8 it.utf_8 ja.utf_8 ja_v1 ja_v1.utf_8 ja_jp.pck.utf_8 ja_jp.932 ja_jp.932.utf_8 ja_jp.pck_v2 ja_jp.pck_v2.utf_8 ko.utf_8 no.utf_8 nl.utf_8 pl pl.utf_8 pt.utf_8 ro ro.utf_8 ru ru.utf_8 sk sk.utf_8 sl sl.utf_8 sv.utf_8 tr tr.utf_8 zh.utf_8 zh.gbk.utf_8 zh_tw.utf_8 zh_tw.big5.utf_8 utf8mb4]
	Language string `json:"language,omitempty"`

	// ldap
	Ldap *SvmLdapReference `json:"ldap,omitempty"`

	// The name of the SVM.
	//
	Name string `json:"name,omitempty"`

	// nfs
	Nfs *SvmNfs `json:"nfs,omitempty"`

	// nis
	Nis *SvmNis `json:"nis,omitempty"`

	// nsswitch
	Nsswitch *SvmNsswitch `json:"nsswitch,omitempty"`

	// nvme
	Nvme *SvmNvme `json:"nvme,omitempty"`

	// Optional array of routes for the SVM
	Routes []*NetworkRouteForSvm `json:"routes,omitempty"`

	// s3
	S3 *SvmS3ServiceReference `json:"s3,omitempty"`

	// snapmirror
	Snapmirror *SvmSnapmirror `json:"snapmirror,omitempty"`

	// snapshot policy
	SnapshotPolicy *SnapshotPolicyReference `json:"snapshot_policy,omitempty"`

	// SVM State
	// Enum: [starting running stopping stopped deleting]
	State string `json:"state,omitempty"`

	// SVM subtype. The SVM subtype sync_destination is created automatically when an SVM of subtype sync_source is created on the source MetroCluster cluster. A POST request with sync_destination as SVM subtype is invalid.
	// Enum: [default dp_destination sync_source sync_destination]
	Subtype string `json:"subtype,omitempty"`

	// The unique identifier of the SVM.
	//
	// Read Only: true
	// Format: uuid
	UUID strfmt.UUID `json:"uuid,omitempty"`
}

// Validate validates this svm
func (m *Svm) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLinks(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateAggregates(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateCertificate(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateCifs(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateComment(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateDNS(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateFcInterfaces(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateFcp(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateIPInterfaces(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateIpspace(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateIscsi(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateLanguage(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateLdap(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateNfs(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateNis(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateNsswitch(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateNvme(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateRoutes(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateS3(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSnapmirror(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSnapshotPolicy(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateState(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSubtype(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateUUID(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *Svm) validateLinks(formats strfmt.Registry) error {

	if swag.IsZero(m.Links) { // not required
		return nil
	}

	if m.Links != nil {
		if err := m.Links.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("_links")
			}
			return err
		}
	}

	return nil
}

func (m *Svm) validateAggregates(formats strfmt.Registry) error {

	if swag.IsZero(m.Aggregates) { // not required
		return nil
	}

	for i := 0; i < len(m.Aggregates); i++ {
		if swag.IsZero(m.Aggregates[i]) { // not required
			continue
		}

		if m.Aggregates[i] != nil {
			if err := m.Aggregates[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("aggregates" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *Svm) validateCertificate(formats strfmt.Registry) error {

	if swag.IsZero(m.Certificate) { // not required
		return nil
	}

	if m.Certificate != nil {
		if err := m.Certificate.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("certificate")
			}
			return err
		}
	}

	return nil
}

func (m *Svm) validateCifs(formats strfmt.Registry) error {

	if swag.IsZero(m.Cifs) { // not required
		return nil
	}

	if m.Cifs != nil {
		if err := m.Cifs.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("cifs")
			}
			return err
		}
	}

	return nil
}

func (m *Svm) validateComment(formats strfmt.Registry) error {

	if swag.IsZero(m.Comment) { // not required
		return nil
	}

	if err := validate.MinLength("comment", "body", string(*m.Comment), 0); err != nil {
		return err
	}

	if err := validate.MaxLength("comment", "body", string(*m.Comment), 255); err != nil {
		return err
	}

	return nil
}

func (m *Svm) validateDNS(formats strfmt.Registry) error {

	if swag.IsZero(m.DNS) { // not required
		return nil
	}

	if m.DNS != nil {
		if err := m.DNS.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("dns")
			}
			return err
		}
	}

	return nil
}

func (m *Svm) validateFcInterfaces(formats strfmt.Registry) error {

	if swag.IsZero(m.FcInterfaces) { // not required
		return nil
	}

	for i := 0; i < len(m.FcInterfaces); i++ {
		if swag.IsZero(m.FcInterfaces[i]) { // not required
			continue
		}

		if m.FcInterfaces[i] != nil {
			if err := m.FcInterfaces[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("fc_interfaces" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *Svm) validateFcp(formats strfmt.Registry) error {

	if swag.IsZero(m.Fcp) { // not required
		return nil
	}

	if m.Fcp != nil {
		if err := m.Fcp.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("fcp")
			}
			return err
		}
	}

	return nil
}

func (m *Svm) validateIPInterfaces(formats strfmt.Registry) error {

	if swag.IsZero(m.IPInterfaces) { // not required
		return nil
	}

	for i := 0; i < len(m.IPInterfaces); i++ {
		if swag.IsZero(m.IPInterfaces[i]) { // not required
			continue
		}

		if m.IPInterfaces[i] != nil {
			if err := m.IPInterfaces[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("ip_interfaces" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *Svm) validateIpspace(formats strfmt.Registry) error {

	if swag.IsZero(m.Ipspace) { // not required
		return nil
	}

	if m.Ipspace != nil {
		if err := m.Ipspace.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ipspace")
			}
			return err
		}
	}

	return nil
}

func (m *Svm) validateIscsi(formats strfmt.Registry) error {

	if swag.IsZero(m.Iscsi) { // not required
		return nil
	}

	if m.Iscsi != nil {
		if err := m.Iscsi.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("iscsi")
			}
			return err
		}
	}

	return nil
}

var svmTypeLanguagePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["c","da","de","en","en_us","es","fi","fr","he","it","ja","ja_jp.pck","ko","no","nl","pt","sv","zh","zh.gbk","zh_tw","zh_tw.big5","c.utf_8","ar","ar.utf_8","cs","cs.utf_8","da.utf_8","de.utf_8","en.utf_8","en_us.utf_8","es.utf_8","fi.utf_8","fr.utf_8","he.utf_8","hr","hr.utf_8","hu","hu.utf_8","it.utf_8","ja.utf_8","ja_v1","ja_v1.utf_8","ja_jp.pck.utf_8","ja_jp.932","ja_jp.932.utf_8","ja_jp.pck_v2","ja_jp.pck_v2.utf_8","ko.utf_8","no.utf_8","nl.utf_8","pl","pl.utf_8","pt.utf_8","ro","ro.utf_8","ru","ru.utf_8","sk","sk.utf_8","sl","sl.utf_8","sv.utf_8","tr","tr.utf_8","zh.utf_8","zh.gbk.utf_8","zh_tw.utf_8","zh_tw.big5.utf_8","utf8mb4"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		svmTypeLanguagePropEnum = append(svmTypeLanguagePropEnum, v)
	}
}

const (

	// SvmLanguageC captures enum value "c"
	SvmLanguageC string = "c"

	// SvmLanguageDa captures enum value "da"
	SvmLanguageDa string = "da"

	// SvmLanguageDe captures enum value "de"
	SvmLanguageDe string = "de"

	// SvmLanguageEn captures enum value "en"
	SvmLanguageEn string = "en"

	// SvmLanguageEnUs captures enum value "en_us"
	SvmLanguageEnUs string = "en_us"

	// SvmLanguageEs captures enum value "es"
	SvmLanguageEs string = "es"

	// SvmLanguageFi captures enum value "fi"
	SvmLanguageFi string = "fi"

	// SvmLanguageFr captures enum value "fr"
	SvmLanguageFr string = "fr"

	// SvmLanguageHe captures enum value "he"
	SvmLanguageHe string = "he"

	// SvmLanguageIt captures enum value "it"
	SvmLanguageIt string = "it"

	// SvmLanguageJa captures enum value "ja"
	SvmLanguageJa string = "ja"

	// SvmLanguageJaJpPck captures enum value "ja_jp.pck"
	SvmLanguageJaJpPck string = "ja_jp.pck"

	// SvmLanguageKo captures enum value "ko"
	SvmLanguageKo string = "ko"

	// SvmLanguageNo captures enum value "no"
	SvmLanguageNo string = "no"

	// SvmLanguageNl captures enum value "nl"
	SvmLanguageNl string = "nl"

	// SvmLanguagePt captures enum value "pt"
	SvmLanguagePt string = "pt"

	// SvmLanguageSv captures enum value "sv"
	SvmLanguageSv string = "sv"

	// SvmLanguageZh captures enum value "zh"
	SvmLanguageZh string = "zh"

	// SvmLanguageZhGbk captures enum value "zh.gbk"
	SvmLanguageZhGbk string = "zh.gbk"

	// SvmLanguageZhTw captures enum value "zh_tw"
	SvmLanguageZhTw string = "zh_tw"

	// SvmLanguageZhTwBig5 captures enum value "zh_tw.big5"
	SvmLanguageZhTwBig5 string = "zh_tw.big5"

	// SvmLanguageCUTF8 captures enum value "c.utf_8"
	SvmLanguageCUTF8 string = "c.utf_8"

	// SvmLanguageAr captures enum value "ar"
	SvmLanguageAr string = "ar"

	// SvmLanguageArUTF8 captures enum value "ar.utf_8"
	SvmLanguageArUTF8 string = "ar.utf_8"

	// SvmLanguageCs captures enum value "cs"
	SvmLanguageCs string = "cs"

	// SvmLanguageCsUTF8 captures enum value "cs.utf_8"
	SvmLanguageCsUTF8 string = "cs.utf_8"

	// SvmLanguageDaUTF8 captures enum value "da.utf_8"
	SvmLanguageDaUTF8 string = "da.utf_8"

	// SvmLanguageDeUTF8 captures enum value "de.utf_8"
	SvmLanguageDeUTF8 string = "de.utf_8"

	// SvmLanguageEnUTF8 captures enum value "en.utf_8"
	SvmLanguageEnUTF8 string = "en.utf_8"

	// SvmLanguageEnUsUTF8 captures enum value "en_us.utf_8"
	SvmLanguageEnUsUTF8 string = "en_us.utf_8"

	// SvmLanguageEsUTF8 captures enum value "es.utf_8"
	SvmLanguageEsUTF8 string = "es.utf_8"

	// SvmLanguageFiUTF8 captures enum value "fi.utf_8"
	SvmLanguageFiUTF8 string = "fi.utf_8"

	// SvmLanguageFrUTF8 captures enum value "fr.utf_8"
	SvmLanguageFrUTF8 string = "fr.utf_8"

	// SvmLanguageHeUTF8 captures enum value "he.utf_8"
	SvmLanguageHeUTF8 string = "he.utf_8"

	// SvmLanguageHr captures enum value "hr"
	SvmLanguageHr string = "hr"

	// SvmLanguageHrUTF8 captures enum value "hr.utf_8"
	SvmLanguageHrUTF8 string = "hr.utf_8"

	// SvmLanguageHu captures enum value "hu"
	SvmLanguageHu string = "hu"

	// SvmLanguageHuUTF8 captures enum value "hu.utf_8"
	SvmLanguageHuUTF8 string = "hu.utf_8"

	// SvmLanguageItUTF8 captures enum value "it.utf_8"
	SvmLanguageItUTF8 string = "it.utf_8"

	// SvmLanguageJaUTF8 captures enum value "ja.utf_8"
	SvmLanguageJaUTF8 string = "ja.utf_8"

	// SvmLanguageJaV1 captures enum value "ja_v1"
	SvmLanguageJaV1 string = "ja_v1"

	// SvmLanguageJaV1UTF8 captures enum value "ja_v1.utf_8"
	SvmLanguageJaV1UTF8 string = "ja_v1.utf_8"

	// SvmLanguageJaJpPckUTF8 captures enum value "ja_jp.pck.utf_8"
	SvmLanguageJaJpPckUTF8 string = "ja_jp.pck.utf_8"

	// SvmLanguageJaJp932 captures enum value "ja_jp.932"
	SvmLanguageJaJp932 string = "ja_jp.932"

	// SvmLanguageJaJp932UTF8 captures enum value "ja_jp.932.utf_8"
	SvmLanguageJaJp932UTF8 string = "ja_jp.932.utf_8"

	// SvmLanguageJaJpPckV2 captures enum value "ja_jp.pck_v2"
	SvmLanguageJaJpPckV2 string = "ja_jp.pck_v2"

	// SvmLanguageJaJpPckV2UTF8 captures enum value "ja_jp.pck_v2.utf_8"
	SvmLanguageJaJpPckV2UTF8 string = "ja_jp.pck_v2.utf_8"

	// SvmLanguageKoUTF8 captures enum value "ko.utf_8"
	SvmLanguageKoUTF8 string = "ko.utf_8"

	// SvmLanguageNoUTF8 captures enum value "no.utf_8"
	SvmLanguageNoUTF8 string = "no.utf_8"

	// SvmLanguageNlUTF8 captures enum value "nl.utf_8"
	SvmLanguageNlUTF8 string = "nl.utf_8"

	// SvmLanguagePl captures enum value "pl"
	SvmLanguagePl string = "pl"

	// SvmLanguagePlUTF8 captures enum value "pl.utf_8"
	SvmLanguagePlUTF8 string = "pl.utf_8"

	// SvmLanguagePtUTF8 captures enum value "pt.utf_8"
	SvmLanguagePtUTF8 string = "pt.utf_8"

	// SvmLanguageRo captures enum value "ro"
	SvmLanguageRo string = "ro"

	// SvmLanguageRoUTF8 captures enum value "ro.utf_8"
	SvmLanguageRoUTF8 string = "ro.utf_8"

	// SvmLanguageRu captures enum value "ru"
	SvmLanguageRu string = "ru"

	// SvmLanguageRuUTF8 captures enum value "ru.utf_8"
	SvmLanguageRuUTF8 string = "ru.utf_8"

	// SvmLanguageSk captures enum value "sk"
	SvmLanguageSk string = "sk"

	// SvmLanguageSkUTF8 captures enum value "sk.utf_8"
	SvmLanguageSkUTF8 string = "sk.utf_8"

	// SvmLanguageSl captures enum value "sl"
	SvmLanguageSl string = "sl"

	// SvmLanguageSlUTF8 captures enum value "sl.utf_8"
	SvmLanguageSlUTF8 string = "sl.utf_8"

	// SvmLanguageSvUTF8 captures enum value "sv.utf_8"
	SvmLanguageSvUTF8 string = "sv.utf_8"

	// SvmLanguageTr captures enum value "tr"
	SvmLanguageTr string = "tr"

	// SvmLanguageTrUTF8 captures enum value "tr.utf_8"
	SvmLanguageTrUTF8 string = "tr.utf_8"

	// SvmLanguageZhUTF8 captures enum value "zh.utf_8"
	SvmLanguageZhUTF8 string = "zh.utf_8"

	// SvmLanguageZhGbkUTF8 captures enum value "zh.gbk.utf_8"
	SvmLanguageZhGbkUTF8 string = "zh.gbk.utf_8"

	// SvmLanguageZhTwUTF8 captures enum value "zh_tw.utf_8"
	SvmLanguageZhTwUTF8 string = "zh_tw.utf_8"

	// SvmLanguageZhTwBig5UTF8 captures enum value "zh_tw.big5.utf_8"
	SvmLanguageZhTwBig5UTF8 string = "zh_tw.big5.utf_8"

	// SvmLanguageUtf8mb4 captures enum value "utf8mb4"
	SvmLanguageUtf8mb4 string = "utf8mb4"
)

// prop value enum
func (m *Svm) validateLanguageEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, svmTypeLanguagePropEnum); err != nil {
		return err
	}
	return nil
}

func (m *Svm) validateLanguage(formats strfmt.Registry) error {

	if swag.IsZero(m.Language) { // not required
		return nil
	}

	// value enum
	if err := m.validateLanguageEnum("language", "body", m.Language); err != nil {
		return err
	}

	return nil
}

func (m *Svm) validateLdap(formats strfmt.Registry) error {

	if swag.IsZero(m.Ldap) { // not required
		return nil
	}

	if m.Ldap != nil {
		if err := m.Ldap.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ldap")
			}
			return err
		}
	}

	return nil
}

func (m *Svm) validateNfs(formats strfmt.Registry) error {

	if swag.IsZero(m.Nfs) { // not required
		return nil
	}

	if m.Nfs != nil {
		if err := m.Nfs.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("nfs")
			}
			return err
		}
	}

	return nil
}

func (m *Svm) validateNis(formats strfmt.Registry) error {

	if swag.IsZero(m.Nis) { // not required
		return nil
	}

	if m.Nis != nil {
		if err := m.Nis.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("nis")
			}
			return err
		}
	}

	return nil
}

func (m *Svm) validateNsswitch(formats strfmt.Registry) error {

	if swag.IsZero(m.Nsswitch) { // not required
		return nil
	}

	if m.Nsswitch != nil {
		if err := m.Nsswitch.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("nsswitch")
			}
			return err
		}
	}

	return nil
}

func (m *Svm) validateNvme(formats strfmt.Registry) error {

	if swag.IsZero(m.Nvme) { // not required
		return nil
	}

	if m.Nvme != nil {
		if err := m.Nvme.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("nvme")
			}
			return err
		}
	}

	return nil
}

func (m *Svm) validateRoutes(formats strfmt.Registry) error {

	if swag.IsZero(m.Routes) { // not required
		return nil
	}

	for i := 0; i < len(m.Routes); i++ {
		if swag.IsZero(m.Routes[i]) { // not required
			continue
		}

		if m.Routes[i] != nil {
			if err := m.Routes[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("routes" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *Svm) validateS3(formats strfmt.Registry) error {

	if swag.IsZero(m.S3) { // not required
		return nil
	}

	if m.S3 != nil {
		if err := m.S3.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("s3")
			}
			return err
		}
	}

	return nil
}

func (m *Svm) validateSnapmirror(formats strfmt.Registry) error {

	if swag.IsZero(m.Snapmirror) { // not required
		return nil
	}

	if m.Snapmirror != nil {
		if err := m.Snapmirror.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("snapmirror")
			}
			return err
		}
	}

	return nil
}

func (m *Svm) validateSnapshotPolicy(formats strfmt.Registry) error {

	if swag.IsZero(m.SnapshotPolicy) { // not required
		return nil
	}

	if m.SnapshotPolicy != nil {
		if err := m.SnapshotPolicy.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("snapshot_policy")
			}
			return err
		}
	}

	return nil
}

var svmTypeStatePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["starting","running","stopping","stopped","deleting"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		svmTypeStatePropEnum = append(svmTypeStatePropEnum, v)
	}
}

const (

	// SvmStateStarting captures enum value "starting"
	SvmStateStarting string = "starting"

	// SvmStateRunning captures enum value "running"
	SvmStateRunning string = "running"

	// SvmStateStopping captures enum value "stopping"
	SvmStateStopping string = "stopping"

	// SvmStateStopped captures enum value "stopped"
	SvmStateStopped string = "stopped"

	// SvmStateDeleting captures enum value "deleting"
	SvmStateDeleting string = "deleting"
)

// prop value enum
func (m *Svm) validateStateEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, svmTypeStatePropEnum); err != nil {
		return err
	}
	return nil
}

func (m *Svm) validateState(formats strfmt.Registry) error {

	if swag.IsZero(m.State) { // not required
		return nil
	}

	// value enum
	if err := m.validateStateEnum("state", "body", m.State); err != nil {
		return err
	}

	return nil
}

var svmTypeSubtypePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["default","dp_destination","sync_source","sync_destination"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		svmTypeSubtypePropEnum = append(svmTypeSubtypePropEnum, v)
	}
}

const (

	// SvmSubtypeDefault captures enum value "default"
	SvmSubtypeDefault string = "default"

	// SvmSubtypeDpDestination captures enum value "dp_destination"
	SvmSubtypeDpDestination string = "dp_destination"

	// SvmSubtypeSyncSource captures enum value "sync_source"
	SvmSubtypeSyncSource string = "sync_source"

	// SvmSubtypeSyncDestination captures enum value "sync_destination"
	SvmSubtypeSyncDestination string = "sync_destination"
)

// prop value enum
func (m *Svm) validateSubtypeEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, svmTypeSubtypePropEnum); err != nil {
		return err
	}
	return nil
}

func (m *Svm) validateSubtype(formats strfmt.Registry) error {

	if swag.IsZero(m.Subtype) { // not required
		return nil
	}

	// value enum
	if err := m.validateSubtypeEnum("subtype", "body", m.Subtype); err != nil {
		return err
	}

	return nil
}

func (m *Svm) validateUUID(formats strfmt.Registry) error {

	if swag.IsZero(m.UUID) { // not required
		return nil
	}

	if err := validate.FormatOf("uuid", "body", "uuid", m.UUID.String(), formats); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *Svm) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *Svm) UnmarshalBinary(b []byte) error {
	var res Svm
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// SvmCifs svm cifs
// swagger:model SvmCifs
type SvmCifs struct {

	// links
	Links *SvmCifsLinks `json:"_links,omitempty"`

	// ad domain
	AdDomain *AdDomain `json:"ad_domain,omitempty"`

	// Specifies whether or not the CIFS service is administratively enabled.
	//
	Enabled bool `json:"enabled,omitempty"`

	// The NetBIOS name of the CIFS server.
	// Max Length: 15
	// Min Length: 1
	Name string `json:"name,omitempty"`
}

// Validate validates this svm cifs
func (m *SvmCifs) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLinks(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateAdDomain(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateName(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *SvmCifs) validateLinks(formats strfmt.Registry) error {

	if swag.IsZero(m.Links) { // not required
		return nil
	}

	if m.Links != nil {
		if err := m.Links.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("cifs" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

func (m *SvmCifs) validateAdDomain(formats strfmt.Registry) error {

	if swag.IsZero(m.AdDomain) { // not required
		return nil
	}

	if m.AdDomain != nil {
		if err := m.AdDomain.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("cifs" + "." + "ad_domain")
			}
			return err
		}
	}

	return nil
}

func (m *SvmCifs) validateName(formats strfmt.Registry) error {

	if swag.IsZero(m.Name) { // not required
		return nil
	}

	if err := validate.MinLength("cifs"+"."+"name", "body", string(m.Name), 1); err != nil {
		return err
	}

	if err := validate.MaxLength("cifs"+"."+"name", "body", string(m.Name), 15); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *SvmCifs) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *SvmCifs) UnmarshalBinary(b []byte) error {
	var res SvmCifs
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// SvmCifsLinks svm cifs links
// swagger:model SvmCifsLinks
type SvmCifsLinks struct {

	// self
	Self *Href `json:"self,omitempty"`
}

// Validate validates this svm cifs links
func (m *SvmCifsLinks) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateSelf(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *SvmCifsLinks) validateSelf(formats strfmt.Registry) error {

	if swag.IsZero(m.Self) { // not required
		return nil
	}

	if m.Self != nil {
		if err := m.Self.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("cifs" + "." + "_links" + "." + "self")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *SvmCifsLinks) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *SvmCifsLinks) UnmarshalBinary(b []byte) error {
	var res SvmCifsLinks
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// SvmDNS svm DNS
// swagger:model SvmDNS
type SvmDNS struct {

	// links
	Links *SvmDNSLinks `json:"_links,omitempty"`

	// domains
	Domains DNSDomains `json:"domains,omitempty"`

	// servers
	Servers NameServers `json:"servers,omitempty"`
}

// Validate validates this svm DNS
func (m *SvmDNS) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLinks(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateDomains(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateServers(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *SvmDNS) validateLinks(formats strfmt.Registry) error {

	if swag.IsZero(m.Links) { // not required
		return nil
	}

	if m.Links != nil {
		if err := m.Links.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("dns" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

func (m *SvmDNS) validateDomains(formats strfmt.Registry) error {

	if swag.IsZero(m.Domains) { // not required
		return nil
	}

	if err := m.Domains.Validate(formats); err != nil {
		if ve, ok := err.(*errors.Validation); ok {
			return ve.ValidateName("dns" + "." + "domains")
		}
		return err
	}

	return nil
}

func (m *SvmDNS) validateServers(formats strfmt.Registry) error {

	if swag.IsZero(m.Servers) { // not required
		return nil
	}

	if err := m.Servers.Validate(formats); err != nil {
		if ve, ok := err.(*errors.Validation); ok {
			return ve.ValidateName("dns" + "." + "servers")
		}
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *SvmDNS) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *SvmDNS) UnmarshalBinary(b []byte) error {
	var res SvmDNS
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// SvmDNSLinks svm DNS links
// swagger:model SvmDNSLinks
type SvmDNSLinks struct {

	// self
	Self *Href `json:"self,omitempty"`
}

// Validate validates this svm DNS links
func (m *SvmDNSLinks) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateSelf(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *SvmDNSLinks) validateSelf(formats strfmt.Registry) error {

	if swag.IsZero(m.Self) { // not required
		return nil
	}

	if m.Self != nil {
		if err := m.Self.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("dns" + "." + "_links" + "." + "self")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *SvmDNSLinks) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *SvmDNSLinks) UnmarshalBinary(b []byte) error {
	var res SvmDNSLinks
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// SvmFcp svm fcp
// swagger:model SvmFcp
type SvmFcp struct {

	// links
	Links *SvmFcpLinks `json:"_links,omitempty"`

	// Enable Fiber Channel Protocol (FCP)? Setting to true creates a service if not already created.
	Enabled bool `json:"enabled,omitempty"`
}

// Validate validates this svm fcp
func (m *SvmFcp) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLinks(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *SvmFcp) validateLinks(formats strfmt.Registry) error {

	if swag.IsZero(m.Links) { // not required
		return nil
	}

	if m.Links != nil {
		if err := m.Links.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("fcp" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *SvmFcp) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *SvmFcp) UnmarshalBinary(b []byte) error {
	var res SvmFcp
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// SvmFcpLinks svm fcp links
// swagger:model SvmFcpLinks
type SvmFcpLinks struct {

	// self
	Self *Href `json:"self,omitempty"`
}

// Validate validates this svm fcp links
func (m *SvmFcpLinks) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateSelf(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *SvmFcpLinks) validateSelf(formats strfmt.Registry) error {

	if swag.IsZero(m.Self) { // not required
		return nil
	}

	if m.Self != nil {
		if err := m.Self.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("fcp" + "." + "_links" + "." + "self")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *SvmFcpLinks) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *SvmFcpLinks) UnmarshalBinary(b []byte) error {
	var res SvmFcpLinks
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// SvmIscsi svm iscsi
// swagger:model SvmIscsi
type SvmIscsi struct {

	// links
	Links *SvmIscsiLinks `json:"_links,omitempty"`

	// Enable iSCSI? Setting to true creates a service if not already created.
	Enabled bool `json:"enabled,omitempty"`
}

// Validate validates this svm iscsi
func (m *SvmIscsi) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLinks(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *SvmIscsi) validateLinks(formats strfmt.Registry) error {

	if swag.IsZero(m.Links) { // not required
		return nil
	}

	if m.Links != nil {
		if err := m.Links.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("iscsi" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *SvmIscsi) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *SvmIscsi) UnmarshalBinary(b []byte) error {
	var res SvmIscsi
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// SvmIscsiLinks svm iscsi links
// swagger:model SvmIscsiLinks
type SvmIscsiLinks struct {

	// self
	Self *Href `json:"self,omitempty"`
}

// Validate validates this svm iscsi links
func (m *SvmIscsiLinks) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateSelf(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *SvmIscsiLinks) validateSelf(formats strfmt.Registry) error {

	if swag.IsZero(m.Self) { // not required
		return nil
	}

	if m.Self != nil {
		if err := m.Self.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("iscsi" + "." + "_links" + "." + "self")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *SvmIscsiLinks) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *SvmIscsiLinks) UnmarshalBinary(b []byte) error {
	var res SvmIscsiLinks
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// SvmLinks svm links
// swagger:model SvmLinks
type SvmLinks struct {

	// self
	Self *Href `json:"self,omitempty"`
}

// Validate validates this svm links
func (m *SvmLinks) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateSelf(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *SvmLinks) validateSelf(formats strfmt.Registry) error {

	if swag.IsZero(m.Self) { // not required
		return nil
	}

	if m.Self != nil {
		if err := m.Self.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("_links" + "." + "self")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *SvmLinks) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *SvmLinks) UnmarshalBinary(b []byte) error {
	var res SvmLinks
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// SvmNfs svm nfs
// swagger:model SvmNfs
type SvmNfs struct {

	// links
	Links *SvmNfsLinks `json:"_links,omitempty"`

	// Enable NFS? Setting to true creates a service if not already created.
	Enabled bool `json:"enabled,omitempty"`
}

// Validate validates this svm nfs
func (m *SvmNfs) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLinks(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *SvmNfs) validateLinks(formats strfmt.Registry) error {

	if swag.IsZero(m.Links) { // not required
		return nil
	}

	if m.Links != nil {
		if err := m.Links.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("nfs" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *SvmNfs) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *SvmNfs) UnmarshalBinary(b []byte) error {
	var res SvmNfs
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// SvmNfsLinks svm nfs links
// swagger:model SvmNfsLinks
type SvmNfsLinks struct {

	// self
	Self *Href `json:"self,omitempty"`
}

// Validate validates this svm nfs links
func (m *SvmNfsLinks) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateSelf(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *SvmNfsLinks) validateSelf(formats strfmt.Registry) error {

	if swag.IsZero(m.Self) { // not required
		return nil
	}

	if m.Self != nil {
		if err := m.Self.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("nfs" + "." + "_links" + "." + "self")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *SvmNfsLinks) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *SvmNfsLinks) UnmarshalBinary(b []byte) error {
	var res SvmNfsLinks
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// SvmNis svm nis
// swagger:model SvmNis
type SvmNis struct {

	// links
	Links *SvmNisLinks `json:"_links,omitempty"`

	// domain
	Domain NisDomain `json:"domain,omitempty"`

	// Enable NIS? Setting to true creates a configuration if not already created.
	Enabled bool `json:"enabled,omitempty"`

	// servers
	Servers NisServers `json:"servers,omitempty"`
}

// Validate validates this svm nis
func (m *SvmNis) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLinks(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateDomain(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateServers(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *SvmNis) validateLinks(formats strfmt.Registry) error {

	if swag.IsZero(m.Links) { // not required
		return nil
	}

	if m.Links != nil {
		if err := m.Links.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("nis" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

func (m *SvmNis) validateDomain(formats strfmt.Registry) error {

	if swag.IsZero(m.Domain) { // not required
		return nil
	}

	if err := m.Domain.Validate(formats); err != nil {
		if ve, ok := err.(*errors.Validation); ok {
			return ve.ValidateName("nis" + "." + "domain")
		}
		return err
	}

	return nil
}

func (m *SvmNis) validateServers(formats strfmt.Registry) error {

	if swag.IsZero(m.Servers) { // not required
		return nil
	}

	if err := m.Servers.Validate(formats); err != nil {
		if ve, ok := err.(*errors.Validation); ok {
			return ve.ValidateName("nis" + "." + "servers")
		}
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *SvmNis) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *SvmNis) UnmarshalBinary(b []byte) error {
	var res SvmNis
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// SvmNisLinks svm nis links
// swagger:model SvmNisLinks
type SvmNisLinks struct {

	// self
	Self *Href `json:"self,omitempty"`
}

// Validate validates this svm nis links
func (m *SvmNisLinks) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateSelf(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *SvmNisLinks) validateSelf(formats strfmt.Registry) error {

	if swag.IsZero(m.Self) { // not required
		return nil
	}

	if m.Self != nil {
		if err := m.Self.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("nis" + "." + "_links" + "." + "self")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *SvmNisLinks) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *SvmNisLinks) UnmarshalBinary(b []byte) error {
	var res SvmNisLinks
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// SvmNsswitch Name service switch configuration
// swagger:model SvmNsswitch
type SvmNsswitch struct {

	// Group sources
	Group []NsswitchSource `json:"group"`

	// Host sources
	Hosts []NsswitchSource `json:"hosts"`

	// NameMap sources
	Namemap []NsswitchSource `json:"namemap"`

	// NetGroup sources
	Netgroup []NsswitchSource `json:"netgroup"`

	// Password sources
	Passwd []NsswitchSource `json:"passwd"`
}

// Validate validates this svm nsswitch
func (m *SvmNsswitch) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateGroup(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateHosts(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateNamemap(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateNetgroup(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validatePasswd(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *SvmNsswitch) validateGroup(formats strfmt.Registry) error {

	if swag.IsZero(m.Group) { // not required
		return nil
	}

	for i := 0; i < len(m.Group); i++ {

		if err := m.Group[i].Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("nsswitch" + "." + "group" + "." + strconv.Itoa(i))
			}
			return err
		}

	}

	return nil
}

func (m *SvmNsswitch) validateHosts(formats strfmt.Registry) error {

	if swag.IsZero(m.Hosts) { // not required
		return nil
	}

	for i := 0; i < len(m.Hosts); i++ {

		if err := m.Hosts[i].Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("nsswitch" + "." + "hosts" + "." + strconv.Itoa(i))
			}
			return err
		}

	}

	return nil
}

func (m *SvmNsswitch) validateNamemap(formats strfmt.Registry) error {

	if swag.IsZero(m.Namemap) { // not required
		return nil
	}

	for i := 0; i < len(m.Namemap); i++ {

		if err := m.Namemap[i].Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("nsswitch" + "." + "namemap" + "." + strconv.Itoa(i))
			}
			return err
		}

	}

	return nil
}

func (m *SvmNsswitch) validateNetgroup(formats strfmt.Registry) error {

	if swag.IsZero(m.Netgroup) { // not required
		return nil
	}

	for i := 0; i < len(m.Netgroup); i++ {

		if err := m.Netgroup[i].Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("nsswitch" + "." + "netgroup" + "." + strconv.Itoa(i))
			}
			return err
		}

	}

	return nil
}

func (m *SvmNsswitch) validatePasswd(formats strfmt.Registry) error {

	if swag.IsZero(m.Passwd) { // not required
		return nil
	}

	for i := 0; i < len(m.Passwd); i++ {

		if err := m.Passwd[i].Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("nsswitch" + "." + "passwd" + "." + strconv.Itoa(i))
			}
			return err
		}

	}

	return nil
}

// MarshalBinary interface implementation
func (m *SvmNsswitch) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *SvmNsswitch) UnmarshalBinary(b []byte) error {
	var res SvmNsswitch
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// SvmNvme svm nvme
// swagger:model SvmNvme
type SvmNvme struct {

	// links
	Links *SvmNvmeLinks `json:"_links,omitempty"`

	// Enable NVMe? Setting to true creates a service if not already created.
	Enabled bool `json:"enabled,omitempty"`
}

// Validate validates this svm nvme
func (m *SvmNvme) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLinks(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *SvmNvme) validateLinks(formats strfmt.Registry) error {

	if swag.IsZero(m.Links) { // not required
		return nil
	}

	if m.Links != nil {
		if err := m.Links.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("nvme" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *SvmNvme) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *SvmNvme) UnmarshalBinary(b []byte) error {
	var res SvmNvme
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// SvmNvmeLinks svm nvme links
// swagger:model SvmNvmeLinks
type SvmNvmeLinks struct {

	// self
	Self *Href `json:"self,omitempty"`
}

// Validate validates this svm nvme links
func (m *SvmNvmeLinks) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateSelf(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *SvmNvmeLinks) validateSelf(formats strfmt.Registry) error {

	if swag.IsZero(m.Self) { // not required
		return nil
	}

	if m.Self != nil {
		if err := m.Self.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("nvme" + "." + "_links" + "." + "self")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *SvmNvmeLinks) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *SvmNvmeLinks) UnmarshalBinary(b []byte) error {
	var res SvmNvmeLinks
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// SvmSnapmirror Specifies attributes for SVM DR protection.
// swagger:model SvmSnapmirror
type SvmSnapmirror struct {

	// Specifies whether the SVM is a SnapMirror source SVM, using SnapMirror to protect its data.
	// Read Only: true
	IsProtected *bool `json:"is_protected,omitempty"`

	// Specifies the number of SVM DR protected volumes in the SVM.
	// Read Only: true
	ProtectedVolumesCount int64 `json:"protected_volumes_count,omitempty"`
}

// Validate validates this svm snapmirror
func (m *SvmSnapmirror) Validate(formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *SvmSnapmirror) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *SvmSnapmirror) UnmarshalBinary(b []byte) error {
	var res SvmSnapmirror
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
