// Code generated by go-swagger; DO NOT EDIT.

package ntapmodel

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"strconv"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// Volume volume
// swagger:model volume
type Volume struct {

	// links
	Links *VolumeLinks `json:"_links,omitempty"`

	// Aggregate hosting the volume. Required on POST.
	Aggregates []*AggregateReference `json:"aggregates,omitempty"`

	// application
	Application *VolumeApplication `json:"application,omitempty"`

	// autosize
	Autosize *VolumeAutosize `json:"autosize,omitempty"`

	// clone
	Clone *VolumeClone `json:"clone,omitempty"`

	// A comment for the volume. Valid in POST or PATCH.
	// Max Length: 1023
	// Min Length: 0
	Comment *string `json:"comment,omitempty"`

	// consistency group
	ConsistencyGroup *VolumeConsistencyGroup `json:"consistency_group,omitempty"`

	// Specifies the number of times to iterate over the aggregates listed with the "aggregates.name" or "aggregates.uuid" when creating or expanding a FlexGroup. If a volume is being created on a single aggregate, the system will create a flexible volume if the "constituents_per_aggregate" field is not specified, and a FlexGroup if it is specified.  If a volume is being created on multiple aggregates, the system will always create a FlexGroup.
	// Maximum: 1000
	// Minimum: 1
	ConstituentsPerAggregate int64 `json:"constituents_per_aggregate,omitempty"`

	// Creation time of the volume. This field is generated when the volume is created.
	// Read Only: true
	// Format: date-time
	CreateTime strfmt.DateTime `json:"create_time,omitempty"`

	// efficiency
	Efficiency *VolumeEfficiency `json:"efficiency,omitempty"`

	// encryption
	Encryption *VolumeEncryption `json:"encryption,omitempty"`

	// error state
	ErrorState *VolumeErrorState `json:"error_state,omitempty"`

	// files
	Files *VolumeFiles `json:"files,omitempty"`

	// FlexCache endpoint type. <br>none &dash; The volume is neither a FlexCache nor origin of any FlexCache. <br>cache &dash; The volume is a FlexCache volume. <br>origin &dash; The volume is origin of a FlexCache volume.
	// Read Only: true
	// Enum: [none cache origin]
	FlexcacheEndpointType string `json:"flexcache_endpoint_type,omitempty"`

	// guarantee
	Guarantee *VolumeGuarantee `json:"guarantee,omitempty"`

	// Specifies whether the volume is a root volume of the SVM it belongs to.
	// Read Only: true
	IsSvmRoot *bool `json:"is_svm_root,omitempty"`

	// Language encoding setting for volume. If no language is specified, the volume inherits its SVM language encoding setting.
	// Enum: [ar ar.utf_8 c c.utf_8 cs cs.utf_8 da da.utf_8 de de.utf_8 en en.utf_8 en_us en_us.utf_8 es es.utf_8 fi fi.utf_8 fr fr.utf_8 he he.utf_8 hr hr.utf_8 hu hu.utf_8 it it.utf_8 ja ja.utf_8 ja_jp.932 ja_jp.932.utf_8 ja_jp.pck ja_jp.pck.utf_8 ja_jp.pck_v2 ja_jp.pck_v2.utf_8 ja_v1 ja_v1.utf_8 ko ko.utf_8 nl nl.utf_8 no no.utf_8 pl pl.utf_8 pt pt.utf_8 ro ro.utf_8 ru ru.utf_8 sk sk.utf_8 sl sl.utf_8 sv sv.utf_8 tr tr.utf_8 utf8mb4 zh zh.gbk zh.gbk.utf_8 zh.utf_8 zh_tw zh_tw.big5 zh_tw.big5.utf_8 zh_tw.utf_8]
	Language string `json:"language,omitempty"`

	// metric
	Metric *VolumeMetrics `json:"metric,omitempty"`

	// movement
	Movement *VolumeMovement `json:"movement,omitempty"`

	// Volume name. The name of volume must start with an alphabetic character (a to z or A to Z) or an underscore (_). The name must be 197 or fewer characters in length for FlexGroups, and 203 or fewer characters in length for all other types of volumes. Volume names must be unique within an SVM. Required on POST.
	// Max Length: 203
	// Min Length: 1
	Name string `json:"name,omitempty"`

	// nas
	Nas *VolumeNas `json:"nas,omitempty"`

	// qos
	Qos *VolumeQos `json:"qos,omitempty"`

	// quota
	Quota *VolumeQuota `json:"quota,omitempty"`

	// Physical size of the volume, in bytes. The minimum size for a FlexVol volume is 20MB and the minimum size for a FlexGroup volume is 200MB per constituent. The recommended size for a FlexGroup volume is a minimum of 100GB per constituent. For all volumes, the default size is equal to the minimum size.
	Size int64 `json:"size,omitempty"`

	// snaplock
	Snaplock *VolumeSnaplock `json:"snaplock,omitempty"`

	// snapmirror
	Snapmirror *VolumeSnapmirror `json:"snapmirror,omitempty"`

	// snapshot policy
	SnapshotPolicy *SnapshotPolicyReference `json:"snapshot_policy,omitempty"`

	// space
	Space *VolumeSpace `json:"space,omitempty"`

	// Volume state. A volume can only be brought online if it is offline. Taking a volume offline removes its junction path. The 'mixed' state applies to FlexGroup volumes only and cannot be specified as a target state. An 'error' state implies that the volume is not in a state to serve data.
	// Enum: [error mixed offline online]
	State string `json:"state,omitempty"`

	// statistics
	Statistics *VolumeStatisticsReference `json:"statistics,omitempty"`

	// The style of the volume. If "style" is not specified, the volume type is determined based on the specified aggregates. Specifying a single aggregate, without "constituents_per_aggregate", creates a flexible volume. Specifying multiple aggregates, or a single aggregate with "constituents_per_aggregate", creates a FlexGroup. Specifying a volume "style" creates a volume of that type. For example, if the style is "flexvol" you must specify a single aggregate. If the style is "flexgroup", the system either uses the specified aggregates or automatically provisions aggregates if there are no specified aggregates.<br>flexvol &dash; flexible volumes and FlexClone volumes<br>flexgroup &dash; FlexGroups.
	// Enum: [flexvol flexgroup]
	Style string `json:"style,omitempty"`

	// svm
	Svm *SvmReference `json:"svm,omitempty"`

	// tiering
	Tiering *VolumeTiering `json:"tiering,omitempty"`

	// Type of the volume.<br>rw &dash; read-write volume.<br>dp &dash; data-protection volume.<br>ls &dash; load-sharing `dp` volume. Valid in GET.
	// Enum: [rw dp ls]
	Type *string `json:"type,omitempty"`

	// Specifies whether mirrored aggregates are selected when provisioning a FlexGroup without specifying "aggregates.name" or "aggregates.uuid". Only mirrored aggregates are used if this parameter is set to 'true' and only unmirrored aggregates are used if this parameter is set to 'false'. Aggregate level mirroring for a FlexGroup can be changed by moving all of the constituents to the required aggregates. The default value is 'true' for a MetroCluster configuration and is 'false' for a non-MetroCluster configuration.
	UseMirroredAggregates bool `json:"use_mirrored_aggregates,omitempty"`

	// Unique identifier for the volume. This corresponds to the instance-uuid that is exposed in the CLI and ONTAPI. It does not change due to a volume move.
	// Read Only: true
	// Format: uuid
	UUID strfmt.UUID `json:"uuid,omitempty"`
}

// Validate validates this volume
func (m *Volume) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLinks(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateAggregates(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateApplication(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateAutosize(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateClone(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateComment(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateConsistencyGroup(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateConstituentsPerAggregate(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateCreateTime(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateEfficiency(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateEncryption(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateErrorState(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateFiles(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateFlexcacheEndpointType(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateGuarantee(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateLanguage(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateMetric(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateMovement(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateName(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateNas(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateQos(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateQuota(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSnaplock(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSnapmirror(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSnapshotPolicy(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSpace(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateState(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateStatistics(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateStyle(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSvm(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateTiering(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateType(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateUUID(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *Volume) validateLinks(formats strfmt.Registry) error {

	if swag.IsZero(m.Links) { // not required
		return nil
	}

	if m.Links != nil {
		if err := m.Links.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("_links")
			}
			return err
		}
	}

	return nil
}

func (m *Volume) validateAggregates(formats strfmt.Registry) error {

	if swag.IsZero(m.Aggregates) { // not required
		return nil
	}

	for i := 0; i < len(m.Aggregates); i++ {
		if swag.IsZero(m.Aggregates[i]) { // not required
			continue
		}

		if m.Aggregates[i] != nil {
			if err := m.Aggregates[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("aggregates" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *Volume) validateApplication(formats strfmt.Registry) error {

	if swag.IsZero(m.Application) { // not required
		return nil
	}

	if m.Application != nil {
		if err := m.Application.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("application")
			}
			return err
		}
	}

	return nil
}

func (m *Volume) validateAutosize(formats strfmt.Registry) error {

	if swag.IsZero(m.Autosize) { // not required
		return nil
	}

	if m.Autosize != nil {
		if err := m.Autosize.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("autosize")
			}
			return err
		}
	}

	return nil
}

func (m *Volume) validateClone(formats strfmt.Registry) error {

	if swag.IsZero(m.Clone) { // not required
		return nil
	}

	if m.Clone != nil {
		if err := m.Clone.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("clone")
			}
			return err
		}
	}

	return nil
}

func (m *Volume) validateComment(formats strfmt.Registry) error {

	if swag.IsZero(m.Comment) { // not required
		return nil
	}

	if err := validate.MinLength("comment", "body", string(*m.Comment), 0); err != nil {
		return err
	}

	if err := validate.MaxLength("comment", "body", string(*m.Comment), 1023); err != nil {
		return err
	}

	return nil
}

func (m *Volume) validateConsistencyGroup(formats strfmt.Registry) error {

	if swag.IsZero(m.ConsistencyGroup) { // not required
		return nil
	}

	if m.ConsistencyGroup != nil {
		if err := m.ConsistencyGroup.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("consistency_group")
			}
			return err
		}
	}

	return nil
}

func (m *Volume) validateConstituentsPerAggregate(formats strfmt.Registry) error {

	if swag.IsZero(m.ConstituentsPerAggregate) { // not required
		return nil
	}

	if err := validate.MinimumInt("constituents_per_aggregate", "body", int64(m.ConstituentsPerAggregate), 1, false); err != nil {
		return err
	}

	if err := validate.MaximumInt("constituents_per_aggregate", "body", int64(m.ConstituentsPerAggregate), 1000, false); err != nil {
		return err
	}

	return nil
}

func (m *Volume) validateCreateTime(formats strfmt.Registry) error {

	if swag.IsZero(m.CreateTime) { // not required
		return nil
	}

	if err := validate.FormatOf("create_time", "body", "date-time", m.CreateTime.String(), formats); err != nil {
		return err
	}

	return nil
}

func (m *Volume) validateEfficiency(formats strfmt.Registry) error {

	if swag.IsZero(m.Efficiency) { // not required
		return nil
	}

	if m.Efficiency != nil {
		if err := m.Efficiency.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("efficiency")
			}
			return err
		}
	}

	return nil
}

func (m *Volume) validateEncryption(formats strfmt.Registry) error {

	if swag.IsZero(m.Encryption) { // not required
		return nil
	}

	if m.Encryption != nil {
		if err := m.Encryption.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("encryption")
			}
			return err
		}
	}

	return nil
}

func (m *Volume) validateErrorState(formats strfmt.Registry) error {

	if swag.IsZero(m.ErrorState) { // not required
		return nil
	}

	if m.ErrorState != nil {
		if err := m.ErrorState.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("error_state")
			}
			return err
		}
	}

	return nil
}

func (m *Volume) validateFiles(formats strfmt.Registry) error {

	if swag.IsZero(m.Files) { // not required
		return nil
	}

	if m.Files != nil {
		if err := m.Files.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("files")
			}
			return err
		}
	}

	return nil
}

var volumeTypeFlexcacheEndpointTypePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["none","cache","origin"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		volumeTypeFlexcacheEndpointTypePropEnum = append(volumeTypeFlexcacheEndpointTypePropEnum, v)
	}
}

const (

	// VolumeFlexcacheEndpointTypeNone captures enum value "none"
	VolumeFlexcacheEndpointTypeNone string = "none"

	// VolumeFlexcacheEndpointTypeCache captures enum value "cache"
	VolumeFlexcacheEndpointTypeCache string = "cache"

	// VolumeFlexcacheEndpointTypeOrigin captures enum value "origin"
	VolumeFlexcacheEndpointTypeOrigin string = "origin"
)

// prop value enum
func (m *Volume) validateFlexcacheEndpointTypeEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, volumeTypeFlexcacheEndpointTypePropEnum); err != nil {
		return err
	}
	return nil
}

func (m *Volume) validateFlexcacheEndpointType(formats strfmt.Registry) error {

	if swag.IsZero(m.FlexcacheEndpointType) { // not required
		return nil
	}

	// value enum
	if err := m.validateFlexcacheEndpointTypeEnum("flexcache_endpoint_type", "body", m.FlexcacheEndpointType); err != nil {
		return err
	}

	return nil
}

func (m *Volume) validateGuarantee(formats strfmt.Registry) error {

	if swag.IsZero(m.Guarantee) { // not required
		return nil
	}

	if m.Guarantee != nil {
		if err := m.Guarantee.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("guarantee")
			}
			return err
		}
	}

	return nil
}

var volumeTypeLanguagePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["ar","ar.utf_8","c","c.utf_8","cs","cs.utf_8","da","da.utf_8","de","de.utf_8","en","en.utf_8","en_us","en_us.utf_8","es","es.utf_8","fi","fi.utf_8","fr","fr.utf_8","he","he.utf_8","hr","hr.utf_8","hu","hu.utf_8","it","it.utf_8","ja","ja.utf_8","ja_jp.932","ja_jp.932.utf_8","ja_jp.pck","ja_jp.pck.utf_8","ja_jp.pck_v2","ja_jp.pck_v2.utf_8","ja_v1","ja_v1.utf_8","ko","ko.utf_8","nl","nl.utf_8","no","no.utf_8","pl","pl.utf_8","pt","pt.utf_8","ro","ro.utf_8","ru","ru.utf_8","sk","sk.utf_8","sl","sl.utf_8","sv","sv.utf_8","tr","tr.utf_8","utf8mb4","zh","zh.gbk","zh.gbk.utf_8","zh.utf_8","zh_tw","zh_tw.big5","zh_tw.big5.utf_8","zh_tw.utf_8"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		volumeTypeLanguagePropEnum = append(volumeTypeLanguagePropEnum, v)
	}
}

const (

	// VolumeLanguageAr captures enum value "ar"
	VolumeLanguageAr string = "ar"

	// VolumeLanguageArUTF8 captures enum value "ar.utf_8"
	VolumeLanguageArUTF8 string = "ar.utf_8"

	// VolumeLanguageC captures enum value "c"
	VolumeLanguageC string = "c"

	// VolumeLanguageCUTF8 captures enum value "c.utf_8"
	VolumeLanguageCUTF8 string = "c.utf_8"

	// VolumeLanguageCs captures enum value "cs"
	VolumeLanguageCs string = "cs"

	// VolumeLanguageCsUTF8 captures enum value "cs.utf_8"
	VolumeLanguageCsUTF8 string = "cs.utf_8"

	// VolumeLanguageDa captures enum value "da"
	VolumeLanguageDa string = "da"

	// VolumeLanguageDaUTF8 captures enum value "da.utf_8"
	VolumeLanguageDaUTF8 string = "da.utf_8"

	// VolumeLanguageDe captures enum value "de"
	VolumeLanguageDe string = "de"

	// VolumeLanguageDeUTF8 captures enum value "de.utf_8"
	VolumeLanguageDeUTF8 string = "de.utf_8"

	// VolumeLanguageEn captures enum value "en"
	VolumeLanguageEn string = "en"

	// VolumeLanguageEnUTF8 captures enum value "en.utf_8"
	VolumeLanguageEnUTF8 string = "en.utf_8"

	// VolumeLanguageEnUs captures enum value "en_us"
	VolumeLanguageEnUs string = "en_us"

	// VolumeLanguageEnUsUTF8 captures enum value "en_us.utf_8"
	VolumeLanguageEnUsUTF8 string = "en_us.utf_8"

	// VolumeLanguageEs captures enum value "es"
	VolumeLanguageEs string = "es"

	// VolumeLanguageEsUTF8 captures enum value "es.utf_8"
	VolumeLanguageEsUTF8 string = "es.utf_8"

	// VolumeLanguageFi captures enum value "fi"
	VolumeLanguageFi string = "fi"

	// VolumeLanguageFiUTF8 captures enum value "fi.utf_8"
	VolumeLanguageFiUTF8 string = "fi.utf_8"

	// VolumeLanguageFr captures enum value "fr"
	VolumeLanguageFr string = "fr"

	// VolumeLanguageFrUTF8 captures enum value "fr.utf_8"
	VolumeLanguageFrUTF8 string = "fr.utf_8"

	// VolumeLanguageHe captures enum value "he"
	VolumeLanguageHe string = "he"

	// VolumeLanguageHeUTF8 captures enum value "he.utf_8"
	VolumeLanguageHeUTF8 string = "he.utf_8"

	// VolumeLanguageHr captures enum value "hr"
	VolumeLanguageHr string = "hr"

	// VolumeLanguageHrUTF8 captures enum value "hr.utf_8"
	VolumeLanguageHrUTF8 string = "hr.utf_8"

	// VolumeLanguageHu captures enum value "hu"
	VolumeLanguageHu string = "hu"

	// VolumeLanguageHuUTF8 captures enum value "hu.utf_8"
	VolumeLanguageHuUTF8 string = "hu.utf_8"

	// VolumeLanguageIt captures enum value "it"
	VolumeLanguageIt string = "it"

	// VolumeLanguageItUTF8 captures enum value "it.utf_8"
	VolumeLanguageItUTF8 string = "it.utf_8"

	// VolumeLanguageJa captures enum value "ja"
	VolumeLanguageJa string = "ja"

	// VolumeLanguageJaUTF8 captures enum value "ja.utf_8"
	VolumeLanguageJaUTF8 string = "ja.utf_8"

	// VolumeLanguageJaJp932 captures enum value "ja_jp.932"
	VolumeLanguageJaJp932 string = "ja_jp.932"

	// VolumeLanguageJaJp932UTF8 captures enum value "ja_jp.932.utf_8"
	VolumeLanguageJaJp932UTF8 string = "ja_jp.932.utf_8"

	// VolumeLanguageJaJpPck captures enum value "ja_jp.pck"
	VolumeLanguageJaJpPck string = "ja_jp.pck"

	// VolumeLanguageJaJpPckUTF8 captures enum value "ja_jp.pck.utf_8"
	VolumeLanguageJaJpPckUTF8 string = "ja_jp.pck.utf_8"

	// VolumeLanguageJaJpPckV2 captures enum value "ja_jp.pck_v2"
	VolumeLanguageJaJpPckV2 string = "ja_jp.pck_v2"

	// VolumeLanguageJaJpPckV2UTF8 captures enum value "ja_jp.pck_v2.utf_8"
	VolumeLanguageJaJpPckV2UTF8 string = "ja_jp.pck_v2.utf_8"

	// VolumeLanguageJaV1 captures enum value "ja_v1"
	VolumeLanguageJaV1 string = "ja_v1"

	// VolumeLanguageJaV1UTF8 captures enum value "ja_v1.utf_8"
	VolumeLanguageJaV1UTF8 string = "ja_v1.utf_8"

	// VolumeLanguageKo captures enum value "ko"
	VolumeLanguageKo string = "ko"

	// VolumeLanguageKoUTF8 captures enum value "ko.utf_8"
	VolumeLanguageKoUTF8 string = "ko.utf_8"

	// VolumeLanguageNl captures enum value "nl"
	VolumeLanguageNl string = "nl"

	// VolumeLanguageNlUTF8 captures enum value "nl.utf_8"
	VolumeLanguageNlUTF8 string = "nl.utf_8"

	// VolumeLanguageNo captures enum value "no"
	VolumeLanguageNo string = "no"

	// VolumeLanguageNoUTF8 captures enum value "no.utf_8"
	VolumeLanguageNoUTF8 string = "no.utf_8"

	// VolumeLanguagePl captures enum value "pl"
	VolumeLanguagePl string = "pl"

	// VolumeLanguagePlUTF8 captures enum value "pl.utf_8"
	VolumeLanguagePlUTF8 string = "pl.utf_8"

	// VolumeLanguagePt captures enum value "pt"
	VolumeLanguagePt string = "pt"

	// VolumeLanguagePtUTF8 captures enum value "pt.utf_8"
	VolumeLanguagePtUTF8 string = "pt.utf_8"

	// VolumeLanguageRo captures enum value "ro"
	VolumeLanguageRo string = "ro"

	// VolumeLanguageRoUTF8 captures enum value "ro.utf_8"
	VolumeLanguageRoUTF8 string = "ro.utf_8"

	// VolumeLanguageRu captures enum value "ru"
	VolumeLanguageRu string = "ru"

	// VolumeLanguageRuUTF8 captures enum value "ru.utf_8"
	VolumeLanguageRuUTF8 string = "ru.utf_8"

	// VolumeLanguageSk captures enum value "sk"
	VolumeLanguageSk string = "sk"

	// VolumeLanguageSkUTF8 captures enum value "sk.utf_8"
	VolumeLanguageSkUTF8 string = "sk.utf_8"

	// VolumeLanguageSl captures enum value "sl"
	VolumeLanguageSl string = "sl"

	// VolumeLanguageSlUTF8 captures enum value "sl.utf_8"
	VolumeLanguageSlUTF8 string = "sl.utf_8"

	// VolumeLanguageSv captures enum value "sv"
	VolumeLanguageSv string = "sv"

	// VolumeLanguageSvUTF8 captures enum value "sv.utf_8"
	VolumeLanguageSvUTF8 string = "sv.utf_8"

	// VolumeLanguageTr captures enum value "tr"
	VolumeLanguageTr string = "tr"

	// VolumeLanguageTrUTF8 captures enum value "tr.utf_8"
	VolumeLanguageTrUTF8 string = "tr.utf_8"

	// VolumeLanguageUtf8mb4 captures enum value "utf8mb4"
	VolumeLanguageUtf8mb4 string = "utf8mb4"

	// VolumeLanguageZh captures enum value "zh"
	VolumeLanguageZh string = "zh"

	// VolumeLanguageZhGbk captures enum value "zh.gbk"
	VolumeLanguageZhGbk string = "zh.gbk"

	// VolumeLanguageZhGbkUTF8 captures enum value "zh.gbk.utf_8"
	VolumeLanguageZhGbkUTF8 string = "zh.gbk.utf_8"

	// VolumeLanguageZhUTF8 captures enum value "zh.utf_8"
	VolumeLanguageZhUTF8 string = "zh.utf_8"

	// VolumeLanguageZhTw captures enum value "zh_tw"
	VolumeLanguageZhTw string = "zh_tw"

	// VolumeLanguageZhTwBig5 captures enum value "zh_tw.big5"
	VolumeLanguageZhTwBig5 string = "zh_tw.big5"

	// VolumeLanguageZhTwBig5UTF8 captures enum value "zh_tw.big5.utf_8"
	VolumeLanguageZhTwBig5UTF8 string = "zh_tw.big5.utf_8"

	// VolumeLanguageZhTwUTF8 captures enum value "zh_tw.utf_8"
	VolumeLanguageZhTwUTF8 string = "zh_tw.utf_8"
)

// prop value enum
func (m *Volume) validateLanguageEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, volumeTypeLanguagePropEnum); err != nil {
		return err
	}
	return nil
}

func (m *Volume) validateLanguage(formats strfmt.Registry) error {

	if swag.IsZero(m.Language) { // not required
		return nil
	}

	// value enum
	if err := m.validateLanguageEnum("language", "body", m.Language); err != nil {
		return err
	}

	return nil
}

func (m *Volume) validateMetric(formats strfmt.Registry) error {

	if swag.IsZero(m.Metric) { // not required
		return nil
	}

	if m.Metric != nil {
		if err := m.Metric.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("metric")
			}
			return err
		}
	}

	return nil
}

func (m *Volume) validateMovement(formats strfmt.Registry) error {

	if swag.IsZero(m.Movement) { // not required
		return nil
	}

	if m.Movement != nil {
		if err := m.Movement.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("movement")
			}
			return err
		}
	}

	return nil
}

func (m *Volume) validateName(formats strfmt.Registry) error {

	if swag.IsZero(m.Name) { // not required
		return nil
	}

	if err := validate.MinLength("name", "body", string(m.Name), 1); err != nil {
		return err
	}

	if err := validate.MaxLength("name", "body", string(m.Name), 203); err != nil {
		return err
	}

	return nil
}

func (m *Volume) validateNas(formats strfmt.Registry) error {

	if swag.IsZero(m.Nas) { // not required
		return nil
	}

	if m.Nas != nil {
		if err := m.Nas.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("nas")
			}
			return err
		}
	}

	return nil
}

func (m *Volume) validateQos(formats strfmt.Registry) error {

	if swag.IsZero(m.Qos) { // not required
		return nil
	}

	if m.Qos != nil {
		if err := m.Qos.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("qos")
			}
			return err
		}
	}

	return nil
}

func (m *Volume) validateQuota(formats strfmt.Registry) error {

	if swag.IsZero(m.Quota) { // not required
		return nil
	}

	if m.Quota != nil {
		if err := m.Quota.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("quota")
			}
			return err
		}
	}

	return nil
}

func (m *Volume) validateSnaplock(formats strfmt.Registry) error {

	if swag.IsZero(m.Snaplock) { // not required
		return nil
	}

	if m.Snaplock != nil {
		if err := m.Snaplock.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("snaplock")
			}
			return err
		}
	}

	return nil
}

func (m *Volume) validateSnapmirror(formats strfmt.Registry) error {

	if swag.IsZero(m.Snapmirror) { // not required
		return nil
	}

	if m.Snapmirror != nil {
		if err := m.Snapmirror.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("snapmirror")
			}
			return err
		}
	}

	return nil
}

func (m *Volume) validateSnapshotPolicy(formats strfmt.Registry) error {

	if swag.IsZero(m.SnapshotPolicy) { // not required
		return nil
	}

	if m.SnapshotPolicy != nil {
		if err := m.SnapshotPolicy.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("snapshot_policy")
			}
			return err
		}
	}

	return nil
}

func (m *Volume) validateSpace(formats strfmt.Registry) error {

	if swag.IsZero(m.Space) { // not required
		return nil
	}

	if m.Space != nil {
		if err := m.Space.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("space")
			}
			return err
		}
	}

	return nil
}

var volumeTypeStatePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["error","mixed","offline","online"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		volumeTypeStatePropEnum = append(volumeTypeStatePropEnum, v)
	}
}

const (

	// VolumeStateError captures enum value "error"
	VolumeStateError string = "error"

	// VolumeStateMixed captures enum value "mixed"
	VolumeStateMixed string = "mixed"

	// VolumeStateOffline captures enum value "offline"
	VolumeStateOffline string = "offline"

	// VolumeStateOnline captures enum value "online"
	VolumeStateOnline string = "online"
)

// prop value enum
func (m *Volume) validateStateEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, volumeTypeStatePropEnum); err != nil {
		return err
	}
	return nil
}

func (m *Volume) validateState(formats strfmt.Registry) error {

	if swag.IsZero(m.State) { // not required
		return nil
	}

	// value enum
	if err := m.validateStateEnum("state", "body", m.State); err != nil {
		return err
	}

	return nil
}

func (m *Volume) validateStatistics(formats strfmt.Registry) error {

	if swag.IsZero(m.Statistics) { // not required
		return nil
	}

	if m.Statistics != nil {
		if err := m.Statistics.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("statistics")
			}
			return err
		}
	}

	return nil
}

var volumeTypeStylePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["flexvol","flexgroup"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		volumeTypeStylePropEnum = append(volumeTypeStylePropEnum, v)
	}
}

const (

	// VolumeStyleFlexvol captures enum value "flexvol"
	VolumeStyleFlexvol string = "flexvol"

	// VolumeStyleFlexgroup captures enum value "flexgroup"
	VolumeStyleFlexgroup string = "flexgroup"
)

// prop value enum
func (m *Volume) validateStyleEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, volumeTypeStylePropEnum); err != nil {
		return err
	}
	return nil
}

func (m *Volume) validateStyle(formats strfmt.Registry) error {

	if swag.IsZero(m.Style) { // not required
		return nil
	}

	// value enum
	if err := m.validateStyleEnum("style", "body", m.Style); err != nil {
		return err
	}

	return nil
}

func (m *Volume) validateSvm(formats strfmt.Registry) error {

	if swag.IsZero(m.Svm) { // not required
		return nil
	}

	if m.Svm != nil {
		if err := m.Svm.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("svm")
			}
			return err
		}
	}

	return nil
}

func (m *Volume) validateTiering(formats strfmt.Registry) error {

	if swag.IsZero(m.Tiering) { // not required
		return nil
	}

	if m.Tiering != nil {
		if err := m.Tiering.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("tiering")
			}
			return err
		}
	}

	return nil
}

var volumeTypeTypePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["rw","dp","ls"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		volumeTypeTypePropEnum = append(volumeTypeTypePropEnum, v)
	}
}

const (

	// VolumeTypeRw captures enum value "rw"
	VolumeTypeRw string = "rw"

	// VolumeTypeDp captures enum value "dp"
	VolumeTypeDp string = "dp"

	// VolumeTypeLs captures enum value "ls"
	VolumeTypeLs string = "ls"
)

// prop value enum
func (m *Volume) validateTypeEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, volumeTypeTypePropEnum); err != nil {
		return err
	}
	return nil
}

func (m *Volume) validateType(formats strfmt.Registry) error {

	if swag.IsZero(m.Type) { // not required
		return nil
	}

	// value enum
	if err := m.validateTypeEnum("type", "body", *m.Type); err != nil {
		return err
	}

	return nil
}

func (m *Volume) validateUUID(formats strfmt.Registry) error {

	if swag.IsZero(m.UUID) { // not required
		return nil
	}

	if err := validate.FormatOf("uuid", "body", "uuid", m.UUID.String(), formats); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *Volume) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *Volume) UnmarshalBinary(b []byte) error {
	var res Volume
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// VolumeApplication volume application
// swagger:model VolumeApplication
type VolumeApplication struct {

	// Name of the application to which the volume belongs. Available only when the volume is part of an application.
	// Read Only: true
	Name string `json:"name,omitempty"`

	// UUID of the application to which the volume belongs. Available only when the volume is part of an application.
	// Read Only: true
	// Format: uuid
	UUID strfmt.UUID `json:"uuid,omitempty"`
}

// Validate validates this volume application
func (m *VolumeApplication) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateUUID(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *VolumeApplication) validateUUID(formats strfmt.Registry) error {

	if swag.IsZero(m.UUID) { // not required
		return nil
	}

	if err := validate.FormatOf("application"+"."+"uuid", "body", "uuid", m.UUID.String(), formats); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *VolumeApplication) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *VolumeApplication) UnmarshalBinary(b []byte) error {
	var res VolumeApplication
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// VolumeAutosize volume autosize
// swagger:model VolumeAutosize
type VolumeAutosize struct {

	// Used space threshold size, in percentage, for the automatic growth of the volume. When the amount of used space in the volume becomes greater than this threhold, the volume automatically grows unless it has reached the maximum size. The volume grows when 'space.used' is greater than this percent of 'space.size'. The 'grow_threshold' size cannot be less than or equal to the 'shrink_threshold' size..
	GrowThreshold int64 `json:"grow_threshold,omitempty"`

	// Maximum size in bytes up to which a volume grows automatically. This size cannot be less than the current volume size, or less than or equal to the minimum size of volume.
	Maximum int64 `json:"maximum,omitempty"`

	// Minimum size in bytes up to which the volume shrinks automatically. This size cannot be greater than or equal to the maximum size of volume.
	Minimum int64 `json:"minimum,omitempty"`

	// Autosize mode for the volume.<br>grow &dash; Volume automatically grows when the amount of used space is above the 'grow_threshold' value.<br>grow_shrink &dash; Volume grows or shrinks in response to the amount of space used.<br>off &dash; Autosizing of the volume is disabled.
	// Enum: [grow grow_shrink off]
	Mode string `json:"mode,omitempty"`

	// Used space threshold size, in percentage, for the automatic shrinkage of the volume.  When the amount of used space in the volume drops below this threshold, the volume automatically shrinks unless it has reached the minimum size. The volume shrinks when the 'space.used' is less than the 'shrink_threshold' percent of 'space.size'. The 'shrink_threshold' size cannot be greater than or equal to the 'grow_threshold' size.
	ShrinkThreshold int64 `json:"shrink_threshold,omitempty"`
}

// Validate validates this volume autosize
func (m *VolumeAutosize) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateMode(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var volumeAutosizeTypeModePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["grow","grow_shrink","off"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		volumeAutosizeTypeModePropEnum = append(volumeAutosizeTypeModePropEnum, v)
	}
}

const (

	// VolumeAutosizeModeGrow captures enum value "grow"
	VolumeAutosizeModeGrow string = "grow"

	// VolumeAutosizeModeGrowShrink captures enum value "grow_shrink"
	VolumeAutosizeModeGrowShrink string = "grow_shrink"

	// VolumeAutosizeModeOff captures enum value "off"
	VolumeAutosizeModeOff string = "off"
)

// prop value enum
func (m *VolumeAutosize) validateModeEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, volumeAutosizeTypeModePropEnum); err != nil {
		return err
	}
	return nil
}

func (m *VolumeAutosize) validateMode(formats strfmt.Registry) error {

	if swag.IsZero(m.Mode) { // not required
		return nil
	}

	// value enum
	if err := m.validateModeEnum("autosize"+"."+"mode", "body", m.Mode); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *VolumeAutosize) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *VolumeAutosize) UnmarshalBinary(b []byte) error {
	var res VolumeAutosize
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// VolumeClone volume clone
// swagger:model VolumeClone
type VolumeClone struct {

	// Specifies if this volume is a normal FlexVol or FlexClone. This field needs to be set when creating a FlexClone. Valid in POST.
	IsFlexclone bool `json:"is_flexclone,omitempty"`

	// parent snapshot
	ParentSnapshot *SnapshotReference `json:"parent_snapshot,omitempty"`

	// parent svm
	ParentSvm *SvmReference `json:"parent_svm,omitempty"`

	// parent volume
	ParentVolume *VolumeReference `json:"parent_volume,omitempty"`

	// Percentage of FlexClone blocks split from its parent volume.
	// Read Only: true
	SplitCompletePercent int64 `json:"split_complete_percent,omitempty"`

	// Space required by the containing-aggregate to split the FlexClone volume.
	// Read Only: true
	SplitEstimate int64 `json:"split_estimate,omitempty"`

	// This field is set when split is executed on any FlexClone, that is when the FlexClone volume is split from its parent FlexVol. This field needs to be set for splitting a FlexClone form FlexVol. Valid in PATCH.
	SplitInitiated bool `json:"split_initiated,omitempty"`
}

// Validate validates this volume clone
func (m *VolumeClone) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateParentSnapshot(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateParentSvm(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateParentVolume(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *VolumeClone) validateParentSnapshot(formats strfmt.Registry) error {

	if swag.IsZero(m.ParentSnapshot) { // not required
		return nil
	}

	if m.ParentSnapshot != nil {
		if err := m.ParentSnapshot.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("clone" + "." + "parent_snapshot")
			}
			return err
		}
	}

	return nil
}

func (m *VolumeClone) validateParentSvm(formats strfmt.Registry) error {

	if swag.IsZero(m.ParentSvm) { // not required
		return nil
	}

	if m.ParentSvm != nil {
		if err := m.ParentSvm.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("clone" + "." + "parent_svm")
			}
			return err
		}
	}

	return nil
}

func (m *VolumeClone) validateParentVolume(formats strfmt.Registry) error {

	if swag.IsZero(m.ParentVolume) { // not required
		return nil
	}

	if m.ParentVolume != nil {
		if err := m.ParentVolume.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("clone" + "." + "parent_volume")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *VolumeClone) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *VolumeClone) UnmarshalBinary(b []byte) error {
	var res VolumeClone
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// VolumeConsistencyGroup Consistency group the volume is part of.
// swagger:model VolumeConsistencyGroup
type VolumeConsistencyGroup struct {

	// Name of the consistency group.
	Name string `json:"name,omitempty"`
}

// Validate validates this volume consistency group
func (m *VolumeConsistencyGroup) Validate(formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *VolumeConsistencyGroup) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *VolumeConsistencyGroup) UnmarshalBinary(b []byte) error {
	var res VolumeConsistencyGroup
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// VolumeEfficiency volume efficiency
// swagger:model VolumeEfficiency
type VolumeEfficiency struct {

	// The system can be enabled/disabled compaction.<br>inline &dash; Data will be compacted first and written to the volume.<br>none &dash; None<br>mixed &dash; Read only field for FlexGroups, where some of the constituent volumes are compaction enabled and some are disabled.
	// Enum: [inline none mixed]
	Compaction string `json:"compaction,omitempty"`

	// The system can be enabled/disabled compression.<br>inline &dash; Data will be compressed first and written to the volume.<br>background &dash; Data will be written to the volume and compressed later.<br>both &dash; Inline compression compresses the data and write to the volume, background compression compresses only the blocks on which inline compression is not run.<br>none &dash; None<br>mixed &dash; Read only field for FlexGroups, where some of the constituent volumes are compression enabled and some are disabled.
	// Enum: [inline background both none mixed]
	Compression string `json:"compression,omitempty"`

	// The system can be enabled/disabled cross volume dedupe. it can be enabled only when dedupe is enabled.<br>inline &dash; Data will be cross volume deduped first and written to the volume.<br>background &dash; Data will be written to the volume and cross volume deduped later.<br>both &dash; Inline cross volume dedupe dedupes the data and write to the volume, background cross volume dedupe dedupes only the blocks on which inline dedupe is not run.<br>none &dash; None<br>mixed &dash; Read only field for FlexGroups, where some of the constituent volumes are cross volume dedupe enabled and some are disabled.
	// Enum: [inline background both none mixed]
	CrossVolumeDedupe string `json:"cross_volume_dedupe,omitempty"`

	// The system can be enabled/disabled dedupe.<br>inline &dash; Data will be deduped first and written to the volume.<br>background &dash; Data will be written to the volume and deduped later.<br>both &dash; Inline dedupe dedupes the data and write to the volume, background dedupe dedupes only the blocks on which inline dedupe is not run.<br>none &dash; None<br>mixed &dash; Read only field for FlexGroups, where some of the constituent volumes are dedupe enabled and some are disabled.
	// Enum: [inline background both none mixed]
	Dedupe string `json:"dedupe,omitempty"`

	// policy
	Policy *VolumeEfficiencyPolicy `json:"policy,omitempty"`
}

// Validate validates this volume efficiency
func (m *VolumeEfficiency) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateCompaction(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateCompression(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateCrossVolumeDedupe(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateDedupe(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validatePolicy(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var volumeEfficiencyTypeCompactionPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["inline","none","mixed"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		volumeEfficiencyTypeCompactionPropEnum = append(volumeEfficiencyTypeCompactionPropEnum, v)
	}
}

const (

	// VolumeEfficiencyCompactionInline captures enum value "inline"
	VolumeEfficiencyCompactionInline string = "inline"

	// VolumeEfficiencyCompactionNone captures enum value "none"
	VolumeEfficiencyCompactionNone string = "none"

	// VolumeEfficiencyCompactionMixed captures enum value "mixed"
	VolumeEfficiencyCompactionMixed string = "mixed"
)

// prop value enum
func (m *VolumeEfficiency) validateCompactionEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, volumeEfficiencyTypeCompactionPropEnum); err != nil {
		return err
	}
	return nil
}

func (m *VolumeEfficiency) validateCompaction(formats strfmt.Registry) error {

	if swag.IsZero(m.Compaction) { // not required
		return nil
	}

	// value enum
	if err := m.validateCompactionEnum("efficiency"+"."+"compaction", "body", m.Compaction); err != nil {
		return err
	}

	return nil
}

var volumeEfficiencyTypeCompressionPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["inline","background","both","none","mixed"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		volumeEfficiencyTypeCompressionPropEnum = append(volumeEfficiencyTypeCompressionPropEnum, v)
	}
}

const (

	// VolumeEfficiencyCompressionInline captures enum value "inline"
	VolumeEfficiencyCompressionInline string = "inline"

	// VolumeEfficiencyCompressionBackground captures enum value "background"
	VolumeEfficiencyCompressionBackground string = "background"

	// VolumeEfficiencyCompressionBoth captures enum value "both"
	VolumeEfficiencyCompressionBoth string = "both"

	// VolumeEfficiencyCompressionNone captures enum value "none"
	VolumeEfficiencyCompressionNone string = "none"

	// VolumeEfficiencyCompressionMixed captures enum value "mixed"
	VolumeEfficiencyCompressionMixed string = "mixed"
)

// prop value enum
func (m *VolumeEfficiency) validateCompressionEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, volumeEfficiencyTypeCompressionPropEnum); err != nil {
		return err
	}
	return nil
}

func (m *VolumeEfficiency) validateCompression(formats strfmt.Registry) error {

	if swag.IsZero(m.Compression) { // not required
		return nil
	}

	// value enum
	if err := m.validateCompressionEnum("efficiency"+"."+"compression", "body", m.Compression); err != nil {
		return err
	}

	return nil
}

var volumeEfficiencyTypeCrossVolumeDedupePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["inline","background","both","none","mixed"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		volumeEfficiencyTypeCrossVolumeDedupePropEnum = append(volumeEfficiencyTypeCrossVolumeDedupePropEnum, v)
	}
}

const (

	// VolumeEfficiencyCrossVolumeDedupeInline captures enum value "inline"
	VolumeEfficiencyCrossVolumeDedupeInline string = "inline"

	// VolumeEfficiencyCrossVolumeDedupeBackground captures enum value "background"
	VolumeEfficiencyCrossVolumeDedupeBackground string = "background"

	// VolumeEfficiencyCrossVolumeDedupeBoth captures enum value "both"
	VolumeEfficiencyCrossVolumeDedupeBoth string = "both"

	// VolumeEfficiencyCrossVolumeDedupeNone captures enum value "none"
	VolumeEfficiencyCrossVolumeDedupeNone string = "none"

	// VolumeEfficiencyCrossVolumeDedupeMixed captures enum value "mixed"
	VolumeEfficiencyCrossVolumeDedupeMixed string = "mixed"
)

// prop value enum
func (m *VolumeEfficiency) validateCrossVolumeDedupeEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, volumeEfficiencyTypeCrossVolumeDedupePropEnum); err != nil {
		return err
	}
	return nil
}

func (m *VolumeEfficiency) validateCrossVolumeDedupe(formats strfmt.Registry) error {

	if swag.IsZero(m.CrossVolumeDedupe) { // not required
		return nil
	}

	// value enum
	if err := m.validateCrossVolumeDedupeEnum("efficiency"+"."+"cross_volume_dedupe", "body", m.CrossVolumeDedupe); err != nil {
		return err
	}

	return nil
}

var volumeEfficiencyTypeDedupePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["inline","background","both","none","mixed"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		volumeEfficiencyTypeDedupePropEnum = append(volumeEfficiencyTypeDedupePropEnum, v)
	}
}

const (

	// VolumeEfficiencyDedupeInline captures enum value "inline"
	VolumeEfficiencyDedupeInline string = "inline"

	// VolumeEfficiencyDedupeBackground captures enum value "background"
	VolumeEfficiencyDedupeBackground string = "background"

	// VolumeEfficiencyDedupeBoth captures enum value "both"
	VolumeEfficiencyDedupeBoth string = "both"

	// VolumeEfficiencyDedupeNone captures enum value "none"
	VolumeEfficiencyDedupeNone string = "none"

	// VolumeEfficiencyDedupeMixed captures enum value "mixed"
	VolumeEfficiencyDedupeMixed string = "mixed"
)

// prop value enum
func (m *VolumeEfficiency) validateDedupeEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, volumeEfficiencyTypeDedupePropEnum); err != nil {
		return err
	}
	return nil
}

func (m *VolumeEfficiency) validateDedupe(formats strfmt.Registry) error {

	if swag.IsZero(m.Dedupe) { // not required
		return nil
	}

	// value enum
	if err := m.validateDedupeEnum("efficiency"+"."+"dedupe", "body", m.Dedupe); err != nil {
		return err
	}

	return nil
}

func (m *VolumeEfficiency) validatePolicy(formats strfmt.Registry) error {

	if swag.IsZero(m.Policy) { // not required
		return nil
	}

	if m.Policy != nil {
		if err := m.Policy.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("efficiency" + "." + "policy")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *VolumeEfficiency) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *VolumeEfficiency) UnmarshalBinary(b []byte) error {
	var res VolumeEfficiency
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// VolumeEfficiencyPolicy volume efficiency policy
// swagger:model VolumeEfficiencyPolicy
type VolumeEfficiencyPolicy struct {

	// Specifies the name of the efficiency policy.
	Name string `json:"name,omitempty"`
}

// Validate validates this volume efficiency policy
func (m *VolumeEfficiencyPolicy) Validate(formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *VolumeEfficiencyPolicy) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *VolumeEfficiencyPolicy) UnmarshalBinary(b []byte) error {
	var res VolumeEfficiencyPolicy
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// VolumeEncryption volume encryption
// swagger:model VolumeEncryption
type VolumeEncryption struct {

	// Encrypts an unencrypted volume. When set to 'true', a new key is generated and used to encrypt the given volume. The underlying SVM must be configured with the key manager.
	Enabled bool `json:"enabled,omitempty"`

	// The key ID used for creating encrypted volume. A new key-id is generated for creating an encrypted volume. This key-id is associated with the generated key.
	// Read Only: true
	KeyID string `json:"key_id,omitempty"`

	// If set to 'true', re-encrypts the volume with a new key. Valid in PATCH.
	Rekey bool `json:"rekey,omitempty"`

	// Volume encryption state.<br>encrypted &dash; The volume is completely encrypted.<br>encrypting &dash; Encryption operation is in progress.<br>partial &dash; Some constituents are encrypted and some are not. Applicable only for FlexGroup volume.<br>rekeying. Encryption of volume with a new key is in progress.<br>unencrypted &dash; The volume is a plain-text one.
	// Read Only: true
	// Enum: [encrypted encrypting partial rekeying unencrypted]
	State string `json:"state,omitempty"`

	// status
	Status *VolumeEncryptionStatus `json:"status,omitempty"`

	// Volume encryption type.<br>none &dash; The volume is a plain-text one.<br>volume &dash; The volume is encrypted with NVE (NetApp Volume Encryption).<br>aggregate &dash; The volume is encrypted with NAE (NetApp Aggregate Encryption).
	// Read Only: true
	// Enum: [none volume aggregate]
	Type string `json:"type,omitempty"`
}

// Validate validates this volume encryption
func (m *VolumeEncryption) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateState(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateStatus(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateType(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var volumeEncryptionTypeStatePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["encrypted","encrypting","partial","rekeying","unencrypted"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		volumeEncryptionTypeStatePropEnum = append(volumeEncryptionTypeStatePropEnum, v)
	}
}

const (

	// VolumeEncryptionStateEncrypted captures enum value "encrypted"
	VolumeEncryptionStateEncrypted string = "encrypted"

	// VolumeEncryptionStateEncrypting captures enum value "encrypting"
	VolumeEncryptionStateEncrypting string = "encrypting"

	// VolumeEncryptionStatePartial captures enum value "partial"
	VolumeEncryptionStatePartial string = "partial"

	// VolumeEncryptionStateRekeying captures enum value "rekeying"
	VolumeEncryptionStateRekeying string = "rekeying"

	// VolumeEncryptionStateUnencrypted captures enum value "unencrypted"
	VolumeEncryptionStateUnencrypted string = "unencrypted"
)

// prop value enum
func (m *VolumeEncryption) validateStateEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, volumeEncryptionTypeStatePropEnum); err != nil {
		return err
	}
	return nil
}

func (m *VolumeEncryption) validateState(formats strfmt.Registry) error {

	if swag.IsZero(m.State) { // not required
		return nil
	}

	// value enum
	if err := m.validateStateEnum("encryption"+"."+"state", "body", m.State); err != nil {
		return err
	}

	return nil
}

func (m *VolumeEncryption) validateStatus(formats strfmt.Registry) error {

	if swag.IsZero(m.Status) { // not required
		return nil
	}

	if m.Status != nil {
		if err := m.Status.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("encryption" + "." + "status")
			}
			return err
		}
	}

	return nil
}

var volumeEncryptionTypeTypePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["none","volume","aggregate"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		volumeEncryptionTypeTypePropEnum = append(volumeEncryptionTypeTypePropEnum, v)
	}
}

const (

	// VolumeEncryptionTypeNone captures enum value "none"
	VolumeEncryptionTypeNone string = "none"

	// VolumeEncryptionTypeVolume captures enum value "volume"
	VolumeEncryptionTypeVolume string = "volume"

	// VolumeEncryptionTypeAggregate captures enum value "aggregate"
	VolumeEncryptionTypeAggregate string = "aggregate"
)

// prop value enum
func (m *VolumeEncryption) validateTypeEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, volumeEncryptionTypeTypePropEnum); err != nil {
		return err
	}
	return nil
}

func (m *VolumeEncryption) validateType(formats strfmt.Registry) error {

	if swag.IsZero(m.Type) { // not required
		return nil
	}

	// value enum
	if err := m.validateTypeEnum("encryption"+"."+"type", "body", m.Type); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *VolumeEncryption) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *VolumeEncryption) UnmarshalBinary(b []byte) error {
	var res VolumeEncryption
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// VolumeEncryptionStatus volume encryption status
// swagger:model VolumeEncryptionStatus
type VolumeEncryptionStatus struct {

	// Encryption progress message code.
	// Read Only: true
	Code string `json:"code,omitempty"`

	// Encryption progress message.
	// Read Only: true
	Message string `json:"message,omitempty"`
}

// Validate validates this volume encryption status
func (m *VolumeEncryptionStatus) Validate(formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *VolumeEncryptionStatus) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *VolumeEncryptionStatus) UnmarshalBinary(b []byte) error {
	var res VolumeEncryptionStatus
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// VolumeErrorState volume error state
// swagger:model VolumeErrorState
type VolumeErrorState struct {

	// Indicates whether the volume has any corrupt data blocks. If the damaged data block is accessed, an IO error, such as EIO for NFS or STATUS_FILE_CORRUPT for CIFS, is returned.
	// Read Only: true
	HasBadBlocks *bool `json:"has_bad_blocks,omitempty"`

	// Indicates whether the file system has any inconsistencies.<br>true &dash; File system is inconsistent.<br>false &dash; File system in not inconsistent.
	// Read Only: true
	IsInconsistent *bool `json:"is_inconsistent,omitempty"`
}

// Validate validates this volume error state
func (m *VolumeErrorState) Validate(formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *VolumeErrorState) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *VolumeErrorState) UnmarshalBinary(b []byte) error {
	var res VolumeErrorState
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// VolumeFiles volume files
// swagger:model VolumeFiles
type VolumeFiles struct {

	// The maximum number of files (inodes) for user-visible data allowed on the volume. This value can be increased or decreased. Increasing the maximum number of files does not immediately cause additional disk space to be used to track files. Instead, as more files are created on the volume, the system dynamically increases the number of disk blocks that are used to track files. The space assigned to track files is never freed, and this value cannot be decreased below the current number of files that can be tracked within the assigned space for the volume. Valid in PATCH.
	Maximum int64 `json:"maximum,omitempty"`

	// Number of files (inodes) used for user-visible data permitted on the volume. This field is valid only when the volume is online.
	// Read Only: true
	Used int64 `json:"used,omitempty"`
}

// Validate validates this volume files
func (m *VolumeFiles) Validate(formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *VolumeFiles) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *VolumeFiles) UnmarshalBinary(b []byte) error {
	var res VolumeFiles
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// VolumeGuarantee volume guarantee
// swagger:model VolumeGuarantee
type VolumeGuarantee struct {

	// Is the space guarantee of this volume honored in the aggregate?
	// Read Only: true
	Honored *bool `json:"honored,omitempty"`

	// The type of space guarantee of this volume in the aggregate.
	// Enum: [volume none]
	Type string `json:"type,omitempty"`
}

// Validate validates this volume guarantee
func (m *VolumeGuarantee) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateType(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var volumeGuaranteeTypeTypePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["volume","none"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		volumeGuaranteeTypeTypePropEnum = append(volumeGuaranteeTypeTypePropEnum, v)
	}
}

const (

	// VolumeGuaranteeTypeVolume captures enum value "volume"
	VolumeGuaranteeTypeVolume string = "volume"

	// VolumeGuaranteeTypeNone captures enum value "none"
	VolumeGuaranteeTypeNone string = "none"
)

// prop value enum
func (m *VolumeGuarantee) validateTypeEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, volumeGuaranteeTypeTypePropEnum); err != nil {
		return err
	}
	return nil
}

func (m *VolumeGuarantee) validateType(formats strfmt.Registry) error {

	if swag.IsZero(m.Type) { // not required
		return nil
	}

	// value enum
	if err := m.validateTypeEnum("guarantee"+"."+"type", "body", m.Type); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *VolumeGuarantee) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *VolumeGuarantee) UnmarshalBinary(b []byte) error {
	var res VolumeGuarantee
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// VolumeLinks volume links
// swagger:model VolumeLinks
type VolumeLinks struct {

	// self
	Self *Href `json:"self,omitempty"`
}

// Validate validates this volume links
func (m *VolumeLinks) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateSelf(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *VolumeLinks) validateSelf(formats strfmt.Registry) error {

	if swag.IsZero(m.Self) { // not required
		return nil
	}

	if m.Self != nil {
		if err := m.Self.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("_links" + "." + "self")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *VolumeLinks) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *VolumeLinks) UnmarshalBinary(b []byte) error {
	var res VolumeLinks
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// VolumeMovement Volume movement. All attributes are modify, that is, not writable through POST. Set PATCH state to destination_aggregate to initiate a volume move operation. Volume movement on FlexGroup constituents are not supported.
// swagger:model VolumeMovement
type VolumeMovement struct {

	// Time window in seconds for cutover. The allowed range is between 30 to 300 seconds.
	CutoverWindow *int64 `json:"cutover_window,omitempty"`

	// destination aggregate
	DestinationAggregate *AggregateReference `json:"destination_aggregate,omitempty"`

	// Completion percentage
	// Read Only: true
	PercentComplete int64 `json:"percent_complete,omitempty"`

	// State of volume move operation. PATCH the state to "aborted" to abort the move operation. PATCH the state to "cutover" to trigger cutover. PATCH the state to "paused" to pause the volume move operation in progress. PATCH the state to "replicating" to resume the paused volume move operation. PATCH the state to "cutover_wait" to go into cutover manually. When volume move operation is waiting to go into "cutover" state, this is indicated by the "cutover_pending" state. A change of state is only supported if volume movement is in progress.
	// Enum: [aborted cutover cutover_wait cutover_pending failed paused queued replicating success]
	State string `json:"state,omitempty"`

	// Tiering policy for FabricPool
	// Enum: [all auto backup none snapshot_only]
	TieringPolicy string `json:"tiering_policy,omitempty"`
}

// Validate validates this volume movement
func (m *VolumeMovement) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateDestinationAggregate(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateState(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateTieringPolicy(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *VolumeMovement) validateDestinationAggregate(formats strfmt.Registry) error {

	if swag.IsZero(m.DestinationAggregate) { // not required
		return nil
	}

	if m.DestinationAggregate != nil {
		if err := m.DestinationAggregate.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("movement" + "." + "destination_aggregate")
			}
			return err
		}
	}

	return nil
}

var volumeMovementTypeStatePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["aborted","cutover","cutover_wait","cutover_pending","failed","paused","queued","replicating","success"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		volumeMovementTypeStatePropEnum = append(volumeMovementTypeStatePropEnum, v)
	}
}

const (

	// VolumeMovementStateAborted captures enum value "aborted"
	VolumeMovementStateAborted string = "aborted"

	// VolumeMovementStateCutover captures enum value "cutover"
	VolumeMovementStateCutover string = "cutover"

	// VolumeMovementStateCutoverWait captures enum value "cutover_wait"
	VolumeMovementStateCutoverWait string = "cutover_wait"

	// VolumeMovementStateCutoverPending captures enum value "cutover_pending"
	VolumeMovementStateCutoverPending string = "cutover_pending"

	// VolumeMovementStateFailed captures enum value "failed"
	VolumeMovementStateFailed string = "failed"

	// VolumeMovementStatePaused captures enum value "paused"
	VolumeMovementStatePaused string = "paused"

	// VolumeMovementStateQueued captures enum value "queued"
	VolumeMovementStateQueued string = "queued"

	// VolumeMovementStateReplicating captures enum value "replicating"
	VolumeMovementStateReplicating string = "replicating"

	// VolumeMovementStateSuccess captures enum value "success"
	VolumeMovementStateSuccess string = "success"
)

// prop value enum
func (m *VolumeMovement) validateStateEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, volumeMovementTypeStatePropEnum); err != nil {
		return err
	}
	return nil
}

func (m *VolumeMovement) validateState(formats strfmt.Registry) error {

	if swag.IsZero(m.State) { // not required
		return nil
	}

	// value enum
	if err := m.validateStateEnum("movement"+"."+"state", "body", m.State); err != nil {
		return err
	}

	return nil
}

var volumeMovementTypeTieringPolicyPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["all","auto","backup","none","snapshot_only"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		volumeMovementTypeTieringPolicyPropEnum = append(volumeMovementTypeTieringPolicyPropEnum, v)
	}
}

const (

	// VolumeMovementTieringPolicyAll captures enum value "all"
	VolumeMovementTieringPolicyAll string = "all"

	// VolumeMovementTieringPolicyAuto captures enum value "auto"
	VolumeMovementTieringPolicyAuto string = "auto"

	// VolumeMovementTieringPolicyBackup captures enum value "backup"
	VolumeMovementTieringPolicyBackup string = "backup"

	// VolumeMovementTieringPolicyNone captures enum value "none"
	VolumeMovementTieringPolicyNone string = "none"

	// VolumeMovementTieringPolicySnapshotOnly captures enum value "snapshot_only"
	VolumeMovementTieringPolicySnapshotOnly string = "snapshot_only"
)

// prop value enum
func (m *VolumeMovement) validateTieringPolicyEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, volumeMovementTypeTieringPolicyPropEnum); err != nil {
		return err
	}
	return nil
}

func (m *VolumeMovement) validateTieringPolicy(formats strfmt.Registry) error {

	if swag.IsZero(m.TieringPolicy) { // not required
		return nil
	}

	// value enum
	if err := m.validateTieringPolicyEnum("movement"+"."+"tiering_policy", "body", m.TieringPolicy); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *VolumeMovement) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *VolumeMovement) UnmarshalBinary(b []byte) error {
	var res VolumeMovement
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// VolumeNas volume nas
// swagger:model VolumeNas
type VolumeNas struct {

	// export policy
	ExportPolicy *ExportPolicyReference `json:"export_policy,omitempty"`

	// The UNIX group ID of the volume. Valid in POST or PATCH.
	Gid int64 `json:"gid,omitempty"`

	// The fully-qualified path in the owning SVM's namespace at which the volume is mounted. The path is case insensitive and must be unique within a SVM's namespace. Path must begin with '/' and must not end with '/'. Only one volume can be mounted at any given junction path. An empty path in POST creates an unmounted volume. An empty path in PATCH deactivates and unmounts the volume. Taking a volume offline removes its junction path. This attribute is reported in GET only when the volume is mounted.
	Path string `json:"path,omitempty"`

	// Security style associated with the volume. Valid in POST or PATCH.<br>mixed &dash; Mixed-style security<br>ntfs &dash; NTFS/WIndows-style security<br>unified &dash; Unified-style security, unified UNIX, NFS and CIFS permissions<br>unix &dash; Unix-style security.
	// Enum: [mixed ntfs unified unix]
	SecurityStyle *string `json:"security_style,omitempty"`

	// The UNIX user ID of the volume. Valid in POST or PATCH.
	UID int64 `json:"uid,omitempty"`

	// UNIX permissions to be viewed as an octal number. It consists of 4 digits derived by adding up bits 4 (read), 2 (write) and 1 (execute). First digit selects the set user ID(4), set group ID (2) and sticky (1) attributes. The second digit selects permission for the owner of the file; the third selects permissions for other users in the same group; the fourth for other users not in the group. Valid in POST or PATCH. For security style "mixed" or "unix", the default setting is 0755 in octal (493 in decimal) and for security style "ntfs", the default setting is 0000. In cases where only owner, group and other permissions are given (as in 755, representing the second, third and fourth dight), first digit is assumed to be zero.
	UnixPermissions int64 `json:"unix_permissions,omitempty"`
}

// Validate validates this volume nas
func (m *VolumeNas) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateExportPolicy(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSecurityStyle(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *VolumeNas) validateExportPolicy(formats strfmt.Registry) error {

	if swag.IsZero(m.ExportPolicy) { // not required
		return nil
	}

	if m.ExportPolicy != nil {
		if err := m.ExportPolicy.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("nas" + "." + "export_policy")
			}
			return err
		}
	}

	return nil
}

var volumeNasTypeSecurityStylePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["mixed","ntfs","unified","unix"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		volumeNasTypeSecurityStylePropEnum = append(volumeNasTypeSecurityStylePropEnum, v)
	}
}

const (

	// VolumeNasSecurityStyleMixed captures enum value "mixed"
	VolumeNasSecurityStyleMixed string = "mixed"

	// VolumeNasSecurityStyleNtfs captures enum value "ntfs"
	VolumeNasSecurityStyleNtfs string = "ntfs"

	// VolumeNasSecurityStyleUnified captures enum value "unified"
	VolumeNasSecurityStyleUnified string = "unified"

	// VolumeNasSecurityStyleUnix captures enum value "unix"
	VolumeNasSecurityStyleUnix string = "unix"
)

// prop value enum
func (m *VolumeNas) validateSecurityStyleEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, volumeNasTypeSecurityStylePropEnum); err != nil {
		return err
	}
	return nil
}

func (m *VolumeNas) validateSecurityStyle(formats strfmt.Registry) error {

	if swag.IsZero(m.SecurityStyle) { // not required
		return nil
	}

	// value enum
	if err := m.validateSecurityStyleEnum("nas"+"."+"security_style", "body", *m.SecurityStyle); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *VolumeNas) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *VolumeNas) UnmarshalBinary(b []byte) error {
	var res VolumeNas
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// VolumeQos QoS information
// swagger:model VolumeQos
type VolumeQos struct {

	// policy
	Policy *QosPolicyReference `json:"policy,omitempty"`
}

// Validate validates this volume qos
func (m *VolumeQos) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validatePolicy(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *VolumeQos) validatePolicy(formats strfmt.Registry) error {

	if swag.IsZero(m.Policy) { // not required
		return nil
	}

	if m.Policy != nil {
		if err := m.Policy.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("qos" + "." + "policy")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *VolumeQos) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *VolumeQos) UnmarshalBinary(b []byte) error {
	var res VolumeQos
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// VolumeQuota Quotas track the space or file usage of a user, group, or qtree in a FlexVol or a FlexGroup volume.
// swagger:model VolumeQuota
type VolumeQuota struct {

	// This option is used to enable or disable the quota for the volume. This option is valid only in PATCH. Quotas are enabled for FlexVols or FlexGroup volumes when the quota state is "on". Quotas are disabled for FlexVols or FlexGroup volumes when the quota state is "off".
	Enabled bool `json:"enabled,omitempty"`

	// Quota state of the volume
	// Read Only: true
	// Enum: [corrupt initializing mixed off on resizing]
	State string `json:"state,omitempty"`
}

// Validate validates this volume quota
func (m *VolumeQuota) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateState(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var volumeQuotaTypeStatePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["corrupt","initializing","mixed","off","on","resizing"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		volumeQuotaTypeStatePropEnum = append(volumeQuotaTypeStatePropEnum, v)
	}
}

const (

	// VolumeQuotaStateCorrupt captures enum value "corrupt"
	VolumeQuotaStateCorrupt string = "corrupt"

	// VolumeQuotaStateInitializing captures enum value "initializing"
	VolumeQuotaStateInitializing string = "initializing"

	// VolumeQuotaStateMixed captures enum value "mixed"
	VolumeQuotaStateMixed string = "mixed"

	// VolumeQuotaStateOff captures enum value "off"
	VolumeQuotaStateOff string = "off"

	// VolumeQuotaStateOn captures enum value "on"
	VolumeQuotaStateOn string = "on"

	// VolumeQuotaStateResizing captures enum value "resizing"
	VolumeQuotaStateResizing string = "resizing"
)

// prop value enum
func (m *VolumeQuota) validateStateEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, volumeQuotaTypeStatePropEnum); err != nil {
		return err
	}
	return nil
}

func (m *VolumeQuota) validateState(formats strfmt.Registry) error {

	if swag.IsZero(m.State) { // not required
		return nil
	}

	// value enum
	if err := m.validateStateEnum("quota"+"."+"state", "body", m.State); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *VolumeQuota) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *VolumeQuota) UnmarshalBinary(b []byte) error {
	var res VolumeQuota
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// VolumeSnaplock volume snaplock
// swagger:model VolumeSnaplock
type VolumeSnaplock struct {

	// Specifies if the volume append mode is enabled or disabled. When it is enabled, all the files created with write permissions on the volume are, by default, WORM appendable files. The user can append the data to a WORM appendable file but cannot modify the existing contents of the file nor delete the file until it expires.
	AppendModeEnabled *bool `json:"append_mode_enabled,omitempty"`

	// Specifies the autocommit period for SnapLock volume. All files which are not modified for a period greater than the autocommit period of the volume are committed to the WORM state. The autocommit period value represents a duration and must be specified in the ISO-8601 duration format. The autocommit period can be in years, months, days, hours, and minutes. A period specified for years, months, and days is represented in the ISO-8601 format as "P<num>Y", "P<num>M", "P<num>D" respectively, for example "P10Y" represents a duration of 10 years. A duration in hours and minutes is represented by "PT<num>H" and "PT<num>M" respectively. The period string must contain only a single time element that is, either years, months, days, hours, or minutes. A duration which combines different periods is not supported, for example "P1Y10M" is not supported. Apart from the duration specified in the ISO-8601 format, the autocommit field also accepts the string "none".
	AutocommitPeriod *string `json:"autocommit_period,omitempty"`

	// This is the volume compliance clock time which is used to manage the SnapLock objects in the volume.
	// Read Only: true
	// Format: date-time
	ComplianceClockTime strfmt.DateTime `json:"compliance_clock_time,omitempty"`

	// Expiry time of the volume.
	// Read Only: true
	// Format: date-time
	ExpiryTime strfmt.DateTime `json:"expiry_time,omitempty"`

	// Indicates if this volume has been configured as SnapLock audit log volume for the SVM .
	// Read Only: true
	IsAuditLog *bool `json:"is_audit_log,omitempty"`

	// Litigation count indicates the number of active legal-holds on the volume.
	// Read Only: true
	LitigationCount int64 `json:"litigation_count,omitempty"`

	// Specifies the privileged-delete attribute of a SnapLock volume. On a SnapLock Enterprise (SLE) volume, a designated privileged user can selectively delete files irrespective of the retention time of the file. SLE volumes can have privileged delete as disabled, enabled or permanently_disabled and for SnapLock Compliance (SLC) volumes it is always permanently_disabled.
	// Enum: [disabled enabled permanently_disabled]
	PrivilegedDelete string `json:"privileged_delete,omitempty"`

	// retention
	Retention *VolumeSnaplockRetention `json:"retention,omitempty"`

	// The SnapLock type of the volume. <br>compliance &dash; A SnapLock Compliance(SLC) volume provides the highest level of WORM protection and an administrator cannot destroy a SLC volume if it contains unexpired WORM files. <br> enterprise &dash; An administrator can delete a SnapLock Enterprise(SLE) volume.<br> non_snaplock &dash; Indicates the volume is non-snaplock.
	// Read Only: true
	// Enum: [compliance enterprise non_snaplock]
	Type string `json:"type,omitempty"`
}

// Validate validates this volume snaplock
func (m *VolumeSnaplock) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateComplianceClockTime(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateExpiryTime(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validatePrivilegedDelete(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateRetention(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateType(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *VolumeSnaplock) validateComplianceClockTime(formats strfmt.Registry) error {

	if swag.IsZero(m.ComplianceClockTime) { // not required
		return nil
	}

	if err := validate.FormatOf("snaplock"+"."+"compliance_clock_time", "body", "date-time", m.ComplianceClockTime.String(), formats); err != nil {
		return err
	}

	return nil
}

func (m *VolumeSnaplock) validateExpiryTime(formats strfmt.Registry) error {

	if swag.IsZero(m.ExpiryTime) { // not required
		return nil
	}

	if err := validate.FormatOf("snaplock"+"."+"expiry_time", "body", "date-time", m.ExpiryTime.String(), formats); err != nil {
		return err
	}

	return nil
}

var volumeSnaplockTypePrivilegedDeletePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["disabled","enabled","permanently_disabled"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		volumeSnaplockTypePrivilegedDeletePropEnum = append(volumeSnaplockTypePrivilegedDeletePropEnum, v)
	}
}

const (

	// VolumeSnaplockPrivilegedDeleteDisabled captures enum value "disabled"
	VolumeSnaplockPrivilegedDeleteDisabled string = "disabled"

	// VolumeSnaplockPrivilegedDeleteEnabled captures enum value "enabled"
	VolumeSnaplockPrivilegedDeleteEnabled string = "enabled"

	// VolumeSnaplockPrivilegedDeletePermanentlyDisabled captures enum value "permanently_disabled"
	VolumeSnaplockPrivilegedDeletePermanentlyDisabled string = "permanently_disabled"
)

// prop value enum
func (m *VolumeSnaplock) validatePrivilegedDeleteEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, volumeSnaplockTypePrivilegedDeletePropEnum); err != nil {
		return err
	}
	return nil
}

func (m *VolumeSnaplock) validatePrivilegedDelete(formats strfmt.Registry) error {

	if swag.IsZero(m.PrivilegedDelete) { // not required
		return nil
	}

	// value enum
	if err := m.validatePrivilegedDeleteEnum("snaplock"+"."+"privileged_delete", "body", m.PrivilegedDelete); err != nil {
		return err
	}

	return nil
}

func (m *VolumeSnaplock) validateRetention(formats strfmt.Registry) error {

	if swag.IsZero(m.Retention) { // not required
		return nil
	}

	if m.Retention != nil {
		if err := m.Retention.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("snaplock" + "." + "retention")
			}
			return err
		}
	}

	return nil
}

var volumeSnaplockTypeTypePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["compliance","enterprise","non_snaplock"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		volumeSnaplockTypeTypePropEnum = append(volumeSnaplockTypeTypePropEnum, v)
	}
}

const (

	// VolumeSnaplockTypeCompliance captures enum value "compliance"
	VolumeSnaplockTypeCompliance string = "compliance"

	// VolumeSnaplockTypeEnterprise captures enum value "enterprise"
	VolumeSnaplockTypeEnterprise string = "enterprise"

	// VolumeSnaplockTypeNonSnaplock captures enum value "non_snaplock"
	VolumeSnaplockTypeNonSnaplock string = "non_snaplock"
)

// prop value enum
func (m *VolumeSnaplock) validateTypeEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, volumeSnaplockTypeTypePropEnum); err != nil {
		return err
	}
	return nil
}

func (m *VolumeSnaplock) validateType(formats strfmt.Registry) error {

	if swag.IsZero(m.Type) { // not required
		return nil
	}

	// value enum
	if err := m.validateTypeEnum("snaplock"+"."+"type", "body", m.Type); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *VolumeSnaplock) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *VolumeSnaplock) UnmarshalBinary(b []byte) error {
	var res VolumeSnaplock
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// VolumeSnaplockRetention volume snaplock retention
// swagger:model VolumeSnaplockRetention
type VolumeSnaplockRetention struct {

	// Specifies the default retention period that is applied to files while committing them to the WORM state without an associated retention period. The retention value represents a duration and must be specified in the ISO-8601 duration format. The retention period can be in years, months, days, hours, and minutes. A duration specified for years, months, and days is represented in the ISO-8601 format as "P<num>Y", "P<num>M", "P<num>D" respectively, for example "P10Y" represents a duration of 10 years. A duration in hours and minutes is represented by "PT<num>H" and "PT<num>M" respectively. The retention string must contain only a single time element that is, either years, months, days, hours, or minutes. A duration which combines different periods is not supported, for example "P1Y10M" is not supported. Apart from the duration specified in the ISO-8601 format, the duration field also accepts the string "infinite" to set an infinite retention period.
	Default string `json:"default,omitempty"`

	// Specifies the maximum allowed retention period for files committed to the WORM state on the volume. The retention value represents a duration and must be specified in the ISO-8601 duration format. The retention period can be in years, months, days, hours, and minutes. A duration specified for years, months, and days is represented in the ISO-8601 format as "P<num>Y", "P<num>M", "P<num>D" respectively, for example "P10Y" represents a duration of 10 years. A duration in hours and minutes is represented by "PT<num>H" and "PT<num>M" respectively. The retention string must contain only a single time element that is, either years, months, days, hours, or minutes. A duration which combines different periods is not supported, for example "P1Y10M" is not supported. Apart from the duration specified in the ISO-8601 format, the duration field also accepts the string "infinite" to set an infinite retention period.
	Maximum *string `json:"maximum,omitempty"`

	// Specifies the minimum allowed retention period for files committed to the WORM state on the volume. The retention value represents a duration and must be specified in the ISO-8601 duration format. The retention period can be in years, months, days, hours, and minutes. A duration specified for years, month,s and days is represented in the ISO-8601 format as "P<num>Y", "P<num>M", "P<num>D" respectively, for example "P10Y" represents a duration of 10 years. A duration in hours and minutes is represented by "PT<num>H" and "PT<num>M" respectively. The retention string must contain only a single time element that is, either years, months, days, hours, or minutes. A duration which combines different periods is not supported, for example "P1Y10M" is not supported. Apart from the duration specified in the ISO-8601 format, the duration field also accepts the string "infinite" to set an infinite retention period.
	Minimum *string `json:"minimum,omitempty"`
}

// Validate validates this volume snaplock retention
func (m *VolumeSnaplockRetention) Validate(formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *VolumeSnaplockRetention) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *VolumeSnaplockRetention) UnmarshalBinary(b []byte) error {
	var res VolumeSnaplockRetention
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// VolumeSnapmirror Specifies attributes for SnapMirror protection.
// swagger:model VolumeSnapmirror
type VolumeSnapmirror struct {

	// Specifies whether a volume is a SnapMirror source volume, using SnapMirror to protect its data.
	// Read Only: true
	IsProtected *bool `json:"is_protected,omitempty"`
}

// Validate validates this volume snapmirror
func (m *VolumeSnapmirror) Validate(formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *VolumeSnapmirror) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *VolumeSnapmirror) UnmarshalBinary(b []byte) error {
	var res VolumeSnapmirror
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// VolumeSpace volume space
// swagger:model VolumeSpace
type VolumeSpace struct {

	// The available space, in bytes.
	// Read Only: true
	Available int64 `json:"available,omitempty"`

	// The size that is physically used in the block storage of the volume and has a cold temperature. In bytes. This parameter is only supported if the volume is in an aggregate that is either attached to a cloud store or could be attached to a cloud store.
	// Read Only: true
	BlockStorageInactiveUserData int64 `json:"block_storage_inactive_user_data,omitempty"`

	// The space used by capacity tier for this volume in the aggregate, in bytes.
	// Read Only: true
	CapacityTierFootprint int64 `json:"capacity_tier_footprint,omitempty"`

	// Data and metadata used for this volume in the aggregate, in bytes.
	// Read Only: true
	Footprint int64 `json:"footprint,omitempty"`

	// logical space
	LogicalSpace *VolumeSpaceLogicalSpace `json:"logical_space,omitempty"`

	// The space used by the total metadata in the volume, in bytes.
	// Read Only: true
	Metadata int64 `json:"metadata,omitempty"`

	// The amount of space not available for this volume in the aggregate, in bytes.
	// Read Only: true
	OverProvisioned int64 `json:"over_provisioned,omitempty"`

	// Total provisioned size. The default size is equal to the minimum size of 20MB, in bytes.
	Size int64 `json:"size,omitempty"`

	// snapshot
	Snapshot *VolumeSpaceSnapshot `json:"snapshot,omitempty"`

	// The virtual space used (includes volume reserves) before storage efficiency, in bytes.
	// Read Only: true
	Used int64 `json:"used,omitempty"`
}

// Validate validates this volume space
func (m *VolumeSpace) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLogicalSpace(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSnapshot(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *VolumeSpace) validateLogicalSpace(formats strfmt.Registry) error {

	if swag.IsZero(m.LogicalSpace) { // not required
		return nil
	}

	if m.LogicalSpace != nil {
		if err := m.LogicalSpace.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("space" + "." + "logical_space")
			}
			return err
		}
	}

	return nil
}

func (m *VolumeSpace) validateSnapshot(formats strfmt.Registry) error {

	if swag.IsZero(m.Snapshot) { // not required
		return nil
	}

	if m.Snapshot != nil {
		if err := m.Snapshot.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("space" + "." + "snapshot")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *VolumeSpace) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *VolumeSpace) UnmarshalBinary(b []byte) error {
	var res VolumeSpace
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// VolumeSpaceLogicalSpace volume space logical space
// swagger:model VolumeSpaceLogicalSpace
type VolumeSpaceLogicalSpace struct {

	// The amount of space available in this volume with storage efficiency space considered used, in bytes.
	// Read Only: true
	Available int64 `json:"available,omitempty"`

	// Specifies whether space accounting for operations on the volume is done along with storage efficiency.
	Enforcement *bool `json:"enforcement,omitempty"`

	// Specifies whether space reporting on the volume is done along with storage efficiency.
	Reporting *bool `json:"reporting,omitempty"`

	// The virtual space used by AFS alone (includes volume reserves) and along with storage efficiency, in bytes.
	// Read Only: true
	UsedByAfs int64 `json:"used_by_afs,omitempty"`
}

// Validate validates this volume space logical space
func (m *VolumeSpaceLogicalSpace) Validate(formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *VolumeSpaceLogicalSpace) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *VolumeSpaceLogicalSpace) UnmarshalBinary(b []byte) error {
	var res VolumeSpaceLogicalSpace
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// VolumeSpaceSnapshot volume space snapshot
// swagger:model VolumeSpaceSnapshot
type VolumeSpaceSnapshot struct {

	// Specifies whether Snapshot copy autodelete is currently enabled on this volume.
	AutodeleteEnabled *bool `json:"autodelete_enabled,omitempty"`

	// The space that has been set aside as a reserve for Snapshot copy usage, in percent.
	ReservePercent *int64 `json:"reserve_percent,omitempty"`

	// The total space used by Snapshot copies in the volume, in bytes.
	// Read Only: true
	Used int64 `json:"used,omitempty"`
}

// Validate validates this volume space snapshot
func (m *VolumeSpaceSnapshot) Validate(formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *VolumeSpaceSnapshot) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *VolumeSpaceSnapshot) UnmarshalBinary(b []byte) error {
	var res VolumeSpaceSnapshot
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// VolumeTiering volume tiering
// swagger:model VolumeTiering
type VolumeTiering struct {

	// Policy that determines whether the user data blocks of a volume in a FabricPool will be tiered to the cloud store when they become cold. FabricPool combines flash (performance tier) with a cloud store into a single aggregate. Temperature of a volume block increases if it is accessed frequently and decreases when it is not. Valid in POST or PATCH.<br>all &dash; This policy allows tiering of both Snapshot copies and active file system user data to the cloud store as soon as possible by ignoring the temperature on the volume blocks.<br>auto &dash; This policy allows tiering of both snapshot and active file system user data to the cloud store<br>none &dash; Volume blocks will not be tiered to the cloud store.<br>snapshot_only &dash; This policy allows tiering of only the volume Snapshot copies not associated with the active file system. The default tiering policy is "snapshot-only" for a FlexVol and "none" for a FlexGroup.
	// Enum: [all auto backup none snapshot_only]
	Policy string `json:"policy,omitempty"`

	// This parameter specifies whether or not FabricPools are selected when provisioning a FlexGroup without specifying "aggregates.name" or "aggregates.uuid". Only FabricPool aggregates are used if this parameter is set to true and only non FabricPool aggregates are used if this parameter is set to false. Tiering support for a FlexGroup can be changed by moving all of the constituents to the required aggregates. Note that in order to tier data, not only does the volume need to support tiering by using FabricPools, the tiering "policy" must not be 'none'. A volume that uses FabricPools but has a tiering "policy" of 'none' supports tiering, but will not tier any data.
	Supported *bool `json:"supported,omitempty"`
}

// Validate validates this volume tiering
func (m *VolumeTiering) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validatePolicy(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var volumeTieringTypePolicyPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["all","auto","backup","none","snapshot_only"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		volumeTieringTypePolicyPropEnum = append(volumeTieringTypePolicyPropEnum, v)
	}
}

const (

	// VolumeTieringPolicyAll captures enum value "all"
	VolumeTieringPolicyAll string = "all"

	// VolumeTieringPolicyAuto captures enum value "auto"
	VolumeTieringPolicyAuto string = "auto"

	// VolumeTieringPolicyBackup captures enum value "backup"
	VolumeTieringPolicyBackup string = "backup"

	// VolumeTieringPolicyNone captures enum value "none"
	VolumeTieringPolicyNone string = "none"

	// VolumeTieringPolicySnapshotOnly captures enum value "snapshot_only"
	VolumeTieringPolicySnapshotOnly string = "snapshot_only"
)

// prop value enum
func (m *VolumeTiering) validatePolicyEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, volumeTieringTypePolicyPropEnum); err != nil {
		return err
	}
	return nil
}

func (m *VolumeTiering) validatePolicy(formats strfmt.Registry) error {

	if swag.IsZero(m.Policy) { // not required
		return nil
	}

	// value enum
	if err := m.validatePolicyEnum("tiering"+"."+"policy", "body", m.Policy); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *VolumeTiering) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *VolumeTiering) UnmarshalBinary(b []byte) error {
	var res VolumeTiering
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
