// Code generated by go-swagger; DO NOT EDIT.

package ntapmodel

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// VolumeMetrics Performance numbers, such as IOPS, latency and throughput.
// swagger:model volumeMetrics
type VolumeMetrics struct {
	PerformanceMetric

	// cloud
	Cloud *VolumeMetricsCloud `json:"cloud,omitempty"`
}

// UnmarshalJSON unmarshals this object from a JSON structure
func (m *VolumeMetrics) UnmarshalJSON(raw []byte) error {
	// AO0
	var aO0 PerformanceMetric
	if err := swag.ReadJSON(raw, &aO0); err != nil {
		return err
	}
	m.PerformanceMetric = aO0

	// now for regular properties
	var propsVolumeMetrics struct {
		Cloud *VolumeMetricsCloud `json:"cloud,omitempty"`
	}
	if err := swag.ReadJSON(raw, &propsVolumeMetrics); err != nil {
		return err
	}
	m.Cloud = propsVolumeMetrics.Cloud

	return nil
}

// MarshalJSON marshals this object to a JSON structure
func (m VolumeMetrics) MarshalJSON() ([]byte, error) {
	_parts := make([][]byte, 0, 1)

	aO0, err := swag.WriteJSON(m.PerformanceMetric)
	if err != nil {
		return nil, err
	}
	_parts = append(_parts, aO0)

	// now for regular properties
	var propsVolumeMetrics struct {
		Cloud *VolumeMetricsCloud `json:"cloud,omitempty"`
	}
	propsVolumeMetrics.Cloud = m.Cloud

	jsonDataPropsVolumeMetrics, errVolumeMetrics := swag.WriteJSON(propsVolumeMetrics)
	if errVolumeMetrics != nil {
		return nil, errVolumeMetrics
	}
	_parts = append(_parts, jsonDataPropsVolumeMetrics)
	return swag.ConcatJSON(_parts...), nil
}

// Validate validates this volume metrics
func (m *VolumeMetrics) Validate(formats strfmt.Registry) error {
	var res []error

	// validation for a type composition with PerformanceMetric
	if err := m.PerformanceMetric.Validate(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateCloud(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *VolumeMetrics) validateCloud(formats strfmt.Registry) error {

	if swag.IsZero(m.Cloud) { // not required
		return nil
	}

	if m.Cloud != nil {
		if err := m.Cloud.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("cloud")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *VolumeMetrics) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *VolumeMetrics) UnmarshalBinary(b []byte) error {
	var res VolumeMetrics
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// VolumeMetricsCloud Performance numbers (IOPS and latency) for cloud store. These numbers are relevant only for volumes hosted on FabricPools.
// swagger:model VolumeMetricsCloud
type VolumeMetricsCloud struct {

	// The duration over which this sample is calculated. The time durations are represented in the ISO-8601 standard format. Samples can be calculated over the following durations:
	//
	// Read Only: true
	// Enum: [PT15S PT4M PT30M PT2H P1D PT5M]
	Duration string `json:"duration,omitempty"`

	// iops
	Iops *VolumeMetricsCloudIops `json:"iops,omitempty"`

	// latency
	Latency *VolumeMetricsCloudLatency `json:"latency,omitempty"`

	// Errors associated with the sample. For example, if the aggregation of data over multiple nodes fails, then any partial errors might return "ok" on success or "error" on an internal uncategorized failure. Whenever a sample collection is missed but done at a later time, it is back filled to the previous 15 second timestamp and tagged with "backfilled_data". "Inconsistent_ delta_time" is encountered when the time between two collections is not the same for all nodes. Therefore, the aggregated value might be over or under inflated. "Negative_delta" is returned when an expected monotonically increasing value has decreased in value. "Inconsistent_old_data" is returned when one or more nodes do not have the latest data.
	// Read Only: true
	// Enum: [ok error partial_no_data partial_no_uuid partial_no_response partial_other_error negative_delta backfilled_data inconsistent_delta_time inconsistent_old_data]
	Status string `json:"status,omitempty"`

	// The timestamp of the performance data.
	// Read Only: true
	// Format: date-time
	Timestamp strfmt.DateTime `json:"timestamp,omitempty"`
}

// Validate validates this volume metrics cloud
func (m *VolumeMetricsCloud) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateDuration(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateIops(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateLatency(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateStatus(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateTimestamp(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var volumeMetricsCloudTypeDurationPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["PT15S","PT4M","PT30M","PT2H","P1D","PT5M"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		volumeMetricsCloudTypeDurationPropEnum = append(volumeMetricsCloudTypeDurationPropEnum, v)
	}
}

const (

	// VolumeMetricsCloudDurationPT15S captures enum value "PT15S"
	VolumeMetricsCloudDurationPT15S string = "PT15S"

	// VolumeMetricsCloudDurationPT4M captures enum value "PT4M"
	VolumeMetricsCloudDurationPT4M string = "PT4M"

	// VolumeMetricsCloudDurationPT30M captures enum value "PT30M"
	VolumeMetricsCloudDurationPT30M string = "PT30M"

	// VolumeMetricsCloudDurationPT2H captures enum value "PT2H"
	VolumeMetricsCloudDurationPT2H string = "PT2H"

	// VolumeMetricsCloudDurationP1D captures enum value "P1D"
	VolumeMetricsCloudDurationP1D string = "P1D"

	// VolumeMetricsCloudDurationPT5M captures enum value "PT5M"
	VolumeMetricsCloudDurationPT5M string = "PT5M"
)

// prop value enum
func (m *VolumeMetricsCloud) validateDurationEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, volumeMetricsCloudTypeDurationPropEnum); err != nil {
		return err
	}
	return nil
}

func (m *VolumeMetricsCloud) validateDuration(formats strfmt.Registry) error {

	if swag.IsZero(m.Duration) { // not required
		return nil
	}

	// value enum
	if err := m.validateDurationEnum("cloud"+"."+"duration", "body", m.Duration); err != nil {
		return err
	}

	return nil
}

func (m *VolumeMetricsCloud) validateIops(formats strfmt.Registry) error {

	if swag.IsZero(m.Iops) { // not required
		return nil
	}

	if m.Iops != nil {
		if err := m.Iops.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("cloud" + "." + "iops")
			}
			return err
		}
	}

	return nil
}

func (m *VolumeMetricsCloud) validateLatency(formats strfmt.Registry) error {

	if swag.IsZero(m.Latency) { // not required
		return nil
	}

	if m.Latency != nil {
		if err := m.Latency.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("cloud" + "." + "latency")
			}
			return err
		}
	}

	return nil
}

var volumeMetricsCloudTypeStatusPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["ok","error","partial_no_data","partial_no_uuid","partial_no_response","partial_other_error","negative_delta","backfilled_data","inconsistent_delta_time","inconsistent_old_data"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		volumeMetricsCloudTypeStatusPropEnum = append(volumeMetricsCloudTypeStatusPropEnum, v)
	}
}

const (

	// VolumeMetricsCloudStatusOk captures enum value "ok"
	VolumeMetricsCloudStatusOk string = "ok"

	// VolumeMetricsCloudStatusError captures enum value "error"
	VolumeMetricsCloudStatusError string = "error"

	// VolumeMetricsCloudStatusPartialNoData captures enum value "partial_no_data"
	VolumeMetricsCloudStatusPartialNoData string = "partial_no_data"

	// VolumeMetricsCloudStatusPartialNoUUID captures enum value "partial_no_uuid"
	VolumeMetricsCloudStatusPartialNoUUID string = "partial_no_uuid"

	// VolumeMetricsCloudStatusPartialNoResponse captures enum value "partial_no_response"
	VolumeMetricsCloudStatusPartialNoResponse string = "partial_no_response"

	// VolumeMetricsCloudStatusPartialOtherError captures enum value "partial_other_error"
	VolumeMetricsCloudStatusPartialOtherError string = "partial_other_error"

	// VolumeMetricsCloudStatusNegativeDelta captures enum value "negative_delta"
	VolumeMetricsCloudStatusNegativeDelta string = "negative_delta"

	// VolumeMetricsCloudStatusBackfilledData captures enum value "backfilled_data"
	VolumeMetricsCloudStatusBackfilledData string = "backfilled_data"

	// VolumeMetricsCloudStatusInconsistentDeltaTime captures enum value "inconsistent_delta_time"
	VolumeMetricsCloudStatusInconsistentDeltaTime string = "inconsistent_delta_time"

	// VolumeMetricsCloudStatusInconsistentOldData captures enum value "inconsistent_old_data"
	VolumeMetricsCloudStatusInconsistentOldData string = "inconsistent_old_data"
)

// prop value enum
func (m *VolumeMetricsCloud) validateStatusEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, volumeMetricsCloudTypeStatusPropEnum); err != nil {
		return err
	}
	return nil
}

func (m *VolumeMetricsCloud) validateStatus(formats strfmt.Registry) error {

	if swag.IsZero(m.Status) { // not required
		return nil
	}

	// value enum
	if err := m.validateStatusEnum("cloud"+"."+"status", "body", m.Status); err != nil {
		return err
	}

	return nil
}

func (m *VolumeMetricsCloud) validateTimestamp(formats strfmt.Registry) error {

	if swag.IsZero(m.Timestamp) { // not required
		return nil
	}

	if err := validate.FormatOf("cloud"+"."+"timestamp", "body", "date-time", m.Timestamp.String(), formats); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *VolumeMetricsCloud) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *VolumeMetricsCloud) UnmarshalBinary(b []byte) error {
	var res VolumeMetricsCloud
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// VolumeMetricsCloudIops The rate of I/O operations observed at the storage object.
// swagger:model VolumeMetricsCloudIops
type VolumeMetricsCloudIops struct {

	// Performance metric for other I/O operations. Other I/O operations can be metadata operations, such as directory lookups and so on.
	Other int64 `json:"other,omitempty"`

	// Performance metric for read I/O operations.
	Read int64 `json:"read,omitempty"`

	// Performance metric aggregated over all types of I/O operations.
	Total int64 `json:"total,omitempty"`

	// Peformance metric for write I/O operations.
	Write int64 `json:"write,omitempty"`
}

// Validate validates this volume metrics cloud iops
func (m *VolumeMetricsCloudIops) Validate(formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *VolumeMetricsCloudIops) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *VolumeMetricsCloudIops) UnmarshalBinary(b []byte) error {
	var res VolumeMetricsCloudIops
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// VolumeMetricsCloudLatency The round trip latency in microseconds observed at the storage object.
// swagger:model VolumeMetricsCloudLatency
type VolumeMetricsCloudLatency struct {

	// Performance metric for other I/O operations. Other I/O operations can be metadata operations, such as directory lookups and so on.
	Other int64 `json:"other,omitempty"`

	// Performance metric for read I/O operations.
	Read int64 `json:"read,omitempty"`

	// Performance metric aggregated over all types of I/O operations.
	Total int64 `json:"total,omitempty"`

	// Peformance metric for write I/O operations.
	Write int64 `json:"write,omitempty"`
}

// Validate validates this volume metrics cloud latency
func (m *VolumeMetricsCloudLatency) Validate(formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *VolumeMetricsCloudLatency) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *VolumeMetricsCloudLatency) UnmarshalBinary(b []byte) error {
	var res VolumeMetricsCloudLatency
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
