// Code generated by go-swagger; DO NOT EDIT.

package ntapmodel

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// VolumeStatisticsReference These are raw performance numbers, such as IOPS latency and throughput. These numbers are aggregated across all nodes in the cluster and increase with the uptime of the cluster.
// swagger:model volumeStatisticsReference
type VolumeStatisticsReference struct {
	PerformanceMetricRawReference

	// cloud
	Cloud *VolumeStatisticsReferenceCloud `json:"cloud,omitempty"`
}

// UnmarshalJSON unmarshals this object from a JSON structure
func (m *VolumeStatisticsReference) UnmarshalJSON(raw []byte) error {
	// AO0
	var aO0 PerformanceMetricRawReference
	if err := swag.ReadJSON(raw, &aO0); err != nil {
		return err
	}
	m.PerformanceMetricRawReference = aO0

	// now for regular properties
	var propsVolumeStatisticsReference struct {
		Cloud *VolumeStatisticsReferenceCloud `json:"cloud,omitempty"`
	}
	if err := swag.ReadJSON(raw, &propsVolumeStatisticsReference); err != nil {
		return err
	}
	m.Cloud = propsVolumeStatisticsReference.Cloud

	return nil
}

// MarshalJSON marshals this object to a JSON structure
func (m VolumeStatisticsReference) MarshalJSON() ([]byte, error) {
	_parts := make([][]byte, 0, 1)

	aO0, err := swag.WriteJSON(m.PerformanceMetricRawReference)
	if err != nil {
		return nil, err
	}
	_parts = append(_parts, aO0)

	// now for regular properties
	var propsVolumeStatisticsReference struct {
		Cloud *VolumeStatisticsReferenceCloud `json:"cloud,omitempty"`
	}
	propsVolumeStatisticsReference.Cloud = m.Cloud

	jsonDataPropsVolumeStatisticsReference, errVolumeStatisticsReference := swag.WriteJSON(propsVolumeStatisticsReference)
	if errVolumeStatisticsReference != nil {
		return nil, errVolumeStatisticsReference
	}
	_parts = append(_parts, jsonDataPropsVolumeStatisticsReference)
	return swag.ConcatJSON(_parts...), nil
}

// Validate validates this volume statistics reference
func (m *VolumeStatisticsReference) Validate(formats strfmt.Registry) error {
	var res []error

	// validation for a type composition with PerformanceMetricRawReference
	if err := m.PerformanceMetricRawReference.Validate(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateCloud(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *VolumeStatisticsReference) validateCloud(formats strfmt.Registry) error {

	if swag.IsZero(m.Cloud) { // not required
		return nil
	}

	if m.Cloud != nil {
		if err := m.Cloud.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("cloud")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *VolumeStatisticsReference) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *VolumeStatisticsReference) UnmarshalBinary(b []byte) error {
	var res VolumeStatisticsReference
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// VolumeStatisticsReferenceCloud These are raw performance numbers (IOPS and latency) for the cloud store. These numbers are aggregated across all nodes in the cluster and increase with the uptime of the cluster. These numbers are relevant only for volumes hosted on FabricPools.
// swagger:model VolumeStatisticsReferenceCloud
type VolumeStatisticsReferenceCloud struct {

	// iops raw
	IopsRaw *VolumeStatisticsReferenceCloudIopsRaw `json:"iops_raw,omitempty"`

	// latency raw
	LatencyRaw *VolumeStatisticsReferenceCloudLatencyRaw `json:"latency_raw,omitempty"`

	// Errors associated with the sample. For example, if the aggregation of data over multiple nodes fails, then any partial errors might return "ok" on success or "error" on an internal uncategorized failure. Whenever a sample collection is missed but done at a later time, it is back filled to the previous 15 second timestamp and tagged with "backfilled_data". "Inconsistent_ delta_time" is encountered when the time between two collections is not the same for all nodes. Therefore, the aggregated value might be over or under inflated. "Negative_delta" is returned when an expected monotonically increasing value has decreased in value. "Inconsistent_old_data" is returned when one or more nodes do not have the latest data.
	// Read Only: true
	// Enum: [ok error partial_no_data partial_no_uuid partial_no_response partial_other_error negative_delta backfilled_data inconsistent_delta_time inconsistent_old_data]
	Status string `json:"status,omitempty"`

	// The timestamp of the performance data.
	// Read Only: true
	// Format: date-time
	Timestamp strfmt.DateTime `json:"timestamp,omitempty"`
}

// Validate validates this volume statistics reference cloud
func (m *VolumeStatisticsReferenceCloud) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateIopsRaw(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateLatencyRaw(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateStatus(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateTimestamp(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *VolumeStatisticsReferenceCloud) validateIopsRaw(formats strfmt.Registry) error {

	if swag.IsZero(m.IopsRaw) { // not required
		return nil
	}

	if m.IopsRaw != nil {
		if err := m.IopsRaw.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("cloud" + "." + "iops_raw")
			}
			return err
		}
	}

	return nil
}

func (m *VolumeStatisticsReferenceCloud) validateLatencyRaw(formats strfmt.Registry) error {

	if swag.IsZero(m.LatencyRaw) { // not required
		return nil
	}

	if m.LatencyRaw != nil {
		if err := m.LatencyRaw.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("cloud" + "." + "latency_raw")
			}
			return err
		}
	}

	return nil
}

var volumeStatisticsReferenceCloudTypeStatusPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["ok","error","partial_no_data","partial_no_uuid","partial_no_response","partial_other_error","negative_delta","backfilled_data","inconsistent_delta_time","inconsistent_old_data"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		volumeStatisticsReferenceCloudTypeStatusPropEnum = append(volumeStatisticsReferenceCloudTypeStatusPropEnum, v)
	}
}

const (

	// VolumeStatisticsReferenceCloudStatusOk captures enum value "ok"
	VolumeStatisticsReferenceCloudStatusOk string = "ok"

	// VolumeStatisticsReferenceCloudStatusError captures enum value "error"
	VolumeStatisticsReferenceCloudStatusError string = "error"

	// VolumeStatisticsReferenceCloudStatusPartialNoData captures enum value "partial_no_data"
	VolumeStatisticsReferenceCloudStatusPartialNoData string = "partial_no_data"

	// VolumeStatisticsReferenceCloudStatusPartialNoUUID captures enum value "partial_no_uuid"
	VolumeStatisticsReferenceCloudStatusPartialNoUUID string = "partial_no_uuid"

	// VolumeStatisticsReferenceCloudStatusPartialNoResponse captures enum value "partial_no_response"
	VolumeStatisticsReferenceCloudStatusPartialNoResponse string = "partial_no_response"

	// VolumeStatisticsReferenceCloudStatusPartialOtherError captures enum value "partial_other_error"
	VolumeStatisticsReferenceCloudStatusPartialOtherError string = "partial_other_error"

	// VolumeStatisticsReferenceCloudStatusNegativeDelta captures enum value "negative_delta"
	VolumeStatisticsReferenceCloudStatusNegativeDelta string = "negative_delta"

	// VolumeStatisticsReferenceCloudStatusBackfilledData captures enum value "backfilled_data"
	VolumeStatisticsReferenceCloudStatusBackfilledData string = "backfilled_data"

	// VolumeStatisticsReferenceCloudStatusInconsistentDeltaTime captures enum value "inconsistent_delta_time"
	VolumeStatisticsReferenceCloudStatusInconsistentDeltaTime string = "inconsistent_delta_time"

	// VolumeStatisticsReferenceCloudStatusInconsistentOldData captures enum value "inconsistent_old_data"
	VolumeStatisticsReferenceCloudStatusInconsistentOldData string = "inconsistent_old_data"
)

// prop value enum
func (m *VolumeStatisticsReferenceCloud) validateStatusEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, volumeStatisticsReferenceCloudTypeStatusPropEnum); err != nil {
		return err
	}
	return nil
}

func (m *VolumeStatisticsReferenceCloud) validateStatus(formats strfmt.Registry) error {

	if swag.IsZero(m.Status) { // not required
		return nil
	}

	// value enum
	if err := m.validateStatusEnum("cloud"+"."+"status", "body", m.Status); err != nil {
		return err
	}

	return nil
}

func (m *VolumeStatisticsReferenceCloud) validateTimestamp(formats strfmt.Registry) error {

	if swag.IsZero(m.Timestamp) { // not required
		return nil
	}

	if err := validate.FormatOf("cloud"+"."+"timestamp", "body", "date-time", m.Timestamp.String(), formats); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *VolumeStatisticsReferenceCloud) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *VolumeStatisticsReferenceCloud) UnmarshalBinary(b []byte) error {
	var res VolumeStatisticsReferenceCloud
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// VolumeStatisticsReferenceCloudIopsRaw The number of I/O operations observed at the storage object. This can be used along with delta time to calculate the rate of I/O operations per unit of time.
// swagger:model VolumeStatisticsReferenceCloudIopsRaw
type VolumeStatisticsReferenceCloudIopsRaw struct {

	// Performance metric for other I/O operations. Other I/O operations can be metadata operations, such as directory lookups and so on.
	Other int64 `json:"other"`

	// Performance metric for read I/O operations.
	Read int64 `json:"read"`

	// Performance metric aggregated over all types of I/O operations.
	Total int64 `json:"total"`

	// Peformance metric for write I/O operations.
	Write int64 `json:"write"`
}

// Validate validates this volume statistics reference cloud iops raw
func (m *VolumeStatisticsReferenceCloudIopsRaw) Validate(formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *VolumeStatisticsReferenceCloudIopsRaw) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *VolumeStatisticsReferenceCloudIopsRaw) UnmarshalBinary(b []byte) error {
	var res VolumeStatisticsReferenceCloudIopsRaw
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// VolumeStatisticsReferenceCloudLatencyRaw The raw latency in microseconds observed at the storage object. This can be divided by the raw IOPS value to calculate the average latency per I/O operation.
// swagger:model VolumeStatisticsReferenceCloudLatencyRaw
type VolumeStatisticsReferenceCloudLatencyRaw struct {

	// Performance metric for other I/O operations. Other I/O operations can be metadata operations, such as directory lookups and so on.
	Other int64 `json:"other"`

	// Performance metric for read I/O operations.
	Read int64 `json:"read"`

	// Performance metric aggregated over all types of I/O operations.
	Total int64 `json:"total"`

	// Peformance metric for write I/O operations.
	Write int64 `json:"write,omitempty"`
}

// Validate validates this volume statistics reference cloud latency raw
func (m *VolumeStatisticsReferenceCloudLatencyRaw) Validate(formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *VolumeStatisticsReferenceCloudLatencyRaw) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *VolumeStatisticsReferenceCloudLatencyRaw) UnmarshalBinary(b []byte) error {
	var res VolumeStatisticsReferenceCloudLatencyRaw
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
